// Use of this source code is governed by a agpl license. It can be obtained at `https://spdx.org/licenses/AGPL-3.0.html`.

// OpenAPI client generated by Dynamite. Do not manually edit this file.

// ignore_for_file: camel_case_extensions, camel_case_types, discarded_futures
// ignore_for_file: no_leading_underscores_for_local_identifiers
// ignore_for_file: non_constant_identifier_names, public_member_api_docs
// ignore_for_file: unreachable_switch_case

/// news Version: 21.2.0.
///
/// An RSS/Atom feed reader.
///
/// Use of this source code is governed by a agpl license.
/// It can be obtained at `https://spdx.org/licenses/AGPL-3.0.html`.
@_i2.experimental
library; // ignore_for_file: no_leading_underscores_for_library_prefixes

import 'package:built_collection/built_collection.dart';
import 'package:built_value/built_value.dart';
import 'package:built_value/json_object.dart';
import 'package:built_value/serializer.dart';
import 'package:built_value/standard_json_plugin.dart' as _i6;
import 'package:collection/collection.dart';
import 'package:dynamite_runtime/built_value.dart' as _i5;
import 'package:dynamite_runtime/http_client.dart' as _i1;
import 'package:http/http.dart' as _i3;
import 'package:meta/meta.dart' as _i2;
import 'package:uri/uri.dart' as _i4;

part 'news.openapi.g.dart';

class $Client extends _i1.DynamiteClient {
  /// Creates a new `DynamiteClient` for untagged requests.
  $Client(
    super.baseURL, {
    super.httpClient,
    super.authentications,
  });

  /// Creates a new [$Client] from another [client].
  $Client.fromClient(_i1.DynamiteClient client)
      : super(
          client.baseURL,
          httpClient: client.httpClient,
          authentications: client.authentications,
        );

  /// Builds a serializer to parse the response of [$getSupportedApiVersions_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<SupportedAPIVersions, void> $getSupportedApiVersions_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(SupportedAPIVersions),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Returns a `DynamiteRequest` backing the [getSupportedApiVersions] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [getSupportedApiVersions] for a method executing this request and parsing the response.
  ///  * [$getSupportedApiVersions_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getSupportedApiVersions_Request() {
    const _path = '/index.php/apps/news/api';
    final _uri = Uri.parse('$baseURL$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for basic_auth');
    }

// coverage:ignore-end
    return _request;
  }

  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [$getSupportedApiVersions_Request] for the request send by this method.
  ///  * [$getSupportedApiVersions_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<SupportedAPIVersions, void>> getSupportedApiVersions() async {
    final _request = $getSupportedApiVersions_Request();
    final _response = await httpClient.send(_request);

    final _serializer = $getSupportedApiVersions_Serializer();
    final _rawResponse = await _i1.ResponseConverter<SupportedAPIVersions, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$listFolders_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ListFolders, void> $listFolders_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(ListFolders),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Returns a `DynamiteRequest` backing the [listFolders] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [listFolders] for a method executing this request and parsing the response.
  ///  * [$listFolders_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $listFolders_Request() {
    const _path = '/index.php/apps/news/api/v1-3/folders';
    final _uri = Uri.parse('$baseURL$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for basic_auth');
    }

// coverage:ignore-end
    return _request;
  }

  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [$listFolders_Request] for the request send by this method.
  ///  * [$listFolders_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ListFolders, void>> listFolders() async {
    final _request = $listFolders_Request();
    final _response = await httpClient.send(_request);

    final _serializer = $listFolders_Serializer();
    final _rawResponse = await _i1.ResponseConverter<ListFolders, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$createFolder_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ListFolders, void> $createFolder_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(ListFolders),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Returns a `DynamiteRequest` backing the [createFolder] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [name]
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [createFolder] for a method executing this request and parsing the response.
  ///  * [$createFolder_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $createFolder_Request({required String name}) {
    final _parameters = <String, Object?>{};
    final $name = _$jsonSerializers.serialize(name, specifiedType: const FullType(String));
    _parameters['name'] = $name;

    final _path = _i4.UriTemplate('/index.php/apps/news/api/v1-3/folders{?name*}').expand(_parameters);
    final _uri = Uri.parse('$baseURL$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for basic_auth');
    }

// coverage:ignore-end
    return _request;
  }

  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [name]
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [$createFolder_Request] for the request send by this method.
  ///  * [$createFolder_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ListFolders, void>> createFolder({required String name}) async {
    final _request = $createFolder_Request(
      name: name,
    );
    final _response = await httpClient.send(_request);

    final _serializer = $createFolder_Serializer();
    final _rawResponse = await _i1.ResponseConverter<ListFolders, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$renameFolder_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<void, void> $renameFolder_Serializer() => _i1.DynamiteSerializer(
        bodyType: null,
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Returns a `DynamiteRequest` backing the [renameFolder] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [name]
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [renameFolder] for a method executing this request and parsing the response.
  ///  * [$renameFolder_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $renameFolder_Request({
    required int folderId,
    required String name,
  }) {
    final _parameters = <String, Object?>{};
    final $folderId = _$jsonSerializers.serialize(folderId, specifiedType: const FullType(int));
    _parameters['folderId'] = $folderId;

    final $name = _$jsonSerializers.serialize(name, specifiedType: const FullType(String));
    _parameters['name'] = $name;

    final _path = _i4.UriTemplate('/index.php/apps/news/api/v1-3/folders/{folderId}{?name*}').expand(_parameters);
    final _uri = Uri.parse('$baseURL$_path');
    final _request = _i3.Request('put', _uri);
// coverage:ignore-start
    final authentication = authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for basic_auth');
    }

// coverage:ignore-end
    return _request;
  }

  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [name]
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [$renameFolder_Request] for the request send by this method.
  ///  * [$renameFolder_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<void, void>> renameFolder({
    required int folderId,
    required String name,
  }) async {
    final _request = $renameFolder_Request(
      folderId: folderId,
      name: name,
    );
    final _response = await httpClient.send(_request);

    final _serializer = $renameFolder_Serializer();
    final _rawResponse = await _i1.ResponseConverter<void, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$deleteFolder_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<void, void> $deleteFolder_Serializer() => _i1.DynamiteSerializer(
        bodyType: null,
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Returns a `DynamiteRequest` backing the [deleteFolder] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [deleteFolder] for a method executing this request and parsing the response.
  ///  * [$deleteFolder_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $deleteFolder_Request({required int folderId}) {
    final _parameters = <String, Object?>{};
    final $folderId = _$jsonSerializers.serialize(folderId, specifiedType: const FullType(int));
    _parameters['folderId'] = $folderId;

    final _path = _i4.UriTemplate('/index.php/apps/news/api/v1-3/folders/{folderId}').expand(_parameters);
    final _uri = Uri.parse('$baseURL$_path');
    final _request = _i3.Request('delete', _uri);
// coverage:ignore-start
    final authentication = authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for basic_auth');
    }

// coverage:ignore-end
    return _request;
  }

  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [$deleteFolder_Request] for the request send by this method.
  ///  * [$deleteFolder_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<void, void>> deleteFolder({required int folderId}) async {
    final _request = $deleteFolder_Request(
      folderId: folderId,
    );
    final _response = await httpClient.send(_request);

    final _serializer = $deleteFolder_Serializer();
    final _rawResponse = await _i1.ResponseConverter<void, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$markFolderAsRead_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<void, void> $markFolderAsRead_Serializer() => _i1.DynamiteSerializer(
        bodyType: null,
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Returns a `DynamiteRequest` backing the [markFolderAsRead] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [newestItemId] The newest read item.
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [markFolderAsRead] for a method executing this request and parsing the response.
  ///  * [$markFolderAsRead_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $markFolderAsRead_Request({
    required int folderId,
    required int newestItemId,
  }) {
    final _parameters = <String, Object?>{};
    final $folderId = _$jsonSerializers.serialize(folderId, specifiedType: const FullType(int));
    _parameters['folderId'] = $folderId;

    final $newestItemId = _$jsonSerializers.serialize(newestItemId, specifiedType: const FullType(int));
    _parameters['newestItemId'] = $newestItemId;

    final _path =
        _i4.UriTemplate('/index.php/apps/news/api/v1-3/folders/{folderId}/read{?newestItemId*}').expand(_parameters);
    final _uri = Uri.parse('$baseURL$_path');
    final _request = _i3.Request('post', _uri);
// coverage:ignore-start
    final authentication = authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for basic_auth');
    }

// coverage:ignore-end
    return _request;
  }

  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [newestItemId] The newest read item.
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [$markFolderAsRead_Request] for the request send by this method.
  ///  * [$markFolderAsRead_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<void, void>> markFolderAsRead({
    required int folderId,
    required int newestItemId,
  }) async {
    final _request = $markFolderAsRead_Request(
      folderId: folderId,
      newestItemId: newestItemId,
    );
    final _response = await httpClient.send(_request);

    final _serializer = $markFolderAsRead_Serializer();
    final _rawResponse = await _i1.ResponseConverter<void, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$listFeeds_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ListFeeds, void> $listFeeds_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(ListFeeds),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Returns a `DynamiteRequest` backing the [listFeeds] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [listFeeds] for a method executing this request and parsing the response.
  ///  * [$listFeeds_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $listFeeds_Request() {
    const _path = '/index.php/apps/news/api/v1-3/feeds';
    final _uri = Uri.parse('$baseURL$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for basic_auth');
    }

// coverage:ignore-end
    return _request;
  }

  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [$listFeeds_Request] for the request send by this method.
  ///  * [$listFeeds_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ListFeeds, void>> listFeeds() async {
    final _request = $listFeeds_Request();
    final _response = await httpClient.send(_request);

    final _serializer = $listFeeds_Serializer();
    final _rawResponse = await _i1.ResponseConverter<ListFeeds, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$addFeed_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ListFeeds, void> $addFeed_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(ListFeeds),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Returns a `DynamiteRequest` backing the [addFeed] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [url]
  ///   * [folderId]
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [addFeed] for a method executing this request and parsing the response.
  ///  * [$addFeed_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $addFeed_Request({
    required String url,
    int? folderId,
  }) {
    final _parameters = <String, Object?>{};
    final $url = _$jsonSerializers.serialize(url, specifiedType: const FullType(String));
    _parameters['url'] = $url;

    final $folderId = _$jsonSerializers.serialize(folderId, specifiedType: const FullType(int));
    _parameters['folderId'] = $folderId;

    final _path = _i4.UriTemplate('/index.php/apps/news/api/v1-3/feeds{?url*,folderId*}').expand(_parameters);
    final _uri = Uri.parse('$baseURL$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for basic_auth');
    }

// coverage:ignore-end
    return _request;
  }

  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [url]
  ///   * [folderId]
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [$addFeed_Request] for the request send by this method.
  ///  * [$addFeed_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ListFeeds, void>> addFeed({
    required String url,
    int? folderId,
  }) async {
    final _request = $addFeed_Request(
      url: url,
      folderId: folderId,
    );
    final _response = await httpClient.send(_request);

    final _serializer = $addFeed_Serializer();
    final _rawResponse = await _i1.ResponseConverter<ListFeeds, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$deleteFeed_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<void, void> $deleteFeed_Serializer() => _i1.DynamiteSerializer(
        bodyType: null,
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Returns a `DynamiteRequest` backing the [deleteFeed] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [deleteFeed] for a method executing this request and parsing the response.
  ///  * [$deleteFeed_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $deleteFeed_Request({required int feedId}) {
    final _parameters = <String, Object?>{};
    final $feedId = _$jsonSerializers.serialize(feedId, specifiedType: const FullType(int));
    _parameters['feedId'] = $feedId;

    final _path = _i4.UriTemplate('/index.php/apps/news/api/v1-3/feeds/{feedId}').expand(_parameters);
    final _uri = Uri.parse('$baseURL$_path');
    final _request = _i3.Request('delete', _uri);
// coverage:ignore-start
    final authentication = authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for basic_auth');
    }

// coverage:ignore-end
    return _request;
  }

  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [$deleteFeed_Request] for the request send by this method.
  ///  * [$deleteFeed_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<void, void>> deleteFeed({required int feedId}) async {
    final _request = $deleteFeed_Request(
      feedId: feedId,
    );
    final _response = await httpClient.send(_request);

    final _serializer = $deleteFeed_Serializer();
    final _rawResponse = await _i1.ResponseConverter<void, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$moveFeed_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<void, void> $moveFeed_Serializer() => _i1.DynamiteSerializer(
        bodyType: null,
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Returns a `DynamiteRequest` backing the [moveFeed] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [folderId]
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [moveFeed] for a method executing this request and parsing the response.
  ///  * [$moveFeed_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $moveFeed_Request({
    required int feedId,
    int? folderId,
  }) {
    final _parameters = <String, Object?>{};
    final $feedId = _$jsonSerializers.serialize(feedId, specifiedType: const FullType(int));
    _parameters['feedId'] = $feedId;

    final $folderId = _$jsonSerializers.serialize(folderId, specifiedType: const FullType(int));
    _parameters['folderId'] = $folderId;

    final _path = _i4.UriTemplate('/index.php/apps/news/api/v1-3/feeds/{feedId}/move{?folderId*}').expand(_parameters);
    final _uri = Uri.parse('$baseURL$_path');
    final _request = _i3.Request('post', _uri);
// coverage:ignore-start
    final authentication = authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for basic_auth');
    }

// coverage:ignore-end
    return _request;
  }

  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [folderId]
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [$moveFeed_Request] for the request send by this method.
  ///  * [$moveFeed_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<void, void>> moveFeed({
    required int feedId,
    int? folderId,
  }) async {
    final _request = $moveFeed_Request(
      feedId: feedId,
      folderId: folderId,
    );
    final _response = await httpClient.send(_request);

    final _serializer = $moveFeed_Serializer();
    final _rawResponse = await _i1.ResponseConverter<void, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$renameFeed_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<void, void> $renameFeed_Serializer() => _i1.DynamiteSerializer(
        bodyType: null,
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Returns a `DynamiteRequest` backing the [renameFeed] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [feedTitle]
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [renameFeed] for a method executing this request and parsing the response.
  ///  * [$renameFeed_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $renameFeed_Request({
    required int feedId,
    required String feedTitle,
  }) {
    final _parameters = <String, Object?>{};
    final $feedId = _$jsonSerializers.serialize(feedId, specifiedType: const FullType(int));
    _parameters['feedId'] = $feedId;

    final $feedTitle = _$jsonSerializers.serialize(feedTitle, specifiedType: const FullType(String));
    _parameters['feedTitle'] = $feedTitle;

    final _path =
        _i4.UriTemplate('/index.php/apps/news/api/v1-3/feeds/{feedId}/rename{?feedTitle*}').expand(_parameters);
    final _uri = Uri.parse('$baseURL$_path');
    final _request = _i3.Request('post', _uri);
// coverage:ignore-start
    final authentication = authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for basic_auth');
    }

// coverage:ignore-end
    return _request;
  }

  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [feedTitle]
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [$renameFeed_Request] for the request send by this method.
  ///  * [$renameFeed_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<void, void>> renameFeed({
    required int feedId,
    required String feedTitle,
  }) async {
    final _request = $renameFeed_Request(
      feedId: feedId,
      feedTitle: feedTitle,
    );
    final _response = await httpClient.send(_request);

    final _serializer = $renameFeed_Serializer();
    final _rawResponse = await _i1.ResponseConverter<void, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$markFeedAsRead_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<void, void> $markFeedAsRead_Serializer() => _i1.DynamiteSerializer(
        bodyType: null,
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Returns a `DynamiteRequest` backing the [markFeedAsRead] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [newestItemId]
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [markFeedAsRead] for a method executing this request and parsing the response.
  ///  * [$markFeedAsRead_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $markFeedAsRead_Request({
    required int feedId,
    required int newestItemId,
  }) {
    final _parameters = <String, Object?>{};
    final $feedId = _$jsonSerializers.serialize(feedId, specifiedType: const FullType(int));
    _parameters['feedId'] = $feedId;

    final $newestItemId = _$jsonSerializers.serialize(newestItemId, specifiedType: const FullType(int));
    _parameters['newestItemId'] = $newestItemId;

    final _path =
        _i4.UriTemplate('/index.php/apps/news/api/v1-3/feeds/{feedId}/read{?newestItemId*}').expand(_parameters);
    final _uri = Uri.parse('$baseURL$_path');
    final _request = _i3.Request('post', _uri);
// coverage:ignore-start
    final authentication = authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for basic_auth');
    }

// coverage:ignore-end
    return _request;
  }

  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [newestItemId]
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [$markFeedAsRead_Request] for the request send by this method.
  ///  * [$markFeedAsRead_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<void, void>> markFeedAsRead({
    required int feedId,
    required int newestItemId,
  }) async {
    final _request = $markFeedAsRead_Request(
      feedId: feedId,
      newestItemId: newestItemId,
    );
    final _response = await httpClient.send(_request);

    final _serializer = $markFeedAsRead_Serializer();
    final _rawResponse = await _i1.ResponseConverter<void, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$listArticles_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ListArticles, void> $listArticles_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(ListArticles),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Returns a `DynamiteRequest` backing the [listArticles] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [type] Defaults to `3`.
  ///   * [id] Defaults to `0`.
  ///   * [getRead] Defaults to `1`.
  ///   * [batchSize] Defaults to `-1`.
  ///   * [offset] Defaults to `0`.
  ///   * [oldestFirst] Defaults to `0`.
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [listArticles] for a method executing this request and parsing the response.
  ///  * [$listArticles_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $listArticles_Request({
    int? type,
    int? id,
    int? getRead,
    int? batchSize,
    int? offset,
    int? oldestFirst,
  }) {
    final _parameters = <String, Object?>{};
    var $type = _$jsonSerializers.serialize(type, specifiedType: const FullType(int));
    $type ??= 3;
    _parameters['type'] = $type;

    var $id = _$jsonSerializers.serialize(id, specifiedType: const FullType(int));
    $id ??= 0;
    _parameters['id'] = $id;

    var $getRead = _$jsonSerializers.serialize(getRead, specifiedType: const FullType(int));
    $getRead ??= 1;
    _parameters['getRead'] = $getRead;

    var $batchSize = _$jsonSerializers.serialize(batchSize, specifiedType: const FullType(int));
    $batchSize ??= -1;
    _parameters['batchSize'] = $batchSize;

    var $offset = _$jsonSerializers.serialize(offset, specifiedType: const FullType(int));
    $offset ??= 0;
    _parameters['offset'] = $offset;

    var $oldestFirst = _$jsonSerializers.serialize(oldestFirst, specifiedType: const FullType(int));
    $oldestFirst ??= 0;
    _parameters['oldestFirst'] = $oldestFirst;

    final _path =
        _i4.UriTemplate('/index.php/apps/news/api/v1-3/items{?type*,id*,getRead*,batchSize*,offset*,oldestFirst*}')
            .expand(_parameters);
    final _uri = Uri.parse('$baseURL$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for basic_auth');
    }

// coverage:ignore-end
    return _request;
  }

  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [type] Defaults to `3`.
  ///   * [id] Defaults to `0`.
  ///   * [getRead] Defaults to `1`.
  ///   * [batchSize] Defaults to `-1`.
  ///   * [offset] Defaults to `0`.
  ///   * [oldestFirst] Defaults to `0`.
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [$listArticles_Request] for the request send by this method.
  ///  * [$listArticles_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ListArticles, void>> listArticles({
    int? type,
    int? id,
    int? getRead,
    int? batchSize,
    int? offset,
    int? oldestFirst,
  }) async {
    final _request = $listArticles_Request(
      type: type,
      id: id,
      getRead: getRead,
      batchSize: batchSize,
      offset: offset,
      oldestFirst: oldestFirst,
    );
    final _response = await httpClient.send(_request);

    final _serializer = $listArticles_Serializer();
    final _rawResponse = await _i1.ResponseConverter<ListArticles, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$listUpdatedArticles_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ListArticles, void> $listUpdatedArticles_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(ListArticles),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Returns a `DynamiteRequest` backing the [listUpdatedArticles] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [type] Defaults to `3`.
  ///   * [id] Defaults to `0`.
  ///   * [lastModified] Defaults to `0`.
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [listUpdatedArticles] for a method executing this request and parsing the response.
  ///  * [$listUpdatedArticles_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $listUpdatedArticles_Request({
    int? type,
    int? id,
    int? lastModified,
  }) {
    final _parameters = <String, Object?>{};
    var $type = _$jsonSerializers.serialize(type, specifiedType: const FullType(int));
    $type ??= 3;
    _parameters['type'] = $type;

    var $id = _$jsonSerializers.serialize(id, specifiedType: const FullType(int));
    $id ??= 0;
    _parameters['id'] = $id;

    var $lastModified = _$jsonSerializers.serialize(lastModified, specifiedType: const FullType(int));
    $lastModified ??= 0;
    _parameters['lastModified'] = $lastModified;

    final _path =
        _i4.UriTemplate('/index.php/apps/news/api/v1-3/items/updated{?type*,id*,lastModified*}').expand(_parameters);
    final _uri = Uri.parse('$baseURL$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for basic_auth');
    }

// coverage:ignore-end
    return _request;
  }

  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [type] Defaults to `3`.
  ///   * [id] Defaults to `0`.
  ///   * [lastModified] Defaults to `0`.
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [$listUpdatedArticles_Request] for the request send by this method.
  ///  * [$listUpdatedArticles_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ListArticles, void>> listUpdatedArticles({
    int? type,
    int? id,
    int? lastModified,
  }) async {
    final _request = $listUpdatedArticles_Request(
      type: type,
      id: id,
      lastModified: lastModified,
    );
    final _response = await httpClient.send(_request);

    final _serializer = $listUpdatedArticles_Serializer();
    final _rawResponse = await _i1.ResponseConverter<ListArticles, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$markArticleAsRead_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<void, void> $markArticleAsRead_Serializer() => _i1.DynamiteSerializer(
        bodyType: null,
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Returns a `DynamiteRequest` backing the [markArticleAsRead] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [markArticleAsRead] for a method executing this request and parsing the response.
  ///  * [$markArticleAsRead_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $markArticleAsRead_Request({required int itemId}) {
    final _parameters = <String, Object?>{};
    final $itemId = _$jsonSerializers.serialize(itemId, specifiedType: const FullType(int));
    _parameters['itemId'] = $itemId;

    final _path = _i4.UriTemplate('/index.php/apps/news/api/v1-3/items/{itemId}/read').expand(_parameters);
    final _uri = Uri.parse('$baseURL$_path');
    final _request = _i3.Request('post', _uri);
// coverage:ignore-start
    final authentication = authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for basic_auth');
    }

// coverage:ignore-end
    return _request;
  }

  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [$markArticleAsRead_Request] for the request send by this method.
  ///  * [$markArticleAsRead_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<void, void>> markArticleAsRead({required int itemId}) async {
    final _request = $markArticleAsRead_Request(
      itemId: itemId,
    );
    final _response = await httpClient.send(_request);

    final _serializer = $markArticleAsRead_Serializer();
    final _rawResponse = await _i1.ResponseConverter<void, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$markArticleAsUnread_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<void, void> $markArticleAsUnread_Serializer() => _i1.DynamiteSerializer(
        bodyType: null,
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Returns a `DynamiteRequest` backing the [markArticleAsUnread] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [markArticleAsUnread] for a method executing this request and parsing the response.
  ///  * [$markArticleAsUnread_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $markArticleAsUnread_Request({required int itemId}) {
    final _parameters = <String, Object?>{};
    final $itemId = _$jsonSerializers.serialize(itemId, specifiedType: const FullType(int));
    _parameters['itemId'] = $itemId;

    final _path = _i4.UriTemplate('/index.php/apps/news/api/v1-3/items/{itemId}/unread').expand(_parameters);
    final _uri = Uri.parse('$baseURL$_path');
    final _request = _i3.Request('post', _uri);
// coverage:ignore-start
    final authentication = authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for basic_auth');
    }

// coverage:ignore-end
    return _request;
  }

  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [$markArticleAsUnread_Request] for the request send by this method.
  ///  * [$markArticleAsUnread_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<void, void>> markArticleAsUnread({required int itemId}) async {
    final _request = $markArticleAsUnread_Request(
      itemId: itemId,
    );
    final _response = await httpClient.send(_request);

    final _serializer = $markArticleAsUnread_Serializer();
    final _rawResponse = await _i1.ResponseConverter<void, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$starArticle_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<void, void> $starArticle_Serializer() => _i1.DynamiteSerializer(
        bodyType: null,
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Returns a `DynamiteRequest` backing the [starArticle] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [starArticle] for a method executing this request and parsing the response.
  ///  * [$starArticle_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $starArticle_Request({required int itemId}) {
    final _parameters = <String, Object?>{};
    final $itemId = _$jsonSerializers.serialize(itemId, specifiedType: const FullType(int));
    _parameters['itemId'] = $itemId;

    final _path = _i4.UriTemplate('/index.php/apps/news/api/v1-3/items/{itemId}/star').expand(_parameters);
    final _uri = Uri.parse('$baseURL$_path');
    final _request = _i3.Request('post', _uri);
// coverage:ignore-start
    final authentication = authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for basic_auth');
    }

// coverage:ignore-end
    return _request;
  }

  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [$starArticle_Request] for the request send by this method.
  ///  * [$starArticle_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<void, void>> starArticle({required int itemId}) async {
    final _request = $starArticle_Request(
      itemId: itemId,
    );
    final _response = await httpClient.send(_request);

    final _serializer = $starArticle_Serializer();
    final _rawResponse = await _i1.ResponseConverter<void, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$unstarArticle_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<void, void> $unstarArticle_Serializer() => _i1.DynamiteSerializer(
        bodyType: null,
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Returns a `DynamiteRequest` backing the [unstarArticle] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [unstarArticle] for a method executing this request and parsing the response.
  ///  * [$unstarArticle_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $unstarArticle_Request({required int itemId}) {
    final _parameters = <String, Object?>{};
    final $itemId = _$jsonSerializers.serialize(itemId, specifiedType: const FullType(int));
    _parameters['itemId'] = $itemId;

    final _path = _i4.UriTemplate('/index.php/apps/news/api/v1-3/items/{itemId}/unstar').expand(_parameters);
    final _uri = Uri.parse('$baseURL$_path');
    final _request = _i3.Request('post', _uri);
// coverage:ignore-start
    final authentication = authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for basic_auth');
    }

// coverage:ignore-end
    return _request;
  }

  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Status codes:
  ///   * 200
  ///
  /// See:
  ///  * [$unstarArticle_Request] for the request send by this method.
  ///  * [$unstarArticle_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<void, void>> unstarArticle({required int itemId}) async {
    final _request = $unstarArticle_Request(
      itemId: itemId,
    );
    final _response = await httpClient.send(_request);

    final _serializer = $unstarArticle_Serializer();
    final _rawResponse = await _i1.ResponseConverter<void, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SupportedAPIVersionsInterface {
  BuiltList<String>? get apiLevels;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SupportedAPIVersionsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SupportedAPIVersionsInterfaceBuilder b) {}
}

abstract class SupportedAPIVersions
    implements $SupportedAPIVersionsInterface, Built<SupportedAPIVersions, SupportedAPIVersionsBuilder> {
  /// Creates a new SupportedAPIVersions object using the builder pattern.
  factory SupportedAPIVersions([void Function(SupportedAPIVersionsBuilder)? b]) = _$SupportedAPIVersions;

  // coverage:ignore-start
  const SupportedAPIVersions._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SupportedAPIVersions.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SupportedAPIVersions.
  static Serializer<SupportedAPIVersions> get serializer => _$supportedAPIVersionsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SupportedAPIVersionsBuilder b) {
    $SupportedAPIVersionsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SupportedAPIVersionsBuilder b) {
    $SupportedAPIVersionsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ArticleInterface {
  int get id;
  String get guid;
  String get guidHash;
  String? get url;
  String get title;
  String? get author;
  int get pubDate;
  int? get updatedDate;
  String get body;
  String? get enclosureMime;
  String? get enclosureLink;
  String? get mediaThumbnail;
  String? get mediaDescription;
  int get feedId;
  bool get unread;
  bool get starred;
  int get lastModified;
  bool get rtl;
  String get fingerprint;
  String get contentHash;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ArticleInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ArticleInterfaceBuilder b) {}
}

abstract class Article implements $ArticleInterface, Built<Article, ArticleBuilder> {
  /// Creates a new Article object using the builder pattern.
  factory Article([void Function(ArticleBuilder)? b]) = _$Article;

  // coverage:ignore-start
  const Article._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory Article.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for Article.
  static Serializer<Article> get serializer => _$articleSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ArticleBuilder b) {
    $ArticleInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ArticleBuilder b) {
    $ArticleInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FeedInterface {
  int get id;
  String get url;
  String get title;
  String? get faviconLink;
  int get added;
  int? get folderId;
  int? get unreadCount;
  int get ordering;
  String? get link;
  bool get pinned;
  int get updateErrorCount;
  String? get lastUpdateError;
  BuiltList<Article> get items;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FeedInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FeedInterfaceBuilder b) {}
}

abstract class Feed implements $FeedInterface, Built<Feed, FeedBuilder> {
  /// Creates a new Feed object using the builder pattern.
  factory Feed([void Function(FeedBuilder)? b]) = _$Feed;

  // coverage:ignore-start
  const Feed._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory Feed.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for Feed.
  static Serializer<Feed> get serializer => _$feedSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FeedBuilder b) {
    $FeedInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FeedBuilder b) {
    $FeedInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FolderInterface {
  int get id;
  String get name;
  bool get opened;

  /// This seems to be broken. In testing it is always empty.
  BuiltList<Feed> get feeds;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FolderInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FolderInterfaceBuilder b) {}
}

abstract class Folder implements $FolderInterface, Built<Folder, FolderBuilder> {
  /// Creates a new Folder object using the builder pattern.
  factory Folder([void Function(FolderBuilder)? b]) = _$Folder;

  // coverage:ignore-start
  const Folder._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory Folder.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for Folder.
  static Serializer<Folder> get serializer => _$folderSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FolderBuilder b) {
    $FolderInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FolderBuilder b) {
    $FolderInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ListFoldersInterface {
  BuiltList<Folder> get folders;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ListFoldersInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ListFoldersInterfaceBuilder b) {}
}

abstract class ListFolders implements $ListFoldersInterface, Built<ListFolders, ListFoldersBuilder> {
  /// Creates a new ListFolders object using the builder pattern.
  factory ListFolders([void Function(ListFoldersBuilder)? b]) = _$ListFolders;

  // coverage:ignore-start
  const ListFolders._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ListFolders.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ListFolders.
  static Serializer<ListFolders> get serializer => _$listFoldersSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ListFoldersBuilder b) {
    $ListFoldersInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ListFoldersBuilder b) {
    $ListFoldersInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ListFeedsInterface {
  int? get starredCount;
  int? get newestItemId;
  BuiltList<Feed> get feeds;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ListFeedsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ListFeedsInterfaceBuilder b) {}
}

abstract class ListFeeds implements $ListFeedsInterface, Built<ListFeeds, ListFeedsBuilder> {
  /// Creates a new ListFeeds object using the builder pattern.
  factory ListFeeds([void Function(ListFeedsBuilder)? b]) = _$ListFeeds;

  // coverage:ignore-start
  const ListFeeds._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ListFeeds.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ListFeeds.
  static Serializer<ListFeeds> get serializer => _$listFeedsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ListFeedsBuilder b) {
    $ListFeedsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ListFeedsBuilder b) {
    $ListFeedsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ListArticlesInterface {
  BuiltList<Article> get items;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ListArticlesInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ListArticlesInterfaceBuilder b) {}
}

abstract class ListArticles implements $ListArticlesInterface, Built<ListArticles, ListArticlesBuilder> {
  /// Creates a new ListArticles object using the builder pattern.
  factory ListArticles([void Function(ListArticlesBuilder)? b]) = _$ListArticles;

  // coverage:ignore-start
  const ListArticles._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ListArticles.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ListArticles.
  static Serializer<ListArticles> get serializer => _$listArticlesSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ListArticlesBuilder b) {
    $ListArticlesInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ListArticlesBuilder b) {
    $ListArticlesInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $OCSMetaInterface {
  String get status;
  int get statuscode;
  String? get message;
  String? get totalitems;
  String? get itemsperpage;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($OCSMetaInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($OCSMetaInterfaceBuilder b) {}
}

abstract class OCSMeta implements $OCSMetaInterface, Built<OCSMeta, OCSMetaBuilder> {
  /// Creates a new OCSMeta object using the builder pattern.
  factory OCSMeta([void Function(OCSMetaBuilder)? b]) = _$OCSMeta;

  // coverage:ignore-start
  const OCSMeta._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory OCSMeta.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for OCSMeta.
  static Serializer<OCSMeta> get serializer => _$oCSMetaSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(OCSMetaBuilder b) {
    $OCSMetaInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(OCSMetaBuilder b) {
    $OCSMetaInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $EmptyOCS_OcsInterface {
  OCSMeta get meta;
  BuiltList<JsonObject> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($EmptyOCS_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($EmptyOCS_OcsInterfaceBuilder b) {}
}

abstract class EmptyOCS_Ocs implements $EmptyOCS_OcsInterface, Built<EmptyOCS_Ocs, EmptyOCS_OcsBuilder> {
  /// Creates a new EmptyOCS_Ocs object using the builder pattern.
  factory EmptyOCS_Ocs([void Function(EmptyOCS_OcsBuilder)? b]) = _$EmptyOCS_Ocs;

  // coverage:ignore-start
  const EmptyOCS_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory EmptyOCS_Ocs.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for EmptyOCS_Ocs.
  static Serializer<EmptyOCS_Ocs> get serializer => _$emptyOCSOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(EmptyOCS_OcsBuilder b) {
    $EmptyOCS_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(EmptyOCS_OcsBuilder b) {
    $EmptyOCS_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $EmptyOCSInterface {
  EmptyOCS_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($EmptyOCSInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($EmptyOCSInterfaceBuilder b) {}
}

abstract class EmptyOCS implements $EmptyOCSInterface, Built<EmptyOCS, EmptyOCSBuilder> {
  /// Creates a new EmptyOCS object using the builder pattern.
  factory EmptyOCS([void Function(EmptyOCSBuilder)? b]) = _$EmptyOCS;

  // coverage:ignore-start
  const EmptyOCS._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory EmptyOCS.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for EmptyOCS.
  static Serializer<EmptyOCS> get serializer => _$emptyOCSSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(EmptyOCSBuilder b) {
    $EmptyOCSInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(EmptyOCSBuilder b) {
    $EmptyOCSInterface._validate(b);
  }
}

// coverage:ignore-start
/// Serializer for all values in this library.
///
/// Serializes values into the `built_value` wire format.
/// See: [$jsonSerializers] for serializing into json.
@_i2.visibleForTesting
final Serializers $serializers = _$serializers;
final Serializers _$serializers = (Serializers().toBuilder()
      ..addBuilderFactory(const FullType(SupportedAPIVersions), SupportedAPIVersionsBuilder.new)
      ..add(SupportedAPIVersions.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(String)]), ListBuilder<String>.new)
      ..addBuilderFactory(const FullType(ListFolders), ListFoldersBuilder.new)
      ..add(ListFolders.serializer)
      ..addBuilderFactory(const FullType(Folder), FolderBuilder.new)
      ..add(Folder.serializer)
      ..addBuilderFactory(const FullType(Feed), FeedBuilder.new)
      ..add(Feed.serializer)
      ..addBuilderFactory(const FullType(Article), ArticleBuilder.new)
      ..add(Article.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(Article)]), ListBuilder<Article>.new)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(Feed)]), ListBuilder<Feed>.new)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(Folder)]), ListBuilder<Folder>.new)
      ..addBuilderFactory(const FullType(ListFeeds), ListFeedsBuilder.new)
      ..add(ListFeeds.serializer)
      ..addBuilderFactory(const FullType(ListArticles), ListArticlesBuilder.new)
      ..add(ListArticles.serializer)
      ..addBuilderFactory(const FullType(OCSMeta), OCSMetaBuilder.new)
      ..add(OCSMeta.serializer)
      ..addBuilderFactory(const FullType(EmptyOCS), EmptyOCSBuilder.new)
      ..add(EmptyOCS.serializer)
      ..addBuilderFactory(const FullType(EmptyOCS_Ocs), EmptyOCS_OcsBuilder.new)
      ..add(EmptyOCS_Ocs.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(JsonObject)]), ListBuilder<JsonObject>.new))
    .build();

/// Serializer for all values in this library.
///
/// Serializes values into the json. Json serialization is more expensive than the built_value wire format.
/// See: [$serializers] for serializing into the `built_value` wire format.
@_i2.visibleForTesting
final Serializers $jsonSerializers = _$jsonSerializers;
final Serializers _$jsonSerializers = (_$serializers.toBuilder()
      ..add(_i5.DynamiteDoubleSerializer())
      ..addPlugin(_i6.StandardJsonPlugin())
      ..addPlugin(const _i5.HeaderPlugin())
      ..addPlugin(const _i5.ContentStringPlugin()))
    .build();
// coverage:ignore-end
