// Use of this source code is governed by a agpl license. It can be obtained at `https://spdx.org/licenses/AGPL-3.0-only.html`.

// OpenAPI client generated by Dynamite. Do not manually edit this file.

// ignore_for_file: camel_case_extensions, camel_case_types, discarded_futures
// ignore_for_file: no_leading_underscores_for_local_identifiers
// ignore_for_file: non_constant_identifier_names, public_member_api_docs
// ignore_for_file: unreachable_switch_case

/// core Version: 0.0.1.
///
/// Core functionality of Nextcloud.
///
/// Use of this source code is governed by a agpl license.
/// It can be obtained at `https://spdx.org/licenses/AGPL-3.0-only.html`.
library; // ignore_for_file: no_leading_underscores_for_library_prefixes

import 'dart:typed_data';

import 'package:built_collection/built_collection.dart';
import 'package:built_value/built_value.dart';
import 'package:built_value/json_object.dart';
import 'package:built_value/serializer.dart';
import 'package:built_value/standard_json_plugin.dart' as _i7;
import 'package:collection/collection.dart';
import 'package:dynamite_runtime/built_value.dart' as _i6;
import 'package:dynamite_runtime/http_client.dart' as _i1;
import 'package:dynamite_runtime/models.dart';
import 'package:dynamite_runtime/utils.dart' as _i4;
import 'package:http/http.dart' as _i3;
import 'package:meta/meta.dart' as _i2;
import 'package:uri/uri.dart' as _i5;

part 'core.openapi.g.dart';

class $Client extends _i1.DynamiteClient {
  /// Creates a new `DynamiteClient` for untagged requests.
  $Client(
    super.baseURL, {
    super.httpClient,
    super.authentications,
  });

  /// Creates a new [$Client] from another [client].
  $Client.fromClient(_i1.DynamiteClient client)
      : super(
          client.baseURL,
          httpClient: client.httpClient,
          authentications: client.authentications,
        );

  late final $AppPasswordClient appPassword = $AppPasswordClient(this);

  late final $AutoCompleteClient autoComplete = $AutoCompleteClient(this);

  /// Class AvatarController.
  late final $AvatarClient avatar = $AvatarClient(this);

  late final $ClientFlowLoginV2Client clientFlowLoginV2 = $ClientFlowLoginV2Client(this);

  late final $CollaborationResourcesClient collaborationResources = $CollaborationResourcesClient(this);

  /// This controller handles guest avatar requests.
  late final $GuestAvatarClient guestAvatar = $GuestAvatarClient(this);

  late final $HoverCardClient hoverCard = $HoverCardClient(this);

  late final $LoginClient login = $LoginClient(this);

  late final $NavigationClient navigation = $NavigationClient(this);

  /// Controller about the endpoint /ocm-provider/.
  late final $OcmClient ocm = $OcmClient(this);

  late final $OcsClient ocs = $OcsClient(this);

  late final $PreviewClient preview = $PreviewClient(this);

  late final $ProfileApiClient profileApi = $ProfileApiClient(this);

  late final $ReferenceClient reference = $ReferenceClient(this);

  late final $ReferenceApiClient referenceApi = $ReferenceApiClient(this);

  late final $TeamsApiClient teamsApi = $TeamsApiClient(this);

  late final $TextProcessingApiClient textProcessingApi = $TextProcessingApiClient(this);

  late final $TextToImageApiClient textToImageApi = $TextToImageApiClient(this);

  late final $TranslationApiClient translationApi = $TranslationApiClient(this);

  late final $UnifiedSearchClient unifiedSearch = $UnifiedSearchClient(this);

  late final $WhatsNewClient whatsNew = $WhatsNewClient(this);

  late final $WipeClient wipe = $WipeClient(this);

  /// Builds a serializer to parse the response of [$getStatus_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<Status, void> $getStatus_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(Status),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Returns a `DynamiteRequest` backing the [getStatus] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Status codes:
  ///   * 200: Status returned
  ///
  /// See:
  ///  * [getStatus] for a method executing this request and parsing the response.
  ///  * [$getStatus_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getStatus_Request() {
    const _path = '/status.php';
    final _uri = Uri.parse('$baseURL$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
    return _request;
  }

  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Status codes:
  ///   * 200: Status returned
  ///
  /// See:
  ///  * [$getStatus_Request] for the request send by this method.
  ///  * [$getStatus_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<Status, void>> getStatus() async {
    final _request = $getStatus_Request();
    final _response = await httpClient.send(_request);

    final _serializer = $getStatus_Serializer();
    final _rawResponse = await _i1.ResponseConverter<Status, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $AppPasswordClient {
  /// Creates a new `DynamiteClient` for app_password requests.
  $AppPasswordClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$getAppPassword_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<AppPasswordGetAppPasswordResponseApplicationJson, void> $getAppPassword_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(AppPasswordGetAppPasswordResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Create app password.
  ///
  /// This endpoint requires password confirmation.
  ///
  /// Returns a `DynamiteRequest` backing the [getAppPassword] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: App password returned
  ///   * 403: Creating app password is not allowed
  ///
  /// See:
  ///  * [getAppPassword] for a method executing this request and parsing the response.
  ///  * [$getAppPassword_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getAppPassword_Request({bool? oCSAPIRequest}) {
    const _path = '/ocs/v2.php/core/getapppassword';
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Create app password.
  ///
  /// This endpoint requires password confirmation.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: App password returned
  ///   * 403: Creating app password is not allowed
  ///
  /// See:
  ///  * [$getAppPassword_Request] for the request send by this method.
  ///  * [$getAppPassword_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<AppPasswordGetAppPasswordResponseApplicationJson, void>> getAppPassword({
    bool? oCSAPIRequest,
  }) async {
    final _request = $getAppPassword_Request(
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getAppPassword_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<AppPasswordGetAppPasswordResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$deleteAppPassword_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<AppPasswordDeleteAppPasswordResponseApplicationJson, void> $deleteAppPassword_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(AppPasswordDeleteAppPasswordResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 403},
      );

  /// Delete app password.
  ///
  /// Returns a `DynamiteRequest` backing the [deleteAppPassword] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: App password deleted successfully
  ///   * 403: Deleting app password is not allowed
  ///
  /// See:
  ///  * [deleteAppPassword] for a method executing this request and parsing the response.
  ///  * [$deleteAppPassword_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $deleteAppPassword_Request({bool? oCSAPIRequest}) {
    const _path = '/ocs/v2.php/core/apppassword';
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Delete app password.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: App password deleted successfully
  ///   * 403: Deleting app password is not allowed
  ///
  /// See:
  ///  * [$deleteAppPassword_Request] for the request send by this method.
  ///  * [$deleteAppPassword_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<AppPasswordDeleteAppPasswordResponseApplicationJson, void>> deleteAppPassword({
    bool? oCSAPIRequest,
  }) async {
    final _request = $deleteAppPassword_Request(
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $deleteAppPassword_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<AppPasswordDeleteAppPasswordResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$rotateAppPassword_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<AppPasswordRotateAppPasswordResponseApplicationJson, void> $rotateAppPassword_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(AppPasswordRotateAppPasswordResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Rotate app password.
  ///
  /// Returns a `DynamiteRequest` backing the [rotateAppPassword] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: App password returned
  ///   * 403: Rotating app password is not allowed
  ///
  /// See:
  ///  * [rotateAppPassword] for a method executing this request and parsing the response.
  ///  * [$rotateAppPassword_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $rotateAppPassword_Request({bool? oCSAPIRequest}) {
    const _path = '/ocs/v2.php/core/apppassword/rotate';
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Rotate app password.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: App password returned
  ///   * 403: Rotating app password is not allowed
  ///
  /// See:
  ///  * [$rotateAppPassword_Request] for the request send by this method.
  ///  * [$rotateAppPassword_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<AppPasswordRotateAppPasswordResponseApplicationJson, void>> rotateAppPassword({
    bool? oCSAPIRequest,
  }) async {
    final _request = $rotateAppPassword_Request(
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $rotateAppPassword_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<AppPasswordRotateAppPasswordResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$confirmUserPassword_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<AppPasswordConfirmUserPasswordResponseApplicationJson, void>
      $confirmUserPassword_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(AppPasswordConfirmUserPasswordResponseApplicationJson),
            headersType: null,
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Confirm the user password.
  ///
  /// Returns a `DynamiteRequest` backing the [confirmUserPassword] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [password] The password of the user.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Password confirmation succeeded
  ///   * 403: Password confirmation failed
  ///
  /// See:
  ///  * [confirmUserPassword] for a method executing this request and parsing the response.
  ///  * [$confirmUserPassword_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $confirmUserPassword_Request({
    required String password,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $password = _$jsonSerializers.serialize(password, specifiedType: const FullType(String));
    _parameters['password'] = $password;

    final _path = _i5.UriTemplate('/ocs/v2.php/core/apppassword/confirm{?password*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('put', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Confirm the user password.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [password] The password of the user.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Password confirmation succeeded
  ///   * 403: Password confirmation failed
  ///
  /// See:
  ///  * [$confirmUserPassword_Request] for the request send by this method.
  ///  * [$confirmUserPassword_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<AppPasswordConfirmUserPasswordResponseApplicationJson, void>> confirmUserPassword({
    required String password,
    bool? oCSAPIRequest,
  }) async {
    final _request = $confirmUserPassword_Request(
      password: password,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $confirmUserPassword_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<AppPasswordConfirmUserPasswordResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $AutoCompleteClient {
  /// Creates a new `DynamiteClient` for auto_complete requests.
  $AutoCompleteClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$$get_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<AutoCompleteGetResponseApplicationJson, void> $$get_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(AutoCompleteGetResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Autocomplete a query.
  ///
  /// Returns a `DynamiteRequest` backing the [$get] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [search] Text to search for.
  ///   * [itemType] Type of the items to search for.
  ///   * [itemId] ID of the items to search for.
  ///   * [sorter] can be piped, top prio first, e.g.: "commenters|share-recipients".
  ///   * [shareTypes] Types of shares to search for. Defaults to `[]`.
  ///   * [limit] Maximum number of results to return. Defaults to `10`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Autocomplete results returned
  ///
  /// See:
  ///  * [$get] for a method executing this request and parsing the response.
  ///  * [$$get_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $$get_Request({
    required String search,
    String? itemType,
    String? itemId,
    String? sorter,
    BuiltList<int>? shareTypes,
    int? limit,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $search = _$jsonSerializers.serialize(search, specifiedType: const FullType(String));
    _parameters['search'] = $search;

    final $itemType = _$jsonSerializers.serialize(itemType, specifiedType: const FullType(String));
    _parameters['itemType'] = $itemType;

    final $itemId = _$jsonSerializers.serialize(itemId, specifiedType: const FullType(String));
    _parameters['itemId'] = $itemId;

    final $sorter = _$jsonSerializers.serialize(sorter, specifiedType: const FullType(String));
    _parameters['sorter'] = $sorter;

    var $shareTypes =
        _$jsonSerializers.serialize(shareTypes, specifiedType: const FullType(BuiltList, [FullType(int)]));
    $shareTypes ??= [];
    _parameters['shareTypes%5B%5D'] = $shareTypes;

    var $limit = _$jsonSerializers.serialize(limit, specifiedType: const FullType(int));
    $limit ??= 10;
    _parameters['limit'] = $limit;

    final _path = _i5.UriTemplate(
      '/ocs/v2.php/core/autocomplete/get{?search*,itemType*,itemId*,sorter*,shareTypes%5B%5D*,limit*}',
    ).expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Autocomplete a query.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [search] Text to search for.
  ///   * [itemType] Type of the items to search for.
  ///   * [itemId] ID of the items to search for.
  ///   * [sorter] can be piped, top prio first, e.g.: "commenters|share-recipients".
  ///   * [shareTypes] Types of shares to search for. Defaults to `[]`.
  ///   * [limit] Maximum number of results to return. Defaults to `10`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Autocomplete results returned
  ///
  /// See:
  ///  * [$$get_Request] for the request send by this method.
  ///  * [$$get_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<AutoCompleteGetResponseApplicationJson, void>> $get({
    required String search,
    String? itemType,
    String? itemId,
    String? sorter,
    BuiltList<int>? shareTypes,
    int? limit,
    bool? oCSAPIRequest,
  }) async {
    final _request = $$get_Request(
      search: search,
      itemType: itemType,
      itemId: itemId,
      sorter: sorter,
      shareTypes: shareTypes,
      limit: limit,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $$get_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<AutoCompleteGetResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

/// Class AvatarController.
class $AvatarClient {
  /// Creates a new `DynamiteClient` for avatar requests.
  $AvatarClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$getAvatarDark_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<Uint8List, AvatarAvatarGetAvatarDarkHeaders> $getAvatarDark_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(Uint8List),
        headersType: const FullType(AvatarAvatarGetAvatarDarkHeaders),
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get the dark avatar.
  ///
  /// Returns a `DynamiteRequest` backing the [getAvatarDark] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [userId] ID of the user.
  ///   * [size] Size of the avatar.
  ///
  /// Status codes:
  ///   * 200: Avatar returned
  ///   * 404: Avatar not found
  ///
  /// See:
  ///  * [getAvatarDark] for a method executing this request and parsing the response.
  ///  * [$getAvatarDark_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getAvatarDark_Request({
    required String userId,
    required int size,
  }) {
    final _parameters = <String, Object?>{};
    final $userId = _$jsonSerializers.serialize(userId, specifiedType: const FullType(String));
    _parameters['userId'] = $userId;

    final $size = _$jsonSerializers.serialize(size, specifiedType: const FullType(int));
    _parameters['size'] = $size;

    final _path = _i5.UriTemplate('/index.php/avatar/{userId}/{size}/dark').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = '*/*';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    return _request;
  }

  /// Get the dark avatar.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [userId] ID of the user.
  ///   * [size] Size of the avatar.
  ///
  /// Status codes:
  ///   * 200: Avatar returned
  ///   * 404: Avatar not found
  ///
  /// See:
  ///  * [$getAvatarDark_Request] for the request send by this method.
  ///  * [$getAvatarDark_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<Uint8List, AvatarAvatarGetAvatarDarkHeaders>> getAvatarDark({
    required String userId,
    required int size,
  }) async {
    final _request = $getAvatarDark_Request(
      userId: userId,
      size: size,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getAvatarDark_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<Uint8List, AvatarAvatarGetAvatarDarkHeaders>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$getAvatar_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<Uint8List, AvatarAvatarGetAvatarHeaders> $getAvatar_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(Uint8List),
        headersType: const FullType(AvatarAvatarGetAvatarHeaders),
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get the avatar.
  ///
  /// Returns a `DynamiteRequest` backing the [getAvatar] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [userId] ID of the user.
  ///   * [size] Size of the avatar.
  ///
  /// Status codes:
  ///   * 200: Avatar returned
  ///   * 404: Avatar not found
  ///
  /// See:
  ///  * [getAvatar] for a method executing this request and parsing the response.
  ///  * [$getAvatar_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getAvatar_Request({
    required String userId,
    required int size,
  }) {
    final _parameters = <String, Object?>{};
    final $userId = _$jsonSerializers.serialize(userId, specifiedType: const FullType(String));
    _parameters['userId'] = $userId;

    final $size = _$jsonSerializers.serialize(size, specifiedType: const FullType(int));
    _parameters['size'] = $size;

    final _path = _i5.UriTemplate('/index.php/avatar/{userId}/{size}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = '*/*';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    return _request;
  }

  /// Get the avatar.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [userId] ID of the user.
  ///   * [size] Size of the avatar.
  ///
  /// Status codes:
  ///   * 200: Avatar returned
  ///   * 404: Avatar not found
  ///
  /// See:
  ///  * [$getAvatar_Request] for the request send by this method.
  ///  * [$getAvatar_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<Uint8List, AvatarAvatarGetAvatarHeaders>> getAvatar({
    required String userId,
    required int size,
  }) async {
    final _request = $getAvatar_Request(
      userId: userId,
      size: size,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getAvatar_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<Uint8List, AvatarAvatarGetAvatarHeaders>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $ClientFlowLoginV2Client {
  /// Creates a new `DynamiteClient` for client_flow_login_v2 requests.
  $ClientFlowLoginV2Client(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$poll_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<LoginFlowV2Credentials, void> $poll_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(LoginFlowV2Credentials),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Poll the login flow credentials.
  ///
  /// Returns a `DynamiteRequest` backing the [poll] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [token] Token of the flow.
  ///
  /// Status codes:
  ///   * 200: Login flow credentials returned
  ///   * 404: Login flow not found or completed
  ///
  /// See:
  ///  * [poll] for a method executing this request and parsing the response.
  ///  * [$poll_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $poll_Request({required String token}) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _parameters['token'] = $token;

    final _path = _i5.UriTemplate('/index.php/login/v2/poll{?token*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    return _request;
  }

  /// Poll the login flow credentials.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [token] Token of the flow.
  ///
  /// Status codes:
  ///   * 200: Login flow credentials returned
  ///   * 404: Login flow not found or completed
  ///
  /// See:
  ///  * [$poll_Request] for the request send by this method.
  ///  * [$poll_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<LoginFlowV2Credentials, void>> poll({required String token}) async {
    final _request = $poll_Request(
      token: token,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $poll_Serializer();
    final _rawResponse = await _i1.ResponseConverter<LoginFlowV2Credentials, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$init_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<LoginFlowV2, void> $init_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(LoginFlowV2),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Init a login flow.
  ///
  /// Returns a `DynamiteRequest` backing the [init] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Status codes:
  ///   * 200: Login flow init returned
  ///
  /// See:
  ///  * [init] for a method executing this request and parsing the response.
  ///  * [$init_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $init_Request() {
    const _path = '/index.php/login/v2';
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    return _request;
  }

  /// Init a login flow.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Status codes:
  ///   * 200: Login flow init returned
  ///
  /// See:
  ///  * [$init_Request] for the request send by this method.
  ///  * [$init_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<LoginFlowV2, void>> init() async {
    final _request = $init_Request();
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $init_Serializer();
    final _rawResponse = await _i1.ResponseConverter<LoginFlowV2, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $CollaborationResourcesClient {
  /// Creates a new `DynamiteClient` for collaboration_resources requests.
  $CollaborationResourcesClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$listCollection_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<CollaborationResourcesListCollectionResponseApplicationJson, void>
      $listCollection_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(CollaborationResourcesListCollectionResponseApplicationJson),
            headersType: null,
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Get a collection.
  ///
  /// Returns a `DynamiteRequest` backing the [listCollection] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [collectionId] ID of the collection.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Collection returned
  ///   * 404: Collection not found
  ///   * 500
  ///
  /// See:
  ///  * [listCollection] for a method executing this request and parsing the response.
  ///  * [$listCollection_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $listCollection_Request({
    required int collectionId,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $collectionId = _$jsonSerializers.serialize(collectionId, specifiedType: const FullType(int));
    _parameters['collectionId'] = $collectionId;

    final _path = _i5.UriTemplate('/ocs/v2.php/collaboration/resources/collections/{collectionId}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get a collection.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [collectionId] ID of the collection.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Collection returned
  ///   * 404: Collection not found
  ///   * 500
  ///
  /// See:
  ///  * [$listCollection_Request] for the request send by this method.
  ///  * [$listCollection_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<CollaborationResourcesListCollectionResponseApplicationJson, void>> listCollection({
    required int collectionId,
    bool? oCSAPIRequest,
  }) async {
    final _request = $listCollection_Request(
      collectionId: collectionId,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $listCollection_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<CollaborationResourcesListCollectionResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$renameCollection_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<CollaborationResourcesRenameCollectionResponseApplicationJson, void>
      $renameCollection_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(CollaborationResourcesRenameCollectionResponseApplicationJson),
            headersType: null,
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Rename a collection.
  ///
  /// Returns a `DynamiteRequest` backing the [renameCollection] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [collectionName] New name.
  ///   * [collectionId] ID of the collection.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Collection returned
  ///   * 404: Collection not found
  ///   * 500
  ///
  /// See:
  ///  * [renameCollection] for a method executing this request and parsing the response.
  ///  * [$renameCollection_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $renameCollection_Request({
    required String collectionName,
    required int collectionId,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $collectionName = _$jsonSerializers.serialize(collectionName, specifiedType: const FullType(String));
    _parameters['collectionName'] = $collectionName;

    final $collectionId = _$jsonSerializers.serialize(collectionId, specifiedType: const FullType(int));
    _parameters['collectionId'] = $collectionId;

    final _path = _i5.UriTemplate('/ocs/v2.php/collaboration/resources/collections/{collectionId}{?collectionName*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('put', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Rename a collection.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [collectionName] New name.
  ///   * [collectionId] ID of the collection.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Collection returned
  ///   * 404: Collection not found
  ///   * 500
  ///
  /// See:
  ///  * [$renameCollection_Request] for the request send by this method.
  ///  * [$renameCollection_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<CollaborationResourcesRenameCollectionResponseApplicationJson, void>> renameCollection({
    required String collectionName,
    required int collectionId,
    bool? oCSAPIRequest,
  }) async {
    final _request = $renameCollection_Request(
      collectionName: collectionName,
      collectionId: collectionId,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $renameCollection_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<CollaborationResourcesRenameCollectionResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$addResource_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<CollaborationResourcesAddResourceResponseApplicationJson, void> $addResource_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(CollaborationResourcesAddResourceResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Add a resource to a collection.
  ///
  /// Returns a `DynamiteRequest` backing the [addResource] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [resourceType] Name of the resource.
  ///   * [resourceId] ID of the resource.
  ///   * [collectionId] ID of the collection.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Collection returned
  ///   * 404: Collection not found or resource inaccessible
  ///   * 500
  ///
  /// See:
  ///  * [addResource] for a method executing this request and parsing the response.
  ///  * [$addResource_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $addResource_Request({
    required String resourceType,
    required String resourceId,
    required int collectionId,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $resourceType = _$jsonSerializers.serialize(resourceType, specifiedType: const FullType(String));
    _parameters['resourceType'] = $resourceType;

    final $resourceId = _$jsonSerializers.serialize(resourceId, specifiedType: const FullType(String));
    _parameters['resourceId'] = $resourceId;

    final $collectionId = _$jsonSerializers.serialize(collectionId, specifiedType: const FullType(int));
    _parameters['collectionId'] = $collectionId;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/collaboration/resources/collections/{collectionId}{?resourceType*,resourceId*}')
            .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Add a resource to a collection.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [resourceType] Name of the resource.
  ///   * [resourceId] ID of the resource.
  ///   * [collectionId] ID of the collection.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Collection returned
  ///   * 404: Collection not found or resource inaccessible
  ///   * 500
  ///
  /// See:
  ///  * [$addResource_Request] for the request send by this method.
  ///  * [$addResource_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<CollaborationResourcesAddResourceResponseApplicationJson, void>> addResource({
    required String resourceType,
    required String resourceId,
    required int collectionId,
    bool? oCSAPIRequest,
  }) async {
    final _request = $addResource_Request(
      resourceType: resourceType,
      resourceId: resourceId,
      collectionId: collectionId,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $addResource_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<CollaborationResourcesAddResourceResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$removeResource_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<CollaborationResourcesRemoveResourceResponseApplicationJson, void>
      $removeResource_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(CollaborationResourcesRemoveResourceResponseApplicationJson),
            headersType: null,
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Remove a resource from a collection.
  ///
  /// Returns a `DynamiteRequest` backing the [removeResource] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [resourceType] Name of the resource.
  ///   * [resourceId] ID of the resource.
  ///   * [collectionId] ID of the collection.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Collection returned
  ///   * 404: Collection or resource not found
  ///   * 500
  ///
  /// See:
  ///  * [removeResource] for a method executing this request and parsing the response.
  ///  * [$removeResource_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $removeResource_Request({
    required String resourceType,
    required String resourceId,
    required int collectionId,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $resourceType = _$jsonSerializers.serialize(resourceType, specifiedType: const FullType(String));
    _parameters['resourceType'] = $resourceType;

    final $resourceId = _$jsonSerializers.serialize(resourceId, specifiedType: const FullType(String));
    _parameters['resourceId'] = $resourceId;

    final $collectionId = _$jsonSerializers.serialize(collectionId, specifiedType: const FullType(int));
    _parameters['collectionId'] = $collectionId;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/collaboration/resources/collections/{collectionId}{?resourceType*,resourceId*}')
            .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Remove a resource from a collection.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [resourceType] Name of the resource.
  ///   * [resourceId] ID of the resource.
  ///   * [collectionId] ID of the collection.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Collection returned
  ///   * 404: Collection or resource not found
  ///   * 500
  ///
  /// See:
  ///  * [$removeResource_Request] for the request send by this method.
  ///  * [$removeResource_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<CollaborationResourcesRemoveResourceResponseApplicationJson, void>> removeResource({
    required String resourceType,
    required String resourceId,
    required int collectionId,
    bool? oCSAPIRequest,
  }) async {
    final _request = $removeResource_Request(
      resourceType: resourceType,
      resourceId: resourceId,
      collectionId: collectionId,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $removeResource_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<CollaborationResourcesRemoveResourceResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$searchCollections_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<CollaborationResourcesSearchCollectionsResponseApplicationJson, void>
      $searchCollections_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(CollaborationResourcesSearchCollectionsResponseApplicationJson),
            headersType: null,
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Search for collections.
  ///
  /// Returns a `DynamiteRequest` backing the [searchCollections] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [filter] Filter collections.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Collections returned
  ///   * 404: Collection not found
  ///
  /// See:
  ///  * [searchCollections] for a method executing this request and parsing the response.
  ///  * [$searchCollections_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $searchCollections_Request({
    required String filter,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $filter = _$jsonSerializers.serialize(filter, specifiedType: const FullType(String));
    _parameters['filter'] = $filter;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/collaboration/resources/collections/search/{filter}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Search for collections.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [filter] Filter collections.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Collections returned
  ///   * 404: Collection not found
  ///
  /// See:
  ///  * [$searchCollections_Request] for the request send by this method.
  ///  * [$searchCollections_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<CollaborationResourcesSearchCollectionsResponseApplicationJson, void>> searchCollections({
    required String filter,
    bool? oCSAPIRequest,
  }) async {
    final _request = $searchCollections_Request(
      filter: filter,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $searchCollections_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<CollaborationResourcesSearchCollectionsResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$getCollectionsByResource_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<CollaborationResourcesGetCollectionsByResourceResponseApplicationJson, void>
      $getCollectionsByResource_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(CollaborationResourcesGetCollectionsByResourceResponseApplicationJson),
            headersType: null,
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Get collections by resource.
  ///
  /// Returns a `DynamiteRequest` backing the [getCollectionsByResource] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [resourceType] Type of the resource.
  ///   * [resourceId] ID of the resource.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Collections returned
  ///   * 404: Resource not accessible
  ///
  /// See:
  ///  * [getCollectionsByResource] for a method executing this request and parsing the response.
  ///  * [$getCollectionsByResource_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getCollectionsByResource_Request({
    required String resourceType,
    required String resourceId,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $resourceType = _$jsonSerializers.serialize(resourceType, specifiedType: const FullType(String));
    _parameters['resourceType'] = $resourceType;

    final $resourceId = _$jsonSerializers.serialize(resourceId, specifiedType: const FullType(String));
    _parameters['resourceId'] = $resourceId;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/collaboration/resources/{resourceType}/{resourceId}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get collections by resource.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [resourceType] Type of the resource.
  ///   * [resourceId] ID of the resource.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Collections returned
  ///   * 404: Resource not accessible
  ///
  /// See:
  ///  * [$getCollectionsByResource_Request] for the request send by this method.
  ///  * [$getCollectionsByResource_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<CollaborationResourcesGetCollectionsByResourceResponseApplicationJson, void>>
      getCollectionsByResource({
    required String resourceType,
    required String resourceId,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getCollectionsByResource_Request(
      resourceType: resourceType,
      resourceId: resourceId,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getCollectionsByResource_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<CollaborationResourcesGetCollectionsByResourceResponseApplicationJson, void>(
      _serializer,
    ).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$createCollectionOnResource_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson, void>
      $createCollectionOnResource_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson),
            headersType: null,
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Create a collection for a resource.
  ///
  /// Returns a `DynamiteRequest` backing the [createCollectionOnResource] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [name] Name of the collection.
  ///   * [baseResourceType] Type of the base resource.
  ///   * [baseResourceId] ID of the base resource.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Collection returned
  ///   * 400: Creating collection is not possible
  ///   * 404: Resource inaccessible
  ///   * 500
  ///
  /// See:
  ///  * [createCollectionOnResource] for a method executing this request and parsing the response.
  ///  * [$createCollectionOnResource_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $createCollectionOnResource_Request({
    required String name,
    required String baseResourceType,
    required String baseResourceId,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $name = _$jsonSerializers.serialize(name, specifiedType: const FullType(String));
    _parameters['name'] = $name;

    final $baseResourceType = _$jsonSerializers.serialize(baseResourceType, specifiedType: const FullType(String));
    _parameters['baseResourceType'] = $baseResourceType;

    final $baseResourceId = _$jsonSerializers.serialize(baseResourceId, specifiedType: const FullType(String));
    _parameters['baseResourceId'] = $baseResourceId;

    final _path = _i5.UriTemplate('/ocs/v2.php/collaboration/resources/{baseResourceType}/{baseResourceId}{?name*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Create a collection for a resource.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [name] Name of the collection.
  ///   * [baseResourceType] Type of the base resource.
  ///   * [baseResourceId] ID of the base resource.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Collection returned
  ///   * 400: Creating collection is not possible
  ///   * 404: Resource inaccessible
  ///   * 500
  ///
  /// See:
  ///  * [$createCollectionOnResource_Request] for the request send by this method.
  ///  * [$createCollectionOnResource_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson, void>>
      createCollectionOnResource({
    required String name,
    required String baseResourceType,
    required String baseResourceId,
    bool? oCSAPIRequest,
  }) async {
    final _request = $createCollectionOnResource_Request(
      name: name,
      baseResourceType: baseResourceType,
      baseResourceId: baseResourceId,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $createCollectionOnResource_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson, void>(
      _serializer,
    ).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

/// This controller handles guest avatar requests.
class $GuestAvatarClient {
  /// Creates a new `DynamiteClient` for guest_avatar requests.
  $GuestAvatarClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$getAvatar_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<Uint8List, void> $getAvatar_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(Uint8List),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 201},
      );

  /// Returns a guest avatar image response.
  ///
  /// Returns a `DynamiteRequest` backing the [getAvatar] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [darkTheme] Return dark avatar. Defaults to `0`.
  ///   * [guestName] The guest name, e.g. "Albert".
  ///   * [size] The desired avatar size, e.g. 64 for 64x64px.
  ///
  /// Status codes:
  ///   * 200: Custom avatar returned
  ///   * 201: Avatar returned
  ///   * 500
  ///
  /// See:
  ///  * [getAvatar] for a method executing this request and parsing the response.
  ///  * [$getAvatar_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getAvatar_Request({
    required String guestName,
    required String size,
    GuestAvatarGetAvatarDarkTheme? darkTheme,
  }) {
    final _parameters = <String, Object?>{};
    final $guestName = _$jsonSerializers.serialize(guestName, specifiedType: const FullType(String));
    _parameters['guestName'] = $guestName;

    final $size = _$jsonSerializers.serialize(size, specifiedType: const FullType(String));
    _parameters['size'] = $size;

    var $darkTheme =
        _$jsonSerializers.serialize(darkTheme, specifiedType: const FullType(GuestAvatarGetAvatarDarkTheme));
    $darkTheme ??= 0;
    _parameters['darkTheme'] = $darkTheme;

    final _path = _i5.UriTemplate('/index.php/avatar/guest/{guestName}/{size}{?darkTheme*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = '*/*';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    return _request;
  }

  /// Returns a guest avatar image response.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [darkTheme] Return dark avatar. Defaults to `0`.
  ///   * [guestName] The guest name, e.g. "Albert".
  ///   * [size] The desired avatar size, e.g. 64 for 64x64px.
  ///
  /// Status codes:
  ///   * 200: Custom avatar returned
  ///   * 201: Avatar returned
  ///   * 500
  ///
  /// See:
  ///  * [$getAvatar_Request] for the request send by this method.
  ///  * [$getAvatar_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<Uint8List, void>> getAvatar({
    required String guestName,
    required String size,
    GuestAvatarGetAvatarDarkTheme? darkTheme,
  }) async {
    final _request = $getAvatar_Request(
      guestName: guestName,
      size: size,
      darkTheme: darkTheme,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getAvatar_Serializer();
    final _rawResponse = await _i1.ResponseConverter<Uint8List, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$getAvatarDark_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<Uint8List, void> $getAvatarDark_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(Uint8List),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 201},
      );

  /// Returns a dark guest avatar image response.
  ///
  /// Returns a `DynamiteRequest` backing the [getAvatarDark] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [guestName] The guest name, e.g. "Albert".
  ///   * [size] The desired avatar size, e.g. 64 for 64x64px.
  ///
  /// Status codes:
  ///   * 200: Custom avatar returned
  ///   * 201: Avatar returned
  ///   * 500
  ///
  /// See:
  ///  * [getAvatarDark] for a method executing this request and parsing the response.
  ///  * [$getAvatarDark_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getAvatarDark_Request({
    required String guestName,
    required String size,
  }) {
    final _parameters = <String, Object?>{};
    final $guestName = _$jsonSerializers.serialize(guestName, specifiedType: const FullType(String));
    _parameters['guestName'] = $guestName;

    final $size = _$jsonSerializers.serialize(size, specifiedType: const FullType(String));
    _parameters['size'] = $size;

    final _path = _i5.UriTemplate('/index.php/avatar/guest/{guestName}/{size}/dark').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = '*/*';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    return _request;
  }

  /// Returns a dark guest avatar image response.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [guestName] The guest name, e.g. "Albert".
  ///   * [size] The desired avatar size, e.g. 64 for 64x64px.
  ///
  /// Status codes:
  ///   * 200: Custom avatar returned
  ///   * 201: Avatar returned
  ///   * 500
  ///
  /// See:
  ///  * [$getAvatarDark_Request] for the request send by this method.
  ///  * [$getAvatarDark_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<Uint8List, void>> getAvatarDark({
    required String guestName,
    required String size,
  }) async {
    final _request = $getAvatarDark_Request(
      guestName: guestName,
      size: size,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getAvatarDark_Serializer();
    final _rawResponse = await _i1.ResponseConverter<Uint8List, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $HoverCardClient {
  /// Creates a new `DynamiteClient` for hover_card requests.
  $HoverCardClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$getUser_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<HoverCardGetUserResponseApplicationJson, void> $getUser_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(HoverCardGetUserResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get the account details for a hovercard.
  ///
  /// Returns a `DynamiteRequest` backing the [getUser] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [userId] ID of the user.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Account details returned
  ///   * 404: Account not found
  ///
  /// See:
  ///  * [getUser] for a method executing this request and parsing the response.
  ///  * [$getUser_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getUser_Request({
    required String userId,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $userId = _$jsonSerializers.serialize(userId, specifiedType: const FullType(String));
    _parameters['userId'] = $userId;

    final _path = _i5.UriTemplate('/ocs/v2.php/hovercard/v1/{userId}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get the account details for a hovercard.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [userId] ID of the user.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Account details returned
  ///   * 404: Account not found
  ///
  /// See:
  ///  * [$getUser_Request] for the request send by this method.
  ///  * [$getUser_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<HoverCardGetUserResponseApplicationJson, void>> getUser({
    required String userId,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getUser_Request(
      userId: userId,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getUser_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<HoverCardGetUserResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $LoginClient {
  /// Creates a new `DynamiteClient` for login requests.
  $LoginClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$confirmPassword_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<LoginConfirmPasswordResponseApplicationJson, void> $confirmPassword_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(LoginConfirmPasswordResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Confirm the user password.
  ///
  /// Returns a `DynamiteRequest` backing the [confirmPassword] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [password] The password of the user.
  ///
  /// Status codes:
  ///   * 200: Password confirmation succeeded
  ///   * 403: Password confirmation failed
  ///
  /// See:
  ///  * [confirmPassword] for a method executing this request and parsing the response.
  ///  * [$confirmPassword_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $confirmPassword_Request({required String password}) {
    final _parameters = <String, Object?>{};
    final $password = _$jsonSerializers.serialize(password, specifiedType: const FullType(String));
    _parameters['password'] = $password;

    final _path = _i5.UriTemplate('/index.php/login/confirm{?password*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    return _request;
  }

  /// Confirm the user password.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [password] The password of the user.
  ///
  /// Status codes:
  ///   * 200: Password confirmation succeeded
  ///   * 403: Password confirmation failed
  ///
  /// See:
  ///  * [$confirmPassword_Request] for the request send by this method.
  ///  * [$confirmPassword_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<LoginConfirmPasswordResponseApplicationJson, void>> confirmPassword({
    required String password,
  }) async {
    final _request = $confirmPassword_Request(
      password: password,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $confirmPassword_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<LoginConfirmPasswordResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $NavigationClient {
  /// Creates a new `DynamiteClient` for navigation requests.
  $NavigationClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$getAppsNavigation_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<NavigationGetAppsNavigationResponseApplicationJson, void> $getAppsNavigation_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(NavigationGetAppsNavigationResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get the apps navigation.
  ///
  /// Returns a `DynamiteRequest` backing the [getAppsNavigation] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [absolute] Rewrite URLs to absolute ones. Defaults to `0`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Apps navigation returned
  ///   * 304: No apps navigation changed
  ///
  /// See:
  ///  * [getAppsNavigation] for a method executing this request and parsing the response.
  ///  * [$getAppsNavigation_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getAppsNavigation_Request({
    NavigationGetAppsNavigationAbsolute? absolute,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    var $absolute =
        _$jsonSerializers.serialize(absolute, specifiedType: const FullType(NavigationGetAppsNavigationAbsolute));
    $absolute ??= 0;
    _parameters['absolute'] = $absolute;

    final _path = _i5.UriTemplate('/ocs/v2.php/core/navigation/apps{?absolute*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get the apps navigation.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [absolute] Rewrite URLs to absolute ones. Defaults to `0`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Apps navigation returned
  ///   * 304: No apps navigation changed
  ///
  /// See:
  ///  * [$getAppsNavigation_Request] for the request send by this method.
  ///  * [$getAppsNavigation_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<NavigationGetAppsNavigationResponseApplicationJson, void>> getAppsNavigation({
    NavigationGetAppsNavigationAbsolute? absolute,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getAppsNavigation_Request(
      absolute: absolute,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getAppsNavigation_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<NavigationGetAppsNavigationResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$getSettingsNavigation_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<NavigationGetSettingsNavigationResponseApplicationJson, void>
      $getSettingsNavigation_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(NavigationGetSettingsNavigationResponseApplicationJson),
            headersType: null,
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Get the settings navigation.
  ///
  /// Returns a `DynamiteRequest` backing the [getSettingsNavigation] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [absolute] Rewrite URLs to absolute ones. Defaults to `0`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Apps navigation returned
  ///   * 304: No apps navigation changed
  ///
  /// See:
  ///  * [getSettingsNavigation] for a method executing this request and parsing the response.
  ///  * [$getSettingsNavigation_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getSettingsNavigation_Request({
    NavigationGetSettingsNavigationAbsolute? absolute,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    var $absolute =
        _$jsonSerializers.serialize(absolute, specifiedType: const FullType(NavigationGetSettingsNavigationAbsolute));
    $absolute ??= 0;
    _parameters['absolute'] = $absolute;

    final _path = _i5.UriTemplate('/ocs/v2.php/core/navigation/settings{?absolute*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get the settings navigation.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [absolute] Rewrite URLs to absolute ones. Defaults to `0`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Apps navigation returned
  ///   * 304: No apps navigation changed
  ///
  /// See:
  ///  * [$getSettingsNavigation_Request] for the request send by this method.
  ///  * [$getSettingsNavigation_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<NavigationGetSettingsNavigationResponseApplicationJson, void>> getSettingsNavigation({
    NavigationGetSettingsNavigationAbsolute? absolute,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getSettingsNavigation_Request(
      absolute: absolute,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getSettingsNavigation_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<NavigationGetSettingsNavigationResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

/// Controller about the endpoint /ocm-provider/.
class $OcmClient {
  /// Creates a new `DynamiteClient` for ocm requests.
  $OcmClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$discovery_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<OcmDiscoveryResponseApplicationJson, OcmOcmDiscoveryHeaders> $discovery_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(OcmDiscoveryResponseApplicationJson),
        headersType: const FullType(OcmOcmDiscoveryHeaders),
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// generate a OCMProvider with local data and send it as DataResponse. This replaces the old PHP file ocm-provider/index.php.
  ///
  /// Returns a `DynamiteRequest` backing the [discovery] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Status codes:
  ///   * 200: OCM Provider details returned
  ///   * 500: OCM not supported
  ///
  /// See:
  ///  * [discovery] for a method executing this request and parsing the response.
  ///  * [$discovery_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $discovery_Request() {
    const _path = '/index.php/ocm-provider';
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    return _request;
  }

  /// generate a OCMProvider with local data and send it as DataResponse. This replaces the old PHP file ocm-provider/index.php.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Status codes:
  ///   * 200: OCM Provider details returned
  ///   * 500: OCM not supported
  ///
  /// See:
  ///  * [$discovery_Request] for the request send by this method.
  ///  * [$discovery_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<OcmDiscoveryResponseApplicationJson, OcmOcmDiscoveryHeaders>> discovery() async {
    final _request = $discovery_Request();
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $discovery_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<OcmDiscoveryResponseApplicationJson, OcmOcmDiscoveryHeaders>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $OcsClient {
  /// Creates a new `DynamiteClient` for ocs requests.
  $OcsClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$getCapabilities_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<OcsGetCapabilitiesResponseApplicationJson, void> $getCapabilities_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(OcsGetCapabilitiesResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get the capabilities.
  ///
  /// Returns a `DynamiteRequest` backing the [getCapabilities] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Capabilities returned
  ///
  /// See:
  ///  * [getCapabilities] for a method executing this request and parsing the response.
  ///  * [$getCapabilities_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getCapabilities_Request({bool? oCSAPIRequest}) {
    const _path = '/ocs/v2.php/cloud/capabilities';
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get the capabilities.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Capabilities returned
  ///
  /// See:
  ///  * [$getCapabilities_Request] for the request send by this method.
  ///  * [$getCapabilities_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<OcsGetCapabilitiesResponseApplicationJson, void>> getCapabilities({
    bool? oCSAPIRequest,
  }) async {
    final _request = $getCapabilities_Request(
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getCapabilities_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<OcsGetCapabilitiesResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $PreviewClient {
  /// Creates a new `DynamiteClient` for preview requests.
  $PreviewClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$getPreview_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<Uint8List, void> $getPreview_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(Uint8List),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get a preview by file path.
  ///
  /// Returns a `DynamiteRequest` backing the [getPreview] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [file] Path of the file. Defaults to `''`.
  ///   * [x] Width of the preview. Defaults to `32`.
  ///   * [y] Height of the preview. Defaults to `32`.
  ///   * [a] Whether to not crop the preview. Defaults to `0`.
  ///   * [forceIcon] Force returning an icon. Defaults to `1`.
  ///   * [mode] How to crop the image. Defaults to `fill`.
  ///   * [mimeFallback] Whether to fallback to the mime icon if no preview is available. Defaults to `0`.
  ///
  /// Status codes:
  ///   * 200: Preview returned
  ///   * 400: Getting preview is not possible
  ///   * 403: Getting preview is not allowed
  ///   * 404: Preview not found
  ///   * 303: Redirect to the mime icon url if mimeFallback is true
  ///
  /// See:
  ///  * [getPreview] for a method executing this request and parsing the response.
  ///  * [$getPreview_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getPreview_Request({
    String? file,
    int? x,
    int? y,
    PreviewGetPreviewA? a,
    PreviewGetPreviewForceIcon? forceIcon,
    String? mode,
    PreviewGetPreviewMimeFallback? mimeFallback,
  }) {
    final _parameters = <String, Object?>{};
    var $file = _$jsonSerializers.serialize(file, specifiedType: const FullType(String));
    $file ??= '';
    _parameters['file'] = $file;

    var $x = _$jsonSerializers.serialize(x, specifiedType: const FullType(int));
    $x ??= 32;
    _parameters['x'] = $x;

    var $y = _$jsonSerializers.serialize(y, specifiedType: const FullType(int));
    $y ??= 32;
    _parameters['y'] = $y;

    var $a = _$jsonSerializers.serialize(a, specifiedType: const FullType(PreviewGetPreviewA));
    $a ??= 0;
    _parameters['a'] = $a;

    var $forceIcon = _$jsonSerializers.serialize(forceIcon, specifiedType: const FullType(PreviewGetPreviewForceIcon));
    $forceIcon ??= 1;
    _parameters['forceIcon'] = $forceIcon;

    var $mode = _$jsonSerializers.serialize(mode, specifiedType: const FullType(String));
    $mode ??= 'fill';
    _parameters['mode'] = $mode;

    var $mimeFallback =
        _$jsonSerializers.serialize(mimeFallback, specifiedType: const FullType(PreviewGetPreviewMimeFallback));
    $mimeFallback ??= 0;
    _parameters['mimeFallback'] = $mimeFallback;

    final _path = _i5.UriTemplate('/index.php/core/preview.png{?file*,x*,y*,a*,forceIcon*,mode*,mimeFallback*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = '*/*';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    return _request;
  }

  /// Get a preview by file path.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [file] Path of the file. Defaults to `''`.
  ///   * [x] Width of the preview. Defaults to `32`.
  ///   * [y] Height of the preview. Defaults to `32`.
  ///   * [a] Whether to not crop the preview. Defaults to `0`.
  ///   * [forceIcon] Force returning an icon. Defaults to `1`.
  ///   * [mode] How to crop the image. Defaults to `fill`.
  ///   * [mimeFallback] Whether to fallback to the mime icon if no preview is available. Defaults to `0`.
  ///
  /// Status codes:
  ///   * 200: Preview returned
  ///   * 400: Getting preview is not possible
  ///   * 403: Getting preview is not allowed
  ///   * 404: Preview not found
  ///   * 303: Redirect to the mime icon url if mimeFallback is true
  ///
  /// See:
  ///  * [$getPreview_Request] for the request send by this method.
  ///  * [$getPreview_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<Uint8List, void>> getPreview({
    String? file,
    int? x,
    int? y,
    PreviewGetPreviewA? a,
    PreviewGetPreviewForceIcon? forceIcon,
    String? mode,
    PreviewGetPreviewMimeFallback? mimeFallback,
  }) async {
    final _request = $getPreview_Request(
      file: file,
      x: x,
      y: y,
      a: a,
      forceIcon: forceIcon,
      mode: mode,
      mimeFallback: mimeFallback,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getPreview_Serializer();
    final _rawResponse = await _i1.ResponseConverter<Uint8List, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$getPreviewByFileId_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<Uint8List, void> $getPreviewByFileId_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(Uint8List),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get a preview by file ID.
  ///
  /// Returns a `DynamiteRequest` backing the [getPreviewByFileId] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [fileId] ID of the file. Defaults to `-1`.
  ///   * [x] Width of the preview. Defaults to `32`.
  ///   * [y] Height of the preview. Defaults to `32`.
  ///   * [a] Whether to not crop the preview. Defaults to `0`.
  ///   * [forceIcon] Force returning an icon. Defaults to `1`.
  ///   * [mode] How to crop the image. Defaults to `fill`.
  ///   * [mimeFallback] Whether to fallback to the mime icon if no preview is available. Defaults to `0`.
  ///
  /// Status codes:
  ///   * 200: Preview returned
  ///   * 400: Getting preview is not possible
  ///   * 403: Getting preview is not allowed
  ///   * 404: Preview not found
  ///   * 303: Redirect to the mime icon url if mimeFallback is true
  ///
  /// See:
  ///  * [getPreviewByFileId] for a method executing this request and parsing the response.
  ///  * [$getPreviewByFileId_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getPreviewByFileId_Request({
    int? fileId,
    int? x,
    int? y,
    PreviewGetPreviewByFileIdA? a,
    PreviewGetPreviewByFileIdForceIcon? forceIcon,
    String? mode,
    PreviewGetPreviewByFileIdMimeFallback? mimeFallback,
  }) {
    final _parameters = <String, Object?>{};
    var $fileId = _$jsonSerializers.serialize(fileId, specifiedType: const FullType(int));
    $fileId ??= -1;
    _parameters['fileId'] = $fileId;

    var $x = _$jsonSerializers.serialize(x, specifiedType: const FullType(int));
    $x ??= 32;
    _parameters['x'] = $x;

    var $y = _$jsonSerializers.serialize(y, specifiedType: const FullType(int));
    $y ??= 32;
    _parameters['y'] = $y;

    var $a = _$jsonSerializers.serialize(a, specifiedType: const FullType(PreviewGetPreviewByFileIdA));
    $a ??= 0;
    _parameters['a'] = $a;

    var $forceIcon =
        _$jsonSerializers.serialize(forceIcon, specifiedType: const FullType(PreviewGetPreviewByFileIdForceIcon));
    $forceIcon ??= 1;
    _parameters['forceIcon'] = $forceIcon;

    var $mode = _$jsonSerializers.serialize(mode, specifiedType: const FullType(String));
    $mode ??= 'fill';
    _parameters['mode'] = $mode;

    var $mimeFallback =
        _$jsonSerializers.serialize(mimeFallback, specifiedType: const FullType(PreviewGetPreviewByFileIdMimeFallback));
    $mimeFallback ??= 0;
    _parameters['mimeFallback'] = $mimeFallback;

    final _path = _i5.UriTemplate('/index.php/core/preview{?fileId*,x*,y*,a*,forceIcon*,mode*,mimeFallback*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = '*/*';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    return _request;
  }

  /// Get a preview by file ID.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [fileId] ID of the file. Defaults to `-1`.
  ///   * [x] Width of the preview. Defaults to `32`.
  ///   * [y] Height of the preview. Defaults to `32`.
  ///   * [a] Whether to not crop the preview. Defaults to `0`.
  ///   * [forceIcon] Force returning an icon. Defaults to `1`.
  ///   * [mode] How to crop the image. Defaults to `fill`.
  ///   * [mimeFallback] Whether to fallback to the mime icon if no preview is available. Defaults to `0`.
  ///
  /// Status codes:
  ///   * 200: Preview returned
  ///   * 400: Getting preview is not possible
  ///   * 403: Getting preview is not allowed
  ///   * 404: Preview not found
  ///   * 303: Redirect to the mime icon url if mimeFallback is true
  ///
  /// See:
  ///  * [$getPreviewByFileId_Request] for the request send by this method.
  ///  * [$getPreviewByFileId_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<Uint8List, void>> getPreviewByFileId({
    int? fileId,
    int? x,
    int? y,
    PreviewGetPreviewByFileIdA? a,
    PreviewGetPreviewByFileIdForceIcon? forceIcon,
    String? mode,
    PreviewGetPreviewByFileIdMimeFallback? mimeFallback,
  }) async {
    final _request = $getPreviewByFileId_Request(
      fileId: fileId,
      x: x,
      y: y,
      a: a,
      forceIcon: forceIcon,
      mode: mode,
      mimeFallback: mimeFallback,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getPreviewByFileId_Serializer();
    final _rawResponse = await _i1.ResponseConverter<Uint8List, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $ProfileApiClient {
  /// Creates a new `DynamiteClient` for profile_api requests.
  $ProfileApiClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$setVisibility_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ProfileApiSetVisibilityResponseApplicationJson, void> $setVisibility_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(ProfileApiSetVisibilityResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 400, 403, 404},
      );

  /// Update the visibility of a parameter.
  ///
  /// This endpoint requires password confirmation.
  ///
  /// Returns a `DynamiteRequest` backing the [setVisibility] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [paramId] ID of the parameter.
  ///   * [visibility] New visibility.
  ///   * [targetUserId] ID of the user.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Visibility updated successfully
  ///   * 400: Updating visibility is not possible
  ///   * 403: Not allowed to edit other users visibility
  ///   * 404: Account not found
  ///
  /// See:
  ///  * [setVisibility] for a method executing this request and parsing the response.
  ///  * [$setVisibility_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $setVisibility_Request({
    required String paramId,
    required String visibility,
    required String targetUserId,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $paramId = _$jsonSerializers.serialize(paramId, specifiedType: const FullType(String));
    _parameters['paramId'] = $paramId;

    final $visibility = _$jsonSerializers.serialize(visibility, specifiedType: const FullType(String));
    _parameters['visibility'] = $visibility;

    final $targetUserId = _$jsonSerializers.serialize(targetUserId, specifiedType: const FullType(String));
    _parameters['targetUserId'] = $targetUserId;

    final _path = _i5.UriTemplate('/ocs/v2.php/profile/{targetUserId}{?paramId*,visibility*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('put', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Update the visibility of a parameter.
  ///
  /// This endpoint requires password confirmation.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [paramId] ID of the parameter.
  ///   * [visibility] New visibility.
  ///   * [targetUserId] ID of the user.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Visibility updated successfully
  ///   * 400: Updating visibility is not possible
  ///   * 403: Not allowed to edit other users visibility
  ///   * 404: Account not found
  ///
  /// See:
  ///  * [$setVisibility_Request] for the request send by this method.
  ///  * [$setVisibility_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ProfileApiSetVisibilityResponseApplicationJson, void>> setVisibility({
    required String paramId,
    required String visibility,
    required String targetUserId,
    bool? oCSAPIRequest,
  }) async {
    final _request = $setVisibility_Request(
      paramId: paramId,
      visibility: visibility,
      targetUserId: targetUserId,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $setVisibility_Serializer();
    final _rawResponse = await _i1.ResponseConverter<ProfileApiSetVisibilityResponseApplicationJson, void>(_serializer)
        .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $ReferenceClient {
  /// Creates a new `DynamiteClient` for reference requests.
  $ReferenceClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$preview_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<Uint8List, void> $preview_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(Uint8List),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get a preview for a reference.
  ///
  /// Returns a `DynamiteRequest` backing the [preview] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [referenceId] the reference cache key.
  ///
  /// Status codes:
  ///   * 200: Preview returned
  ///   * 404: Reference not found
  ///
  /// See:
  ///  * [preview] for a method executing this request and parsing the response.
  ///  * [$preview_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $preview_Request({required String referenceId}) {
    final _parameters = <String, Object?>{};
    final $referenceId = _$jsonSerializers.serialize(referenceId, specifiedType: const FullType(String));
    _parameters['referenceId'] = $referenceId;

    final _path = _i5.UriTemplate('/index.php/core/references/preview/{referenceId}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = '*/*';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    return _request;
  }

  /// Get a preview for a reference.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [referenceId] the reference cache key.
  ///
  /// Status codes:
  ///   * 200: Preview returned
  ///   * 404: Reference not found
  ///
  /// See:
  ///  * [$preview_Request] for the request send by this method.
  ///  * [$preview_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<Uint8List, void>> preview({required String referenceId}) async {
    final _request = $preview_Request(
      referenceId: referenceId,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $preview_Serializer();
    final _rawResponse = await _i1.ResponseConverter<Uint8List, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $ReferenceApiClient {
  /// Creates a new `DynamiteClient` for reference_api requests.
  $ReferenceApiClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$extract_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ReferenceApiExtractResponseApplicationJson, void> $extract_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(ReferenceApiExtractResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Extract references from a text.
  ///
  /// Returns a `DynamiteRequest` backing the [extract] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [text] Text to extract from.
  ///   * [resolve] Resolve the references. Defaults to `0`.
  ///   * [limit] Maximum amount of references to extract. Defaults to `1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: References returned
  ///
  /// See:
  ///  * [extract] for a method executing this request and parsing the response.
  ///  * [$extract_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $extract_Request({
    required String text,
    ReferenceApiExtractResolve? resolve,
    int? limit,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $text = _$jsonSerializers.serialize(text, specifiedType: const FullType(String));
    _parameters['text'] = $text;

    var $resolve = _$jsonSerializers.serialize(resolve, specifiedType: const FullType(ReferenceApiExtractResolve));
    $resolve ??= 0;
    _parameters['resolve'] = $resolve;

    var $limit = _$jsonSerializers.serialize(limit, specifiedType: const FullType(int));
    $limit ??= 1;
    _parameters['limit'] = $limit;

    final _path = _i5.UriTemplate('/ocs/v2.php/references/extract{?text*,resolve*,limit*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Extract references from a text.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [text] Text to extract from.
  ///   * [resolve] Resolve the references. Defaults to `0`.
  ///   * [limit] Maximum amount of references to extract. Defaults to `1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: References returned
  ///
  /// See:
  ///  * [$extract_Request] for the request send by this method.
  ///  * [$extract_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ReferenceApiExtractResponseApplicationJson, void>> extract({
    required String text,
    ReferenceApiExtractResolve? resolve,
    int? limit,
    bool? oCSAPIRequest,
  }) async {
    final _request = $extract_Request(
      text: text,
      resolve: resolve,
      limit: limit,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $extract_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<ReferenceApiExtractResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$resolveOne_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ReferenceApiResolveOneResponseApplicationJson, void> $resolveOne_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(ReferenceApiResolveOneResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Resolve a reference.
  ///
  /// Returns a `DynamiteRequest` backing the [resolveOne] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [reference] Reference to resolve.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reference returned
  ///
  /// See:
  ///  * [resolveOne] for a method executing this request and parsing the response.
  ///  * [$resolveOne_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $resolveOne_Request({
    required String reference,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $reference = _$jsonSerializers.serialize(reference, specifiedType: const FullType(String));
    _parameters['reference'] = $reference;

    final _path = _i5.UriTemplate('/ocs/v2.php/references/resolve{?reference*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Resolve a reference.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [reference] Reference to resolve.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reference returned
  ///
  /// See:
  ///  * [$resolveOne_Request] for the request send by this method.
  ///  * [$resolveOne_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ReferenceApiResolveOneResponseApplicationJson, void>> resolveOne({
    required String reference,
    bool? oCSAPIRequest,
  }) async {
    final _request = $resolveOne_Request(
      reference: reference,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $resolveOne_Serializer();
    final _rawResponse = await _i1.ResponseConverter<ReferenceApiResolveOneResponseApplicationJson, void>(_serializer)
        .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$resolve_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ReferenceApiResolveResponseApplicationJson, void> $resolve_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(ReferenceApiResolveResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Resolve multiple references.
  ///
  /// Returns a `DynamiteRequest` backing the [resolve] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [references] References to resolve.
  ///   * [limit] Maximum amount of references to resolve. Defaults to `1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: References returned
  ///
  /// See:
  ///  * [resolve] for a method executing this request and parsing the response.
  ///  * [$resolve_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $resolve_Request({
    required BuiltList<String> references,
    int? limit,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $references =
        _$jsonSerializers.serialize(references, specifiedType: const FullType(BuiltList, [FullType(String)]));
    _parameters['references%5B%5D'] = $references;

    var $limit = _$jsonSerializers.serialize(limit, specifiedType: const FullType(int));
    $limit ??= 1;
    _parameters['limit'] = $limit;

    final _path = _i5.UriTemplate('/ocs/v2.php/references/resolve{?references%5B%5D*,limit*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Resolve multiple references.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [references] References to resolve.
  ///   * [limit] Maximum amount of references to resolve. Defaults to `1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: References returned
  ///
  /// See:
  ///  * [$resolve_Request] for the request send by this method.
  ///  * [$resolve_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ReferenceApiResolveResponseApplicationJson, void>> resolve({
    required BuiltList<String> references,
    int? limit,
    bool? oCSAPIRequest,
  }) async {
    final _request = $resolve_Request(
      references: references,
      limit: limit,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $resolve_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<ReferenceApiResolveResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$getProvidersInfo_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ReferenceApiGetProvidersInfoResponseApplicationJson, void> $getProvidersInfo_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(ReferenceApiGetProvidersInfoResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get the providers.
  ///
  /// Returns a `DynamiteRequest` backing the [getProvidersInfo] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Providers returned
  ///
  /// See:
  ///  * [getProvidersInfo] for a method executing this request and parsing the response.
  ///  * [$getProvidersInfo_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getProvidersInfo_Request({bool? oCSAPIRequest}) {
    const _path = '/ocs/v2.php/references/providers';
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get the providers.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Providers returned
  ///
  /// See:
  ///  * [$getProvidersInfo_Request] for the request send by this method.
  ///  * [$getProvidersInfo_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ReferenceApiGetProvidersInfoResponseApplicationJson, void>> getProvidersInfo({
    bool? oCSAPIRequest,
  }) async {
    final _request = $getProvidersInfo_Request(
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getProvidersInfo_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<ReferenceApiGetProvidersInfoResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$touchProvider_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ReferenceApiTouchProviderResponseApplicationJson, void> $touchProvider_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(ReferenceApiTouchProviderResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Touch a provider.
  ///
  /// Returns a `DynamiteRequest` backing the [touchProvider] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [timestamp] Timestamp of the last usage.
  ///   * [providerId] ID of the provider.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Provider touched
  ///
  /// See:
  ///  * [touchProvider] for a method executing this request and parsing the response.
  ///  * [$touchProvider_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $touchProvider_Request({
    required String providerId,
    int? timestamp,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $providerId = _$jsonSerializers.serialize(providerId, specifiedType: const FullType(String));
    _parameters['providerId'] = $providerId;

    final $timestamp = _$jsonSerializers.serialize(timestamp, specifiedType: const FullType(int));
    _parameters['timestamp'] = $timestamp;

    final _path = _i5.UriTemplate('/ocs/v2.php/references/provider/{providerId}{?timestamp*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('put', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Touch a provider.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [timestamp] Timestamp of the last usage.
  ///   * [providerId] ID of the provider.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Provider touched
  ///
  /// See:
  ///  * [$touchProvider_Request] for the request send by this method.
  ///  * [$touchProvider_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ReferenceApiTouchProviderResponseApplicationJson, void>> touchProvider({
    required String providerId,
    int? timestamp,
    bool? oCSAPIRequest,
  }) async {
    final _request = $touchProvider_Request(
      providerId: providerId,
      timestamp: timestamp,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $touchProvider_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<ReferenceApiTouchProviderResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $TeamsApiClient {
  /// Creates a new `DynamiteClient` for teams_api requests.
  $TeamsApiClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$resolveOne_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<TeamsApiResolveOneResponseApplicationJson, void> $resolveOne_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(TeamsApiResolveOneResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get all resources of a team.
  ///
  /// Returns a `DynamiteRequest` backing the [resolveOne] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [teamId] Unique id of the team.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Resources returned
  ///
  /// See:
  ///  * [resolveOne] for a method executing this request and parsing the response.
  ///  * [$resolveOne_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $resolveOne_Request({
    required String teamId,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $teamId = _$jsonSerializers.serialize(teamId, specifiedType: const FullType(String));
    _parameters['teamId'] = $teamId;

    final _path = _i5.UriTemplate('/ocs/v2.php/teams/{teamId}/resources').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get all resources of a team.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [teamId] Unique id of the team.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Resources returned
  ///
  /// See:
  ///  * [$resolveOne_Request] for the request send by this method.
  ///  * [$resolveOne_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<TeamsApiResolveOneResponseApplicationJson, void>> resolveOne({
    required String teamId,
    bool? oCSAPIRequest,
  }) async {
    final _request = $resolveOne_Request(
      teamId: teamId,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $resolveOne_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<TeamsApiResolveOneResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$listTeams_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<TeamsApiListTeamsResponseApplicationJson, void> $listTeams_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(TeamsApiListTeamsResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get all teams of a resource.
  ///
  /// Returns a `DynamiteRequest` backing the [listTeams] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [providerId] Identifier of the provider (e.g. deck, talk, collectives).
  ///   * [resourceId] Unique id of the resource to list teams for (e.g. deck board id).
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Teams returned
  ///
  /// See:
  ///  * [listTeams] for a method executing this request and parsing the response.
  ///  * [$listTeams_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $listTeams_Request({
    required String providerId,
    required String resourceId,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $providerId = _$jsonSerializers.serialize(providerId, specifiedType: const FullType(String));
    _parameters['providerId'] = $providerId;

    final $resourceId = _$jsonSerializers.serialize(resourceId, specifiedType: const FullType(String));
    _parameters['resourceId'] = $resourceId;

    final _path = _i5.UriTemplate('/ocs/v2.php/teams/resources/{providerId}/{resourceId}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get all teams of a resource.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [providerId] Identifier of the provider (e.g. deck, talk, collectives).
  ///   * [resourceId] Unique id of the resource to list teams for (e.g. deck board id).
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Teams returned
  ///
  /// See:
  ///  * [$listTeams_Request] for the request send by this method.
  ///  * [$listTeams_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<TeamsApiListTeamsResponseApplicationJson, void>> listTeams({
    required String providerId,
    required String resourceId,
    bool? oCSAPIRequest,
  }) async {
    final _request = $listTeams_Request(
      providerId: providerId,
      resourceId: resourceId,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $listTeams_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<TeamsApiListTeamsResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $TextProcessingApiClient {
  /// Creates a new `DynamiteClient` for text_processing_api requests.
  $TextProcessingApiClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$taskTypes_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<TextProcessingApiTaskTypesResponseApplicationJson, void> $taskTypes_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(TextProcessingApiTaskTypesResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// This endpoint returns all available LanguageModel task types.
  ///
  /// Returns a `DynamiteRequest` backing the [taskTypes] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Task types returned
  ///
  /// See:
  ///  * [taskTypes] for a method executing this request and parsing the response.
  ///  * [$taskTypes_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $taskTypes_Request({bool? oCSAPIRequest}) {
    const _path = '/ocs/v2.php/textprocessing/tasktypes';
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// This endpoint returns all available LanguageModel task types.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Task types returned
  ///
  /// See:
  ///  * [$taskTypes_Request] for the request send by this method.
  ///  * [$taskTypes_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<TextProcessingApiTaskTypesResponseApplicationJson, void>> taskTypes({
    bool? oCSAPIRequest,
  }) async {
    final _request = $taskTypes_Request(
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $taskTypes_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<TextProcessingApiTaskTypesResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$schedule_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<TextProcessingApiScheduleResponseApplicationJson, void> $schedule_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(TextProcessingApiScheduleResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// This endpoint allows scheduling a language model task.
  ///
  /// Returns a `DynamiteRequest` backing the [schedule] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [input] Input text.
  ///   * [type] Type of the task.
  ///   * [appId] ID of the app that will execute the task.
  ///   * [identifier] An arbitrary identifier for the task. Defaults to `''`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Task scheduled successfully
  ///   * 500
  ///   * 400: Scheduling task is not possible
  ///   * 412: Scheduling task is not possible
  ///
  /// See:
  ///  * [schedule] for a method executing this request and parsing the response.
  ///  * [$schedule_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $schedule_Request({
    required String input,
    required String type,
    required String appId,
    String? identifier,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $input = _$jsonSerializers.serialize(input, specifiedType: const FullType(String));
    _parameters['input'] = $input;

    final $type = _$jsonSerializers.serialize(type, specifiedType: const FullType(String));
    _parameters['type'] = $type;

    final $appId = _$jsonSerializers.serialize(appId, specifiedType: const FullType(String));
    _parameters['appId'] = $appId;

    var $identifier = _$jsonSerializers.serialize(identifier, specifiedType: const FullType(String));
    $identifier ??= '';
    _parameters['identifier'] = $identifier;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/textprocessing/schedule{?input*,type*,appId*,identifier*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// This endpoint allows scheduling a language model task.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [input] Input text.
  ///   * [type] Type of the task.
  ///   * [appId] ID of the app that will execute the task.
  ///   * [identifier] An arbitrary identifier for the task. Defaults to `''`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Task scheduled successfully
  ///   * 500
  ///   * 400: Scheduling task is not possible
  ///   * 412: Scheduling task is not possible
  ///
  /// See:
  ///  * [$schedule_Request] for the request send by this method.
  ///  * [$schedule_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<TextProcessingApiScheduleResponseApplicationJson, void>> schedule({
    required String input,
    required String type,
    required String appId,
    String? identifier,
    bool? oCSAPIRequest,
  }) async {
    final _request = $schedule_Request(
      input: input,
      type: type,
      appId: appId,
      identifier: identifier,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $schedule_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<TextProcessingApiScheduleResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$getTask_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<TextProcessingApiGetTaskResponseApplicationJson, void> $getTask_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(TextProcessingApiGetTaskResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// This endpoint allows checking the status and results of a task. Tasks are removed 1 week after receiving their last update.
  ///
  /// Returns a `DynamiteRequest` backing the [getTask] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [id] The id of the task.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Task returned
  ///   * 404: Task not found
  ///   * 500
  ///
  /// See:
  ///  * [getTask] for a method executing this request and parsing the response.
  ///  * [$getTask_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getTask_Request({
    required int id,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $id = _$jsonSerializers.serialize(id, specifiedType: const FullType(int));
    _parameters['id'] = $id;

    final _path = _i5.UriTemplate('/ocs/v2.php/textprocessing/task/{id}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// This endpoint allows checking the status and results of a task. Tasks are removed 1 week after receiving their last update.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [id] The id of the task.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Task returned
  ///   * 404: Task not found
  ///   * 500
  ///
  /// See:
  ///  * [$getTask_Request] for the request send by this method.
  ///  * [$getTask_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<TextProcessingApiGetTaskResponseApplicationJson, void>> getTask({
    required int id,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getTask_Request(
      id: id,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getTask_Serializer();
    final _rawResponse = await _i1.ResponseConverter<TextProcessingApiGetTaskResponseApplicationJson, void>(_serializer)
        .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$deleteTask_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<TextProcessingApiDeleteTaskResponseApplicationJson, void> $deleteTask_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(TextProcessingApiDeleteTaskResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// This endpoint allows to delete a scheduled task for a user.
  ///
  /// Returns a `DynamiteRequest` backing the [deleteTask] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [id] The id of the task.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Task returned
  ///   * 404: Task not found
  ///   * 500
  ///
  /// See:
  ///  * [deleteTask] for a method executing this request and parsing the response.
  ///  * [$deleteTask_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $deleteTask_Request({
    required int id,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $id = _$jsonSerializers.serialize(id, specifiedType: const FullType(int));
    _parameters['id'] = $id;

    final _path = _i5.UriTemplate('/ocs/v2.php/textprocessing/task/{id}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// This endpoint allows to delete a scheduled task for a user.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [id] The id of the task.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Task returned
  ///   * 404: Task not found
  ///   * 500
  ///
  /// See:
  ///  * [$deleteTask_Request] for the request send by this method.
  ///  * [$deleteTask_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<TextProcessingApiDeleteTaskResponseApplicationJson, void>> deleteTask({
    required int id,
    bool? oCSAPIRequest,
  }) async {
    final _request = $deleteTask_Request(
      id: id,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $deleteTask_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<TextProcessingApiDeleteTaskResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$listTasksByApp_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<TextProcessingApiListTasksByAppResponseApplicationJson, void> $listTasksByApp_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(TextProcessingApiListTasksByAppResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// This endpoint returns a list of tasks of a user that are related with a specific appId and optionally with an identifier.
  ///
  /// Returns a `DynamiteRequest` backing the [listTasksByApp] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [identifier] An arbitrary identifier for the task.
  ///   * [appId] ID of the app.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Task list returned
  ///   * 500
  ///
  /// See:
  ///  * [listTasksByApp] for a method executing this request and parsing the response.
  ///  * [$listTasksByApp_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $listTasksByApp_Request({
    required String appId,
    String? identifier,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $appId = _$jsonSerializers.serialize(appId, specifiedType: const FullType(String));
    _parameters['appId'] = $appId;

    final $identifier = _$jsonSerializers.serialize(identifier, specifiedType: const FullType(String));
    _parameters['identifier'] = $identifier;

    final _path = _i5.UriTemplate('/ocs/v2.php/textprocessing/tasks/app/{appId}{?identifier*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// This endpoint returns a list of tasks of a user that are related with a specific appId and optionally with an identifier.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [identifier] An arbitrary identifier for the task.
  ///   * [appId] ID of the app.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Task list returned
  ///   * 500
  ///
  /// See:
  ///  * [$listTasksByApp_Request] for the request send by this method.
  ///  * [$listTasksByApp_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<TextProcessingApiListTasksByAppResponseApplicationJson, void>> listTasksByApp({
    required String appId,
    String? identifier,
    bool? oCSAPIRequest,
  }) async {
    final _request = $listTasksByApp_Request(
      appId: appId,
      identifier: identifier,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $listTasksByApp_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<TextProcessingApiListTasksByAppResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $TextToImageApiClient {
  /// Creates a new `DynamiteClient` for text_to_image_api requests.
  $TextToImageApiClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$isAvailable_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<TextToImageApiIsAvailableResponseApplicationJson, void> $isAvailable_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(TextToImageApiIsAvailableResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Check whether this feature is available.
  ///
  /// Returns a `DynamiteRequest` backing the [isAvailable] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Returns availability status
  ///
  /// See:
  ///  * [isAvailable] for a method executing this request and parsing the response.
  ///  * [$isAvailable_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $isAvailable_Request({bool? oCSAPIRequest}) {
    const _path = '/ocs/v2.php/text2image/is_available';
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Check whether this feature is available.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Returns availability status
  ///
  /// See:
  ///  * [$isAvailable_Request] for the request send by this method.
  ///  * [$isAvailable_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<TextToImageApiIsAvailableResponseApplicationJson, void>> isAvailable({
    bool? oCSAPIRequest,
  }) async {
    final _request = $isAvailable_Request(
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $isAvailable_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<TextToImageApiIsAvailableResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$schedule_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<TextToImageApiScheduleResponseApplicationJson, void> $schedule_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(TextToImageApiScheduleResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// This endpoint allows scheduling a text to image task.
  ///
  /// Returns a `DynamiteRequest` backing the [schedule] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [input] Input text.
  ///   * [appId] ID of the app that will execute the task.
  ///   * [identifier] An arbitrary identifier for the task. Defaults to `''`.
  ///   * [numberOfImages] The number of images to generate. Defaults to `8`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Task scheduled successfully
  ///   * 412: Scheduling task is not possible
  ///   * 500
  ///
  /// See:
  ///  * [schedule] for a method executing this request and parsing the response.
  ///  * [$schedule_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $schedule_Request({
    required String input,
    required String appId,
    String? identifier,
    int? numberOfImages,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $input = _$jsonSerializers.serialize(input, specifiedType: const FullType(String));
    _parameters['input'] = $input;

    final $appId = _$jsonSerializers.serialize(appId, specifiedType: const FullType(String));
    _parameters['appId'] = $appId;

    var $identifier = _$jsonSerializers.serialize(identifier, specifiedType: const FullType(String));
    $identifier ??= '';
    _parameters['identifier'] = $identifier;

    var $numberOfImages = _$jsonSerializers.serialize(numberOfImages, specifiedType: const FullType(int));
    $numberOfImages ??= 8;
    _parameters['numberOfImages'] = $numberOfImages;

    final _path = _i5.UriTemplate('/ocs/v2.php/text2image/schedule{?input*,appId*,identifier*,numberOfImages*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// This endpoint allows scheduling a text to image task.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [input] Input text.
  ///   * [appId] ID of the app that will execute the task.
  ///   * [identifier] An arbitrary identifier for the task. Defaults to `''`.
  ///   * [numberOfImages] The number of images to generate. Defaults to `8`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Task scheduled successfully
  ///   * 412: Scheduling task is not possible
  ///   * 500
  ///
  /// See:
  ///  * [$schedule_Request] for the request send by this method.
  ///  * [$schedule_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<TextToImageApiScheduleResponseApplicationJson, void>> schedule({
    required String input,
    required String appId,
    String? identifier,
    int? numberOfImages,
    bool? oCSAPIRequest,
  }) async {
    final _request = $schedule_Request(
      input: input,
      appId: appId,
      identifier: identifier,
      numberOfImages: numberOfImages,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $schedule_Serializer();
    final _rawResponse = await _i1.ResponseConverter<TextToImageApiScheduleResponseApplicationJson, void>(_serializer)
        .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$getTask_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<TextToImageApiGetTaskResponseApplicationJson, void> $getTask_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(TextToImageApiGetTaskResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// This endpoint allows checking the status and results of a task. Tasks are removed 1 week after receiving their last update.
  ///
  /// Returns a `DynamiteRequest` backing the [getTask] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [id] The id of the task.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Task returned
  ///   * 404: Task not found
  ///   * 500
  ///
  /// See:
  ///  * [getTask] for a method executing this request and parsing the response.
  ///  * [$getTask_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getTask_Request({
    required int id,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $id = _$jsonSerializers.serialize(id, specifiedType: const FullType(int));
    _parameters['id'] = $id;

    final _path = _i5.UriTemplate('/ocs/v2.php/text2image/task/{id}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// This endpoint allows checking the status and results of a task. Tasks are removed 1 week after receiving their last update.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [id] The id of the task.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Task returned
  ///   * 404: Task not found
  ///   * 500
  ///
  /// See:
  ///  * [$getTask_Request] for the request send by this method.
  ///  * [$getTask_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<TextToImageApiGetTaskResponseApplicationJson, void>> getTask({
    required int id,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getTask_Request(
      id: id,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getTask_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<TextToImageApiGetTaskResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$deleteTask_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<TextToImageApiDeleteTaskResponseApplicationJson, void> $deleteTask_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(TextToImageApiDeleteTaskResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// This endpoint allows to delete a scheduled task for a user.
  ///
  /// Returns a `DynamiteRequest` backing the [deleteTask] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [id] The id of the task.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Task returned
  ///   * 404: Task not found
  ///   * 500
  ///
  /// See:
  ///  * [deleteTask] for a method executing this request and parsing the response.
  ///  * [$deleteTask_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $deleteTask_Request({
    required int id,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $id = _$jsonSerializers.serialize(id, specifiedType: const FullType(int));
    _parameters['id'] = $id;

    final _path = _i5.UriTemplate('/ocs/v2.php/text2image/task/{id}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// This endpoint allows to delete a scheduled task for a user.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [id] The id of the task.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Task returned
  ///   * 404: Task not found
  ///   * 500
  ///
  /// See:
  ///  * [$deleteTask_Request] for the request send by this method.
  ///  * [$deleteTask_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<TextToImageApiDeleteTaskResponseApplicationJson, void>> deleteTask({
    required int id,
    bool? oCSAPIRequest,
  }) async {
    final _request = $deleteTask_Request(
      id: id,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $deleteTask_Serializer();
    final _rawResponse = await _i1.ResponseConverter<TextToImageApiDeleteTaskResponseApplicationJson, void>(_serializer)
        .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$getImage_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<Uint8List, void> $getImage_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(Uint8List),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// This endpoint allows downloading the resulting image of a task.
  ///
  /// Returns a `DynamiteRequest` backing the [getImage] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [id] The id of the task.
  ///   * [index] The index of the image to retrieve.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Image returned
  ///   * 404: Task or image not found
  ///   * 500
  ///
  /// See:
  ///  * [getImage] for a method executing this request and parsing the response.
  ///  * [$getImage_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getImage_Request({
    required int id,
    required int index,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $id = _$jsonSerializers.serialize(id, specifiedType: const FullType(int));
    _parameters['id'] = $id;

    final $index = _$jsonSerializers.serialize(index, specifiedType: const FullType(int));
    _parameters['index'] = $index;

    final _path = _i5.UriTemplate('/ocs/v2.php/text2image/task/{id}/image/{index}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = '*/*';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// This endpoint allows downloading the resulting image of a task.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [id] The id of the task.
  ///   * [index] The index of the image to retrieve.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Image returned
  ///   * 404: Task or image not found
  ///   * 500
  ///
  /// See:
  ///  * [$getImage_Request] for the request send by this method.
  ///  * [$getImage_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<Uint8List, void>> getImage({
    required int id,
    required int index,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getImage_Request(
      id: id,
      index: index,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getImage_Serializer();
    final _rawResponse = await _i1.ResponseConverter<Uint8List, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$listTasksByApp_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<TextToImageApiListTasksByAppResponseApplicationJson, void> $listTasksByApp_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(TextToImageApiListTasksByAppResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// This endpoint returns a list of tasks of a user that are related with a specific appId and optionally with an identifier.
  ///
  /// Returns a `DynamiteRequest` backing the [listTasksByApp] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [identifier] An arbitrary identifier for the task.
  ///   * [appId] ID of the app.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Task list returned
  ///   * 500
  ///
  /// See:
  ///  * [listTasksByApp] for a method executing this request and parsing the response.
  ///  * [$listTasksByApp_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $listTasksByApp_Request({
    required String appId,
    String? identifier,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $appId = _$jsonSerializers.serialize(appId, specifiedType: const FullType(String));
    _parameters['appId'] = $appId;

    final $identifier = _$jsonSerializers.serialize(identifier, specifiedType: const FullType(String));
    _parameters['identifier'] = $identifier;

    final _path = _i5.UriTemplate('/ocs/v2.php/text2image/tasks/app/{appId}{?identifier*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// This endpoint returns a list of tasks of a user that are related with a specific appId and optionally with an identifier.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [identifier] An arbitrary identifier for the task.
  ///   * [appId] ID of the app.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Task list returned
  ///   * 500
  ///
  /// See:
  ///  * [$listTasksByApp_Request] for the request send by this method.
  ///  * [$listTasksByApp_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<TextToImageApiListTasksByAppResponseApplicationJson, void>> listTasksByApp({
    required String appId,
    String? identifier,
    bool? oCSAPIRequest,
  }) async {
    final _request = $listTasksByApp_Request(
      appId: appId,
      identifier: identifier,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $listTasksByApp_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<TextToImageApiListTasksByAppResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $TranslationApiClient {
  /// Creates a new `DynamiteClient` for translation_api requests.
  $TranslationApiClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$languages_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<TranslationApiLanguagesResponseApplicationJson, void> $languages_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(TranslationApiLanguagesResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get the list of supported languages.
  ///
  /// Returns a `DynamiteRequest` backing the [languages] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Supported languages returned
  ///
  /// See:
  ///  * [languages] for a method executing this request and parsing the response.
  ///  * [$languages_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $languages_Request({bool? oCSAPIRequest}) {
    const _path = '/ocs/v2.php/translation/languages';
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get the list of supported languages.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Supported languages returned
  ///
  /// See:
  ///  * [$languages_Request] for the request send by this method.
  ///  * [$languages_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<TranslationApiLanguagesResponseApplicationJson, void>> languages({
    bool? oCSAPIRequest,
  }) async {
    final _request = $languages_Request(
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $languages_Serializer();
    final _rawResponse = await _i1.ResponseConverter<TranslationApiLanguagesResponseApplicationJson, void>(_serializer)
        .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$translate_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<TranslationApiTranslateResponseApplicationJson, void> $translate_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(TranslationApiTranslateResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Translate a text.
  ///
  /// Returns a `DynamiteRequest` backing the [translate] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [text] Text to be translated.
  ///   * [fromLanguage] Language to translate from.
  ///   * [toLanguage] Language to translate to.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Translated text returned
  ///   * 400: Language not detected or unable to translate
  ///   * 412: Translating is not possible
  ///   * 500
  ///
  /// See:
  ///  * [translate] for a method executing this request and parsing the response.
  ///  * [$translate_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $translate_Request({
    required String text,
    required String toLanguage,
    String? fromLanguage,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $text = _$jsonSerializers.serialize(text, specifiedType: const FullType(String));
    _parameters['text'] = $text;

    final $toLanguage = _$jsonSerializers.serialize(toLanguage, specifiedType: const FullType(String));
    _parameters['toLanguage'] = $toLanguage;

    final $fromLanguage = _$jsonSerializers.serialize(fromLanguage, specifiedType: const FullType(String));
    _parameters['fromLanguage'] = $fromLanguage;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/translation/translate{?text*,toLanguage*,fromLanguage*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Translate a text.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [text] Text to be translated.
  ///   * [fromLanguage] Language to translate from.
  ///   * [toLanguage] Language to translate to.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Translated text returned
  ///   * 400: Language not detected or unable to translate
  ///   * 412: Translating is not possible
  ///   * 500
  ///
  /// See:
  ///  * [$translate_Request] for the request send by this method.
  ///  * [$translate_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<TranslationApiTranslateResponseApplicationJson, void>> translate({
    required String text,
    required String toLanguage,
    String? fromLanguage,
    bool? oCSAPIRequest,
  }) async {
    final _request = $translate_Request(
      text: text,
      toLanguage: toLanguage,
      fromLanguage: fromLanguage,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $translate_Serializer();
    final _rawResponse = await _i1.ResponseConverter<TranslationApiTranslateResponseApplicationJson, void>(_serializer)
        .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $UnifiedSearchClient {
  /// Creates a new `DynamiteClient` for unified_search requests.
  $UnifiedSearchClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$getProviders_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<UnifiedSearchGetProvidersResponseApplicationJson, void> $getProviders_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(UnifiedSearchGetProvidersResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get the providers for unified search.
  ///
  /// Returns a `DynamiteRequest` backing the [getProviders] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [from] the url the user is currently at. Defaults to `''`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Providers returned
  ///
  /// See:
  ///  * [getProviders] for a method executing this request and parsing the response.
  ///  * [$getProviders_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getProviders_Request({
    String? from,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    var $from = _$jsonSerializers.serialize(from, specifiedType: const FullType(String));
    $from ??= '';
    _parameters['from'] = $from;

    final _path = _i5.UriTemplate('/ocs/v2.php/search/providers{?from*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get the providers for unified search.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [from] the url the user is currently at. Defaults to `''`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Providers returned
  ///
  /// See:
  ///  * [$getProviders_Request] for the request send by this method.
  ///  * [$getProviders_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<UnifiedSearchGetProvidersResponseApplicationJson, void>> getProviders({
    String? from,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getProviders_Request(
      from: from,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getProviders_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<UnifiedSearchGetProvidersResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$search_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<UnifiedSearchSearchResponseApplicationJson, void> $search_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(UnifiedSearchSearchResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Launch a search for a specific search provider.
  ///
  /// Additional filters are available for each provider. Send a request to /providers endpoint to list providers with their available filters.
  ///
  /// Returns a `DynamiteRequest` backing the [search] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [term] Term to search. Defaults to `''`.
  ///   * [sortOrder] Order of entries.
  ///   * [limit] Maximum amount of entries.
  ///   * [cursor] Offset for searching.
  ///   * [from] The current user URL. Defaults to `''`.
  ///   * [providerId] ID of the provider.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Search entries returned
  ///   * 400: Searching is not possible
  ///
  /// See:
  ///  * [search] for a method executing this request and parsing the response.
  ///  * [$search_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $search_Request({
    required String providerId,
    String? term,
    int? sortOrder,
    int? limit,
    UnifiedSearchSearchCursor? cursor,
    String? from,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $providerId = _$jsonSerializers.serialize(providerId, specifiedType: const FullType(String));
    _parameters['providerId'] = $providerId;

    var $term = _$jsonSerializers.serialize(term, specifiedType: const FullType(String));
    $term ??= '';
    _parameters['term'] = $term;

    final $sortOrder = _$jsonSerializers.serialize(sortOrder, specifiedType: const FullType(int));
    _parameters['sortOrder'] = $sortOrder;

    final $limit = _$jsonSerializers.serialize(limit, specifiedType: const FullType(int));
    _parameters['limit'] = $limit;

    final $cursor = _$jsonSerializers.serialize(cursor, specifiedType: const FullType(UnifiedSearchSearchCursor));
    _parameters['cursor'] = $cursor;

    var $from = _$jsonSerializers.serialize(from, specifiedType: const FullType(String));
    $from ??= '';
    _parameters['from'] = $from;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/search/providers/{providerId}/search{?term*,sortOrder*,limit*,cursor*,from*}')
            .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Launch a search for a specific search provider.
  ///
  /// Additional filters are available for each provider. Send a request to /providers endpoint to list providers with their available filters.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [term] Term to search. Defaults to `''`.
  ///   * [sortOrder] Order of entries.
  ///   * [limit] Maximum amount of entries.
  ///   * [cursor] Offset for searching.
  ///   * [from] The current user URL. Defaults to `''`.
  ///   * [providerId] ID of the provider.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Search entries returned
  ///   * 400: Searching is not possible
  ///
  /// See:
  ///  * [$search_Request] for the request send by this method.
  ///  * [$search_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<UnifiedSearchSearchResponseApplicationJson, void>> search({
    required String providerId,
    String? term,
    int? sortOrder,
    int? limit,
    UnifiedSearchSearchCursor? cursor,
    String? from,
    bool? oCSAPIRequest,
  }) async {
    final _request = $search_Request(
      providerId: providerId,
      term: term,
      sortOrder: sortOrder,
      limit: limit,
      cursor: cursor,
      from: from,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $search_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<UnifiedSearchSearchResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $WhatsNewClient {
  /// Creates a new `DynamiteClient` for whats_new requests.
  $WhatsNewClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$$get_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<WhatsNewGetResponseApplicationJson, void> $$get_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(WhatsNewGetResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get the changes.
  ///
  /// Returns a `DynamiteRequest` backing the [$get] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Changes returned
  ///   * 204: No changes
  ///
  /// See:
  ///  * [$get] for a method executing this request and parsing the response.
  ///  * [$$get_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $$get_Request({bool? oCSAPIRequest}) {
    const _path = '/ocs/v2.php/core/whatsnew';
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get the changes.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Changes returned
  ///   * 204: No changes
  ///
  /// See:
  ///  * [$$get_Request] for the request send by this method.
  ///  * [$$get_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<WhatsNewGetResponseApplicationJson, void>> $get({bool? oCSAPIRequest}) async {
    final _request = $$get_Request(
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $$get_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<WhatsNewGetResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$dismiss_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<WhatsNewDismissResponseApplicationJson, void> $dismiss_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(WhatsNewDismissResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Dismiss the changes.
  ///
  /// Returns a `DynamiteRequest` backing the [dismiss] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [version] Version to dismiss the changes for.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Changes dismissed
  ///   * 500
  ///
  /// See:
  ///  * [dismiss] for a method executing this request and parsing the response.
  ///  * [$dismiss_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $dismiss_Request({
    required String version,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $version = _$jsonSerializers.serialize(version, specifiedType: const FullType(String));
    _parameters['version'] = $version;

    final _path = _i5.UriTemplate('/ocs/v2.php/core/whatsnew{?version*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Dismiss the changes.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [version] Version to dismiss the changes for.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Changes dismissed
  ///   * 500
  ///
  /// See:
  ///  * [$dismiss_Request] for the request send by this method.
  ///  * [$dismiss_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<WhatsNewDismissResponseApplicationJson, void>> dismiss({
    required String version,
    bool? oCSAPIRequest,
  }) async {
    final _request = $dismiss_Request(
      version: version,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $dismiss_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<WhatsNewDismissResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $WipeClient {
  /// Creates a new `DynamiteClient` for wipe requests.
  $WipeClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$checkWipe_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<WipeCheckWipeResponseApplicationJson, void> $checkWipe_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(WipeCheckWipeResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Check if the device should be wiped.
  ///
  /// Returns a `DynamiteRequest` backing the [checkWipe] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [token] App password.
  ///
  /// Status codes:
  ///   * 200: Device should be wiped
  ///   * 404: Device should not be wiped
  ///
  /// See:
  ///  * [checkWipe] for a method executing this request and parsing the response.
  ///  * [$checkWipe_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $checkWipe_Request({required String token}) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _parameters['token'] = $token;

    final _path = _i5.UriTemplate('/index.php/core/wipe/check{?token*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    return _request;
  }

  /// Check if the device should be wiped.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [token] App password.
  ///
  /// Status codes:
  ///   * 200: Device should be wiped
  ///   * 404: Device should not be wiped
  ///
  /// See:
  ///  * [$checkWipe_Request] for the request send by this method.
  ///  * [$checkWipe_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<WipeCheckWipeResponseApplicationJson, void>> checkWipe({required String token}) async {
    final _request = $checkWipe_Request(
      token: token,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $checkWipe_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<WipeCheckWipeResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$wipeDone_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<JsonObject, void> $wipeDone_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(JsonObject),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 404},
      );

  /// Finish the wipe.
  ///
  /// Returns a `DynamiteRequest` backing the [wipeDone] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [token] App password.
  ///
  /// Status codes:
  ///   * 200: Wipe finished successfully
  ///   * 404: Device should not be wiped
  ///
  /// See:
  ///  * [wipeDone] for a method executing this request and parsing the response.
  ///  * [$wipeDone_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $wipeDone_Request({required String token}) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _parameters['token'] = $token;

    final _path = _i5.UriTemplate('/index.php/core/wipe/success{?token*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    return _request;
  }

  /// Finish the wipe.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [token] App password.
  ///
  /// Status codes:
  ///   * 200: Wipe finished successfully
  ///   * 404: Device should not be wiped
  ///
  /// See:
  ///  * [$wipeDone_Request] for the request send by this method.
  ///  * [$wipeDone_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<JsonObject, void>> wipeDone({required String token}) async {
    final _request = $wipeDone_Request(
      token: token,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $wipeDone_Serializer();
    final _rawResponse = await _i1.ResponseConverter<JsonObject, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $StatusInterface {
  bool get installed;
  bool get maintenance;
  bool get needsDbUpgrade;
  String get version;
  String get versionstring;
  String get edition;
  String get productname;
  bool get extendedSupport;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($StatusInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($StatusInterfaceBuilder b) {}
}

abstract class Status implements $StatusInterface, Built<Status, StatusBuilder> {
  /// Creates a new Status object using the builder pattern.
  factory Status([void Function(StatusBuilder)? b]) = _$Status;

  // coverage:ignore-start
  const Status._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory Status.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for Status.
  static Serializer<Status> get serializer => _$statusSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(StatusBuilder b) {
    $StatusInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(StatusBuilder b) {
    $StatusInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $OCSMetaInterface {
  String get status;
  int get statuscode;
  String? get message;
  String? get totalitems;
  String? get itemsperpage;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($OCSMetaInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($OCSMetaInterfaceBuilder b) {}
}

abstract class OCSMeta implements $OCSMetaInterface, Built<OCSMeta, OCSMetaBuilder> {
  /// Creates a new OCSMeta object using the builder pattern.
  factory OCSMeta([void Function(OCSMetaBuilder)? b]) = _$OCSMeta;

  // coverage:ignore-start
  const OCSMeta._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory OCSMeta.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for OCSMeta.
  static Serializer<OCSMeta> get serializer => _$oCSMetaSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(OCSMetaBuilder b) {
    $OCSMetaInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(OCSMetaBuilder b) {
    $OCSMetaInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $AppPasswordGetAppPasswordResponseApplicationJson_Ocs_DataInterface {
  String get apppassword;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($AppPasswordGetAppPasswordResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($AppPasswordGetAppPasswordResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class AppPasswordGetAppPasswordResponseApplicationJson_Ocs_Data
    implements
        $AppPasswordGetAppPasswordResponseApplicationJson_Ocs_DataInterface,
        Built<AppPasswordGetAppPasswordResponseApplicationJson_Ocs_Data,
            AppPasswordGetAppPasswordResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new AppPasswordGetAppPasswordResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory AppPasswordGetAppPasswordResponseApplicationJson_Ocs_Data([
    void Function(AppPasswordGetAppPasswordResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$AppPasswordGetAppPasswordResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const AppPasswordGetAppPasswordResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory AppPasswordGetAppPasswordResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for AppPasswordGetAppPasswordResponseApplicationJson_Ocs_Data.
  static Serializer<AppPasswordGetAppPasswordResponseApplicationJson_Ocs_Data> get serializer =>
      _$appPasswordGetAppPasswordResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(AppPasswordGetAppPasswordResponseApplicationJson_Ocs_DataBuilder b) {
    $AppPasswordGetAppPasswordResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(AppPasswordGetAppPasswordResponseApplicationJson_Ocs_DataBuilder b) {
    $AppPasswordGetAppPasswordResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $AppPasswordGetAppPasswordResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  AppPasswordGetAppPasswordResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($AppPasswordGetAppPasswordResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($AppPasswordGetAppPasswordResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class AppPasswordGetAppPasswordResponseApplicationJson_Ocs
    implements
        $AppPasswordGetAppPasswordResponseApplicationJson_OcsInterface,
        Built<AppPasswordGetAppPasswordResponseApplicationJson_Ocs,
            AppPasswordGetAppPasswordResponseApplicationJson_OcsBuilder> {
  /// Creates a new AppPasswordGetAppPasswordResponseApplicationJson_Ocs object using the builder pattern.
  factory AppPasswordGetAppPasswordResponseApplicationJson_Ocs([
    void Function(AppPasswordGetAppPasswordResponseApplicationJson_OcsBuilder)? b,
  ]) = _$AppPasswordGetAppPasswordResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const AppPasswordGetAppPasswordResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory AppPasswordGetAppPasswordResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for AppPasswordGetAppPasswordResponseApplicationJson_Ocs.
  static Serializer<AppPasswordGetAppPasswordResponseApplicationJson_Ocs> get serializer =>
      _$appPasswordGetAppPasswordResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(AppPasswordGetAppPasswordResponseApplicationJson_OcsBuilder b) {
    $AppPasswordGetAppPasswordResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(AppPasswordGetAppPasswordResponseApplicationJson_OcsBuilder b) {
    $AppPasswordGetAppPasswordResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $AppPasswordGetAppPasswordResponseApplicationJsonInterface {
  AppPasswordGetAppPasswordResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($AppPasswordGetAppPasswordResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($AppPasswordGetAppPasswordResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class AppPasswordGetAppPasswordResponseApplicationJson
    implements
        $AppPasswordGetAppPasswordResponseApplicationJsonInterface,
        Built<AppPasswordGetAppPasswordResponseApplicationJson,
            AppPasswordGetAppPasswordResponseApplicationJsonBuilder> {
  /// Creates a new AppPasswordGetAppPasswordResponseApplicationJson object using the builder pattern.
  factory AppPasswordGetAppPasswordResponseApplicationJson([
    void Function(AppPasswordGetAppPasswordResponseApplicationJsonBuilder)? b,
  ]) = _$AppPasswordGetAppPasswordResponseApplicationJson;

  // coverage:ignore-start
  const AppPasswordGetAppPasswordResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory AppPasswordGetAppPasswordResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for AppPasswordGetAppPasswordResponseApplicationJson.
  static Serializer<AppPasswordGetAppPasswordResponseApplicationJson> get serializer =>
      _$appPasswordGetAppPasswordResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(AppPasswordGetAppPasswordResponseApplicationJsonBuilder b) {
    $AppPasswordGetAppPasswordResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(AppPasswordGetAppPasswordResponseApplicationJsonBuilder b) {
    $AppPasswordGetAppPasswordResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $AppPasswordDeleteAppPasswordResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($AppPasswordDeleteAppPasswordResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($AppPasswordDeleteAppPasswordResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class AppPasswordDeleteAppPasswordResponseApplicationJson_Ocs
    implements
        $AppPasswordDeleteAppPasswordResponseApplicationJson_OcsInterface,
        Built<AppPasswordDeleteAppPasswordResponseApplicationJson_Ocs,
            AppPasswordDeleteAppPasswordResponseApplicationJson_OcsBuilder> {
  /// Creates a new AppPasswordDeleteAppPasswordResponseApplicationJson_Ocs object using the builder pattern.
  factory AppPasswordDeleteAppPasswordResponseApplicationJson_Ocs([
    void Function(AppPasswordDeleteAppPasswordResponseApplicationJson_OcsBuilder)? b,
  ]) = _$AppPasswordDeleteAppPasswordResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const AppPasswordDeleteAppPasswordResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory AppPasswordDeleteAppPasswordResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for AppPasswordDeleteAppPasswordResponseApplicationJson_Ocs.
  static Serializer<AppPasswordDeleteAppPasswordResponseApplicationJson_Ocs> get serializer =>
      _$appPasswordDeleteAppPasswordResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(AppPasswordDeleteAppPasswordResponseApplicationJson_OcsBuilder b) {
    $AppPasswordDeleteAppPasswordResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(AppPasswordDeleteAppPasswordResponseApplicationJson_OcsBuilder b) {
    $AppPasswordDeleteAppPasswordResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $AppPasswordDeleteAppPasswordResponseApplicationJsonInterface {
  AppPasswordDeleteAppPasswordResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($AppPasswordDeleteAppPasswordResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($AppPasswordDeleteAppPasswordResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class AppPasswordDeleteAppPasswordResponseApplicationJson
    implements
        $AppPasswordDeleteAppPasswordResponseApplicationJsonInterface,
        Built<AppPasswordDeleteAppPasswordResponseApplicationJson,
            AppPasswordDeleteAppPasswordResponseApplicationJsonBuilder> {
  /// Creates a new AppPasswordDeleteAppPasswordResponseApplicationJson object using the builder pattern.
  factory AppPasswordDeleteAppPasswordResponseApplicationJson([
    void Function(AppPasswordDeleteAppPasswordResponseApplicationJsonBuilder)? b,
  ]) = _$AppPasswordDeleteAppPasswordResponseApplicationJson;

  // coverage:ignore-start
  const AppPasswordDeleteAppPasswordResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory AppPasswordDeleteAppPasswordResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for AppPasswordDeleteAppPasswordResponseApplicationJson.
  static Serializer<AppPasswordDeleteAppPasswordResponseApplicationJson> get serializer =>
      _$appPasswordDeleteAppPasswordResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(AppPasswordDeleteAppPasswordResponseApplicationJsonBuilder b) {
    $AppPasswordDeleteAppPasswordResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(AppPasswordDeleteAppPasswordResponseApplicationJsonBuilder b) {
    $AppPasswordDeleteAppPasswordResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $AppPasswordRotateAppPasswordResponseApplicationJson_Ocs_DataInterface {
  String get apppassword;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($AppPasswordRotateAppPasswordResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($AppPasswordRotateAppPasswordResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class AppPasswordRotateAppPasswordResponseApplicationJson_Ocs_Data
    implements
        $AppPasswordRotateAppPasswordResponseApplicationJson_Ocs_DataInterface,
        Built<AppPasswordRotateAppPasswordResponseApplicationJson_Ocs_Data,
            AppPasswordRotateAppPasswordResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new AppPasswordRotateAppPasswordResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory AppPasswordRotateAppPasswordResponseApplicationJson_Ocs_Data([
    void Function(AppPasswordRotateAppPasswordResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$AppPasswordRotateAppPasswordResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const AppPasswordRotateAppPasswordResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory AppPasswordRotateAppPasswordResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for AppPasswordRotateAppPasswordResponseApplicationJson_Ocs_Data.
  static Serializer<AppPasswordRotateAppPasswordResponseApplicationJson_Ocs_Data> get serializer =>
      _$appPasswordRotateAppPasswordResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(AppPasswordRotateAppPasswordResponseApplicationJson_Ocs_DataBuilder b) {
    $AppPasswordRotateAppPasswordResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(AppPasswordRotateAppPasswordResponseApplicationJson_Ocs_DataBuilder b) {
    $AppPasswordRotateAppPasswordResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $AppPasswordRotateAppPasswordResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  AppPasswordRotateAppPasswordResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($AppPasswordRotateAppPasswordResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($AppPasswordRotateAppPasswordResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class AppPasswordRotateAppPasswordResponseApplicationJson_Ocs
    implements
        $AppPasswordRotateAppPasswordResponseApplicationJson_OcsInterface,
        Built<AppPasswordRotateAppPasswordResponseApplicationJson_Ocs,
            AppPasswordRotateAppPasswordResponseApplicationJson_OcsBuilder> {
  /// Creates a new AppPasswordRotateAppPasswordResponseApplicationJson_Ocs object using the builder pattern.
  factory AppPasswordRotateAppPasswordResponseApplicationJson_Ocs([
    void Function(AppPasswordRotateAppPasswordResponseApplicationJson_OcsBuilder)? b,
  ]) = _$AppPasswordRotateAppPasswordResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const AppPasswordRotateAppPasswordResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory AppPasswordRotateAppPasswordResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for AppPasswordRotateAppPasswordResponseApplicationJson_Ocs.
  static Serializer<AppPasswordRotateAppPasswordResponseApplicationJson_Ocs> get serializer =>
      _$appPasswordRotateAppPasswordResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(AppPasswordRotateAppPasswordResponseApplicationJson_OcsBuilder b) {
    $AppPasswordRotateAppPasswordResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(AppPasswordRotateAppPasswordResponseApplicationJson_OcsBuilder b) {
    $AppPasswordRotateAppPasswordResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $AppPasswordRotateAppPasswordResponseApplicationJsonInterface {
  AppPasswordRotateAppPasswordResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($AppPasswordRotateAppPasswordResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($AppPasswordRotateAppPasswordResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class AppPasswordRotateAppPasswordResponseApplicationJson
    implements
        $AppPasswordRotateAppPasswordResponseApplicationJsonInterface,
        Built<AppPasswordRotateAppPasswordResponseApplicationJson,
            AppPasswordRotateAppPasswordResponseApplicationJsonBuilder> {
  /// Creates a new AppPasswordRotateAppPasswordResponseApplicationJson object using the builder pattern.
  factory AppPasswordRotateAppPasswordResponseApplicationJson([
    void Function(AppPasswordRotateAppPasswordResponseApplicationJsonBuilder)? b,
  ]) = _$AppPasswordRotateAppPasswordResponseApplicationJson;

  // coverage:ignore-start
  const AppPasswordRotateAppPasswordResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory AppPasswordRotateAppPasswordResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for AppPasswordRotateAppPasswordResponseApplicationJson.
  static Serializer<AppPasswordRotateAppPasswordResponseApplicationJson> get serializer =>
      _$appPasswordRotateAppPasswordResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(AppPasswordRotateAppPasswordResponseApplicationJsonBuilder b) {
    $AppPasswordRotateAppPasswordResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(AppPasswordRotateAppPasswordResponseApplicationJsonBuilder b) {
    $AppPasswordRotateAppPasswordResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs_DataInterface {
  int get lastLogin;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs_Data
    implements
        $AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs_DataInterface,
        Built<AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs_Data,
            AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs_Data([
    void Function(AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs_Data.
  static Serializer<AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs_Data> get serializer =>
      _$appPasswordConfirmUserPasswordResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs_DataBuilder b) {
    $AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs_DataBuilder b) {
    $AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $AppPasswordConfirmUserPasswordResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($AppPasswordConfirmUserPasswordResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($AppPasswordConfirmUserPasswordResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs
    implements
        $AppPasswordConfirmUserPasswordResponseApplicationJson_OcsInterface,
        Built<AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs,
            AppPasswordConfirmUserPasswordResponseApplicationJson_OcsBuilder> {
  /// Creates a new AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs object using the builder pattern.
  factory AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs([
    void Function(AppPasswordConfirmUserPasswordResponseApplicationJson_OcsBuilder)? b,
  ]) = _$AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs.
  static Serializer<AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs> get serializer =>
      _$appPasswordConfirmUserPasswordResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(AppPasswordConfirmUserPasswordResponseApplicationJson_OcsBuilder b) {
    $AppPasswordConfirmUserPasswordResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(AppPasswordConfirmUserPasswordResponseApplicationJson_OcsBuilder b) {
    $AppPasswordConfirmUserPasswordResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $AppPasswordConfirmUserPasswordResponseApplicationJsonInterface {
  AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($AppPasswordConfirmUserPasswordResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($AppPasswordConfirmUserPasswordResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class AppPasswordConfirmUserPasswordResponseApplicationJson
    implements
        $AppPasswordConfirmUserPasswordResponseApplicationJsonInterface,
        Built<AppPasswordConfirmUserPasswordResponseApplicationJson,
            AppPasswordConfirmUserPasswordResponseApplicationJsonBuilder> {
  /// Creates a new AppPasswordConfirmUserPasswordResponseApplicationJson object using the builder pattern.
  factory AppPasswordConfirmUserPasswordResponseApplicationJson([
    void Function(AppPasswordConfirmUserPasswordResponseApplicationJsonBuilder)? b,
  ]) = _$AppPasswordConfirmUserPasswordResponseApplicationJson;

  // coverage:ignore-start
  const AppPasswordConfirmUserPasswordResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory AppPasswordConfirmUserPasswordResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for AppPasswordConfirmUserPasswordResponseApplicationJson.
  static Serializer<AppPasswordConfirmUserPasswordResponseApplicationJson> get serializer =>
      _$appPasswordConfirmUserPasswordResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(AppPasswordConfirmUserPasswordResponseApplicationJsonBuilder b) {
    $AppPasswordConfirmUserPasswordResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(AppPasswordConfirmUserPasswordResponseApplicationJsonBuilder b) {
    $AppPasswordConfirmUserPasswordResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $AutocompleteResult_Status0Interface {
  String get status;
  String? get message;
  String? get icon;
  int? get clearAt;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($AutocompleteResult_Status0InterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($AutocompleteResult_Status0InterfaceBuilder b) {}
}

abstract class AutocompleteResult_Status0
    implements
        $AutocompleteResult_Status0Interface,
        Built<AutocompleteResult_Status0, AutocompleteResult_Status0Builder> {
  /// Creates a new AutocompleteResult_Status0 object using the builder pattern.
  factory AutocompleteResult_Status0([void Function(AutocompleteResult_Status0Builder)? b]) =
      _$AutocompleteResult_Status0;

  // coverage:ignore-start
  const AutocompleteResult_Status0._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory AutocompleteResult_Status0.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for AutocompleteResult_Status0.
  static Serializer<AutocompleteResult_Status0> get serializer => _$autocompleteResultStatus0Serializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(AutocompleteResult_Status0Builder b) {
    $AutocompleteResult_Status0Interface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(AutocompleteResult_Status0Builder b) {
    $AutocompleteResult_Status0Interface._validate(b);
  }
}

typedef AutocompleteResult_Status = ({AutocompleteResult_Status0? autocompleteResultStatus0, String? string});

@BuiltValue(instantiable: false)
abstract interface class $AutocompleteResultInterface {
  String get id;
  String get label;
  String get icon;
  String get source;
  AutocompleteResult_Status get status;
  String get subline;
  String get shareWithDisplayNameUnique;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($AutocompleteResultInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($AutocompleteResultInterfaceBuilder b) {
    b.status?.validateOneOf();
  }
}

abstract class AutocompleteResult
    implements $AutocompleteResultInterface, Built<AutocompleteResult, AutocompleteResultBuilder> {
  /// Creates a new AutocompleteResult object using the builder pattern.
  factory AutocompleteResult([void Function(AutocompleteResultBuilder)? b]) = _$AutocompleteResult;

  // coverage:ignore-start
  const AutocompleteResult._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory AutocompleteResult.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for AutocompleteResult.
  static Serializer<AutocompleteResult> get serializer => _$autocompleteResultSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(AutocompleteResultBuilder b) {
    $AutocompleteResultInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(AutocompleteResultBuilder b) {
    $AutocompleteResultInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $AutoCompleteGetResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<AutocompleteResult> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($AutoCompleteGetResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($AutoCompleteGetResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class AutoCompleteGetResponseApplicationJson_Ocs
    implements
        $AutoCompleteGetResponseApplicationJson_OcsInterface,
        Built<AutoCompleteGetResponseApplicationJson_Ocs, AutoCompleteGetResponseApplicationJson_OcsBuilder> {
  /// Creates a new AutoCompleteGetResponseApplicationJson_Ocs object using the builder pattern.
  factory AutoCompleteGetResponseApplicationJson_Ocs([
    void Function(AutoCompleteGetResponseApplicationJson_OcsBuilder)? b,
  ]) = _$AutoCompleteGetResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const AutoCompleteGetResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory AutoCompleteGetResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for AutoCompleteGetResponseApplicationJson_Ocs.
  static Serializer<AutoCompleteGetResponseApplicationJson_Ocs> get serializer =>
      _$autoCompleteGetResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(AutoCompleteGetResponseApplicationJson_OcsBuilder b) {
    $AutoCompleteGetResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(AutoCompleteGetResponseApplicationJson_OcsBuilder b) {
    $AutoCompleteGetResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $AutoCompleteGetResponseApplicationJsonInterface {
  AutoCompleteGetResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($AutoCompleteGetResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($AutoCompleteGetResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class AutoCompleteGetResponseApplicationJson
    implements
        $AutoCompleteGetResponseApplicationJsonInterface,
        Built<AutoCompleteGetResponseApplicationJson, AutoCompleteGetResponseApplicationJsonBuilder> {
  /// Creates a new AutoCompleteGetResponseApplicationJson object using the builder pattern.
  factory AutoCompleteGetResponseApplicationJson([void Function(AutoCompleteGetResponseApplicationJsonBuilder)? b]) =
      _$AutoCompleteGetResponseApplicationJson;

  // coverage:ignore-start
  const AutoCompleteGetResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory AutoCompleteGetResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for AutoCompleteGetResponseApplicationJson.
  static Serializer<AutoCompleteGetResponseApplicationJson> get serializer =>
      _$autoCompleteGetResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(AutoCompleteGetResponseApplicationJsonBuilder b) {
    $AutoCompleteGetResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(AutoCompleteGetResponseApplicationJsonBuilder b) {
    $AutoCompleteGetResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $AvatarAvatarGetAvatarDarkHeadersInterface {
  @BuiltValueField(wireName: 'x-nc-iscustomavatar')
  Header<int>? get xNcIscustomavatar;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($AvatarAvatarGetAvatarDarkHeadersInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($AvatarAvatarGetAvatarDarkHeadersInterfaceBuilder b) {}
}

abstract class AvatarAvatarGetAvatarDarkHeaders
    implements
        $AvatarAvatarGetAvatarDarkHeadersInterface,
        Built<AvatarAvatarGetAvatarDarkHeaders, AvatarAvatarGetAvatarDarkHeadersBuilder> {
  /// Creates a new AvatarAvatarGetAvatarDarkHeaders object using the builder pattern.
  factory AvatarAvatarGetAvatarDarkHeaders([void Function(AvatarAvatarGetAvatarDarkHeadersBuilder)? b]) =
      _$AvatarAvatarGetAvatarDarkHeaders;

  // coverage:ignore-start
  const AvatarAvatarGetAvatarDarkHeaders._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory AvatarAvatarGetAvatarDarkHeaders.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for AvatarAvatarGetAvatarDarkHeaders.
  static Serializer<AvatarAvatarGetAvatarDarkHeaders> get serializer => _$avatarAvatarGetAvatarDarkHeadersSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(AvatarAvatarGetAvatarDarkHeadersBuilder b) {
    $AvatarAvatarGetAvatarDarkHeadersInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(AvatarAvatarGetAvatarDarkHeadersBuilder b) {
    $AvatarAvatarGetAvatarDarkHeadersInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $AvatarAvatarGetAvatarHeadersInterface {
  @BuiltValueField(wireName: 'x-nc-iscustomavatar')
  Header<int>? get xNcIscustomavatar;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($AvatarAvatarGetAvatarHeadersInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($AvatarAvatarGetAvatarHeadersInterfaceBuilder b) {}
}

abstract class AvatarAvatarGetAvatarHeaders
    implements
        $AvatarAvatarGetAvatarHeadersInterface,
        Built<AvatarAvatarGetAvatarHeaders, AvatarAvatarGetAvatarHeadersBuilder> {
  /// Creates a new AvatarAvatarGetAvatarHeaders object using the builder pattern.
  factory AvatarAvatarGetAvatarHeaders([void Function(AvatarAvatarGetAvatarHeadersBuilder)? b]) =
      _$AvatarAvatarGetAvatarHeaders;

  // coverage:ignore-start
  const AvatarAvatarGetAvatarHeaders._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory AvatarAvatarGetAvatarHeaders.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for AvatarAvatarGetAvatarHeaders.
  static Serializer<AvatarAvatarGetAvatarHeaders> get serializer => _$avatarAvatarGetAvatarHeadersSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(AvatarAvatarGetAvatarHeadersBuilder b) {
    $AvatarAvatarGetAvatarHeadersInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(AvatarAvatarGetAvatarHeadersBuilder b) {
    $AvatarAvatarGetAvatarHeadersInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $LoginFlowV2CredentialsInterface {
  String get server;
  String get loginName;
  String get appPassword;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($LoginFlowV2CredentialsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($LoginFlowV2CredentialsInterfaceBuilder b) {}
}

abstract class LoginFlowV2Credentials
    implements $LoginFlowV2CredentialsInterface, Built<LoginFlowV2Credentials, LoginFlowV2CredentialsBuilder> {
  /// Creates a new LoginFlowV2Credentials object using the builder pattern.
  factory LoginFlowV2Credentials([void Function(LoginFlowV2CredentialsBuilder)? b]) = _$LoginFlowV2Credentials;

  // coverage:ignore-start
  const LoginFlowV2Credentials._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory LoginFlowV2Credentials.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for LoginFlowV2Credentials.
  static Serializer<LoginFlowV2Credentials> get serializer => _$loginFlowV2CredentialsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(LoginFlowV2CredentialsBuilder b) {
    $LoginFlowV2CredentialsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(LoginFlowV2CredentialsBuilder b) {
    $LoginFlowV2CredentialsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $LoginFlowV2_PollInterface {
  String get token;
  String get endpoint;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($LoginFlowV2_PollInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($LoginFlowV2_PollInterfaceBuilder b) {}
}

abstract class LoginFlowV2_Poll
    implements $LoginFlowV2_PollInterface, Built<LoginFlowV2_Poll, LoginFlowV2_PollBuilder> {
  /// Creates a new LoginFlowV2_Poll object using the builder pattern.
  factory LoginFlowV2_Poll([void Function(LoginFlowV2_PollBuilder)? b]) = _$LoginFlowV2_Poll;

  // coverage:ignore-start
  const LoginFlowV2_Poll._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory LoginFlowV2_Poll.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for LoginFlowV2_Poll.
  static Serializer<LoginFlowV2_Poll> get serializer => _$loginFlowV2PollSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(LoginFlowV2_PollBuilder b) {
    $LoginFlowV2_PollInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(LoginFlowV2_PollBuilder b) {
    $LoginFlowV2_PollInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $LoginFlowV2Interface {
  LoginFlowV2_Poll get poll;
  String get login;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($LoginFlowV2InterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($LoginFlowV2InterfaceBuilder b) {}
}

abstract class LoginFlowV2 implements $LoginFlowV2Interface, Built<LoginFlowV2, LoginFlowV2Builder> {
  /// Creates a new LoginFlowV2 object using the builder pattern.
  factory LoginFlowV2([void Function(LoginFlowV2Builder)? b]) = _$LoginFlowV2;

  // coverage:ignore-start
  const LoginFlowV2._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory LoginFlowV2.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for LoginFlowV2.
  static Serializer<LoginFlowV2> get serializer => _$loginFlowV2Serializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(LoginFlowV2Builder b) {
    $LoginFlowV2Interface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(LoginFlowV2Builder b) {
    $LoginFlowV2Interface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $OpenGraphObjectInterface {
  String get id;
  String get name;
  String? get description;
  String? get thumb;
  String get link;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($OpenGraphObjectInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($OpenGraphObjectInterfaceBuilder b) {}
}

abstract class OpenGraphObject implements $OpenGraphObjectInterface, Built<OpenGraphObject, OpenGraphObjectBuilder> {
  /// Creates a new OpenGraphObject object using the builder pattern.
  factory OpenGraphObject([void Function(OpenGraphObjectBuilder)? b]) = _$OpenGraphObject;

  // coverage:ignore-start
  const OpenGraphObject._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory OpenGraphObject.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for OpenGraphObject.
  static Serializer<OpenGraphObject> get serializer => _$openGraphObjectSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(OpenGraphObjectBuilder b) {
    $OpenGraphObjectInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(OpenGraphObjectBuilder b) {
    $OpenGraphObjectInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ResourceInterface {
  String get richObjectType;
  BuiltMap<String, JsonObject> get richObject;
  OpenGraphObject get openGraphObject;
  bool get accessible;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ResourceInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ResourceInterfaceBuilder b) {}
}

abstract class Resource implements $ResourceInterface, Built<Resource, ResourceBuilder> {
  /// Creates a new Resource object using the builder pattern.
  factory Resource([void Function(ResourceBuilder)? b]) = _$Resource;

  // coverage:ignore-start
  const Resource._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory Resource.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for Resource.
  static Serializer<Resource> get serializer => _$resourceSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ResourceBuilder b) {
    $ResourceInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ResourceBuilder b) {
    $ResourceInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CollectionInterface {
  int get id;
  String get name;
  BuiltList<Resource> get resources;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CollectionInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CollectionInterfaceBuilder b) {}
}

abstract class Collection implements $CollectionInterface, Built<Collection, CollectionBuilder> {
  /// Creates a new Collection object using the builder pattern.
  factory Collection([void Function(CollectionBuilder)? b]) = _$Collection;

  // coverage:ignore-start
  const Collection._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory Collection.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for Collection.
  static Serializer<Collection> get serializer => _$collectionSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CollectionBuilder b) {
    $CollectionInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CollectionBuilder b) {
    $CollectionInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CollaborationResourcesListCollectionResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Collection get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CollaborationResourcesListCollectionResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CollaborationResourcesListCollectionResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class CollaborationResourcesListCollectionResponseApplicationJson_Ocs
    implements
        $CollaborationResourcesListCollectionResponseApplicationJson_OcsInterface,
        Built<CollaborationResourcesListCollectionResponseApplicationJson_Ocs,
            CollaborationResourcesListCollectionResponseApplicationJson_OcsBuilder> {
  /// Creates a new CollaborationResourcesListCollectionResponseApplicationJson_Ocs object using the builder pattern.
  factory CollaborationResourcesListCollectionResponseApplicationJson_Ocs([
    void Function(CollaborationResourcesListCollectionResponseApplicationJson_OcsBuilder)? b,
  ]) = _$CollaborationResourcesListCollectionResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const CollaborationResourcesListCollectionResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CollaborationResourcesListCollectionResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CollaborationResourcesListCollectionResponseApplicationJson_Ocs.
  static Serializer<CollaborationResourcesListCollectionResponseApplicationJson_Ocs> get serializer =>
      _$collaborationResourcesListCollectionResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CollaborationResourcesListCollectionResponseApplicationJson_OcsBuilder b) {
    $CollaborationResourcesListCollectionResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CollaborationResourcesListCollectionResponseApplicationJson_OcsBuilder b) {
    $CollaborationResourcesListCollectionResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CollaborationResourcesListCollectionResponseApplicationJsonInterface {
  CollaborationResourcesListCollectionResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CollaborationResourcesListCollectionResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CollaborationResourcesListCollectionResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class CollaborationResourcesListCollectionResponseApplicationJson
    implements
        $CollaborationResourcesListCollectionResponseApplicationJsonInterface,
        Built<CollaborationResourcesListCollectionResponseApplicationJson,
            CollaborationResourcesListCollectionResponseApplicationJsonBuilder> {
  /// Creates a new CollaborationResourcesListCollectionResponseApplicationJson object using the builder pattern.
  factory CollaborationResourcesListCollectionResponseApplicationJson([
    void Function(CollaborationResourcesListCollectionResponseApplicationJsonBuilder)? b,
  ]) = _$CollaborationResourcesListCollectionResponseApplicationJson;

  // coverage:ignore-start
  const CollaborationResourcesListCollectionResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CollaborationResourcesListCollectionResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CollaborationResourcesListCollectionResponseApplicationJson.
  static Serializer<CollaborationResourcesListCollectionResponseApplicationJson> get serializer =>
      _$collaborationResourcesListCollectionResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CollaborationResourcesListCollectionResponseApplicationJsonBuilder b) {
    $CollaborationResourcesListCollectionResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CollaborationResourcesListCollectionResponseApplicationJsonBuilder b) {
    $CollaborationResourcesListCollectionResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CollaborationResourcesRenameCollectionResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Collection get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CollaborationResourcesRenameCollectionResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CollaborationResourcesRenameCollectionResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class CollaborationResourcesRenameCollectionResponseApplicationJson_Ocs
    implements
        $CollaborationResourcesRenameCollectionResponseApplicationJson_OcsInterface,
        Built<CollaborationResourcesRenameCollectionResponseApplicationJson_Ocs,
            CollaborationResourcesRenameCollectionResponseApplicationJson_OcsBuilder> {
  /// Creates a new CollaborationResourcesRenameCollectionResponseApplicationJson_Ocs object using the builder pattern.
  factory CollaborationResourcesRenameCollectionResponseApplicationJson_Ocs([
    void Function(CollaborationResourcesRenameCollectionResponseApplicationJson_OcsBuilder)? b,
  ]) = _$CollaborationResourcesRenameCollectionResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const CollaborationResourcesRenameCollectionResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CollaborationResourcesRenameCollectionResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CollaborationResourcesRenameCollectionResponseApplicationJson_Ocs.
  static Serializer<CollaborationResourcesRenameCollectionResponseApplicationJson_Ocs> get serializer =>
      _$collaborationResourcesRenameCollectionResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CollaborationResourcesRenameCollectionResponseApplicationJson_OcsBuilder b) {
    $CollaborationResourcesRenameCollectionResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CollaborationResourcesRenameCollectionResponseApplicationJson_OcsBuilder b) {
    $CollaborationResourcesRenameCollectionResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CollaborationResourcesRenameCollectionResponseApplicationJsonInterface {
  CollaborationResourcesRenameCollectionResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CollaborationResourcesRenameCollectionResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CollaborationResourcesRenameCollectionResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class CollaborationResourcesRenameCollectionResponseApplicationJson
    implements
        $CollaborationResourcesRenameCollectionResponseApplicationJsonInterface,
        Built<CollaborationResourcesRenameCollectionResponseApplicationJson,
            CollaborationResourcesRenameCollectionResponseApplicationJsonBuilder> {
  /// Creates a new CollaborationResourcesRenameCollectionResponseApplicationJson object using the builder pattern.
  factory CollaborationResourcesRenameCollectionResponseApplicationJson([
    void Function(CollaborationResourcesRenameCollectionResponseApplicationJsonBuilder)? b,
  ]) = _$CollaborationResourcesRenameCollectionResponseApplicationJson;

  // coverage:ignore-start
  const CollaborationResourcesRenameCollectionResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CollaborationResourcesRenameCollectionResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CollaborationResourcesRenameCollectionResponseApplicationJson.
  static Serializer<CollaborationResourcesRenameCollectionResponseApplicationJson> get serializer =>
      _$collaborationResourcesRenameCollectionResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CollaborationResourcesRenameCollectionResponseApplicationJsonBuilder b) {
    $CollaborationResourcesRenameCollectionResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CollaborationResourcesRenameCollectionResponseApplicationJsonBuilder b) {
    $CollaborationResourcesRenameCollectionResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CollaborationResourcesAddResourceResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Collection get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CollaborationResourcesAddResourceResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CollaborationResourcesAddResourceResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class CollaborationResourcesAddResourceResponseApplicationJson_Ocs
    implements
        $CollaborationResourcesAddResourceResponseApplicationJson_OcsInterface,
        Built<CollaborationResourcesAddResourceResponseApplicationJson_Ocs,
            CollaborationResourcesAddResourceResponseApplicationJson_OcsBuilder> {
  /// Creates a new CollaborationResourcesAddResourceResponseApplicationJson_Ocs object using the builder pattern.
  factory CollaborationResourcesAddResourceResponseApplicationJson_Ocs([
    void Function(CollaborationResourcesAddResourceResponseApplicationJson_OcsBuilder)? b,
  ]) = _$CollaborationResourcesAddResourceResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const CollaborationResourcesAddResourceResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CollaborationResourcesAddResourceResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CollaborationResourcesAddResourceResponseApplicationJson_Ocs.
  static Serializer<CollaborationResourcesAddResourceResponseApplicationJson_Ocs> get serializer =>
      _$collaborationResourcesAddResourceResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CollaborationResourcesAddResourceResponseApplicationJson_OcsBuilder b) {
    $CollaborationResourcesAddResourceResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CollaborationResourcesAddResourceResponseApplicationJson_OcsBuilder b) {
    $CollaborationResourcesAddResourceResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CollaborationResourcesAddResourceResponseApplicationJsonInterface {
  CollaborationResourcesAddResourceResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CollaborationResourcesAddResourceResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CollaborationResourcesAddResourceResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class CollaborationResourcesAddResourceResponseApplicationJson
    implements
        $CollaborationResourcesAddResourceResponseApplicationJsonInterface,
        Built<CollaborationResourcesAddResourceResponseApplicationJson,
            CollaborationResourcesAddResourceResponseApplicationJsonBuilder> {
  /// Creates a new CollaborationResourcesAddResourceResponseApplicationJson object using the builder pattern.
  factory CollaborationResourcesAddResourceResponseApplicationJson([
    void Function(CollaborationResourcesAddResourceResponseApplicationJsonBuilder)? b,
  ]) = _$CollaborationResourcesAddResourceResponseApplicationJson;

  // coverage:ignore-start
  const CollaborationResourcesAddResourceResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CollaborationResourcesAddResourceResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CollaborationResourcesAddResourceResponseApplicationJson.
  static Serializer<CollaborationResourcesAddResourceResponseApplicationJson> get serializer =>
      _$collaborationResourcesAddResourceResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CollaborationResourcesAddResourceResponseApplicationJsonBuilder b) {
    $CollaborationResourcesAddResourceResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CollaborationResourcesAddResourceResponseApplicationJsonBuilder b) {
    $CollaborationResourcesAddResourceResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CollaborationResourcesRemoveResourceResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Collection get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CollaborationResourcesRemoveResourceResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CollaborationResourcesRemoveResourceResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class CollaborationResourcesRemoveResourceResponseApplicationJson_Ocs
    implements
        $CollaborationResourcesRemoveResourceResponseApplicationJson_OcsInterface,
        Built<CollaborationResourcesRemoveResourceResponseApplicationJson_Ocs,
            CollaborationResourcesRemoveResourceResponseApplicationJson_OcsBuilder> {
  /// Creates a new CollaborationResourcesRemoveResourceResponseApplicationJson_Ocs object using the builder pattern.
  factory CollaborationResourcesRemoveResourceResponseApplicationJson_Ocs([
    void Function(CollaborationResourcesRemoveResourceResponseApplicationJson_OcsBuilder)? b,
  ]) = _$CollaborationResourcesRemoveResourceResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const CollaborationResourcesRemoveResourceResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CollaborationResourcesRemoveResourceResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CollaborationResourcesRemoveResourceResponseApplicationJson_Ocs.
  static Serializer<CollaborationResourcesRemoveResourceResponseApplicationJson_Ocs> get serializer =>
      _$collaborationResourcesRemoveResourceResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CollaborationResourcesRemoveResourceResponseApplicationJson_OcsBuilder b) {
    $CollaborationResourcesRemoveResourceResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CollaborationResourcesRemoveResourceResponseApplicationJson_OcsBuilder b) {
    $CollaborationResourcesRemoveResourceResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CollaborationResourcesRemoveResourceResponseApplicationJsonInterface {
  CollaborationResourcesRemoveResourceResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CollaborationResourcesRemoveResourceResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CollaborationResourcesRemoveResourceResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class CollaborationResourcesRemoveResourceResponseApplicationJson
    implements
        $CollaborationResourcesRemoveResourceResponseApplicationJsonInterface,
        Built<CollaborationResourcesRemoveResourceResponseApplicationJson,
            CollaborationResourcesRemoveResourceResponseApplicationJsonBuilder> {
  /// Creates a new CollaborationResourcesRemoveResourceResponseApplicationJson object using the builder pattern.
  factory CollaborationResourcesRemoveResourceResponseApplicationJson([
    void Function(CollaborationResourcesRemoveResourceResponseApplicationJsonBuilder)? b,
  ]) = _$CollaborationResourcesRemoveResourceResponseApplicationJson;

  // coverage:ignore-start
  const CollaborationResourcesRemoveResourceResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CollaborationResourcesRemoveResourceResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CollaborationResourcesRemoveResourceResponseApplicationJson.
  static Serializer<CollaborationResourcesRemoveResourceResponseApplicationJson> get serializer =>
      _$collaborationResourcesRemoveResourceResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CollaborationResourcesRemoveResourceResponseApplicationJsonBuilder b) {
    $CollaborationResourcesRemoveResourceResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CollaborationResourcesRemoveResourceResponseApplicationJsonBuilder b) {
    $CollaborationResourcesRemoveResourceResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CollaborationResourcesSearchCollectionsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<Collection> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CollaborationResourcesSearchCollectionsResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CollaborationResourcesSearchCollectionsResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class CollaborationResourcesSearchCollectionsResponseApplicationJson_Ocs
    implements
        $CollaborationResourcesSearchCollectionsResponseApplicationJson_OcsInterface,
        Built<CollaborationResourcesSearchCollectionsResponseApplicationJson_Ocs,
            CollaborationResourcesSearchCollectionsResponseApplicationJson_OcsBuilder> {
  /// Creates a new CollaborationResourcesSearchCollectionsResponseApplicationJson_Ocs object using the builder pattern.
  factory CollaborationResourcesSearchCollectionsResponseApplicationJson_Ocs([
    void Function(CollaborationResourcesSearchCollectionsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$CollaborationResourcesSearchCollectionsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const CollaborationResourcesSearchCollectionsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CollaborationResourcesSearchCollectionsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CollaborationResourcesSearchCollectionsResponseApplicationJson_Ocs.
  static Serializer<CollaborationResourcesSearchCollectionsResponseApplicationJson_Ocs> get serializer =>
      _$collaborationResourcesSearchCollectionsResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CollaborationResourcesSearchCollectionsResponseApplicationJson_OcsBuilder b) {
    $CollaborationResourcesSearchCollectionsResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CollaborationResourcesSearchCollectionsResponseApplicationJson_OcsBuilder b) {
    $CollaborationResourcesSearchCollectionsResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CollaborationResourcesSearchCollectionsResponseApplicationJsonInterface {
  CollaborationResourcesSearchCollectionsResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CollaborationResourcesSearchCollectionsResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CollaborationResourcesSearchCollectionsResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class CollaborationResourcesSearchCollectionsResponseApplicationJson
    implements
        $CollaborationResourcesSearchCollectionsResponseApplicationJsonInterface,
        Built<CollaborationResourcesSearchCollectionsResponseApplicationJson,
            CollaborationResourcesSearchCollectionsResponseApplicationJsonBuilder> {
  /// Creates a new CollaborationResourcesSearchCollectionsResponseApplicationJson object using the builder pattern.
  factory CollaborationResourcesSearchCollectionsResponseApplicationJson([
    void Function(CollaborationResourcesSearchCollectionsResponseApplicationJsonBuilder)? b,
  ]) = _$CollaborationResourcesSearchCollectionsResponseApplicationJson;

  // coverage:ignore-start
  const CollaborationResourcesSearchCollectionsResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CollaborationResourcesSearchCollectionsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CollaborationResourcesSearchCollectionsResponseApplicationJson.
  static Serializer<CollaborationResourcesSearchCollectionsResponseApplicationJson> get serializer =>
      _$collaborationResourcesSearchCollectionsResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CollaborationResourcesSearchCollectionsResponseApplicationJsonBuilder b) {
    $CollaborationResourcesSearchCollectionsResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CollaborationResourcesSearchCollectionsResponseApplicationJsonBuilder b) {
    $CollaborationResourcesSearchCollectionsResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CollaborationResourcesGetCollectionsByResourceResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<Collection> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CollaborationResourcesGetCollectionsByResourceResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CollaborationResourcesGetCollectionsByResourceResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class CollaborationResourcesGetCollectionsByResourceResponseApplicationJson_Ocs
    implements
        $CollaborationResourcesGetCollectionsByResourceResponseApplicationJson_OcsInterface,
        Built<CollaborationResourcesGetCollectionsByResourceResponseApplicationJson_Ocs,
            CollaborationResourcesGetCollectionsByResourceResponseApplicationJson_OcsBuilder> {
  /// Creates a new CollaborationResourcesGetCollectionsByResourceResponseApplicationJson_Ocs object using the builder pattern.
  factory CollaborationResourcesGetCollectionsByResourceResponseApplicationJson_Ocs([
    void Function(CollaborationResourcesGetCollectionsByResourceResponseApplicationJson_OcsBuilder)? b,
  ]) = _$CollaborationResourcesGetCollectionsByResourceResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const CollaborationResourcesGetCollectionsByResourceResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CollaborationResourcesGetCollectionsByResourceResponseApplicationJson_Ocs.fromJson(
    Map<String, dynamic> json,
  ) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CollaborationResourcesGetCollectionsByResourceResponseApplicationJson_Ocs.
  static Serializer<CollaborationResourcesGetCollectionsByResourceResponseApplicationJson_Ocs> get serializer =>
      _$collaborationResourcesGetCollectionsByResourceResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CollaborationResourcesGetCollectionsByResourceResponseApplicationJson_OcsBuilder b) {
    $CollaborationResourcesGetCollectionsByResourceResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CollaborationResourcesGetCollectionsByResourceResponseApplicationJson_OcsBuilder b) {
    $CollaborationResourcesGetCollectionsByResourceResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CollaborationResourcesGetCollectionsByResourceResponseApplicationJsonInterface {
  CollaborationResourcesGetCollectionsByResourceResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CollaborationResourcesGetCollectionsByResourceResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CollaborationResourcesGetCollectionsByResourceResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class CollaborationResourcesGetCollectionsByResourceResponseApplicationJson
    implements
        $CollaborationResourcesGetCollectionsByResourceResponseApplicationJsonInterface,
        Built<CollaborationResourcesGetCollectionsByResourceResponseApplicationJson,
            CollaborationResourcesGetCollectionsByResourceResponseApplicationJsonBuilder> {
  /// Creates a new CollaborationResourcesGetCollectionsByResourceResponseApplicationJson object using the builder pattern.
  factory CollaborationResourcesGetCollectionsByResourceResponseApplicationJson([
    void Function(CollaborationResourcesGetCollectionsByResourceResponseApplicationJsonBuilder)? b,
  ]) = _$CollaborationResourcesGetCollectionsByResourceResponseApplicationJson;

  // coverage:ignore-start
  const CollaborationResourcesGetCollectionsByResourceResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CollaborationResourcesGetCollectionsByResourceResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CollaborationResourcesGetCollectionsByResourceResponseApplicationJson.
  static Serializer<CollaborationResourcesGetCollectionsByResourceResponseApplicationJson> get serializer =>
      _$collaborationResourcesGetCollectionsByResourceResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CollaborationResourcesGetCollectionsByResourceResponseApplicationJsonBuilder b) {
    $CollaborationResourcesGetCollectionsByResourceResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CollaborationResourcesGetCollectionsByResourceResponseApplicationJsonBuilder b) {
    $CollaborationResourcesGetCollectionsByResourceResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Collection get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(
    $CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson_OcsInterfaceBuilder b,
  ) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(
    $CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson_OcsInterfaceBuilder b,
  ) {}
}

abstract class CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson_Ocs
    implements
        $CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson_OcsInterface,
        Built<CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson_Ocs,
            CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson_OcsBuilder> {
  /// Creates a new CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson_Ocs object using the builder pattern.
  factory CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson_Ocs([
    void Function(CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson_OcsBuilder)? b,
  ]) = _$CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson_Ocs.fromJson(
    Map<String, dynamic> json,
  ) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson_Ocs.
  static Serializer<CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson_Ocs> get serializer =>
      _$collaborationResourcesCreateCollectionOnResourceResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson_OcsBuilder b) {
    $CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson_OcsBuilder b) {
    $CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CollaborationResourcesCreateCollectionOnResourceResponseApplicationJsonInterface {
  CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CollaborationResourcesCreateCollectionOnResourceResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CollaborationResourcesCreateCollectionOnResourceResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson
    implements
        $CollaborationResourcesCreateCollectionOnResourceResponseApplicationJsonInterface,
        Built<CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson,
            CollaborationResourcesCreateCollectionOnResourceResponseApplicationJsonBuilder> {
  /// Creates a new CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson object using the builder pattern.
  factory CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson([
    void Function(CollaborationResourcesCreateCollectionOnResourceResponseApplicationJsonBuilder)? b,
  ]) = _$CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson;

  // coverage:ignore-start
  const CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson.
  static Serializer<CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson> get serializer =>
      _$collaborationResourcesCreateCollectionOnResourceResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CollaborationResourcesCreateCollectionOnResourceResponseApplicationJsonBuilder b) {
    $CollaborationResourcesCreateCollectionOnResourceResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CollaborationResourcesCreateCollectionOnResourceResponseApplicationJsonBuilder b) {
    $CollaborationResourcesCreateCollectionOnResourceResponseApplicationJsonInterface._validate(b);
  }
}

class GuestAvatarGetAvatarDarkTheme extends EnumClass {
  const GuestAvatarGetAvatarDarkTheme._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const GuestAvatarGetAvatarDarkTheme $0 = _$guestAvatarGetAvatarDarkTheme$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const GuestAvatarGetAvatarDarkTheme $1 = _$guestAvatarGetAvatarDarkTheme$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<GuestAvatarGetAvatarDarkTheme> get values => _$guestAvatarGetAvatarDarkThemeValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static GuestAvatarGetAvatarDarkTheme valueOf(String name) => _$valueOfGuestAvatarGetAvatarDarkTheme(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for GuestAvatarGetAvatarDarkTheme.
  @BuiltValueSerializer(custom: true)
  static Serializer<GuestAvatarGetAvatarDarkTheme> get serializer => const _$GuestAvatarGetAvatarDarkThemeSerializer();
}

class _$GuestAvatarGetAvatarDarkThemeSerializer implements PrimitiveSerializer<GuestAvatarGetAvatarDarkTheme> {
  const _$GuestAvatarGetAvatarDarkThemeSerializer();

  static const Map<GuestAvatarGetAvatarDarkTheme, Object> _toWire = <GuestAvatarGetAvatarDarkTheme, Object>{
    GuestAvatarGetAvatarDarkTheme.$0: 0,
    GuestAvatarGetAvatarDarkTheme.$1: 1,
  };

  static const Map<Object, GuestAvatarGetAvatarDarkTheme> _fromWire = <Object, GuestAvatarGetAvatarDarkTheme>{
    0: GuestAvatarGetAvatarDarkTheme.$0,
    1: GuestAvatarGetAvatarDarkTheme.$1,
  };

  @override
  Iterable<Type> get types => const [GuestAvatarGetAvatarDarkTheme];

  @override
  String get wireName => 'GuestAvatarGetAvatarDarkTheme';

  @override
  Object serialize(
    Serializers serializers,
    GuestAvatarGetAvatarDarkTheme object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  GuestAvatarGetAvatarDarkTheme deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ContactsActionInterface {
  String get title;
  String get icon;
  String get hyperlink;
  String get appId;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ContactsActionInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ContactsActionInterfaceBuilder b) {}
}

abstract class ContactsAction implements $ContactsActionInterface, Built<ContactsAction, ContactsActionBuilder> {
  /// Creates a new ContactsAction object using the builder pattern.
  factory ContactsAction([void Function(ContactsActionBuilder)? b]) = _$ContactsAction;

  // coverage:ignore-start
  const ContactsAction._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ContactsAction.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ContactsAction.
  static Serializer<ContactsAction> get serializer => _$contactsActionSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ContactsActionBuilder b) {
    $ContactsActionInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ContactsActionBuilder b) {
    $ContactsActionInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $HoverCardGetUserResponseApplicationJson_Ocs_DataInterface {
  String get userId;
  String get displayName;
  BuiltList<ContactsAction> get actions;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($HoverCardGetUserResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($HoverCardGetUserResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class HoverCardGetUserResponseApplicationJson_Ocs_Data
    implements
        $HoverCardGetUserResponseApplicationJson_Ocs_DataInterface,
        Built<HoverCardGetUserResponseApplicationJson_Ocs_Data,
            HoverCardGetUserResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new HoverCardGetUserResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory HoverCardGetUserResponseApplicationJson_Ocs_Data([
    void Function(HoverCardGetUserResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$HoverCardGetUserResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const HoverCardGetUserResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory HoverCardGetUserResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for HoverCardGetUserResponseApplicationJson_Ocs_Data.
  static Serializer<HoverCardGetUserResponseApplicationJson_Ocs_Data> get serializer =>
      _$hoverCardGetUserResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(HoverCardGetUserResponseApplicationJson_Ocs_DataBuilder b) {
    $HoverCardGetUserResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(HoverCardGetUserResponseApplicationJson_Ocs_DataBuilder b) {
    $HoverCardGetUserResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $HoverCardGetUserResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  HoverCardGetUserResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($HoverCardGetUserResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($HoverCardGetUserResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class HoverCardGetUserResponseApplicationJson_Ocs
    implements
        $HoverCardGetUserResponseApplicationJson_OcsInterface,
        Built<HoverCardGetUserResponseApplicationJson_Ocs, HoverCardGetUserResponseApplicationJson_OcsBuilder> {
  /// Creates a new HoverCardGetUserResponseApplicationJson_Ocs object using the builder pattern.
  factory HoverCardGetUserResponseApplicationJson_Ocs([
    void Function(HoverCardGetUserResponseApplicationJson_OcsBuilder)? b,
  ]) = _$HoverCardGetUserResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const HoverCardGetUserResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory HoverCardGetUserResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for HoverCardGetUserResponseApplicationJson_Ocs.
  static Serializer<HoverCardGetUserResponseApplicationJson_Ocs> get serializer =>
      _$hoverCardGetUserResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(HoverCardGetUserResponseApplicationJson_OcsBuilder b) {
    $HoverCardGetUserResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(HoverCardGetUserResponseApplicationJson_OcsBuilder b) {
    $HoverCardGetUserResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $HoverCardGetUserResponseApplicationJsonInterface {
  HoverCardGetUserResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($HoverCardGetUserResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($HoverCardGetUserResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class HoverCardGetUserResponseApplicationJson
    implements
        $HoverCardGetUserResponseApplicationJsonInterface,
        Built<HoverCardGetUserResponseApplicationJson, HoverCardGetUserResponseApplicationJsonBuilder> {
  /// Creates a new HoverCardGetUserResponseApplicationJson object using the builder pattern.
  factory HoverCardGetUserResponseApplicationJson([void Function(HoverCardGetUserResponseApplicationJsonBuilder)? b]) =
      _$HoverCardGetUserResponseApplicationJson;

  // coverage:ignore-start
  const HoverCardGetUserResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory HoverCardGetUserResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for HoverCardGetUserResponseApplicationJson.
  static Serializer<HoverCardGetUserResponseApplicationJson> get serializer =>
      _$hoverCardGetUserResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(HoverCardGetUserResponseApplicationJsonBuilder b) {
    $HoverCardGetUserResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(HoverCardGetUserResponseApplicationJsonBuilder b) {
    $HoverCardGetUserResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $LoginConfirmPasswordResponseApplicationJsonInterface {
  int get lastLogin;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($LoginConfirmPasswordResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($LoginConfirmPasswordResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class LoginConfirmPasswordResponseApplicationJson
    implements
        $LoginConfirmPasswordResponseApplicationJsonInterface,
        Built<LoginConfirmPasswordResponseApplicationJson, LoginConfirmPasswordResponseApplicationJsonBuilder> {
  /// Creates a new LoginConfirmPasswordResponseApplicationJson object using the builder pattern.
  factory LoginConfirmPasswordResponseApplicationJson([
    void Function(LoginConfirmPasswordResponseApplicationJsonBuilder)? b,
  ]) = _$LoginConfirmPasswordResponseApplicationJson;

  // coverage:ignore-start
  const LoginConfirmPasswordResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory LoginConfirmPasswordResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for LoginConfirmPasswordResponseApplicationJson.
  static Serializer<LoginConfirmPasswordResponseApplicationJson> get serializer =>
      _$loginConfirmPasswordResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(LoginConfirmPasswordResponseApplicationJsonBuilder b) {
    $LoginConfirmPasswordResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(LoginConfirmPasswordResponseApplicationJsonBuilder b) {
    $LoginConfirmPasswordResponseApplicationJsonInterface._validate(b);
  }
}

class NavigationGetAppsNavigationAbsolute extends EnumClass {
  const NavigationGetAppsNavigationAbsolute._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const NavigationGetAppsNavigationAbsolute $0 = _$navigationGetAppsNavigationAbsolute$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const NavigationGetAppsNavigationAbsolute $1 = _$navigationGetAppsNavigationAbsolute$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<NavigationGetAppsNavigationAbsolute> get values => _$navigationGetAppsNavigationAbsoluteValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static NavigationGetAppsNavigationAbsolute valueOf(String name) => _$valueOfNavigationGetAppsNavigationAbsolute(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for NavigationGetAppsNavigationAbsolute.
  @BuiltValueSerializer(custom: true)
  static Serializer<NavigationGetAppsNavigationAbsolute> get serializer =>
      const _$NavigationGetAppsNavigationAbsoluteSerializer();
}

class _$NavigationGetAppsNavigationAbsoluteSerializer
    implements PrimitiveSerializer<NavigationGetAppsNavigationAbsolute> {
  const _$NavigationGetAppsNavigationAbsoluteSerializer();

  static const Map<NavigationGetAppsNavigationAbsolute, Object> _toWire = <NavigationGetAppsNavigationAbsolute, Object>{
    NavigationGetAppsNavigationAbsolute.$0: 0,
    NavigationGetAppsNavigationAbsolute.$1: 1,
  };

  static const Map<Object, NavigationGetAppsNavigationAbsolute> _fromWire =
      <Object, NavigationGetAppsNavigationAbsolute>{
    0: NavigationGetAppsNavigationAbsolute.$0,
    1: NavigationGetAppsNavigationAbsolute.$1,
  };

  @override
  Iterable<Type> get types => const [NavigationGetAppsNavigationAbsolute];

  @override
  String get wireName => 'NavigationGetAppsNavigationAbsolute';

  @override
  Object serialize(
    Serializers serializers,
    NavigationGetAppsNavigationAbsolute object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  NavigationGetAppsNavigationAbsolute deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

typedef NavigationEntry_Order = ({int? $int, String? string});

@BuiltValue(instantiable: false)
abstract interface class $NavigationEntryInterface {
  String get id;
  NavigationEntry_Order get order;
  String get href;
  String get icon;
  String get type;
  String get name;
  bool get active;
  String get classes;
  int get unread;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($NavigationEntryInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($NavigationEntryInterfaceBuilder b) {
    b.order?.validateOneOf();
  }
}

abstract class NavigationEntry implements $NavigationEntryInterface, Built<NavigationEntry, NavigationEntryBuilder> {
  /// Creates a new NavigationEntry object using the builder pattern.
  factory NavigationEntry([void Function(NavigationEntryBuilder)? b]) = _$NavigationEntry;

  // coverage:ignore-start
  const NavigationEntry._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory NavigationEntry.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for NavigationEntry.
  static Serializer<NavigationEntry> get serializer => _$navigationEntrySerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(NavigationEntryBuilder b) {
    $NavigationEntryInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(NavigationEntryBuilder b) {
    $NavigationEntryInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $NavigationGetAppsNavigationResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<NavigationEntry> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($NavigationGetAppsNavigationResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($NavigationGetAppsNavigationResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class NavigationGetAppsNavigationResponseApplicationJson_Ocs
    implements
        $NavigationGetAppsNavigationResponseApplicationJson_OcsInterface,
        Built<NavigationGetAppsNavigationResponseApplicationJson_Ocs,
            NavigationGetAppsNavigationResponseApplicationJson_OcsBuilder> {
  /// Creates a new NavigationGetAppsNavigationResponseApplicationJson_Ocs object using the builder pattern.
  factory NavigationGetAppsNavigationResponseApplicationJson_Ocs([
    void Function(NavigationGetAppsNavigationResponseApplicationJson_OcsBuilder)? b,
  ]) = _$NavigationGetAppsNavigationResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const NavigationGetAppsNavigationResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory NavigationGetAppsNavigationResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for NavigationGetAppsNavigationResponseApplicationJson_Ocs.
  static Serializer<NavigationGetAppsNavigationResponseApplicationJson_Ocs> get serializer =>
      _$navigationGetAppsNavigationResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(NavigationGetAppsNavigationResponseApplicationJson_OcsBuilder b) {
    $NavigationGetAppsNavigationResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(NavigationGetAppsNavigationResponseApplicationJson_OcsBuilder b) {
    $NavigationGetAppsNavigationResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $NavigationGetAppsNavigationResponseApplicationJsonInterface {
  NavigationGetAppsNavigationResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($NavigationGetAppsNavigationResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($NavigationGetAppsNavigationResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class NavigationGetAppsNavigationResponseApplicationJson
    implements
        $NavigationGetAppsNavigationResponseApplicationJsonInterface,
        Built<NavigationGetAppsNavigationResponseApplicationJson,
            NavigationGetAppsNavigationResponseApplicationJsonBuilder> {
  /// Creates a new NavigationGetAppsNavigationResponseApplicationJson object using the builder pattern.
  factory NavigationGetAppsNavigationResponseApplicationJson([
    void Function(NavigationGetAppsNavigationResponseApplicationJsonBuilder)? b,
  ]) = _$NavigationGetAppsNavigationResponseApplicationJson;

  // coverage:ignore-start
  const NavigationGetAppsNavigationResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory NavigationGetAppsNavigationResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for NavigationGetAppsNavigationResponseApplicationJson.
  static Serializer<NavigationGetAppsNavigationResponseApplicationJson> get serializer =>
      _$navigationGetAppsNavigationResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(NavigationGetAppsNavigationResponseApplicationJsonBuilder b) {
    $NavigationGetAppsNavigationResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(NavigationGetAppsNavigationResponseApplicationJsonBuilder b) {
    $NavigationGetAppsNavigationResponseApplicationJsonInterface._validate(b);
  }
}

class NavigationGetSettingsNavigationAbsolute extends EnumClass {
  const NavigationGetSettingsNavigationAbsolute._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const NavigationGetSettingsNavigationAbsolute $0 = _$navigationGetSettingsNavigationAbsolute$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const NavigationGetSettingsNavigationAbsolute $1 = _$navigationGetSettingsNavigationAbsolute$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<NavigationGetSettingsNavigationAbsolute> get values =>
      _$navigationGetSettingsNavigationAbsoluteValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static NavigationGetSettingsNavigationAbsolute valueOf(String name) =>
      _$valueOfNavigationGetSettingsNavigationAbsolute(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for NavigationGetSettingsNavigationAbsolute.
  @BuiltValueSerializer(custom: true)
  static Serializer<NavigationGetSettingsNavigationAbsolute> get serializer =>
      const _$NavigationGetSettingsNavigationAbsoluteSerializer();
}

class _$NavigationGetSettingsNavigationAbsoluteSerializer
    implements PrimitiveSerializer<NavigationGetSettingsNavigationAbsolute> {
  const _$NavigationGetSettingsNavigationAbsoluteSerializer();

  static const Map<NavigationGetSettingsNavigationAbsolute, Object> _toWire =
      <NavigationGetSettingsNavigationAbsolute, Object>{
    NavigationGetSettingsNavigationAbsolute.$0: 0,
    NavigationGetSettingsNavigationAbsolute.$1: 1,
  };

  static const Map<Object, NavigationGetSettingsNavigationAbsolute> _fromWire =
      <Object, NavigationGetSettingsNavigationAbsolute>{
    0: NavigationGetSettingsNavigationAbsolute.$0,
    1: NavigationGetSettingsNavigationAbsolute.$1,
  };

  @override
  Iterable<Type> get types => const [NavigationGetSettingsNavigationAbsolute];

  @override
  String get wireName => 'NavigationGetSettingsNavigationAbsolute';

  @override
  Object serialize(
    Serializers serializers,
    NavigationGetSettingsNavigationAbsolute object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  NavigationGetSettingsNavigationAbsolute deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $NavigationGetSettingsNavigationResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<NavigationEntry> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($NavigationGetSettingsNavigationResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($NavigationGetSettingsNavigationResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class NavigationGetSettingsNavigationResponseApplicationJson_Ocs
    implements
        $NavigationGetSettingsNavigationResponseApplicationJson_OcsInterface,
        Built<NavigationGetSettingsNavigationResponseApplicationJson_Ocs,
            NavigationGetSettingsNavigationResponseApplicationJson_OcsBuilder> {
  /// Creates a new NavigationGetSettingsNavigationResponseApplicationJson_Ocs object using the builder pattern.
  factory NavigationGetSettingsNavigationResponseApplicationJson_Ocs([
    void Function(NavigationGetSettingsNavigationResponseApplicationJson_OcsBuilder)? b,
  ]) = _$NavigationGetSettingsNavigationResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const NavigationGetSettingsNavigationResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory NavigationGetSettingsNavigationResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for NavigationGetSettingsNavigationResponseApplicationJson_Ocs.
  static Serializer<NavigationGetSettingsNavigationResponseApplicationJson_Ocs> get serializer =>
      _$navigationGetSettingsNavigationResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(NavigationGetSettingsNavigationResponseApplicationJson_OcsBuilder b) {
    $NavigationGetSettingsNavigationResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(NavigationGetSettingsNavigationResponseApplicationJson_OcsBuilder b) {
    $NavigationGetSettingsNavigationResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $NavigationGetSettingsNavigationResponseApplicationJsonInterface {
  NavigationGetSettingsNavigationResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($NavigationGetSettingsNavigationResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($NavigationGetSettingsNavigationResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class NavigationGetSettingsNavigationResponseApplicationJson
    implements
        $NavigationGetSettingsNavigationResponseApplicationJsonInterface,
        Built<NavigationGetSettingsNavigationResponseApplicationJson,
            NavigationGetSettingsNavigationResponseApplicationJsonBuilder> {
  /// Creates a new NavigationGetSettingsNavigationResponseApplicationJson object using the builder pattern.
  factory NavigationGetSettingsNavigationResponseApplicationJson([
    void Function(NavigationGetSettingsNavigationResponseApplicationJsonBuilder)? b,
  ]) = _$NavigationGetSettingsNavigationResponseApplicationJson;

  // coverage:ignore-start
  const NavigationGetSettingsNavigationResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory NavigationGetSettingsNavigationResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for NavigationGetSettingsNavigationResponseApplicationJson.
  static Serializer<NavigationGetSettingsNavigationResponseApplicationJson> get serializer =>
      _$navigationGetSettingsNavigationResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(NavigationGetSettingsNavigationResponseApplicationJsonBuilder b) {
    $NavigationGetSettingsNavigationResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(NavigationGetSettingsNavigationResponseApplicationJsonBuilder b) {
    $NavigationGetSettingsNavigationResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $OcmDiscoveryResponseApplicationJson_ResourceTypes_ProtocolsInterface {
  String get webdav;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($OcmDiscoveryResponseApplicationJson_ResourceTypes_ProtocolsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($OcmDiscoveryResponseApplicationJson_ResourceTypes_ProtocolsInterfaceBuilder b) {}
}

abstract class OcmDiscoveryResponseApplicationJson_ResourceTypes_Protocols
    implements
        $OcmDiscoveryResponseApplicationJson_ResourceTypes_ProtocolsInterface,
        Built<OcmDiscoveryResponseApplicationJson_ResourceTypes_Protocols,
            OcmDiscoveryResponseApplicationJson_ResourceTypes_ProtocolsBuilder> {
  /// Creates a new OcmDiscoveryResponseApplicationJson_ResourceTypes_Protocols object using the builder pattern.
  factory OcmDiscoveryResponseApplicationJson_ResourceTypes_Protocols([
    void Function(OcmDiscoveryResponseApplicationJson_ResourceTypes_ProtocolsBuilder)? b,
  ]) = _$OcmDiscoveryResponseApplicationJson_ResourceTypes_Protocols;

  // coverage:ignore-start
  const OcmDiscoveryResponseApplicationJson_ResourceTypes_Protocols._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory OcmDiscoveryResponseApplicationJson_ResourceTypes_Protocols.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for OcmDiscoveryResponseApplicationJson_ResourceTypes_Protocols.
  static Serializer<OcmDiscoveryResponseApplicationJson_ResourceTypes_Protocols> get serializer =>
      _$ocmDiscoveryResponseApplicationJsonResourceTypesProtocolsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(OcmDiscoveryResponseApplicationJson_ResourceTypes_ProtocolsBuilder b) {
    $OcmDiscoveryResponseApplicationJson_ResourceTypes_ProtocolsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(OcmDiscoveryResponseApplicationJson_ResourceTypes_ProtocolsBuilder b) {
    $OcmDiscoveryResponseApplicationJson_ResourceTypes_ProtocolsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $OcmDiscoveryResponseApplicationJson_ResourceTypesInterface {
  String get name;
  BuiltList<String> get shareTypes;
  OcmDiscoveryResponseApplicationJson_ResourceTypes_Protocols get protocols;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($OcmDiscoveryResponseApplicationJson_ResourceTypesInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($OcmDiscoveryResponseApplicationJson_ResourceTypesInterfaceBuilder b) {}
}

abstract class OcmDiscoveryResponseApplicationJson_ResourceTypes
    implements
        $OcmDiscoveryResponseApplicationJson_ResourceTypesInterface,
        Built<OcmDiscoveryResponseApplicationJson_ResourceTypes,
            OcmDiscoveryResponseApplicationJson_ResourceTypesBuilder> {
  /// Creates a new OcmDiscoveryResponseApplicationJson_ResourceTypes object using the builder pattern.
  factory OcmDiscoveryResponseApplicationJson_ResourceTypes([
    void Function(OcmDiscoveryResponseApplicationJson_ResourceTypesBuilder)? b,
  ]) = _$OcmDiscoveryResponseApplicationJson_ResourceTypes;

  // coverage:ignore-start
  const OcmDiscoveryResponseApplicationJson_ResourceTypes._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory OcmDiscoveryResponseApplicationJson_ResourceTypes.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for OcmDiscoveryResponseApplicationJson_ResourceTypes.
  static Serializer<OcmDiscoveryResponseApplicationJson_ResourceTypes> get serializer =>
      _$ocmDiscoveryResponseApplicationJsonResourceTypesSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(OcmDiscoveryResponseApplicationJson_ResourceTypesBuilder b) {
    $OcmDiscoveryResponseApplicationJson_ResourceTypesInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(OcmDiscoveryResponseApplicationJson_ResourceTypesBuilder b) {
    $OcmDiscoveryResponseApplicationJson_ResourceTypesInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $OcmDiscoveryResponseApplicationJsonInterface {
  bool get enabled;
  String get apiVersion;
  String get endPoint;
  BuiltList<OcmDiscoveryResponseApplicationJson_ResourceTypes> get resourceTypes;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($OcmDiscoveryResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($OcmDiscoveryResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class OcmDiscoveryResponseApplicationJson
    implements
        $OcmDiscoveryResponseApplicationJsonInterface,
        Built<OcmDiscoveryResponseApplicationJson, OcmDiscoveryResponseApplicationJsonBuilder> {
  /// Creates a new OcmDiscoveryResponseApplicationJson object using the builder pattern.
  factory OcmDiscoveryResponseApplicationJson([void Function(OcmDiscoveryResponseApplicationJsonBuilder)? b]) =
      _$OcmDiscoveryResponseApplicationJson;

  // coverage:ignore-start
  const OcmDiscoveryResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory OcmDiscoveryResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for OcmDiscoveryResponseApplicationJson.
  static Serializer<OcmDiscoveryResponseApplicationJson> get serializer =>
      _$ocmDiscoveryResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(OcmDiscoveryResponseApplicationJsonBuilder b) {
    $OcmDiscoveryResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(OcmDiscoveryResponseApplicationJsonBuilder b) {
    $OcmDiscoveryResponseApplicationJsonInterface._validate(b);
  }
}

class OcmOcmDiscoveryHeaders_XNextcloudOcmProviders extends EnumClass {
  const OcmOcmDiscoveryHeaders_XNextcloudOcmProviders._(super.name);

  /// `true`
  @BuiltValueEnumConst(wireName: 'true')
  static const OcmOcmDiscoveryHeaders_XNextcloudOcmProviders $true =
      _$ocmOcmDiscoveryHeadersXNextcloudOcmProviders$true;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<OcmOcmDiscoveryHeaders_XNextcloudOcmProviders> get values =>
      _$ocmOcmDiscoveryHeadersXNextcloudOcmProvidersValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static OcmOcmDiscoveryHeaders_XNextcloudOcmProviders valueOf(String name) =>
      _$valueOfOcmOcmDiscoveryHeaders_XNextcloudOcmProviders(name);

  /// Returns the serialized value of this enum value.
  bool get value => _$jsonSerializers.serializeWith(serializer, this)! as bool;

  /// Serializer for OcmOcmDiscoveryHeaders_XNextcloudOcmProviders.
  @BuiltValueSerializer(custom: true)
  static Serializer<OcmOcmDiscoveryHeaders_XNextcloudOcmProviders> get serializer =>
      const _$OcmOcmDiscoveryHeaders_XNextcloudOcmProvidersSerializer();
}

class _$OcmOcmDiscoveryHeaders_XNextcloudOcmProvidersSerializer
    implements PrimitiveSerializer<OcmOcmDiscoveryHeaders_XNextcloudOcmProviders> {
  const _$OcmOcmDiscoveryHeaders_XNextcloudOcmProvidersSerializer();

  static const Map<OcmOcmDiscoveryHeaders_XNextcloudOcmProviders, Object> _toWire =
      <OcmOcmDiscoveryHeaders_XNextcloudOcmProviders, Object>{
    OcmOcmDiscoveryHeaders_XNextcloudOcmProviders.$true: true,
  };

  static const Map<Object, OcmOcmDiscoveryHeaders_XNextcloudOcmProviders> _fromWire =
      <Object, OcmOcmDiscoveryHeaders_XNextcloudOcmProviders>{
    true: OcmOcmDiscoveryHeaders_XNextcloudOcmProviders.$true,
  };

  @override
  Iterable<Type> get types => const [OcmOcmDiscoveryHeaders_XNextcloudOcmProviders];

  @override
  String get wireName => 'OcmOcmDiscoveryHeaders_XNextcloudOcmProviders';

  @override
  Object serialize(
    Serializers serializers,
    OcmOcmDiscoveryHeaders_XNextcloudOcmProviders object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  OcmOcmDiscoveryHeaders_XNextcloudOcmProviders deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $OcmOcmDiscoveryHeadersInterface {
  @BuiltValueField(wireName: 'x-nextcloud-ocm-providers')
  Header<OcmOcmDiscoveryHeaders_XNextcloudOcmProviders>? get xNextcloudOcmProviders;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($OcmOcmDiscoveryHeadersInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($OcmOcmDiscoveryHeadersInterfaceBuilder b) {}
}

abstract class OcmOcmDiscoveryHeaders
    implements $OcmOcmDiscoveryHeadersInterface, Built<OcmOcmDiscoveryHeaders, OcmOcmDiscoveryHeadersBuilder> {
  /// Creates a new OcmOcmDiscoveryHeaders object using the builder pattern.
  factory OcmOcmDiscoveryHeaders([void Function(OcmOcmDiscoveryHeadersBuilder)? b]) = _$OcmOcmDiscoveryHeaders;

  // coverage:ignore-start
  const OcmOcmDiscoveryHeaders._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory OcmOcmDiscoveryHeaders.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for OcmOcmDiscoveryHeaders.
  static Serializer<OcmOcmDiscoveryHeaders> get serializer => _$ocmOcmDiscoveryHeadersSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(OcmOcmDiscoveryHeadersBuilder b) {
    $OcmOcmDiscoveryHeadersInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(OcmOcmDiscoveryHeadersBuilder b) {
    $OcmOcmDiscoveryHeadersInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_VersionInterface {
  int get major;
  int get minor;
  int get micro;
  String get string;
  String get edition;
  bool get extendedSupport;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_VersionInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_VersionInterfaceBuilder b) {}
}

abstract class OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_Version
    implements
        $OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_VersionInterface,
        Built<OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_Version,
            OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_VersionBuilder> {
  /// Creates a new OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_Version object using the builder pattern.
  factory OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_Version([
    void Function(OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_VersionBuilder)? b,
  ]) = _$OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_Version;

  // coverage:ignore-start
  const OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_Version._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_Version.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_Version.
  static Serializer<OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_Version> get serializer =>
      _$ocsGetCapabilitiesResponseApplicationJsonOcsDataVersionSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_VersionBuilder b) {
    $OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_VersionInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_VersionBuilder b) {
    $OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_VersionInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CoreCapabilities_CoreInterface {
  int get pollinterval;
  @BuiltValueField(wireName: 'webdav-root')
  String get webdavRoot;
  @BuiltValueField(wireName: 'reference-api')
  bool get referenceApi;
  @BuiltValueField(wireName: 'reference-regex')
  String get referenceRegex;
  @BuiltValueField(wireName: 'mod-rewrite-working')
  bool? get modRewriteWorking;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CoreCapabilities_CoreInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CoreCapabilities_CoreInterfaceBuilder b) {}
}

abstract class CoreCapabilities_Core
    implements $CoreCapabilities_CoreInterface, Built<CoreCapabilities_Core, CoreCapabilities_CoreBuilder> {
  /// Creates a new CoreCapabilities_Core object using the builder pattern.
  factory CoreCapabilities_Core([void Function(CoreCapabilities_CoreBuilder)? b]) = _$CoreCapabilities_Core;

  // coverage:ignore-start
  const CoreCapabilities_Core._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CoreCapabilities_Core.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CoreCapabilities_Core.
  static Serializer<CoreCapabilities_Core> get serializer => _$coreCapabilitiesCoreSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CoreCapabilities_CoreBuilder b) {
    $CoreCapabilities_CoreInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CoreCapabilities_CoreBuilder b) {
    $CoreCapabilities_CoreInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CoreCapabilitiesInterface {
  CoreCapabilities_Core get core;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CoreCapabilitiesInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CoreCapabilitiesInterfaceBuilder b) {}
}

abstract class CoreCapabilities
    implements $CoreCapabilitiesInterface, Built<CoreCapabilities, CoreCapabilitiesBuilder> {
  /// Creates a new CoreCapabilities object using the builder pattern.
  factory CoreCapabilities([void Function(CoreCapabilitiesBuilder)? b]) = _$CoreCapabilities;

  // coverage:ignore-start
  const CoreCapabilities._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CoreCapabilities.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CoreCapabilities.
  static Serializer<CoreCapabilities> get serializer => _$coreCapabilitiesSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CoreCapabilitiesBuilder b) {
    $CoreCapabilitiesInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CoreCapabilitiesBuilder b) {
    $CoreCapabilitiesInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CorePublicCapabilities_BruteforceInterface {
  int get delay;
  @BuiltValueField(wireName: 'allow-listed')
  bool get allowListed;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CorePublicCapabilities_BruteforceInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CorePublicCapabilities_BruteforceInterfaceBuilder b) {}
}

abstract class CorePublicCapabilities_Bruteforce
    implements
        $CorePublicCapabilities_BruteforceInterface,
        Built<CorePublicCapabilities_Bruteforce, CorePublicCapabilities_BruteforceBuilder> {
  /// Creates a new CorePublicCapabilities_Bruteforce object using the builder pattern.
  factory CorePublicCapabilities_Bruteforce([void Function(CorePublicCapabilities_BruteforceBuilder)? b]) =
      _$CorePublicCapabilities_Bruteforce;

  // coverage:ignore-start
  const CorePublicCapabilities_Bruteforce._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CorePublicCapabilities_Bruteforce.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CorePublicCapabilities_Bruteforce.
  static Serializer<CorePublicCapabilities_Bruteforce> get serializer => _$corePublicCapabilitiesBruteforceSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CorePublicCapabilities_BruteforceBuilder b) {
    $CorePublicCapabilities_BruteforceInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CorePublicCapabilities_BruteforceBuilder b) {
    $CorePublicCapabilities_BruteforceInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CorePublicCapabilitiesInterface {
  CorePublicCapabilities_Bruteforce get bruteforce;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CorePublicCapabilitiesInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CorePublicCapabilitiesInterfaceBuilder b) {}
}

abstract class CorePublicCapabilities
    implements $CorePublicCapabilitiesInterface, Built<CorePublicCapabilities, CorePublicCapabilitiesBuilder> {
  /// Creates a new CorePublicCapabilities object using the builder pattern.
  factory CorePublicCapabilities([void Function(CorePublicCapabilitiesBuilder)? b]) = _$CorePublicCapabilities;

  // coverage:ignore-start
  const CorePublicCapabilities._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CorePublicCapabilities.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CorePublicCapabilities.
  static Serializer<CorePublicCapabilities> get serializer => _$corePublicCapabilitiesSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CorePublicCapabilitiesBuilder b) {
    $CorePublicCapabilitiesInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CorePublicCapabilitiesBuilder b) {
    $CorePublicCapabilitiesInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CommentsCapabilities_FilesInterface {
  bool get comments;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CommentsCapabilities_FilesInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CommentsCapabilities_FilesInterfaceBuilder b) {}
}

abstract class CommentsCapabilities_Files
    implements
        $CommentsCapabilities_FilesInterface,
        Built<CommentsCapabilities_Files, CommentsCapabilities_FilesBuilder> {
  /// Creates a new CommentsCapabilities_Files object using the builder pattern.
  factory CommentsCapabilities_Files([void Function(CommentsCapabilities_FilesBuilder)? b]) =
      _$CommentsCapabilities_Files;

  // coverage:ignore-start
  const CommentsCapabilities_Files._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CommentsCapabilities_Files.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CommentsCapabilities_Files.
  static Serializer<CommentsCapabilities_Files> get serializer => _$commentsCapabilitiesFilesSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CommentsCapabilities_FilesBuilder b) {
    $CommentsCapabilities_FilesInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CommentsCapabilities_FilesBuilder b) {
    $CommentsCapabilities_FilesInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CommentsCapabilitiesInterface {
  CommentsCapabilities_Files get files;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CommentsCapabilitiesInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CommentsCapabilitiesInterfaceBuilder b) {}
}

abstract class CommentsCapabilities
    implements $CommentsCapabilitiesInterface, Built<CommentsCapabilities, CommentsCapabilitiesBuilder> {
  /// Creates a new CommentsCapabilities object using the builder pattern.
  factory CommentsCapabilities([void Function(CommentsCapabilitiesBuilder)? b]) = _$CommentsCapabilities;

  // coverage:ignore-start
  const CommentsCapabilities._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CommentsCapabilities.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CommentsCapabilities.
  static Serializer<CommentsCapabilities> get serializer => _$commentsCapabilitiesSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CommentsCapabilitiesBuilder b) {
    $CommentsCapabilitiesInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CommentsCapabilitiesBuilder b) {
    $CommentsCapabilitiesInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $DavCapabilities_DavInterface {
  String get chunking;
  String? get bulkupload;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($DavCapabilities_DavInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($DavCapabilities_DavInterfaceBuilder b) {}
}

abstract class DavCapabilities_Dav
    implements $DavCapabilities_DavInterface, Built<DavCapabilities_Dav, DavCapabilities_DavBuilder> {
  /// Creates a new DavCapabilities_Dav object using the builder pattern.
  factory DavCapabilities_Dav([void Function(DavCapabilities_DavBuilder)? b]) = _$DavCapabilities_Dav;

  // coverage:ignore-start
  const DavCapabilities_Dav._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory DavCapabilities_Dav.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for DavCapabilities_Dav.
  static Serializer<DavCapabilities_Dav> get serializer => _$davCapabilitiesDavSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(DavCapabilities_DavBuilder b) {
    $DavCapabilities_DavInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(DavCapabilities_DavBuilder b) {
    $DavCapabilities_DavInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $DavCapabilitiesInterface {
  DavCapabilities_Dav get dav;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($DavCapabilitiesInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($DavCapabilitiesInterfaceBuilder b) {}
}

abstract class DavCapabilities implements $DavCapabilitiesInterface, Built<DavCapabilities, DavCapabilitiesBuilder> {
  /// Creates a new DavCapabilities object using the builder pattern.
  factory DavCapabilities([void Function(DavCapabilitiesBuilder)? b]) = _$DavCapabilities;

  // coverage:ignore-start
  const DavCapabilities._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory DavCapabilities.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for DavCapabilities.
  static Serializer<DavCapabilities> get serializer => _$davCapabilitiesSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(DavCapabilitiesBuilder b) {
    $DavCapabilitiesInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(DavCapabilitiesBuilder b) {
    $DavCapabilitiesInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $DropAccountCapabilities_DropAccount_DelayInterface {
  bool get enabled;
  int get hours;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($DropAccountCapabilities_DropAccount_DelayInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($DropAccountCapabilities_DropAccount_DelayInterfaceBuilder b) {}
}

abstract class DropAccountCapabilities_DropAccount_Delay
    implements
        $DropAccountCapabilities_DropAccount_DelayInterface,
        Built<DropAccountCapabilities_DropAccount_Delay, DropAccountCapabilities_DropAccount_DelayBuilder> {
  /// Creates a new DropAccountCapabilities_DropAccount_Delay object using the builder pattern.
  factory DropAccountCapabilities_DropAccount_Delay([
    void Function(DropAccountCapabilities_DropAccount_DelayBuilder)? b,
  ]) = _$DropAccountCapabilities_DropAccount_Delay;

  // coverage:ignore-start
  const DropAccountCapabilities_DropAccount_Delay._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory DropAccountCapabilities_DropAccount_Delay.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for DropAccountCapabilities_DropAccount_Delay.
  static Serializer<DropAccountCapabilities_DropAccount_Delay> get serializer =>
      _$dropAccountCapabilitiesDropAccountDelaySerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(DropAccountCapabilities_DropAccount_DelayBuilder b) {
    $DropAccountCapabilities_DropAccount_DelayInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(DropAccountCapabilities_DropAccount_DelayBuilder b) {
    $DropAccountCapabilities_DropAccount_DelayInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $DropAccountCapabilities_DropAccountInterface {
  bool get enabled;
  @BuiltValueField(wireName: 'api-version')
  String get apiVersion;
  DropAccountCapabilities_DropAccount_Delay get delay;
  String? get details;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($DropAccountCapabilities_DropAccountInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($DropAccountCapabilities_DropAccountInterfaceBuilder b) {}
}

abstract class DropAccountCapabilities_DropAccount
    implements
        $DropAccountCapabilities_DropAccountInterface,
        Built<DropAccountCapabilities_DropAccount, DropAccountCapabilities_DropAccountBuilder> {
  /// Creates a new DropAccountCapabilities_DropAccount object using the builder pattern.
  factory DropAccountCapabilities_DropAccount([void Function(DropAccountCapabilities_DropAccountBuilder)? b]) =
      _$DropAccountCapabilities_DropAccount;

  // coverage:ignore-start
  const DropAccountCapabilities_DropAccount._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory DropAccountCapabilities_DropAccount.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for DropAccountCapabilities_DropAccount.
  static Serializer<DropAccountCapabilities_DropAccount> get serializer =>
      _$dropAccountCapabilitiesDropAccountSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(DropAccountCapabilities_DropAccountBuilder b) {
    $DropAccountCapabilities_DropAccountInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(DropAccountCapabilities_DropAccountBuilder b) {
    $DropAccountCapabilities_DropAccountInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $DropAccountCapabilitiesInterface {
  @BuiltValueField(wireName: 'drop-account')
  DropAccountCapabilities_DropAccount get dropAccount;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($DropAccountCapabilitiesInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($DropAccountCapabilitiesInterfaceBuilder b) {}
}

abstract class DropAccountCapabilities
    implements $DropAccountCapabilitiesInterface, Built<DropAccountCapabilities, DropAccountCapabilitiesBuilder> {
  /// Creates a new DropAccountCapabilities object using the builder pattern.
  factory DropAccountCapabilities([void Function(DropAccountCapabilitiesBuilder)? b]) = _$DropAccountCapabilities;

  // coverage:ignore-start
  const DropAccountCapabilities._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory DropAccountCapabilities.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for DropAccountCapabilities.
  static Serializer<DropAccountCapabilities> get serializer => _$dropAccountCapabilitiesSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(DropAccountCapabilitiesBuilder b) {
    $DropAccountCapabilitiesInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(DropAccountCapabilitiesBuilder b) {
    $DropAccountCapabilitiesInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FilesCapabilities_Files_DirectEditingInterface {
  String get url;
  String get etag;
  bool get supportsFileId;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FilesCapabilities_Files_DirectEditingInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FilesCapabilities_Files_DirectEditingInterfaceBuilder b) {}
}

abstract class FilesCapabilities_Files_DirectEditing
    implements
        $FilesCapabilities_Files_DirectEditingInterface,
        Built<FilesCapabilities_Files_DirectEditing, FilesCapabilities_Files_DirectEditingBuilder> {
  /// Creates a new FilesCapabilities_Files_DirectEditing object using the builder pattern.
  factory FilesCapabilities_Files_DirectEditing([void Function(FilesCapabilities_Files_DirectEditingBuilder)? b]) =
      _$FilesCapabilities_Files_DirectEditing;

  // coverage:ignore-start
  const FilesCapabilities_Files_DirectEditing._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FilesCapabilities_Files_DirectEditing.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FilesCapabilities_Files_DirectEditing.
  static Serializer<FilesCapabilities_Files_DirectEditing> get serializer =>
      _$filesCapabilitiesFilesDirectEditingSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FilesCapabilities_Files_DirectEditingBuilder b) {
    $FilesCapabilities_Files_DirectEditingInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FilesCapabilities_Files_DirectEditingBuilder b) {
    $FilesCapabilities_Files_DirectEditingInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FilesCapabilities_FilesInterface {
  bool get bigfilechunking;
  @BuiltValueField(wireName: 'blacklisted_files')
  BuiltList<JsonObject> get blacklistedFiles;
  @BuiltValueField(wireName: 'forbidden_filename_characters')
  BuiltList<String> get forbiddenFilenameCharacters;
  FilesCapabilities_Files_DirectEditing get directEditing;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FilesCapabilities_FilesInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FilesCapabilities_FilesInterfaceBuilder b) {}
}

abstract class FilesCapabilities_Files
    implements $FilesCapabilities_FilesInterface, Built<FilesCapabilities_Files, FilesCapabilities_FilesBuilder> {
  /// Creates a new FilesCapabilities_Files object using the builder pattern.
  factory FilesCapabilities_Files([void Function(FilesCapabilities_FilesBuilder)? b]) = _$FilesCapabilities_Files;

  // coverage:ignore-start
  const FilesCapabilities_Files._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FilesCapabilities_Files.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FilesCapabilities_Files.
  static Serializer<FilesCapabilities_Files> get serializer => _$filesCapabilitiesFilesSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FilesCapabilities_FilesBuilder b) {
    $FilesCapabilities_FilesInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FilesCapabilities_FilesBuilder b) {
    $FilesCapabilities_FilesInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FilesCapabilitiesInterface {
  FilesCapabilities_Files get files;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FilesCapabilitiesInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FilesCapabilitiesInterfaceBuilder b) {}
}

abstract class FilesCapabilities
    implements $FilesCapabilitiesInterface, Built<FilesCapabilities, FilesCapabilitiesBuilder> {
  /// Creates a new FilesCapabilities object using the builder pattern.
  factory FilesCapabilities([void Function(FilesCapabilitiesBuilder)? b]) = _$FilesCapabilities;

  // coverage:ignore-start
  const FilesCapabilities._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FilesCapabilities.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FilesCapabilities.
  static Serializer<FilesCapabilities> get serializer => _$filesCapabilitiesSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FilesCapabilitiesBuilder b) {
    $FilesCapabilitiesInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FilesCapabilitiesBuilder b) {
    $FilesCapabilitiesInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FilesSharingCapabilities_FilesSharing_Public_PasswordInterface {
  bool get enforced;
  bool get askForOptionalPassword;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FilesSharingCapabilities_FilesSharing_Public_PasswordInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FilesSharingCapabilities_FilesSharing_Public_PasswordInterfaceBuilder b) {}
}

abstract class FilesSharingCapabilities_FilesSharing_Public_Password
    implements
        $FilesSharingCapabilities_FilesSharing_Public_PasswordInterface,
        Built<FilesSharingCapabilities_FilesSharing_Public_Password,
            FilesSharingCapabilities_FilesSharing_Public_PasswordBuilder> {
  /// Creates a new FilesSharingCapabilities_FilesSharing_Public_Password object using the builder pattern.
  factory FilesSharingCapabilities_FilesSharing_Public_Password([
    void Function(FilesSharingCapabilities_FilesSharing_Public_PasswordBuilder)? b,
  ]) = _$FilesSharingCapabilities_FilesSharing_Public_Password;

  // coverage:ignore-start
  const FilesSharingCapabilities_FilesSharing_Public_Password._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FilesSharingCapabilities_FilesSharing_Public_Password.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FilesSharingCapabilities_FilesSharing_Public_Password.
  static Serializer<FilesSharingCapabilities_FilesSharing_Public_Password> get serializer =>
      _$filesSharingCapabilitiesFilesSharingPublicPasswordSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FilesSharingCapabilities_FilesSharing_Public_PasswordBuilder b) {
    $FilesSharingCapabilities_FilesSharing_Public_PasswordInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FilesSharingCapabilities_FilesSharing_Public_PasswordBuilder b) {
    $FilesSharingCapabilities_FilesSharing_Public_PasswordInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FilesSharingCapabilities_FilesSharing_Public_ExpireDateInterface {
  bool get enabled;
  int? get days;
  bool? get enforced;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FilesSharingCapabilities_FilesSharing_Public_ExpireDateInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FilesSharingCapabilities_FilesSharing_Public_ExpireDateInterfaceBuilder b) {}
}

abstract class FilesSharingCapabilities_FilesSharing_Public_ExpireDate
    implements
        $FilesSharingCapabilities_FilesSharing_Public_ExpireDateInterface,
        Built<FilesSharingCapabilities_FilesSharing_Public_ExpireDate,
            FilesSharingCapabilities_FilesSharing_Public_ExpireDateBuilder> {
  /// Creates a new FilesSharingCapabilities_FilesSharing_Public_ExpireDate object using the builder pattern.
  factory FilesSharingCapabilities_FilesSharing_Public_ExpireDate([
    void Function(FilesSharingCapabilities_FilesSharing_Public_ExpireDateBuilder)? b,
  ]) = _$FilesSharingCapabilities_FilesSharing_Public_ExpireDate;

  // coverage:ignore-start
  const FilesSharingCapabilities_FilesSharing_Public_ExpireDate._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FilesSharingCapabilities_FilesSharing_Public_ExpireDate.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FilesSharingCapabilities_FilesSharing_Public_ExpireDate.
  static Serializer<FilesSharingCapabilities_FilesSharing_Public_ExpireDate> get serializer =>
      _$filesSharingCapabilitiesFilesSharingPublicExpireDateSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FilesSharingCapabilities_FilesSharing_Public_ExpireDateBuilder b) {
    $FilesSharingCapabilities_FilesSharing_Public_ExpireDateInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FilesSharingCapabilities_FilesSharing_Public_ExpireDateBuilder b) {
    $FilesSharingCapabilities_FilesSharing_Public_ExpireDateInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FilesSharingCapabilities_FilesSharing_Public_ExpireDateInternalInterface {
  bool get enabled;
  int? get days;
  bool? get enforced;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FilesSharingCapabilities_FilesSharing_Public_ExpireDateInternalInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FilesSharingCapabilities_FilesSharing_Public_ExpireDateInternalInterfaceBuilder b) {}
}

abstract class FilesSharingCapabilities_FilesSharing_Public_ExpireDateInternal
    implements
        $FilesSharingCapabilities_FilesSharing_Public_ExpireDateInternalInterface,
        Built<FilesSharingCapabilities_FilesSharing_Public_ExpireDateInternal,
            FilesSharingCapabilities_FilesSharing_Public_ExpireDateInternalBuilder> {
  /// Creates a new FilesSharingCapabilities_FilesSharing_Public_ExpireDateInternal object using the builder pattern.
  factory FilesSharingCapabilities_FilesSharing_Public_ExpireDateInternal([
    void Function(FilesSharingCapabilities_FilesSharing_Public_ExpireDateInternalBuilder)? b,
  ]) = _$FilesSharingCapabilities_FilesSharing_Public_ExpireDateInternal;

  // coverage:ignore-start
  const FilesSharingCapabilities_FilesSharing_Public_ExpireDateInternal._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FilesSharingCapabilities_FilesSharing_Public_ExpireDateInternal.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FilesSharingCapabilities_FilesSharing_Public_ExpireDateInternal.
  static Serializer<FilesSharingCapabilities_FilesSharing_Public_ExpireDateInternal> get serializer =>
      _$filesSharingCapabilitiesFilesSharingPublicExpireDateInternalSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FilesSharingCapabilities_FilesSharing_Public_ExpireDateInternalBuilder b) {
    $FilesSharingCapabilities_FilesSharing_Public_ExpireDateInternalInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FilesSharingCapabilities_FilesSharing_Public_ExpireDateInternalBuilder b) {
    $FilesSharingCapabilities_FilesSharing_Public_ExpireDateInternalInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FilesSharingCapabilities_FilesSharing_Public_ExpireDateRemoteInterface {
  bool get enabled;
  int? get days;
  bool? get enforced;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FilesSharingCapabilities_FilesSharing_Public_ExpireDateRemoteInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FilesSharingCapabilities_FilesSharing_Public_ExpireDateRemoteInterfaceBuilder b) {}
}

abstract class FilesSharingCapabilities_FilesSharing_Public_ExpireDateRemote
    implements
        $FilesSharingCapabilities_FilesSharing_Public_ExpireDateRemoteInterface,
        Built<FilesSharingCapabilities_FilesSharing_Public_ExpireDateRemote,
            FilesSharingCapabilities_FilesSharing_Public_ExpireDateRemoteBuilder> {
  /// Creates a new FilesSharingCapabilities_FilesSharing_Public_ExpireDateRemote object using the builder pattern.
  factory FilesSharingCapabilities_FilesSharing_Public_ExpireDateRemote([
    void Function(FilesSharingCapabilities_FilesSharing_Public_ExpireDateRemoteBuilder)? b,
  ]) = _$FilesSharingCapabilities_FilesSharing_Public_ExpireDateRemote;

  // coverage:ignore-start
  const FilesSharingCapabilities_FilesSharing_Public_ExpireDateRemote._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FilesSharingCapabilities_FilesSharing_Public_ExpireDateRemote.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FilesSharingCapabilities_FilesSharing_Public_ExpireDateRemote.
  static Serializer<FilesSharingCapabilities_FilesSharing_Public_ExpireDateRemote> get serializer =>
      _$filesSharingCapabilitiesFilesSharingPublicExpireDateRemoteSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FilesSharingCapabilities_FilesSharing_Public_ExpireDateRemoteBuilder b) {
    $FilesSharingCapabilities_FilesSharing_Public_ExpireDateRemoteInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FilesSharingCapabilities_FilesSharing_Public_ExpireDateRemoteBuilder b) {
    $FilesSharingCapabilities_FilesSharing_Public_ExpireDateRemoteInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FilesSharingCapabilities_FilesSharing_PublicInterface {
  bool get enabled;
  FilesSharingCapabilities_FilesSharing_Public_Password? get password;
  @BuiltValueField(wireName: 'multiple_links')
  bool? get multipleLinks;
  @BuiltValueField(wireName: 'expire_date')
  FilesSharingCapabilities_FilesSharing_Public_ExpireDate? get expireDate;
  @BuiltValueField(wireName: 'expire_date_internal')
  FilesSharingCapabilities_FilesSharing_Public_ExpireDateInternal? get expireDateInternal;
  @BuiltValueField(wireName: 'expire_date_remote')
  FilesSharingCapabilities_FilesSharing_Public_ExpireDateRemote? get expireDateRemote;
  @BuiltValueField(wireName: 'send_mail')
  bool? get sendMail;
  bool? get upload;
  @BuiltValueField(wireName: 'upload_files_drop')
  bool? get uploadFilesDrop;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FilesSharingCapabilities_FilesSharing_PublicInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FilesSharingCapabilities_FilesSharing_PublicInterfaceBuilder b) {}
}

abstract class FilesSharingCapabilities_FilesSharing_Public
    implements
        $FilesSharingCapabilities_FilesSharing_PublicInterface,
        Built<FilesSharingCapabilities_FilesSharing_Public, FilesSharingCapabilities_FilesSharing_PublicBuilder> {
  /// Creates a new FilesSharingCapabilities_FilesSharing_Public object using the builder pattern.
  factory FilesSharingCapabilities_FilesSharing_Public([
    void Function(FilesSharingCapabilities_FilesSharing_PublicBuilder)? b,
  ]) = _$FilesSharingCapabilities_FilesSharing_Public;

  // coverage:ignore-start
  const FilesSharingCapabilities_FilesSharing_Public._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FilesSharingCapabilities_FilesSharing_Public.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FilesSharingCapabilities_FilesSharing_Public.
  static Serializer<FilesSharingCapabilities_FilesSharing_Public> get serializer =>
      _$filesSharingCapabilitiesFilesSharingPublicSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FilesSharingCapabilities_FilesSharing_PublicBuilder b) {
    $FilesSharingCapabilities_FilesSharing_PublicInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FilesSharingCapabilities_FilesSharing_PublicBuilder b) {
    $FilesSharingCapabilities_FilesSharing_PublicInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FilesSharingCapabilities_FilesSharing_User_ExpireDateInterface {
  bool get enabled;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FilesSharingCapabilities_FilesSharing_User_ExpireDateInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FilesSharingCapabilities_FilesSharing_User_ExpireDateInterfaceBuilder b) {}
}

abstract class FilesSharingCapabilities_FilesSharing_User_ExpireDate
    implements
        $FilesSharingCapabilities_FilesSharing_User_ExpireDateInterface,
        Built<FilesSharingCapabilities_FilesSharing_User_ExpireDate,
            FilesSharingCapabilities_FilesSharing_User_ExpireDateBuilder> {
  /// Creates a new FilesSharingCapabilities_FilesSharing_User_ExpireDate object using the builder pattern.
  factory FilesSharingCapabilities_FilesSharing_User_ExpireDate([
    void Function(FilesSharingCapabilities_FilesSharing_User_ExpireDateBuilder)? b,
  ]) = _$FilesSharingCapabilities_FilesSharing_User_ExpireDate;

  // coverage:ignore-start
  const FilesSharingCapabilities_FilesSharing_User_ExpireDate._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FilesSharingCapabilities_FilesSharing_User_ExpireDate.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FilesSharingCapabilities_FilesSharing_User_ExpireDate.
  static Serializer<FilesSharingCapabilities_FilesSharing_User_ExpireDate> get serializer =>
      _$filesSharingCapabilitiesFilesSharingUserExpireDateSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FilesSharingCapabilities_FilesSharing_User_ExpireDateBuilder b) {
    $FilesSharingCapabilities_FilesSharing_User_ExpireDateInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FilesSharingCapabilities_FilesSharing_User_ExpireDateBuilder b) {
    $FilesSharingCapabilities_FilesSharing_User_ExpireDateInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FilesSharingCapabilities_FilesSharing_UserInterface {
  @BuiltValueField(wireName: 'send_mail')
  bool get sendMail;
  @BuiltValueField(wireName: 'expire_date')
  FilesSharingCapabilities_FilesSharing_User_ExpireDate? get expireDate;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FilesSharingCapabilities_FilesSharing_UserInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FilesSharingCapabilities_FilesSharing_UserInterfaceBuilder b) {}
}

abstract class FilesSharingCapabilities_FilesSharing_User
    implements
        $FilesSharingCapabilities_FilesSharing_UserInterface,
        Built<FilesSharingCapabilities_FilesSharing_User, FilesSharingCapabilities_FilesSharing_UserBuilder> {
  /// Creates a new FilesSharingCapabilities_FilesSharing_User object using the builder pattern.
  factory FilesSharingCapabilities_FilesSharing_User([
    void Function(FilesSharingCapabilities_FilesSharing_UserBuilder)? b,
  ]) = _$FilesSharingCapabilities_FilesSharing_User;

  // coverage:ignore-start
  const FilesSharingCapabilities_FilesSharing_User._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FilesSharingCapabilities_FilesSharing_User.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FilesSharingCapabilities_FilesSharing_User.
  static Serializer<FilesSharingCapabilities_FilesSharing_User> get serializer =>
      _$filesSharingCapabilitiesFilesSharingUserSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FilesSharingCapabilities_FilesSharing_UserBuilder b) {
    $FilesSharingCapabilities_FilesSharing_UserInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FilesSharingCapabilities_FilesSharing_UserBuilder b) {
    $FilesSharingCapabilities_FilesSharing_UserInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FilesSharingCapabilities_FilesSharing_Group_ExpireDateInterface {
  bool get enabled;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FilesSharingCapabilities_FilesSharing_Group_ExpireDateInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FilesSharingCapabilities_FilesSharing_Group_ExpireDateInterfaceBuilder b) {}
}

abstract class FilesSharingCapabilities_FilesSharing_Group_ExpireDate
    implements
        $FilesSharingCapabilities_FilesSharing_Group_ExpireDateInterface,
        Built<FilesSharingCapabilities_FilesSharing_Group_ExpireDate,
            FilesSharingCapabilities_FilesSharing_Group_ExpireDateBuilder> {
  /// Creates a new FilesSharingCapabilities_FilesSharing_Group_ExpireDate object using the builder pattern.
  factory FilesSharingCapabilities_FilesSharing_Group_ExpireDate([
    void Function(FilesSharingCapabilities_FilesSharing_Group_ExpireDateBuilder)? b,
  ]) = _$FilesSharingCapabilities_FilesSharing_Group_ExpireDate;

  // coverage:ignore-start
  const FilesSharingCapabilities_FilesSharing_Group_ExpireDate._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FilesSharingCapabilities_FilesSharing_Group_ExpireDate.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FilesSharingCapabilities_FilesSharing_Group_ExpireDate.
  static Serializer<FilesSharingCapabilities_FilesSharing_Group_ExpireDate> get serializer =>
      _$filesSharingCapabilitiesFilesSharingGroupExpireDateSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FilesSharingCapabilities_FilesSharing_Group_ExpireDateBuilder b) {
    $FilesSharingCapabilities_FilesSharing_Group_ExpireDateInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FilesSharingCapabilities_FilesSharing_Group_ExpireDateBuilder b) {
    $FilesSharingCapabilities_FilesSharing_Group_ExpireDateInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FilesSharingCapabilities_FilesSharing_GroupInterface {
  bool get enabled;
  @BuiltValueField(wireName: 'expire_date')
  FilesSharingCapabilities_FilesSharing_Group_ExpireDate? get expireDate;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FilesSharingCapabilities_FilesSharing_GroupInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FilesSharingCapabilities_FilesSharing_GroupInterfaceBuilder b) {}
}

abstract class FilesSharingCapabilities_FilesSharing_Group
    implements
        $FilesSharingCapabilities_FilesSharing_GroupInterface,
        Built<FilesSharingCapabilities_FilesSharing_Group, FilesSharingCapabilities_FilesSharing_GroupBuilder> {
  /// Creates a new FilesSharingCapabilities_FilesSharing_Group object using the builder pattern.
  factory FilesSharingCapabilities_FilesSharing_Group([
    void Function(FilesSharingCapabilities_FilesSharing_GroupBuilder)? b,
  ]) = _$FilesSharingCapabilities_FilesSharing_Group;

  // coverage:ignore-start
  const FilesSharingCapabilities_FilesSharing_Group._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FilesSharingCapabilities_FilesSharing_Group.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FilesSharingCapabilities_FilesSharing_Group.
  static Serializer<FilesSharingCapabilities_FilesSharing_Group> get serializer =>
      _$filesSharingCapabilitiesFilesSharingGroupSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FilesSharingCapabilities_FilesSharing_GroupBuilder b) {
    $FilesSharingCapabilities_FilesSharing_GroupInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FilesSharingCapabilities_FilesSharing_GroupBuilder b) {
    $FilesSharingCapabilities_FilesSharing_GroupInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FilesSharingCapabilities_FilesSharing_Federation_ExpireDateInterface {
  bool get enabled;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FilesSharingCapabilities_FilesSharing_Federation_ExpireDateInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FilesSharingCapabilities_FilesSharing_Federation_ExpireDateInterfaceBuilder b) {}
}

abstract class FilesSharingCapabilities_FilesSharing_Federation_ExpireDate
    implements
        $FilesSharingCapabilities_FilesSharing_Federation_ExpireDateInterface,
        Built<FilesSharingCapabilities_FilesSharing_Federation_ExpireDate,
            FilesSharingCapabilities_FilesSharing_Federation_ExpireDateBuilder> {
  /// Creates a new FilesSharingCapabilities_FilesSharing_Federation_ExpireDate object using the builder pattern.
  factory FilesSharingCapabilities_FilesSharing_Federation_ExpireDate([
    void Function(FilesSharingCapabilities_FilesSharing_Federation_ExpireDateBuilder)? b,
  ]) = _$FilesSharingCapabilities_FilesSharing_Federation_ExpireDate;

  // coverage:ignore-start
  const FilesSharingCapabilities_FilesSharing_Federation_ExpireDate._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FilesSharingCapabilities_FilesSharing_Federation_ExpireDate.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FilesSharingCapabilities_FilesSharing_Federation_ExpireDate.
  static Serializer<FilesSharingCapabilities_FilesSharing_Federation_ExpireDate> get serializer =>
      _$filesSharingCapabilitiesFilesSharingFederationExpireDateSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FilesSharingCapabilities_FilesSharing_Federation_ExpireDateBuilder b) {
    $FilesSharingCapabilities_FilesSharing_Federation_ExpireDateInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FilesSharingCapabilities_FilesSharing_Federation_ExpireDateBuilder b) {
    $FilesSharingCapabilities_FilesSharing_Federation_ExpireDateInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FilesSharingCapabilities_FilesSharing_Federation_ExpireDateSupportedInterface {
  bool get enabled;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FilesSharingCapabilities_FilesSharing_Federation_ExpireDateSupportedInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FilesSharingCapabilities_FilesSharing_Federation_ExpireDateSupportedInterfaceBuilder b) {}
}

abstract class FilesSharingCapabilities_FilesSharing_Federation_ExpireDateSupported
    implements
        $FilesSharingCapabilities_FilesSharing_Federation_ExpireDateSupportedInterface,
        Built<FilesSharingCapabilities_FilesSharing_Federation_ExpireDateSupported,
            FilesSharingCapabilities_FilesSharing_Federation_ExpireDateSupportedBuilder> {
  /// Creates a new FilesSharingCapabilities_FilesSharing_Federation_ExpireDateSupported object using the builder pattern.
  factory FilesSharingCapabilities_FilesSharing_Federation_ExpireDateSupported([
    void Function(FilesSharingCapabilities_FilesSharing_Federation_ExpireDateSupportedBuilder)? b,
  ]) = _$FilesSharingCapabilities_FilesSharing_Federation_ExpireDateSupported;

  // coverage:ignore-start
  const FilesSharingCapabilities_FilesSharing_Federation_ExpireDateSupported._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FilesSharingCapabilities_FilesSharing_Federation_ExpireDateSupported.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FilesSharingCapabilities_FilesSharing_Federation_ExpireDateSupported.
  static Serializer<FilesSharingCapabilities_FilesSharing_Federation_ExpireDateSupported> get serializer =>
      _$filesSharingCapabilitiesFilesSharingFederationExpireDateSupportedSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FilesSharingCapabilities_FilesSharing_Federation_ExpireDateSupportedBuilder b) {
    $FilesSharingCapabilities_FilesSharing_Federation_ExpireDateSupportedInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FilesSharingCapabilities_FilesSharing_Federation_ExpireDateSupportedBuilder b) {
    $FilesSharingCapabilities_FilesSharing_Federation_ExpireDateSupportedInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FilesSharingCapabilities_FilesSharing_FederationInterface {
  bool get outgoing;
  bool get incoming;
  @BuiltValueField(wireName: 'expire_date')
  FilesSharingCapabilities_FilesSharing_Federation_ExpireDate get expireDate;
  @BuiltValueField(wireName: 'expire_date_supported')
  FilesSharingCapabilities_FilesSharing_Federation_ExpireDateSupported get expireDateSupported;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FilesSharingCapabilities_FilesSharing_FederationInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FilesSharingCapabilities_FilesSharing_FederationInterfaceBuilder b) {}
}

abstract class FilesSharingCapabilities_FilesSharing_Federation
    implements
        $FilesSharingCapabilities_FilesSharing_FederationInterface,
        Built<FilesSharingCapabilities_FilesSharing_Federation,
            FilesSharingCapabilities_FilesSharing_FederationBuilder> {
  /// Creates a new FilesSharingCapabilities_FilesSharing_Federation object using the builder pattern.
  factory FilesSharingCapabilities_FilesSharing_Federation([
    void Function(FilesSharingCapabilities_FilesSharing_FederationBuilder)? b,
  ]) = _$FilesSharingCapabilities_FilesSharing_Federation;

  // coverage:ignore-start
  const FilesSharingCapabilities_FilesSharing_Federation._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FilesSharingCapabilities_FilesSharing_Federation.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FilesSharingCapabilities_FilesSharing_Federation.
  static Serializer<FilesSharingCapabilities_FilesSharing_Federation> get serializer =>
      _$filesSharingCapabilitiesFilesSharingFederationSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FilesSharingCapabilities_FilesSharing_FederationBuilder b) {
    $FilesSharingCapabilities_FilesSharing_FederationInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FilesSharingCapabilities_FilesSharing_FederationBuilder b) {
    $FilesSharingCapabilities_FilesSharing_FederationInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FilesSharingCapabilities_FilesSharing_ShareeInterface {
  @BuiltValueField(wireName: 'query_lookup_default')
  bool get queryLookupDefault;
  @BuiltValueField(wireName: 'always_show_unique')
  bool get alwaysShowUnique;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FilesSharingCapabilities_FilesSharing_ShareeInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FilesSharingCapabilities_FilesSharing_ShareeInterfaceBuilder b) {}
}

abstract class FilesSharingCapabilities_FilesSharing_Sharee
    implements
        $FilesSharingCapabilities_FilesSharing_ShareeInterface,
        Built<FilesSharingCapabilities_FilesSharing_Sharee, FilesSharingCapabilities_FilesSharing_ShareeBuilder> {
  /// Creates a new FilesSharingCapabilities_FilesSharing_Sharee object using the builder pattern.
  factory FilesSharingCapabilities_FilesSharing_Sharee([
    void Function(FilesSharingCapabilities_FilesSharing_ShareeBuilder)? b,
  ]) = _$FilesSharingCapabilities_FilesSharing_Sharee;

  // coverage:ignore-start
  const FilesSharingCapabilities_FilesSharing_Sharee._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FilesSharingCapabilities_FilesSharing_Sharee.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FilesSharingCapabilities_FilesSharing_Sharee.
  static Serializer<FilesSharingCapabilities_FilesSharing_Sharee> get serializer =>
      _$filesSharingCapabilitiesFilesSharingShareeSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FilesSharingCapabilities_FilesSharing_ShareeBuilder b) {
    $FilesSharingCapabilities_FilesSharing_ShareeInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FilesSharingCapabilities_FilesSharing_ShareeBuilder b) {
    $FilesSharingCapabilities_FilesSharing_ShareeInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FilesSharingCapabilities_FilesSharingInterface {
  @BuiltValueField(wireName: 'api_enabled')
  bool get apiEnabled;
  FilesSharingCapabilities_FilesSharing_Public get public;
  FilesSharingCapabilities_FilesSharing_User get user;
  bool get resharing;
  @BuiltValueField(wireName: 'group_sharing')
  bool? get groupSharing;
  FilesSharingCapabilities_FilesSharing_Group? get group;
  @BuiltValueField(wireName: 'default_permissions')
  int? get defaultPermissions;
  FilesSharingCapabilities_FilesSharing_Federation get federation;
  FilesSharingCapabilities_FilesSharing_Sharee get sharee;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FilesSharingCapabilities_FilesSharingInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FilesSharingCapabilities_FilesSharingInterfaceBuilder b) {}
}

abstract class FilesSharingCapabilities_FilesSharing
    implements
        $FilesSharingCapabilities_FilesSharingInterface,
        Built<FilesSharingCapabilities_FilesSharing, FilesSharingCapabilities_FilesSharingBuilder> {
  /// Creates a new FilesSharingCapabilities_FilesSharing object using the builder pattern.
  factory FilesSharingCapabilities_FilesSharing([void Function(FilesSharingCapabilities_FilesSharingBuilder)? b]) =
      _$FilesSharingCapabilities_FilesSharing;

  // coverage:ignore-start
  const FilesSharingCapabilities_FilesSharing._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FilesSharingCapabilities_FilesSharing.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FilesSharingCapabilities_FilesSharing.
  static Serializer<FilesSharingCapabilities_FilesSharing> get serializer =>
      _$filesSharingCapabilitiesFilesSharingSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FilesSharingCapabilities_FilesSharingBuilder b) {
    $FilesSharingCapabilities_FilesSharingInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FilesSharingCapabilities_FilesSharingBuilder b) {
    $FilesSharingCapabilities_FilesSharingInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FilesSharingCapabilitiesInterface {
  @BuiltValueField(wireName: 'files_sharing')
  FilesSharingCapabilities_FilesSharing get filesSharing;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FilesSharingCapabilitiesInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FilesSharingCapabilitiesInterfaceBuilder b) {}
}

abstract class FilesSharingCapabilities
    implements $FilesSharingCapabilitiesInterface, Built<FilesSharingCapabilities, FilesSharingCapabilitiesBuilder> {
  /// Creates a new FilesSharingCapabilities object using the builder pattern.
  factory FilesSharingCapabilities([void Function(FilesSharingCapabilitiesBuilder)? b]) = _$FilesSharingCapabilities;

  // coverage:ignore-start
  const FilesSharingCapabilities._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FilesSharingCapabilities.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FilesSharingCapabilities.
  static Serializer<FilesSharingCapabilities> get serializer => _$filesSharingCapabilitiesSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FilesSharingCapabilitiesBuilder b) {
    $FilesSharingCapabilitiesInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FilesSharingCapabilitiesBuilder b) {
    $FilesSharingCapabilitiesInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FilesTrashbinCapabilities_FilesInterface {
  bool get undelete;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FilesTrashbinCapabilities_FilesInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FilesTrashbinCapabilities_FilesInterfaceBuilder b) {}
}

abstract class FilesTrashbinCapabilities_Files
    implements
        $FilesTrashbinCapabilities_FilesInterface,
        Built<FilesTrashbinCapabilities_Files, FilesTrashbinCapabilities_FilesBuilder> {
  /// Creates a new FilesTrashbinCapabilities_Files object using the builder pattern.
  factory FilesTrashbinCapabilities_Files([void Function(FilesTrashbinCapabilities_FilesBuilder)? b]) =
      _$FilesTrashbinCapabilities_Files;

  // coverage:ignore-start
  const FilesTrashbinCapabilities_Files._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FilesTrashbinCapabilities_Files.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FilesTrashbinCapabilities_Files.
  static Serializer<FilesTrashbinCapabilities_Files> get serializer => _$filesTrashbinCapabilitiesFilesSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FilesTrashbinCapabilities_FilesBuilder b) {
    $FilesTrashbinCapabilities_FilesInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FilesTrashbinCapabilities_FilesBuilder b) {
    $FilesTrashbinCapabilities_FilesInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FilesTrashbinCapabilitiesInterface {
  FilesTrashbinCapabilities_Files get files;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FilesTrashbinCapabilitiesInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FilesTrashbinCapabilitiesInterfaceBuilder b) {}
}

abstract class FilesTrashbinCapabilities
    implements $FilesTrashbinCapabilitiesInterface, Built<FilesTrashbinCapabilities, FilesTrashbinCapabilitiesBuilder> {
  /// Creates a new FilesTrashbinCapabilities object using the builder pattern.
  factory FilesTrashbinCapabilities([void Function(FilesTrashbinCapabilitiesBuilder)? b]) = _$FilesTrashbinCapabilities;

  // coverage:ignore-start
  const FilesTrashbinCapabilities._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FilesTrashbinCapabilities.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FilesTrashbinCapabilities.
  static Serializer<FilesTrashbinCapabilities> get serializer => _$filesTrashbinCapabilitiesSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FilesTrashbinCapabilitiesBuilder b) {
    $FilesTrashbinCapabilitiesInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FilesTrashbinCapabilitiesBuilder b) {
    $FilesTrashbinCapabilitiesInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FilesVersionsCapabilities_FilesInterface {
  bool get versioning;
  @BuiltValueField(wireName: 'version_labeling')
  bool get versionLabeling;
  @BuiltValueField(wireName: 'version_deletion')
  bool get versionDeletion;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FilesVersionsCapabilities_FilesInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FilesVersionsCapabilities_FilesInterfaceBuilder b) {}
}

abstract class FilesVersionsCapabilities_Files
    implements
        $FilesVersionsCapabilities_FilesInterface,
        Built<FilesVersionsCapabilities_Files, FilesVersionsCapabilities_FilesBuilder> {
  /// Creates a new FilesVersionsCapabilities_Files object using the builder pattern.
  factory FilesVersionsCapabilities_Files([void Function(FilesVersionsCapabilities_FilesBuilder)? b]) =
      _$FilesVersionsCapabilities_Files;

  // coverage:ignore-start
  const FilesVersionsCapabilities_Files._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FilesVersionsCapabilities_Files.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FilesVersionsCapabilities_Files.
  static Serializer<FilesVersionsCapabilities_Files> get serializer => _$filesVersionsCapabilitiesFilesSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FilesVersionsCapabilities_FilesBuilder b) {
    $FilesVersionsCapabilities_FilesInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FilesVersionsCapabilities_FilesBuilder b) {
    $FilesVersionsCapabilities_FilesInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FilesVersionsCapabilitiesInterface {
  FilesVersionsCapabilities_Files get files;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FilesVersionsCapabilitiesInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FilesVersionsCapabilitiesInterfaceBuilder b) {}
}

abstract class FilesVersionsCapabilities
    implements $FilesVersionsCapabilitiesInterface, Built<FilesVersionsCapabilities, FilesVersionsCapabilitiesBuilder> {
  /// Creates a new FilesVersionsCapabilities object using the builder pattern.
  factory FilesVersionsCapabilities([void Function(FilesVersionsCapabilitiesBuilder)? b]) = _$FilesVersionsCapabilities;

  // coverage:ignore-start
  const FilesVersionsCapabilities._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FilesVersionsCapabilities.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FilesVersionsCapabilities.
  static Serializer<FilesVersionsCapabilities> get serializer => _$filesVersionsCapabilitiesSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FilesVersionsCapabilitiesBuilder b) {
    $FilesVersionsCapabilitiesInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FilesVersionsCapabilitiesBuilder b) {
    $FilesVersionsCapabilitiesInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $NotificationsCapabilities_NotificationsInterface {
  @BuiltValueField(wireName: 'ocs-endpoints')
  BuiltList<String> get ocsEndpoints;
  BuiltList<String> get push;
  @BuiltValueField(wireName: 'admin-notifications')
  BuiltList<String> get adminNotifications;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($NotificationsCapabilities_NotificationsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($NotificationsCapabilities_NotificationsInterfaceBuilder b) {}
}

abstract class NotificationsCapabilities_Notifications
    implements
        $NotificationsCapabilities_NotificationsInterface,
        Built<NotificationsCapabilities_Notifications, NotificationsCapabilities_NotificationsBuilder> {
  /// Creates a new NotificationsCapabilities_Notifications object using the builder pattern.
  factory NotificationsCapabilities_Notifications([void Function(NotificationsCapabilities_NotificationsBuilder)? b]) =
      _$NotificationsCapabilities_Notifications;

  // coverage:ignore-start
  const NotificationsCapabilities_Notifications._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory NotificationsCapabilities_Notifications.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for NotificationsCapabilities_Notifications.
  static Serializer<NotificationsCapabilities_Notifications> get serializer =>
      _$notificationsCapabilitiesNotificationsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(NotificationsCapabilities_NotificationsBuilder b) {
    $NotificationsCapabilities_NotificationsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(NotificationsCapabilities_NotificationsBuilder b) {
    $NotificationsCapabilities_NotificationsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $NotificationsCapabilitiesInterface {
  NotificationsCapabilities_Notifications get notifications;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($NotificationsCapabilitiesInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($NotificationsCapabilitiesInterfaceBuilder b) {}
}

abstract class NotificationsCapabilities
    implements $NotificationsCapabilitiesInterface, Built<NotificationsCapabilities, NotificationsCapabilitiesBuilder> {
  /// Creates a new NotificationsCapabilities object using the builder pattern.
  factory NotificationsCapabilities([void Function(NotificationsCapabilitiesBuilder)? b]) = _$NotificationsCapabilities;

  // coverage:ignore-start
  const NotificationsCapabilities._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory NotificationsCapabilities.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for NotificationsCapabilities.
  static Serializer<NotificationsCapabilities> get serializer => _$notificationsCapabilitiesSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(NotificationsCapabilitiesBuilder b) {
    $NotificationsCapabilitiesInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(NotificationsCapabilitiesBuilder b) {
    $NotificationsCapabilitiesInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ProvisioningApiCapabilities_ProvisioningApiInterface {
  String get version;
  @BuiltValueField(wireName: 'AccountPropertyScopesVersion')
  int get accountPropertyScopesVersion;
  @BuiltValueField(wireName: 'AccountPropertyScopesFederatedEnabled')
  bool get accountPropertyScopesFederatedEnabled;
  @BuiltValueField(wireName: 'AccountPropertyScopesPublishedEnabled')
  bool get accountPropertyScopesPublishedEnabled;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ProvisioningApiCapabilities_ProvisioningApiInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ProvisioningApiCapabilities_ProvisioningApiInterfaceBuilder b) {}
}

abstract class ProvisioningApiCapabilities_ProvisioningApi
    implements
        $ProvisioningApiCapabilities_ProvisioningApiInterface,
        Built<ProvisioningApiCapabilities_ProvisioningApi, ProvisioningApiCapabilities_ProvisioningApiBuilder> {
  /// Creates a new ProvisioningApiCapabilities_ProvisioningApi object using the builder pattern.
  factory ProvisioningApiCapabilities_ProvisioningApi([
    void Function(ProvisioningApiCapabilities_ProvisioningApiBuilder)? b,
  ]) = _$ProvisioningApiCapabilities_ProvisioningApi;

  // coverage:ignore-start
  const ProvisioningApiCapabilities_ProvisioningApi._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ProvisioningApiCapabilities_ProvisioningApi.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ProvisioningApiCapabilities_ProvisioningApi.
  static Serializer<ProvisioningApiCapabilities_ProvisioningApi> get serializer =>
      _$provisioningApiCapabilitiesProvisioningApiSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ProvisioningApiCapabilities_ProvisioningApiBuilder b) {
    $ProvisioningApiCapabilities_ProvisioningApiInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ProvisioningApiCapabilities_ProvisioningApiBuilder b) {
    $ProvisioningApiCapabilities_ProvisioningApiInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ProvisioningApiCapabilitiesInterface {
  @BuiltValueField(wireName: 'provisioning_api')
  ProvisioningApiCapabilities_ProvisioningApi get provisioningApi;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ProvisioningApiCapabilitiesInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ProvisioningApiCapabilitiesInterfaceBuilder b) {}
}

abstract class ProvisioningApiCapabilities
    implements
        $ProvisioningApiCapabilitiesInterface,
        Built<ProvisioningApiCapabilities, ProvisioningApiCapabilitiesBuilder> {
  /// Creates a new ProvisioningApiCapabilities object using the builder pattern.
  factory ProvisioningApiCapabilities([void Function(ProvisioningApiCapabilitiesBuilder)? b]) =
      _$ProvisioningApiCapabilities;

  // coverage:ignore-start
  const ProvisioningApiCapabilities._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ProvisioningApiCapabilities.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ProvisioningApiCapabilities.
  static Serializer<ProvisioningApiCapabilities> get serializer => _$provisioningApiCapabilitiesSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ProvisioningApiCapabilitiesBuilder b) {
    $ProvisioningApiCapabilitiesInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ProvisioningApiCapabilitiesBuilder b) {
    $ProvisioningApiCapabilitiesInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SharebymailCapabilities0_FilesSharing_Sharebymail_UploadFilesDropInterface {
  bool get enabled;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SharebymailCapabilities0_FilesSharing_Sharebymail_UploadFilesDropInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SharebymailCapabilities0_FilesSharing_Sharebymail_UploadFilesDropInterfaceBuilder b) {}
}

abstract class SharebymailCapabilities0_FilesSharing_Sharebymail_UploadFilesDrop
    implements
        $SharebymailCapabilities0_FilesSharing_Sharebymail_UploadFilesDropInterface,
        Built<SharebymailCapabilities0_FilesSharing_Sharebymail_UploadFilesDrop,
            SharebymailCapabilities0_FilesSharing_Sharebymail_UploadFilesDropBuilder> {
  /// Creates a new SharebymailCapabilities0_FilesSharing_Sharebymail_UploadFilesDrop object using the builder pattern.
  factory SharebymailCapabilities0_FilesSharing_Sharebymail_UploadFilesDrop([
    void Function(SharebymailCapabilities0_FilesSharing_Sharebymail_UploadFilesDropBuilder)? b,
  ]) = _$SharebymailCapabilities0_FilesSharing_Sharebymail_UploadFilesDrop;

  // coverage:ignore-start
  const SharebymailCapabilities0_FilesSharing_Sharebymail_UploadFilesDrop._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SharebymailCapabilities0_FilesSharing_Sharebymail_UploadFilesDrop.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SharebymailCapabilities0_FilesSharing_Sharebymail_UploadFilesDrop.
  static Serializer<SharebymailCapabilities0_FilesSharing_Sharebymail_UploadFilesDrop> get serializer =>
      _$sharebymailCapabilities0FilesSharingSharebymailUploadFilesDropSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SharebymailCapabilities0_FilesSharing_Sharebymail_UploadFilesDropBuilder b) {
    $SharebymailCapabilities0_FilesSharing_Sharebymail_UploadFilesDropInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SharebymailCapabilities0_FilesSharing_Sharebymail_UploadFilesDropBuilder b) {
    $SharebymailCapabilities0_FilesSharing_Sharebymail_UploadFilesDropInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SharebymailCapabilities0_FilesSharing_Sharebymail_PasswordInterface {
  bool get enabled;
  bool get enforced;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SharebymailCapabilities0_FilesSharing_Sharebymail_PasswordInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SharebymailCapabilities0_FilesSharing_Sharebymail_PasswordInterfaceBuilder b) {}
}

abstract class SharebymailCapabilities0_FilesSharing_Sharebymail_Password
    implements
        $SharebymailCapabilities0_FilesSharing_Sharebymail_PasswordInterface,
        Built<SharebymailCapabilities0_FilesSharing_Sharebymail_Password,
            SharebymailCapabilities0_FilesSharing_Sharebymail_PasswordBuilder> {
  /// Creates a new SharebymailCapabilities0_FilesSharing_Sharebymail_Password object using the builder pattern.
  factory SharebymailCapabilities0_FilesSharing_Sharebymail_Password([
    void Function(SharebymailCapabilities0_FilesSharing_Sharebymail_PasswordBuilder)? b,
  ]) = _$SharebymailCapabilities0_FilesSharing_Sharebymail_Password;

  // coverage:ignore-start
  const SharebymailCapabilities0_FilesSharing_Sharebymail_Password._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SharebymailCapabilities0_FilesSharing_Sharebymail_Password.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SharebymailCapabilities0_FilesSharing_Sharebymail_Password.
  static Serializer<SharebymailCapabilities0_FilesSharing_Sharebymail_Password> get serializer =>
      _$sharebymailCapabilities0FilesSharingSharebymailPasswordSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SharebymailCapabilities0_FilesSharing_Sharebymail_PasswordBuilder b) {
    $SharebymailCapabilities0_FilesSharing_Sharebymail_PasswordInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SharebymailCapabilities0_FilesSharing_Sharebymail_PasswordBuilder b) {
    $SharebymailCapabilities0_FilesSharing_Sharebymail_PasswordInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SharebymailCapabilities0_FilesSharing_Sharebymail_ExpireDateInterface {
  bool get enabled;
  bool get enforced;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SharebymailCapabilities0_FilesSharing_Sharebymail_ExpireDateInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SharebymailCapabilities0_FilesSharing_Sharebymail_ExpireDateInterfaceBuilder b) {}
}

abstract class SharebymailCapabilities0_FilesSharing_Sharebymail_ExpireDate
    implements
        $SharebymailCapabilities0_FilesSharing_Sharebymail_ExpireDateInterface,
        Built<SharebymailCapabilities0_FilesSharing_Sharebymail_ExpireDate,
            SharebymailCapabilities0_FilesSharing_Sharebymail_ExpireDateBuilder> {
  /// Creates a new SharebymailCapabilities0_FilesSharing_Sharebymail_ExpireDate object using the builder pattern.
  factory SharebymailCapabilities0_FilesSharing_Sharebymail_ExpireDate([
    void Function(SharebymailCapabilities0_FilesSharing_Sharebymail_ExpireDateBuilder)? b,
  ]) = _$SharebymailCapabilities0_FilesSharing_Sharebymail_ExpireDate;

  // coverage:ignore-start
  const SharebymailCapabilities0_FilesSharing_Sharebymail_ExpireDate._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SharebymailCapabilities0_FilesSharing_Sharebymail_ExpireDate.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SharebymailCapabilities0_FilesSharing_Sharebymail_ExpireDate.
  static Serializer<SharebymailCapabilities0_FilesSharing_Sharebymail_ExpireDate> get serializer =>
      _$sharebymailCapabilities0FilesSharingSharebymailExpireDateSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SharebymailCapabilities0_FilesSharing_Sharebymail_ExpireDateBuilder b) {
    $SharebymailCapabilities0_FilesSharing_Sharebymail_ExpireDateInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SharebymailCapabilities0_FilesSharing_Sharebymail_ExpireDateBuilder b) {
    $SharebymailCapabilities0_FilesSharing_Sharebymail_ExpireDateInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SharebymailCapabilities0_FilesSharing_SharebymailInterface {
  bool get enabled;
  @BuiltValueField(wireName: 'send_password_by_mail')
  bool get sendPasswordByMail;
  @BuiltValueField(wireName: 'upload_files_drop')
  SharebymailCapabilities0_FilesSharing_Sharebymail_UploadFilesDrop get uploadFilesDrop;
  SharebymailCapabilities0_FilesSharing_Sharebymail_Password get password;
  @BuiltValueField(wireName: 'expire_date')
  SharebymailCapabilities0_FilesSharing_Sharebymail_ExpireDate get expireDate;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SharebymailCapabilities0_FilesSharing_SharebymailInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SharebymailCapabilities0_FilesSharing_SharebymailInterfaceBuilder b) {}
}

abstract class SharebymailCapabilities0_FilesSharing_Sharebymail
    implements
        $SharebymailCapabilities0_FilesSharing_SharebymailInterface,
        Built<SharebymailCapabilities0_FilesSharing_Sharebymail,
            SharebymailCapabilities0_FilesSharing_SharebymailBuilder> {
  /// Creates a new SharebymailCapabilities0_FilesSharing_Sharebymail object using the builder pattern.
  factory SharebymailCapabilities0_FilesSharing_Sharebymail([
    void Function(SharebymailCapabilities0_FilesSharing_SharebymailBuilder)? b,
  ]) = _$SharebymailCapabilities0_FilesSharing_Sharebymail;

  // coverage:ignore-start
  const SharebymailCapabilities0_FilesSharing_Sharebymail._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SharebymailCapabilities0_FilesSharing_Sharebymail.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SharebymailCapabilities0_FilesSharing_Sharebymail.
  static Serializer<SharebymailCapabilities0_FilesSharing_Sharebymail> get serializer =>
      _$sharebymailCapabilities0FilesSharingSharebymailSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SharebymailCapabilities0_FilesSharing_SharebymailBuilder b) {
    $SharebymailCapabilities0_FilesSharing_SharebymailInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SharebymailCapabilities0_FilesSharing_SharebymailBuilder b) {
    $SharebymailCapabilities0_FilesSharing_SharebymailInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SharebymailCapabilities0_FilesSharingInterface {
  SharebymailCapabilities0_FilesSharing_Sharebymail get sharebymail;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SharebymailCapabilities0_FilesSharingInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SharebymailCapabilities0_FilesSharingInterfaceBuilder b) {}
}

abstract class SharebymailCapabilities0_FilesSharing
    implements
        $SharebymailCapabilities0_FilesSharingInterface,
        Built<SharebymailCapabilities0_FilesSharing, SharebymailCapabilities0_FilesSharingBuilder> {
  /// Creates a new SharebymailCapabilities0_FilesSharing object using the builder pattern.
  factory SharebymailCapabilities0_FilesSharing([void Function(SharebymailCapabilities0_FilesSharingBuilder)? b]) =
      _$SharebymailCapabilities0_FilesSharing;

  // coverage:ignore-start
  const SharebymailCapabilities0_FilesSharing._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SharebymailCapabilities0_FilesSharing.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SharebymailCapabilities0_FilesSharing.
  static Serializer<SharebymailCapabilities0_FilesSharing> get serializer =>
      _$sharebymailCapabilities0FilesSharingSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SharebymailCapabilities0_FilesSharingBuilder b) {
    $SharebymailCapabilities0_FilesSharingInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SharebymailCapabilities0_FilesSharingBuilder b) {
    $SharebymailCapabilities0_FilesSharingInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SharebymailCapabilities0Interface {
  @BuiltValueField(wireName: 'files_sharing')
  SharebymailCapabilities0_FilesSharing get filesSharing;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SharebymailCapabilities0InterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SharebymailCapabilities0InterfaceBuilder b) {}
}

abstract class SharebymailCapabilities0
    implements $SharebymailCapabilities0Interface, Built<SharebymailCapabilities0, SharebymailCapabilities0Builder> {
  /// Creates a new SharebymailCapabilities0 object using the builder pattern.
  factory SharebymailCapabilities0([void Function(SharebymailCapabilities0Builder)? b]) = _$SharebymailCapabilities0;

  // coverage:ignore-start
  const SharebymailCapabilities0._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SharebymailCapabilities0.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SharebymailCapabilities0.
  static Serializer<SharebymailCapabilities0> get serializer => _$sharebymailCapabilities0Serializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SharebymailCapabilities0Builder b) {
    $SharebymailCapabilities0Interface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SharebymailCapabilities0Builder b) {
    $SharebymailCapabilities0Interface._validate(b);
  }
}

typedef SharebymailCapabilities = ({
  BuiltList<Never>? builtListNever,
  SharebymailCapabilities0? sharebymailCapabilities0
});

@BuiltValue(instantiable: false)
abstract interface class $SpreedCapabilities_Config_AttachmentsInterface {
  bool get allowed;
  String? get folder;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SpreedCapabilities_Config_AttachmentsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SpreedCapabilities_Config_AttachmentsInterfaceBuilder b) {}
}

abstract class SpreedCapabilities_Config_Attachments
    implements
        $SpreedCapabilities_Config_AttachmentsInterface,
        Built<SpreedCapabilities_Config_Attachments, SpreedCapabilities_Config_AttachmentsBuilder> {
  /// Creates a new SpreedCapabilities_Config_Attachments object using the builder pattern.
  factory SpreedCapabilities_Config_Attachments([void Function(SpreedCapabilities_Config_AttachmentsBuilder)? b]) =
      _$SpreedCapabilities_Config_Attachments;

  // coverage:ignore-start
  const SpreedCapabilities_Config_Attachments._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SpreedCapabilities_Config_Attachments.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SpreedCapabilities_Config_Attachments.
  static Serializer<SpreedCapabilities_Config_Attachments> get serializer =>
      _$spreedCapabilitiesConfigAttachmentsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SpreedCapabilities_Config_AttachmentsBuilder b) {
    $SpreedCapabilities_Config_AttachmentsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SpreedCapabilities_Config_AttachmentsBuilder b) {
    $SpreedCapabilities_Config_AttachmentsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SpreedCapabilities_Config_CallInterface {
  bool get enabled;
  @BuiltValueField(wireName: 'breakout-rooms')
  bool get breakoutRooms;
  bool get recording;
  @BuiltValueField(wireName: 'recording-consent')
  int? get recordingConsent;
  @BuiltValueField(wireName: 'supported-reactions')
  BuiltList<String> get supportedReactions;
  @BuiltValueField(wireName: 'predefined-backgrounds')
  BuiltList<String> get predefinedBackgrounds;
  @BuiltValueField(wireName: 'can-upload-background')
  bool get canUploadBackground;
  @BuiltValueField(wireName: 'sip-enabled')
  bool? get sipEnabled;
  @BuiltValueField(wireName: 'sip-dialout-enabled')
  bool? get sipDialoutEnabled;
  @BuiltValueField(wireName: 'can-enable-sip')
  bool? get canEnableSip;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SpreedCapabilities_Config_CallInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SpreedCapabilities_Config_CallInterfaceBuilder b) {}
}

abstract class SpreedCapabilities_Config_Call
    implements
        $SpreedCapabilities_Config_CallInterface,
        Built<SpreedCapabilities_Config_Call, SpreedCapabilities_Config_CallBuilder> {
  /// Creates a new SpreedCapabilities_Config_Call object using the builder pattern.
  factory SpreedCapabilities_Config_Call([void Function(SpreedCapabilities_Config_CallBuilder)? b]) =
      _$SpreedCapabilities_Config_Call;

  // coverage:ignore-start
  const SpreedCapabilities_Config_Call._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SpreedCapabilities_Config_Call.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SpreedCapabilities_Config_Call.
  static Serializer<SpreedCapabilities_Config_Call> get serializer => _$spreedCapabilitiesConfigCallSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SpreedCapabilities_Config_CallBuilder b) {
    $SpreedCapabilities_Config_CallInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SpreedCapabilities_Config_CallBuilder b) {
    $SpreedCapabilities_Config_CallInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SpreedCapabilities_Config_ChatInterface {
  @BuiltValueField(wireName: 'max-length')
  int get maxLength;
  @BuiltValueField(wireName: 'read-privacy')
  int get readPrivacy;
  @BuiltValueField(wireName: 'has-translation-providers')
  bool? get hasTranslationProviders;
  @BuiltValueField(wireName: 'typing-privacy')
  int get typingPrivacy;
  BuiltList<String>? get translations;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SpreedCapabilities_Config_ChatInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SpreedCapabilities_Config_ChatInterfaceBuilder b) {}
}

abstract class SpreedCapabilities_Config_Chat
    implements
        $SpreedCapabilities_Config_ChatInterface,
        Built<SpreedCapabilities_Config_Chat, SpreedCapabilities_Config_ChatBuilder> {
  /// Creates a new SpreedCapabilities_Config_Chat object using the builder pattern.
  factory SpreedCapabilities_Config_Chat([void Function(SpreedCapabilities_Config_ChatBuilder)? b]) =
      _$SpreedCapabilities_Config_Chat;

  // coverage:ignore-start
  const SpreedCapabilities_Config_Chat._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SpreedCapabilities_Config_Chat.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SpreedCapabilities_Config_Chat.
  static Serializer<SpreedCapabilities_Config_Chat> get serializer => _$spreedCapabilitiesConfigChatSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SpreedCapabilities_Config_ChatBuilder b) {
    $SpreedCapabilities_Config_ChatInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SpreedCapabilities_Config_ChatBuilder b) {
    $SpreedCapabilities_Config_ChatInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SpreedCapabilities_Config_ConversationsInterface {
  @BuiltValueField(wireName: 'can-create')
  bool get canCreate;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SpreedCapabilities_Config_ConversationsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SpreedCapabilities_Config_ConversationsInterfaceBuilder b) {}
}

abstract class SpreedCapabilities_Config_Conversations
    implements
        $SpreedCapabilities_Config_ConversationsInterface,
        Built<SpreedCapabilities_Config_Conversations, SpreedCapabilities_Config_ConversationsBuilder> {
  /// Creates a new SpreedCapabilities_Config_Conversations object using the builder pattern.
  factory SpreedCapabilities_Config_Conversations([void Function(SpreedCapabilities_Config_ConversationsBuilder)? b]) =
      _$SpreedCapabilities_Config_Conversations;

  // coverage:ignore-start
  const SpreedCapabilities_Config_Conversations._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SpreedCapabilities_Config_Conversations.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SpreedCapabilities_Config_Conversations.
  static Serializer<SpreedCapabilities_Config_Conversations> get serializer =>
      _$spreedCapabilitiesConfigConversationsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SpreedCapabilities_Config_ConversationsBuilder b) {
    $SpreedCapabilities_Config_ConversationsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SpreedCapabilities_Config_ConversationsBuilder b) {
    $SpreedCapabilities_Config_ConversationsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SpreedCapabilities_Config_FederationInterface {
  bool get enabled;
  @BuiltValueField(wireName: 'incoming-enabled')
  bool get incomingEnabled;
  @BuiltValueField(wireName: 'outgoing-enabled')
  bool get outgoingEnabled;
  @BuiltValueField(wireName: 'only-trusted-servers')
  bool get onlyTrustedServers;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SpreedCapabilities_Config_FederationInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SpreedCapabilities_Config_FederationInterfaceBuilder b) {}
}

abstract class SpreedCapabilities_Config_Federation
    implements
        $SpreedCapabilities_Config_FederationInterface,
        Built<SpreedCapabilities_Config_Federation, SpreedCapabilities_Config_FederationBuilder> {
  /// Creates a new SpreedCapabilities_Config_Federation object using the builder pattern.
  factory SpreedCapabilities_Config_Federation([void Function(SpreedCapabilities_Config_FederationBuilder)? b]) =
      _$SpreedCapabilities_Config_Federation;

  // coverage:ignore-start
  const SpreedCapabilities_Config_Federation._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SpreedCapabilities_Config_Federation.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SpreedCapabilities_Config_Federation.
  static Serializer<SpreedCapabilities_Config_Federation> get serializer =>
      _$spreedCapabilitiesConfigFederationSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SpreedCapabilities_Config_FederationBuilder b) {
    $SpreedCapabilities_Config_FederationInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SpreedCapabilities_Config_FederationBuilder b) {
    $SpreedCapabilities_Config_FederationInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SpreedCapabilities_Config_PreviewsInterface {
  @BuiltValueField(wireName: 'max-gif-size')
  int get maxGifSize;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SpreedCapabilities_Config_PreviewsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SpreedCapabilities_Config_PreviewsInterfaceBuilder b) {}
}

abstract class SpreedCapabilities_Config_Previews
    implements
        $SpreedCapabilities_Config_PreviewsInterface,
        Built<SpreedCapabilities_Config_Previews, SpreedCapabilities_Config_PreviewsBuilder> {
  /// Creates a new SpreedCapabilities_Config_Previews object using the builder pattern.
  factory SpreedCapabilities_Config_Previews([void Function(SpreedCapabilities_Config_PreviewsBuilder)? b]) =
      _$SpreedCapabilities_Config_Previews;

  // coverage:ignore-start
  const SpreedCapabilities_Config_Previews._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SpreedCapabilities_Config_Previews.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SpreedCapabilities_Config_Previews.
  static Serializer<SpreedCapabilities_Config_Previews> get serializer => _$spreedCapabilitiesConfigPreviewsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SpreedCapabilities_Config_PreviewsBuilder b) {
    $SpreedCapabilities_Config_PreviewsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SpreedCapabilities_Config_PreviewsBuilder b) {
    $SpreedCapabilities_Config_PreviewsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SpreedCapabilities_Config_SignalingInterface {
  @BuiltValueField(wireName: 'session-ping-limit')
  int get sessionPingLimit;
  @BuiltValueField(wireName: 'hello-v2-token-key')
  String? get helloV2TokenKey;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SpreedCapabilities_Config_SignalingInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SpreedCapabilities_Config_SignalingInterfaceBuilder b) {}
}

abstract class SpreedCapabilities_Config_Signaling
    implements
        $SpreedCapabilities_Config_SignalingInterface,
        Built<SpreedCapabilities_Config_Signaling, SpreedCapabilities_Config_SignalingBuilder> {
  /// Creates a new SpreedCapabilities_Config_Signaling object using the builder pattern.
  factory SpreedCapabilities_Config_Signaling([void Function(SpreedCapabilities_Config_SignalingBuilder)? b]) =
      _$SpreedCapabilities_Config_Signaling;

  // coverage:ignore-start
  const SpreedCapabilities_Config_Signaling._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SpreedCapabilities_Config_Signaling.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SpreedCapabilities_Config_Signaling.
  static Serializer<SpreedCapabilities_Config_Signaling> get serializer =>
      _$spreedCapabilitiesConfigSignalingSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SpreedCapabilities_Config_SignalingBuilder b) {
    $SpreedCapabilities_Config_SignalingInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SpreedCapabilities_Config_SignalingBuilder b) {
    $SpreedCapabilities_Config_SignalingInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SpreedCapabilities_ConfigInterface {
  SpreedCapabilities_Config_Attachments get attachments;
  SpreedCapabilities_Config_Call get call;
  SpreedCapabilities_Config_Chat get chat;
  SpreedCapabilities_Config_Conversations get conversations;
  SpreedCapabilities_Config_Federation? get federation;
  SpreedCapabilities_Config_Previews get previews;
  SpreedCapabilities_Config_Signaling get signaling;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SpreedCapabilities_ConfigInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SpreedCapabilities_ConfigInterfaceBuilder b) {}
}

abstract class SpreedCapabilities_Config
    implements $SpreedCapabilities_ConfigInterface, Built<SpreedCapabilities_Config, SpreedCapabilities_ConfigBuilder> {
  /// Creates a new SpreedCapabilities_Config object using the builder pattern.
  factory SpreedCapabilities_Config([void Function(SpreedCapabilities_ConfigBuilder)? b]) = _$SpreedCapabilities_Config;

  // coverage:ignore-start
  const SpreedCapabilities_Config._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SpreedCapabilities_Config.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SpreedCapabilities_Config.
  static Serializer<SpreedCapabilities_Config> get serializer => _$spreedCapabilitiesConfigSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SpreedCapabilities_ConfigBuilder b) {
    $SpreedCapabilities_ConfigInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SpreedCapabilities_ConfigBuilder b) {
    $SpreedCapabilities_ConfigInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SpreedCapabilitiesInterface {
  BuiltList<String> get features;
  SpreedCapabilities_Config get config;
  String get version;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SpreedCapabilitiesInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SpreedCapabilitiesInterfaceBuilder b) {}
}

abstract class SpreedCapabilities
    implements $SpreedCapabilitiesInterface, Built<SpreedCapabilities, SpreedCapabilitiesBuilder> {
  /// Creates a new SpreedCapabilities object using the builder pattern.
  factory SpreedCapabilities([void Function(SpreedCapabilitiesBuilder)? b]) = _$SpreedCapabilities;

  // coverage:ignore-start
  const SpreedCapabilities._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SpreedCapabilities.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SpreedCapabilities.
  static Serializer<SpreedCapabilities> get serializer => _$spreedCapabilitiesSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SpreedCapabilitiesBuilder b) {
    $SpreedCapabilitiesInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SpreedCapabilitiesBuilder b) {
    $SpreedCapabilitiesInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SpreedPublicCapabilities0Interface {
  SpreedCapabilities get spreed;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SpreedPublicCapabilities0InterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SpreedPublicCapabilities0InterfaceBuilder b) {}
}

abstract class SpreedPublicCapabilities0
    implements $SpreedPublicCapabilities0Interface, Built<SpreedPublicCapabilities0, SpreedPublicCapabilities0Builder> {
  /// Creates a new SpreedPublicCapabilities0 object using the builder pattern.
  factory SpreedPublicCapabilities0([void Function(SpreedPublicCapabilities0Builder)? b]) = _$SpreedPublicCapabilities0;

  // coverage:ignore-start
  const SpreedPublicCapabilities0._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SpreedPublicCapabilities0.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SpreedPublicCapabilities0.
  static Serializer<SpreedPublicCapabilities0> get serializer => _$spreedPublicCapabilities0Serializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SpreedPublicCapabilities0Builder b) {
    $SpreedPublicCapabilities0Interface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SpreedPublicCapabilities0Builder b) {
    $SpreedPublicCapabilities0Interface._validate(b);
  }
}

typedef SpreedPublicCapabilities = ({
  BuiltList<Never>? builtListNever,
  SpreedPublicCapabilities0? spreedPublicCapabilities0
});

class SystemtagsCapabilities_Systemtags_Enabled extends EnumClass {
  const SystemtagsCapabilities_Systemtags_Enabled._(super.name);

  /// `true`
  @BuiltValueEnumConst(wireName: 'true')
  static const SystemtagsCapabilities_Systemtags_Enabled $true = _$systemtagsCapabilitiesSystemtagsEnabled$true;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<SystemtagsCapabilities_Systemtags_Enabled> get values =>
      _$systemtagsCapabilitiesSystemtagsEnabledValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static SystemtagsCapabilities_Systemtags_Enabled valueOf(String name) =>
      _$valueOfSystemtagsCapabilities_Systemtags_Enabled(name);

  /// Returns the serialized value of this enum value.
  bool get value => _$jsonSerializers.serializeWith(serializer, this)! as bool;

  /// Serializer for SystemtagsCapabilities_Systemtags_Enabled.
  @BuiltValueSerializer(custom: true)
  static Serializer<SystemtagsCapabilities_Systemtags_Enabled> get serializer =>
      const _$SystemtagsCapabilities_Systemtags_EnabledSerializer();
}

class _$SystemtagsCapabilities_Systemtags_EnabledSerializer
    implements PrimitiveSerializer<SystemtagsCapabilities_Systemtags_Enabled> {
  const _$SystemtagsCapabilities_Systemtags_EnabledSerializer();

  static const Map<SystemtagsCapabilities_Systemtags_Enabled, Object> _toWire =
      <SystemtagsCapabilities_Systemtags_Enabled, Object>{
    SystemtagsCapabilities_Systemtags_Enabled.$true: true,
  };

  static const Map<Object, SystemtagsCapabilities_Systemtags_Enabled> _fromWire =
      <Object, SystemtagsCapabilities_Systemtags_Enabled>{
    true: SystemtagsCapabilities_Systemtags_Enabled.$true,
  };

  @override
  Iterable<Type> get types => const [SystemtagsCapabilities_Systemtags_Enabled];

  @override
  String get wireName => 'SystemtagsCapabilities_Systemtags_Enabled';

  @override
  Object serialize(
    Serializers serializers,
    SystemtagsCapabilities_Systemtags_Enabled object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  SystemtagsCapabilities_Systemtags_Enabled deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $SystemtagsCapabilities_SystemtagsInterface {
  SystemtagsCapabilities_Systemtags_Enabled get enabled;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SystemtagsCapabilities_SystemtagsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SystemtagsCapabilities_SystemtagsInterfaceBuilder b) {}
}

abstract class SystemtagsCapabilities_Systemtags
    implements
        $SystemtagsCapabilities_SystemtagsInterface,
        Built<SystemtagsCapabilities_Systemtags, SystemtagsCapabilities_SystemtagsBuilder> {
  /// Creates a new SystemtagsCapabilities_Systemtags object using the builder pattern.
  factory SystemtagsCapabilities_Systemtags([void Function(SystemtagsCapabilities_SystemtagsBuilder)? b]) =
      _$SystemtagsCapabilities_Systemtags;

  // coverage:ignore-start
  const SystemtagsCapabilities_Systemtags._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SystemtagsCapabilities_Systemtags.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SystemtagsCapabilities_Systemtags.
  static Serializer<SystemtagsCapabilities_Systemtags> get serializer => _$systemtagsCapabilitiesSystemtagsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SystemtagsCapabilities_SystemtagsBuilder b) {
    $SystemtagsCapabilities_SystemtagsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SystemtagsCapabilities_SystemtagsBuilder b) {
    $SystemtagsCapabilities_SystemtagsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SystemtagsCapabilitiesInterface {
  SystemtagsCapabilities_Systemtags get systemtags;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SystemtagsCapabilitiesInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SystemtagsCapabilitiesInterfaceBuilder b) {}
}

abstract class SystemtagsCapabilities
    implements $SystemtagsCapabilitiesInterface, Built<SystemtagsCapabilities, SystemtagsCapabilitiesBuilder> {
  /// Creates a new SystemtagsCapabilities object using the builder pattern.
  factory SystemtagsCapabilities([void Function(SystemtagsCapabilitiesBuilder)? b]) = _$SystemtagsCapabilities;

  // coverage:ignore-start
  const SystemtagsCapabilities._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SystemtagsCapabilities.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SystemtagsCapabilities.
  static Serializer<SystemtagsCapabilities> get serializer => _$systemtagsCapabilitiesSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SystemtagsCapabilitiesBuilder b) {
    $SystemtagsCapabilitiesInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SystemtagsCapabilitiesBuilder b) {
    $SystemtagsCapabilitiesInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ThemingPublicCapabilities_ThemingInterface {
  String get name;
  String get url;
  String get slogan;
  String get color;
  @BuiltValueField(wireName: 'color-text')
  String get colorText;
  @BuiltValueField(wireName: 'color-element')
  String get colorElement;
  @BuiltValueField(wireName: 'color-element-bright')
  String get colorElementBright;
  @BuiltValueField(wireName: 'color-element-dark')
  String get colorElementDark;
  String get logo;
  String get background;
  @BuiltValueField(wireName: 'background-plain')
  bool get backgroundPlain;
  @BuiltValueField(wireName: 'background-default')
  bool get backgroundDefault;
  String get logoheader;
  String get favicon;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ThemingPublicCapabilities_ThemingInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ThemingPublicCapabilities_ThemingInterfaceBuilder b) {}
}

abstract class ThemingPublicCapabilities_Theming
    implements
        $ThemingPublicCapabilities_ThemingInterface,
        Built<ThemingPublicCapabilities_Theming, ThemingPublicCapabilities_ThemingBuilder> {
  /// Creates a new ThemingPublicCapabilities_Theming object using the builder pattern.
  factory ThemingPublicCapabilities_Theming([void Function(ThemingPublicCapabilities_ThemingBuilder)? b]) =
      _$ThemingPublicCapabilities_Theming;

  // coverage:ignore-start
  const ThemingPublicCapabilities_Theming._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ThemingPublicCapabilities_Theming.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ThemingPublicCapabilities_Theming.
  static Serializer<ThemingPublicCapabilities_Theming> get serializer => _$themingPublicCapabilitiesThemingSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ThemingPublicCapabilities_ThemingBuilder b) {
    $ThemingPublicCapabilities_ThemingInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ThemingPublicCapabilities_ThemingBuilder b) {
    $ThemingPublicCapabilities_ThemingInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ThemingPublicCapabilitiesInterface {
  ThemingPublicCapabilities_Theming get theming;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ThemingPublicCapabilitiesInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ThemingPublicCapabilitiesInterfaceBuilder b) {}
}

abstract class ThemingPublicCapabilities
    implements $ThemingPublicCapabilitiesInterface, Built<ThemingPublicCapabilities, ThemingPublicCapabilitiesBuilder> {
  /// Creates a new ThemingPublicCapabilities object using the builder pattern.
  factory ThemingPublicCapabilities([void Function(ThemingPublicCapabilitiesBuilder)? b]) = _$ThemingPublicCapabilities;

  // coverage:ignore-start
  const ThemingPublicCapabilities._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ThemingPublicCapabilities.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ThemingPublicCapabilities.
  static Serializer<ThemingPublicCapabilities> get serializer => _$themingPublicCapabilitiesSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ThemingPublicCapabilitiesBuilder b) {
    $ThemingPublicCapabilitiesInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ThemingPublicCapabilitiesBuilder b) {
    $ThemingPublicCapabilitiesInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $UserStatusCapabilities_UserStatusInterface {
  bool get enabled;
  bool get restore;
  @BuiltValueField(wireName: 'supports_emoji')
  bool get supportsEmoji;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($UserStatusCapabilities_UserStatusInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($UserStatusCapabilities_UserStatusInterfaceBuilder b) {}
}

abstract class UserStatusCapabilities_UserStatus
    implements
        $UserStatusCapabilities_UserStatusInterface,
        Built<UserStatusCapabilities_UserStatus, UserStatusCapabilities_UserStatusBuilder> {
  /// Creates a new UserStatusCapabilities_UserStatus object using the builder pattern.
  factory UserStatusCapabilities_UserStatus([void Function(UserStatusCapabilities_UserStatusBuilder)? b]) =
      _$UserStatusCapabilities_UserStatus;

  // coverage:ignore-start
  const UserStatusCapabilities_UserStatus._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory UserStatusCapabilities_UserStatus.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for UserStatusCapabilities_UserStatus.
  static Serializer<UserStatusCapabilities_UserStatus> get serializer => _$userStatusCapabilitiesUserStatusSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(UserStatusCapabilities_UserStatusBuilder b) {
    $UserStatusCapabilities_UserStatusInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(UserStatusCapabilities_UserStatusBuilder b) {
    $UserStatusCapabilities_UserStatusInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $UserStatusCapabilitiesInterface {
  @BuiltValueField(wireName: 'user_status')
  UserStatusCapabilities_UserStatus get userStatus;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($UserStatusCapabilitiesInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($UserStatusCapabilitiesInterfaceBuilder b) {}
}

abstract class UserStatusCapabilities
    implements $UserStatusCapabilitiesInterface, Built<UserStatusCapabilities, UserStatusCapabilitiesBuilder> {
  /// Creates a new UserStatusCapabilities object using the builder pattern.
  factory UserStatusCapabilities([void Function(UserStatusCapabilitiesBuilder)? b]) = _$UserStatusCapabilities;

  // coverage:ignore-start
  const UserStatusCapabilities._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory UserStatusCapabilities.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for UserStatusCapabilities.
  static Serializer<UserStatusCapabilities> get serializer => _$userStatusCapabilitiesSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(UserStatusCapabilitiesBuilder b) {
    $UserStatusCapabilitiesInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(UserStatusCapabilitiesBuilder b) {
    $UserStatusCapabilitiesInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $WeatherStatusCapabilities_WeatherStatusInterface {
  bool get enabled;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($WeatherStatusCapabilities_WeatherStatusInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($WeatherStatusCapabilities_WeatherStatusInterfaceBuilder b) {}
}

abstract class WeatherStatusCapabilities_WeatherStatus
    implements
        $WeatherStatusCapabilities_WeatherStatusInterface,
        Built<WeatherStatusCapabilities_WeatherStatus, WeatherStatusCapabilities_WeatherStatusBuilder> {
  /// Creates a new WeatherStatusCapabilities_WeatherStatus object using the builder pattern.
  factory WeatherStatusCapabilities_WeatherStatus([void Function(WeatherStatusCapabilities_WeatherStatusBuilder)? b]) =
      _$WeatherStatusCapabilities_WeatherStatus;

  // coverage:ignore-start
  const WeatherStatusCapabilities_WeatherStatus._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory WeatherStatusCapabilities_WeatherStatus.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for WeatherStatusCapabilities_WeatherStatus.
  static Serializer<WeatherStatusCapabilities_WeatherStatus> get serializer =>
      _$weatherStatusCapabilitiesWeatherStatusSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(WeatherStatusCapabilities_WeatherStatusBuilder b) {
    $WeatherStatusCapabilities_WeatherStatusInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(WeatherStatusCapabilities_WeatherStatusBuilder b) {
    $WeatherStatusCapabilities_WeatherStatusInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $WeatherStatusCapabilitiesInterface {
  @BuiltValueField(wireName: 'weather_status')
  WeatherStatusCapabilities_WeatherStatus get weatherStatus;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($WeatherStatusCapabilitiesInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($WeatherStatusCapabilitiesInterfaceBuilder b) {}
}

abstract class WeatherStatusCapabilities
    implements $WeatherStatusCapabilitiesInterface, Built<WeatherStatusCapabilities, WeatherStatusCapabilitiesBuilder> {
  /// Creates a new WeatherStatusCapabilities object using the builder pattern.
  factory WeatherStatusCapabilities([void Function(WeatherStatusCapabilitiesBuilder)? b]) = _$WeatherStatusCapabilities;

  // coverage:ignore-start
  const WeatherStatusCapabilities._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory WeatherStatusCapabilities.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for WeatherStatusCapabilities.
  static Serializer<WeatherStatusCapabilities> get serializer => _$weatherStatusCapabilitiesSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(WeatherStatusCapabilitiesBuilder b) {
    $WeatherStatusCapabilitiesInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(WeatherStatusCapabilitiesBuilder b) {
    $WeatherStatusCapabilitiesInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $NotesCapabilities_NotesInterface {
  @BuiltValueField(wireName: 'api_version')
  BuiltList<String>? get apiVersion;
  String? get version;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($NotesCapabilities_NotesInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($NotesCapabilities_NotesInterfaceBuilder b) {}
}

abstract class NotesCapabilities_Notes
    implements $NotesCapabilities_NotesInterface, Built<NotesCapabilities_Notes, NotesCapabilities_NotesBuilder> {
  /// Creates a new NotesCapabilities_Notes object using the builder pattern.
  factory NotesCapabilities_Notes([void Function(NotesCapabilities_NotesBuilder)? b]) = _$NotesCapabilities_Notes;

  // coverage:ignore-start
  const NotesCapabilities_Notes._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory NotesCapabilities_Notes.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for NotesCapabilities_Notes.
  static Serializer<NotesCapabilities_Notes> get serializer => _$notesCapabilitiesNotesSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(NotesCapabilities_NotesBuilder b) {
    $NotesCapabilities_NotesInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(NotesCapabilities_NotesBuilder b) {
    $NotesCapabilities_NotesInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $NotesCapabilitiesInterface {
  NotesCapabilities_Notes get notes;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($NotesCapabilitiesInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($NotesCapabilitiesInterfaceBuilder b) {}
}

abstract class NotesCapabilities
    implements $NotesCapabilitiesInterface, Built<NotesCapabilities, NotesCapabilitiesBuilder> {
  /// Creates a new NotesCapabilities object using the builder pattern.
  factory NotesCapabilities([void Function(NotesCapabilitiesBuilder)? b]) = _$NotesCapabilities;

  // coverage:ignore-start
  const NotesCapabilities._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory NotesCapabilities.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for NotesCapabilities.
  static Serializer<NotesCapabilities> get serializer => _$notesCapabilitiesSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(NotesCapabilitiesBuilder b) {
    $NotesCapabilitiesInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(NotesCapabilitiesBuilder b) {
    $NotesCapabilitiesInterface._validate(b);
  }
}

typedef OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_Capabilities = ({
  CommentsCapabilities? commentsCapabilities,
  CoreCapabilities? coreCapabilities,
  CorePublicCapabilities? corePublicCapabilities,
  DavCapabilities? davCapabilities,
  DropAccountCapabilities? dropAccountCapabilities,
  FilesCapabilities? filesCapabilities,
  FilesSharingCapabilities? filesSharingCapabilities,
  FilesTrashbinCapabilities? filesTrashbinCapabilities,
  FilesVersionsCapabilities? filesVersionsCapabilities,
  NotesCapabilities? notesCapabilities,
  NotificationsCapabilities? notificationsCapabilities,
  ProvisioningApiCapabilities? provisioningApiCapabilities,
  SharebymailCapabilities? sharebymailCapabilities,
  SpreedCapabilities? spreedCapabilities,
  SpreedPublicCapabilities? spreedPublicCapabilities,
  SystemtagsCapabilities? systemtagsCapabilities,
  ThemingPublicCapabilities? themingPublicCapabilities,
  UserStatusCapabilities? userStatusCapabilities,
  WeatherStatusCapabilities? weatherStatusCapabilities
});

@BuiltValue(instantiable: false)
abstract interface class $OcsGetCapabilitiesResponseApplicationJson_Ocs_DataInterface {
  OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_Version get version;
  OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_Capabilities get capabilities;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($OcsGetCapabilitiesResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($OcsGetCapabilitiesResponseApplicationJson_Ocs_DataInterfaceBuilder b) {
    b.capabilities?.validateAnyOf();
  }
}

abstract class OcsGetCapabilitiesResponseApplicationJson_Ocs_Data
    implements
        $OcsGetCapabilitiesResponseApplicationJson_Ocs_DataInterface,
        Built<OcsGetCapabilitiesResponseApplicationJson_Ocs_Data,
            OcsGetCapabilitiesResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new OcsGetCapabilitiesResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory OcsGetCapabilitiesResponseApplicationJson_Ocs_Data([
    void Function(OcsGetCapabilitiesResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$OcsGetCapabilitiesResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const OcsGetCapabilitiesResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory OcsGetCapabilitiesResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for OcsGetCapabilitiesResponseApplicationJson_Ocs_Data.
  static Serializer<OcsGetCapabilitiesResponseApplicationJson_Ocs_Data> get serializer =>
      _$ocsGetCapabilitiesResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(OcsGetCapabilitiesResponseApplicationJson_Ocs_DataBuilder b) {
    $OcsGetCapabilitiesResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(OcsGetCapabilitiesResponseApplicationJson_Ocs_DataBuilder b) {
    $OcsGetCapabilitiesResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $OcsGetCapabilitiesResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  OcsGetCapabilitiesResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($OcsGetCapabilitiesResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($OcsGetCapabilitiesResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class OcsGetCapabilitiesResponseApplicationJson_Ocs
    implements
        $OcsGetCapabilitiesResponseApplicationJson_OcsInterface,
        Built<OcsGetCapabilitiesResponseApplicationJson_Ocs, OcsGetCapabilitiesResponseApplicationJson_OcsBuilder> {
  /// Creates a new OcsGetCapabilitiesResponseApplicationJson_Ocs object using the builder pattern.
  factory OcsGetCapabilitiesResponseApplicationJson_Ocs([
    void Function(OcsGetCapabilitiesResponseApplicationJson_OcsBuilder)? b,
  ]) = _$OcsGetCapabilitiesResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const OcsGetCapabilitiesResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory OcsGetCapabilitiesResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for OcsGetCapabilitiesResponseApplicationJson_Ocs.
  static Serializer<OcsGetCapabilitiesResponseApplicationJson_Ocs> get serializer =>
      _$ocsGetCapabilitiesResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(OcsGetCapabilitiesResponseApplicationJson_OcsBuilder b) {
    $OcsGetCapabilitiesResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(OcsGetCapabilitiesResponseApplicationJson_OcsBuilder b) {
    $OcsGetCapabilitiesResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $OcsGetCapabilitiesResponseApplicationJsonInterface {
  OcsGetCapabilitiesResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($OcsGetCapabilitiesResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($OcsGetCapabilitiesResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class OcsGetCapabilitiesResponseApplicationJson
    implements
        $OcsGetCapabilitiesResponseApplicationJsonInterface,
        Built<OcsGetCapabilitiesResponseApplicationJson, OcsGetCapabilitiesResponseApplicationJsonBuilder> {
  /// Creates a new OcsGetCapabilitiesResponseApplicationJson object using the builder pattern.
  factory OcsGetCapabilitiesResponseApplicationJson([
    void Function(OcsGetCapabilitiesResponseApplicationJsonBuilder)? b,
  ]) = _$OcsGetCapabilitiesResponseApplicationJson;

  // coverage:ignore-start
  const OcsGetCapabilitiesResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory OcsGetCapabilitiesResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for OcsGetCapabilitiesResponseApplicationJson.
  static Serializer<OcsGetCapabilitiesResponseApplicationJson> get serializer =>
      _$ocsGetCapabilitiesResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(OcsGetCapabilitiesResponseApplicationJsonBuilder b) {
    $OcsGetCapabilitiesResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(OcsGetCapabilitiesResponseApplicationJsonBuilder b) {
    $OcsGetCapabilitiesResponseApplicationJsonInterface._validate(b);
  }
}

class PreviewGetPreviewA extends EnumClass {
  const PreviewGetPreviewA._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const PreviewGetPreviewA $0 = _$previewGetPreviewA$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const PreviewGetPreviewA $1 = _$previewGetPreviewA$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<PreviewGetPreviewA> get values => _$previewGetPreviewAValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static PreviewGetPreviewA valueOf(String name) => _$valueOfPreviewGetPreviewA(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for PreviewGetPreviewA.
  @BuiltValueSerializer(custom: true)
  static Serializer<PreviewGetPreviewA> get serializer => const _$PreviewGetPreviewASerializer();
}

class _$PreviewGetPreviewASerializer implements PrimitiveSerializer<PreviewGetPreviewA> {
  const _$PreviewGetPreviewASerializer();

  static const Map<PreviewGetPreviewA, Object> _toWire = <PreviewGetPreviewA, Object>{
    PreviewGetPreviewA.$0: 0,
    PreviewGetPreviewA.$1: 1,
  };

  static const Map<Object, PreviewGetPreviewA> _fromWire = <Object, PreviewGetPreviewA>{
    0: PreviewGetPreviewA.$0,
    1: PreviewGetPreviewA.$1,
  };

  @override
  Iterable<Type> get types => const [PreviewGetPreviewA];

  @override
  String get wireName => 'PreviewGetPreviewA';

  @override
  Object serialize(
    Serializers serializers,
    PreviewGetPreviewA object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  PreviewGetPreviewA deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class PreviewGetPreviewForceIcon extends EnumClass {
  const PreviewGetPreviewForceIcon._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const PreviewGetPreviewForceIcon $0 = _$previewGetPreviewForceIcon$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const PreviewGetPreviewForceIcon $1 = _$previewGetPreviewForceIcon$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<PreviewGetPreviewForceIcon> get values => _$previewGetPreviewForceIconValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static PreviewGetPreviewForceIcon valueOf(String name) => _$valueOfPreviewGetPreviewForceIcon(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for PreviewGetPreviewForceIcon.
  @BuiltValueSerializer(custom: true)
  static Serializer<PreviewGetPreviewForceIcon> get serializer => const _$PreviewGetPreviewForceIconSerializer();
}

class _$PreviewGetPreviewForceIconSerializer implements PrimitiveSerializer<PreviewGetPreviewForceIcon> {
  const _$PreviewGetPreviewForceIconSerializer();

  static const Map<PreviewGetPreviewForceIcon, Object> _toWire = <PreviewGetPreviewForceIcon, Object>{
    PreviewGetPreviewForceIcon.$0: 0,
    PreviewGetPreviewForceIcon.$1: 1,
  };

  static const Map<Object, PreviewGetPreviewForceIcon> _fromWire = <Object, PreviewGetPreviewForceIcon>{
    0: PreviewGetPreviewForceIcon.$0,
    1: PreviewGetPreviewForceIcon.$1,
  };

  @override
  Iterable<Type> get types => const [PreviewGetPreviewForceIcon];

  @override
  String get wireName => 'PreviewGetPreviewForceIcon';

  @override
  Object serialize(
    Serializers serializers,
    PreviewGetPreviewForceIcon object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  PreviewGetPreviewForceIcon deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class PreviewGetPreviewMimeFallback extends EnumClass {
  const PreviewGetPreviewMimeFallback._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const PreviewGetPreviewMimeFallback $0 = _$previewGetPreviewMimeFallback$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const PreviewGetPreviewMimeFallback $1 = _$previewGetPreviewMimeFallback$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<PreviewGetPreviewMimeFallback> get values => _$previewGetPreviewMimeFallbackValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static PreviewGetPreviewMimeFallback valueOf(String name) => _$valueOfPreviewGetPreviewMimeFallback(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for PreviewGetPreviewMimeFallback.
  @BuiltValueSerializer(custom: true)
  static Serializer<PreviewGetPreviewMimeFallback> get serializer => const _$PreviewGetPreviewMimeFallbackSerializer();
}

class _$PreviewGetPreviewMimeFallbackSerializer implements PrimitiveSerializer<PreviewGetPreviewMimeFallback> {
  const _$PreviewGetPreviewMimeFallbackSerializer();

  static const Map<PreviewGetPreviewMimeFallback, Object> _toWire = <PreviewGetPreviewMimeFallback, Object>{
    PreviewGetPreviewMimeFallback.$0: 0,
    PreviewGetPreviewMimeFallback.$1: 1,
  };

  static const Map<Object, PreviewGetPreviewMimeFallback> _fromWire = <Object, PreviewGetPreviewMimeFallback>{
    0: PreviewGetPreviewMimeFallback.$0,
    1: PreviewGetPreviewMimeFallback.$1,
  };

  @override
  Iterable<Type> get types => const [PreviewGetPreviewMimeFallback];

  @override
  String get wireName => 'PreviewGetPreviewMimeFallback';

  @override
  Object serialize(
    Serializers serializers,
    PreviewGetPreviewMimeFallback object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  PreviewGetPreviewMimeFallback deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class PreviewGetPreviewByFileIdA extends EnumClass {
  const PreviewGetPreviewByFileIdA._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const PreviewGetPreviewByFileIdA $0 = _$previewGetPreviewByFileIdA$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const PreviewGetPreviewByFileIdA $1 = _$previewGetPreviewByFileIdA$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<PreviewGetPreviewByFileIdA> get values => _$previewGetPreviewByFileIdAValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static PreviewGetPreviewByFileIdA valueOf(String name) => _$valueOfPreviewGetPreviewByFileIdA(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for PreviewGetPreviewByFileIdA.
  @BuiltValueSerializer(custom: true)
  static Serializer<PreviewGetPreviewByFileIdA> get serializer => const _$PreviewGetPreviewByFileIdASerializer();
}

class _$PreviewGetPreviewByFileIdASerializer implements PrimitiveSerializer<PreviewGetPreviewByFileIdA> {
  const _$PreviewGetPreviewByFileIdASerializer();

  static const Map<PreviewGetPreviewByFileIdA, Object> _toWire = <PreviewGetPreviewByFileIdA, Object>{
    PreviewGetPreviewByFileIdA.$0: 0,
    PreviewGetPreviewByFileIdA.$1: 1,
  };

  static const Map<Object, PreviewGetPreviewByFileIdA> _fromWire = <Object, PreviewGetPreviewByFileIdA>{
    0: PreviewGetPreviewByFileIdA.$0,
    1: PreviewGetPreviewByFileIdA.$1,
  };

  @override
  Iterable<Type> get types => const [PreviewGetPreviewByFileIdA];

  @override
  String get wireName => 'PreviewGetPreviewByFileIdA';

  @override
  Object serialize(
    Serializers serializers,
    PreviewGetPreviewByFileIdA object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  PreviewGetPreviewByFileIdA deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class PreviewGetPreviewByFileIdForceIcon extends EnumClass {
  const PreviewGetPreviewByFileIdForceIcon._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const PreviewGetPreviewByFileIdForceIcon $0 = _$previewGetPreviewByFileIdForceIcon$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const PreviewGetPreviewByFileIdForceIcon $1 = _$previewGetPreviewByFileIdForceIcon$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<PreviewGetPreviewByFileIdForceIcon> get values => _$previewGetPreviewByFileIdForceIconValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static PreviewGetPreviewByFileIdForceIcon valueOf(String name) => _$valueOfPreviewGetPreviewByFileIdForceIcon(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for PreviewGetPreviewByFileIdForceIcon.
  @BuiltValueSerializer(custom: true)
  static Serializer<PreviewGetPreviewByFileIdForceIcon> get serializer =>
      const _$PreviewGetPreviewByFileIdForceIconSerializer();
}

class _$PreviewGetPreviewByFileIdForceIconSerializer
    implements PrimitiveSerializer<PreviewGetPreviewByFileIdForceIcon> {
  const _$PreviewGetPreviewByFileIdForceIconSerializer();

  static const Map<PreviewGetPreviewByFileIdForceIcon, Object> _toWire = <PreviewGetPreviewByFileIdForceIcon, Object>{
    PreviewGetPreviewByFileIdForceIcon.$0: 0,
    PreviewGetPreviewByFileIdForceIcon.$1: 1,
  };

  static const Map<Object, PreviewGetPreviewByFileIdForceIcon> _fromWire = <Object, PreviewGetPreviewByFileIdForceIcon>{
    0: PreviewGetPreviewByFileIdForceIcon.$0,
    1: PreviewGetPreviewByFileIdForceIcon.$1,
  };

  @override
  Iterable<Type> get types => const [PreviewGetPreviewByFileIdForceIcon];

  @override
  String get wireName => 'PreviewGetPreviewByFileIdForceIcon';

  @override
  Object serialize(
    Serializers serializers,
    PreviewGetPreviewByFileIdForceIcon object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  PreviewGetPreviewByFileIdForceIcon deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class PreviewGetPreviewByFileIdMimeFallback extends EnumClass {
  const PreviewGetPreviewByFileIdMimeFallback._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const PreviewGetPreviewByFileIdMimeFallback $0 = _$previewGetPreviewByFileIdMimeFallback$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const PreviewGetPreviewByFileIdMimeFallback $1 = _$previewGetPreviewByFileIdMimeFallback$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<PreviewGetPreviewByFileIdMimeFallback> get values => _$previewGetPreviewByFileIdMimeFallbackValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static PreviewGetPreviewByFileIdMimeFallback valueOf(String name) =>
      _$valueOfPreviewGetPreviewByFileIdMimeFallback(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for PreviewGetPreviewByFileIdMimeFallback.
  @BuiltValueSerializer(custom: true)
  static Serializer<PreviewGetPreviewByFileIdMimeFallback> get serializer =>
      const _$PreviewGetPreviewByFileIdMimeFallbackSerializer();
}

class _$PreviewGetPreviewByFileIdMimeFallbackSerializer
    implements PrimitiveSerializer<PreviewGetPreviewByFileIdMimeFallback> {
  const _$PreviewGetPreviewByFileIdMimeFallbackSerializer();

  static const Map<PreviewGetPreviewByFileIdMimeFallback, Object> _toWire =
      <PreviewGetPreviewByFileIdMimeFallback, Object>{
    PreviewGetPreviewByFileIdMimeFallback.$0: 0,
    PreviewGetPreviewByFileIdMimeFallback.$1: 1,
  };

  static const Map<Object, PreviewGetPreviewByFileIdMimeFallback> _fromWire =
      <Object, PreviewGetPreviewByFileIdMimeFallback>{
    0: PreviewGetPreviewByFileIdMimeFallback.$0,
    1: PreviewGetPreviewByFileIdMimeFallback.$1,
  };

  @override
  Iterable<Type> get types => const [PreviewGetPreviewByFileIdMimeFallback];

  @override
  String get wireName => 'PreviewGetPreviewByFileIdMimeFallback';

  @override
  Object serialize(
    Serializers serializers,
    PreviewGetPreviewByFileIdMimeFallback object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  PreviewGetPreviewByFileIdMimeFallback deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ProfileApiSetVisibilityResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ProfileApiSetVisibilityResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ProfileApiSetVisibilityResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class ProfileApiSetVisibilityResponseApplicationJson_Ocs
    implements
        $ProfileApiSetVisibilityResponseApplicationJson_OcsInterface,
        Built<ProfileApiSetVisibilityResponseApplicationJson_Ocs,
            ProfileApiSetVisibilityResponseApplicationJson_OcsBuilder> {
  /// Creates a new ProfileApiSetVisibilityResponseApplicationJson_Ocs object using the builder pattern.
  factory ProfileApiSetVisibilityResponseApplicationJson_Ocs([
    void Function(ProfileApiSetVisibilityResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ProfileApiSetVisibilityResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ProfileApiSetVisibilityResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ProfileApiSetVisibilityResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ProfileApiSetVisibilityResponseApplicationJson_Ocs.
  static Serializer<ProfileApiSetVisibilityResponseApplicationJson_Ocs> get serializer =>
      _$profileApiSetVisibilityResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ProfileApiSetVisibilityResponseApplicationJson_OcsBuilder b) {
    $ProfileApiSetVisibilityResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ProfileApiSetVisibilityResponseApplicationJson_OcsBuilder b) {
    $ProfileApiSetVisibilityResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ProfileApiSetVisibilityResponseApplicationJsonInterface {
  ProfileApiSetVisibilityResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ProfileApiSetVisibilityResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ProfileApiSetVisibilityResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class ProfileApiSetVisibilityResponseApplicationJson
    implements
        $ProfileApiSetVisibilityResponseApplicationJsonInterface,
        Built<ProfileApiSetVisibilityResponseApplicationJson, ProfileApiSetVisibilityResponseApplicationJsonBuilder> {
  /// Creates a new ProfileApiSetVisibilityResponseApplicationJson object using the builder pattern.
  factory ProfileApiSetVisibilityResponseApplicationJson([
    void Function(ProfileApiSetVisibilityResponseApplicationJsonBuilder)? b,
  ]) = _$ProfileApiSetVisibilityResponseApplicationJson;

  // coverage:ignore-start
  const ProfileApiSetVisibilityResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ProfileApiSetVisibilityResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ProfileApiSetVisibilityResponseApplicationJson.
  static Serializer<ProfileApiSetVisibilityResponseApplicationJson> get serializer =>
      _$profileApiSetVisibilityResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ProfileApiSetVisibilityResponseApplicationJsonBuilder b) {
    $ProfileApiSetVisibilityResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ProfileApiSetVisibilityResponseApplicationJsonBuilder b) {
    $ProfileApiSetVisibilityResponseApplicationJsonInterface._validate(b);
  }
}

class ReferenceApiExtractResolve extends EnumClass {
  const ReferenceApiExtractResolve._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const ReferenceApiExtractResolve $0 = _$referenceApiExtractResolve$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const ReferenceApiExtractResolve $1 = _$referenceApiExtractResolve$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<ReferenceApiExtractResolve> get values => _$referenceApiExtractResolveValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static ReferenceApiExtractResolve valueOf(String name) => _$valueOfReferenceApiExtractResolve(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for ReferenceApiExtractResolve.
  @BuiltValueSerializer(custom: true)
  static Serializer<ReferenceApiExtractResolve> get serializer => const _$ReferenceApiExtractResolveSerializer();
}

class _$ReferenceApiExtractResolveSerializer implements PrimitiveSerializer<ReferenceApiExtractResolve> {
  const _$ReferenceApiExtractResolveSerializer();

  static const Map<ReferenceApiExtractResolve, Object> _toWire = <ReferenceApiExtractResolve, Object>{
    ReferenceApiExtractResolve.$0: 0,
    ReferenceApiExtractResolve.$1: 1,
  };

  static const Map<Object, ReferenceApiExtractResolve> _fromWire = <Object, ReferenceApiExtractResolve>{
    0: ReferenceApiExtractResolve.$0,
    1: ReferenceApiExtractResolve.$1,
  };

  @override
  Iterable<Type> get types => const [ReferenceApiExtractResolve];

  @override
  String get wireName => 'ReferenceApiExtractResolve';

  @override
  Object serialize(
    Serializers serializers,
    ReferenceApiExtractResolve object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ReferenceApiExtractResolve deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ReferenceInterface {
  String get richObjectType;
  BuiltMap<String, JsonObject> get richObject;
  OpenGraphObject get openGraphObject;
  bool get accessible;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ReferenceInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ReferenceInterfaceBuilder b) {}
}

abstract class Reference implements $ReferenceInterface, Built<Reference, ReferenceBuilder> {
  /// Creates a new Reference object using the builder pattern.
  factory Reference([void Function(ReferenceBuilder)? b]) = _$Reference;

  // coverage:ignore-start
  const Reference._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory Reference.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for Reference.
  static Serializer<Reference> get serializer => _$referenceSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ReferenceBuilder b) {
    $ReferenceInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ReferenceBuilder b) {
    $ReferenceInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ReferenceApiExtractResponseApplicationJson_Ocs_DataInterface {
  BuiltMap<String, Reference> get references;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ReferenceApiExtractResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ReferenceApiExtractResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class ReferenceApiExtractResponseApplicationJson_Ocs_Data
    implements
        $ReferenceApiExtractResponseApplicationJson_Ocs_DataInterface,
        Built<ReferenceApiExtractResponseApplicationJson_Ocs_Data,
            ReferenceApiExtractResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new ReferenceApiExtractResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory ReferenceApiExtractResponseApplicationJson_Ocs_Data([
    void Function(ReferenceApiExtractResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$ReferenceApiExtractResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const ReferenceApiExtractResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ReferenceApiExtractResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ReferenceApiExtractResponseApplicationJson_Ocs_Data.
  static Serializer<ReferenceApiExtractResponseApplicationJson_Ocs_Data> get serializer =>
      _$referenceApiExtractResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ReferenceApiExtractResponseApplicationJson_Ocs_DataBuilder b) {
    $ReferenceApiExtractResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ReferenceApiExtractResponseApplicationJson_Ocs_DataBuilder b) {
    $ReferenceApiExtractResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ReferenceApiExtractResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  ReferenceApiExtractResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ReferenceApiExtractResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ReferenceApiExtractResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class ReferenceApiExtractResponseApplicationJson_Ocs
    implements
        $ReferenceApiExtractResponseApplicationJson_OcsInterface,
        Built<ReferenceApiExtractResponseApplicationJson_Ocs, ReferenceApiExtractResponseApplicationJson_OcsBuilder> {
  /// Creates a new ReferenceApiExtractResponseApplicationJson_Ocs object using the builder pattern.
  factory ReferenceApiExtractResponseApplicationJson_Ocs([
    void Function(ReferenceApiExtractResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ReferenceApiExtractResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ReferenceApiExtractResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ReferenceApiExtractResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ReferenceApiExtractResponseApplicationJson_Ocs.
  static Serializer<ReferenceApiExtractResponseApplicationJson_Ocs> get serializer =>
      _$referenceApiExtractResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ReferenceApiExtractResponseApplicationJson_OcsBuilder b) {
    $ReferenceApiExtractResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ReferenceApiExtractResponseApplicationJson_OcsBuilder b) {
    $ReferenceApiExtractResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ReferenceApiExtractResponseApplicationJsonInterface {
  ReferenceApiExtractResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ReferenceApiExtractResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ReferenceApiExtractResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class ReferenceApiExtractResponseApplicationJson
    implements
        $ReferenceApiExtractResponseApplicationJsonInterface,
        Built<ReferenceApiExtractResponseApplicationJson, ReferenceApiExtractResponseApplicationJsonBuilder> {
  /// Creates a new ReferenceApiExtractResponseApplicationJson object using the builder pattern.
  factory ReferenceApiExtractResponseApplicationJson([
    void Function(ReferenceApiExtractResponseApplicationJsonBuilder)? b,
  ]) = _$ReferenceApiExtractResponseApplicationJson;

  // coverage:ignore-start
  const ReferenceApiExtractResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ReferenceApiExtractResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ReferenceApiExtractResponseApplicationJson.
  static Serializer<ReferenceApiExtractResponseApplicationJson> get serializer =>
      _$referenceApiExtractResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ReferenceApiExtractResponseApplicationJsonBuilder b) {
    $ReferenceApiExtractResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ReferenceApiExtractResponseApplicationJsonBuilder b) {
    $ReferenceApiExtractResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ReferenceApiResolveOneResponseApplicationJson_Ocs_DataInterface {
  BuiltMap<String, Reference> get references;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ReferenceApiResolveOneResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ReferenceApiResolveOneResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class ReferenceApiResolveOneResponseApplicationJson_Ocs_Data
    implements
        $ReferenceApiResolveOneResponseApplicationJson_Ocs_DataInterface,
        Built<ReferenceApiResolveOneResponseApplicationJson_Ocs_Data,
            ReferenceApiResolveOneResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new ReferenceApiResolveOneResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory ReferenceApiResolveOneResponseApplicationJson_Ocs_Data([
    void Function(ReferenceApiResolveOneResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$ReferenceApiResolveOneResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const ReferenceApiResolveOneResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ReferenceApiResolveOneResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ReferenceApiResolveOneResponseApplicationJson_Ocs_Data.
  static Serializer<ReferenceApiResolveOneResponseApplicationJson_Ocs_Data> get serializer =>
      _$referenceApiResolveOneResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ReferenceApiResolveOneResponseApplicationJson_Ocs_DataBuilder b) {
    $ReferenceApiResolveOneResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ReferenceApiResolveOneResponseApplicationJson_Ocs_DataBuilder b) {
    $ReferenceApiResolveOneResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ReferenceApiResolveOneResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  ReferenceApiResolveOneResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ReferenceApiResolveOneResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ReferenceApiResolveOneResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class ReferenceApiResolveOneResponseApplicationJson_Ocs
    implements
        $ReferenceApiResolveOneResponseApplicationJson_OcsInterface,
        Built<ReferenceApiResolveOneResponseApplicationJson_Ocs,
            ReferenceApiResolveOneResponseApplicationJson_OcsBuilder> {
  /// Creates a new ReferenceApiResolveOneResponseApplicationJson_Ocs object using the builder pattern.
  factory ReferenceApiResolveOneResponseApplicationJson_Ocs([
    void Function(ReferenceApiResolveOneResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ReferenceApiResolveOneResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ReferenceApiResolveOneResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ReferenceApiResolveOneResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ReferenceApiResolveOneResponseApplicationJson_Ocs.
  static Serializer<ReferenceApiResolveOneResponseApplicationJson_Ocs> get serializer =>
      _$referenceApiResolveOneResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ReferenceApiResolveOneResponseApplicationJson_OcsBuilder b) {
    $ReferenceApiResolveOneResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ReferenceApiResolveOneResponseApplicationJson_OcsBuilder b) {
    $ReferenceApiResolveOneResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ReferenceApiResolveOneResponseApplicationJsonInterface {
  ReferenceApiResolveOneResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ReferenceApiResolveOneResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ReferenceApiResolveOneResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class ReferenceApiResolveOneResponseApplicationJson
    implements
        $ReferenceApiResolveOneResponseApplicationJsonInterface,
        Built<ReferenceApiResolveOneResponseApplicationJson, ReferenceApiResolveOneResponseApplicationJsonBuilder> {
  /// Creates a new ReferenceApiResolveOneResponseApplicationJson object using the builder pattern.
  factory ReferenceApiResolveOneResponseApplicationJson([
    void Function(ReferenceApiResolveOneResponseApplicationJsonBuilder)? b,
  ]) = _$ReferenceApiResolveOneResponseApplicationJson;

  // coverage:ignore-start
  const ReferenceApiResolveOneResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ReferenceApiResolveOneResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ReferenceApiResolveOneResponseApplicationJson.
  static Serializer<ReferenceApiResolveOneResponseApplicationJson> get serializer =>
      _$referenceApiResolveOneResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ReferenceApiResolveOneResponseApplicationJsonBuilder b) {
    $ReferenceApiResolveOneResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ReferenceApiResolveOneResponseApplicationJsonBuilder b) {
    $ReferenceApiResolveOneResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ReferenceApiResolveResponseApplicationJson_Ocs_DataInterface {
  BuiltMap<String, Reference> get references;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ReferenceApiResolveResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ReferenceApiResolveResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class ReferenceApiResolveResponseApplicationJson_Ocs_Data
    implements
        $ReferenceApiResolveResponseApplicationJson_Ocs_DataInterface,
        Built<ReferenceApiResolveResponseApplicationJson_Ocs_Data,
            ReferenceApiResolveResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new ReferenceApiResolveResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory ReferenceApiResolveResponseApplicationJson_Ocs_Data([
    void Function(ReferenceApiResolveResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$ReferenceApiResolveResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const ReferenceApiResolveResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ReferenceApiResolveResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ReferenceApiResolveResponseApplicationJson_Ocs_Data.
  static Serializer<ReferenceApiResolveResponseApplicationJson_Ocs_Data> get serializer =>
      _$referenceApiResolveResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ReferenceApiResolveResponseApplicationJson_Ocs_DataBuilder b) {
    $ReferenceApiResolveResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ReferenceApiResolveResponseApplicationJson_Ocs_DataBuilder b) {
    $ReferenceApiResolveResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ReferenceApiResolveResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  ReferenceApiResolveResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ReferenceApiResolveResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ReferenceApiResolveResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class ReferenceApiResolveResponseApplicationJson_Ocs
    implements
        $ReferenceApiResolveResponseApplicationJson_OcsInterface,
        Built<ReferenceApiResolveResponseApplicationJson_Ocs, ReferenceApiResolveResponseApplicationJson_OcsBuilder> {
  /// Creates a new ReferenceApiResolveResponseApplicationJson_Ocs object using the builder pattern.
  factory ReferenceApiResolveResponseApplicationJson_Ocs([
    void Function(ReferenceApiResolveResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ReferenceApiResolveResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ReferenceApiResolveResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ReferenceApiResolveResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ReferenceApiResolveResponseApplicationJson_Ocs.
  static Serializer<ReferenceApiResolveResponseApplicationJson_Ocs> get serializer =>
      _$referenceApiResolveResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ReferenceApiResolveResponseApplicationJson_OcsBuilder b) {
    $ReferenceApiResolveResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ReferenceApiResolveResponseApplicationJson_OcsBuilder b) {
    $ReferenceApiResolveResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ReferenceApiResolveResponseApplicationJsonInterface {
  ReferenceApiResolveResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ReferenceApiResolveResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ReferenceApiResolveResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class ReferenceApiResolveResponseApplicationJson
    implements
        $ReferenceApiResolveResponseApplicationJsonInterface,
        Built<ReferenceApiResolveResponseApplicationJson, ReferenceApiResolveResponseApplicationJsonBuilder> {
  /// Creates a new ReferenceApiResolveResponseApplicationJson object using the builder pattern.
  factory ReferenceApiResolveResponseApplicationJson([
    void Function(ReferenceApiResolveResponseApplicationJsonBuilder)? b,
  ]) = _$ReferenceApiResolveResponseApplicationJson;

  // coverage:ignore-start
  const ReferenceApiResolveResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ReferenceApiResolveResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ReferenceApiResolveResponseApplicationJson.
  static Serializer<ReferenceApiResolveResponseApplicationJson> get serializer =>
      _$referenceApiResolveResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ReferenceApiResolveResponseApplicationJsonBuilder b) {
    $ReferenceApiResolveResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ReferenceApiResolveResponseApplicationJsonBuilder b) {
    $ReferenceApiResolveResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ReferenceProviderInterface {
  String get id;
  String get title;
  @BuiltValueField(wireName: 'icon_url')
  String get iconUrl;
  int get order;
  @BuiltValueField(wireName: 'search_providers_ids')
  BuiltList<String>? get searchProvidersIds;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ReferenceProviderInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ReferenceProviderInterfaceBuilder b) {}
}

abstract class ReferenceProvider
    implements $ReferenceProviderInterface, Built<ReferenceProvider, ReferenceProviderBuilder> {
  /// Creates a new ReferenceProvider object using the builder pattern.
  factory ReferenceProvider([void Function(ReferenceProviderBuilder)? b]) = _$ReferenceProvider;

  // coverage:ignore-start
  const ReferenceProvider._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ReferenceProvider.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ReferenceProvider.
  static Serializer<ReferenceProvider> get serializer => _$referenceProviderSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ReferenceProviderBuilder b) {
    $ReferenceProviderInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ReferenceProviderBuilder b) {
    $ReferenceProviderInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ReferenceApiGetProvidersInfoResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<ReferenceProvider> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ReferenceApiGetProvidersInfoResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ReferenceApiGetProvidersInfoResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class ReferenceApiGetProvidersInfoResponseApplicationJson_Ocs
    implements
        $ReferenceApiGetProvidersInfoResponseApplicationJson_OcsInterface,
        Built<ReferenceApiGetProvidersInfoResponseApplicationJson_Ocs,
            ReferenceApiGetProvidersInfoResponseApplicationJson_OcsBuilder> {
  /// Creates a new ReferenceApiGetProvidersInfoResponseApplicationJson_Ocs object using the builder pattern.
  factory ReferenceApiGetProvidersInfoResponseApplicationJson_Ocs([
    void Function(ReferenceApiGetProvidersInfoResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ReferenceApiGetProvidersInfoResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ReferenceApiGetProvidersInfoResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ReferenceApiGetProvidersInfoResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ReferenceApiGetProvidersInfoResponseApplicationJson_Ocs.
  static Serializer<ReferenceApiGetProvidersInfoResponseApplicationJson_Ocs> get serializer =>
      _$referenceApiGetProvidersInfoResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ReferenceApiGetProvidersInfoResponseApplicationJson_OcsBuilder b) {
    $ReferenceApiGetProvidersInfoResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ReferenceApiGetProvidersInfoResponseApplicationJson_OcsBuilder b) {
    $ReferenceApiGetProvidersInfoResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ReferenceApiGetProvidersInfoResponseApplicationJsonInterface {
  ReferenceApiGetProvidersInfoResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ReferenceApiGetProvidersInfoResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ReferenceApiGetProvidersInfoResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class ReferenceApiGetProvidersInfoResponseApplicationJson
    implements
        $ReferenceApiGetProvidersInfoResponseApplicationJsonInterface,
        Built<ReferenceApiGetProvidersInfoResponseApplicationJson,
            ReferenceApiGetProvidersInfoResponseApplicationJsonBuilder> {
  /// Creates a new ReferenceApiGetProvidersInfoResponseApplicationJson object using the builder pattern.
  factory ReferenceApiGetProvidersInfoResponseApplicationJson([
    void Function(ReferenceApiGetProvidersInfoResponseApplicationJsonBuilder)? b,
  ]) = _$ReferenceApiGetProvidersInfoResponseApplicationJson;

  // coverage:ignore-start
  const ReferenceApiGetProvidersInfoResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ReferenceApiGetProvidersInfoResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ReferenceApiGetProvidersInfoResponseApplicationJson.
  static Serializer<ReferenceApiGetProvidersInfoResponseApplicationJson> get serializer =>
      _$referenceApiGetProvidersInfoResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ReferenceApiGetProvidersInfoResponseApplicationJsonBuilder b) {
    $ReferenceApiGetProvidersInfoResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ReferenceApiGetProvidersInfoResponseApplicationJsonBuilder b) {
    $ReferenceApiGetProvidersInfoResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ReferenceApiTouchProviderResponseApplicationJson_Ocs_DataInterface {
  bool get success;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ReferenceApiTouchProviderResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ReferenceApiTouchProviderResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class ReferenceApiTouchProviderResponseApplicationJson_Ocs_Data
    implements
        $ReferenceApiTouchProviderResponseApplicationJson_Ocs_DataInterface,
        Built<ReferenceApiTouchProviderResponseApplicationJson_Ocs_Data,
            ReferenceApiTouchProviderResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new ReferenceApiTouchProviderResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory ReferenceApiTouchProviderResponseApplicationJson_Ocs_Data([
    void Function(ReferenceApiTouchProviderResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$ReferenceApiTouchProviderResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const ReferenceApiTouchProviderResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ReferenceApiTouchProviderResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ReferenceApiTouchProviderResponseApplicationJson_Ocs_Data.
  static Serializer<ReferenceApiTouchProviderResponseApplicationJson_Ocs_Data> get serializer =>
      _$referenceApiTouchProviderResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ReferenceApiTouchProviderResponseApplicationJson_Ocs_DataBuilder b) {
    $ReferenceApiTouchProviderResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ReferenceApiTouchProviderResponseApplicationJson_Ocs_DataBuilder b) {
    $ReferenceApiTouchProviderResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ReferenceApiTouchProviderResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  ReferenceApiTouchProviderResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ReferenceApiTouchProviderResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ReferenceApiTouchProviderResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class ReferenceApiTouchProviderResponseApplicationJson_Ocs
    implements
        $ReferenceApiTouchProviderResponseApplicationJson_OcsInterface,
        Built<ReferenceApiTouchProviderResponseApplicationJson_Ocs,
            ReferenceApiTouchProviderResponseApplicationJson_OcsBuilder> {
  /// Creates a new ReferenceApiTouchProviderResponseApplicationJson_Ocs object using the builder pattern.
  factory ReferenceApiTouchProviderResponseApplicationJson_Ocs([
    void Function(ReferenceApiTouchProviderResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ReferenceApiTouchProviderResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ReferenceApiTouchProviderResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ReferenceApiTouchProviderResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ReferenceApiTouchProviderResponseApplicationJson_Ocs.
  static Serializer<ReferenceApiTouchProviderResponseApplicationJson_Ocs> get serializer =>
      _$referenceApiTouchProviderResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ReferenceApiTouchProviderResponseApplicationJson_OcsBuilder b) {
    $ReferenceApiTouchProviderResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ReferenceApiTouchProviderResponseApplicationJson_OcsBuilder b) {
    $ReferenceApiTouchProviderResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ReferenceApiTouchProviderResponseApplicationJsonInterface {
  ReferenceApiTouchProviderResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ReferenceApiTouchProviderResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ReferenceApiTouchProviderResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class ReferenceApiTouchProviderResponseApplicationJson
    implements
        $ReferenceApiTouchProviderResponseApplicationJsonInterface,
        Built<ReferenceApiTouchProviderResponseApplicationJson,
            ReferenceApiTouchProviderResponseApplicationJsonBuilder> {
  /// Creates a new ReferenceApiTouchProviderResponseApplicationJson object using the builder pattern.
  factory ReferenceApiTouchProviderResponseApplicationJson([
    void Function(ReferenceApiTouchProviderResponseApplicationJsonBuilder)? b,
  ]) = _$ReferenceApiTouchProviderResponseApplicationJson;

  // coverage:ignore-start
  const ReferenceApiTouchProviderResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ReferenceApiTouchProviderResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ReferenceApiTouchProviderResponseApplicationJson.
  static Serializer<ReferenceApiTouchProviderResponseApplicationJson> get serializer =>
      _$referenceApiTouchProviderResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ReferenceApiTouchProviderResponseApplicationJsonBuilder b) {
    $ReferenceApiTouchProviderResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ReferenceApiTouchProviderResponseApplicationJsonBuilder b) {
    $ReferenceApiTouchProviderResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TeamResourceInterface {
  int get id;
  String get label;
  String get url;
  String? get iconSvg;
  String? get iconURL;
  String? get iconEmoji;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TeamResourceInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TeamResourceInterfaceBuilder b) {}
}

abstract class TeamResource implements $TeamResourceInterface, Built<TeamResource, TeamResourceBuilder> {
  /// Creates a new TeamResource object using the builder pattern.
  factory TeamResource([void Function(TeamResourceBuilder)? b]) = _$TeamResource;

  // coverage:ignore-start
  const TeamResource._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TeamResource.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TeamResource.
  static Serializer<TeamResource> get serializer => _$teamResourceSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TeamResourceBuilder b) {
    $TeamResourceInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TeamResourceBuilder b) {
    $TeamResourceInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TeamsApiResolveOneResponseApplicationJson_Ocs_DataInterface {
  BuiltList<TeamResource> get resources;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TeamsApiResolveOneResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TeamsApiResolveOneResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class TeamsApiResolveOneResponseApplicationJson_Ocs_Data
    implements
        $TeamsApiResolveOneResponseApplicationJson_Ocs_DataInterface,
        Built<TeamsApiResolveOneResponseApplicationJson_Ocs_Data,
            TeamsApiResolveOneResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new TeamsApiResolveOneResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory TeamsApiResolveOneResponseApplicationJson_Ocs_Data([
    void Function(TeamsApiResolveOneResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$TeamsApiResolveOneResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const TeamsApiResolveOneResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TeamsApiResolveOneResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TeamsApiResolveOneResponseApplicationJson_Ocs_Data.
  static Serializer<TeamsApiResolveOneResponseApplicationJson_Ocs_Data> get serializer =>
      _$teamsApiResolveOneResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TeamsApiResolveOneResponseApplicationJson_Ocs_DataBuilder b) {
    $TeamsApiResolveOneResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TeamsApiResolveOneResponseApplicationJson_Ocs_DataBuilder b) {
    $TeamsApiResolveOneResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TeamsApiResolveOneResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  TeamsApiResolveOneResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TeamsApiResolveOneResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TeamsApiResolveOneResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class TeamsApiResolveOneResponseApplicationJson_Ocs
    implements
        $TeamsApiResolveOneResponseApplicationJson_OcsInterface,
        Built<TeamsApiResolveOneResponseApplicationJson_Ocs, TeamsApiResolveOneResponseApplicationJson_OcsBuilder> {
  /// Creates a new TeamsApiResolveOneResponseApplicationJson_Ocs object using the builder pattern.
  factory TeamsApiResolveOneResponseApplicationJson_Ocs([
    void Function(TeamsApiResolveOneResponseApplicationJson_OcsBuilder)? b,
  ]) = _$TeamsApiResolveOneResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const TeamsApiResolveOneResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TeamsApiResolveOneResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TeamsApiResolveOneResponseApplicationJson_Ocs.
  static Serializer<TeamsApiResolveOneResponseApplicationJson_Ocs> get serializer =>
      _$teamsApiResolveOneResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TeamsApiResolveOneResponseApplicationJson_OcsBuilder b) {
    $TeamsApiResolveOneResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TeamsApiResolveOneResponseApplicationJson_OcsBuilder b) {
    $TeamsApiResolveOneResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TeamsApiResolveOneResponseApplicationJsonInterface {
  TeamsApiResolveOneResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TeamsApiResolveOneResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TeamsApiResolveOneResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class TeamsApiResolveOneResponseApplicationJson
    implements
        $TeamsApiResolveOneResponseApplicationJsonInterface,
        Built<TeamsApiResolveOneResponseApplicationJson, TeamsApiResolveOneResponseApplicationJsonBuilder> {
  /// Creates a new TeamsApiResolveOneResponseApplicationJson object using the builder pattern.
  factory TeamsApiResolveOneResponseApplicationJson([
    void Function(TeamsApiResolveOneResponseApplicationJsonBuilder)? b,
  ]) = _$TeamsApiResolveOneResponseApplicationJson;

  // coverage:ignore-start
  const TeamsApiResolveOneResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TeamsApiResolveOneResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TeamsApiResolveOneResponseApplicationJson.
  static Serializer<TeamsApiResolveOneResponseApplicationJson> get serializer =>
      _$teamsApiResolveOneResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TeamsApiResolveOneResponseApplicationJsonBuilder b) {
    $TeamsApiResolveOneResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TeamsApiResolveOneResponseApplicationJsonBuilder b) {
    $TeamsApiResolveOneResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TeamInterface {
  String get id;
  String get name;
  String get icon;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TeamInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TeamInterfaceBuilder b) {}
}

abstract class Team implements $TeamInterface, Built<Team, TeamBuilder> {
  /// Creates a new Team object using the builder pattern.
  factory Team([void Function(TeamBuilder)? b]) = _$Team;

  // coverage:ignore-start
  const Team._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory Team.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for Team.
  static Serializer<Team> get serializer => _$teamSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TeamBuilder b) {
    $TeamInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TeamBuilder b) {
    $TeamInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TeamsApiListTeamsResponseApplicationJson_Ocs_DataInterface {
  BuiltList<Team> get teams;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TeamsApiListTeamsResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TeamsApiListTeamsResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class TeamsApiListTeamsResponseApplicationJson_Ocs_Data
    implements
        $TeamsApiListTeamsResponseApplicationJson_Ocs_DataInterface,
        Built<TeamsApiListTeamsResponseApplicationJson_Ocs_Data,
            TeamsApiListTeamsResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new TeamsApiListTeamsResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory TeamsApiListTeamsResponseApplicationJson_Ocs_Data([
    void Function(TeamsApiListTeamsResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$TeamsApiListTeamsResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const TeamsApiListTeamsResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TeamsApiListTeamsResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TeamsApiListTeamsResponseApplicationJson_Ocs_Data.
  static Serializer<TeamsApiListTeamsResponseApplicationJson_Ocs_Data> get serializer =>
      _$teamsApiListTeamsResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TeamsApiListTeamsResponseApplicationJson_Ocs_DataBuilder b) {
    $TeamsApiListTeamsResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TeamsApiListTeamsResponseApplicationJson_Ocs_DataBuilder b) {
    $TeamsApiListTeamsResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TeamsApiListTeamsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  TeamsApiListTeamsResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TeamsApiListTeamsResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TeamsApiListTeamsResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class TeamsApiListTeamsResponseApplicationJson_Ocs
    implements
        $TeamsApiListTeamsResponseApplicationJson_OcsInterface,
        Built<TeamsApiListTeamsResponseApplicationJson_Ocs, TeamsApiListTeamsResponseApplicationJson_OcsBuilder> {
  /// Creates a new TeamsApiListTeamsResponseApplicationJson_Ocs object using the builder pattern.
  factory TeamsApiListTeamsResponseApplicationJson_Ocs([
    void Function(TeamsApiListTeamsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$TeamsApiListTeamsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const TeamsApiListTeamsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TeamsApiListTeamsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TeamsApiListTeamsResponseApplicationJson_Ocs.
  static Serializer<TeamsApiListTeamsResponseApplicationJson_Ocs> get serializer =>
      _$teamsApiListTeamsResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TeamsApiListTeamsResponseApplicationJson_OcsBuilder b) {
    $TeamsApiListTeamsResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TeamsApiListTeamsResponseApplicationJson_OcsBuilder b) {
    $TeamsApiListTeamsResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TeamsApiListTeamsResponseApplicationJsonInterface {
  TeamsApiListTeamsResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TeamsApiListTeamsResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TeamsApiListTeamsResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class TeamsApiListTeamsResponseApplicationJson
    implements
        $TeamsApiListTeamsResponseApplicationJsonInterface,
        Built<TeamsApiListTeamsResponseApplicationJson, TeamsApiListTeamsResponseApplicationJsonBuilder> {
  /// Creates a new TeamsApiListTeamsResponseApplicationJson object using the builder pattern.
  factory TeamsApiListTeamsResponseApplicationJson([
    void Function(TeamsApiListTeamsResponseApplicationJsonBuilder)? b,
  ]) = _$TeamsApiListTeamsResponseApplicationJson;

  // coverage:ignore-start
  const TeamsApiListTeamsResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TeamsApiListTeamsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TeamsApiListTeamsResponseApplicationJson.
  static Serializer<TeamsApiListTeamsResponseApplicationJson> get serializer =>
      _$teamsApiListTeamsResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TeamsApiListTeamsResponseApplicationJsonBuilder b) {
    $TeamsApiListTeamsResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TeamsApiListTeamsResponseApplicationJsonBuilder b) {
    $TeamsApiListTeamsResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data_TypesInterface {
  String get id;
  String get name;
  String get description;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data_TypesInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data_TypesInterfaceBuilder b) {}
}

abstract class TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data_Types
    implements
        $TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data_TypesInterface,
        Built<TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data_Types,
            TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data_TypesBuilder> {
  /// Creates a new TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data_Types object using the builder pattern.
  factory TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data_Types([
    void Function(TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data_TypesBuilder)? b,
  ]) = _$TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data_Types;

  // coverage:ignore-start
  const TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data_Types._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data_Types.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data_Types.
  static Serializer<TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data_Types> get serializer =>
      _$textProcessingApiTaskTypesResponseApplicationJsonOcsDataTypesSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data_TypesBuilder b) {
    $TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data_TypesInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data_TypesBuilder b) {
    $TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data_TypesInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextProcessingApiTaskTypesResponseApplicationJson_Ocs_DataInterface {
  BuiltList<TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data_Types> get types;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextProcessingApiTaskTypesResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextProcessingApiTaskTypesResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data
    implements
        $TextProcessingApiTaskTypesResponseApplicationJson_Ocs_DataInterface,
        Built<TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data,
            TextProcessingApiTaskTypesResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data([
    void Function(TextProcessingApiTaskTypesResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data.
  static Serializer<TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data> get serializer =>
      _$textProcessingApiTaskTypesResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextProcessingApiTaskTypesResponseApplicationJson_Ocs_DataBuilder b) {
    $TextProcessingApiTaskTypesResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextProcessingApiTaskTypesResponseApplicationJson_Ocs_DataBuilder b) {
    $TextProcessingApiTaskTypesResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextProcessingApiTaskTypesResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextProcessingApiTaskTypesResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextProcessingApiTaskTypesResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class TextProcessingApiTaskTypesResponseApplicationJson_Ocs
    implements
        $TextProcessingApiTaskTypesResponseApplicationJson_OcsInterface,
        Built<TextProcessingApiTaskTypesResponseApplicationJson_Ocs,
            TextProcessingApiTaskTypesResponseApplicationJson_OcsBuilder> {
  /// Creates a new TextProcessingApiTaskTypesResponseApplicationJson_Ocs object using the builder pattern.
  factory TextProcessingApiTaskTypesResponseApplicationJson_Ocs([
    void Function(TextProcessingApiTaskTypesResponseApplicationJson_OcsBuilder)? b,
  ]) = _$TextProcessingApiTaskTypesResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const TextProcessingApiTaskTypesResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextProcessingApiTaskTypesResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextProcessingApiTaskTypesResponseApplicationJson_Ocs.
  static Serializer<TextProcessingApiTaskTypesResponseApplicationJson_Ocs> get serializer =>
      _$textProcessingApiTaskTypesResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextProcessingApiTaskTypesResponseApplicationJson_OcsBuilder b) {
    $TextProcessingApiTaskTypesResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextProcessingApiTaskTypesResponseApplicationJson_OcsBuilder b) {
    $TextProcessingApiTaskTypesResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextProcessingApiTaskTypesResponseApplicationJsonInterface {
  TextProcessingApiTaskTypesResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextProcessingApiTaskTypesResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextProcessingApiTaskTypesResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class TextProcessingApiTaskTypesResponseApplicationJson
    implements
        $TextProcessingApiTaskTypesResponseApplicationJsonInterface,
        Built<TextProcessingApiTaskTypesResponseApplicationJson,
            TextProcessingApiTaskTypesResponseApplicationJsonBuilder> {
  /// Creates a new TextProcessingApiTaskTypesResponseApplicationJson object using the builder pattern.
  factory TextProcessingApiTaskTypesResponseApplicationJson([
    void Function(TextProcessingApiTaskTypesResponseApplicationJsonBuilder)? b,
  ]) = _$TextProcessingApiTaskTypesResponseApplicationJson;

  // coverage:ignore-start
  const TextProcessingApiTaskTypesResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextProcessingApiTaskTypesResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextProcessingApiTaskTypesResponseApplicationJson.
  static Serializer<TextProcessingApiTaskTypesResponseApplicationJson> get serializer =>
      _$textProcessingApiTaskTypesResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextProcessingApiTaskTypesResponseApplicationJsonBuilder b) {
    $TextProcessingApiTaskTypesResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextProcessingApiTaskTypesResponseApplicationJsonBuilder b) {
    $TextProcessingApiTaskTypesResponseApplicationJsonInterface._validate(b);
  }
}

class TextProcessingTask_Status extends EnumClass {
  const TextProcessingTask_Status._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const TextProcessingTask_Status $0 = _$textProcessingTaskStatus$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const TextProcessingTask_Status $1 = _$textProcessingTaskStatus$1;

  /// `2`
  @BuiltValueEnumConst(wireName: '2')
  static const TextProcessingTask_Status $2 = _$textProcessingTaskStatus$2;

  /// `3`
  @BuiltValueEnumConst(wireName: '3')
  static const TextProcessingTask_Status $3 = _$textProcessingTaskStatus$3;

  /// `4`
  @BuiltValueEnumConst(wireName: '4')
  static const TextProcessingTask_Status $4 = _$textProcessingTaskStatus$4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<TextProcessingTask_Status> get values => _$textProcessingTaskStatusValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static TextProcessingTask_Status valueOf(String name) => _$valueOfTextProcessingTask_Status(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for TextProcessingTask_Status.
  @BuiltValueSerializer(custom: true)
  static Serializer<TextProcessingTask_Status> get serializer => const _$TextProcessingTask_StatusSerializer();
}

class _$TextProcessingTask_StatusSerializer implements PrimitiveSerializer<TextProcessingTask_Status> {
  const _$TextProcessingTask_StatusSerializer();

  static const Map<TextProcessingTask_Status, Object> _toWire = <TextProcessingTask_Status, Object>{
    TextProcessingTask_Status.$0: 0,
    TextProcessingTask_Status.$1: 1,
    TextProcessingTask_Status.$2: 2,
    TextProcessingTask_Status.$3: 3,
    TextProcessingTask_Status.$4: 4,
  };

  static const Map<Object, TextProcessingTask_Status> _fromWire = <Object, TextProcessingTask_Status>{
    0: TextProcessingTask_Status.$0,
    1: TextProcessingTask_Status.$1,
    2: TextProcessingTask_Status.$2,
    3: TextProcessingTask_Status.$3,
    4: TextProcessingTask_Status.$4,
  };

  @override
  Iterable<Type> get types => const [TextProcessingTask_Status];

  @override
  String get wireName => 'TextProcessingTask_Status';

  @override
  Object serialize(
    Serializers serializers,
    TextProcessingTask_Status object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  TextProcessingTask_Status deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $TextProcessingTaskInterface {
  int? get id;
  String get type;
  TextProcessingTask_Status get status;
  String? get userId;
  String get appId;
  String get input;
  String? get output;
  String get identifier;
  int? get completionExpectedAt;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextProcessingTaskInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextProcessingTaskInterfaceBuilder b) {}
}

abstract class TextProcessingTask
    implements $TextProcessingTaskInterface, Built<TextProcessingTask, TextProcessingTaskBuilder> {
  /// Creates a new TextProcessingTask object using the builder pattern.
  factory TextProcessingTask([void Function(TextProcessingTaskBuilder)? b]) = _$TextProcessingTask;

  // coverage:ignore-start
  const TextProcessingTask._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextProcessingTask.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextProcessingTask.
  static Serializer<TextProcessingTask> get serializer => _$textProcessingTaskSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextProcessingTaskBuilder b) {
    $TextProcessingTaskInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextProcessingTaskBuilder b) {
    $TextProcessingTaskInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextProcessingApiScheduleResponseApplicationJson_Ocs_DataInterface {
  TextProcessingTask get task;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextProcessingApiScheduleResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextProcessingApiScheduleResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class TextProcessingApiScheduleResponseApplicationJson_Ocs_Data
    implements
        $TextProcessingApiScheduleResponseApplicationJson_Ocs_DataInterface,
        Built<TextProcessingApiScheduleResponseApplicationJson_Ocs_Data,
            TextProcessingApiScheduleResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new TextProcessingApiScheduleResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory TextProcessingApiScheduleResponseApplicationJson_Ocs_Data([
    void Function(TextProcessingApiScheduleResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$TextProcessingApiScheduleResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const TextProcessingApiScheduleResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextProcessingApiScheduleResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextProcessingApiScheduleResponseApplicationJson_Ocs_Data.
  static Serializer<TextProcessingApiScheduleResponseApplicationJson_Ocs_Data> get serializer =>
      _$textProcessingApiScheduleResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextProcessingApiScheduleResponseApplicationJson_Ocs_DataBuilder b) {
    $TextProcessingApiScheduleResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextProcessingApiScheduleResponseApplicationJson_Ocs_DataBuilder b) {
    $TextProcessingApiScheduleResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextProcessingApiScheduleResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  TextProcessingApiScheduleResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextProcessingApiScheduleResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextProcessingApiScheduleResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class TextProcessingApiScheduleResponseApplicationJson_Ocs
    implements
        $TextProcessingApiScheduleResponseApplicationJson_OcsInterface,
        Built<TextProcessingApiScheduleResponseApplicationJson_Ocs,
            TextProcessingApiScheduleResponseApplicationJson_OcsBuilder> {
  /// Creates a new TextProcessingApiScheduleResponseApplicationJson_Ocs object using the builder pattern.
  factory TextProcessingApiScheduleResponseApplicationJson_Ocs([
    void Function(TextProcessingApiScheduleResponseApplicationJson_OcsBuilder)? b,
  ]) = _$TextProcessingApiScheduleResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const TextProcessingApiScheduleResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextProcessingApiScheduleResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextProcessingApiScheduleResponseApplicationJson_Ocs.
  static Serializer<TextProcessingApiScheduleResponseApplicationJson_Ocs> get serializer =>
      _$textProcessingApiScheduleResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextProcessingApiScheduleResponseApplicationJson_OcsBuilder b) {
    $TextProcessingApiScheduleResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextProcessingApiScheduleResponseApplicationJson_OcsBuilder b) {
    $TextProcessingApiScheduleResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextProcessingApiScheduleResponseApplicationJsonInterface {
  TextProcessingApiScheduleResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextProcessingApiScheduleResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextProcessingApiScheduleResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class TextProcessingApiScheduleResponseApplicationJson
    implements
        $TextProcessingApiScheduleResponseApplicationJsonInterface,
        Built<TextProcessingApiScheduleResponseApplicationJson,
            TextProcessingApiScheduleResponseApplicationJsonBuilder> {
  /// Creates a new TextProcessingApiScheduleResponseApplicationJson object using the builder pattern.
  factory TextProcessingApiScheduleResponseApplicationJson([
    void Function(TextProcessingApiScheduleResponseApplicationJsonBuilder)? b,
  ]) = _$TextProcessingApiScheduleResponseApplicationJson;

  // coverage:ignore-start
  const TextProcessingApiScheduleResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextProcessingApiScheduleResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextProcessingApiScheduleResponseApplicationJson.
  static Serializer<TextProcessingApiScheduleResponseApplicationJson> get serializer =>
      _$textProcessingApiScheduleResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextProcessingApiScheduleResponseApplicationJsonBuilder b) {
    $TextProcessingApiScheduleResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextProcessingApiScheduleResponseApplicationJsonBuilder b) {
    $TextProcessingApiScheduleResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextProcessingApiGetTaskResponseApplicationJson_Ocs_DataInterface {
  TextProcessingTask get task;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextProcessingApiGetTaskResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextProcessingApiGetTaskResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class TextProcessingApiGetTaskResponseApplicationJson_Ocs_Data
    implements
        $TextProcessingApiGetTaskResponseApplicationJson_Ocs_DataInterface,
        Built<TextProcessingApiGetTaskResponseApplicationJson_Ocs_Data,
            TextProcessingApiGetTaskResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new TextProcessingApiGetTaskResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory TextProcessingApiGetTaskResponseApplicationJson_Ocs_Data([
    void Function(TextProcessingApiGetTaskResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$TextProcessingApiGetTaskResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const TextProcessingApiGetTaskResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextProcessingApiGetTaskResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextProcessingApiGetTaskResponseApplicationJson_Ocs_Data.
  static Serializer<TextProcessingApiGetTaskResponseApplicationJson_Ocs_Data> get serializer =>
      _$textProcessingApiGetTaskResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextProcessingApiGetTaskResponseApplicationJson_Ocs_DataBuilder b) {
    $TextProcessingApiGetTaskResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextProcessingApiGetTaskResponseApplicationJson_Ocs_DataBuilder b) {
    $TextProcessingApiGetTaskResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextProcessingApiGetTaskResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  TextProcessingApiGetTaskResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextProcessingApiGetTaskResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextProcessingApiGetTaskResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class TextProcessingApiGetTaskResponseApplicationJson_Ocs
    implements
        $TextProcessingApiGetTaskResponseApplicationJson_OcsInterface,
        Built<TextProcessingApiGetTaskResponseApplicationJson_Ocs,
            TextProcessingApiGetTaskResponseApplicationJson_OcsBuilder> {
  /// Creates a new TextProcessingApiGetTaskResponseApplicationJson_Ocs object using the builder pattern.
  factory TextProcessingApiGetTaskResponseApplicationJson_Ocs([
    void Function(TextProcessingApiGetTaskResponseApplicationJson_OcsBuilder)? b,
  ]) = _$TextProcessingApiGetTaskResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const TextProcessingApiGetTaskResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextProcessingApiGetTaskResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextProcessingApiGetTaskResponseApplicationJson_Ocs.
  static Serializer<TextProcessingApiGetTaskResponseApplicationJson_Ocs> get serializer =>
      _$textProcessingApiGetTaskResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextProcessingApiGetTaskResponseApplicationJson_OcsBuilder b) {
    $TextProcessingApiGetTaskResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextProcessingApiGetTaskResponseApplicationJson_OcsBuilder b) {
    $TextProcessingApiGetTaskResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextProcessingApiGetTaskResponseApplicationJsonInterface {
  TextProcessingApiGetTaskResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextProcessingApiGetTaskResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextProcessingApiGetTaskResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class TextProcessingApiGetTaskResponseApplicationJson
    implements
        $TextProcessingApiGetTaskResponseApplicationJsonInterface,
        Built<TextProcessingApiGetTaskResponseApplicationJson, TextProcessingApiGetTaskResponseApplicationJsonBuilder> {
  /// Creates a new TextProcessingApiGetTaskResponseApplicationJson object using the builder pattern.
  factory TextProcessingApiGetTaskResponseApplicationJson([
    void Function(TextProcessingApiGetTaskResponseApplicationJsonBuilder)? b,
  ]) = _$TextProcessingApiGetTaskResponseApplicationJson;

  // coverage:ignore-start
  const TextProcessingApiGetTaskResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextProcessingApiGetTaskResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextProcessingApiGetTaskResponseApplicationJson.
  static Serializer<TextProcessingApiGetTaskResponseApplicationJson> get serializer =>
      _$textProcessingApiGetTaskResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextProcessingApiGetTaskResponseApplicationJsonBuilder b) {
    $TextProcessingApiGetTaskResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextProcessingApiGetTaskResponseApplicationJsonBuilder b) {
    $TextProcessingApiGetTaskResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextProcessingApiDeleteTaskResponseApplicationJson_Ocs_DataInterface {
  TextProcessingTask get task;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextProcessingApiDeleteTaskResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextProcessingApiDeleteTaskResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class TextProcessingApiDeleteTaskResponseApplicationJson_Ocs_Data
    implements
        $TextProcessingApiDeleteTaskResponseApplicationJson_Ocs_DataInterface,
        Built<TextProcessingApiDeleteTaskResponseApplicationJson_Ocs_Data,
            TextProcessingApiDeleteTaskResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new TextProcessingApiDeleteTaskResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory TextProcessingApiDeleteTaskResponseApplicationJson_Ocs_Data([
    void Function(TextProcessingApiDeleteTaskResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$TextProcessingApiDeleteTaskResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const TextProcessingApiDeleteTaskResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextProcessingApiDeleteTaskResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextProcessingApiDeleteTaskResponseApplicationJson_Ocs_Data.
  static Serializer<TextProcessingApiDeleteTaskResponseApplicationJson_Ocs_Data> get serializer =>
      _$textProcessingApiDeleteTaskResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextProcessingApiDeleteTaskResponseApplicationJson_Ocs_DataBuilder b) {
    $TextProcessingApiDeleteTaskResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextProcessingApiDeleteTaskResponseApplicationJson_Ocs_DataBuilder b) {
    $TextProcessingApiDeleteTaskResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextProcessingApiDeleteTaskResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  TextProcessingApiDeleteTaskResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextProcessingApiDeleteTaskResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextProcessingApiDeleteTaskResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class TextProcessingApiDeleteTaskResponseApplicationJson_Ocs
    implements
        $TextProcessingApiDeleteTaskResponseApplicationJson_OcsInterface,
        Built<TextProcessingApiDeleteTaskResponseApplicationJson_Ocs,
            TextProcessingApiDeleteTaskResponseApplicationJson_OcsBuilder> {
  /// Creates a new TextProcessingApiDeleteTaskResponseApplicationJson_Ocs object using the builder pattern.
  factory TextProcessingApiDeleteTaskResponseApplicationJson_Ocs([
    void Function(TextProcessingApiDeleteTaskResponseApplicationJson_OcsBuilder)? b,
  ]) = _$TextProcessingApiDeleteTaskResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const TextProcessingApiDeleteTaskResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextProcessingApiDeleteTaskResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextProcessingApiDeleteTaskResponseApplicationJson_Ocs.
  static Serializer<TextProcessingApiDeleteTaskResponseApplicationJson_Ocs> get serializer =>
      _$textProcessingApiDeleteTaskResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextProcessingApiDeleteTaskResponseApplicationJson_OcsBuilder b) {
    $TextProcessingApiDeleteTaskResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextProcessingApiDeleteTaskResponseApplicationJson_OcsBuilder b) {
    $TextProcessingApiDeleteTaskResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextProcessingApiDeleteTaskResponseApplicationJsonInterface {
  TextProcessingApiDeleteTaskResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextProcessingApiDeleteTaskResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextProcessingApiDeleteTaskResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class TextProcessingApiDeleteTaskResponseApplicationJson
    implements
        $TextProcessingApiDeleteTaskResponseApplicationJsonInterface,
        Built<TextProcessingApiDeleteTaskResponseApplicationJson,
            TextProcessingApiDeleteTaskResponseApplicationJsonBuilder> {
  /// Creates a new TextProcessingApiDeleteTaskResponseApplicationJson object using the builder pattern.
  factory TextProcessingApiDeleteTaskResponseApplicationJson([
    void Function(TextProcessingApiDeleteTaskResponseApplicationJsonBuilder)? b,
  ]) = _$TextProcessingApiDeleteTaskResponseApplicationJson;

  // coverage:ignore-start
  const TextProcessingApiDeleteTaskResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextProcessingApiDeleteTaskResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextProcessingApiDeleteTaskResponseApplicationJson.
  static Serializer<TextProcessingApiDeleteTaskResponseApplicationJson> get serializer =>
      _$textProcessingApiDeleteTaskResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextProcessingApiDeleteTaskResponseApplicationJsonBuilder b) {
    $TextProcessingApiDeleteTaskResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextProcessingApiDeleteTaskResponseApplicationJsonBuilder b) {
    $TextProcessingApiDeleteTaskResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextProcessingApiListTasksByAppResponseApplicationJson_Ocs_DataInterface {
  BuiltList<TextProcessingTask> get tasks;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextProcessingApiListTasksByAppResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextProcessingApiListTasksByAppResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class TextProcessingApiListTasksByAppResponseApplicationJson_Ocs_Data
    implements
        $TextProcessingApiListTasksByAppResponseApplicationJson_Ocs_DataInterface,
        Built<TextProcessingApiListTasksByAppResponseApplicationJson_Ocs_Data,
            TextProcessingApiListTasksByAppResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new TextProcessingApiListTasksByAppResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory TextProcessingApiListTasksByAppResponseApplicationJson_Ocs_Data([
    void Function(TextProcessingApiListTasksByAppResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$TextProcessingApiListTasksByAppResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const TextProcessingApiListTasksByAppResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextProcessingApiListTasksByAppResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextProcessingApiListTasksByAppResponseApplicationJson_Ocs_Data.
  static Serializer<TextProcessingApiListTasksByAppResponseApplicationJson_Ocs_Data> get serializer =>
      _$textProcessingApiListTasksByAppResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextProcessingApiListTasksByAppResponseApplicationJson_Ocs_DataBuilder b) {
    $TextProcessingApiListTasksByAppResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextProcessingApiListTasksByAppResponseApplicationJson_Ocs_DataBuilder b) {
    $TextProcessingApiListTasksByAppResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextProcessingApiListTasksByAppResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  TextProcessingApiListTasksByAppResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextProcessingApiListTasksByAppResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextProcessingApiListTasksByAppResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class TextProcessingApiListTasksByAppResponseApplicationJson_Ocs
    implements
        $TextProcessingApiListTasksByAppResponseApplicationJson_OcsInterface,
        Built<TextProcessingApiListTasksByAppResponseApplicationJson_Ocs,
            TextProcessingApiListTasksByAppResponseApplicationJson_OcsBuilder> {
  /// Creates a new TextProcessingApiListTasksByAppResponseApplicationJson_Ocs object using the builder pattern.
  factory TextProcessingApiListTasksByAppResponseApplicationJson_Ocs([
    void Function(TextProcessingApiListTasksByAppResponseApplicationJson_OcsBuilder)? b,
  ]) = _$TextProcessingApiListTasksByAppResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const TextProcessingApiListTasksByAppResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextProcessingApiListTasksByAppResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextProcessingApiListTasksByAppResponseApplicationJson_Ocs.
  static Serializer<TextProcessingApiListTasksByAppResponseApplicationJson_Ocs> get serializer =>
      _$textProcessingApiListTasksByAppResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextProcessingApiListTasksByAppResponseApplicationJson_OcsBuilder b) {
    $TextProcessingApiListTasksByAppResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextProcessingApiListTasksByAppResponseApplicationJson_OcsBuilder b) {
    $TextProcessingApiListTasksByAppResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextProcessingApiListTasksByAppResponseApplicationJsonInterface {
  TextProcessingApiListTasksByAppResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextProcessingApiListTasksByAppResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextProcessingApiListTasksByAppResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class TextProcessingApiListTasksByAppResponseApplicationJson
    implements
        $TextProcessingApiListTasksByAppResponseApplicationJsonInterface,
        Built<TextProcessingApiListTasksByAppResponseApplicationJson,
            TextProcessingApiListTasksByAppResponseApplicationJsonBuilder> {
  /// Creates a new TextProcessingApiListTasksByAppResponseApplicationJson object using the builder pattern.
  factory TextProcessingApiListTasksByAppResponseApplicationJson([
    void Function(TextProcessingApiListTasksByAppResponseApplicationJsonBuilder)? b,
  ]) = _$TextProcessingApiListTasksByAppResponseApplicationJson;

  // coverage:ignore-start
  const TextProcessingApiListTasksByAppResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextProcessingApiListTasksByAppResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextProcessingApiListTasksByAppResponseApplicationJson.
  static Serializer<TextProcessingApiListTasksByAppResponseApplicationJson> get serializer =>
      _$textProcessingApiListTasksByAppResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextProcessingApiListTasksByAppResponseApplicationJsonBuilder b) {
    $TextProcessingApiListTasksByAppResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextProcessingApiListTasksByAppResponseApplicationJsonBuilder b) {
    $TextProcessingApiListTasksByAppResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextToImageApiIsAvailableResponseApplicationJson_Ocs_DataInterface {
  bool get isAvailable;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextToImageApiIsAvailableResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextToImageApiIsAvailableResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class TextToImageApiIsAvailableResponseApplicationJson_Ocs_Data
    implements
        $TextToImageApiIsAvailableResponseApplicationJson_Ocs_DataInterface,
        Built<TextToImageApiIsAvailableResponseApplicationJson_Ocs_Data,
            TextToImageApiIsAvailableResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new TextToImageApiIsAvailableResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory TextToImageApiIsAvailableResponseApplicationJson_Ocs_Data([
    void Function(TextToImageApiIsAvailableResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$TextToImageApiIsAvailableResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const TextToImageApiIsAvailableResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextToImageApiIsAvailableResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextToImageApiIsAvailableResponseApplicationJson_Ocs_Data.
  static Serializer<TextToImageApiIsAvailableResponseApplicationJson_Ocs_Data> get serializer =>
      _$textToImageApiIsAvailableResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextToImageApiIsAvailableResponseApplicationJson_Ocs_DataBuilder b) {
    $TextToImageApiIsAvailableResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextToImageApiIsAvailableResponseApplicationJson_Ocs_DataBuilder b) {
    $TextToImageApiIsAvailableResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextToImageApiIsAvailableResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  TextToImageApiIsAvailableResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextToImageApiIsAvailableResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextToImageApiIsAvailableResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class TextToImageApiIsAvailableResponseApplicationJson_Ocs
    implements
        $TextToImageApiIsAvailableResponseApplicationJson_OcsInterface,
        Built<TextToImageApiIsAvailableResponseApplicationJson_Ocs,
            TextToImageApiIsAvailableResponseApplicationJson_OcsBuilder> {
  /// Creates a new TextToImageApiIsAvailableResponseApplicationJson_Ocs object using the builder pattern.
  factory TextToImageApiIsAvailableResponseApplicationJson_Ocs([
    void Function(TextToImageApiIsAvailableResponseApplicationJson_OcsBuilder)? b,
  ]) = _$TextToImageApiIsAvailableResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const TextToImageApiIsAvailableResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextToImageApiIsAvailableResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextToImageApiIsAvailableResponseApplicationJson_Ocs.
  static Serializer<TextToImageApiIsAvailableResponseApplicationJson_Ocs> get serializer =>
      _$textToImageApiIsAvailableResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextToImageApiIsAvailableResponseApplicationJson_OcsBuilder b) {
    $TextToImageApiIsAvailableResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextToImageApiIsAvailableResponseApplicationJson_OcsBuilder b) {
    $TextToImageApiIsAvailableResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextToImageApiIsAvailableResponseApplicationJsonInterface {
  TextToImageApiIsAvailableResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextToImageApiIsAvailableResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextToImageApiIsAvailableResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class TextToImageApiIsAvailableResponseApplicationJson
    implements
        $TextToImageApiIsAvailableResponseApplicationJsonInterface,
        Built<TextToImageApiIsAvailableResponseApplicationJson,
            TextToImageApiIsAvailableResponseApplicationJsonBuilder> {
  /// Creates a new TextToImageApiIsAvailableResponseApplicationJson object using the builder pattern.
  factory TextToImageApiIsAvailableResponseApplicationJson([
    void Function(TextToImageApiIsAvailableResponseApplicationJsonBuilder)? b,
  ]) = _$TextToImageApiIsAvailableResponseApplicationJson;

  // coverage:ignore-start
  const TextToImageApiIsAvailableResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextToImageApiIsAvailableResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextToImageApiIsAvailableResponseApplicationJson.
  static Serializer<TextToImageApiIsAvailableResponseApplicationJson> get serializer =>
      _$textToImageApiIsAvailableResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextToImageApiIsAvailableResponseApplicationJsonBuilder b) {
    $TextToImageApiIsAvailableResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextToImageApiIsAvailableResponseApplicationJsonBuilder b) {
    $TextToImageApiIsAvailableResponseApplicationJsonInterface._validate(b);
  }
}

class TextToImageTask_Status extends EnumClass {
  const TextToImageTask_Status._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const TextToImageTask_Status $0 = _$textToImageTaskStatus$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const TextToImageTask_Status $1 = _$textToImageTaskStatus$1;

  /// `2`
  @BuiltValueEnumConst(wireName: '2')
  static const TextToImageTask_Status $2 = _$textToImageTaskStatus$2;

  /// `3`
  @BuiltValueEnumConst(wireName: '3')
  static const TextToImageTask_Status $3 = _$textToImageTaskStatus$3;

  /// `4`
  @BuiltValueEnumConst(wireName: '4')
  static const TextToImageTask_Status $4 = _$textToImageTaskStatus$4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<TextToImageTask_Status> get values => _$textToImageTaskStatusValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static TextToImageTask_Status valueOf(String name) => _$valueOfTextToImageTask_Status(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for TextToImageTask_Status.
  @BuiltValueSerializer(custom: true)
  static Serializer<TextToImageTask_Status> get serializer => const _$TextToImageTask_StatusSerializer();
}

class _$TextToImageTask_StatusSerializer implements PrimitiveSerializer<TextToImageTask_Status> {
  const _$TextToImageTask_StatusSerializer();

  static const Map<TextToImageTask_Status, Object> _toWire = <TextToImageTask_Status, Object>{
    TextToImageTask_Status.$0: 0,
    TextToImageTask_Status.$1: 1,
    TextToImageTask_Status.$2: 2,
    TextToImageTask_Status.$3: 3,
    TextToImageTask_Status.$4: 4,
  };

  static const Map<Object, TextToImageTask_Status> _fromWire = <Object, TextToImageTask_Status>{
    0: TextToImageTask_Status.$0,
    1: TextToImageTask_Status.$1,
    2: TextToImageTask_Status.$2,
    3: TextToImageTask_Status.$3,
    4: TextToImageTask_Status.$4,
  };

  @override
  Iterable<Type> get types => const [TextToImageTask_Status];

  @override
  String get wireName => 'TextToImageTask_Status';

  @override
  Object serialize(
    Serializers serializers,
    TextToImageTask_Status object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  TextToImageTask_Status deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $TextToImageTaskInterface {
  int? get id;
  TextToImageTask_Status get status;
  String? get userId;
  String get appId;
  String get input;
  String? get identifier;
  int get numberOfImages;
  int? get completionExpectedAt;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextToImageTaskInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextToImageTaskInterfaceBuilder b) {}
}

abstract class TextToImageTask implements $TextToImageTaskInterface, Built<TextToImageTask, TextToImageTaskBuilder> {
  /// Creates a new TextToImageTask object using the builder pattern.
  factory TextToImageTask([void Function(TextToImageTaskBuilder)? b]) = _$TextToImageTask;

  // coverage:ignore-start
  const TextToImageTask._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextToImageTask.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextToImageTask.
  static Serializer<TextToImageTask> get serializer => _$textToImageTaskSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextToImageTaskBuilder b) {
    $TextToImageTaskInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextToImageTaskBuilder b) {
    $TextToImageTaskInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextToImageApiScheduleResponseApplicationJson_Ocs_DataInterface {
  TextToImageTask get task;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextToImageApiScheduleResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextToImageApiScheduleResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class TextToImageApiScheduleResponseApplicationJson_Ocs_Data
    implements
        $TextToImageApiScheduleResponseApplicationJson_Ocs_DataInterface,
        Built<TextToImageApiScheduleResponseApplicationJson_Ocs_Data,
            TextToImageApiScheduleResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new TextToImageApiScheduleResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory TextToImageApiScheduleResponseApplicationJson_Ocs_Data([
    void Function(TextToImageApiScheduleResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$TextToImageApiScheduleResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const TextToImageApiScheduleResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextToImageApiScheduleResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextToImageApiScheduleResponseApplicationJson_Ocs_Data.
  static Serializer<TextToImageApiScheduleResponseApplicationJson_Ocs_Data> get serializer =>
      _$textToImageApiScheduleResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextToImageApiScheduleResponseApplicationJson_Ocs_DataBuilder b) {
    $TextToImageApiScheduleResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextToImageApiScheduleResponseApplicationJson_Ocs_DataBuilder b) {
    $TextToImageApiScheduleResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextToImageApiScheduleResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  TextToImageApiScheduleResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextToImageApiScheduleResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextToImageApiScheduleResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class TextToImageApiScheduleResponseApplicationJson_Ocs
    implements
        $TextToImageApiScheduleResponseApplicationJson_OcsInterface,
        Built<TextToImageApiScheduleResponseApplicationJson_Ocs,
            TextToImageApiScheduleResponseApplicationJson_OcsBuilder> {
  /// Creates a new TextToImageApiScheduleResponseApplicationJson_Ocs object using the builder pattern.
  factory TextToImageApiScheduleResponseApplicationJson_Ocs([
    void Function(TextToImageApiScheduleResponseApplicationJson_OcsBuilder)? b,
  ]) = _$TextToImageApiScheduleResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const TextToImageApiScheduleResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextToImageApiScheduleResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextToImageApiScheduleResponseApplicationJson_Ocs.
  static Serializer<TextToImageApiScheduleResponseApplicationJson_Ocs> get serializer =>
      _$textToImageApiScheduleResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextToImageApiScheduleResponseApplicationJson_OcsBuilder b) {
    $TextToImageApiScheduleResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextToImageApiScheduleResponseApplicationJson_OcsBuilder b) {
    $TextToImageApiScheduleResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextToImageApiScheduleResponseApplicationJsonInterface {
  TextToImageApiScheduleResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextToImageApiScheduleResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextToImageApiScheduleResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class TextToImageApiScheduleResponseApplicationJson
    implements
        $TextToImageApiScheduleResponseApplicationJsonInterface,
        Built<TextToImageApiScheduleResponseApplicationJson, TextToImageApiScheduleResponseApplicationJsonBuilder> {
  /// Creates a new TextToImageApiScheduleResponseApplicationJson object using the builder pattern.
  factory TextToImageApiScheduleResponseApplicationJson([
    void Function(TextToImageApiScheduleResponseApplicationJsonBuilder)? b,
  ]) = _$TextToImageApiScheduleResponseApplicationJson;

  // coverage:ignore-start
  const TextToImageApiScheduleResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextToImageApiScheduleResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextToImageApiScheduleResponseApplicationJson.
  static Serializer<TextToImageApiScheduleResponseApplicationJson> get serializer =>
      _$textToImageApiScheduleResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextToImageApiScheduleResponseApplicationJsonBuilder b) {
    $TextToImageApiScheduleResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextToImageApiScheduleResponseApplicationJsonBuilder b) {
    $TextToImageApiScheduleResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextToImageApiGetTaskResponseApplicationJson_Ocs_DataInterface {
  TextToImageTask get task;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextToImageApiGetTaskResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextToImageApiGetTaskResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class TextToImageApiGetTaskResponseApplicationJson_Ocs_Data
    implements
        $TextToImageApiGetTaskResponseApplicationJson_Ocs_DataInterface,
        Built<TextToImageApiGetTaskResponseApplicationJson_Ocs_Data,
            TextToImageApiGetTaskResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new TextToImageApiGetTaskResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory TextToImageApiGetTaskResponseApplicationJson_Ocs_Data([
    void Function(TextToImageApiGetTaskResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$TextToImageApiGetTaskResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const TextToImageApiGetTaskResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextToImageApiGetTaskResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextToImageApiGetTaskResponseApplicationJson_Ocs_Data.
  static Serializer<TextToImageApiGetTaskResponseApplicationJson_Ocs_Data> get serializer =>
      _$textToImageApiGetTaskResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextToImageApiGetTaskResponseApplicationJson_Ocs_DataBuilder b) {
    $TextToImageApiGetTaskResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextToImageApiGetTaskResponseApplicationJson_Ocs_DataBuilder b) {
    $TextToImageApiGetTaskResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextToImageApiGetTaskResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  TextToImageApiGetTaskResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextToImageApiGetTaskResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextToImageApiGetTaskResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class TextToImageApiGetTaskResponseApplicationJson_Ocs
    implements
        $TextToImageApiGetTaskResponseApplicationJson_OcsInterface,
        Built<TextToImageApiGetTaskResponseApplicationJson_Ocs,
            TextToImageApiGetTaskResponseApplicationJson_OcsBuilder> {
  /// Creates a new TextToImageApiGetTaskResponseApplicationJson_Ocs object using the builder pattern.
  factory TextToImageApiGetTaskResponseApplicationJson_Ocs([
    void Function(TextToImageApiGetTaskResponseApplicationJson_OcsBuilder)? b,
  ]) = _$TextToImageApiGetTaskResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const TextToImageApiGetTaskResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextToImageApiGetTaskResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextToImageApiGetTaskResponseApplicationJson_Ocs.
  static Serializer<TextToImageApiGetTaskResponseApplicationJson_Ocs> get serializer =>
      _$textToImageApiGetTaskResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextToImageApiGetTaskResponseApplicationJson_OcsBuilder b) {
    $TextToImageApiGetTaskResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextToImageApiGetTaskResponseApplicationJson_OcsBuilder b) {
    $TextToImageApiGetTaskResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextToImageApiGetTaskResponseApplicationJsonInterface {
  TextToImageApiGetTaskResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextToImageApiGetTaskResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextToImageApiGetTaskResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class TextToImageApiGetTaskResponseApplicationJson
    implements
        $TextToImageApiGetTaskResponseApplicationJsonInterface,
        Built<TextToImageApiGetTaskResponseApplicationJson, TextToImageApiGetTaskResponseApplicationJsonBuilder> {
  /// Creates a new TextToImageApiGetTaskResponseApplicationJson object using the builder pattern.
  factory TextToImageApiGetTaskResponseApplicationJson([
    void Function(TextToImageApiGetTaskResponseApplicationJsonBuilder)? b,
  ]) = _$TextToImageApiGetTaskResponseApplicationJson;

  // coverage:ignore-start
  const TextToImageApiGetTaskResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextToImageApiGetTaskResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextToImageApiGetTaskResponseApplicationJson.
  static Serializer<TextToImageApiGetTaskResponseApplicationJson> get serializer =>
      _$textToImageApiGetTaskResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextToImageApiGetTaskResponseApplicationJsonBuilder b) {
    $TextToImageApiGetTaskResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextToImageApiGetTaskResponseApplicationJsonBuilder b) {
    $TextToImageApiGetTaskResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextToImageApiDeleteTaskResponseApplicationJson_Ocs_DataInterface {
  TextToImageTask get task;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextToImageApiDeleteTaskResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextToImageApiDeleteTaskResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class TextToImageApiDeleteTaskResponseApplicationJson_Ocs_Data
    implements
        $TextToImageApiDeleteTaskResponseApplicationJson_Ocs_DataInterface,
        Built<TextToImageApiDeleteTaskResponseApplicationJson_Ocs_Data,
            TextToImageApiDeleteTaskResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new TextToImageApiDeleteTaskResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory TextToImageApiDeleteTaskResponseApplicationJson_Ocs_Data([
    void Function(TextToImageApiDeleteTaskResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$TextToImageApiDeleteTaskResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const TextToImageApiDeleteTaskResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextToImageApiDeleteTaskResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextToImageApiDeleteTaskResponseApplicationJson_Ocs_Data.
  static Serializer<TextToImageApiDeleteTaskResponseApplicationJson_Ocs_Data> get serializer =>
      _$textToImageApiDeleteTaskResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextToImageApiDeleteTaskResponseApplicationJson_Ocs_DataBuilder b) {
    $TextToImageApiDeleteTaskResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextToImageApiDeleteTaskResponseApplicationJson_Ocs_DataBuilder b) {
    $TextToImageApiDeleteTaskResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextToImageApiDeleteTaskResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  TextToImageApiDeleteTaskResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextToImageApiDeleteTaskResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextToImageApiDeleteTaskResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class TextToImageApiDeleteTaskResponseApplicationJson_Ocs
    implements
        $TextToImageApiDeleteTaskResponseApplicationJson_OcsInterface,
        Built<TextToImageApiDeleteTaskResponseApplicationJson_Ocs,
            TextToImageApiDeleteTaskResponseApplicationJson_OcsBuilder> {
  /// Creates a new TextToImageApiDeleteTaskResponseApplicationJson_Ocs object using the builder pattern.
  factory TextToImageApiDeleteTaskResponseApplicationJson_Ocs([
    void Function(TextToImageApiDeleteTaskResponseApplicationJson_OcsBuilder)? b,
  ]) = _$TextToImageApiDeleteTaskResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const TextToImageApiDeleteTaskResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextToImageApiDeleteTaskResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextToImageApiDeleteTaskResponseApplicationJson_Ocs.
  static Serializer<TextToImageApiDeleteTaskResponseApplicationJson_Ocs> get serializer =>
      _$textToImageApiDeleteTaskResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextToImageApiDeleteTaskResponseApplicationJson_OcsBuilder b) {
    $TextToImageApiDeleteTaskResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextToImageApiDeleteTaskResponseApplicationJson_OcsBuilder b) {
    $TextToImageApiDeleteTaskResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextToImageApiDeleteTaskResponseApplicationJsonInterface {
  TextToImageApiDeleteTaskResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextToImageApiDeleteTaskResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextToImageApiDeleteTaskResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class TextToImageApiDeleteTaskResponseApplicationJson
    implements
        $TextToImageApiDeleteTaskResponseApplicationJsonInterface,
        Built<TextToImageApiDeleteTaskResponseApplicationJson, TextToImageApiDeleteTaskResponseApplicationJsonBuilder> {
  /// Creates a new TextToImageApiDeleteTaskResponseApplicationJson object using the builder pattern.
  factory TextToImageApiDeleteTaskResponseApplicationJson([
    void Function(TextToImageApiDeleteTaskResponseApplicationJsonBuilder)? b,
  ]) = _$TextToImageApiDeleteTaskResponseApplicationJson;

  // coverage:ignore-start
  const TextToImageApiDeleteTaskResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextToImageApiDeleteTaskResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextToImageApiDeleteTaskResponseApplicationJson.
  static Serializer<TextToImageApiDeleteTaskResponseApplicationJson> get serializer =>
      _$textToImageApiDeleteTaskResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextToImageApiDeleteTaskResponseApplicationJsonBuilder b) {
    $TextToImageApiDeleteTaskResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextToImageApiDeleteTaskResponseApplicationJsonBuilder b) {
    $TextToImageApiDeleteTaskResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextToImageApiListTasksByAppResponseApplicationJson_Ocs_DataInterface {
  BuiltList<TextToImageTask> get tasks;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextToImageApiListTasksByAppResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextToImageApiListTasksByAppResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class TextToImageApiListTasksByAppResponseApplicationJson_Ocs_Data
    implements
        $TextToImageApiListTasksByAppResponseApplicationJson_Ocs_DataInterface,
        Built<TextToImageApiListTasksByAppResponseApplicationJson_Ocs_Data,
            TextToImageApiListTasksByAppResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new TextToImageApiListTasksByAppResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory TextToImageApiListTasksByAppResponseApplicationJson_Ocs_Data([
    void Function(TextToImageApiListTasksByAppResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$TextToImageApiListTasksByAppResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const TextToImageApiListTasksByAppResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextToImageApiListTasksByAppResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextToImageApiListTasksByAppResponseApplicationJson_Ocs_Data.
  static Serializer<TextToImageApiListTasksByAppResponseApplicationJson_Ocs_Data> get serializer =>
      _$textToImageApiListTasksByAppResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextToImageApiListTasksByAppResponseApplicationJson_Ocs_DataBuilder b) {
    $TextToImageApiListTasksByAppResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextToImageApiListTasksByAppResponseApplicationJson_Ocs_DataBuilder b) {
    $TextToImageApiListTasksByAppResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextToImageApiListTasksByAppResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  TextToImageApiListTasksByAppResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextToImageApiListTasksByAppResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextToImageApiListTasksByAppResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class TextToImageApiListTasksByAppResponseApplicationJson_Ocs
    implements
        $TextToImageApiListTasksByAppResponseApplicationJson_OcsInterface,
        Built<TextToImageApiListTasksByAppResponseApplicationJson_Ocs,
            TextToImageApiListTasksByAppResponseApplicationJson_OcsBuilder> {
  /// Creates a new TextToImageApiListTasksByAppResponseApplicationJson_Ocs object using the builder pattern.
  factory TextToImageApiListTasksByAppResponseApplicationJson_Ocs([
    void Function(TextToImageApiListTasksByAppResponseApplicationJson_OcsBuilder)? b,
  ]) = _$TextToImageApiListTasksByAppResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const TextToImageApiListTasksByAppResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextToImageApiListTasksByAppResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextToImageApiListTasksByAppResponseApplicationJson_Ocs.
  static Serializer<TextToImageApiListTasksByAppResponseApplicationJson_Ocs> get serializer =>
      _$textToImageApiListTasksByAppResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextToImageApiListTasksByAppResponseApplicationJson_OcsBuilder b) {
    $TextToImageApiListTasksByAppResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextToImageApiListTasksByAppResponseApplicationJson_OcsBuilder b) {
    $TextToImageApiListTasksByAppResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TextToImageApiListTasksByAppResponseApplicationJsonInterface {
  TextToImageApiListTasksByAppResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TextToImageApiListTasksByAppResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TextToImageApiListTasksByAppResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class TextToImageApiListTasksByAppResponseApplicationJson
    implements
        $TextToImageApiListTasksByAppResponseApplicationJsonInterface,
        Built<TextToImageApiListTasksByAppResponseApplicationJson,
            TextToImageApiListTasksByAppResponseApplicationJsonBuilder> {
  /// Creates a new TextToImageApiListTasksByAppResponseApplicationJson object using the builder pattern.
  factory TextToImageApiListTasksByAppResponseApplicationJson([
    void Function(TextToImageApiListTasksByAppResponseApplicationJsonBuilder)? b,
  ]) = _$TextToImageApiListTasksByAppResponseApplicationJson;

  // coverage:ignore-start
  const TextToImageApiListTasksByAppResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TextToImageApiListTasksByAppResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TextToImageApiListTasksByAppResponseApplicationJson.
  static Serializer<TextToImageApiListTasksByAppResponseApplicationJson> get serializer =>
      _$textToImageApiListTasksByAppResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TextToImageApiListTasksByAppResponseApplicationJsonBuilder b) {
    $TextToImageApiListTasksByAppResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TextToImageApiListTasksByAppResponseApplicationJsonBuilder b) {
    $TextToImageApiListTasksByAppResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TranslationApiLanguagesResponseApplicationJson_Ocs_Data_LanguagesInterface {
  String get from;
  String get fromLabel;
  String get to;
  String get toLabel;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TranslationApiLanguagesResponseApplicationJson_Ocs_Data_LanguagesInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TranslationApiLanguagesResponseApplicationJson_Ocs_Data_LanguagesInterfaceBuilder b) {}
}

abstract class TranslationApiLanguagesResponseApplicationJson_Ocs_Data_Languages
    implements
        $TranslationApiLanguagesResponseApplicationJson_Ocs_Data_LanguagesInterface,
        Built<TranslationApiLanguagesResponseApplicationJson_Ocs_Data_Languages,
            TranslationApiLanguagesResponseApplicationJson_Ocs_Data_LanguagesBuilder> {
  /// Creates a new TranslationApiLanguagesResponseApplicationJson_Ocs_Data_Languages object using the builder pattern.
  factory TranslationApiLanguagesResponseApplicationJson_Ocs_Data_Languages([
    void Function(TranslationApiLanguagesResponseApplicationJson_Ocs_Data_LanguagesBuilder)? b,
  ]) = _$TranslationApiLanguagesResponseApplicationJson_Ocs_Data_Languages;

  // coverage:ignore-start
  const TranslationApiLanguagesResponseApplicationJson_Ocs_Data_Languages._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TranslationApiLanguagesResponseApplicationJson_Ocs_Data_Languages.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TranslationApiLanguagesResponseApplicationJson_Ocs_Data_Languages.
  static Serializer<TranslationApiLanguagesResponseApplicationJson_Ocs_Data_Languages> get serializer =>
      _$translationApiLanguagesResponseApplicationJsonOcsDataLanguagesSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TranslationApiLanguagesResponseApplicationJson_Ocs_Data_LanguagesBuilder b) {
    $TranslationApiLanguagesResponseApplicationJson_Ocs_Data_LanguagesInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TranslationApiLanguagesResponseApplicationJson_Ocs_Data_LanguagesBuilder b) {
    $TranslationApiLanguagesResponseApplicationJson_Ocs_Data_LanguagesInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TranslationApiLanguagesResponseApplicationJson_Ocs_DataInterface {
  BuiltList<TranslationApiLanguagesResponseApplicationJson_Ocs_Data_Languages> get languages;
  bool get languageDetection;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TranslationApiLanguagesResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TranslationApiLanguagesResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class TranslationApiLanguagesResponseApplicationJson_Ocs_Data
    implements
        $TranslationApiLanguagesResponseApplicationJson_Ocs_DataInterface,
        Built<TranslationApiLanguagesResponseApplicationJson_Ocs_Data,
            TranslationApiLanguagesResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new TranslationApiLanguagesResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory TranslationApiLanguagesResponseApplicationJson_Ocs_Data([
    void Function(TranslationApiLanguagesResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$TranslationApiLanguagesResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const TranslationApiLanguagesResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TranslationApiLanguagesResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TranslationApiLanguagesResponseApplicationJson_Ocs_Data.
  static Serializer<TranslationApiLanguagesResponseApplicationJson_Ocs_Data> get serializer =>
      _$translationApiLanguagesResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TranslationApiLanguagesResponseApplicationJson_Ocs_DataBuilder b) {
    $TranslationApiLanguagesResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TranslationApiLanguagesResponseApplicationJson_Ocs_DataBuilder b) {
    $TranslationApiLanguagesResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TranslationApiLanguagesResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  TranslationApiLanguagesResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TranslationApiLanguagesResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TranslationApiLanguagesResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class TranslationApiLanguagesResponseApplicationJson_Ocs
    implements
        $TranslationApiLanguagesResponseApplicationJson_OcsInterface,
        Built<TranslationApiLanguagesResponseApplicationJson_Ocs,
            TranslationApiLanguagesResponseApplicationJson_OcsBuilder> {
  /// Creates a new TranslationApiLanguagesResponseApplicationJson_Ocs object using the builder pattern.
  factory TranslationApiLanguagesResponseApplicationJson_Ocs([
    void Function(TranslationApiLanguagesResponseApplicationJson_OcsBuilder)? b,
  ]) = _$TranslationApiLanguagesResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const TranslationApiLanguagesResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TranslationApiLanguagesResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TranslationApiLanguagesResponseApplicationJson_Ocs.
  static Serializer<TranslationApiLanguagesResponseApplicationJson_Ocs> get serializer =>
      _$translationApiLanguagesResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TranslationApiLanguagesResponseApplicationJson_OcsBuilder b) {
    $TranslationApiLanguagesResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TranslationApiLanguagesResponseApplicationJson_OcsBuilder b) {
    $TranslationApiLanguagesResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TranslationApiLanguagesResponseApplicationJsonInterface {
  TranslationApiLanguagesResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TranslationApiLanguagesResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TranslationApiLanguagesResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class TranslationApiLanguagesResponseApplicationJson
    implements
        $TranslationApiLanguagesResponseApplicationJsonInterface,
        Built<TranslationApiLanguagesResponseApplicationJson, TranslationApiLanguagesResponseApplicationJsonBuilder> {
  /// Creates a new TranslationApiLanguagesResponseApplicationJson object using the builder pattern.
  factory TranslationApiLanguagesResponseApplicationJson([
    void Function(TranslationApiLanguagesResponseApplicationJsonBuilder)? b,
  ]) = _$TranslationApiLanguagesResponseApplicationJson;

  // coverage:ignore-start
  const TranslationApiLanguagesResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TranslationApiLanguagesResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TranslationApiLanguagesResponseApplicationJson.
  static Serializer<TranslationApiLanguagesResponseApplicationJson> get serializer =>
      _$translationApiLanguagesResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TranslationApiLanguagesResponseApplicationJsonBuilder b) {
    $TranslationApiLanguagesResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TranslationApiLanguagesResponseApplicationJsonBuilder b) {
    $TranslationApiLanguagesResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TranslationApiTranslateResponseApplicationJson_Ocs_DataInterface {
  String get text;
  String? get from;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TranslationApiTranslateResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TranslationApiTranslateResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class TranslationApiTranslateResponseApplicationJson_Ocs_Data
    implements
        $TranslationApiTranslateResponseApplicationJson_Ocs_DataInterface,
        Built<TranslationApiTranslateResponseApplicationJson_Ocs_Data,
            TranslationApiTranslateResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new TranslationApiTranslateResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory TranslationApiTranslateResponseApplicationJson_Ocs_Data([
    void Function(TranslationApiTranslateResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$TranslationApiTranslateResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const TranslationApiTranslateResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TranslationApiTranslateResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TranslationApiTranslateResponseApplicationJson_Ocs_Data.
  static Serializer<TranslationApiTranslateResponseApplicationJson_Ocs_Data> get serializer =>
      _$translationApiTranslateResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TranslationApiTranslateResponseApplicationJson_Ocs_DataBuilder b) {
    $TranslationApiTranslateResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TranslationApiTranslateResponseApplicationJson_Ocs_DataBuilder b) {
    $TranslationApiTranslateResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TranslationApiTranslateResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  TranslationApiTranslateResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TranslationApiTranslateResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TranslationApiTranslateResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class TranslationApiTranslateResponseApplicationJson_Ocs
    implements
        $TranslationApiTranslateResponseApplicationJson_OcsInterface,
        Built<TranslationApiTranslateResponseApplicationJson_Ocs,
            TranslationApiTranslateResponseApplicationJson_OcsBuilder> {
  /// Creates a new TranslationApiTranslateResponseApplicationJson_Ocs object using the builder pattern.
  factory TranslationApiTranslateResponseApplicationJson_Ocs([
    void Function(TranslationApiTranslateResponseApplicationJson_OcsBuilder)? b,
  ]) = _$TranslationApiTranslateResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const TranslationApiTranslateResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TranslationApiTranslateResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TranslationApiTranslateResponseApplicationJson_Ocs.
  static Serializer<TranslationApiTranslateResponseApplicationJson_Ocs> get serializer =>
      _$translationApiTranslateResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TranslationApiTranslateResponseApplicationJson_OcsBuilder b) {
    $TranslationApiTranslateResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TranslationApiTranslateResponseApplicationJson_OcsBuilder b) {
    $TranslationApiTranslateResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TranslationApiTranslateResponseApplicationJsonInterface {
  TranslationApiTranslateResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TranslationApiTranslateResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TranslationApiTranslateResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class TranslationApiTranslateResponseApplicationJson
    implements
        $TranslationApiTranslateResponseApplicationJsonInterface,
        Built<TranslationApiTranslateResponseApplicationJson, TranslationApiTranslateResponseApplicationJsonBuilder> {
  /// Creates a new TranslationApiTranslateResponseApplicationJson object using the builder pattern.
  factory TranslationApiTranslateResponseApplicationJson([
    void Function(TranslationApiTranslateResponseApplicationJsonBuilder)? b,
  ]) = _$TranslationApiTranslateResponseApplicationJson;

  // coverage:ignore-start
  const TranslationApiTranslateResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TranslationApiTranslateResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TranslationApiTranslateResponseApplicationJson.
  static Serializer<TranslationApiTranslateResponseApplicationJson> get serializer =>
      _$translationApiTranslateResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TranslationApiTranslateResponseApplicationJsonBuilder b) {
    $TranslationApiTranslateResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TranslationApiTranslateResponseApplicationJsonBuilder b) {
    $TranslationApiTranslateResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $UnifiedSearchProviderInterface {
  String get id;
  String? get appId;
  String get name;
  String? get icon;
  int get order;
  BuiltList<String>? get triggers;
  BuiltMap<String, String>? get filters;
  bool? get inAppSearch;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($UnifiedSearchProviderInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($UnifiedSearchProviderInterfaceBuilder b) {}
}

abstract class UnifiedSearchProvider
    implements $UnifiedSearchProviderInterface, Built<UnifiedSearchProvider, UnifiedSearchProviderBuilder> {
  /// Creates a new UnifiedSearchProvider object using the builder pattern.
  factory UnifiedSearchProvider([void Function(UnifiedSearchProviderBuilder)? b]) = _$UnifiedSearchProvider;

  // coverage:ignore-start
  const UnifiedSearchProvider._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory UnifiedSearchProvider.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for UnifiedSearchProvider.
  static Serializer<UnifiedSearchProvider> get serializer => _$unifiedSearchProviderSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(UnifiedSearchProviderBuilder b) {
    $UnifiedSearchProviderInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(UnifiedSearchProviderBuilder b) {
    $UnifiedSearchProviderInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $UnifiedSearchGetProvidersResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<UnifiedSearchProvider> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($UnifiedSearchGetProvidersResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($UnifiedSearchGetProvidersResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class UnifiedSearchGetProvidersResponseApplicationJson_Ocs
    implements
        $UnifiedSearchGetProvidersResponseApplicationJson_OcsInterface,
        Built<UnifiedSearchGetProvidersResponseApplicationJson_Ocs,
            UnifiedSearchGetProvidersResponseApplicationJson_OcsBuilder> {
  /// Creates a new UnifiedSearchGetProvidersResponseApplicationJson_Ocs object using the builder pattern.
  factory UnifiedSearchGetProvidersResponseApplicationJson_Ocs([
    void Function(UnifiedSearchGetProvidersResponseApplicationJson_OcsBuilder)? b,
  ]) = _$UnifiedSearchGetProvidersResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const UnifiedSearchGetProvidersResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory UnifiedSearchGetProvidersResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for UnifiedSearchGetProvidersResponseApplicationJson_Ocs.
  static Serializer<UnifiedSearchGetProvidersResponseApplicationJson_Ocs> get serializer =>
      _$unifiedSearchGetProvidersResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(UnifiedSearchGetProvidersResponseApplicationJson_OcsBuilder b) {
    $UnifiedSearchGetProvidersResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(UnifiedSearchGetProvidersResponseApplicationJson_OcsBuilder b) {
    $UnifiedSearchGetProvidersResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $UnifiedSearchGetProvidersResponseApplicationJsonInterface {
  UnifiedSearchGetProvidersResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($UnifiedSearchGetProvidersResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($UnifiedSearchGetProvidersResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class UnifiedSearchGetProvidersResponseApplicationJson
    implements
        $UnifiedSearchGetProvidersResponseApplicationJsonInterface,
        Built<UnifiedSearchGetProvidersResponseApplicationJson,
            UnifiedSearchGetProvidersResponseApplicationJsonBuilder> {
  /// Creates a new UnifiedSearchGetProvidersResponseApplicationJson object using the builder pattern.
  factory UnifiedSearchGetProvidersResponseApplicationJson([
    void Function(UnifiedSearchGetProvidersResponseApplicationJsonBuilder)? b,
  ]) = _$UnifiedSearchGetProvidersResponseApplicationJson;

  // coverage:ignore-start
  const UnifiedSearchGetProvidersResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory UnifiedSearchGetProvidersResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for UnifiedSearchGetProvidersResponseApplicationJson.
  static Serializer<UnifiedSearchGetProvidersResponseApplicationJson> get serializer =>
      _$unifiedSearchGetProvidersResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(UnifiedSearchGetProvidersResponseApplicationJsonBuilder b) {
    $UnifiedSearchGetProvidersResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(UnifiedSearchGetProvidersResponseApplicationJsonBuilder b) {
    $UnifiedSearchGetProvidersResponseApplicationJsonInterface._validate(b);
  }
}

typedef UnifiedSearchSearchCursor = ({int? $int, String? string});

@BuiltValue(instantiable: false)
abstract interface class $UnifiedSearchResultEntryInterface {
  String get thumbnailUrl;
  String get title;
  String get subline;
  String get resourceUrl;
  String get icon;
  bool get rounded;
  BuiltList<String> get attributes;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($UnifiedSearchResultEntryInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($UnifiedSearchResultEntryInterfaceBuilder b) {}
}

abstract class UnifiedSearchResultEntry
    implements $UnifiedSearchResultEntryInterface, Built<UnifiedSearchResultEntry, UnifiedSearchResultEntryBuilder> {
  /// Creates a new UnifiedSearchResultEntry object using the builder pattern.
  factory UnifiedSearchResultEntry([void Function(UnifiedSearchResultEntryBuilder)? b]) = _$UnifiedSearchResultEntry;

  // coverage:ignore-start
  const UnifiedSearchResultEntry._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory UnifiedSearchResultEntry.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for UnifiedSearchResultEntry.
  static Serializer<UnifiedSearchResultEntry> get serializer => _$unifiedSearchResultEntrySerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(UnifiedSearchResultEntryBuilder b) {
    $UnifiedSearchResultEntryInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(UnifiedSearchResultEntryBuilder b) {
    $UnifiedSearchResultEntryInterface._validate(b);
  }
}

typedef UnifiedSearchResult_Cursor = ({int? $int, String? string});

@BuiltValue(instantiable: false)
abstract interface class $UnifiedSearchResultInterface {
  String get name;
  bool get isPaginated;
  BuiltList<UnifiedSearchResultEntry> get entries;
  UnifiedSearchResult_Cursor? get cursor;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($UnifiedSearchResultInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($UnifiedSearchResultInterfaceBuilder b) {
    b.cursor?.validateOneOf();
  }
}

abstract class UnifiedSearchResult
    implements $UnifiedSearchResultInterface, Built<UnifiedSearchResult, UnifiedSearchResultBuilder> {
  /// Creates a new UnifiedSearchResult object using the builder pattern.
  factory UnifiedSearchResult([void Function(UnifiedSearchResultBuilder)? b]) = _$UnifiedSearchResult;

  // coverage:ignore-start
  const UnifiedSearchResult._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory UnifiedSearchResult.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for UnifiedSearchResult.
  static Serializer<UnifiedSearchResult> get serializer => _$unifiedSearchResultSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(UnifiedSearchResultBuilder b) {
    $UnifiedSearchResultInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(UnifiedSearchResultBuilder b) {
    $UnifiedSearchResultInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $UnifiedSearchSearchResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  UnifiedSearchResult get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($UnifiedSearchSearchResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($UnifiedSearchSearchResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class UnifiedSearchSearchResponseApplicationJson_Ocs
    implements
        $UnifiedSearchSearchResponseApplicationJson_OcsInterface,
        Built<UnifiedSearchSearchResponseApplicationJson_Ocs, UnifiedSearchSearchResponseApplicationJson_OcsBuilder> {
  /// Creates a new UnifiedSearchSearchResponseApplicationJson_Ocs object using the builder pattern.
  factory UnifiedSearchSearchResponseApplicationJson_Ocs([
    void Function(UnifiedSearchSearchResponseApplicationJson_OcsBuilder)? b,
  ]) = _$UnifiedSearchSearchResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const UnifiedSearchSearchResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory UnifiedSearchSearchResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for UnifiedSearchSearchResponseApplicationJson_Ocs.
  static Serializer<UnifiedSearchSearchResponseApplicationJson_Ocs> get serializer =>
      _$unifiedSearchSearchResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(UnifiedSearchSearchResponseApplicationJson_OcsBuilder b) {
    $UnifiedSearchSearchResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(UnifiedSearchSearchResponseApplicationJson_OcsBuilder b) {
    $UnifiedSearchSearchResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $UnifiedSearchSearchResponseApplicationJsonInterface {
  UnifiedSearchSearchResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($UnifiedSearchSearchResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($UnifiedSearchSearchResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class UnifiedSearchSearchResponseApplicationJson
    implements
        $UnifiedSearchSearchResponseApplicationJsonInterface,
        Built<UnifiedSearchSearchResponseApplicationJson, UnifiedSearchSearchResponseApplicationJsonBuilder> {
  /// Creates a new UnifiedSearchSearchResponseApplicationJson object using the builder pattern.
  factory UnifiedSearchSearchResponseApplicationJson([
    void Function(UnifiedSearchSearchResponseApplicationJsonBuilder)? b,
  ]) = _$UnifiedSearchSearchResponseApplicationJson;

  // coverage:ignore-start
  const UnifiedSearchSearchResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory UnifiedSearchSearchResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for UnifiedSearchSearchResponseApplicationJson.
  static Serializer<UnifiedSearchSearchResponseApplicationJson> get serializer =>
      _$unifiedSearchSearchResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(UnifiedSearchSearchResponseApplicationJsonBuilder b) {
    $UnifiedSearchSearchResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(UnifiedSearchSearchResponseApplicationJsonBuilder b) {
    $UnifiedSearchSearchResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $WhatsNewGetResponseApplicationJson_Ocs_Data_WhatsNewInterface {
  BuiltList<String> get regular;
  BuiltList<String> get admin;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($WhatsNewGetResponseApplicationJson_Ocs_Data_WhatsNewInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($WhatsNewGetResponseApplicationJson_Ocs_Data_WhatsNewInterfaceBuilder b) {}
}

abstract class WhatsNewGetResponseApplicationJson_Ocs_Data_WhatsNew
    implements
        $WhatsNewGetResponseApplicationJson_Ocs_Data_WhatsNewInterface,
        Built<WhatsNewGetResponseApplicationJson_Ocs_Data_WhatsNew,
            WhatsNewGetResponseApplicationJson_Ocs_Data_WhatsNewBuilder> {
  /// Creates a new WhatsNewGetResponseApplicationJson_Ocs_Data_WhatsNew object using the builder pattern.
  factory WhatsNewGetResponseApplicationJson_Ocs_Data_WhatsNew([
    void Function(WhatsNewGetResponseApplicationJson_Ocs_Data_WhatsNewBuilder)? b,
  ]) = _$WhatsNewGetResponseApplicationJson_Ocs_Data_WhatsNew;

  // coverage:ignore-start
  const WhatsNewGetResponseApplicationJson_Ocs_Data_WhatsNew._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory WhatsNewGetResponseApplicationJson_Ocs_Data_WhatsNew.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for WhatsNewGetResponseApplicationJson_Ocs_Data_WhatsNew.
  static Serializer<WhatsNewGetResponseApplicationJson_Ocs_Data_WhatsNew> get serializer =>
      _$whatsNewGetResponseApplicationJsonOcsDataWhatsNewSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(WhatsNewGetResponseApplicationJson_Ocs_Data_WhatsNewBuilder b) {
    $WhatsNewGetResponseApplicationJson_Ocs_Data_WhatsNewInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(WhatsNewGetResponseApplicationJson_Ocs_Data_WhatsNewBuilder b) {
    $WhatsNewGetResponseApplicationJson_Ocs_Data_WhatsNewInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $WhatsNewGetResponseApplicationJson_Ocs_DataInterface {
  String get changelogURL;
  String get product;
  String get version;
  WhatsNewGetResponseApplicationJson_Ocs_Data_WhatsNew? get whatsNew;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($WhatsNewGetResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($WhatsNewGetResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class WhatsNewGetResponseApplicationJson_Ocs_Data
    implements
        $WhatsNewGetResponseApplicationJson_Ocs_DataInterface,
        Built<WhatsNewGetResponseApplicationJson_Ocs_Data, WhatsNewGetResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new WhatsNewGetResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory WhatsNewGetResponseApplicationJson_Ocs_Data([
    void Function(WhatsNewGetResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$WhatsNewGetResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const WhatsNewGetResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory WhatsNewGetResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for WhatsNewGetResponseApplicationJson_Ocs_Data.
  static Serializer<WhatsNewGetResponseApplicationJson_Ocs_Data> get serializer =>
      _$whatsNewGetResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(WhatsNewGetResponseApplicationJson_Ocs_DataBuilder b) {
    $WhatsNewGetResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(WhatsNewGetResponseApplicationJson_Ocs_DataBuilder b) {
    $WhatsNewGetResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $WhatsNewGetResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  WhatsNewGetResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($WhatsNewGetResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($WhatsNewGetResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class WhatsNewGetResponseApplicationJson_Ocs
    implements
        $WhatsNewGetResponseApplicationJson_OcsInterface,
        Built<WhatsNewGetResponseApplicationJson_Ocs, WhatsNewGetResponseApplicationJson_OcsBuilder> {
  /// Creates a new WhatsNewGetResponseApplicationJson_Ocs object using the builder pattern.
  factory WhatsNewGetResponseApplicationJson_Ocs([void Function(WhatsNewGetResponseApplicationJson_OcsBuilder)? b]) =
      _$WhatsNewGetResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const WhatsNewGetResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory WhatsNewGetResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for WhatsNewGetResponseApplicationJson_Ocs.
  static Serializer<WhatsNewGetResponseApplicationJson_Ocs> get serializer =>
      _$whatsNewGetResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(WhatsNewGetResponseApplicationJson_OcsBuilder b) {
    $WhatsNewGetResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(WhatsNewGetResponseApplicationJson_OcsBuilder b) {
    $WhatsNewGetResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $WhatsNewGetResponseApplicationJsonInterface {
  WhatsNewGetResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($WhatsNewGetResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($WhatsNewGetResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class WhatsNewGetResponseApplicationJson
    implements
        $WhatsNewGetResponseApplicationJsonInterface,
        Built<WhatsNewGetResponseApplicationJson, WhatsNewGetResponseApplicationJsonBuilder> {
  /// Creates a new WhatsNewGetResponseApplicationJson object using the builder pattern.
  factory WhatsNewGetResponseApplicationJson([void Function(WhatsNewGetResponseApplicationJsonBuilder)? b]) =
      _$WhatsNewGetResponseApplicationJson;

  // coverage:ignore-start
  const WhatsNewGetResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory WhatsNewGetResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for WhatsNewGetResponseApplicationJson.
  static Serializer<WhatsNewGetResponseApplicationJson> get serializer =>
      _$whatsNewGetResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(WhatsNewGetResponseApplicationJsonBuilder b) {
    $WhatsNewGetResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(WhatsNewGetResponseApplicationJsonBuilder b) {
    $WhatsNewGetResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $WhatsNewDismissResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($WhatsNewDismissResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($WhatsNewDismissResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class WhatsNewDismissResponseApplicationJson_Ocs
    implements
        $WhatsNewDismissResponseApplicationJson_OcsInterface,
        Built<WhatsNewDismissResponseApplicationJson_Ocs, WhatsNewDismissResponseApplicationJson_OcsBuilder> {
  /// Creates a new WhatsNewDismissResponseApplicationJson_Ocs object using the builder pattern.
  factory WhatsNewDismissResponseApplicationJson_Ocs([
    void Function(WhatsNewDismissResponseApplicationJson_OcsBuilder)? b,
  ]) = _$WhatsNewDismissResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const WhatsNewDismissResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory WhatsNewDismissResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for WhatsNewDismissResponseApplicationJson_Ocs.
  static Serializer<WhatsNewDismissResponseApplicationJson_Ocs> get serializer =>
      _$whatsNewDismissResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(WhatsNewDismissResponseApplicationJson_OcsBuilder b) {
    $WhatsNewDismissResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(WhatsNewDismissResponseApplicationJson_OcsBuilder b) {
    $WhatsNewDismissResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $WhatsNewDismissResponseApplicationJsonInterface {
  WhatsNewDismissResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($WhatsNewDismissResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($WhatsNewDismissResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class WhatsNewDismissResponseApplicationJson
    implements
        $WhatsNewDismissResponseApplicationJsonInterface,
        Built<WhatsNewDismissResponseApplicationJson, WhatsNewDismissResponseApplicationJsonBuilder> {
  /// Creates a new WhatsNewDismissResponseApplicationJson object using the builder pattern.
  factory WhatsNewDismissResponseApplicationJson([void Function(WhatsNewDismissResponseApplicationJsonBuilder)? b]) =
      _$WhatsNewDismissResponseApplicationJson;

  // coverage:ignore-start
  const WhatsNewDismissResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory WhatsNewDismissResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for WhatsNewDismissResponseApplicationJson.
  static Serializer<WhatsNewDismissResponseApplicationJson> get serializer =>
      _$whatsNewDismissResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(WhatsNewDismissResponseApplicationJsonBuilder b) {
    $WhatsNewDismissResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(WhatsNewDismissResponseApplicationJsonBuilder b) {
    $WhatsNewDismissResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $WipeCheckWipeResponseApplicationJsonInterface {
  bool get wipe;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($WipeCheckWipeResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($WipeCheckWipeResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class WipeCheckWipeResponseApplicationJson
    implements
        $WipeCheckWipeResponseApplicationJsonInterface,
        Built<WipeCheckWipeResponseApplicationJson, WipeCheckWipeResponseApplicationJsonBuilder> {
  /// Creates a new WipeCheckWipeResponseApplicationJson object using the builder pattern.
  factory WipeCheckWipeResponseApplicationJson([void Function(WipeCheckWipeResponseApplicationJsonBuilder)? b]) =
      _$WipeCheckWipeResponseApplicationJson;

  // coverage:ignore-start
  const WipeCheckWipeResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory WipeCheckWipeResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for WipeCheckWipeResponseApplicationJson.
  static Serializer<WipeCheckWipeResponseApplicationJson> get serializer =>
      _$wipeCheckWipeResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(WipeCheckWipeResponseApplicationJsonBuilder b) {
    $WipeCheckWipeResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(WipeCheckWipeResponseApplicationJsonBuilder b) {
    $WipeCheckWipeResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $Capabilities_CoreInterface {
  int get pollinterval;
  @BuiltValueField(wireName: 'webdav-root')
  String get webdavRoot;
  @BuiltValueField(wireName: 'reference-api')
  bool get referenceApi;
  @BuiltValueField(wireName: 'reference-regex')
  String get referenceRegex;
  @BuiltValueField(wireName: 'mod-rewrite-working')
  bool get modRewriteWorking;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($Capabilities_CoreInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($Capabilities_CoreInterfaceBuilder b) {}
}

abstract class Capabilities_Core
    implements $Capabilities_CoreInterface, Built<Capabilities_Core, Capabilities_CoreBuilder> {
  /// Creates a new Capabilities_Core object using the builder pattern.
  factory Capabilities_Core([void Function(Capabilities_CoreBuilder)? b]) = _$Capabilities_Core;

  // coverage:ignore-start
  const Capabilities_Core._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory Capabilities_Core.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for Capabilities_Core.
  static Serializer<Capabilities_Core> get serializer => _$capabilitiesCoreSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(Capabilities_CoreBuilder b) {
    $Capabilities_CoreInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(Capabilities_CoreBuilder b) {
    $Capabilities_CoreInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CapabilitiesInterface {
  Capabilities_Core get core;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CapabilitiesInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CapabilitiesInterfaceBuilder b) {}
}

abstract class Capabilities implements $CapabilitiesInterface, Built<Capabilities, CapabilitiesBuilder> {
  /// Creates a new Capabilities object using the builder pattern.
  factory Capabilities([void Function(CapabilitiesBuilder)? b]) = _$Capabilities;

  // coverage:ignore-start
  const Capabilities._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory Capabilities.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for Capabilities.
  static Serializer<Capabilities> get serializer => _$capabilitiesSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CapabilitiesBuilder b) {
    $CapabilitiesInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CapabilitiesBuilder b) {
    $CapabilitiesInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $PublicCapabilities_BruteforceInterface {
  int get delay;
  @BuiltValueField(wireName: 'allow-listed')
  bool get allowListed;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($PublicCapabilities_BruteforceInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($PublicCapabilities_BruteforceInterfaceBuilder b) {}
}

abstract class PublicCapabilities_Bruteforce
    implements
        $PublicCapabilities_BruteforceInterface,
        Built<PublicCapabilities_Bruteforce, PublicCapabilities_BruteforceBuilder> {
  /// Creates a new PublicCapabilities_Bruteforce object using the builder pattern.
  factory PublicCapabilities_Bruteforce([void Function(PublicCapabilities_BruteforceBuilder)? b]) =
      _$PublicCapabilities_Bruteforce;

  // coverage:ignore-start
  const PublicCapabilities_Bruteforce._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory PublicCapabilities_Bruteforce.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for PublicCapabilities_Bruteforce.
  static Serializer<PublicCapabilities_Bruteforce> get serializer => _$publicCapabilitiesBruteforceSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(PublicCapabilities_BruteforceBuilder b) {
    $PublicCapabilities_BruteforceInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(PublicCapabilities_BruteforceBuilder b) {
    $PublicCapabilities_BruteforceInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $PublicCapabilitiesInterface {
  PublicCapabilities_Bruteforce get bruteforce;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($PublicCapabilitiesInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($PublicCapabilitiesInterfaceBuilder b) {}
}

abstract class PublicCapabilities
    implements $PublicCapabilitiesInterface, Built<PublicCapabilities, PublicCapabilitiesBuilder> {
  /// Creates a new PublicCapabilities object using the builder pattern.
  factory PublicCapabilities([void Function(PublicCapabilitiesBuilder)? b]) = _$PublicCapabilities;

  // coverage:ignore-start
  const PublicCapabilities._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory PublicCapabilities.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for PublicCapabilities.
  static Serializer<PublicCapabilities> get serializer => _$publicCapabilitiesSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(PublicCapabilitiesBuilder b) {
    $PublicCapabilitiesInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(PublicCapabilitiesBuilder b) {
    $PublicCapabilitiesInterface._validate(b);
  }
}

/// Serialization extension for `AutocompleteResult_Status`.
extension $AutocompleteResult_StatusExtension on AutocompleteResult_Status {
  /// Serializer for AutocompleteResult_Status.
  @BuiltValueSerializer(custom: true)
  static Serializer<AutocompleteResult_Status> get serializer => $87e48e5649cd72b4d2947aaaea13ccd8Extension._serializer;

  /// Creates a new object from the given [json] data.
  ///
  /// Use `toJson` to serialize it back into json.
  static AutocompleteResult_Status fromJson(Object? json) => $87e48e5649cd72b4d2947aaaea13ccd8Extension._fromJson(json);
}

/// Serialization extension for `NavigationEntry_Order`.
extension $NavigationEntry_OrderExtension on NavigationEntry_Order {
  /// Serializer for NavigationEntry_Order.
  @BuiltValueSerializer(custom: true)
  static Serializer<NavigationEntry_Order> get serializer => $b2c4857c0136baea42828d89c87c757dExtension._serializer;

  /// Creates a new object from the given [json] data.
  ///
  /// Use `toJson` to serialize it back into json.
  static NavigationEntry_Order fromJson(Object? json) => $b2c4857c0136baea42828d89c87c757dExtension._fromJson(json);
}

/// Serialization extension for `SharebymailCapabilities`.
extension $SharebymailCapabilitiesExtension on SharebymailCapabilities {
  /// Serializer for SharebymailCapabilities.
  @BuiltValueSerializer(custom: true)
  static Serializer<SharebymailCapabilities> get serializer => $46564992d3ed3482aa6c1162698aac99Extension._serializer;

  /// Creates a new object from the given [json] data.
  ///
  /// Use `toJson` to serialize it back into json.
  static SharebymailCapabilities fromJson(Object? json) => $46564992d3ed3482aa6c1162698aac99Extension._fromJson(json);
}

/// Serialization extension for `SpreedPublicCapabilities`.
extension $SpreedPublicCapabilitiesExtension on SpreedPublicCapabilities {
  /// Serializer for SpreedPublicCapabilities.
  @BuiltValueSerializer(custom: true)
  static Serializer<SpreedPublicCapabilities> get serializer => $06c2e47196a84ebc3718dccf9eb4b29dExtension._serializer;

  /// Creates a new object from the given [json] data.
  ///
  /// Use `toJson` to serialize it back into json.
  static SpreedPublicCapabilities fromJson(Object? json) => $06c2e47196a84ebc3718dccf9eb4b29dExtension._fromJson(json);
}

/// Serialization extension for `OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_Capabilities`.
extension $OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_CapabilitiesExtension
    on OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_Capabilities {
  /// Serializer for OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_Capabilities.
  @BuiltValueSerializer(custom: true)
  static Serializer<OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_Capabilities> get serializer =>
      $f6f5edfce09cb06e8f14ce14ab1af117Extension._serializer;

  /// Creates a new object from the given [json] data.
  ///
  /// Use `toJson` to serialize it back into json.
  static OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_Capabilities fromJson(Object? json) =>
      $f6f5edfce09cb06e8f14ce14ab1af117Extension._fromJson(json);
}

/// Serialization extension for `UnifiedSearchSearchCursor`.
extension $UnifiedSearchSearchCursorExtension on UnifiedSearchSearchCursor {
  /// Serializer for UnifiedSearchSearchCursor.
  @BuiltValueSerializer(custom: true)
  static Serializer<UnifiedSearchSearchCursor> get serializer => $b2c4857c0136baea42828d89c87c757dExtension._serializer;

  /// Creates a new object from the given [json] data.
  ///
  /// Use `toJson` to serialize it back into json.
  static UnifiedSearchSearchCursor fromJson(Object? json) => $b2c4857c0136baea42828d89c87c757dExtension._fromJson(json);
}

/// Serialization extension for `UnifiedSearchResult_Cursor`.
extension $UnifiedSearchResult_CursorExtension on UnifiedSearchResult_Cursor {
  /// Serializer for UnifiedSearchResult_Cursor.
  @BuiltValueSerializer(custom: true)
  static Serializer<UnifiedSearchResult_Cursor> get serializer =>
      $b2c4857c0136baea42828d89c87c757dExtension._serializer;

  /// Creates a new object from the given [json] data.
  ///
  /// Use `toJson` to serialize it back into json.
  static UnifiedSearchResult_Cursor fromJson(Object? json) =>
      $b2c4857c0136baea42828d89c87c757dExtension._fromJson(json);
}

typedef _$87e48e5649cd72b4d2947aaaea13ccd8 = ({AutocompleteResult_Status0? autocompleteResultStatus0, String? string});

/// @nodoc
// ignore: library_private_types_in_public_api
extension $87e48e5649cd72b4d2947aaaea13ccd8Extension on _$87e48e5649cd72b4d2947aaaea13ccd8 {
  List<dynamic> get _values => [autocompleteResultStatus0, string];
  List<String> get _names => const ['autocompleteResultStatus0', 'string'];

  /// {@macro Dynamite.validateOneOf}
  void validateOneOf() => _i4.validateOneOf(
        _values,
        _names,
      );

  /// {@macro Dynamite.validateAnyOf}
  void validateAnyOf() => _i4.validateAnyOf(
        _values,
        _names,
      );
  static Serializer<_$87e48e5649cd72b4d2947aaaea13ccd8> get _serializer =>
      const _$87e48e5649cd72b4d2947aaaea13ccd8Serializer();
  static _$87e48e5649cd72b4d2947aaaea13ccd8 _fromJson(Object? json) =>
      _$jsonSerializers.deserializeWith(_serializer, json)!;

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  Object? toJson() => _$jsonSerializers.serializeWith(_serializer, this);
}

class _$87e48e5649cd72b4d2947aaaea13ccd8Serializer implements PrimitiveSerializer<_$87e48e5649cd72b4d2947aaaea13ccd8> {
  const _$87e48e5649cd72b4d2947aaaea13ccd8Serializer();

  @override
  Iterable<Type> get types => const [_$87e48e5649cd72b4d2947aaaea13ccd8];

  @override
  String get wireName => r'_$87e48e5649cd72b4d2947aaaea13ccd8';

  @override
  Object serialize(
    Serializers serializers,
    _$87e48e5649cd72b4d2947aaaea13ccd8 object, {
    FullType specifiedType = FullType.unspecified,
  }) {
    dynamic value;
    value = object.autocompleteResultStatus0;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(AutocompleteResult_Status0))!;
    }
    value = object.string;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(String))!;
    }
// Should not be possible after validation.
    throw StateError('Tried to serialize without any value.');
  }

  @override
  _$87e48e5649cd72b4d2947aaaea13ccd8 deserialize(
    Serializers serializers,
    Object data, {
    FullType specifiedType = FullType.unspecified,
  }) {
    AutocompleteResult_Status0? autocompleteResultStatus0;
    try {
      autocompleteResultStatus0 = serializers.deserialize(
        data,
        specifiedType: const FullType(AutocompleteResult_Status0),
      )! as AutocompleteResult_Status0;
    } catch (_) {}
    String? string;
    try {
      string = serializers.deserialize(
        data,
        specifiedType: const FullType(String),
      )! as String;
    } catch (_) {}
    return (autocompleteResultStatus0: autocompleteResultStatus0, string: string);
  }
}

typedef _$b2c4857c0136baea42828d89c87c757d = ({int? $int, String? string});

/// @nodoc
// ignore: library_private_types_in_public_api
extension $b2c4857c0136baea42828d89c87c757dExtension on _$b2c4857c0136baea42828d89c87c757d {
  List<dynamic> get _values => [$int, string];
  List<String> get _names => const [r'$int', 'string'];

  /// {@macro Dynamite.validateOneOf}
  void validateOneOf() => _i4.validateOneOf(
        _values,
        _names,
      );

  /// {@macro Dynamite.validateAnyOf}
  void validateAnyOf() => _i4.validateAnyOf(
        _values,
        _names,
      );
  static Serializer<_$b2c4857c0136baea42828d89c87c757d> get _serializer =>
      const _$b2c4857c0136baea42828d89c87c757dSerializer();
  static _$b2c4857c0136baea42828d89c87c757d _fromJson(Object? json) =>
      _$jsonSerializers.deserializeWith(_serializer, json)!;

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  Object? toJson() => _$jsonSerializers.serializeWith(_serializer, this);
}

class _$b2c4857c0136baea42828d89c87c757dSerializer implements PrimitiveSerializer<_$b2c4857c0136baea42828d89c87c757d> {
  const _$b2c4857c0136baea42828d89c87c757dSerializer();

  @override
  Iterable<Type> get types => const [_$b2c4857c0136baea42828d89c87c757d];

  @override
  String get wireName => r'_$b2c4857c0136baea42828d89c87c757d';

  @override
  Object serialize(
    Serializers serializers,
    _$b2c4857c0136baea42828d89c87c757d object, {
    FullType specifiedType = FullType.unspecified,
  }) {
    dynamic value;
    value = object.$int;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(int))!;
    }
    value = object.string;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(String))!;
    }
// Should not be possible after validation.
    throw StateError('Tried to serialize without any value.');
  }

  @override
  _$b2c4857c0136baea42828d89c87c757d deserialize(
    Serializers serializers,
    Object data, {
    FullType specifiedType = FullType.unspecified,
  }) {
    int? $int;
    try {
      $int = serializers.deserialize(
        data,
        specifiedType: const FullType(int),
      )! as int;
    } catch (_) {}
    String? string;
    try {
      string = serializers.deserialize(
        data,
        specifiedType: const FullType(String),
      )! as String;
    } catch (_) {}
    return ($int: $int, string: string);
  }
}

typedef _$46564992d3ed3482aa6c1162698aac99 = ({
  BuiltList<Never>? builtListNever,
  SharebymailCapabilities0? sharebymailCapabilities0
});

/// @nodoc
// ignore: library_private_types_in_public_api
extension $46564992d3ed3482aa6c1162698aac99Extension on _$46564992d3ed3482aa6c1162698aac99 {
  List<dynamic> get _values => [builtListNever, sharebymailCapabilities0];
  List<String> get _names => const ['builtListNever', 'sharebymailCapabilities0'];

  /// {@macro Dynamite.validateOneOf}
  void validateOneOf() => _i4.validateOneOf(
        _values,
        _names,
      );

  /// {@macro Dynamite.validateAnyOf}
  void validateAnyOf() => _i4.validateAnyOf(
        _values,
        _names,
      );
  static Serializer<_$46564992d3ed3482aa6c1162698aac99> get _serializer =>
      const _$46564992d3ed3482aa6c1162698aac99Serializer();
  static _$46564992d3ed3482aa6c1162698aac99 _fromJson(Object? json) =>
      _$jsonSerializers.deserializeWith(_serializer, json)!;

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  Object? toJson() => _$jsonSerializers.serializeWith(_serializer, this);
}

class _$46564992d3ed3482aa6c1162698aac99Serializer implements PrimitiveSerializer<_$46564992d3ed3482aa6c1162698aac99> {
  const _$46564992d3ed3482aa6c1162698aac99Serializer();

  @override
  Iterable<Type> get types => const [_$46564992d3ed3482aa6c1162698aac99];

  @override
  String get wireName => r'_$46564992d3ed3482aa6c1162698aac99';

  @override
  Object serialize(
    Serializers serializers,
    _$46564992d3ed3482aa6c1162698aac99 object, {
    FullType specifiedType = FullType.unspecified,
  }) {
    dynamic value;
    value = object.builtListNever;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(BuiltList, [FullType(Never)]))!;
    }
    value = object.sharebymailCapabilities0;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(SharebymailCapabilities0))!;
    }
// Should not be possible after validation.
    throw StateError('Tried to serialize without any value.');
  }

  @override
  _$46564992d3ed3482aa6c1162698aac99 deserialize(
    Serializers serializers,
    Object data, {
    FullType specifiedType = FullType.unspecified,
  }) {
    BuiltList<Never>? builtListNever;
    try {
      builtListNever = serializers.deserialize(
        data,
        specifiedType: const FullType(BuiltList, [FullType(Never)]),
      )! as BuiltList<Never>;
    } catch (_) {}
    SharebymailCapabilities0? sharebymailCapabilities0;
    try {
      sharebymailCapabilities0 = serializers.deserialize(
        data,
        specifiedType: const FullType(SharebymailCapabilities0),
      )! as SharebymailCapabilities0;
    } catch (_) {}
    return (builtListNever: builtListNever, sharebymailCapabilities0: sharebymailCapabilities0);
  }
}

typedef _$06c2e47196a84ebc3718dccf9eb4b29d = ({
  BuiltList<Never>? builtListNever,
  SpreedPublicCapabilities0? spreedPublicCapabilities0
});

/// @nodoc
// ignore: library_private_types_in_public_api
extension $06c2e47196a84ebc3718dccf9eb4b29dExtension on _$06c2e47196a84ebc3718dccf9eb4b29d {
  List<dynamic> get _values => [builtListNever, spreedPublicCapabilities0];
  List<String> get _names => const ['builtListNever', 'spreedPublicCapabilities0'];

  /// {@macro Dynamite.validateOneOf}
  void validateOneOf() => _i4.validateOneOf(
        _values,
        _names,
      );

  /// {@macro Dynamite.validateAnyOf}
  void validateAnyOf() => _i4.validateAnyOf(
        _values,
        _names,
      );
  static Serializer<_$06c2e47196a84ebc3718dccf9eb4b29d> get _serializer =>
      const _$06c2e47196a84ebc3718dccf9eb4b29dSerializer();
  static _$06c2e47196a84ebc3718dccf9eb4b29d _fromJson(Object? json) =>
      _$jsonSerializers.deserializeWith(_serializer, json)!;

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  Object? toJson() => _$jsonSerializers.serializeWith(_serializer, this);
}

class _$06c2e47196a84ebc3718dccf9eb4b29dSerializer implements PrimitiveSerializer<_$06c2e47196a84ebc3718dccf9eb4b29d> {
  const _$06c2e47196a84ebc3718dccf9eb4b29dSerializer();

  @override
  Iterable<Type> get types => const [_$06c2e47196a84ebc3718dccf9eb4b29d];

  @override
  String get wireName => r'_$06c2e47196a84ebc3718dccf9eb4b29d';

  @override
  Object serialize(
    Serializers serializers,
    _$06c2e47196a84ebc3718dccf9eb4b29d object, {
    FullType specifiedType = FullType.unspecified,
  }) {
    dynamic value;
    value = object.builtListNever;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(BuiltList, [FullType(Never)]))!;
    }
    value = object.spreedPublicCapabilities0;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(SpreedPublicCapabilities0))!;
    }
// Should not be possible after validation.
    throw StateError('Tried to serialize without any value.');
  }

  @override
  _$06c2e47196a84ebc3718dccf9eb4b29d deserialize(
    Serializers serializers,
    Object data, {
    FullType specifiedType = FullType.unspecified,
  }) {
    BuiltList<Never>? builtListNever;
    try {
      builtListNever = serializers.deserialize(
        data,
        specifiedType: const FullType(BuiltList, [FullType(Never)]),
      )! as BuiltList<Never>;
    } catch (_) {}
    SpreedPublicCapabilities0? spreedPublicCapabilities0;
    try {
      spreedPublicCapabilities0 = serializers.deserialize(
        data,
        specifiedType: const FullType(SpreedPublicCapabilities0),
      )! as SpreedPublicCapabilities0;
    } catch (_) {}
    return (builtListNever: builtListNever, spreedPublicCapabilities0: spreedPublicCapabilities0);
  }
}

typedef _$f6f5edfce09cb06e8f14ce14ab1af117 = ({
  CommentsCapabilities? commentsCapabilities,
  CoreCapabilities? coreCapabilities,
  CorePublicCapabilities? corePublicCapabilities,
  DavCapabilities? davCapabilities,
  DropAccountCapabilities? dropAccountCapabilities,
  FilesCapabilities? filesCapabilities,
  FilesSharingCapabilities? filesSharingCapabilities,
  FilesTrashbinCapabilities? filesTrashbinCapabilities,
  FilesVersionsCapabilities? filesVersionsCapabilities,
  NotesCapabilities? notesCapabilities,
  NotificationsCapabilities? notificationsCapabilities,
  ProvisioningApiCapabilities? provisioningApiCapabilities,
  SharebymailCapabilities? sharebymailCapabilities,
  SpreedCapabilities? spreedCapabilities,
  SpreedPublicCapabilities? spreedPublicCapabilities,
  SystemtagsCapabilities? systemtagsCapabilities,
  ThemingPublicCapabilities? themingPublicCapabilities,
  UserStatusCapabilities? userStatusCapabilities,
  WeatherStatusCapabilities? weatherStatusCapabilities
});

/// @nodoc
// ignore: library_private_types_in_public_api
extension $f6f5edfce09cb06e8f14ce14ab1af117Extension on _$f6f5edfce09cb06e8f14ce14ab1af117 {
  List<dynamic> get _values => [
        commentsCapabilities,
        coreCapabilities,
        corePublicCapabilities,
        davCapabilities,
        dropAccountCapabilities,
        filesCapabilities,
        filesSharingCapabilities,
        filesTrashbinCapabilities,
        filesVersionsCapabilities,
        notesCapabilities,
        notificationsCapabilities,
        provisioningApiCapabilities,
        sharebymailCapabilities,
        spreedCapabilities,
        spreedPublicCapabilities,
        systemtagsCapabilities,
        themingPublicCapabilities,
        userStatusCapabilities,
        weatherStatusCapabilities,
      ];
  List<String> get _names => const [
        'commentsCapabilities',
        'coreCapabilities',
        'corePublicCapabilities',
        'davCapabilities',
        'dropAccountCapabilities',
        'filesCapabilities',
        'filesSharingCapabilities',
        'filesTrashbinCapabilities',
        'filesVersionsCapabilities',
        'notesCapabilities',
        'notificationsCapabilities',
        'provisioningApiCapabilities',
        'sharebymailCapabilities',
        'spreedCapabilities',
        'spreedPublicCapabilities',
        'systemtagsCapabilities',
        'themingPublicCapabilities',
        'userStatusCapabilities',
        'weatherStatusCapabilities',
      ];

  /// {@macro Dynamite.validateOneOf}
  void validateOneOf() => _i4.validateOneOf(
        _values,
        _names,
      );

  /// {@macro Dynamite.validateAnyOf}
  void validateAnyOf() => _i4.validateAnyOf(
        _values,
        _names,
      );
  static Serializer<_$f6f5edfce09cb06e8f14ce14ab1af117> get _serializer =>
      const _$f6f5edfce09cb06e8f14ce14ab1af117Serializer();
  static _$f6f5edfce09cb06e8f14ce14ab1af117 _fromJson(Object? json) =>
      _$jsonSerializers.deserializeWith(_serializer, json)!;

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  Object? toJson() => _$jsonSerializers.serializeWith(_serializer, this);
}

class _$f6f5edfce09cb06e8f14ce14ab1af117Serializer implements PrimitiveSerializer<_$f6f5edfce09cb06e8f14ce14ab1af117> {
  const _$f6f5edfce09cb06e8f14ce14ab1af117Serializer();

  @override
  Iterable<Type> get types => const [_$f6f5edfce09cb06e8f14ce14ab1af117];

  @override
  String get wireName => r'_$f6f5edfce09cb06e8f14ce14ab1af117';

  @override
  Object serialize(
    Serializers serializers,
    _$f6f5edfce09cb06e8f14ce14ab1af117 object, {
    FullType specifiedType = FullType.unspecified,
  }) {
    dynamic value;
    value = object.commentsCapabilities;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(CommentsCapabilities))!;
    }
    value = object.coreCapabilities;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(CoreCapabilities))!;
    }
    value = object.corePublicCapabilities;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(CorePublicCapabilities))!;
    }
    value = object.davCapabilities;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(DavCapabilities))!;
    }
    value = object.dropAccountCapabilities;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(DropAccountCapabilities))!;
    }
    value = object.filesCapabilities;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(FilesCapabilities))!;
    }
    value = object.filesSharingCapabilities;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(FilesSharingCapabilities))!;
    }
    value = object.filesTrashbinCapabilities;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(FilesTrashbinCapabilities))!;
    }
    value = object.filesVersionsCapabilities;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(FilesVersionsCapabilities))!;
    }
    value = object.notesCapabilities;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(NotesCapabilities))!;
    }
    value = object.notificationsCapabilities;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(NotificationsCapabilities))!;
    }
    value = object.provisioningApiCapabilities;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(ProvisioningApiCapabilities))!;
    }
    value = object.sharebymailCapabilities;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(SharebymailCapabilities))!;
    }
    value = object.spreedCapabilities;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(SpreedCapabilities))!;
    }
    value = object.spreedPublicCapabilities;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(SpreedPublicCapabilities))!;
    }
    value = object.systemtagsCapabilities;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(SystemtagsCapabilities))!;
    }
    value = object.themingPublicCapabilities;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(ThemingPublicCapabilities))!;
    }
    value = object.userStatusCapabilities;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(UserStatusCapabilities))!;
    }
    value = object.weatherStatusCapabilities;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(WeatherStatusCapabilities))!;
    }
// Should not be possible after validation.
    throw StateError('Tried to serialize without any value.');
  }

  @override
  _$f6f5edfce09cb06e8f14ce14ab1af117 deserialize(
    Serializers serializers,
    Object data, {
    FullType specifiedType = FullType.unspecified,
  }) {
    CommentsCapabilities? commentsCapabilities;
    try {
      commentsCapabilities = serializers.deserialize(
        data,
        specifiedType: const FullType(CommentsCapabilities),
      )! as CommentsCapabilities;
    } catch (_) {}
    CoreCapabilities? coreCapabilities;
    try {
      coreCapabilities = serializers.deserialize(
        data,
        specifiedType: const FullType(CoreCapabilities),
      )! as CoreCapabilities;
    } catch (_) {}
    CorePublicCapabilities? corePublicCapabilities;
    try {
      corePublicCapabilities = serializers.deserialize(
        data,
        specifiedType: const FullType(CorePublicCapabilities),
      )! as CorePublicCapabilities;
    } catch (_) {}
    DavCapabilities? davCapabilities;
    try {
      davCapabilities = serializers.deserialize(
        data,
        specifiedType: const FullType(DavCapabilities),
      )! as DavCapabilities;
    } catch (_) {}
    DropAccountCapabilities? dropAccountCapabilities;
    try {
      dropAccountCapabilities = serializers.deserialize(
        data,
        specifiedType: const FullType(DropAccountCapabilities),
      )! as DropAccountCapabilities;
    } catch (_) {}
    FilesCapabilities? filesCapabilities;
    try {
      filesCapabilities = serializers.deserialize(
        data,
        specifiedType: const FullType(FilesCapabilities),
      )! as FilesCapabilities;
    } catch (_) {}
    FilesSharingCapabilities? filesSharingCapabilities;
    try {
      filesSharingCapabilities = serializers.deserialize(
        data,
        specifiedType: const FullType(FilesSharingCapabilities),
      )! as FilesSharingCapabilities;
    } catch (_) {}
    FilesTrashbinCapabilities? filesTrashbinCapabilities;
    try {
      filesTrashbinCapabilities = serializers.deserialize(
        data,
        specifiedType: const FullType(FilesTrashbinCapabilities),
      )! as FilesTrashbinCapabilities;
    } catch (_) {}
    FilesVersionsCapabilities? filesVersionsCapabilities;
    try {
      filesVersionsCapabilities = serializers.deserialize(
        data,
        specifiedType: const FullType(FilesVersionsCapabilities),
      )! as FilesVersionsCapabilities;
    } catch (_) {}
    NotesCapabilities? notesCapabilities;
    try {
      notesCapabilities = serializers.deserialize(
        data,
        specifiedType: const FullType(NotesCapabilities),
      )! as NotesCapabilities;
    } catch (_) {}
    NotificationsCapabilities? notificationsCapabilities;
    try {
      notificationsCapabilities = serializers.deserialize(
        data,
        specifiedType: const FullType(NotificationsCapabilities),
      )! as NotificationsCapabilities;
    } catch (_) {}
    ProvisioningApiCapabilities? provisioningApiCapabilities;
    try {
      provisioningApiCapabilities = serializers.deserialize(
        data,
        specifiedType: const FullType(ProvisioningApiCapabilities),
      )! as ProvisioningApiCapabilities;
    } catch (_) {}
    SharebymailCapabilities? sharebymailCapabilities;
    try {
      sharebymailCapabilities = (serializers.deserialize(
        data,
        specifiedType: const FullType(SharebymailCapabilities),
      )! as SharebymailCapabilities)
        ..validateOneOf();
    } catch (_) {}
    SpreedCapabilities? spreedCapabilities;
    try {
      spreedCapabilities = serializers.deserialize(
        data,
        specifiedType: const FullType(SpreedCapabilities),
      )! as SpreedCapabilities;
    } catch (_) {}
    SpreedPublicCapabilities? spreedPublicCapabilities;
    try {
      spreedPublicCapabilities = (serializers.deserialize(
        data,
        specifiedType: const FullType(SpreedPublicCapabilities),
      )! as SpreedPublicCapabilities)
        ..validateOneOf();
    } catch (_) {}
    SystemtagsCapabilities? systemtagsCapabilities;
    try {
      systemtagsCapabilities = serializers.deserialize(
        data,
        specifiedType: const FullType(SystemtagsCapabilities),
      )! as SystemtagsCapabilities;
    } catch (_) {}
    ThemingPublicCapabilities? themingPublicCapabilities;
    try {
      themingPublicCapabilities = serializers.deserialize(
        data,
        specifiedType: const FullType(ThemingPublicCapabilities),
      )! as ThemingPublicCapabilities;
    } catch (_) {}
    UserStatusCapabilities? userStatusCapabilities;
    try {
      userStatusCapabilities = serializers.deserialize(
        data,
        specifiedType: const FullType(UserStatusCapabilities),
      )! as UserStatusCapabilities;
    } catch (_) {}
    WeatherStatusCapabilities? weatherStatusCapabilities;
    try {
      weatherStatusCapabilities = serializers.deserialize(
        data,
        specifiedType: const FullType(WeatherStatusCapabilities),
      )! as WeatherStatusCapabilities;
    } catch (_) {}
    return (
      commentsCapabilities: commentsCapabilities,
      coreCapabilities: coreCapabilities,
      corePublicCapabilities: corePublicCapabilities,
      davCapabilities: davCapabilities,
      dropAccountCapabilities: dropAccountCapabilities,
      filesCapabilities: filesCapabilities,
      filesSharingCapabilities: filesSharingCapabilities,
      filesTrashbinCapabilities: filesTrashbinCapabilities,
      filesVersionsCapabilities: filesVersionsCapabilities,
      notesCapabilities: notesCapabilities,
      notificationsCapabilities: notificationsCapabilities,
      provisioningApiCapabilities: provisioningApiCapabilities,
      sharebymailCapabilities: sharebymailCapabilities,
      spreedCapabilities: spreedCapabilities,
      spreedPublicCapabilities: spreedPublicCapabilities,
      systemtagsCapabilities: systemtagsCapabilities,
      themingPublicCapabilities: themingPublicCapabilities,
      userStatusCapabilities: userStatusCapabilities,
      weatherStatusCapabilities: weatherStatusCapabilities
    );
  }
}

// coverage:ignore-start
/// Serializer for all values in this library.
///
/// Serializes values into the `built_value` wire format.
/// See: [$jsonSerializers] for serializing into json.
@_i2.visibleForTesting
final Serializers $serializers = _$serializers;
final Serializers _$serializers = (Serializers().toBuilder()
      ..addBuilderFactory(const FullType(Status), StatusBuilder.new)
      ..add(Status.serializer)
      ..addBuilderFactory(
        const FullType(AppPasswordGetAppPasswordResponseApplicationJson),
        AppPasswordGetAppPasswordResponseApplicationJsonBuilder.new,
      )
      ..add(AppPasswordGetAppPasswordResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(AppPasswordGetAppPasswordResponseApplicationJson_Ocs),
        AppPasswordGetAppPasswordResponseApplicationJson_OcsBuilder.new,
      )
      ..add(AppPasswordGetAppPasswordResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(OCSMeta), OCSMetaBuilder.new)
      ..add(OCSMeta.serializer)
      ..addBuilderFactory(
        const FullType(AppPasswordGetAppPasswordResponseApplicationJson_Ocs_Data),
        AppPasswordGetAppPasswordResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(AppPasswordGetAppPasswordResponseApplicationJson_Ocs_Data.serializer)
      ..addBuilderFactory(
        const FullType(AppPasswordDeleteAppPasswordResponseApplicationJson),
        AppPasswordDeleteAppPasswordResponseApplicationJsonBuilder.new,
      )
      ..add(AppPasswordDeleteAppPasswordResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(AppPasswordDeleteAppPasswordResponseApplicationJson_Ocs),
        AppPasswordDeleteAppPasswordResponseApplicationJson_OcsBuilder.new,
      )
      ..add(AppPasswordDeleteAppPasswordResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(AppPasswordRotateAppPasswordResponseApplicationJson),
        AppPasswordRotateAppPasswordResponseApplicationJsonBuilder.new,
      )
      ..add(AppPasswordRotateAppPasswordResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(AppPasswordRotateAppPasswordResponseApplicationJson_Ocs),
        AppPasswordRotateAppPasswordResponseApplicationJson_OcsBuilder.new,
      )
      ..add(AppPasswordRotateAppPasswordResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(AppPasswordRotateAppPasswordResponseApplicationJson_Ocs_Data),
        AppPasswordRotateAppPasswordResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(AppPasswordRotateAppPasswordResponseApplicationJson_Ocs_Data.serializer)
      ..addBuilderFactory(
        const FullType(AppPasswordConfirmUserPasswordResponseApplicationJson),
        AppPasswordConfirmUserPasswordResponseApplicationJsonBuilder.new,
      )
      ..add(AppPasswordConfirmUserPasswordResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs),
        AppPasswordConfirmUserPasswordResponseApplicationJson_OcsBuilder.new,
      )
      ..add(AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs_Data),
        AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(AppPasswordConfirmUserPasswordResponseApplicationJson_Ocs_Data.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(int)]), ListBuilder<int>.new)
      ..addBuilderFactory(
        const FullType(AutoCompleteGetResponseApplicationJson),
        AutoCompleteGetResponseApplicationJsonBuilder.new,
      )
      ..add(AutoCompleteGetResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(AutoCompleteGetResponseApplicationJson_Ocs),
        AutoCompleteGetResponseApplicationJson_OcsBuilder.new,
      )
      ..add(AutoCompleteGetResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(AutocompleteResult), AutocompleteResultBuilder.new)
      ..add(AutocompleteResult.serializer)
      ..addBuilderFactory(const FullType(AutocompleteResult_Status0), AutocompleteResult_Status0Builder.new)
      ..add(AutocompleteResult_Status0.serializer)
      ..add($87e48e5649cd72b4d2947aaaea13ccd8Extension._serializer)
      ..addBuilderFactory(
        const FullType(BuiltList, [FullType(AutocompleteResult)]),
        ListBuilder<AutocompleteResult>.new,
      )
      ..addBuilderFactory(const FullType(AvatarAvatarGetAvatarDarkHeaders), AvatarAvatarGetAvatarDarkHeadersBuilder.new)
      ..add(AvatarAvatarGetAvatarDarkHeaders.serializer)
      ..addBuilderFactory(const FullType(Header, [FullType(int)]), HeaderBuilder<int>.new)
      ..add(Header.serializer)
      ..addBuilderFactory(const FullType(AvatarAvatarGetAvatarHeaders), AvatarAvatarGetAvatarHeadersBuilder.new)
      ..add(AvatarAvatarGetAvatarHeaders.serializer)
      ..addBuilderFactory(const FullType(LoginFlowV2Credentials), LoginFlowV2CredentialsBuilder.new)
      ..add(LoginFlowV2Credentials.serializer)
      ..addBuilderFactory(const FullType(LoginFlowV2), LoginFlowV2Builder.new)
      ..add(LoginFlowV2.serializer)
      ..addBuilderFactory(const FullType(LoginFlowV2_Poll), LoginFlowV2_PollBuilder.new)
      ..add(LoginFlowV2_Poll.serializer)
      ..addBuilderFactory(
        const FullType(CollaborationResourcesListCollectionResponseApplicationJson),
        CollaborationResourcesListCollectionResponseApplicationJsonBuilder.new,
      )
      ..add(CollaborationResourcesListCollectionResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(CollaborationResourcesListCollectionResponseApplicationJson_Ocs),
        CollaborationResourcesListCollectionResponseApplicationJson_OcsBuilder.new,
      )
      ..add(CollaborationResourcesListCollectionResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(Collection), CollectionBuilder.new)
      ..add(Collection.serializer)
      ..addBuilderFactory(const FullType(Resource), ResourceBuilder.new)
      ..add(Resource.serializer)
      ..addBuilderFactory(
        const FullType(BuiltMap, [FullType(String), FullType(JsonObject)]),
        MapBuilder<String, JsonObject>.new,
      )
      ..addBuilderFactory(const FullType(OpenGraphObject), OpenGraphObjectBuilder.new)
      ..add(OpenGraphObject.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(Resource)]), ListBuilder<Resource>.new)
      ..addBuilderFactory(
        const FullType(CollaborationResourcesRenameCollectionResponseApplicationJson),
        CollaborationResourcesRenameCollectionResponseApplicationJsonBuilder.new,
      )
      ..add(CollaborationResourcesRenameCollectionResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(CollaborationResourcesRenameCollectionResponseApplicationJson_Ocs),
        CollaborationResourcesRenameCollectionResponseApplicationJson_OcsBuilder.new,
      )
      ..add(CollaborationResourcesRenameCollectionResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(CollaborationResourcesAddResourceResponseApplicationJson),
        CollaborationResourcesAddResourceResponseApplicationJsonBuilder.new,
      )
      ..add(CollaborationResourcesAddResourceResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(CollaborationResourcesAddResourceResponseApplicationJson_Ocs),
        CollaborationResourcesAddResourceResponseApplicationJson_OcsBuilder.new,
      )
      ..add(CollaborationResourcesAddResourceResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(CollaborationResourcesRemoveResourceResponseApplicationJson),
        CollaborationResourcesRemoveResourceResponseApplicationJsonBuilder.new,
      )
      ..add(CollaborationResourcesRemoveResourceResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(CollaborationResourcesRemoveResourceResponseApplicationJson_Ocs),
        CollaborationResourcesRemoveResourceResponseApplicationJson_OcsBuilder.new,
      )
      ..add(CollaborationResourcesRemoveResourceResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(CollaborationResourcesSearchCollectionsResponseApplicationJson),
        CollaborationResourcesSearchCollectionsResponseApplicationJsonBuilder.new,
      )
      ..add(CollaborationResourcesSearchCollectionsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(CollaborationResourcesSearchCollectionsResponseApplicationJson_Ocs),
        CollaborationResourcesSearchCollectionsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(CollaborationResourcesSearchCollectionsResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(Collection)]), ListBuilder<Collection>.new)
      ..addBuilderFactory(
        const FullType(CollaborationResourcesGetCollectionsByResourceResponseApplicationJson),
        CollaborationResourcesGetCollectionsByResourceResponseApplicationJsonBuilder.new,
      )
      ..add(CollaborationResourcesGetCollectionsByResourceResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(CollaborationResourcesGetCollectionsByResourceResponseApplicationJson_Ocs),
        CollaborationResourcesGetCollectionsByResourceResponseApplicationJson_OcsBuilder.new,
      )
      ..add(CollaborationResourcesGetCollectionsByResourceResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson),
        CollaborationResourcesCreateCollectionOnResourceResponseApplicationJsonBuilder.new,
      )
      ..add(CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson_Ocs),
        CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson_OcsBuilder.new,
      )
      ..add(CollaborationResourcesCreateCollectionOnResourceResponseApplicationJson_Ocs.serializer)
      ..add(GuestAvatarGetAvatarDarkTheme.serializer)
      ..addBuilderFactory(
        const FullType(HoverCardGetUserResponseApplicationJson),
        HoverCardGetUserResponseApplicationJsonBuilder.new,
      )
      ..add(HoverCardGetUserResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(HoverCardGetUserResponseApplicationJson_Ocs),
        HoverCardGetUserResponseApplicationJson_OcsBuilder.new,
      )
      ..add(HoverCardGetUserResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(HoverCardGetUserResponseApplicationJson_Ocs_Data),
        HoverCardGetUserResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(HoverCardGetUserResponseApplicationJson_Ocs_Data.serializer)
      ..addBuilderFactory(const FullType(ContactsAction), ContactsActionBuilder.new)
      ..add(ContactsAction.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(ContactsAction)]), ListBuilder<ContactsAction>.new)
      ..addBuilderFactory(
        const FullType(LoginConfirmPasswordResponseApplicationJson),
        LoginConfirmPasswordResponseApplicationJsonBuilder.new,
      )
      ..add(LoginConfirmPasswordResponseApplicationJson.serializer)
      ..add(NavigationGetAppsNavigationAbsolute.serializer)
      ..addBuilderFactory(
        const FullType(NavigationGetAppsNavigationResponseApplicationJson),
        NavigationGetAppsNavigationResponseApplicationJsonBuilder.new,
      )
      ..add(NavigationGetAppsNavigationResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(NavigationGetAppsNavigationResponseApplicationJson_Ocs),
        NavigationGetAppsNavigationResponseApplicationJson_OcsBuilder.new,
      )
      ..add(NavigationGetAppsNavigationResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(NavigationEntry), NavigationEntryBuilder.new)
      ..add(NavigationEntry.serializer)
      ..add($b2c4857c0136baea42828d89c87c757dExtension._serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(NavigationEntry)]), ListBuilder<NavigationEntry>.new)
      ..add(NavigationGetSettingsNavigationAbsolute.serializer)
      ..addBuilderFactory(
        const FullType(NavigationGetSettingsNavigationResponseApplicationJson),
        NavigationGetSettingsNavigationResponseApplicationJsonBuilder.new,
      )
      ..add(NavigationGetSettingsNavigationResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(NavigationGetSettingsNavigationResponseApplicationJson_Ocs),
        NavigationGetSettingsNavigationResponseApplicationJson_OcsBuilder.new,
      )
      ..add(NavigationGetSettingsNavigationResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(OcmDiscoveryResponseApplicationJson),
        OcmDiscoveryResponseApplicationJsonBuilder.new,
      )
      ..add(OcmDiscoveryResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(OcmDiscoveryResponseApplicationJson_ResourceTypes),
        OcmDiscoveryResponseApplicationJson_ResourceTypesBuilder.new,
      )
      ..add(OcmDiscoveryResponseApplicationJson_ResourceTypes.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(String)]), ListBuilder<String>.new)
      ..addBuilderFactory(
        const FullType(OcmDiscoveryResponseApplicationJson_ResourceTypes_Protocols),
        OcmDiscoveryResponseApplicationJson_ResourceTypes_ProtocolsBuilder.new,
      )
      ..add(OcmDiscoveryResponseApplicationJson_ResourceTypes_Protocols.serializer)
      ..addBuilderFactory(
        const FullType(BuiltList, [FullType(OcmDiscoveryResponseApplicationJson_ResourceTypes)]),
        ListBuilder<OcmDiscoveryResponseApplicationJson_ResourceTypes>.new,
      )
      ..addBuilderFactory(const FullType(OcmOcmDiscoveryHeaders), OcmOcmDiscoveryHeadersBuilder.new)
      ..add(OcmOcmDiscoveryHeaders.serializer)
      ..add(OcmOcmDiscoveryHeaders_XNextcloudOcmProviders.serializer)
      ..addBuilderFactory(
        const FullType(Header, [FullType(OcmOcmDiscoveryHeaders_XNextcloudOcmProviders)]),
        HeaderBuilder<OcmOcmDiscoveryHeaders_XNextcloudOcmProviders>.new,
      )
      ..addBuilderFactory(
        const FullType(OcsGetCapabilitiesResponseApplicationJson),
        OcsGetCapabilitiesResponseApplicationJsonBuilder.new,
      )
      ..add(OcsGetCapabilitiesResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(OcsGetCapabilitiesResponseApplicationJson_Ocs),
        OcsGetCapabilitiesResponseApplicationJson_OcsBuilder.new,
      )
      ..add(OcsGetCapabilitiesResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(OcsGetCapabilitiesResponseApplicationJson_Ocs_Data),
        OcsGetCapabilitiesResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(OcsGetCapabilitiesResponseApplicationJson_Ocs_Data.serializer)
      ..addBuilderFactory(
        const FullType(OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_Version),
        OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_VersionBuilder.new,
      )
      ..add(OcsGetCapabilitiesResponseApplicationJson_Ocs_Data_Version.serializer)
      ..addBuilderFactory(const FullType(CoreCapabilities), CoreCapabilitiesBuilder.new)
      ..add(CoreCapabilities.serializer)
      ..addBuilderFactory(const FullType(CoreCapabilities_Core), CoreCapabilities_CoreBuilder.new)
      ..add(CoreCapabilities_Core.serializer)
      ..addBuilderFactory(const FullType(CorePublicCapabilities), CorePublicCapabilitiesBuilder.new)
      ..add(CorePublicCapabilities.serializer)
      ..addBuilderFactory(
        const FullType(CorePublicCapabilities_Bruteforce),
        CorePublicCapabilities_BruteforceBuilder.new,
      )
      ..add(CorePublicCapabilities_Bruteforce.serializer)
      ..addBuilderFactory(const FullType(CommentsCapabilities), CommentsCapabilitiesBuilder.new)
      ..add(CommentsCapabilities.serializer)
      ..addBuilderFactory(const FullType(CommentsCapabilities_Files), CommentsCapabilities_FilesBuilder.new)
      ..add(CommentsCapabilities_Files.serializer)
      ..addBuilderFactory(const FullType(DavCapabilities), DavCapabilitiesBuilder.new)
      ..add(DavCapabilities.serializer)
      ..addBuilderFactory(const FullType(DavCapabilities_Dav), DavCapabilities_DavBuilder.new)
      ..add(DavCapabilities_Dav.serializer)
      ..addBuilderFactory(const FullType(DropAccountCapabilities), DropAccountCapabilitiesBuilder.new)
      ..add(DropAccountCapabilities.serializer)
      ..addBuilderFactory(
        const FullType(DropAccountCapabilities_DropAccount),
        DropAccountCapabilities_DropAccountBuilder.new,
      )
      ..add(DropAccountCapabilities_DropAccount.serializer)
      ..addBuilderFactory(
        const FullType(DropAccountCapabilities_DropAccount_Delay),
        DropAccountCapabilities_DropAccount_DelayBuilder.new,
      )
      ..add(DropAccountCapabilities_DropAccount_Delay.serializer)
      ..addBuilderFactory(const FullType(FilesCapabilities), FilesCapabilitiesBuilder.new)
      ..add(FilesCapabilities.serializer)
      ..addBuilderFactory(const FullType(FilesCapabilities_Files), FilesCapabilities_FilesBuilder.new)
      ..add(FilesCapabilities_Files.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(JsonObject)]), ListBuilder<JsonObject>.new)
      ..addBuilderFactory(
        const FullType(FilesCapabilities_Files_DirectEditing),
        FilesCapabilities_Files_DirectEditingBuilder.new,
      )
      ..add(FilesCapabilities_Files_DirectEditing.serializer)
      ..addBuilderFactory(const FullType(FilesSharingCapabilities), FilesSharingCapabilitiesBuilder.new)
      ..add(FilesSharingCapabilities.serializer)
      ..addBuilderFactory(
        const FullType(FilesSharingCapabilities_FilesSharing),
        FilesSharingCapabilities_FilesSharingBuilder.new,
      )
      ..add(FilesSharingCapabilities_FilesSharing.serializer)
      ..addBuilderFactory(
        const FullType(FilesSharingCapabilities_FilesSharing_Public),
        FilesSharingCapabilities_FilesSharing_PublicBuilder.new,
      )
      ..add(FilesSharingCapabilities_FilesSharing_Public.serializer)
      ..addBuilderFactory(
        const FullType(FilesSharingCapabilities_FilesSharing_Public_Password),
        FilesSharingCapabilities_FilesSharing_Public_PasswordBuilder.new,
      )
      ..add(FilesSharingCapabilities_FilesSharing_Public_Password.serializer)
      ..addBuilderFactory(
        const FullType(FilesSharingCapabilities_FilesSharing_Public_ExpireDate),
        FilesSharingCapabilities_FilesSharing_Public_ExpireDateBuilder.new,
      )
      ..add(FilesSharingCapabilities_FilesSharing_Public_ExpireDate.serializer)
      ..addBuilderFactory(
        const FullType(FilesSharingCapabilities_FilesSharing_Public_ExpireDateInternal),
        FilesSharingCapabilities_FilesSharing_Public_ExpireDateInternalBuilder.new,
      )
      ..add(FilesSharingCapabilities_FilesSharing_Public_ExpireDateInternal.serializer)
      ..addBuilderFactory(
        const FullType(FilesSharingCapabilities_FilesSharing_Public_ExpireDateRemote),
        FilesSharingCapabilities_FilesSharing_Public_ExpireDateRemoteBuilder.new,
      )
      ..add(FilesSharingCapabilities_FilesSharing_Public_ExpireDateRemote.serializer)
      ..addBuilderFactory(
        const FullType(FilesSharingCapabilities_FilesSharing_User),
        FilesSharingCapabilities_FilesSharing_UserBuilder.new,
      )
      ..add(FilesSharingCapabilities_FilesSharing_User.serializer)
      ..addBuilderFactory(
        const FullType(FilesSharingCapabilities_FilesSharing_User_ExpireDate),
        FilesSharingCapabilities_FilesSharing_User_ExpireDateBuilder.new,
      )
      ..add(FilesSharingCapabilities_FilesSharing_User_ExpireDate.serializer)
      ..addBuilderFactory(
        const FullType(FilesSharingCapabilities_FilesSharing_Group),
        FilesSharingCapabilities_FilesSharing_GroupBuilder.new,
      )
      ..add(FilesSharingCapabilities_FilesSharing_Group.serializer)
      ..addBuilderFactory(
        const FullType(FilesSharingCapabilities_FilesSharing_Group_ExpireDate),
        FilesSharingCapabilities_FilesSharing_Group_ExpireDateBuilder.new,
      )
      ..add(FilesSharingCapabilities_FilesSharing_Group_ExpireDate.serializer)
      ..addBuilderFactory(
        const FullType(FilesSharingCapabilities_FilesSharing_Federation),
        FilesSharingCapabilities_FilesSharing_FederationBuilder.new,
      )
      ..add(FilesSharingCapabilities_FilesSharing_Federation.serializer)
      ..addBuilderFactory(
        const FullType(FilesSharingCapabilities_FilesSharing_Federation_ExpireDate),
        FilesSharingCapabilities_FilesSharing_Federation_ExpireDateBuilder.new,
      )
      ..add(FilesSharingCapabilities_FilesSharing_Federation_ExpireDate.serializer)
      ..addBuilderFactory(
        const FullType(FilesSharingCapabilities_FilesSharing_Federation_ExpireDateSupported),
        FilesSharingCapabilities_FilesSharing_Federation_ExpireDateSupportedBuilder.new,
      )
      ..add(FilesSharingCapabilities_FilesSharing_Federation_ExpireDateSupported.serializer)
      ..addBuilderFactory(
        const FullType(FilesSharingCapabilities_FilesSharing_Sharee),
        FilesSharingCapabilities_FilesSharing_ShareeBuilder.new,
      )
      ..add(FilesSharingCapabilities_FilesSharing_Sharee.serializer)
      ..addBuilderFactory(const FullType(FilesTrashbinCapabilities), FilesTrashbinCapabilitiesBuilder.new)
      ..add(FilesTrashbinCapabilities.serializer)
      ..addBuilderFactory(const FullType(FilesTrashbinCapabilities_Files), FilesTrashbinCapabilities_FilesBuilder.new)
      ..add(FilesTrashbinCapabilities_Files.serializer)
      ..addBuilderFactory(const FullType(FilesVersionsCapabilities), FilesVersionsCapabilitiesBuilder.new)
      ..add(FilesVersionsCapabilities.serializer)
      ..addBuilderFactory(const FullType(FilesVersionsCapabilities_Files), FilesVersionsCapabilities_FilesBuilder.new)
      ..add(FilesVersionsCapabilities_Files.serializer)
      ..addBuilderFactory(const FullType(NotificationsCapabilities), NotificationsCapabilitiesBuilder.new)
      ..add(NotificationsCapabilities.serializer)
      ..addBuilderFactory(
        const FullType(NotificationsCapabilities_Notifications),
        NotificationsCapabilities_NotificationsBuilder.new,
      )
      ..add(NotificationsCapabilities_Notifications.serializer)
      ..addBuilderFactory(const FullType(ProvisioningApiCapabilities), ProvisioningApiCapabilitiesBuilder.new)
      ..add(ProvisioningApiCapabilities.serializer)
      ..addBuilderFactory(
        const FullType(ProvisioningApiCapabilities_ProvisioningApi),
        ProvisioningApiCapabilities_ProvisioningApiBuilder.new,
      )
      ..add(ProvisioningApiCapabilities_ProvisioningApi.serializer)
      ..addBuilderFactory(const FullType(SharebymailCapabilities0), SharebymailCapabilities0Builder.new)
      ..add(SharebymailCapabilities0.serializer)
      ..addBuilderFactory(
        const FullType(SharebymailCapabilities0_FilesSharing),
        SharebymailCapabilities0_FilesSharingBuilder.new,
      )
      ..add(SharebymailCapabilities0_FilesSharing.serializer)
      ..addBuilderFactory(
        const FullType(SharebymailCapabilities0_FilesSharing_Sharebymail),
        SharebymailCapabilities0_FilesSharing_SharebymailBuilder.new,
      )
      ..add(SharebymailCapabilities0_FilesSharing_Sharebymail.serializer)
      ..addBuilderFactory(
        const FullType(SharebymailCapabilities0_FilesSharing_Sharebymail_UploadFilesDrop),
        SharebymailCapabilities0_FilesSharing_Sharebymail_UploadFilesDropBuilder.new,
      )
      ..add(SharebymailCapabilities0_FilesSharing_Sharebymail_UploadFilesDrop.serializer)
      ..addBuilderFactory(
        const FullType(SharebymailCapabilities0_FilesSharing_Sharebymail_Password),
        SharebymailCapabilities0_FilesSharing_Sharebymail_PasswordBuilder.new,
      )
      ..add(SharebymailCapabilities0_FilesSharing_Sharebymail_Password.serializer)
      ..addBuilderFactory(
        const FullType(SharebymailCapabilities0_FilesSharing_Sharebymail_ExpireDate),
        SharebymailCapabilities0_FilesSharing_Sharebymail_ExpireDateBuilder.new,
      )
      ..add(SharebymailCapabilities0_FilesSharing_Sharebymail_ExpireDate.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(Never)]), ListBuilder<Never>.new)
      ..add($46564992d3ed3482aa6c1162698aac99Extension._serializer)
      ..addBuilderFactory(const FullType(SpreedCapabilities), SpreedCapabilitiesBuilder.new)
      ..add(SpreedCapabilities.serializer)
      ..addBuilderFactory(const FullType(SpreedCapabilities_Config), SpreedCapabilities_ConfigBuilder.new)
      ..add(SpreedCapabilities_Config.serializer)
      ..addBuilderFactory(
        const FullType(SpreedCapabilities_Config_Attachments),
        SpreedCapabilities_Config_AttachmentsBuilder.new,
      )
      ..add(SpreedCapabilities_Config_Attachments.serializer)
      ..addBuilderFactory(const FullType(SpreedCapabilities_Config_Call), SpreedCapabilities_Config_CallBuilder.new)
      ..add(SpreedCapabilities_Config_Call.serializer)
      ..addBuilderFactory(const FullType(SpreedCapabilities_Config_Chat), SpreedCapabilities_Config_ChatBuilder.new)
      ..add(SpreedCapabilities_Config_Chat.serializer)
      ..addBuilderFactory(
        const FullType(SpreedCapabilities_Config_Conversations),
        SpreedCapabilities_Config_ConversationsBuilder.new,
      )
      ..add(SpreedCapabilities_Config_Conversations.serializer)
      ..addBuilderFactory(
        const FullType(SpreedCapabilities_Config_Federation),
        SpreedCapabilities_Config_FederationBuilder.new,
      )
      ..add(SpreedCapabilities_Config_Federation.serializer)
      ..addBuilderFactory(
        const FullType(SpreedCapabilities_Config_Previews),
        SpreedCapabilities_Config_PreviewsBuilder.new,
      )
      ..add(SpreedCapabilities_Config_Previews.serializer)
      ..addBuilderFactory(
        const FullType(SpreedCapabilities_Config_Signaling),
        SpreedCapabilities_Config_SignalingBuilder.new,
      )
      ..add(SpreedCapabilities_Config_Signaling.serializer)
      ..addBuilderFactory(const FullType(SpreedPublicCapabilities0), SpreedPublicCapabilities0Builder.new)
      ..add(SpreedPublicCapabilities0.serializer)
      ..add($06c2e47196a84ebc3718dccf9eb4b29dExtension._serializer)
      ..addBuilderFactory(const FullType(SystemtagsCapabilities), SystemtagsCapabilitiesBuilder.new)
      ..add(SystemtagsCapabilities.serializer)
      ..addBuilderFactory(
        const FullType(SystemtagsCapabilities_Systemtags),
        SystemtagsCapabilities_SystemtagsBuilder.new,
      )
      ..add(SystemtagsCapabilities_Systemtags.serializer)
      ..add(SystemtagsCapabilities_Systemtags_Enabled.serializer)
      ..addBuilderFactory(const FullType(ThemingPublicCapabilities), ThemingPublicCapabilitiesBuilder.new)
      ..add(ThemingPublicCapabilities.serializer)
      ..addBuilderFactory(
        const FullType(ThemingPublicCapabilities_Theming),
        ThemingPublicCapabilities_ThemingBuilder.new,
      )
      ..add(ThemingPublicCapabilities_Theming.serializer)
      ..addBuilderFactory(const FullType(UserStatusCapabilities), UserStatusCapabilitiesBuilder.new)
      ..add(UserStatusCapabilities.serializer)
      ..addBuilderFactory(
        const FullType(UserStatusCapabilities_UserStatus),
        UserStatusCapabilities_UserStatusBuilder.new,
      )
      ..add(UserStatusCapabilities_UserStatus.serializer)
      ..addBuilderFactory(const FullType(WeatherStatusCapabilities), WeatherStatusCapabilitiesBuilder.new)
      ..add(WeatherStatusCapabilities.serializer)
      ..addBuilderFactory(
        const FullType(WeatherStatusCapabilities_WeatherStatus),
        WeatherStatusCapabilities_WeatherStatusBuilder.new,
      )
      ..add(WeatherStatusCapabilities_WeatherStatus.serializer)
      ..addBuilderFactory(const FullType(NotesCapabilities), NotesCapabilitiesBuilder.new)
      ..add(NotesCapabilities.serializer)
      ..addBuilderFactory(const FullType(NotesCapabilities_Notes), NotesCapabilities_NotesBuilder.new)
      ..add(NotesCapabilities_Notes.serializer)
      ..add($f6f5edfce09cb06e8f14ce14ab1af117Extension._serializer)
      ..add(PreviewGetPreviewA.serializer)
      ..add(PreviewGetPreviewForceIcon.serializer)
      ..add(PreviewGetPreviewMimeFallback.serializer)
      ..add(PreviewGetPreviewByFileIdA.serializer)
      ..add(PreviewGetPreviewByFileIdForceIcon.serializer)
      ..add(PreviewGetPreviewByFileIdMimeFallback.serializer)
      ..addBuilderFactory(
        const FullType(ProfileApiSetVisibilityResponseApplicationJson),
        ProfileApiSetVisibilityResponseApplicationJsonBuilder.new,
      )
      ..add(ProfileApiSetVisibilityResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ProfileApiSetVisibilityResponseApplicationJson_Ocs),
        ProfileApiSetVisibilityResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ProfileApiSetVisibilityResponseApplicationJson_Ocs.serializer)
      ..add(ReferenceApiExtractResolve.serializer)
      ..addBuilderFactory(
        const FullType(ReferenceApiExtractResponseApplicationJson),
        ReferenceApiExtractResponseApplicationJsonBuilder.new,
      )
      ..add(ReferenceApiExtractResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ReferenceApiExtractResponseApplicationJson_Ocs),
        ReferenceApiExtractResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ReferenceApiExtractResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(ReferenceApiExtractResponseApplicationJson_Ocs_Data),
        ReferenceApiExtractResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(ReferenceApiExtractResponseApplicationJson_Ocs_Data.serializer)
      ..addBuilderFactory(const FullType(Reference), ReferenceBuilder.new)
      ..add(Reference.serializer)
      ..addBuilderFactory(
        const FullType(BuiltMap, [FullType(String), FullType(Reference)]),
        MapBuilder<String, Reference>.new,
      )
      ..addBuilderFactory(
        const FullType(ReferenceApiResolveOneResponseApplicationJson),
        ReferenceApiResolveOneResponseApplicationJsonBuilder.new,
      )
      ..add(ReferenceApiResolveOneResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ReferenceApiResolveOneResponseApplicationJson_Ocs),
        ReferenceApiResolveOneResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ReferenceApiResolveOneResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(ReferenceApiResolveOneResponseApplicationJson_Ocs_Data),
        ReferenceApiResolveOneResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(ReferenceApiResolveOneResponseApplicationJson_Ocs_Data.serializer)
      ..addBuilderFactory(
        const FullType(ReferenceApiResolveResponseApplicationJson),
        ReferenceApiResolveResponseApplicationJsonBuilder.new,
      )
      ..add(ReferenceApiResolveResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ReferenceApiResolveResponseApplicationJson_Ocs),
        ReferenceApiResolveResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ReferenceApiResolveResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(ReferenceApiResolveResponseApplicationJson_Ocs_Data),
        ReferenceApiResolveResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(ReferenceApiResolveResponseApplicationJson_Ocs_Data.serializer)
      ..addBuilderFactory(
        const FullType(ReferenceApiGetProvidersInfoResponseApplicationJson),
        ReferenceApiGetProvidersInfoResponseApplicationJsonBuilder.new,
      )
      ..add(ReferenceApiGetProvidersInfoResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ReferenceApiGetProvidersInfoResponseApplicationJson_Ocs),
        ReferenceApiGetProvidersInfoResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ReferenceApiGetProvidersInfoResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(ReferenceProvider), ReferenceProviderBuilder.new)
      ..add(ReferenceProvider.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(ReferenceProvider)]), ListBuilder<ReferenceProvider>.new)
      ..addBuilderFactory(
        const FullType(ReferenceApiTouchProviderResponseApplicationJson),
        ReferenceApiTouchProviderResponseApplicationJsonBuilder.new,
      )
      ..add(ReferenceApiTouchProviderResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ReferenceApiTouchProviderResponseApplicationJson_Ocs),
        ReferenceApiTouchProviderResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ReferenceApiTouchProviderResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(ReferenceApiTouchProviderResponseApplicationJson_Ocs_Data),
        ReferenceApiTouchProviderResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(ReferenceApiTouchProviderResponseApplicationJson_Ocs_Data.serializer)
      ..addBuilderFactory(
        const FullType(TeamsApiResolveOneResponseApplicationJson),
        TeamsApiResolveOneResponseApplicationJsonBuilder.new,
      )
      ..add(TeamsApiResolveOneResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(TeamsApiResolveOneResponseApplicationJson_Ocs),
        TeamsApiResolveOneResponseApplicationJson_OcsBuilder.new,
      )
      ..add(TeamsApiResolveOneResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(TeamsApiResolveOneResponseApplicationJson_Ocs_Data),
        TeamsApiResolveOneResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(TeamsApiResolveOneResponseApplicationJson_Ocs_Data.serializer)
      ..addBuilderFactory(const FullType(TeamResource), TeamResourceBuilder.new)
      ..add(TeamResource.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(TeamResource)]), ListBuilder<TeamResource>.new)
      ..addBuilderFactory(
        const FullType(TeamsApiListTeamsResponseApplicationJson),
        TeamsApiListTeamsResponseApplicationJsonBuilder.new,
      )
      ..add(TeamsApiListTeamsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(TeamsApiListTeamsResponseApplicationJson_Ocs),
        TeamsApiListTeamsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(TeamsApiListTeamsResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(TeamsApiListTeamsResponseApplicationJson_Ocs_Data),
        TeamsApiListTeamsResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(TeamsApiListTeamsResponseApplicationJson_Ocs_Data.serializer)
      ..addBuilderFactory(const FullType(Team), TeamBuilder.new)
      ..add(Team.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(Team)]), ListBuilder<Team>.new)
      ..addBuilderFactory(
        const FullType(TextProcessingApiTaskTypesResponseApplicationJson),
        TextProcessingApiTaskTypesResponseApplicationJsonBuilder.new,
      )
      ..add(TextProcessingApiTaskTypesResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(TextProcessingApiTaskTypesResponseApplicationJson_Ocs),
        TextProcessingApiTaskTypesResponseApplicationJson_OcsBuilder.new,
      )
      ..add(TextProcessingApiTaskTypesResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data),
        TextProcessingApiTaskTypesResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data.serializer)
      ..addBuilderFactory(
        const FullType(TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data_Types),
        TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data_TypesBuilder.new,
      )
      ..add(TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data_Types.serializer)
      ..addBuilderFactory(
        const FullType(BuiltList, [FullType(TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data_Types)]),
        ListBuilder<TextProcessingApiTaskTypesResponseApplicationJson_Ocs_Data_Types>.new,
      )
      ..addBuilderFactory(
        const FullType(TextProcessingApiScheduleResponseApplicationJson),
        TextProcessingApiScheduleResponseApplicationJsonBuilder.new,
      )
      ..add(TextProcessingApiScheduleResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(TextProcessingApiScheduleResponseApplicationJson_Ocs),
        TextProcessingApiScheduleResponseApplicationJson_OcsBuilder.new,
      )
      ..add(TextProcessingApiScheduleResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(TextProcessingApiScheduleResponseApplicationJson_Ocs_Data),
        TextProcessingApiScheduleResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(TextProcessingApiScheduleResponseApplicationJson_Ocs_Data.serializer)
      ..addBuilderFactory(const FullType(TextProcessingTask), TextProcessingTaskBuilder.new)
      ..add(TextProcessingTask.serializer)
      ..add(TextProcessingTask_Status.serializer)
      ..addBuilderFactory(
        const FullType(TextProcessingApiGetTaskResponseApplicationJson),
        TextProcessingApiGetTaskResponseApplicationJsonBuilder.new,
      )
      ..add(TextProcessingApiGetTaskResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(TextProcessingApiGetTaskResponseApplicationJson_Ocs),
        TextProcessingApiGetTaskResponseApplicationJson_OcsBuilder.new,
      )
      ..add(TextProcessingApiGetTaskResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(TextProcessingApiGetTaskResponseApplicationJson_Ocs_Data),
        TextProcessingApiGetTaskResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(TextProcessingApiGetTaskResponseApplicationJson_Ocs_Data.serializer)
      ..addBuilderFactory(
        const FullType(TextProcessingApiDeleteTaskResponseApplicationJson),
        TextProcessingApiDeleteTaskResponseApplicationJsonBuilder.new,
      )
      ..add(TextProcessingApiDeleteTaskResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(TextProcessingApiDeleteTaskResponseApplicationJson_Ocs),
        TextProcessingApiDeleteTaskResponseApplicationJson_OcsBuilder.new,
      )
      ..add(TextProcessingApiDeleteTaskResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(TextProcessingApiDeleteTaskResponseApplicationJson_Ocs_Data),
        TextProcessingApiDeleteTaskResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(TextProcessingApiDeleteTaskResponseApplicationJson_Ocs_Data.serializer)
      ..addBuilderFactory(
        const FullType(TextProcessingApiListTasksByAppResponseApplicationJson),
        TextProcessingApiListTasksByAppResponseApplicationJsonBuilder.new,
      )
      ..add(TextProcessingApiListTasksByAppResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(TextProcessingApiListTasksByAppResponseApplicationJson_Ocs),
        TextProcessingApiListTasksByAppResponseApplicationJson_OcsBuilder.new,
      )
      ..add(TextProcessingApiListTasksByAppResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(TextProcessingApiListTasksByAppResponseApplicationJson_Ocs_Data),
        TextProcessingApiListTasksByAppResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(TextProcessingApiListTasksByAppResponseApplicationJson_Ocs_Data.serializer)
      ..addBuilderFactory(
        const FullType(BuiltList, [FullType(TextProcessingTask)]),
        ListBuilder<TextProcessingTask>.new,
      )
      ..addBuilderFactory(
        const FullType(TextToImageApiIsAvailableResponseApplicationJson),
        TextToImageApiIsAvailableResponseApplicationJsonBuilder.new,
      )
      ..add(TextToImageApiIsAvailableResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(TextToImageApiIsAvailableResponseApplicationJson_Ocs),
        TextToImageApiIsAvailableResponseApplicationJson_OcsBuilder.new,
      )
      ..add(TextToImageApiIsAvailableResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(TextToImageApiIsAvailableResponseApplicationJson_Ocs_Data),
        TextToImageApiIsAvailableResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(TextToImageApiIsAvailableResponseApplicationJson_Ocs_Data.serializer)
      ..addBuilderFactory(
        const FullType(TextToImageApiScheduleResponseApplicationJson),
        TextToImageApiScheduleResponseApplicationJsonBuilder.new,
      )
      ..add(TextToImageApiScheduleResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(TextToImageApiScheduleResponseApplicationJson_Ocs),
        TextToImageApiScheduleResponseApplicationJson_OcsBuilder.new,
      )
      ..add(TextToImageApiScheduleResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(TextToImageApiScheduleResponseApplicationJson_Ocs_Data),
        TextToImageApiScheduleResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(TextToImageApiScheduleResponseApplicationJson_Ocs_Data.serializer)
      ..addBuilderFactory(const FullType(TextToImageTask), TextToImageTaskBuilder.new)
      ..add(TextToImageTask.serializer)
      ..add(TextToImageTask_Status.serializer)
      ..addBuilderFactory(
        const FullType(TextToImageApiGetTaskResponseApplicationJson),
        TextToImageApiGetTaskResponseApplicationJsonBuilder.new,
      )
      ..add(TextToImageApiGetTaskResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(TextToImageApiGetTaskResponseApplicationJson_Ocs),
        TextToImageApiGetTaskResponseApplicationJson_OcsBuilder.new,
      )
      ..add(TextToImageApiGetTaskResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(TextToImageApiGetTaskResponseApplicationJson_Ocs_Data),
        TextToImageApiGetTaskResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(TextToImageApiGetTaskResponseApplicationJson_Ocs_Data.serializer)
      ..addBuilderFactory(
        const FullType(TextToImageApiDeleteTaskResponseApplicationJson),
        TextToImageApiDeleteTaskResponseApplicationJsonBuilder.new,
      )
      ..add(TextToImageApiDeleteTaskResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(TextToImageApiDeleteTaskResponseApplicationJson_Ocs),
        TextToImageApiDeleteTaskResponseApplicationJson_OcsBuilder.new,
      )
      ..add(TextToImageApiDeleteTaskResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(TextToImageApiDeleteTaskResponseApplicationJson_Ocs_Data),
        TextToImageApiDeleteTaskResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(TextToImageApiDeleteTaskResponseApplicationJson_Ocs_Data.serializer)
      ..addBuilderFactory(
        const FullType(TextToImageApiListTasksByAppResponseApplicationJson),
        TextToImageApiListTasksByAppResponseApplicationJsonBuilder.new,
      )
      ..add(TextToImageApiListTasksByAppResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(TextToImageApiListTasksByAppResponseApplicationJson_Ocs),
        TextToImageApiListTasksByAppResponseApplicationJson_OcsBuilder.new,
      )
      ..add(TextToImageApiListTasksByAppResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(TextToImageApiListTasksByAppResponseApplicationJson_Ocs_Data),
        TextToImageApiListTasksByAppResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(TextToImageApiListTasksByAppResponseApplicationJson_Ocs_Data.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(TextToImageTask)]), ListBuilder<TextToImageTask>.new)
      ..addBuilderFactory(
        const FullType(TranslationApiLanguagesResponseApplicationJson),
        TranslationApiLanguagesResponseApplicationJsonBuilder.new,
      )
      ..add(TranslationApiLanguagesResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(TranslationApiLanguagesResponseApplicationJson_Ocs),
        TranslationApiLanguagesResponseApplicationJson_OcsBuilder.new,
      )
      ..add(TranslationApiLanguagesResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(TranslationApiLanguagesResponseApplicationJson_Ocs_Data),
        TranslationApiLanguagesResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(TranslationApiLanguagesResponseApplicationJson_Ocs_Data.serializer)
      ..addBuilderFactory(
        const FullType(TranslationApiLanguagesResponseApplicationJson_Ocs_Data_Languages),
        TranslationApiLanguagesResponseApplicationJson_Ocs_Data_LanguagesBuilder.new,
      )
      ..add(TranslationApiLanguagesResponseApplicationJson_Ocs_Data_Languages.serializer)
      ..addBuilderFactory(
        const FullType(BuiltList, [FullType(TranslationApiLanguagesResponseApplicationJson_Ocs_Data_Languages)]),
        ListBuilder<TranslationApiLanguagesResponseApplicationJson_Ocs_Data_Languages>.new,
      )
      ..addBuilderFactory(
        const FullType(TranslationApiTranslateResponseApplicationJson),
        TranslationApiTranslateResponseApplicationJsonBuilder.new,
      )
      ..add(TranslationApiTranslateResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(TranslationApiTranslateResponseApplicationJson_Ocs),
        TranslationApiTranslateResponseApplicationJson_OcsBuilder.new,
      )
      ..add(TranslationApiTranslateResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(TranslationApiTranslateResponseApplicationJson_Ocs_Data),
        TranslationApiTranslateResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(TranslationApiTranslateResponseApplicationJson_Ocs_Data.serializer)
      ..addBuilderFactory(
        const FullType(UnifiedSearchGetProvidersResponseApplicationJson),
        UnifiedSearchGetProvidersResponseApplicationJsonBuilder.new,
      )
      ..add(UnifiedSearchGetProvidersResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(UnifiedSearchGetProvidersResponseApplicationJson_Ocs),
        UnifiedSearchGetProvidersResponseApplicationJson_OcsBuilder.new,
      )
      ..add(UnifiedSearchGetProvidersResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(UnifiedSearchProvider), UnifiedSearchProviderBuilder.new)
      ..add(UnifiedSearchProvider.serializer)
      ..addBuilderFactory(
        const FullType(BuiltMap, [FullType(String), FullType(String)]),
        MapBuilder<String, String>.new,
      )
      ..addBuilderFactory(
        const FullType(BuiltList, [FullType(UnifiedSearchProvider)]),
        ListBuilder<UnifiedSearchProvider>.new,
      )
      ..addBuilderFactory(
        const FullType(UnifiedSearchSearchResponseApplicationJson),
        UnifiedSearchSearchResponseApplicationJsonBuilder.new,
      )
      ..add(UnifiedSearchSearchResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(UnifiedSearchSearchResponseApplicationJson_Ocs),
        UnifiedSearchSearchResponseApplicationJson_OcsBuilder.new,
      )
      ..add(UnifiedSearchSearchResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(UnifiedSearchResult), UnifiedSearchResultBuilder.new)
      ..add(UnifiedSearchResult.serializer)
      ..addBuilderFactory(const FullType(UnifiedSearchResultEntry), UnifiedSearchResultEntryBuilder.new)
      ..add(UnifiedSearchResultEntry.serializer)
      ..addBuilderFactory(
        const FullType(BuiltList, [FullType(UnifiedSearchResultEntry)]),
        ListBuilder<UnifiedSearchResultEntry>.new,
      )
      ..addBuilderFactory(
        const FullType(WhatsNewGetResponseApplicationJson),
        WhatsNewGetResponseApplicationJsonBuilder.new,
      )
      ..add(WhatsNewGetResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(WhatsNewGetResponseApplicationJson_Ocs),
        WhatsNewGetResponseApplicationJson_OcsBuilder.new,
      )
      ..add(WhatsNewGetResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(WhatsNewGetResponseApplicationJson_Ocs_Data),
        WhatsNewGetResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(WhatsNewGetResponseApplicationJson_Ocs_Data.serializer)
      ..addBuilderFactory(
        const FullType(WhatsNewGetResponseApplicationJson_Ocs_Data_WhatsNew),
        WhatsNewGetResponseApplicationJson_Ocs_Data_WhatsNewBuilder.new,
      )
      ..add(WhatsNewGetResponseApplicationJson_Ocs_Data_WhatsNew.serializer)
      ..addBuilderFactory(
        const FullType(WhatsNewDismissResponseApplicationJson),
        WhatsNewDismissResponseApplicationJsonBuilder.new,
      )
      ..add(WhatsNewDismissResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(WhatsNewDismissResponseApplicationJson_Ocs),
        WhatsNewDismissResponseApplicationJson_OcsBuilder.new,
      )
      ..add(WhatsNewDismissResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(WipeCheckWipeResponseApplicationJson),
        WipeCheckWipeResponseApplicationJsonBuilder.new,
      )
      ..add(WipeCheckWipeResponseApplicationJson.serializer)
      ..addBuilderFactory(const FullType(Capabilities), CapabilitiesBuilder.new)
      ..add(Capabilities.serializer)
      ..addBuilderFactory(const FullType(Capabilities_Core), Capabilities_CoreBuilder.new)
      ..add(Capabilities_Core.serializer)
      ..addBuilderFactory(const FullType(PublicCapabilities), PublicCapabilitiesBuilder.new)
      ..add(PublicCapabilities.serializer)
      ..addBuilderFactory(const FullType(PublicCapabilities_Bruteforce), PublicCapabilities_BruteforceBuilder.new)
      ..add(PublicCapabilities_Bruteforce.serializer))
    .build();

/// Serializer for all values in this library.
///
/// Serializes values into the json. Json serialization is more expensive than the built_value wire format.
/// See: [$serializers] for serializing into the `built_value` wire format.
@_i2.visibleForTesting
final Serializers $jsonSerializers = _$jsonSerializers;
final Serializers _$jsonSerializers = (_$serializers.toBuilder()
      ..add(_i6.DynamiteDoubleSerializer())
      ..addPlugin(
        _i7.StandardJsonPlugin(
          typesToLeaveAsList: const {
            _$87e48e5649cd72b4d2947aaaea13ccd8,
            _$b2c4857c0136baea42828d89c87c757d,
            _$46564992d3ed3482aa6c1162698aac99,
            _$06c2e47196a84ebc3718dccf9eb4b29d,
            _$f6f5edfce09cb06e8f14ce14ab1af117,
          },
        ),
      )
      ..addPlugin(const _i6.HeaderPlugin())
      ..addPlugin(const _i6.ContentStringPlugin()))
    .build();
// coverage:ignore-end
