// Use of this source code is governed by a agpl license. It can be obtained at `https://spdx.org/licenses/AGPL-3.0-only.html`.

// OpenAPI client generated by Dynamite. Do not manually edit this file.

// ignore_for_file: camel_case_extensions, camel_case_types, discarded_futures
// ignore_for_file: no_leading_underscores_for_local_identifiers
// ignore_for_file: non_constant_identifier_names, public_member_api_docs
// ignore_for_file: unreachable_switch_case

/// spreed Version: 0.0.1.
///
/// Chat, video & audio-conferencing using WebRTC.
///
/// Use of this source code is governed by a agpl license.
/// It can be obtained at `https://spdx.org/licenses/AGPL-3.0-only.html`.
library; // ignore_for_file: no_leading_underscores_for_library_prefixes

import 'dart:typed_data';

import 'package:built_collection/built_collection.dart';
import 'package:built_value/built_value.dart';
import 'package:built_value/json_object.dart';
import 'package:built_value/serializer.dart';
import 'package:built_value/standard_json_plugin.dart' as _i7;
import 'package:collection/collection.dart';
import 'package:dynamite_runtime/built_value.dart' as _i6;
import 'package:dynamite_runtime/http_client.dart' as _i1;
import 'package:dynamite_runtime/models.dart';
import 'package:dynamite_runtime/utils.dart' as _i4;
import 'package:http/http.dart' as _i3;
import 'package:meta/meta.dart' as _i2;
import 'package:uri/uri.dart' as _i5;

part 'spreed.openapi.g.dart';

class $Client extends _i1.DynamiteClient {
  /// Creates a new `DynamiteClient` for untagged requests.
  $Client(
    super.baseURL, {
    super.httpClient,
    super.authentications,
  });

  /// Creates a new [$Client] from another [client].
  $Client.fromClient(_i1.DynamiteClient client)
      : super(
          client.baseURL,
          httpClient: client.httpClient,
          authentications: client.authentications,
        );

  late final $AvatarClient avatar = $AvatarClient(this);

  late final $BotClient bot = $BotClient(this);

  late final $BreakoutRoomClient breakoutRoom = $BreakoutRoomClient(this);

  late final $CallClient call = $CallClient(this);

  late final $ChatClient chat = $ChatClient(this);

  late final $ExternalSignalingClient externalSignaling = $ExternalSignalingClient(this);

  late final $FederationClient federation = $FederationClient(this);

  late final $FilesIntegrationClient filesIntegration = $FilesIntegrationClient(this);

  late final $GuestClient guest = $GuestClient(this);

  late final $HostedSignalingServerClient hostedSignalingServer = $HostedSignalingServerClient(this);

  late final $InternalSignalingClient internalSignaling = $InternalSignalingClient(this);

  late final $MatterbridgeClient matterbridge = $MatterbridgeClient(this);

  late final $PollClient poll = $PollClient(this);

  late final $ReactionClient reaction = $ReactionClient(this);

  late final $RecordingClient recording = $RecordingClient(this);

  late final $RoomClient room = $RoomClient(this);

  late final $SettingsClient settings = $SettingsClient(this);

  late final $SignalingClient signaling = $SignalingClient(this);

  late final $UserAvatarClient userAvatar = $UserAvatarClient(this);
}

class $AvatarClient {
  /// Creates a new `DynamiteClient` for avatar requests.
  $AvatarClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$getAvatar_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<Uint8List, void> $getAvatar_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(Uint8List),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get the avatar of a room.
  ///
  /// Returns a `DynamiteRequest` backing the [getAvatar] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [darkTheme] Theme used for background. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room avatar returned
  ///
  /// See:
  ///  * [getAvatar] for a method executing this request and parsing the response.
  ///  * [$getAvatar_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getAvatar_Request({
    required String token,
    AvatarGetAvatarDarkTheme? darkTheme,
    AvatarGetAvatarApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $darkTheme = _$jsonSerializers.serialize(darkTheme, specifiedType: const FullType(AvatarGetAvatarDarkTheme));
    $darkTheme ??= 0;
    _parameters['darkTheme'] = $darkTheme;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(AvatarGetAvatarApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/avatar{?darkTheme*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = '*/*';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get the avatar of a room.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [darkTheme] Theme used for background. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room avatar returned
  ///
  /// See:
  ///  * [$getAvatar_Request] for the request send by this method.
  ///  * [$getAvatar_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<Uint8List, void>> getAvatar({
    required String token,
    AvatarGetAvatarDarkTheme? darkTheme,
    AvatarGetAvatarApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getAvatar_Request(
      token: token,
      darkTheme: darkTheme,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getAvatar_Serializer();
    final _rawResponse = await _i1.ResponseConverter<Uint8List, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$uploadAvatar_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<AvatarUploadAvatarResponseApplicationJson, void> $uploadAvatar_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(AvatarUploadAvatarResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Upload an avatar for a room.
  ///
  /// Returns a `DynamiteRequest` backing the [uploadAvatar] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Avatar uploaded successfully
  ///   * 400: Avatar invalid
  ///
  /// See:
  ///  * [uploadAvatar] for a method executing this request and parsing the response.
  ///  * [$uploadAvatar_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $uploadAvatar_Request({
    required String token,
    AvatarUploadAvatarApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(AvatarUploadAvatarApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/avatar').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Upload an avatar for a room.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Avatar uploaded successfully
  ///   * 400: Avatar invalid
  ///
  /// See:
  ///  * [$uploadAvatar_Request] for the request send by this method.
  ///  * [$uploadAvatar_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<AvatarUploadAvatarResponseApplicationJson, void>> uploadAvatar({
    required String token,
    AvatarUploadAvatarApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $uploadAvatar_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $uploadAvatar_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<AvatarUploadAvatarResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$deleteAvatar_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<AvatarDeleteAvatarResponseApplicationJson, void> $deleteAvatar_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(AvatarDeleteAvatarResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Delete the avatar of a room.
  ///
  /// Returns a `DynamiteRequest` backing the [deleteAvatar] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Avatar removed successfully
  ///
  /// See:
  ///  * [deleteAvatar] for a method executing this request and parsing the response.
  ///  * [$deleteAvatar_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $deleteAvatar_Request({
    required String token,
    AvatarDeleteAvatarApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(AvatarDeleteAvatarApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/avatar').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Delete the avatar of a room.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Avatar removed successfully
  ///
  /// See:
  ///  * [$deleteAvatar_Request] for the request send by this method.
  ///  * [$deleteAvatar_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<AvatarDeleteAvatarResponseApplicationJson, void>> deleteAvatar({
    required String token,
    AvatarDeleteAvatarApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $deleteAvatar_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $deleteAvatar_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<AvatarDeleteAvatarResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$emojiAvatar_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<AvatarEmojiAvatarResponseApplicationJson, void> $emojiAvatar_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(AvatarEmojiAvatarResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Set an emoji as avatar.
  ///
  /// Returns a `DynamiteRequest` backing the [emojiAvatar] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [emoji] Emoji.
  ///   * [color] Color of the emoji.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Avatar set successfully
  ///   * 400: Setting emoji avatar is not possible
  ///
  /// See:
  ///  * [emojiAvatar] for a method executing this request and parsing the response.
  ///  * [$emojiAvatar_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $emojiAvatar_Request({
    required String emoji,
    required String token,
    String? color,
    AvatarEmojiAvatarApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $emoji = _$jsonSerializers.serialize(emoji, specifiedType: const FullType(String));
    _parameters['emoji'] = $emoji;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $color = _$jsonSerializers.serialize(color, specifiedType: const FullType(String));
    _parameters['color'] = $color;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(AvatarEmojiAvatarApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/avatar/emoji{?emoji*,color*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Set an emoji as avatar.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [emoji] Emoji.
  ///   * [color] Color of the emoji.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Avatar set successfully
  ///   * 400: Setting emoji avatar is not possible
  ///
  /// See:
  ///  * [$emojiAvatar_Request] for the request send by this method.
  ///  * [$emojiAvatar_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<AvatarEmojiAvatarResponseApplicationJson, void>> emojiAvatar({
    required String emoji,
    required String token,
    String? color,
    AvatarEmojiAvatarApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $emojiAvatar_Request(
      emoji: emoji,
      token: token,
      color: color,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $emojiAvatar_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<AvatarEmojiAvatarResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$getAvatarDark_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<Uint8List, void> $getAvatarDark_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(Uint8List),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get the dark mode avatar of a room.
  ///
  /// Returns a `DynamiteRequest` backing the [getAvatarDark] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room avatar returned
  ///
  /// See:
  ///  * [getAvatarDark] for a method executing this request and parsing the response.
  ///  * [$getAvatarDark_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getAvatarDark_Request({
    required String token,
    AvatarGetAvatarDarkApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(AvatarGetAvatarDarkApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/avatar/dark').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = '*/*';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get the dark mode avatar of a room.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room avatar returned
  ///
  /// See:
  ///  * [$getAvatarDark_Request] for the request send by this method.
  ///  * [$getAvatarDark_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<Uint8List, void>> getAvatarDark({
    required String token,
    AvatarGetAvatarDarkApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getAvatarDark_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getAvatarDark_Serializer();
    final _rawResponse = await _i1.ResponseConverter<Uint8List, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$getUserProxyAvatarWithoutRoom_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<Uint8List, void> $getUserProxyAvatarWithoutRoom_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(Uint8List),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get the avatar of a cloudId user when inviting users while creating a conversation.
  ///
  /// Returns a `DynamiteRequest` backing the [getUserProxyAvatarWithoutRoom] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [cloudId] Federation CloudID to get the avatar for.
  ///   * [darkTheme] Theme used for background. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [size] Avatar size.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: User avatar returned
  ///
  /// See:
  ///  * [getUserProxyAvatarWithoutRoom] for a method executing this request and parsing the response.
  ///  * [$getUserProxyAvatarWithoutRoom_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getUserProxyAvatarWithoutRoom_Request({
    required String cloudId,
    required AvatarGetUserProxyAvatarWithoutRoomSize size,
    AvatarGetUserProxyAvatarWithoutRoomDarkTheme? darkTheme,
    AvatarGetUserProxyAvatarWithoutRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $cloudId = _$jsonSerializers.serialize(cloudId, specifiedType: const FullType(String));
    _parameters['cloudId'] = $cloudId;

    final $size =
        _$jsonSerializers.serialize(size, specifiedType: const FullType(AvatarGetUserProxyAvatarWithoutRoomSize));
    _parameters['size'] = $size;

    var $darkTheme = _$jsonSerializers.serialize(
      darkTheme,
      specifiedType: const FullType(AvatarGetUserProxyAvatarWithoutRoomDarkTheme),
    );
    $darkTheme ??= 0;
    _parameters['darkTheme'] = $darkTheme;

    var $apiVersion = _$jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(AvatarGetUserProxyAvatarWithoutRoomApiVersion),
    );
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/proxy/new/user-avatar/{size}{?cloudId*,darkTheme*}')
            .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = '*/*';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get the avatar of a cloudId user when inviting users while creating a conversation.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [cloudId] Federation CloudID to get the avatar for.
  ///   * [darkTheme] Theme used for background. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [size] Avatar size.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: User avatar returned
  ///
  /// See:
  ///  * [$getUserProxyAvatarWithoutRoom_Request] for the request send by this method.
  ///  * [$getUserProxyAvatarWithoutRoom_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<Uint8List, void>> getUserProxyAvatarWithoutRoom({
    required String cloudId,
    required AvatarGetUserProxyAvatarWithoutRoomSize size,
    AvatarGetUserProxyAvatarWithoutRoomDarkTheme? darkTheme,
    AvatarGetUserProxyAvatarWithoutRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getUserProxyAvatarWithoutRoom_Request(
      cloudId: cloudId,
      size: size,
      darkTheme: darkTheme,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getUserProxyAvatarWithoutRoom_Serializer();
    final _rawResponse = await _i1.ResponseConverter<Uint8List, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$getUserProxyAvatarDarkWithoutRoom_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<Uint8List, void> $getUserProxyAvatarDarkWithoutRoom_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(Uint8List),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get the dark mode avatar of a cloudId user when inviting users while creating a conversation.
  ///
  /// Returns a `DynamiteRequest` backing the [getUserProxyAvatarDarkWithoutRoom] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [cloudId] Federation CloudID to get the avatar for.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [size] Avatar size.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: User avatar returned
  ///
  /// See:
  ///  * [getUserProxyAvatarDarkWithoutRoom] for a method executing this request and parsing the response.
  ///  * [$getUserProxyAvatarDarkWithoutRoom_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getUserProxyAvatarDarkWithoutRoom_Request({
    required String cloudId,
    required AvatarGetUserProxyAvatarDarkWithoutRoomSize size,
    AvatarGetUserProxyAvatarDarkWithoutRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $cloudId = _$jsonSerializers.serialize(cloudId, specifiedType: const FullType(String));
    _parameters['cloudId'] = $cloudId;

    final $size =
        _$jsonSerializers.serialize(size, specifiedType: const FullType(AvatarGetUserProxyAvatarDarkWithoutRoomSize));
    _parameters['size'] = $size;

    var $apiVersion = _$jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(AvatarGetUserProxyAvatarDarkWithoutRoomApiVersion),
    );
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/proxy/new/user-avatar/{size}/dark{?cloudId*}')
            .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = '*/*';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get the dark mode avatar of a cloudId user when inviting users while creating a conversation.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [cloudId] Federation CloudID to get the avatar for.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [size] Avatar size.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: User avatar returned
  ///
  /// See:
  ///  * [$getUserProxyAvatarDarkWithoutRoom_Request] for the request send by this method.
  ///  * [$getUserProxyAvatarDarkWithoutRoom_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<Uint8List, void>> getUserProxyAvatarDarkWithoutRoom({
    required String cloudId,
    required AvatarGetUserProxyAvatarDarkWithoutRoomSize size,
    AvatarGetUserProxyAvatarDarkWithoutRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getUserProxyAvatarDarkWithoutRoom_Request(
      cloudId: cloudId,
      size: size,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getUserProxyAvatarDarkWithoutRoom_Serializer();
    final _rawResponse = await _i1.ResponseConverter<Uint8List, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$getUserProxyAvatar_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<Uint8List, void> $getUserProxyAvatar_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(Uint8List),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get the avatar of a cloudId user.
  ///
  /// Returns a `DynamiteRequest` backing the [getUserProxyAvatar] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [cloudId] Federation CloudID to get the avatar for.
  ///   * [darkTheme] Theme used for background. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [size] Avatar size.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: User avatar returned
  ///
  /// See:
  ///  * [getUserProxyAvatar] for a method executing this request and parsing the response.
  ///  * [$getUserProxyAvatar_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getUserProxyAvatar_Request({
    required String cloudId,
    required String token,
    required AvatarGetUserProxyAvatarSize size,
    AvatarGetUserProxyAvatarDarkTheme? darkTheme,
    AvatarGetUserProxyAvatarApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $cloudId = _$jsonSerializers.serialize(cloudId, specifiedType: const FullType(String));
    _parameters['cloudId'] = $cloudId;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $size = _$jsonSerializers.serialize(size, specifiedType: const FullType(AvatarGetUserProxyAvatarSize));
    _parameters['size'] = $size;

    var $darkTheme =
        _$jsonSerializers.serialize(darkTheme, specifiedType: const FullType(AvatarGetUserProxyAvatarDarkTheme));
    $darkTheme ??= 0;
    _parameters['darkTheme'] = $darkTheme;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(AvatarGetUserProxyAvatarApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/proxy/{token}/user-avatar/{size}{?cloudId*,darkTheme*}',
    ).expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = '*/*';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get the avatar of a cloudId user.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [cloudId] Federation CloudID to get the avatar for.
  ///   * [darkTheme] Theme used for background. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [size] Avatar size.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: User avatar returned
  ///
  /// See:
  ///  * [$getUserProxyAvatar_Request] for the request send by this method.
  ///  * [$getUserProxyAvatar_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<Uint8List, void>> getUserProxyAvatar({
    required String cloudId,
    required String token,
    required AvatarGetUserProxyAvatarSize size,
    AvatarGetUserProxyAvatarDarkTheme? darkTheme,
    AvatarGetUserProxyAvatarApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getUserProxyAvatar_Request(
      cloudId: cloudId,
      token: token,
      size: size,
      darkTheme: darkTheme,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getUserProxyAvatar_Serializer();
    final _rawResponse = await _i1.ResponseConverter<Uint8List, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$getUserProxyAvatarDark_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<Uint8List, void> $getUserProxyAvatarDark_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(Uint8List),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get the dark mode avatar of a cloudId user.
  ///
  /// Returns a `DynamiteRequest` backing the [getUserProxyAvatarDark] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [cloudId] Federation CloudID to get the avatar for.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [size] Avatar size.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: User avatar returned
  ///
  /// See:
  ///  * [getUserProxyAvatarDark] for a method executing this request and parsing the response.
  ///  * [$getUserProxyAvatarDark_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getUserProxyAvatarDark_Request({
    required String cloudId,
    required String token,
    required AvatarGetUserProxyAvatarDarkSize size,
    AvatarGetUserProxyAvatarDarkApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $cloudId = _$jsonSerializers.serialize(cloudId, specifiedType: const FullType(String));
    _parameters['cloudId'] = $cloudId;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $size = _$jsonSerializers.serialize(size, specifiedType: const FullType(AvatarGetUserProxyAvatarDarkSize));
    _parameters['size'] = $size;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(AvatarGetUserProxyAvatarDarkApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/proxy/{token}/user-avatar/{size}/dark{?cloudId*}')
            .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = '*/*';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get the dark mode avatar of a cloudId user.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [cloudId] Federation CloudID to get the avatar for.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [size] Avatar size.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: User avatar returned
  ///
  /// See:
  ///  * [$getUserProxyAvatarDark_Request] for the request send by this method.
  ///  * [$getUserProxyAvatarDark_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<Uint8List, void>> getUserProxyAvatarDark({
    required String cloudId,
    required String token,
    required AvatarGetUserProxyAvatarDarkSize size,
    AvatarGetUserProxyAvatarDarkApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getUserProxyAvatarDark_Request(
      cloudId: cloudId,
      token: token,
      size: size,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getUserProxyAvatarDark_Serializer();
    final _rawResponse = await _i1.ResponseConverter<Uint8List, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $BotClient {
  /// Creates a new `DynamiteClient` for bot requests.
  $BotClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$listBots_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<BotListBotsResponseApplicationJson, void> $listBots_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(BotListBotsResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// List bots.
  ///
  /// Returns a `DynamiteRequest` backing the [listBots] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Bot list returned
  ///
  /// See:
  ///  * [listBots] for a method executing this request and parsing the response.
  ///  * [$listBots_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $listBots_Request({
    required String token,
    BotListBotsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(BotListBotsApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/bot/{token}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// List bots.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Bot list returned
  ///
  /// See:
  ///  * [$listBots_Request] for the request send by this method.
  ///  * [$listBots_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<BotListBotsResponseApplicationJson, void>> listBots({
    required String token,
    BotListBotsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $listBots_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $listBots_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<BotListBotsResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$enableBot_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<BotEnableBotResponseApplicationJson, void> $enableBot_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(BotEnableBotResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 201},
      );

  /// Enables a bot.
  ///
  /// Returns a `DynamiteRequest` backing the [enableBot] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [botId] ID of the bot.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Bot already enabled
  ///   * 201: Bot enabled successfully
  ///   * 400: Enabling bot errored
  ///
  /// See:
  ///  * [enableBot] for a method executing this request and parsing the response.
  ///  * [$enableBot_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $enableBot_Request({
    required String token,
    required int botId,
    BotEnableBotApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $botId = _$jsonSerializers.serialize(botId, specifiedType: const FullType(int));
    _parameters['botId'] = $botId;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(BotEnableBotApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/bot/{token}/{botId}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Enables a bot.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [botId] ID of the bot.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Bot already enabled
  ///   * 201: Bot enabled successfully
  ///   * 400: Enabling bot errored
  ///
  /// See:
  ///  * [$enableBot_Request] for the request send by this method.
  ///  * [$enableBot_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<BotEnableBotResponseApplicationJson, void>> enableBot({
    required String token,
    required int botId,
    BotEnableBotApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $enableBot_Request(
      token: token,
      botId: botId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $enableBot_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<BotEnableBotResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$disableBot_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<BotDisableBotResponseApplicationJson, void> $disableBot_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(BotDisableBotResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Disables a bot.
  ///
  /// Returns a `DynamiteRequest` backing the [disableBot] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [botId] ID of the bot.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Bot disabled successfully
  ///   * 400: Disabling bot errored
  ///
  /// See:
  ///  * [disableBot] for a method executing this request and parsing the response.
  ///  * [$disableBot_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $disableBot_Request({
    required String token,
    required int botId,
    BotDisableBotApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $botId = _$jsonSerializers.serialize(botId, specifiedType: const FullType(int));
    _parameters['botId'] = $botId;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(BotDisableBotApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/bot/{token}/{botId}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Disables a bot.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [botId] ID of the bot.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Bot disabled successfully
  ///   * 400: Disabling bot errored
  ///
  /// See:
  ///  * [$disableBot_Request] for the request send by this method.
  ///  * [$disableBot_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<BotDisableBotResponseApplicationJson, void>> disableBot({
    required String token,
    required int botId,
    BotDisableBotApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $disableBot_Request(
      token: token,
      botId: botId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $disableBot_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<BotDisableBotResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$sendMessage_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<BotSendMessageResponseApplicationJson, void> $sendMessage_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(BotSendMessageResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {201, 400, 401, 413},
      );

  /// Sends a new chat message to the given room.
  ///
  /// The author and timestamp are automatically set to the current user/guest and time.
  ///
  /// Returns a `DynamiteRequest` backing the [sendMessage] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [message] The message to send.
  ///   * [referenceId] For the message to be able to later identify it again. Defaults to `''`.
  ///   * [replyTo] Parent id which this message is a reply to. Defaults to `0`.
  ///   * [silent] If sent silent the chat message will not create any notifications. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token] Conversation token.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Message sent successfully
  ///   * 400: When the replyTo is invalid or message is empty
  ///   * 401: Sending message is not allowed
  ///   * 413: Message too long
  ///
  /// See:
  ///  * [sendMessage] for a method executing this request and parsing the response.
  ///  * [$sendMessage_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $sendMessage_Request({
    required String message,
    required String token,
    String? referenceId,
    int? replyTo,
    BotSendMessageSilent? silent,
    BotSendMessageApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $message = _$jsonSerializers.serialize(message, specifiedType: const FullType(String));
    _parameters['message'] = $message;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $referenceId = _$jsonSerializers.serialize(referenceId, specifiedType: const FullType(String));
    $referenceId ??= '';
    _parameters['referenceId'] = $referenceId;

    var $replyTo = _$jsonSerializers.serialize(replyTo, specifiedType: const FullType(int));
    $replyTo ??= 0;
    _parameters['replyTo'] = $replyTo;

    var $silent = _$jsonSerializers.serialize(silent, specifiedType: const FullType(BotSendMessageSilent));
    $silent ??= 0;
    _parameters['silent'] = $silent;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(BotSendMessageApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/bot/{token}/message{?message*,referenceId*,replyTo*,silent*}',
    ).expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Sends a new chat message to the given room.
  ///
  /// The author and timestamp are automatically set to the current user/guest and time.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [message] The message to send.
  ///   * [referenceId] For the message to be able to later identify it again. Defaults to `''`.
  ///   * [replyTo] Parent id which this message is a reply to. Defaults to `0`.
  ///   * [silent] If sent silent the chat message will not create any notifications. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token] Conversation token.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Message sent successfully
  ///   * 400: When the replyTo is invalid or message is empty
  ///   * 401: Sending message is not allowed
  ///   * 413: Message too long
  ///
  /// See:
  ///  * [$sendMessage_Request] for the request send by this method.
  ///  * [$sendMessage_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<BotSendMessageResponseApplicationJson, void>> sendMessage({
    required String message,
    required String token,
    String? referenceId,
    int? replyTo,
    BotSendMessageSilent? silent,
    BotSendMessageApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $sendMessage_Request(
      message: message,
      token: token,
      referenceId: referenceId,
      replyTo: replyTo,
      silent: silent,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $sendMessage_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<BotSendMessageResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$react_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<BotReactResponseApplicationJson, void> $react_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(BotReactResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 201, 400, 401, 404},
      );

  /// Adds a reaction to a chat message.
  ///
  /// Returns a `DynamiteRequest` backing the [react] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [reaction] Reaction to add.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token] Conversation token.
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reaction already exists
  ///   * 201: Reacted successfully
  ///   * 400: Reacting is not possible
  ///   * 401: Reacting is not allowed
  ///   * 404: Reaction not found
  ///
  /// See:
  ///  * [react] for a method executing this request and parsing the response.
  ///  * [$react_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $react_Request({
    required String reaction,
    required String token,
    required int messageId,
    BotReactApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $reaction = _$jsonSerializers.serialize(reaction, specifiedType: const FullType(String));
    _parameters['reaction'] = $reaction;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $messageId = _$jsonSerializers.serialize(messageId, specifiedType: const FullType(int));
    _parameters['messageId'] = $messageId;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(BotReactApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/bot/{token}/reaction/{messageId}{?reaction*}')
            .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Adds a reaction to a chat message.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [reaction] Reaction to add.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token] Conversation token.
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reaction already exists
  ///   * 201: Reacted successfully
  ///   * 400: Reacting is not possible
  ///   * 401: Reacting is not allowed
  ///   * 404: Reaction not found
  ///
  /// See:
  ///  * [$react_Request] for the request send by this method.
  ///  * [$react_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<BotReactResponseApplicationJson, void>> react({
    required String reaction,
    required String token,
    required int messageId,
    BotReactApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $react_Request(
      reaction: reaction,
      token: token,
      messageId: messageId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $react_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<BotReactResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$deleteReaction_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<BotDeleteReactionResponseApplicationJson, void> $deleteReaction_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(BotDeleteReactionResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 400, 404, 401},
      );

  /// Deletes a reaction from a chat message.
  ///
  /// Returns a `DynamiteRequest` backing the [deleteReaction] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [reaction] Reaction to delete.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token] Conversation token.
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reaction deleted successfully
  ///   * 400: Reacting is not possible
  ///   * 404: Reaction not found
  ///   * 401: Reacting is not allowed
  ///
  /// See:
  ///  * [deleteReaction] for a method executing this request and parsing the response.
  ///  * [$deleteReaction_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $deleteReaction_Request({
    required String reaction,
    required String token,
    required int messageId,
    BotDeleteReactionApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $reaction = _$jsonSerializers.serialize(reaction, specifiedType: const FullType(String));
    _parameters['reaction'] = $reaction;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $messageId = _$jsonSerializers.serialize(messageId, specifiedType: const FullType(int));
    _parameters['messageId'] = $messageId;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(BotDeleteReactionApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/bot/{token}/reaction/{messageId}{?reaction*}')
            .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Deletes a reaction from a chat message.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [reaction] Reaction to delete.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token] Conversation token.
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reaction deleted successfully
  ///   * 400: Reacting is not possible
  ///   * 404: Reaction not found
  ///   * 401: Reacting is not allowed
  ///
  /// See:
  ///  * [$deleteReaction_Request] for the request send by this method.
  ///  * [$deleteReaction_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<BotDeleteReactionResponseApplicationJson, void>> deleteReaction({
    required String reaction,
    required String token,
    required int messageId,
    BotDeleteReactionApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $deleteReaction_Request(
      reaction: reaction,
      token: token,
      messageId: messageId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $deleteReaction_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<BotDeleteReactionResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $BreakoutRoomClient {
  /// Creates a new `DynamiteClient` for breakout_room requests.
  $BreakoutRoomClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$configureBreakoutRooms_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson, void>
      $configureBreakoutRooms_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson),
            headersType: null,
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Configure the breakout rooms.
  ///
  /// Returns a `DynamiteRequest` backing the [configureBreakoutRooms] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [mode] Mode of the breakout rooms.
  ///   * [amount] Number of breakout rooms - Constants {@see BreakoutRoom::MINIMUM_ROOM_AMOUNT} and {@see BreakoutRoom::MAXIMUM_ROOM_AMOUNT}.
  ///   * [attendeeMap] Mapping of the attendees to breakout rooms. Defaults to `[]`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Breakout rooms configured successfully
  ///   * 400: Configuring breakout rooms errored
  ///
  /// See:
  ///  * [configureBreakoutRooms] for a method executing this request and parsing the response.
  ///  * [$configureBreakoutRooms_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $configureBreakoutRooms_Request({
    required BreakoutRoomConfigureBreakoutRoomsMode mode,
    required int amount,
    required String token,
    String? attendeeMap,
    BreakoutRoomConfigureBreakoutRoomsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $mode =
        _$jsonSerializers.serialize(mode, specifiedType: const FullType(BreakoutRoomConfigureBreakoutRoomsMode));
    _parameters['mode'] = $mode;

    final $amount = _$jsonSerializers.serialize(amount, specifiedType: const FullType(int));
    _parameters['amount'] = $amount;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $attendeeMap = _$jsonSerializers.serialize(attendeeMap, specifiedType: const FullType(String));
    $attendeeMap ??= '[]';
    _parameters['attendeeMap'] = $attendeeMap;

    var $apiVersion = _$jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(BreakoutRoomConfigureBreakoutRoomsApiVersion),
    );
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/breakout-rooms/{token}{?mode*,amount*,attendeeMap*}')
            .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Configure the breakout rooms.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [mode] Mode of the breakout rooms.
  ///   * [amount] Number of breakout rooms - Constants {@see BreakoutRoom::MINIMUM_ROOM_AMOUNT} and {@see BreakoutRoom::MAXIMUM_ROOM_AMOUNT}.
  ///   * [attendeeMap] Mapping of the attendees to breakout rooms. Defaults to `[]`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Breakout rooms configured successfully
  ///   * 400: Configuring breakout rooms errored
  ///
  /// See:
  ///  * [$configureBreakoutRooms_Request] for the request send by this method.
  ///  * [$configureBreakoutRooms_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson, void>> configureBreakoutRooms({
    required BreakoutRoomConfigureBreakoutRoomsMode mode,
    required int amount,
    required String token,
    String? attendeeMap,
    BreakoutRoomConfigureBreakoutRoomsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $configureBreakoutRooms_Request(
      mode: mode,
      amount: amount,
      token: token,
      attendeeMap: attendeeMap,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $configureBreakoutRooms_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$removeBreakoutRooms_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson, void>
      $removeBreakoutRooms_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson),
            headersType: null,
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Remove the breakout rooms.
  ///
  /// Returns a `DynamiteRequest` backing the [removeBreakoutRooms] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Breakout rooms removed successfully
  ///
  /// See:
  ///  * [removeBreakoutRooms] for a method executing this request and parsing the response.
  ///  * [$removeBreakoutRooms_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $removeBreakoutRooms_Request({
    required String token,
    BreakoutRoomRemoveBreakoutRoomsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion = _$jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(BreakoutRoomRemoveBreakoutRoomsApiVersion),
    );
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/breakout-rooms/{token}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Remove the breakout rooms.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Breakout rooms removed successfully
  ///
  /// See:
  ///  * [$removeBreakoutRooms_Request] for the request send by this method.
  ///  * [$removeBreakoutRooms_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson, void>> removeBreakoutRooms({
    required String token,
    BreakoutRoomRemoveBreakoutRoomsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $removeBreakoutRooms_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $removeBreakoutRooms_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$broadcastChatMessage_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<BreakoutRoomBroadcastChatMessageResponseApplicationJson, void>
      $broadcastChatMessage_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(BreakoutRoomBroadcastChatMessageResponseApplicationJson),
            headersType: null,
            serializers: _$jsonSerializers,
            validStatuses: const {201},
          );

  /// Broadcast a chat message to all breakout rooms.
  ///
  /// Returns a `DynamiteRequest` backing the [broadcastChatMessage] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [message] Message to broadcast.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Chat message broadcasted successfully
  ///   * 400: Broadcasting chat message is not possible
  ///   * 413: Chat message too long
  ///
  /// See:
  ///  * [broadcastChatMessage] for a method executing this request and parsing the response.
  ///  * [$broadcastChatMessage_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $broadcastChatMessage_Request({
    required String message,
    required String token,
    BreakoutRoomBroadcastChatMessageApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $message = _$jsonSerializers.serialize(message, specifiedType: const FullType(String));
    _parameters['message'] = $message;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion = _$jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(BreakoutRoomBroadcastChatMessageApiVersion),
    );
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/breakout-rooms/{token}/broadcast{?message*}')
            .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Broadcast a chat message to all breakout rooms.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [message] Message to broadcast.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Chat message broadcasted successfully
  ///   * 400: Broadcasting chat message is not possible
  ///   * 413: Chat message too long
  ///
  /// See:
  ///  * [$broadcastChatMessage_Request] for the request send by this method.
  ///  * [$broadcastChatMessage_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<BreakoutRoomBroadcastChatMessageResponseApplicationJson, void>> broadcastChatMessage({
    required String message,
    required String token,
    BreakoutRoomBroadcastChatMessageApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $broadcastChatMessage_Request(
      message: message,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $broadcastChatMessage_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<BreakoutRoomBroadcastChatMessageResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$applyAttendeeMap_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<BreakoutRoomApplyAttendeeMapResponseApplicationJson, void> $applyAttendeeMap_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(BreakoutRoomApplyAttendeeMapResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Apply an attendee map to the breakout rooms.
  ///
  /// Returns a `DynamiteRequest` backing the [applyAttendeeMap] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [attendeeMap] JSON encoded mapping of the attendees to breakout rooms `array<int, int>`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Attendee map applied successfully
  ///   * 400: Applying attendee map is not possible
  ///
  /// See:
  ///  * [applyAttendeeMap] for a method executing this request and parsing the response.
  ///  * [$applyAttendeeMap_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $applyAttendeeMap_Request({
    required String attendeeMap,
    required String token,
    BreakoutRoomApplyAttendeeMapApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $attendeeMap = _$jsonSerializers.serialize(attendeeMap, specifiedType: const FullType(String));
    _parameters['attendeeMap'] = $attendeeMap;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(BreakoutRoomApplyAttendeeMapApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/breakout-rooms/{token}/attendees{?attendeeMap*}')
            .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Apply an attendee map to the breakout rooms.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [attendeeMap] JSON encoded mapping of the attendees to breakout rooms `array<int, int>`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Attendee map applied successfully
  ///   * 400: Applying attendee map is not possible
  ///
  /// See:
  ///  * [$applyAttendeeMap_Request] for the request send by this method.
  ///  * [$applyAttendeeMap_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<BreakoutRoomApplyAttendeeMapResponseApplicationJson, void>> applyAttendeeMap({
    required String attendeeMap,
    required String token,
    BreakoutRoomApplyAttendeeMapApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $applyAttendeeMap_Request(
      attendeeMap: attendeeMap,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $applyAttendeeMap_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<BreakoutRoomApplyAttendeeMapResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$requestAssistance_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<BreakoutRoomRequestAssistanceResponseApplicationJson, void> $requestAssistance_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(BreakoutRoomRequestAssistanceResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Request assistance.
  ///
  /// Returns a `DynamiteRequest` backing the [requestAssistance] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Assistance requested successfully
  ///   * 400: Requesting assistance is not possible
  ///
  /// See:
  ///  * [requestAssistance] for a method executing this request and parsing the response.
  ///  * [$requestAssistance_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $requestAssistance_Request({
    required String token,
    BreakoutRoomRequestAssistanceApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(BreakoutRoomRequestAssistanceApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/breakout-rooms/{token}/request-assistance')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Request assistance.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Assistance requested successfully
  ///   * 400: Requesting assistance is not possible
  ///
  /// See:
  ///  * [$requestAssistance_Request] for the request send by this method.
  ///  * [$requestAssistance_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<BreakoutRoomRequestAssistanceResponseApplicationJson, void>> requestAssistance({
    required String token,
    BreakoutRoomRequestAssistanceApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $requestAssistance_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $requestAssistance_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<BreakoutRoomRequestAssistanceResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$resetRequestForAssistance_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<BreakoutRoomResetRequestForAssistanceResponseApplicationJson, void>
      $resetRequestForAssistance_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(BreakoutRoomResetRequestForAssistanceResponseApplicationJson),
            headersType: null,
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Reset the request for assistance.
  ///
  /// Returns a `DynamiteRequest` backing the [resetRequestForAssistance] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Request for assistance reset successfully
  ///   * 400: Resetting the request for assistance is not possible
  ///
  /// See:
  ///  * [resetRequestForAssistance] for a method executing this request and parsing the response.
  ///  * [$resetRequestForAssistance_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $resetRequestForAssistance_Request({
    required String token,
    BreakoutRoomResetRequestForAssistanceApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion = _$jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(BreakoutRoomResetRequestForAssistanceApiVersion),
    );
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/breakout-rooms/{token}/request-assistance')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Reset the request for assistance.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Request for assistance reset successfully
  ///   * 400: Resetting the request for assistance is not possible
  ///
  /// See:
  ///  * [$resetRequestForAssistance_Request] for the request send by this method.
  ///  * [$resetRequestForAssistance_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<BreakoutRoomResetRequestForAssistanceResponseApplicationJson, void>>
      resetRequestForAssistance({
    required String token,
    BreakoutRoomResetRequestForAssistanceApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $resetRequestForAssistance_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $resetRequestForAssistance_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<BreakoutRoomResetRequestForAssistanceResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$startBreakoutRooms_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<BreakoutRoomStartBreakoutRoomsResponseApplicationJson, void>
      $startBreakoutRooms_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(BreakoutRoomStartBreakoutRoomsResponseApplicationJson),
            headersType: null,
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Start the breakout rooms.
  ///
  /// Returns a `DynamiteRequest` backing the [startBreakoutRooms] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Breakout rooms started successfully
  ///   * 400: Starting breakout rooms is not possible
  ///
  /// See:
  ///  * [startBreakoutRooms] for a method executing this request and parsing the response.
  ///  * [$startBreakoutRooms_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $startBreakoutRooms_Request({
    required String token,
    BreakoutRoomStartBreakoutRoomsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion = _$jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(BreakoutRoomStartBreakoutRoomsApiVersion),
    );
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/breakout-rooms/{token}/rooms').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Start the breakout rooms.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Breakout rooms started successfully
  ///   * 400: Starting breakout rooms is not possible
  ///
  /// See:
  ///  * [$startBreakoutRooms_Request] for the request send by this method.
  ///  * [$startBreakoutRooms_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<BreakoutRoomStartBreakoutRoomsResponseApplicationJson, void>> startBreakoutRooms({
    required String token,
    BreakoutRoomStartBreakoutRoomsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $startBreakoutRooms_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $startBreakoutRooms_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<BreakoutRoomStartBreakoutRoomsResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$stopBreakoutRooms_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<BreakoutRoomStopBreakoutRoomsResponseApplicationJson, void> $stopBreakoutRooms_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(BreakoutRoomStopBreakoutRoomsResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Stop the breakout rooms.
  ///
  /// Returns a `DynamiteRequest` backing the [stopBreakoutRooms] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Breakout rooms stopped successfully
  ///   * 400: Stopping breakout rooms is not possible
  ///
  /// See:
  ///  * [stopBreakoutRooms] for a method executing this request and parsing the response.
  ///  * [$stopBreakoutRooms_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $stopBreakoutRooms_Request({
    required String token,
    BreakoutRoomStopBreakoutRoomsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(BreakoutRoomStopBreakoutRoomsApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/breakout-rooms/{token}/rooms').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Stop the breakout rooms.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Breakout rooms stopped successfully
  ///   * 400: Stopping breakout rooms is not possible
  ///
  /// See:
  ///  * [$stopBreakoutRooms_Request] for the request send by this method.
  ///  * [$stopBreakoutRooms_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<BreakoutRoomStopBreakoutRoomsResponseApplicationJson, void>> stopBreakoutRooms({
    required String token,
    BreakoutRoomStopBreakoutRoomsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $stopBreakoutRooms_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $stopBreakoutRooms_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<BreakoutRoomStopBreakoutRoomsResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$switchBreakoutRoom_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<BreakoutRoomSwitchBreakoutRoomResponseApplicationJson, void>
      $switchBreakoutRoom_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(BreakoutRoomSwitchBreakoutRoomResponseApplicationJson),
            headersType: null,
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Switch to another breakout room.
  ///
  /// Returns a `DynamiteRequest` backing the [switchBreakoutRoom] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [target] Target breakout room.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Switched to breakout room successfully
  ///   * 400: Switching to breakout room is not possible
  ///
  /// See:
  ///  * [switchBreakoutRoom] for a method executing this request and parsing the response.
  ///  * [$switchBreakoutRoom_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $switchBreakoutRoom_Request({
    required String target,
    required String token,
    BreakoutRoomSwitchBreakoutRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $target = _$jsonSerializers.serialize(target, specifiedType: const FullType(String));
    _parameters['target'] = $target;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion = _$jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(BreakoutRoomSwitchBreakoutRoomApiVersion),
    );
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/breakout-rooms/{token}/switch{?target*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Switch to another breakout room.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [target] Target breakout room.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Switched to breakout room successfully
  ///   * 400: Switching to breakout room is not possible
  ///
  /// See:
  ///  * [$switchBreakoutRoom_Request] for the request send by this method.
  ///  * [$switchBreakoutRoom_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<BreakoutRoomSwitchBreakoutRoomResponseApplicationJson, void>> switchBreakoutRoom({
    required String target,
    required String token,
    BreakoutRoomSwitchBreakoutRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $switchBreakoutRoom_Request(
      target: target,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $switchBreakoutRoom_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<BreakoutRoomSwitchBreakoutRoomResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $CallClient {
  /// Creates a new `DynamiteClient` for call requests.
  $CallClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$getPeersForCall_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<CallGetPeersForCallResponseApplicationJson, void> $getPeersForCall_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(CallGetPeersForCallResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get the peers for a call.
  ///
  /// Returns a `DynamiteRequest` backing the [getPeersForCall] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: List of peers in the call returned
  ///
  /// See:
  ///  * [getPeersForCall] for a method executing this request and parsing the response.
  ///  * [$getPeersForCall_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getPeersForCall_Request({
    required String token,
    CallGetPeersForCallApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(CallGetPeersForCallApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/call/{token}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get the peers for a call.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: List of peers in the call returned
  ///
  /// See:
  ///  * [$getPeersForCall_Request] for the request send by this method.
  ///  * [$getPeersForCall_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<CallGetPeersForCallResponseApplicationJson, void>> getPeersForCall({
    required String token,
    CallGetPeersForCallApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getPeersForCall_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getPeersForCall_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<CallGetPeersForCallResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$updateCallFlags_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<CallUpdateCallFlagsResponseApplicationJson, void> $updateCallFlags_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(CallUpdateCallFlagsResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 400, 404},
      );

  /// Update the in-call flags.
  ///
  /// Returns a `DynamiteRequest` backing the [updateCallFlags] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [flags] New flags.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: In-call flags updated successfully
  ///   * 400: Updating in-call flags is not possible
  ///   * 404: Call session not found
  ///
  /// See:
  ///  * [updateCallFlags] for a method executing this request and parsing the response.
  ///  * [$updateCallFlags_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $updateCallFlags_Request({
    required int flags,
    required String token,
    CallUpdateCallFlagsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $flags = _$jsonSerializers.serialize(flags, specifiedType: const FullType(int));
    _parameters['flags'] = $flags;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(CallUpdateCallFlagsApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/call/{token}{?flags*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('put', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Update the in-call flags.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [flags] New flags.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: In-call flags updated successfully
  ///   * 400: Updating in-call flags is not possible
  ///   * 404: Call session not found
  ///
  /// See:
  ///  * [$updateCallFlags_Request] for the request send by this method.
  ///  * [$updateCallFlags_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<CallUpdateCallFlagsResponseApplicationJson, void>> updateCallFlags({
    required int flags,
    required String token,
    CallUpdateCallFlagsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $updateCallFlags_Request(
      flags: flags,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $updateCallFlags_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<CallUpdateCallFlagsResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$joinCall_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<CallJoinCallResponseApplicationJson, void> $joinCall_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(CallJoinCallResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 404},
      );

  /// Join a call.
  ///
  /// Returns a `DynamiteRequest` backing the [joinCall] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [flags] In-Call flags.
  ///   * [forcePermissions] In-call permissions.
  ///   * [silent] Join the call silently. Defaults to `0`.
  ///   * [recordingConsent] When the user ticked a checkbox and agreed with being recorded (Only needed when the `config => call => recording-consent` capability is set to {@see RecordingService::CONSENT_REQUIRED_YES} or the capability is {@see RecordingService::CONSENT_REQUIRED_OPTIONAL} and the conversation `recordingConsent` value is {@see RecordingService::CONSENT_REQUIRED_YES} ). Defaults to `0`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Call joined successfully
  ///   * 404: Call not found
  ///   * 400: No recording consent was given
  ///
  /// See:
  ///  * [joinCall] for a method executing this request and parsing the response.
  ///  * [$joinCall_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $joinCall_Request({
    required String token,
    int? flags,
    int? forcePermissions,
    CallJoinCallSilent? silent,
    CallJoinCallRecordingConsent? recordingConsent,
    CallJoinCallApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $flags = _$jsonSerializers.serialize(flags, specifiedType: const FullType(int));
    _parameters['flags'] = $flags;

    final $forcePermissions = _$jsonSerializers.serialize(forcePermissions, specifiedType: const FullType(int));
    _parameters['forcePermissions'] = $forcePermissions;

    var $silent = _$jsonSerializers.serialize(silent, specifiedType: const FullType(CallJoinCallSilent));
    $silent ??= 0;
    _parameters['silent'] = $silent;

    var $recordingConsent =
        _$jsonSerializers.serialize(recordingConsent, specifiedType: const FullType(CallJoinCallRecordingConsent));
    $recordingConsent ??= 0;
    _parameters['recordingConsent'] = $recordingConsent;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(CallJoinCallApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/call/{token}{?flags*,forcePermissions*,silent*,recordingConsent*}',
    ).expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Join a call.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [flags] In-Call flags.
  ///   * [forcePermissions] In-call permissions.
  ///   * [silent] Join the call silently. Defaults to `0`.
  ///   * [recordingConsent] When the user ticked a checkbox and agreed with being recorded (Only needed when the `config => call => recording-consent` capability is set to {@see RecordingService::CONSENT_REQUIRED_YES} or the capability is {@see RecordingService::CONSENT_REQUIRED_OPTIONAL} and the conversation `recordingConsent` value is {@see RecordingService::CONSENT_REQUIRED_YES} ). Defaults to `0`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Call joined successfully
  ///   * 404: Call not found
  ///   * 400: No recording consent was given
  ///
  /// See:
  ///  * [$joinCall_Request] for the request send by this method.
  ///  * [$joinCall_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<CallJoinCallResponseApplicationJson, void>> joinCall({
    required String token,
    int? flags,
    int? forcePermissions,
    CallJoinCallSilent? silent,
    CallJoinCallRecordingConsent? recordingConsent,
    CallJoinCallApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $joinCall_Request(
      token: token,
      flags: flags,
      forcePermissions: forcePermissions,
      silent: silent,
      recordingConsent: recordingConsent,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $joinCall_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<CallJoinCallResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$leaveCall_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<CallLeaveCallResponseApplicationJson, void> $leaveCall_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(CallLeaveCallResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 404},
      );

  /// Leave a call.
  ///
  /// Returns a `DynamiteRequest` backing the [leaveCall] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [all] whether to also terminate the call for all participants. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Call left successfully
  ///   * 404: Call session not found
  ///
  /// See:
  ///  * [leaveCall] for a method executing this request and parsing the response.
  ///  * [$leaveCall_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $leaveCall_Request({
    required String token,
    CallLeaveCallAll? all,
    CallLeaveCallApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $all = _$jsonSerializers.serialize(all, specifiedType: const FullType(CallLeaveCallAll));
    $all ??= 0;
    _parameters['all'] = $all;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(CallLeaveCallApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/call/{token}{?all*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Leave a call.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [all] whether to also terminate the call for all participants. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Call left successfully
  ///   * 404: Call session not found
  ///
  /// See:
  ///  * [$leaveCall_Request] for the request send by this method.
  ///  * [$leaveCall_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<CallLeaveCallResponseApplicationJson, void>> leaveCall({
    required String token,
    CallLeaveCallAll? all,
    CallLeaveCallApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $leaveCall_Request(
      token: token,
      all: all,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $leaveCall_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<CallLeaveCallResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$ringAttendee_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<CallRingAttendeeResponseApplicationJson, void> $ringAttendee_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(CallRingAttendeeResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 400, 404},
      );

  /// Ring an attendee.
  ///
  /// Returns a `DynamiteRequest` backing the [ringAttendee] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [attendeeId] ID of the attendee to ring.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Attendee rang successfully
  ///   * 400: Ringing attendee is not possible
  ///   * 404: Attendee could not be found
  ///
  /// See:
  ///  * [ringAttendee] for a method executing this request and parsing the response.
  ///  * [$ringAttendee_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $ringAttendee_Request({
    required String token,
    required int attendeeId,
    CallRingAttendeeApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $attendeeId = _$jsonSerializers.serialize(attendeeId, specifiedType: const FullType(int));
    _parameters['attendeeId'] = $attendeeId;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(CallRingAttendeeApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/call/{token}/ring/{attendeeId}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Ring an attendee.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [attendeeId] ID of the attendee to ring.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Attendee rang successfully
  ///   * 400: Ringing attendee is not possible
  ///   * 404: Attendee could not be found
  ///
  /// See:
  ///  * [$ringAttendee_Request] for the request send by this method.
  ///  * [$ringAttendee_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<CallRingAttendeeResponseApplicationJson, void>> ringAttendee({
    required String token,
    required int attendeeId,
    CallRingAttendeeApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $ringAttendee_Request(
      token: token,
      attendeeId: attendeeId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $ringAttendee_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<CallRingAttendeeResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$sipDialOut_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<CallSipDialOutResponseApplicationJson, void> $sipDialOut_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(CallSipDialOutResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {201, 400, 404, 501},
      );

  /// Call a SIP dial-out attendee.
  ///
  /// Returns a `DynamiteRequest` backing the [sipDialOut] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [attendeeId] ID of the attendee to call.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Dial-out initiated successfully
  ///   * 400: SIP dial-out not possible
  ///   * 404: Participant could not be found or is a wrong type
  ///   * 501: SIP dial-out is not configured on the server
  ///
  /// See:
  ///  * [sipDialOut] for a method executing this request and parsing the response.
  ///  * [$sipDialOut_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $sipDialOut_Request({
    required String token,
    required int attendeeId,
    CallSipDialOutApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $attendeeId = _$jsonSerializers.serialize(attendeeId, specifiedType: const FullType(int));
    _parameters['attendeeId'] = $attendeeId;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(CallSipDialOutApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/call/{token}/dialout/{attendeeId}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Call a SIP dial-out attendee.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [attendeeId] ID of the attendee to call.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Dial-out initiated successfully
  ///   * 400: SIP dial-out not possible
  ///   * 404: Participant could not be found or is a wrong type
  ///   * 501: SIP dial-out is not configured on the server
  ///
  /// See:
  ///  * [$sipDialOut_Request] for the request send by this method.
  ///  * [$sipDialOut_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<CallSipDialOutResponseApplicationJson, void>> sipDialOut({
    required String token,
    required int attendeeId,
    CallSipDialOutApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $sipDialOut_Request(
      token: token,
      attendeeId: attendeeId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $sipDialOut_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<CallSipDialOutResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $ChatClient {
  /// Creates a new `DynamiteClient` for chat requests.
  $ChatClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$receiveMessages_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ChatReceiveMessagesResponseApplicationJson, ChatChatReceiveMessagesHeaders>
      $receiveMessages_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(ChatReceiveMessagesResponseApplicationJson),
            headersType: const FullType(ChatChatReceiveMessagesHeaders),
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Receives chat messages from the given room.
  ///
  /// - Receiving the history ($lookIntoFuture=0): The next $limit messages after $lastKnownMessageId will be returned. The new $lastKnownMessageId for the follow up query is available as `X-Chat-Last-Given` header.
  /// - Looking into the future ($lookIntoFuture=1): If there are currently no messages the response will not be sent immediately. Instead, HTTP connection will be kept open waiting for new messages to arrive and, when they do, then the response will be sent. The connection will not be kept open indefinitely, though; the number of seconds to wait for new messages to arrive can be set using the timeout parameter; the default timeout is 30 seconds, maximum timeout is 60 seconds. If the timeout ends a successful but empty response will be sent. If messages have been returned (status=200) the new $lastKnownMessageId for the follow up query is available as `X-Chat-Last-Given` header.
  /// The limit specifies the maximum number of messages that will be returned, although the actual number of returned messages could be lower if some messages are not visible to the participant. Note that if none of the messages are visible to the participant the returned number of messages will be 0, yet the status will still be 200. Also note that `X-Chat-Last-Given` may reference a message not visible and thus not returned, but it should be used nevertheless as the $lastKnownMessageId for the follow-up query.
  ///
  /// Returns a `DynamiteRequest` backing the [receiveMessages] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [lookIntoFuture] Polling for new messages (1) or getting the history of the chat (0).
  ///   * [limit] Number of chat messages to receive (100 by default, 200 at most). Defaults to `100`.
  ///   * [lastKnownMessageId] The last known message (serves as offset). Defaults to `0`.
  ///   * [lastCommonReadId] The last known common read message (so the response is 200 instead of 304 when it changes even when there are no messages). Defaults to `0`.
  ///   * [timeout] Number of seconds to wait for new messages (30 by default, 30 at most). Defaults to `30`.
  ///   * [setReadMarker] Automatically set the last read marker when 1, if your client does this itself via chat/{token}/read set to 0. Defaults to `1`.
  ///   * [includeLastKnown] Include the $lastKnownMessageId in the messages when 1 (default 0). Defaults to `0`.
  ///   * [noStatusUpdate] When the user status should not be automatically set to online set to 1 (default 0). Defaults to `0`.
  ///   * [markNotificationsAsRead] Set to 0 when notifications should not be marked as read (default 1). Defaults to `1`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Messages returned
  ///   * 304: No messages
  ///
  /// See:
  ///  * [receiveMessages] for a method executing this request and parsing the response.
  ///  * [$receiveMessages_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $receiveMessages_Request({
    required ChatReceiveMessagesLookIntoFuture lookIntoFuture,
    required String token,
    int? limit,
    int? lastKnownMessageId,
    int? lastCommonReadId,
    int? timeout,
    ChatReceiveMessagesSetReadMarker? setReadMarker,
    ChatReceiveMessagesIncludeLastKnown? includeLastKnown,
    ChatReceiveMessagesNoStatusUpdate? noStatusUpdate,
    ChatReceiveMessagesMarkNotificationsAsRead? markNotificationsAsRead,
    ChatReceiveMessagesApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $lookIntoFuture =
        _$jsonSerializers.serialize(lookIntoFuture, specifiedType: const FullType(ChatReceiveMessagesLookIntoFuture));
    _parameters['lookIntoFuture'] = $lookIntoFuture;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $limit = _$jsonSerializers.serialize(limit, specifiedType: const FullType(int));
    $limit ??= 100;
    _parameters['limit'] = $limit;

    var $lastKnownMessageId = _$jsonSerializers.serialize(lastKnownMessageId, specifiedType: const FullType(int));
    $lastKnownMessageId ??= 0;
    _parameters['lastKnownMessageId'] = $lastKnownMessageId;

    var $lastCommonReadId = _$jsonSerializers.serialize(lastCommonReadId, specifiedType: const FullType(int));
    $lastCommonReadId ??= 0;
    _parameters['lastCommonReadId'] = $lastCommonReadId;

    var $timeout = _$jsonSerializers.serialize(timeout, specifiedType: const FullType(int));
    $timeout ??= 30;
    _parameters['timeout'] = $timeout;

    var $setReadMarker =
        _$jsonSerializers.serialize(setReadMarker, specifiedType: const FullType(ChatReceiveMessagesSetReadMarker));
    $setReadMarker ??= 1;
    _parameters['setReadMarker'] = $setReadMarker;

    var $includeLastKnown = _$jsonSerializers.serialize(
      includeLastKnown,
      specifiedType: const FullType(ChatReceiveMessagesIncludeLastKnown),
    );
    $includeLastKnown ??= 0;
    _parameters['includeLastKnown'] = $includeLastKnown;

    var $noStatusUpdate =
        _$jsonSerializers.serialize(noStatusUpdate, specifiedType: const FullType(ChatReceiveMessagesNoStatusUpdate));
    $noStatusUpdate ??= 0;
    _parameters['noStatusUpdate'] = $noStatusUpdate;

    var $markNotificationsAsRead = _$jsonSerializers.serialize(
      markNotificationsAsRead,
      specifiedType: const FullType(ChatReceiveMessagesMarkNotificationsAsRead),
    );
    $markNotificationsAsRead ??= 1;
    _parameters['markNotificationsAsRead'] = $markNotificationsAsRead;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ChatReceiveMessagesApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/chat/{token}{?lookIntoFuture*,limit*,lastKnownMessageId*,lastCommonReadId*,timeout*,setReadMarker*,includeLastKnown*,noStatusUpdate*,markNotificationsAsRead*}',
    ).expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Receives chat messages from the given room.
  ///
  /// - Receiving the history ($lookIntoFuture=0): The next $limit messages after $lastKnownMessageId will be returned. The new $lastKnownMessageId for the follow up query is available as `X-Chat-Last-Given` header.
  /// - Looking into the future ($lookIntoFuture=1): If there are currently no messages the response will not be sent immediately. Instead, HTTP connection will be kept open waiting for new messages to arrive and, when they do, then the response will be sent. The connection will not be kept open indefinitely, though; the number of seconds to wait for new messages to arrive can be set using the timeout parameter; the default timeout is 30 seconds, maximum timeout is 60 seconds. If the timeout ends a successful but empty response will be sent. If messages have been returned (status=200) the new $lastKnownMessageId for the follow up query is available as `X-Chat-Last-Given` header.
  /// The limit specifies the maximum number of messages that will be returned, although the actual number of returned messages could be lower if some messages are not visible to the participant. Note that if none of the messages are visible to the participant the returned number of messages will be 0, yet the status will still be 200. Also note that `X-Chat-Last-Given` may reference a message not visible and thus not returned, but it should be used nevertheless as the $lastKnownMessageId for the follow-up query.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [lookIntoFuture] Polling for new messages (1) or getting the history of the chat (0).
  ///   * [limit] Number of chat messages to receive (100 by default, 200 at most). Defaults to `100`.
  ///   * [lastKnownMessageId] The last known message (serves as offset). Defaults to `0`.
  ///   * [lastCommonReadId] The last known common read message (so the response is 200 instead of 304 when it changes even when there are no messages). Defaults to `0`.
  ///   * [timeout] Number of seconds to wait for new messages (30 by default, 30 at most). Defaults to `30`.
  ///   * [setReadMarker] Automatically set the last read marker when 1, if your client does this itself via chat/{token}/read set to 0. Defaults to `1`.
  ///   * [includeLastKnown] Include the $lastKnownMessageId in the messages when 1 (default 0). Defaults to `0`.
  ///   * [noStatusUpdate] When the user status should not be automatically set to online set to 1 (default 0). Defaults to `0`.
  ///   * [markNotificationsAsRead] Set to 0 when notifications should not be marked as read (default 1). Defaults to `1`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Messages returned
  ///   * 304: No messages
  ///
  /// See:
  ///  * [$receiveMessages_Request] for the request send by this method.
  ///  * [$receiveMessages_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ChatReceiveMessagesResponseApplicationJson, ChatChatReceiveMessagesHeaders>>
      receiveMessages({
    required ChatReceiveMessagesLookIntoFuture lookIntoFuture,
    required String token,
    int? limit,
    int? lastKnownMessageId,
    int? lastCommonReadId,
    int? timeout,
    ChatReceiveMessagesSetReadMarker? setReadMarker,
    ChatReceiveMessagesIncludeLastKnown? includeLastKnown,
    ChatReceiveMessagesNoStatusUpdate? noStatusUpdate,
    ChatReceiveMessagesMarkNotificationsAsRead? markNotificationsAsRead,
    ChatReceiveMessagesApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $receiveMessages_Request(
      lookIntoFuture: lookIntoFuture,
      token: token,
      limit: limit,
      lastKnownMessageId: lastKnownMessageId,
      lastCommonReadId: lastCommonReadId,
      timeout: timeout,
      setReadMarker: setReadMarker,
      includeLastKnown: includeLastKnown,
      noStatusUpdate: noStatusUpdate,
      markNotificationsAsRead: markNotificationsAsRead,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $receiveMessages_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<ChatReceiveMessagesResponseApplicationJson, ChatChatReceiveMessagesHeaders>(
      _serializer,
    ).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$sendMessage_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ChatSendMessageResponseApplicationJson, ChatChatSendMessageHeaders>
      $sendMessage_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(ChatSendMessageResponseApplicationJson),
            headersType: const FullType(ChatChatSendMessageHeaders),
            serializers: _$jsonSerializers,
            validStatuses: const {201},
          );

  /// Sends a new chat message to the given room.
  ///
  /// The author and timestamp are automatically set to the current user/guest and time.
  ///
  /// Returns a `DynamiteRequest` backing the [sendMessage] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [message] the message to send.
  ///   * [actorDisplayName] for guests. Defaults to `''`.
  ///   * [referenceId] for the message to be able to later identify it again. Defaults to `''`.
  ///   * [replyTo] Parent id which this message is a reply to. Defaults to `0`.
  ///   * [silent] If sent silent the chat message will not create any notifications. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Message sent successfully
  ///   * 400: Sending message is not possible
  ///   * 404: Actor not found
  ///   * 413: Message too long
  ///   * 429: Mention rate limit exceeded (guests only)
  ///
  /// See:
  ///  * [sendMessage] for a method executing this request and parsing the response.
  ///  * [$sendMessage_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $sendMessage_Request({
    required String message,
    required String token,
    String? actorDisplayName,
    String? referenceId,
    int? replyTo,
    ChatSendMessageSilent? silent,
    ChatSendMessageApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $message = _$jsonSerializers.serialize(message, specifiedType: const FullType(String));
    _parameters['message'] = $message;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $actorDisplayName = _$jsonSerializers.serialize(actorDisplayName, specifiedType: const FullType(String));
    $actorDisplayName ??= '';
    _parameters['actorDisplayName'] = $actorDisplayName;

    var $referenceId = _$jsonSerializers.serialize(referenceId, specifiedType: const FullType(String));
    $referenceId ??= '';
    _parameters['referenceId'] = $referenceId;

    var $replyTo = _$jsonSerializers.serialize(replyTo, specifiedType: const FullType(int));
    $replyTo ??= 0;
    _parameters['replyTo'] = $replyTo;

    var $silent = _$jsonSerializers.serialize(silent, specifiedType: const FullType(ChatSendMessageSilent));
    $silent ??= 0;
    _parameters['silent'] = $silent;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ChatSendMessageApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/chat/{token}{?message*,actorDisplayName*,referenceId*,replyTo*,silent*}',
    ).expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Sends a new chat message to the given room.
  ///
  /// The author and timestamp are automatically set to the current user/guest and time.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [message] the message to send.
  ///   * [actorDisplayName] for guests. Defaults to `''`.
  ///   * [referenceId] for the message to be able to later identify it again. Defaults to `''`.
  ///   * [replyTo] Parent id which this message is a reply to. Defaults to `0`.
  ///   * [silent] If sent silent the chat message will not create any notifications. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Message sent successfully
  ///   * 400: Sending message is not possible
  ///   * 404: Actor not found
  ///   * 413: Message too long
  ///   * 429: Mention rate limit exceeded (guests only)
  ///
  /// See:
  ///  * [$sendMessage_Request] for the request send by this method.
  ///  * [$sendMessage_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ChatSendMessageResponseApplicationJson, ChatChatSendMessageHeaders>> sendMessage({
    required String message,
    required String token,
    String? actorDisplayName,
    String? referenceId,
    int? replyTo,
    ChatSendMessageSilent? silent,
    ChatSendMessageApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $sendMessage_Request(
      message: message,
      token: token,
      actorDisplayName: actorDisplayName,
      referenceId: referenceId,
      replyTo: replyTo,
      silent: silent,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $sendMessage_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<ChatSendMessageResponseApplicationJson, ChatChatSendMessageHeaders>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$clearHistory_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ChatClearHistoryResponseApplicationJson, ChatChatClearHistoryHeaders>
      $clearHistory_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(ChatClearHistoryResponseApplicationJson),
            headersType: const FullType(ChatChatClearHistoryHeaders),
            serializers: _$jsonSerializers,
            validStatuses: const {200, 202},
          );

  /// Clear the chat history.
  ///
  /// Returns a `DynamiteRequest` backing the [clearHistory] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: History cleared successfully
  ///   * 202: History cleared successfully, but Matterbridge is configured, so the information can be replicated elsewhere
  ///   * 403: Missing permissions to clear history
  ///
  /// See:
  ///  * [clearHistory] for a method executing this request and parsing the response.
  ///  * [$clearHistory_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $clearHistory_Request({
    required String token,
    ChatClearHistoryApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ChatClearHistoryApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/chat/{token}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Clear the chat history.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: History cleared successfully
  ///   * 202: History cleared successfully, but Matterbridge is configured, so the information can be replicated elsewhere
  ///   * 403: Missing permissions to clear history
  ///
  /// See:
  ///  * [$clearHistory_Request] for the request send by this method.
  ///  * [$clearHistory_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ChatClearHistoryResponseApplicationJson, ChatChatClearHistoryHeaders>> clearHistory({
    required String token,
    ChatClearHistoryApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $clearHistory_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $clearHistory_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<ChatClearHistoryResponseApplicationJson, ChatChatClearHistoryHeaders>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$editMessage_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ChatEditMessageResponseApplicationJson, ChatChatEditMessageHeaders>
      $editMessage_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(ChatEditMessageResponseApplicationJson),
            headersType: const FullType(ChatChatEditMessageHeaders),
            serializers: _$jsonSerializers,
            validStatuses: const {200, 202},
          );

  /// Edit a chat message.
  ///
  /// Returns a `DynamiteRequest` backing the [editMessage] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [message] the message to send.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Message edited successfully
  ///   * 202: Message edited successfully, but a bot or Matterbridge is configured, so the information can be replicated to other services
  ///   * 400: Editing message is not possible, e.g. when the new message is empty or the message is too old
  ///   * 403: Missing permissions to edit message
  ///   * 404: Message not found
  ///   * 405: Editing this message type is not allowed
  ///   * 413: Message too long
  ///
  /// See:
  ///  * [editMessage] for a method executing this request and parsing the response.
  ///  * [$editMessage_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $editMessage_Request({
    required String message,
    required String token,
    required int messageId,
    ChatEditMessageApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $message = _$jsonSerializers.serialize(message, specifiedType: const FullType(String));
    _parameters['message'] = $message;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $messageId = _$jsonSerializers.serialize(messageId, specifiedType: const FullType(int));
    _parameters['messageId'] = $messageId;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ChatEditMessageApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/chat/{token}/{messageId}{?message*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('put', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Edit a chat message.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [message] the message to send.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Message edited successfully
  ///   * 202: Message edited successfully, but a bot or Matterbridge is configured, so the information can be replicated to other services
  ///   * 400: Editing message is not possible, e.g. when the new message is empty or the message is too old
  ///   * 403: Missing permissions to edit message
  ///   * 404: Message not found
  ///   * 405: Editing this message type is not allowed
  ///   * 413: Message too long
  ///
  /// See:
  ///  * [$editMessage_Request] for the request send by this method.
  ///  * [$editMessage_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ChatEditMessageResponseApplicationJson, ChatChatEditMessageHeaders>> editMessage({
    required String message,
    required String token,
    required int messageId,
    ChatEditMessageApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $editMessage_Request(
      message: message,
      token: token,
      messageId: messageId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $editMessage_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<ChatEditMessageResponseApplicationJson, ChatChatEditMessageHeaders>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$deleteMessage_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ChatDeleteMessageResponseApplicationJson, ChatChatDeleteMessageHeaders>
      $deleteMessage_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(ChatDeleteMessageResponseApplicationJson),
            headersType: const FullType(ChatChatDeleteMessageHeaders),
            serializers: _$jsonSerializers,
            validStatuses: const {200, 202},
          );

  /// Delete a chat message.
  ///
  /// Returns a `DynamiteRequest` backing the [deleteMessage] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Message deleted successfully
  ///   * 202: Message deleted successfully, but a bot or Matterbridge is configured, so the information can be replicated elsewhere
  ///   * 400: Deleting message is not possible
  ///   * 403: Missing permissions to delete message
  ///   * 404: Message not found
  ///   * 405: Deleting this message type is not allowed
  ///
  /// See:
  ///  * [deleteMessage] for a method executing this request and parsing the response.
  ///  * [$deleteMessage_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $deleteMessage_Request({
    required String token,
    required int messageId,
    ChatDeleteMessageApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $messageId = _$jsonSerializers.serialize(messageId, specifiedType: const FullType(int));
    _parameters['messageId'] = $messageId;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ChatDeleteMessageApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/chat/{token}/{messageId}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Delete a chat message.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Message deleted successfully
  ///   * 202: Message deleted successfully, but a bot or Matterbridge is configured, so the information can be replicated elsewhere
  ///   * 400: Deleting message is not possible
  ///   * 403: Missing permissions to delete message
  ///   * 404: Message not found
  ///   * 405: Deleting this message type is not allowed
  ///
  /// See:
  ///  * [$deleteMessage_Request] for the request send by this method.
  ///  * [$deleteMessage_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ChatDeleteMessageResponseApplicationJson, ChatChatDeleteMessageHeaders>> deleteMessage({
    required String token,
    required int messageId,
    ChatDeleteMessageApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $deleteMessage_Request(
      token: token,
      messageId: messageId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $deleteMessage_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<ChatDeleteMessageResponseApplicationJson, ChatChatDeleteMessageHeaders>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$getMessageContext_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ChatGetMessageContextResponseApplicationJson, ChatChatGetMessageContextHeaders>
      $getMessageContext_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(ChatGetMessageContextResponseApplicationJson),
            headersType: const FullType(ChatChatGetMessageContextHeaders),
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Get the context of a message.
  ///
  /// Returns a `DynamiteRequest` backing the [getMessageContext] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [limit] Number of chat messages to receive in both directions (50 by default, 100 at most, might return 201 messages). Defaults to `50`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] The focused message which should be in the "middle" of the returned context.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Message context returned
  ///   * 304: No messages
  ///
  /// See:
  ///  * [getMessageContext] for a method executing this request and parsing the response.
  ///  * [$getMessageContext_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getMessageContext_Request({
    required String token,
    required int messageId,
    int? limit,
    ChatGetMessageContextApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $messageId = _$jsonSerializers.serialize(messageId, specifiedType: const FullType(int));
    _parameters['messageId'] = $messageId;

    var $limit = _$jsonSerializers.serialize(limit, specifiedType: const FullType(int));
    $limit ??= 50;
    _parameters['limit'] = $limit;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ChatGetMessageContextApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/chat/{token}/{messageId}/context{?limit*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get the context of a message.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [limit] Number of chat messages to receive in both directions (50 by default, 100 at most, might return 201 messages). Defaults to `50`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] The focused message which should be in the "middle" of the returned context.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Message context returned
  ///   * 304: No messages
  ///
  /// See:
  ///  * [$getMessageContext_Request] for the request send by this method.
  ///  * [$getMessageContext_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ChatGetMessageContextResponseApplicationJson, ChatChatGetMessageContextHeaders>>
      getMessageContext({
    required String token,
    required int messageId,
    int? limit,
    ChatGetMessageContextApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getMessageContext_Request(
      token: token,
      messageId: messageId,
      limit: limit,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getMessageContext_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<ChatGetMessageContextResponseApplicationJson, ChatChatGetMessageContextHeaders>(
      _serializer,
    ).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$getReminder_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ChatGetReminderResponseApplicationJson, void> $getReminder_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(ChatGetReminderResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get the reminder for a chat message.
  ///
  /// Returns a `DynamiteRequest` backing the [getReminder] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reminder returned
  ///   * 404: Message not found
  ///
  /// See:
  ///  * [getReminder] for a method executing this request and parsing the response.
  ///  * [$getReminder_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getReminder_Request({
    required String token,
    required int messageId,
    ChatGetReminderApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $messageId = _$jsonSerializers.serialize(messageId, specifiedType: const FullType(int));
    _parameters['messageId'] = $messageId;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ChatGetReminderApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/chat/{token}/{messageId}/reminder')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get the reminder for a chat message.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reminder returned
  ///   * 404: Message not found
  ///
  /// See:
  ///  * [$getReminder_Request] for the request send by this method.
  ///  * [$getReminder_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ChatGetReminderResponseApplicationJson, void>> getReminder({
    required String token,
    required int messageId,
    ChatGetReminderApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getReminder_Request(
      token: token,
      messageId: messageId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getReminder_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<ChatGetReminderResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$setReminder_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ChatSetReminderResponseApplicationJson, void> $setReminder_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(ChatSetReminderResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {201},
      );

  /// Set a reminder for a chat message.
  ///
  /// Returns a `DynamiteRequest` backing the [setReminder] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [timestamp] Timestamp of the reminder.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Reminder created successfully
  ///   * 404: Message not found
  ///
  /// See:
  ///  * [setReminder] for a method executing this request and parsing the response.
  ///  * [$setReminder_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $setReminder_Request({
    required int timestamp,
    required String token,
    required int messageId,
    ChatSetReminderApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $timestamp = _$jsonSerializers.serialize(timestamp, specifiedType: const FullType(int));
    _parameters['timestamp'] = $timestamp;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $messageId = _$jsonSerializers.serialize(messageId, specifiedType: const FullType(int));
    _parameters['messageId'] = $messageId;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ChatSetReminderApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/chat/{token}/{messageId}/reminder{?timestamp*}')
            .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Set a reminder for a chat message.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [timestamp] Timestamp of the reminder.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Reminder created successfully
  ///   * 404: Message not found
  ///
  /// See:
  ///  * [$setReminder_Request] for the request send by this method.
  ///  * [$setReminder_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ChatSetReminderResponseApplicationJson, void>> setReminder({
    required int timestamp,
    required String token,
    required int messageId,
    ChatSetReminderApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $setReminder_Request(
      timestamp: timestamp,
      token: token,
      messageId: messageId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $setReminder_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<ChatSetReminderResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$deleteReminder_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ChatDeleteReminderResponseApplicationJson, void> $deleteReminder_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(ChatDeleteReminderResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 404},
      );

  /// Delete a chat reminder.
  ///
  /// Returns a `DynamiteRequest` backing the [deleteReminder] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reminder deleted successfully
  ///   * 404: Message not found
  ///
  /// See:
  ///  * [deleteReminder] for a method executing this request and parsing the response.
  ///  * [$deleteReminder_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $deleteReminder_Request({
    required String token,
    required int messageId,
    ChatDeleteReminderApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $messageId = _$jsonSerializers.serialize(messageId, specifiedType: const FullType(int));
    _parameters['messageId'] = $messageId;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ChatDeleteReminderApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/chat/{token}/{messageId}/reminder')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Delete a chat reminder.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reminder deleted successfully
  ///   * 404: Message not found
  ///
  /// See:
  ///  * [$deleteReminder_Request] for the request send by this method.
  ///  * [$deleteReminder_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ChatDeleteReminderResponseApplicationJson, void>> deleteReminder({
    required String token,
    required int messageId,
    ChatDeleteReminderApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $deleteReminder_Request(
      token: token,
      messageId: messageId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $deleteReminder_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<ChatDeleteReminderResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$setReadMarker_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ChatSetReadMarkerResponseApplicationJson, ChatChatSetReadMarkerHeaders>
      $setReadMarker_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(ChatSetReadMarkerResponseApplicationJson),
            headersType: const FullType(ChatChatSetReadMarkerHeaders),
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Set the read marker to a specific message.
  ///
  /// Returns a `DynamiteRequest` backing the [setReadMarker] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [lastReadMessage] ID if the last read message (Optional only with `chat-read-last` capability).
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Read marker set successfully
  ///
  /// See:
  ///  * [setReadMarker] for a method executing this request and parsing the response.
  ///  * [$setReadMarker_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $setReadMarker_Request({
    required String token,
    int? lastReadMessage,
    ChatSetReadMarkerApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $lastReadMessage = _$jsonSerializers.serialize(lastReadMessage, specifiedType: const FullType(int));
    _parameters['lastReadMessage'] = $lastReadMessage;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ChatSetReadMarkerApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/chat/{token}/read{?lastReadMessage*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Set the read marker to a specific message.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [lastReadMessage] ID if the last read message (Optional only with `chat-read-last` capability).
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Read marker set successfully
  ///
  /// See:
  ///  * [$setReadMarker_Request] for the request send by this method.
  ///  * [$setReadMarker_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ChatSetReadMarkerResponseApplicationJson, ChatChatSetReadMarkerHeaders>> setReadMarker({
    required String token,
    int? lastReadMessage,
    ChatSetReadMarkerApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $setReadMarker_Request(
      token: token,
      lastReadMessage: lastReadMessage,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $setReadMarker_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<ChatSetReadMarkerResponseApplicationJson, ChatChatSetReadMarkerHeaders>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$markUnread_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ChatMarkUnreadResponseApplicationJson, ChatChatMarkUnreadHeaders> $markUnread_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(ChatMarkUnreadResponseApplicationJson),
        headersType: const FullType(ChatChatMarkUnreadHeaders),
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Mark a chat as unread.
  ///
  /// Returns a `DynamiteRequest` backing the [markUnread] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Read marker set successfully
  ///
  /// See:
  ///  * [markUnread] for a method executing this request and parsing the response.
  ///  * [$markUnread_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $markUnread_Request({
    required String token,
    ChatMarkUnreadApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ChatMarkUnreadApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/chat/{token}/read').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Mark a chat as unread.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Read marker set successfully
  ///
  /// See:
  ///  * [$markUnread_Request] for the request send by this method.
  ///  * [$markUnread_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ChatMarkUnreadResponseApplicationJson, ChatChatMarkUnreadHeaders>> markUnread({
    required String token,
    ChatMarkUnreadApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $markUnread_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $markUnread_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<ChatMarkUnreadResponseApplicationJson, ChatChatMarkUnreadHeaders>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$mentions_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ChatMentionsResponseApplicationJson, void> $mentions_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(ChatMentionsResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Search for mentions.
  ///
  /// Returns a `DynamiteRequest` backing the [mentions] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [search] Text to search for.
  ///   * [limit] Maximum number of results. Defaults to `20`.
  ///   * [includeStatus] Include the user statuses. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: List of mention suggestions returned
  ///
  /// See:
  ///  * [mentions] for a method executing this request and parsing the response.
  ///  * [$mentions_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $mentions_Request({
    required String search,
    required String token,
    int? limit,
    ChatMentionsIncludeStatus? includeStatus,
    ChatMentionsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $search = _$jsonSerializers.serialize(search, specifiedType: const FullType(String));
    _parameters['search'] = $search;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $limit = _$jsonSerializers.serialize(limit, specifiedType: const FullType(int));
    $limit ??= 20;
    _parameters['limit'] = $limit;

    var $includeStatus =
        _$jsonSerializers.serialize(includeStatus, specifiedType: const FullType(ChatMentionsIncludeStatus));
    $includeStatus ??= 0;
    _parameters['includeStatus'] = $includeStatus;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ChatMentionsApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/chat/{token}/mentions{?search*,limit*,includeStatus*}',
    ).expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Search for mentions.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [search] Text to search for.
  ///   * [limit] Maximum number of results. Defaults to `20`.
  ///   * [includeStatus] Include the user statuses. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: List of mention suggestions returned
  ///
  /// See:
  ///  * [$mentions_Request] for the request send by this method.
  ///  * [$mentions_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ChatMentionsResponseApplicationJson, void>> mentions({
    required String search,
    required String token,
    int? limit,
    ChatMentionsIncludeStatus? includeStatus,
    ChatMentionsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $mentions_Request(
      search: search,
      token: token,
      limit: limit,
      includeStatus: includeStatus,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $mentions_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<ChatMentionsResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$getObjectsSharedInRoom_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ChatGetObjectsSharedInRoomResponseApplicationJson, ChatChatGetObjectsSharedInRoomHeaders>
      $getObjectsSharedInRoom_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(ChatGetObjectsSharedInRoomResponseApplicationJson),
            headersType: const FullType(ChatChatGetObjectsSharedInRoomHeaders),
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Get objects that are shared in the room.
  ///
  /// Returns a `DynamiteRequest` backing the [getObjectsSharedInRoom] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [objectType] Type of the objects.
  ///   * [lastKnownMessageId] ID of the last known message. Defaults to `0`.
  ///   * [limit] Maximum number of objects. Defaults to `100`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: List of shared objects messages returned
  ///
  /// See:
  ///  * [getObjectsSharedInRoom] for a method executing this request and parsing the response.
  ///  * [$getObjectsSharedInRoom_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getObjectsSharedInRoom_Request({
    required String objectType,
    required String token,
    int? lastKnownMessageId,
    int? limit,
    ChatGetObjectsSharedInRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $objectType = _$jsonSerializers.serialize(objectType, specifiedType: const FullType(String));
    _parameters['objectType'] = $objectType;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $lastKnownMessageId = _$jsonSerializers.serialize(lastKnownMessageId, specifiedType: const FullType(int));
    $lastKnownMessageId ??= 0;
    _parameters['lastKnownMessageId'] = $lastKnownMessageId;

    var $limit = _$jsonSerializers.serialize(limit, specifiedType: const FullType(int));
    $limit ??= 100;
    _parameters['limit'] = $limit;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ChatGetObjectsSharedInRoomApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/chat/{token}/share{?objectType*,lastKnownMessageId*,limit*}',
    ).expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get objects that are shared in the room.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [objectType] Type of the objects.
  ///   * [lastKnownMessageId] ID of the last known message. Defaults to `0`.
  ///   * [limit] Maximum number of objects. Defaults to `100`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: List of shared objects messages returned
  ///
  /// See:
  ///  * [$getObjectsSharedInRoom_Request] for the request send by this method.
  ///  * [$getObjectsSharedInRoom_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ChatGetObjectsSharedInRoomResponseApplicationJson, ChatChatGetObjectsSharedInRoomHeaders>>
      getObjectsSharedInRoom({
    required String objectType,
    required String token,
    int? lastKnownMessageId,
    int? limit,
    ChatGetObjectsSharedInRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getObjectsSharedInRoom_Request(
      objectType: objectType,
      token: token,
      lastKnownMessageId: lastKnownMessageId,
      limit: limit,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getObjectsSharedInRoom_Serializer();
    final _rawResponse = await _i1.ResponseConverter<ChatGetObjectsSharedInRoomResponseApplicationJson,
            ChatChatGetObjectsSharedInRoomHeaders>(_serializer)
        .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$shareObjectToChat_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ChatShareObjectToChatResponseApplicationJson, ChatChatShareObjectToChatHeaders>
      $shareObjectToChat_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(ChatShareObjectToChatResponseApplicationJson),
            headersType: const FullType(ChatChatShareObjectToChatHeaders),
            serializers: _$jsonSerializers,
            validStatuses: const {201},
          );

  /// Sends a rich-object to the given room.
  ///
  /// The author and timestamp are automatically set to the current user/guest and time.
  ///
  /// Returns a `DynamiteRequest` backing the [shareObjectToChat] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [objectType] Type of the object.
  ///   * [objectId] ID of the object.
  ///   * [metaData] Additional metadata. Defaults to `''`.
  ///   * [actorDisplayName] Guest name. Defaults to `''`.
  ///   * [referenceId] Reference ID. Defaults to `''`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Object shared successfully
  ///   * 400: Sharing object is not possible
  ///   * 404: Actor not found
  ///   * 413: Message too long
  ///
  /// See:
  ///  * [shareObjectToChat] for a method executing this request and parsing the response.
  ///  * [$shareObjectToChat_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $shareObjectToChat_Request({
    required String objectType,
    required String objectId,
    required String token,
    String? metaData,
    String? actorDisplayName,
    String? referenceId,
    ChatShareObjectToChatApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $objectType = _$jsonSerializers.serialize(objectType, specifiedType: const FullType(String));
    _parameters['objectType'] = $objectType;

    final $objectId = _$jsonSerializers.serialize(objectId, specifiedType: const FullType(String));
    _parameters['objectId'] = $objectId;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $metaData = _$jsonSerializers.serialize(metaData, specifiedType: const FullType(String));
    $metaData ??= '';
    _parameters['metaData'] = $metaData;

    var $actorDisplayName = _$jsonSerializers.serialize(actorDisplayName, specifiedType: const FullType(String));
    $actorDisplayName ??= '';
    _parameters['actorDisplayName'] = $actorDisplayName;

    var $referenceId = _$jsonSerializers.serialize(referenceId, specifiedType: const FullType(String));
    $referenceId ??= '';
    _parameters['referenceId'] = $referenceId;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ChatShareObjectToChatApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/chat/{token}/share{?objectType*,objectId*,metaData*,actorDisplayName*,referenceId*}',
    ).expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Sends a rich-object to the given room.
  ///
  /// The author and timestamp are automatically set to the current user/guest and time.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [objectType] Type of the object.
  ///   * [objectId] ID of the object.
  ///   * [metaData] Additional metadata. Defaults to `''`.
  ///   * [actorDisplayName] Guest name. Defaults to `''`.
  ///   * [referenceId] Reference ID. Defaults to `''`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Object shared successfully
  ///   * 400: Sharing object is not possible
  ///   * 404: Actor not found
  ///   * 413: Message too long
  ///
  /// See:
  ///  * [$shareObjectToChat_Request] for the request send by this method.
  ///  * [$shareObjectToChat_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ChatShareObjectToChatResponseApplicationJson, ChatChatShareObjectToChatHeaders>>
      shareObjectToChat({
    required String objectType,
    required String objectId,
    required String token,
    String? metaData,
    String? actorDisplayName,
    String? referenceId,
    ChatShareObjectToChatApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $shareObjectToChat_Request(
      objectType: objectType,
      objectId: objectId,
      token: token,
      metaData: metaData,
      actorDisplayName: actorDisplayName,
      referenceId: referenceId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $shareObjectToChat_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<ChatShareObjectToChatResponseApplicationJson, ChatChatShareObjectToChatHeaders>(
      _serializer,
    ).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$getObjectsSharedInRoomOverview_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ChatGetObjectsSharedInRoomOverviewResponseApplicationJson, void>
      $getObjectsSharedInRoomOverview_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(ChatGetObjectsSharedInRoomOverviewResponseApplicationJson),
            headersType: null,
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Get objects that are shared in the room overview.
  ///
  /// Returns a `DynamiteRequest` backing the [getObjectsSharedInRoomOverview] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [limit] Maximum number of objects. Defaults to `7`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: List of shared objects messages of each type returned
  ///
  /// See:
  ///  * [getObjectsSharedInRoomOverview] for a method executing this request and parsing the response.
  ///  * [$getObjectsSharedInRoomOverview_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getObjectsSharedInRoomOverview_Request({
    required String token,
    int? limit,
    ChatGetObjectsSharedInRoomOverviewApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $limit = _$jsonSerializers.serialize(limit, specifiedType: const FullType(int));
    $limit ??= 7;
    _parameters['limit'] = $limit;

    var $apiVersion = _$jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(ChatGetObjectsSharedInRoomOverviewApiVersion),
    );
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/chat/{token}/share/overview{?limit*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get objects that are shared in the room overview.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [limit] Maximum number of objects. Defaults to `7`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: List of shared objects messages of each type returned
  ///
  /// See:
  ///  * [$getObjectsSharedInRoomOverview_Request] for the request send by this method.
  ///  * [$getObjectsSharedInRoomOverview_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ChatGetObjectsSharedInRoomOverviewResponseApplicationJson, void>>
      getObjectsSharedInRoomOverview({
    required String token,
    int? limit,
    ChatGetObjectsSharedInRoomOverviewApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getObjectsSharedInRoomOverview_Request(
      token: token,
      limit: limit,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getObjectsSharedInRoomOverview_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<ChatGetObjectsSharedInRoomOverviewResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $ExternalSignalingClient {
  /// Creates a new `DynamiteClient` for external_signaling requests.
  $ExternalSignalingClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$signalingGetSettings_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<SignalingGetSettingsResponseApplicationJson, void> $signalingGetSettings_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(SignalingGetSettingsResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get the signaling settings.
  ///
  /// Returns a `DynamiteRequest` backing the [signalingGetSettings] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [token] Token of the room. Defaults to `''`.
  ///   * [apiVersion] Defaults to `v3`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Signaling settings returned
  ///   * 401: Recording request invalid
  ///   * 404: Room not found
  ///
  /// See:
  ///  * [signalingGetSettings] for a method executing this request and parsing the response.
  ///  * [$signalingGetSettings_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $signalingGetSettings_Request({
    String? token,
    SignalingGetSettingsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    var $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    $token ??= '';
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(SignalingGetSettingsApiVersion));
    $apiVersion ??= 'v3';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/signaling/settings{?token*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get the signaling settings.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [token] Token of the room. Defaults to `''`.
  ///   * [apiVersion] Defaults to `v3`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Signaling settings returned
  ///   * 401: Recording request invalid
  ///   * 404: Room not found
  ///
  /// See:
  ///  * [$signalingGetSettings_Request] for the request send by this method.
  ///  * [$signalingGetSettings_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<SignalingGetSettingsResponseApplicationJson, void>> signalingGetSettings({
    String? token,
    SignalingGetSettingsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $signalingGetSettings_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $signalingGetSettings_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<SignalingGetSettingsResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $FederationClient {
  /// Creates a new `DynamiteClient` for federation requests.
  $FederationClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$acceptShare_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<FederationAcceptShareResponseApplicationJson, void> $acceptShare_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(FederationAcceptShareResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Accept a federation invites.
  ///
  /// 🚧 Draft: Still work in progress.
  ///
  /// Returns a `DynamiteRequest` backing the [acceptShare] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [id] ID of the share.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Invite accepted successfully
  ///   * 400: Invite can not be accepted (maybe it was accepted already)
  ///   * 410: Remote server could not be reached to notify about the acceptance
  ///   * 404: Invite can not be found
  ///
  /// See:
  ///  * [acceptShare] for a method executing this request and parsing the response.
  ///  * [$acceptShare_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $acceptShare_Request({
    required int id,
    FederationAcceptShareApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $id = _$jsonSerializers.serialize(id, specifiedType: const FullType(int));
    _parameters['id'] = $id;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(FederationAcceptShareApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/federation/invitation/{id}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Accept a federation invites.
  ///
  /// 🚧 Draft: Still work in progress.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [id] ID of the share.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Invite accepted successfully
  ///   * 400: Invite can not be accepted (maybe it was accepted already)
  ///   * 410: Remote server could not be reached to notify about the acceptance
  ///   * 404: Invite can not be found
  ///
  /// See:
  ///  * [$acceptShare_Request] for the request send by this method.
  ///  * [$acceptShare_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<FederationAcceptShareResponseApplicationJson, void>> acceptShare({
    required int id,
    FederationAcceptShareApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $acceptShare_Request(
      id: id,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $acceptShare_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<FederationAcceptShareResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$rejectShare_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<FederationRejectShareResponseApplicationJson, void> $rejectShare_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(FederationRejectShareResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Decline a federation invites.
  ///
  /// 🚧 Draft: Still work in progress.
  ///
  /// Returns a `DynamiteRequest` backing the [rejectShare] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [id] ID of the share.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Invite declined successfully
  ///   * 404: Invite can not be found
  ///   * 400: Invite was already accepted, use the "Remove the current user from a room" endpoint instead
  ///
  /// See:
  ///  * [rejectShare] for a method executing this request and parsing the response.
  ///  * [$rejectShare_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $rejectShare_Request({
    required int id,
    FederationRejectShareApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $id = _$jsonSerializers.serialize(id, specifiedType: const FullType(int));
    _parameters['id'] = $id;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(FederationRejectShareApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/federation/invitation/{id}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Decline a federation invites.
  ///
  /// 🚧 Draft: Still work in progress.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [id] ID of the share.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Invite declined successfully
  ///   * 404: Invite can not be found
  ///   * 400: Invite was already accepted, use the "Remove the current user from a room" endpoint instead
  ///
  /// See:
  ///  * [$rejectShare_Request] for the request send by this method.
  ///  * [$rejectShare_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<FederationRejectShareResponseApplicationJson, void>> rejectShare({
    required int id,
    FederationRejectShareApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $rejectShare_Request(
      id: id,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $rejectShare_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<FederationRejectShareResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$getShares_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<FederationGetSharesResponseApplicationJson, void> $getShares_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(FederationGetSharesResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get a list of federation invites.
  ///
  /// 🚧 Draft: Still work in progress.
  ///
  /// Returns a `DynamiteRequest` backing the [getShares] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Get list of received federation invites successfully
  ///
  /// See:
  ///  * [getShares] for a method executing this request and parsing the response.
  ///  * [$getShares_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getShares_Request({
    FederationGetSharesApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(FederationGetSharesApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/federation/invitation').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get a list of federation invites.
  ///
  /// 🚧 Draft: Still work in progress.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Get list of received federation invites successfully
  ///
  /// See:
  ///  * [$getShares_Request] for the request send by this method.
  ///  * [$getShares_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<FederationGetSharesResponseApplicationJson, void>> getShares({
    FederationGetSharesApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getShares_Request(
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getShares_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<FederationGetSharesResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $FilesIntegrationClient {
  /// Creates a new `DynamiteClient` for files_integration requests.
  $FilesIntegrationClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$getRoomByFileId_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<FilesIntegrationGetRoomByFileIdResponseApplicationJson, void> $getRoomByFileId_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(FilesIntegrationGetRoomByFileIdResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get the token of the room associated to the given file id.
  ///
  /// This is the counterpart of self::getRoomByShareToken() for file ids instead of share tokens, although both return the same room token if the given file id and share token refer to the same file.
  /// If there is no room associated to the given file id a new room is created; the new room is a public room associated with a "file" object with the given file id. Unlike normal rooms in which the owner is the user that created the room these are special rooms without owner (although self joined users with direct access to the file become persistent participants automatically when they join until they explicitly leave or no longer have access to the file).
  /// In any case, to create or even get the token of the room, the file must be shared and the user must be the owner of a public share of the file (like a link share, for example) or have direct access to that file; an error is returned otherwise. A user has direct access to a file if she has access to it (or to an ancestor) through a user, group, circle or room share (but not through a link share, for example), or if she is the owner of such a file.
  ///
  /// Returns a `DynamiteRequest` backing the [getRoomByFileId] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [fileId] ID of the file.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room token returned
  ///   * 400: Rooms not allowed for shares
  ///   * 404: Share not found
  ///
  /// See:
  ///  * [getRoomByFileId] for a method executing this request and parsing the response.
  ///  * [$getRoomByFileId_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getRoomByFileId_Request({
    required String fileId,
    FilesIntegrationGetRoomByFileIdApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $fileId = _$jsonSerializers.serialize(fileId, specifiedType: const FullType(String));
    _i4.checkPattern(
      $fileId as String?,
      RegExp(r'^.+$'),
      'fileId',
    );
    _parameters['fileId'] = $fileId;

    var $apiVersion = _$jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(FilesIntegrationGetRoomByFileIdApiVersion),
    );
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/file/{fileId}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get the token of the room associated to the given file id.
  ///
  /// This is the counterpart of self::getRoomByShareToken() for file ids instead of share tokens, although both return the same room token if the given file id and share token refer to the same file.
  /// If there is no room associated to the given file id a new room is created; the new room is a public room associated with a "file" object with the given file id. Unlike normal rooms in which the owner is the user that created the room these are special rooms without owner (although self joined users with direct access to the file become persistent participants automatically when they join until they explicitly leave or no longer have access to the file).
  /// In any case, to create or even get the token of the room, the file must be shared and the user must be the owner of a public share of the file (like a link share, for example) or have direct access to that file; an error is returned otherwise. A user has direct access to a file if she has access to it (or to an ancestor) through a user, group, circle or room share (but not through a link share, for example), or if she is the owner of such a file.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [fileId] ID of the file.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room token returned
  ///   * 400: Rooms not allowed for shares
  ///   * 404: Share not found
  ///
  /// See:
  ///  * [$getRoomByFileId_Request] for the request send by this method.
  ///  * [$getRoomByFileId_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<FilesIntegrationGetRoomByFileIdResponseApplicationJson, void>> getRoomByFileId({
    required String fileId,
    FilesIntegrationGetRoomByFileIdApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getRoomByFileId_Request(
      fileId: fileId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getRoomByFileId_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<FilesIntegrationGetRoomByFileIdResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$getRoomByShareToken_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<FilesIntegrationGetRoomByShareTokenResponseApplicationJson, void>
      $getRoomByShareToken_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(FilesIntegrationGetRoomByShareTokenResponseApplicationJson),
            headersType: null,
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Returns the token of the room associated to the file of the given share token.
  ///
  /// This is the counterpart of self::getRoomByFileId() for share tokens instead of file ids, although both return the same room token if the given file id and share token refer to the same file.
  /// If there is no room associated to the file id of the given share token a new room is created; the new room is a public room associated with a "file" object with the file id of the given share token. Unlike normal rooms in which the owner is the user that created the room these are special rooms without owner (although self joined users with direct access to the file become persistent participants automatically when they join until they explicitly leave or no longer have access to the file).
  /// In any case, to create or even get the token of the room, the file must be publicly shared (like a link share, for example); an error is returned otherwise.
  /// Besides the token of the room this also returns the current user ID and display name, if any; this is needed by the Talk sidebar to know the actual current user, as the public share page uses the incognito mode and thus logged-in users as seen as guests.
  ///
  /// Returns a `DynamiteRequest` backing the [getRoomByShareToken] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [shareToken] Token of the file share.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room token and user info returned
  ///   * 400: Rooms not allowed for shares
  ///   * 404: Share not found
  ///
  /// See:
  ///  * [getRoomByShareToken] for a method executing this request and parsing the response.
  ///  * [$getRoomByShareToken_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getRoomByShareToken_Request({
    required String shareToken,
    FilesIntegrationGetRoomByShareTokenApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $shareToken = _$jsonSerializers.serialize(shareToken, specifiedType: const FullType(String));
    _i4.checkPattern(
      $shareToken as String?,
      RegExp(r'^.+$'),
      'shareToken',
    );
    _parameters['shareToken'] = $shareToken;

    var $apiVersion = _$jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(FilesIntegrationGetRoomByShareTokenApiVersion),
    );
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/publicshare/{shareToken}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Returns the token of the room associated to the file of the given share token.
  ///
  /// This is the counterpart of self::getRoomByFileId() for share tokens instead of file ids, although both return the same room token if the given file id and share token refer to the same file.
  /// If there is no room associated to the file id of the given share token a new room is created; the new room is a public room associated with a "file" object with the file id of the given share token. Unlike normal rooms in which the owner is the user that created the room these are special rooms without owner (although self joined users with direct access to the file become persistent participants automatically when they join until they explicitly leave or no longer have access to the file).
  /// In any case, to create or even get the token of the room, the file must be publicly shared (like a link share, for example); an error is returned otherwise.
  /// Besides the token of the room this also returns the current user ID and display name, if any; this is needed by the Talk sidebar to know the actual current user, as the public share page uses the incognito mode and thus logged-in users as seen as guests.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [shareToken] Token of the file share.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room token and user info returned
  ///   * 400: Rooms not allowed for shares
  ///   * 404: Share not found
  ///
  /// See:
  ///  * [$getRoomByShareToken_Request] for the request send by this method.
  ///  * [$getRoomByShareToken_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<FilesIntegrationGetRoomByShareTokenResponseApplicationJson, void>> getRoomByShareToken({
    required String shareToken,
    FilesIntegrationGetRoomByShareTokenApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getRoomByShareToken_Request(
      shareToken: shareToken,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getRoomByShareToken_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<FilesIntegrationGetRoomByShareTokenResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$publicShareAuthCreateRoom_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<PublicShareAuthCreateRoomResponseApplicationJson, void>
      $publicShareAuthCreateRoom_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(PublicShareAuthCreateRoomResponseApplicationJson),
            headersType: null,
            serializers: _$jsonSerializers,
            validStatuses: const {201},
          );

  /// Creates a new room for video verification (requesting the password of a share).
  ///
  /// The new room is a public room associated with a "share:password" object with the ID of the share token. Unlike normal rooms in which the owner is the user that created the room these are special rooms always created by a guest or user on behalf of a registered user, the sharer, who will be the owner of the room.
  /// The share must have "send password by Talk" enabled; an error is returned otherwise.
  ///
  /// Returns a `DynamiteRequest` backing the [publicShareAuthCreateRoom] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [shareToken] Token of the file share.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Room created successfully
  ///   * 404: Share not found
  ///
  /// See:
  ///  * [publicShareAuthCreateRoom] for a method executing this request and parsing the response.
  ///  * [$publicShareAuthCreateRoom_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $publicShareAuthCreateRoom_Request({
    required String shareToken,
    PublicShareAuthCreateRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $shareToken = _$jsonSerializers.serialize(shareToken, specifiedType: const FullType(String));
    _parameters['shareToken'] = $shareToken;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(PublicShareAuthCreateRoomApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/publicshareauth{?shareToken*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Creates a new room for video verification (requesting the password of a share).
  ///
  /// The new room is a public room associated with a "share:password" object with the ID of the share token. Unlike normal rooms in which the owner is the user that created the room these are special rooms always created by a guest or user on behalf of a registered user, the sharer, who will be the owner of the room.
  /// The share must have "send password by Talk" enabled; an error is returned otherwise.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [shareToken] Token of the file share.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Room created successfully
  ///   * 404: Share not found
  ///
  /// See:
  ///  * [$publicShareAuthCreateRoom_Request] for the request send by this method.
  ///  * [$publicShareAuthCreateRoom_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<PublicShareAuthCreateRoomResponseApplicationJson, void>> publicShareAuthCreateRoom({
    required String shareToken,
    PublicShareAuthCreateRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $publicShareAuthCreateRoom_Request(
      shareToken: shareToken,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $publicShareAuthCreateRoom_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<PublicShareAuthCreateRoomResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $GuestClient {
  /// Creates a new `DynamiteClient` for guest requests.
  $GuestClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$setDisplayName_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<GuestSetDisplayNameResponseApplicationJson, void> $setDisplayName_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(GuestSetDisplayNameResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 403, 404},
      );

  /// Set the display name as a guest.
  ///
  /// Returns a `DynamiteRequest` backing the [setDisplayName] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [displayName] New display name.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Display name updated successfully
  ///   * 403: Not a guest
  ///   * 404: Not a participant
  ///
  /// See:
  ///  * [setDisplayName] for a method executing this request and parsing the response.
  ///  * [$setDisplayName_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $setDisplayName_Request({
    required String displayName,
    required String token,
    GuestSetDisplayNameApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $displayName = _$jsonSerializers.serialize(displayName, specifiedType: const FullType(String));
    _parameters['displayName'] = $displayName;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(GuestSetDisplayNameApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/guest/{token}/name{?displayName*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Set the display name as a guest.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [displayName] New display name.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Display name updated successfully
  ///   * 403: Not a guest
  ///   * 404: Not a participant
  ///
  /// See:
  ///  * [$setDisplayName_Request] for the request send by this method.
  ///  * [$setDisplayName_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<GuestSetDisplayNameResponseApplicationJson, void>> setDisplayName({
    required String displayName,
    required String token,
    GuestSetDisplayNameApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $setDisplayName_Request(
      displayName: displayName,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $setDisplayName_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<GuestSetDisplayNameResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $HostedSignalingServerClient {
  /// Creates a new `DynamiteClient` for hosted_signaling_server requests.
  $HostedSignalingServerClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$requestTrial_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<HostedSignalingServerRequestTrialResponseApplicationJson, void> $requestTrial_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(HostedSignalingServerRequestTrialResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Request a trial account.
  ///
  /// This endpoint requires admin access.
  ///
  /// Returns a `DynamiteRequest` backing the [requestTrial] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [url] Server URL.
  ///   * [name] Display name of the user.
  ///   * [email] Email of the user.
  ///   * [language] Language of the user.
  ///   * [country] Country of the user.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Trial requested successfully
  ///   * 400: Requesting trial is not possible
  ///   * 500
  ///
  /// See:
  ///  * [requestTrial] for a method executing this request and parsing the response.
  ///  * [$requestTrial_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $requestTrial_Request({
    required String url,
    required String name,
    required String email,
    required String language,
    required String country,
    HostedSignalingServerRequestTrialApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $url = _$jsonSerializers.serialize(url, specifiedType: const FullType(String));
    _parameters['url'] = $url;

    final $name = _$jsonSerializers.serialize(name, specifiedType: const FullType(String));
    _parameters['name'] = $name;

    final $email = _$jsonSerializers.serialize(email, specifiedType: const FullType(String));
    _parameters['email'] = $email;

    final $language = _$jsonSerializers.serialize(language, specifiedType: const FullType(String));
    _parameters['language'] = $language;

    final $country = _$jsonSerializers.serialize(country, specifiedType: const FullType(String));
    _parameters['country'] = $country;

    var $apiVersion = _$jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(HostedSignalingServerRequestTrialApiVersion),
    );
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/hostedsignalingserver/requesttrial{?url*,name*,email*,language*,country*}',
    ).expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Request a trial account.
  ///
  /// This endpoint requires admin access.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [url] Server URL.
  ///   * [name] Display name of the user.
  ///   * [email] Email of the user.
  ///   * [language] Language of the user.
  ///   * [country] Country of the user.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Trial requested successfully
  ///   * 400: Requesting trial is not possible
  ///   * 500
  ///
  /// See:
  ///  * [$requestTrial_Request] for the request send by this method.
  ///  * [$requestTrial_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<HostedSignalingServerRequestTrialResponseApplicationJson, void>> requestTrial({
    required String url,
    required String name,
    required String email,
    required String language,
    required String country,
    HostedSignalingServerRequestTrialApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $requestTrial_Request(
      url: url,
      name: name,
      email: email,
      language: language,
      country: country,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $requestTrial_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<HostedSignalingServerRequestTrialResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$deleteAccount_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<void, void> $deleteAccount_Serializer() => _i1.DynamiteSerializer(
        bodyType: null,
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {204},
      );

  /// Delete the account.
  ///
  /// This endpoint requires admin access.
  ///
  /// Returns a `DynamiteRequest` backing the [deleteAccount] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 204: Account deleted successfully
  ///   * 400: Deleting account is not possible
  ///   * 500
  ///
  /// See:
  ///  * [deleteAccount] for a method executing this request and parsing the response.
  ///  * [$deleteAccount_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $deleteAccount_Request({
    HostedSignalingServerDeleteAccountApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    var $apiVersion = _$jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(HostedSignalingServerDeleteAccountApiVersion),
    );
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/hostedsignalingserver/delete').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Delete the account.
  ///
  /// This endpoint requires admin access.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 204: Account deleted successfully
  ///   * 400: Deleting account is not possible
  ///   * 500
  ///
  /// See:
  ///  * [$deleteAccount_Request] for the request send by this method.
  ///  * [$deleteAccount_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<void, void>> deleteAccount({
    HostedSignalingServerDeleteAccountApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $deleteAccount_Request(
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $deleteAccount_Serializer();
    final _rawResponse = await _i1.ResponseConverter<void, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $InternalSignalingClient {
  /// Creates a new `DynamiteClient` for internal_signaling requests.
  $InternalSignalingClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$signalingGetSettings_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<SignalingGetSettingsResponseApplicationJson, void> $signalingGetSettings_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(SignalingGetSettingsResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get the signaling settings.
  ///
  /// Returns a `DynamiteRequest` backing the [signalingGetSettings] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [token] Token of the room. Defaults to `''`.
  ///   * [apiVersion] Defaults to `v3`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Signaling settings returned
  ///   * 401: Recording request invalid
  ///   * 404: Room not found
  ///
  /// See:
  ///  * [signalingGetSettings] for a method executing this request and parsing the response.
  ///  * [$signalingGetSettings_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $signalingGetSettings_Request({
    String? token,
    SignalingGetSettingsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    var $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    $token ??= '';
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(SignalingGetSettingsApiVersion));
    $apiVersion ??= 'v3';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/signaling/settings{?token*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get the signaling settings.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [token] Token of the room. Defaults to `''`.
  ///   * [apiVersion] Defaults to `v3`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Signaling settings returned
  ///   * 401: Recording request invalid
  ///   * 404: Room not found
  ///
  /// See:
  ///  * [$signalingGetSettings_Request] for the request send by this method.
  ///  * [$signalingGetSettings_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<SignalingGetSettingsResponseApplicationJson, void>> signalingGetSettings({
    String? token,
    SignalingGetSettingsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $signalingGetSettings_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $signalingGetSettings_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<SignalingGetSettingsResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$signalingPullMessages_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<SignalingPullMessagesResponseApplicationJson, void> $signalingPullMessages_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(SignalingPullMessagesResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 404, 409},
      );

  /// Get signaling messages.
  ///
  /// Returns a `DynamiteRequest` backing the [signalingPullMessages] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v3`.
  ///   * [token] Token of the room.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Signaling messages returned
  ///   * 404: Session, room or participant not found
  ///   * 409: Session killed
  ///   * 400: Getting signaling messages is not possible
  ///
  /// See:
  ///  * [signalingPullMessages] for a method executing this request and parsing the response.
  ///  * [$signalingPullMessages_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $signalingPullMessages_Request({
    required String token,
    SignalingPullMessagesApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(SignalingPullMessagesApiVersion));
    $apiVersion ??= 'v3';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/signaling/{token}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get signaling messages.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v3`.
  ///   * [token] Token of the room.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Signaling messages returned
  ///   * 404: Session, room or participant not found
  ///   * 409: Session killed
  ///   * 400: Getting signaling messages is not possible
  ///
  /// See:
  ///  * [$signalingPullMessages_Request] for the request send by this method.
  ///  * [$signalingPullMessages_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<SignalingPullMessagesResponseApplicationJson, void>> signalingPullMessages({
    required String token,
    SignalingPullMessagesApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $signalingPullMessages_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $signalingPullMessages_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<SignalingPullMessagesResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$signalingSendMessages_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<SignalingSendMessagesResponseApplicationJson, void> $signalingSendMessages_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(SignalingSendMessagesResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Send signaling messages.
  ///
  /// Returns a `DynamiteRequest` backing the [signalingSendMessages] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [messages] JSON encoded messages.
  ///   * [apiVersion] Defaults to `v3`.
  ///   * [token] Token of the room.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Signaling message sent successfully
  ///   * 400: Sending signaling message is not possible
  ///
  /// See:
  ///  * [signalingSendMessages] for a method executing this request and parsing the response.
  ///  * [$signalingSendMessages_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $signalingSendMessages_Request({
    required String messages,
    required String token,
    SignalingSendMessagesApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $messages = _$jsonSerializers.serialize(messages, specifiedType: const FullType(String));
    _parameters['messages'] = $messages;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(SignalingSendMessagesApiVersion));
    $apiVersion ??= 'v3';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/signaling/{token}{?messages*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Send signaling messages.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [messages] JSON encoded messages.
  ///   * [apiVersion] Defaults to `v3`.
  ///   * [token] Token of the room.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Signaling message sent successfully
  ///   * 400: Sending signaling message is not possible
  ///
  /// See:
  ///  * [$signalingSendMessages_Request] for the request send by this method.
  ///  * [$signalingSendMessages_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<SignalingSendMessagesResponseApplicationJson, void>> signalingSendMessages({
    required String messages,
    required String token,
    SignalingSendMessagesApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $signalingSendMessages_Request(
      messages: messages,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $signalingSendMessages_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<SignalingSendMessagesResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $MatterbridgeClient {
  /// Creates a new `DynamiteClient` for matterbridge requests.
  $MatterbridgeClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$getBridgeOfRoom_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<MatterbridgeGetBridgeOfRoomResponseApplicationJson, void> $getBridgeOfRoom_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(MatterbridgeGetBridgeOfRoomResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get bridge information of one room.
  ///
  /// Returns a `DynamiteRequest` backing the [getBridgeOfRoom] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Return list of configured bridges
  ///
  /// See:
  ///  * [getBridgeOfRoom] for a method executing this request and parsing the response.
  ///  * [$getBridgeOfRoom_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getBridgeOfRoom_Request({
    required String token,
    MatterbridgeGetBridgeOfRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(MatterbridgeGetBridgeOfRoomApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/bridge/{token}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get bridge information of one room.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Return list of configured bridges
  ///
  /// See:
  ///  * [$getBridgeOfRoom_Request] for the request send by this method.
  ///  * [$getBridgeOfRoom_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<MatterbridgeGetBridgeOfRoomResponseApplicationJson, void>> getBridgeOfRoom({
    required String token,
    MatterbridgeGetBridgeOfRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getBridgeOfRoom_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getBridgeOfRoom_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<MatterbridgeGetBridgeOfRoomResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$editBridgeOfRoom_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<MatterbridgeEditBridgeOfRoomResponseApplicationJson, void> $editBridgeOfRoom_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(MatterbridgeEditBridgeOfRoomResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Edit bridge information of one room.
  ///
  /// Returns a `DynamiteRequest` backing the [editBridgeOfRoom] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [enabled] If the bridge should be enabled.
  ///   * [parts] New parts.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Bridge edited successfully
  ///   * 406: Editing bridge is not possible
  ///
  /// See:
  ///  * [editBridgeOfRoom] for a method executing this request and parsing the response.
  ///  * [$editBridgeOfRoom_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $editBridgeOfRoom_Request({
    required MatterbridgeEditBridgeOfRoomEnabled enabled,
    required String token,
    ContentString<BuiltList<BuiltMap<String, JsonObject>>>? parts,
    MatterbridgeEditBridgeOfRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $enabled =
        _$jsonSerializers.serialize(enabled, specifiedType: const FullType(MatterbridgeEditBridgeOfRoomEnabled));
    _parameters['enabled'] = $enabled;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $parts = _$jsonSerializers.serialize(
      parts,
      specifiedType: const FullType(ContentString, [
        FullType(BuiltList, [
          FullType(BuiltMap, [FullType(String), FullType(JsonObject)]),
        ]),
      ]),
    );
    _parameters['parts'] = $parts;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(MatterbridgeEditBridgeOfRoomApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/bridge/{token}{?enabled*,parts*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('put', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Edit bridge information of one room.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [enabled] If the bridge should be enabled.
  ///   * [parts] New parts.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Bridge edited successfully
  ///   * 406: Editing bridge is not possible
  ///
  /// See:
  ///  * [$editBridgeOfRoom_Request] for the request send by this method.
  ///  * [$editBridgeOfRoom_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<MatterbridgeEditBridgeOfRoomResponseApplicationJson, void>> editBridgeOfRoom({
    required MatterbridgeEditBridgeOfRoomEnabled enabled,
    required String token,
    ContentString<BuiltList<BuiltMap<String, JsonObject>>>? parts,
    MatterbridgeEditBridgeOfRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $editBridgeOfRoom_Request(
      enabled: enabled,
      token: token,
      parts: parts,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $editBridgeOfRoom_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<MatterbridgeEditBridgeOfRoomResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$deleteBridgeOfRoom_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<MatterbridgeDeleteBridgeOfRoomResponseApplicationJson, void>
      $deleteBridgeOfRoom_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(MatterbridgeDeleteBridgeOfRoomResponseApplicationJson),
            headersType: null,
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Delete bridge of one room.
  ///
  /// Returns a `DynamiteRequest` backing the [deleteBridgeOfRoom] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Bridge deleted successfully
  ///   * 406: Deleting bridge is not possible
  ///
  /// See:
  ///  * [deleteBridgeOfRoom] for a method executing this request and parsing the response.
  ///  * [$deleteBridgeOfRoom_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $deleteBridgeOfRoom_Request({
    required String token,
    MatterbridgeDeleteBridgeOfRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion = _$jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(MatterbridgeDeleteBridgeOfRoomApiVersion),
    );
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/bridge/{token}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Delete bridge of one room.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Bridge deleted successfully
  ///   * 406: Deleting bridge is not possible
  ///
  /// See:
  ///  * [$deleteBridgeOfRoom_Request] for the request send by this method.
  ///  * [$deleteBridgeOfRoom_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<MatterbridgeDeleteBridgeOfRoomResponseApplicationJson, void>> deleteBridgeOfRoom({
    required String token,
    MatterbridgeDeleteBridgeOfRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $deleteBridgeOfRoom_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $deleteBridgeOfRoom_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<MatterbridgeDeleteBridgeOfRoomResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$getBridgeProcessState_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<MatterbridgeGetBridgeProcessStateResponseApplicationJson, void>
      $getBridgeProcessState_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(MatterbridgeGetBridgeProcessStateResponseApplicationJson),
            headersType: null,
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Get bridge process information.
  ///
  /// Returns a `DynamiteRequest` backing the [getBridgeProcessState] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Return list of running processes
  ///
  /// See:
  ///  * [getBridgeProcessState] for a method executing this request and parsing the response.
  ///  * [$getBridgeProcessState_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getBridgeProcessState_Request({
    required String token,
    MatterbridgeGetBridgeProcessStateApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion = _$jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(MatterbridgeGetBridgeProcessStateApiVersion),
    );
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/bridge/{token}/process').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get bridge process information.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Return list of running processes
  ///
  /// See:
  ///  * [$getBridgeProcessState_Request] for the request send by this method.
  ///  * [$getBridgeProcessState_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<MatterbridgeGetBridgeProcessStateResponseApplicationJson, void>> getBridgeProcessState({
    required String token,
    MatterbridgeGetBridgeProcessStateApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getBridgeProcessState_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getBridgeProcessState_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<MatterbridgeGetBridgeProcessStateResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$matterbridgeSettingsStopAllBridges_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<MatterbridgeSettingsStopAllBridgesResponseApplicationJson, void>
      $matterbridgeSettingsStopAllBridges_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(MatterbridgeSettingsStopAllBridgesResponseApplicationJson),
            headersType: null,
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Stop all bridges.
  ///
  /// This endpoint requires admin access.
  ///
  /// Returns a `DynamiteRequest` backing the [matterbridgeSettingsStopAllBridges] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: All bridges stopped successfully
  ///   * 406: Stopping all bridges is not possible
  ///
  /// See:
  ///  * [matterbridgeSettingsStopAllBridges] for a method executing this request and parsing the response.
  ///  * [$matterbridgeSettingsStopAllBridges_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $matterbridgeSettingsStopAllBridges_Request({
    MatterbridgeSettingsStopAllBridgesApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    var $apiVersion = _$jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(MatterbridgeSettingsStopAllBridgesApiVersion),
    );
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/bridge').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Stop all bridges.
  ///
  /// This endpoint requires admin access.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: All bridges stopped successfully
  ///   * 406: Stopping all bridges is not possible
  ///
  /// See:
  ///  * [$matterbridgeSettingsStopAllBridges_Request] for the request send by this method.
  ///  * [$matterbridgeSettingsStopAllBridges_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<MatterbridgeSettingsStopAllBridgesResponseApplicationJson, void>>
      matterbridgeSettingsStopAllBridges({
    MatterbridgeSettingsStopAllBridgesApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $matterbridgeSettingsStopAllBridges_Request(
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $matterbridgeSettingsStopAllBridges_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<MatterbridgeSettingsStopAllBridgesResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$matterbridgeSettingsGetMatterbridgeVersion_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson, void>
      $matterbridgeSettingsGetMatterbridgeVersion_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson),
            headersType: null,
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Get Matterbridge version.
  ///
  /// This endpoint requires admin access.
  ///
  /// Returns a `DynamiteRequest` backing the [matterbridgeSettingsGetMatterbridgeVersion] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Bridge version returned
  ///   * 400: Getting bridge version is not possible
  ///
  /// See:
  ///  * [matterbridgeSettingsGetMatterbridgeVersion] for a method executing this request and parsing the response.
  ///  * [$matterbridgeSettingsGetMatterbridgeVersion_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $matterbridgeSettingsGetMatterbridgeVersion_Request({
    MatterbridgeSettingsGetMatterbridgeVersionApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    var $apiVersion = _$jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(MatterbridgeSettingsGetMatterbridgeVersionApiVersion),
    );
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/bridge/version').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get Matterbridge version.
  ///
  /// This endpoint requires admin access.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Bridge version returned
  ///   * 400: Getting bridge version is not possible
  ///
  /// See:
  ///  * [$matterbridgeSettingsGetMatterbridgeVersion_Request] for the request send by this method.
  ///  * [$matterbridgeSettingsGetMatterbridgeVersion_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson, void>>
      matterbridgeSettingsGetMatterbridgeVersion({
    MatterbridgeSettingsGetMatterbridgeVersionApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $matterbridgeSettingsGetMatterbridgeVersion_Request(
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $matterbridgeSettingsGetMatterbridgeVersion_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson, void>(
      _serializer,
    ).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $PollClient {
  /// Creates a new `DynamiteClient` for poll requests.
  $PollClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$createPoll_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<PollCreatePollResponseApplicationJson, void> $createPoll_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(PollCreatePollResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {201},
      );

  /// Create a poll.
  ///
  /// Returns a `DynamiteRequest` backing the [createPoll] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [question] Question of the poll.
  ///   * [options] Options of the poll.
  ///   * [resultMode] Mode how the results will be shown.
  ///   * [maxVotes] Number of maximum votes per voter.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Poll created successfully
  ///   * 400: Creating poll is not possible
  ///
  /// See:
  ///  * [createPoll] for a method executing this request and parsing the response.
  ///  * [$createPoll_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $createPoll_Request({
    required String question,
    required BuiltList<String> options,
    required PollCreatePollResultMode resultMode,
    required int maxVotes,
    required String token,
    PollCreatePollApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $question = _$jsonSerializers.serialize(question, specifiedType: const FullType(String));
    _parameters['question'] = $question;

    final $options = _$jsonSerializers.serialize(options, specifiedType: const FullType(BuiltList, [FullType(String)]));
    _parameters['options%5B%5D'] = $options;

    final $resultMode =
        _$jsonSerializers.serialize(resultMode, specifiedType: const FullType(PollCreatePollResultMode));
    _parameters['resultMode'] = $resultMode;

    final $maxVotes = _$jsonSerializers.serialize(maxVotes, specifiedType: const FullType(int));
    _parameters['maxVotes'] = $maxVotes;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(PollCreatePollApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/poll/{token}{?question*,options%5B%5D*,resultMode*,maxVotes*}',
    ).expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Create a poll.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [question] Question of the poll.
  ///   * [options] Options of the poll.
  ///   * [resultMode] Mode how the results will be shown.
  ///   * [maxVotes] Number of maximum votes per voter.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Poll created successfully
  ///   * 400: Creating poll is not possible
  ///
  /// See:
  ///  * [$createPoll_Request] for the request send by this method.
  ///  * [$createPoll_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<PollCreatePollResponseApplicationJson, void>> createPoll({
    required String question,
    required BuiltList<String> options,
    required PollCreatePollResultMode resultMode,
    required int maxVotes,
    required String token,
    PollCreatePollApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $createPoll_Request(
      question: question,
      options: options,
      resultMode: resultMode,
      maxVotes: maxVotes,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $createPoll_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<PollCreatePollResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$showPoll_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<PollShowPollResponseApplicationJson, void> $showPoll_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(PollShowPollResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get a poll.
  ///
  /// Returns a `DynamiteRequest` backing the [showPoll] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [pollId] ID of the poll.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Poll returned
  ///   * 404: Poll not found
  ///
  /// See:
  ///  * [showPoll] for a method executing this request and parsing the response.
  ///  * [$showPoll_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $showPoll_Request({
    required String token,
    required int pollId,
    PollShowPollApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $pollId = _$jsonSerializers.serialize(pollId, specifiedType: const FullType(int));
    _parameters['pollId'] = $pollId;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(PollShowPollApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/poll/{token}/{pollId}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get a poll.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [pollId] ID of the poll.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Poll returned
  ///   * 404: Poll not found
  ///
  /// See:
  ///  * [$showPoll_Request] for the request send by this method.
  ///  * [$showPoll_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<PollShowPollResponseApplicationJson, void>> showPoll({
    required String token,
    required int pollId,
    PollShowPollApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $showPoll_Request(
      token: token,
      pollId: pollId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $showPoll_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<PollShowPollResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$votePoll_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<PollVotePollResponseApplicationJson, void> $votePoll_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(PollVotePollResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Vote on a poll.
  ///
  /// Returns a `DynamiteRequest` backing the [votePoll] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [optionIds] IDs of the selected options. Defaults to `[]`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [pollId] ID of the poll.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Voted successfully
  ///   * 400: Voting is not possible
  ///   * 404: Poll not found
  ///
  /// See:
  ///  * [votePoll] for a method executing this request and parsing the response.
  ///  * [$votePoll_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $votePoll_Request({
    required String token,
    required int pollId,
    BuiltList<int>? optionIds,
    PollVotePollApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $pollId = _$jsonSerializers.serialize(pollId, specifiedType: const FullType(int));
    _parameters['pollId'] = $pollId;

    var $optionIds = _$jsonSerializers.serialize(optionIds, specifiedType: const FullType(BuiltList, [FullType(int)]));
    $optionIds ??= [];
    _parameters['optionIds%5B%5D'] = $optionIds;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(PollVotePollApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/poll/{token}/{pollId}{?optionIds%5B%5D*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Vote on a poll.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [optionIds] IDs of the selected options. Defaults to `[]`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [pollId] ID of the poll.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Voted successfully
  ///   * 400: Voting is not possible
  ///   * 404: Poll not found
  ///
  /// See:
  ///  * [$votePoll_Request] for the request send by this method.
  ///  * [$votePoll_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<PollVotePollResponseApplicationJson, void>> votePoll({
    required String token,
    required int pollId,
    BuiltList<int>? optionIds,
    PollVotePollApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $votePoll_Request(
      token: token,
      pollId: pollId,
      optionIds: optionIds,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $votePoll_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<PollVotePollResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$closePoll_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<PollClosePollResponseApplicationJson, void> $closePoll_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(PollClosePollResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Close a poll.
  ///
  /// Returns a `DynamiteRequest` backing the [closePoll] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [pollId] ID of the poll.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Poll closed successfully
  ///   * 400: Poll already closed
  ///   * 403: Missing permissions to close poll
  ///   * 404: Poll not found
  ///   * 500
  ///
  /// See:
  ///  * [closePoll] for a method executing this request and parsing the response.
  ///  * [$closePoll_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $closePoll_Request({
    required String token,
    required int pollId,
    PollClosePollApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $pollId = _$jsonSerializers.serialize(pollId, specifiedType: const FullType(int));
    _parameters['pollId'] = $pollId;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(PollClosePollApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/poll/{token}/{pollId}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Close a poll.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [pollId] ID of the poll.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Poll closed successfully
  ///   * 400: Poll already closed
  ///   * 403: Missing permissions to close poll
  ///   * 404: Poll not found
  ///   * 500
  ///
  /// See:
  ///  * [$closePoll_Request] for the request send by this method.
  ///  * [$closePoll_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<PollClosePollResponseApplicationJson, void>> closePoll({
    required String token,
    required int pollId,
    PollClosePollApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $closePoll_Request(
      token: token,
      pollId: pollId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $closePoll_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<PollClosePollResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $ReactionClient {
  /// Creates a new `DynamiteClient` for reaction requests.
  $ReactionClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$getReactions_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ReactionGetReactionsResponseApplicationJson, void> $getReactions_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(ReactionGetReactionsResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get a list of reactions for a message.
  ///
  /// Returns a `DynamiteRequest` backing the [getReactions] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [reaction] Emoji to filter.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reactions returned
  ///   * 404: Message or reaction not found
  ///
  /// See:
  ///  * [getReactions] for a method executing this request and parsing the response.
  ///  * [$getReactions_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getReactions_Request({
    required String token,
    required int messageId,
    String? reaction,
    ReactionGetReactionsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $messageId = _$jsonSerializers.serialize(messageId, specifiedType: const FullType(int));
    _parameters['messageId'] = $messageId;

    final $reaction = _$jsonSerializers.serialize(reaction, specifiedType: const FullType(String));
    _parameters['reaction'] = $reaction;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ReactionGetReactionsApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/reaction/{token}/{messageId}{?reaction*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get a list of reactions for a message.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [reaction] Emoji to filter.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reactions returned
  ///   * 404: Message or reaction not found
  ///
  /// See:
  ///  * [$getReactions_Request] for the request send by this method.
  ///  * [$getReactions_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ReactionGetReactionsResponseApplicationJson, void>> getReactions({
    required String token,
    required int messageId,
    String? reaction,
    ReactionGetReactionsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getReactions_Request(
      token: token,
      messageId: messageId,
      reaction: reaction,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getReactions_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<ReactionGetReactionsResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$react_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ReactionReactResponseApplicationJson, void> $react_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(ReactionReactResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 201},
      );

  /// Add a reaction to a message.
  ///
  /// Returns a `DynamiteRequest` backing the [react] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [reaction] Emoji to add.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reaction already existed
  ///   * 201: Reaction added successfully
  ///   * 400: Adding reaction is not possible
  ///   * 404: Message not found
  ///
  /// See:
  ///  * [react] for a method executing this request and parsing the response.
  ///  * [$react_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $react_Request({
    required String reaction,
    required String token,
    required int messageId,
    ReactionReactApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $reaction = _$jsonSerializers.serialize(reaction, specifiedType: const FullType(String));
    _parameters['reaction'] = $reaction;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $messageId = _$jsonSerializers.serialize(messageId, specifiedType: const FullType(int));
    _parameters['messageId'] = $messageId;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ReactionReactApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/reaction/{token}/{messageId}{?reaction*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Add a reaction to a message.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [reaction] Emoji to add.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reaction already existed
  ///   * 201: Reaction added successfully
  ///   * 400: Adding reaction is not possible
  ///   * 404: Message not found
  ///
  /// See:
  ///  * [$react_Request] for the request send by this method.
  ///  * [$react_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ReactionReactResponseApplicationJson, void>> react({
    required String reaction,
    required String token,
    required int messageId,
    ReactionReactApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $react_Request(
      reaction: reaction,
      token: token,
      messageId: messageId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $react_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<ReactionReactResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$delete_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<ReactionDeleteResponseApplicationJson, void> $delete_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(ReactionDeleteResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Delete a reaction from a message.
  ///
  /// Returns a `DynamiteRequest` backing the [delete] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [reaction] Emoji to remove.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reaction deleted successfully
  ///   * 400: Deleting reaction is not possible
  ///   * 404: Message not found
  ///
  /// See:
  ///  * [delete] for a method executing this request and parsing the response.
  ///  * [$delete_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $delete_Request({
    required String reaction,
    required String token,
    required int messageId,
    ReactionDeleteApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $reaction = _$jsonSerializers.serialize(reaction, specifiedType: const FullType(String));
    _parameters['reaction'] = $reaction;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $messageId = _$jsonSerializers.serialize(messageId, specifiedType: const FullType(int));
    _parameters['messageId'] = $messageId;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ReactionDeleteApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/reaction/{token}/{messageId}{?reaction*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Delete a reaction from a message.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [reaction] Emoji to remove.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reaction deleted successfully
  ///   * 400: Deleting reaction is not possible
  ///   * 404: Message not found
  ///
  /// See:
  ///  * [$delete_Request] for the request send by this method.
  ///  * [$delete_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<ReactionDeleteResponseApplicationJson, void>> delete({
    required String reaction,
    required String token,
    required int messageId,
    ReactionDeleteApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $delete_Request(
      reaction: reaction,
      token: token,
      messageId: messageId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $delete_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<ReactionDeleteResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $RecordingClient {
  /// Creates a new `DynamiteClient` for recording requests.
  $RecordingClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$start_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RecordingStartResponseApplicationJson, void> $start_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(RecordingStartResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Start the recording.
  ///
  /// Returns a `DynamiteRequest` backing the [start] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [status] Type of the recording.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Recording started successfully
  ///   * 400: Starting recording is not possible
  ///
  /// See:
  ///  * [start] for a method executing this request and parsing the response.
  ///  * [$start_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $start_Request({
    required int status,
    required String token,
    RecordingStartApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $status = _$jsonSerializers.serialize(status, specifiedType: const FullType(int));
    _parameters['status'] = $status;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RecordingStartApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/recording/{token}{?status*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Start the recording.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [status] Type of the recording.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Recording started successfully
  ///   * 400: Starting recording is not possible
  ///
  /// See:
  ///  * [$start_Request] for the request send by this method.
  ///  * [$start_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RecordingStartResponseApplicationJson, void>> start({
    required int status,
    required String token,
    RecordingStartApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $start_Request(
      status: status,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $start_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RecordingStartResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$stop_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RecordingStopResponseApplicationJson, void> $stop_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(RecordingStopResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Stop the recording.
  ///
  /// Returns a `DynamiteRequest` backing the [stop] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Recording stopped successfully
  ///   * 400: Stopping recording is not possible
  ///
  /// See:
  ///  * [stop] for a method executing this request and parsing the response.
  ///  * [$stop_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $stop_Request({
    required String token,
    RecordingStopApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RecordingStopApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/recording/{token}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Stop the recording.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Recording stopped successfully
  ///   * 400: Stopping recording is not possible
  ///
  /// See:
  ///  * [$stop_Request] for the request send by this method.
  ///  * [$stop_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RecordingStopResponseApplicationJson, void>> stop({
    required String token,
    RecordingStopApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $stop_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $stop_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RecordingStopResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$notificationDismiss_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RecordingNotificationDismissResponseApplicationJson, void> $notificationDismiss_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RecordingNotificationDismissResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Dismiss the store call recording notification.
  ///
  /// Returns a `DynamiteRequest` backing the [notificationDismiss] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [timestamp] Timestamp of the notification to be dismissed.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Notification dismissed successfully
  ///   * 400: Dismissing notification is not possible
  ///
  /// See:
  ///  * [notificationDismiss] for a method executing this request and parsing the response.
  ///  * [$notificationDismiss_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $notificationDismiss_Request({
    required int timestamp,
    required String token,
    RecordingNotificationDismissApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $timestamp = _$jsonSerializers.serialize(timestamp, specifiedType: const FullType(int));
    _parameters['timestamp'] = $timestamp;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RecordingNotificationDismissApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/recording/{token}/notification{?timestamp*}')
            .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Dismiss the store call recording notification.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [timestamp] Timestamp of the notification to be dismissed.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Notification dismissed successfully
  ///   * 400: Dismissing notification is not possible
  ///
  /// See:
  ///  * [$notificationDismiss_Request] for the request send by this method.
  ///  * [$notificationDismiss_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RecordingNotificationDismissResponseApplicationJson, void>> notificationDismiss({
    required int timestamp,
    required String token,
    RecordingNotificationDismissApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $notificationDismiss_Request(
      timestamp: timestamp,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $notificationDismiss_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RecordingNotificationDismissResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$shareToChat_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RecordingShareToChatResponseApplicationJson, void> $shareToChat_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RecordingShareToChatResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Share the recorded file to the chat.
  ///
  /// Returns a `DynamiteRequest` backing the [shareToChat] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [fileId] ID of the file.
  ///   * [timestamp] Timestamp of the notification to be dismissed.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Recording shared to chat successfully
  ///   * 400: Sharing recording to chat is not possible
  ///
  /// See:
  ///  * [shareToChat] for a method executing this request and parsing the response.
  ///  * [$shareToChat_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $shareToChat_Request({
    required int fileId,
    required int timestamp,
    required String token,
    RecordingShareToChatApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $fileId = _$jsonSerializers.serialize(fileId, specifiedType: const FullType(int));
    _parameters['fileId'] = $fileId;

    final $timestamp = _$jsonSerializers.serialize(timestamp, specifiedType: const FullType(int));
    _parameters['timestamp'] = $timestamp;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RecordingShareToChatApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/recording/{token}/share-chat{?fileId*,timestamp*}')
            .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Share the recorded file to the chat.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [fileId] ID of the file.
  ///   * [timestamp] Timestamp of the notification to be dismissed.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Recording shared to chat successfully
  ///   * 400: Sharing recording to chat is not possible
  ///
  /// See:
  ///  * [$shareToChat_Request] for the request send by this method.
  ///  * [$shareToChat_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RecordingShareToChatResponseApplicationJson, void>> shareToChat({
    required int fileId,
    required int timestamp,
    required String token,
    RecordingShareToChatApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $shareToChat_Request(
      fileId: fileId,
      timestamp: timestamp,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $shareToChat_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RecordingShareToChatResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$backend_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RecordingBackendResponseApplicationJson, void> $backend_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(RecordingBackendResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Update the recording status as a backend.
  ///
  /// Returns a `DynamiteRequest` backing the [backend] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Recording status updated successfully
  ///   * 400: Updating recording status is not possible
  ///   * 403: Missing permissions to update recording status
  ///   * 404: Room not found
  ///
  /// See:
  ///  * [backend] for a method executing this request and parsing the response.
  ///  * [$backend_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $backend_Request({
    RecordingBackendApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RecordingBackendApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/recording/backend').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Update the recording status as a backend.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Recording status updated successfully
  ///   * 400: Updating recording status is not possible
  ///   * 403: Missing permissions to update recording status
  ///   * 404: Room not found
  ///
  /// See:
  ///  * [$backend_Request] for the request send by this method.
  ///  * [$backend_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RecordingBackendResponseApplicationJson, void>> backend({
    RecordingBackendApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $backend_Request(
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $backend_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RecordingBackendResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$store_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RecordingStoreResponseApplicationJson, void> $store_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(RecordingStoreResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Store the recording.
  ///
  /// Returns a `DynamiteRequest` backing the [store] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [owner] User that will own the recording file.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Recording stored successfully
  ///   * 400: Storing recording is not possible
  ///   * 401: Missing permissions to store recording
  ///
  /// See:
  ///  * [store] for a method executing this request and parsing the response.
  ///  * [$store_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $store_Request({
    required String owner,
    required String token,
    RecordingStoreApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $owner = _$jsonSerializers.serialize(owner, specifiedType: const FullType(String));
    _parameters['owner'] = $owner;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RecordingStoreApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/recording/{token}/store{?owner*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Store the recording.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [owner] User that will own the recording file.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Recording stored successfully
  ///   * 400: Storing recording is not possible
  ///   * 401: Missing permissions to store recording
  ///
  /// See:
  ///  * [$store_Request] for the request send by this method.
  ///  * [$store_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RecordingStoreResponseApplicationJson, void>> store({
    required String owner,
    required String token,
    RecordingStoreApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $store_Request(
      owner: owner,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $store_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RecordingStoreResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $RoomClient {
  /// Creates a new `DynamiteClient` for room requests.
  $RoomClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$getRooms_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomGetRoomsResponseApplicationJson, RoomRoomGetRoomsHeaders> $getRooms_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RoomGetRoomsResponseApplicationJson),
        headersType: const FullType(RoomRoomGetRoomsHeaders),
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get all currently existent rooms which the user has joined.
  ///
  /// Returns a `DynamiteRequest` backing the [getRooms] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [noStatusUpdate] When the user status should not be automatically set to online set to 1 (default 0). Defaults to `0`.
  ///   * [includeStatus] Include the user status. Defaults to `0`.
  ///   * [modifiedSince] Filter rooms modified after a timestamp. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Return list of rooms
  ///
  /// See:
  ///  * [getRooms] for a method executing this request and parsing the response.
  ///  * [$getRooms_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getRooms_Request({
    RoomGetRoomsNoStatusUpdate? noStatusUpdate,
    RoomGetRoomsIncludeStatus? includeStatus,
    int? modifiedSince,
    RoomGetRoomsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    var $noStatusUpdate =
        _$jsonSerializers.serialize(noStatusUpdate, specifiedType: const FullType(RoomGetRoomsNoStatusUpdate));
    $noStatusUpdate ??= 0;
    _parameters['noStatusUpdate'] = $noStatusUpdate;

    var $includeStatus =
        _$jsonSerializers.serialize(includeStatus, specifiedType: const FullType(RoomGetRoomsIncludeStatus));
    $includeStatus ??= 0;
    _parameters['includeStatus'] = $includeStatus;

    var $modifiedSince = _$jsonSerializers.serialize(modifiedSince, specifiedType: const FullType(int));
    $modifiedSince ??= 0;
    _parameters['modifiedSince'] = $modifiedSince;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomGetRoomsApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room{?noStatusUpdate*,includeStatus*,modifiedSince*}')
            .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get all currently existent rooms which the user has joined.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [noStatusUpdate] When the user status should not be automatically set to online set to 1 (default 0). Defaults to `0`.
  ///   * [includeStatus] Include the user status. Defaults to `0`.
  ///   * [modifiedSince] Filter rooms modified after a timestamp. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Return list of rooms
  ///
  /// See:
  ///  * [$getRooms_Request] for the request send by this method.
  ///  * [$getRooms_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomGetRoomsResponseApplicationJson, RoomRoomGetRoomsHeaders>> getRooms({
    RoomGetRoomsNoStatusUpdate? noStatusUpdate,
    RoomGetRoomsIncludeStatus? includeStatus,
    int? modifiedSince,
    RoomGetRoomsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getRooms_Request(
      noStatusUpdate: noStatusUpdate,
      includeStatus: includeStatus,
      modifiedSince: modifiedSince,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getRooms_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomGetRoomsResponseApplicationJson, RoomRoomGetRoomsHeaders>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$createRoom_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomCreateRoomResponseApplicationJson, void> $createRoom_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RoomCreateRoomResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 201},
      );

  /// Create a room with a user, a group or a circle.
  ///
  /// Returns a `DynamiteRequest` backing the [createRoom] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [roomType] Type of the room.
  ///   * [invite] User, group, … ID to invite. Defaults to `''`.
  ///   * [roomName] Name of the room. Defaults to `''`.
  ///   * [source] Source of the invite ID ('circles' to create a room with a circle, etc.). Defaults to `''`.
  ///   * [objectType] Type of the object. Defaults to `''`.
  ///   * [objectId] ID of the object. Defaults to `''`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room already existed
  ///   * 201: Room created successfully
  ///   * 400: Room type invalid
  ///   * 403: Missing permissions to create room
  ///   * 404: User, group or other target to invite was not found
  ///
  /// See:
  ///  * [createRoom] for a method executing this request and parsing the response.
  ///  * [$createRoom_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $createRoom_Request({
    required int roomType,
    String? invite,
    String? roomName,
    String? source,
    String? objectType,
    String? objectId,
    RoomCreateRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $roomType = _$jsonSerializers.serialize(roomType, specifiedType: const FullType(int));
    _parameters['roomType'] = $roomType;

    var $invite = _$jsonSerializers.serialize(invite, specifiedType: const FullType(String));
    $invite ??= '';
    _parameters['invite'] = $invite;

    var $roomName = _$jsonSerializers.serialize(roomName, specifiedType: const FullType(String));
    $roomName ??= '';
    _parameters['roomName'] = $roomName;

    var $source = _$jsonSerializers.serialize(source, specifiedType: const FullType(String));
    $source ??= '';
    _parameters['source'] = $source;

    var $objectType = _$jsonSerializers.serialize(objectType, specifiedType: const FullType(String));
    $objectType ??= '';
    _parameters['objectType'] = $objectType;

    var $objectId = _$jsonSerializers.serialize(objectId, specifiedType: const FullType(String));
    $objectId ??= '';
    _parameters['objectId'] = $objectId;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomCreateRoomApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/room{?roomType*,invite*,roomName*,source*,objectType*,objectId*}',
    ).expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Create a room with a user, a group or a circle.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [roomType] Type of the room.
  ///   * [invite] User, group, … ID to invite. Defaults to `''`.
  ///   * [roomName] Name of the room. Defaults to `''`.
  ///   * [source] Source of the invite ID ('circles' to create a room with a circle, etc.). Defaults to `''`.
  ///   * [objectType] Type of the object. Defaults to `''`.
  ///   * [objectId] ID of the object. Defaults to `''`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room already existed
  ///   * 201: Room created successfully
  ///   * 400: Room type invalid
  ///   * 403: Missing permissions to create room
  ///   * 404: User, group or other target to invite was not found
  ///
  /// See:
  ///  * [$createRoom_Request] for the request send by this method.
  ///  * [$createRoom_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomCreateRoomResponseApplicationJson, void>> createRoom({
    required int roomType,
    String? invite,
    String? roomName,
    String? source,
    String? objectType,
    String? objectId,
    RoomCreateRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $createRoom_Request(
      roomType: roomType,
      invite: invite,
      roomName: roomName,
      source: source,
      objectType: objectType,
      objectId: objectId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $createRoom_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomCreateRoomResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$getListedRooms_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomGetListedRoomsResponseApplicationJson, void> $getListedRooms_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RoomGetListedRoomsResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get listed rooms with optional search term.
  ///
  /// Returns a `DynamiteRequest` backing the [getListedRooms] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [searchTerm] search term. Defaults to `''`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Return list of matching rooms
  ///
  /// See:
  ///  * [getListedRooms] for a method executing this request and parsing the response.
  ///  * [$getListedRooms_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getListedRooms_Request({
    String? searchTerm,
    RoomGetListedRoomsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    var $searchTerm = _$jsonSerializers.serialize(searchTerm, specifiedType: const FullType(String));
    $searchTerm ??= '';
    _parameters['searchTerm'] = $searchTerm;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomGetListedRoomsApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/listed-room{?searchTerm*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get listed rooms with optional search term.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [searchTerm] search term. Defaults to `''`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Return list of matching rooms
  ///
  /// See:
  ///  * [$getListedRooms_Request] for the request send by this method.
  ///  * [$getListedRooms_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomGetListedRoomsResponseApplicationJson, void>> getListedRooms({
    String? searchTerm,
    RoomGetListedRoomsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getListedRooms_Request(
      searchTerm: searchTerm,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getListedRooms_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomGetListedRoomsResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$getNoteToSelfConversation_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomGetNoteToSelfConversationResponseApplicationJson, RoomRoomGetNoteToSelfConversationHeaders>
      $getNoteToSelfConversation_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(RoomGetNoteToSelfConversationResponseApplicationJson),
            headersType: const FullType(RoomRoomGetNoteToSelfConversationHeaders),
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Get the "Note to self" conversation for the user.
  ///
  /// It will be automatically created when it is currently missing.
  ///
  /// Returns a `DynamiteRequest` backing the [getNoteToSelfConversation] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room returned successfully
  ///
  /// See:
  ///  * [getNoteToSelfConversation] for a method executing this request and parsing the response.
  ///  * [$getNoteToSelfConversation_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getNoteToSelfConversation_Request({
    RoomGetNoteToSelfConversationApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomGetNoteToSelfConversationApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/note-to-self').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get the "Note to self" conversation for the user.
  ///
  /// It will be automatically created when it is currently missing.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room returned successfully
  ///
  /// See:
  ///  * [$getNoteToSelfConversation_Request] for the request send by this method.
  ///  * [$getNoteToSelfConversation_Serializer] for a converter to parse the `Response` from an executed request.
  Future<
      _i1.DynamiteResponse<RoomGetNoteToSelfConversationResponseApplicationJson,
          RoomRoomGetNoteToSelfConversationHeaders>> getNoteToSelfConversation({
    RoomGetNoteToSelfConversationApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getNoteToSelfConversation_Request(
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getNoteToSelfConversation_Serializer();
    final _rawResponse = await _i1.ResponseConverter<RoomGetNoteToSelfConversationResponseApplicationJson,
            RoomRoomGetNoteToSelfConversationHeaders>(_serializer)
        .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$getSingleRoom_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomGetSingleRoomResponseApplicationJson, RoomRoomGetSingleRoomHeaders>
      $getSingleRoom_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(RoomGetSingleRoomResponseApplicationJson),
            headersType: const FullType(RoomRoomGetSingleRoomHeaders),
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Get a room.
  ///
  /// Returns a `DynamiteRequest` backing the [getSingleRoom] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token] Token of the room.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room returned
  ///   * 401: SIP request invalid
  ///   * 404: Room not found
  ///
  /// See:
  ///  * [getSingleRoom] for a method executing this request and parsing the response.
  ///  * [$getSingleRoom_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getSingleRoom_Request({
    required String token,
    RoomGetSingleRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomGetSingleRoomApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get a room.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token] Token of the room.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room returned
  ///   * 401: SIP request invalid
  ///   * 404: Room not found
  ///
  /// See:
  ///  * [$getSingleRoom_Request] for the request send by this method.
  ///  * [$getSingleRoom_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomGetSingleRoomResponseApplicationJson, RoomRoomGetSingleRoomHeaders>> getSingleRoom({
    required String token,
    RoomGetSingleRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getSingleRoom_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getSingleRoom_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomGetSingleRoomResponseApplicationJson, RoomRoomGetSingleRoomHeaders>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$getBreakoutRooms_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomGetBreakoutRoomsResponseApplicationJson, void> $getBreakoutRooms_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RoomGetBreakoutRoomsResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Get breakout rooms.
  ///
  /// All for moderators and in case of "free selection", or the assigned breakout room for other participants.
  ///
  /// Returns a `DynamiteRequest` backing the [getBreakoutRooms] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Breakout rooms returned
  ///   * 400: Getting breakout rooms is not possible
  ///
  /// See:
  ///  * [getBreakoutRooms] for a method executing this request and parsing the response.
  ///  * [$getBreakoutRooms_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getBreakoutRooms_Request({
    required String token,
    RoomGetBreakoutRoomsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomGetBreakoutRoomsApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/breakout-rooms').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get breakout rooms.
  ///
  /// All for moderators and in case of "free selection", or the assigned breakout room for other participants.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Breakout rooms returned
  ///   * 400: Getting breakout rooms is not possible
  ///
  /// See:
  ///  * [$getBreakoutRooms_Request] for the request send by this method.
  ///  * [$getBreakoutRooms_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomGetBreakoutRoomsResponseApplicationJson, void>> getBreakoutRooms({
    required String token,
    RoomGetBreakoutRoomsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getBreakoutRooms_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getBreakoutRooms_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomGetBreakoutRoomsResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$makePublic_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomMakePublicResponseApplicationJson, void> $makePublic_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RoomMakePublicResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 400},
      );

  /// Allowed guests to join conversation.
  ///
  /// Returns a `DynamiteRequest` backing the [makePublic] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Allowed guests successfully
  ///   * 400: Allowing guests is not possible
  ///
  /// See:
  ///  * [makePublic] for a method executing this request and parsing the response.
  ///  * [$makePublic_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $makePublic_Request({
    required String token,
    RoomMakePublicApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomMakePublicApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/public').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Allowed guests to join conversation.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Allowed guests successfully
  ///   * 400: Allowing guests is not possible
  ///
  /// See:
  ///  * [$makePublic_Request] for the request send by this method.
  ///  * [$makePublic_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomMakePublicResponseApplicationJson, void>> makePublic({
    required String token,
    RoomMakePublicApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $makePublic_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $makePublic_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomMakePublicResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$makePrivate_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomMakePrivateResponseApplicationJson, void> $makePrivate_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RoomMakePrivateResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 400},
      );

  /// Disallowed guests to join conversation.
  ///
  /// Returns a `DynamiteRequest` backing the [makePrivate] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room unpublished Disallowing guests successfully
  ///   * 400: Disallowing guests is not possible
  ///
  /// See:
  ///  * [makePrivate] for a method executing this request and parsing the response.
  ///  * [$makePrivate_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $makePrivate_Request({
    required String token,
    RoomMakePrivateApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomMakePrivateApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/public').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Disallowed guests to join conversation.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room unpublished Disallowing guests successfully
  ///   * 400: Disallowing guests is not possible
  ///
  /// See:
  ///  * [$makePrivate_Request] for the request send by this method.
  ///  * [$makePrivate_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomMakePrivateResponseApplicationJson, void>> makePrivate({
    required String token,
    RoomMakePrivateApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $makePrivate_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $makePrivate_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomMakePrivateResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$setDescription_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomSetDescriptionResponseApplicationJson, void> $setDescription_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RoomSetDescriptionResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 400},
      );

  /// Update the description of a room.
  ///
  /// Returns a `DynamiteRequest` backing the [setDescription] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [description] New description.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Description updated successfully
  ///   * 400: Updating description is not possible
  ///
  /// See:
  ///  * [setDescription] for a method executing this request and parsing the response.
  ///  * [$setDescription_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $setDescription_Request({
    required String description,
    required String token,
    RoomSetDescriptionApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $description = _$jsonSerializers.serialize(description, specifiedType: const FullType(String));
    _parameters['description'] = $description;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomSetDescriptionApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/description{?description*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('put', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Update the description of a room.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [description] New description.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Description updated successfully
  ///   * 400: Updating description is not possible
  ///
  /// See:
  ///  * [$setDescription_Request] for the request send by this method.
  ///  * [$setDescription_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomSetDescriptionResponseApplicationJson, void>> setDescription({
    required String description,
    required String token,
    RoomSetDescriptionApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $setDescription_Request(
      description: description,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $setDescription_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomSetDescriptionResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$setReadOnly_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomSetReadOnlyResponseApplicationJson, void> $setReadOnly_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RoomSetReadOnlyResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 400},
      );

  /// Set read-only state of a room.
  ///
  /// Returns a `DynamiteRequest` backing the [setReadOnly] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [state] New read-only state.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Read-only state updated successfully
  ///   * 400: Updating read-only state is not possible
  ///
  /// See:
  ///  * [setReadOnly] for a method executing this request and parsing the response.
  ///  * [$setReadOnly_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $setReadOnly_Request({
    required RoomSetReadOnlyState state,
    required String token,
    RoomSetReadOnlyApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $state = _$jsonSerializers.serialize(state, specifiedType: const FullType(RoomSetReadOnlyState));
    _parameters['state'] = $state;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomSetReadOnlyApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/read-only{?state*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('put', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Set read-only state of a room.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [state] New read-only state.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Read-only state updated successfully
  ///   * 400: Updating read-only state is not possible
  ///
  /// See:
  ///  * [$setReadOnly_Request] for the request send by this method.
  ///  * [$setReadOnly_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomSetReadOnlyResponseApplicationJson, void>> setReadOnly({
    required RoomSetReadOnlyState state,
    required String token,
    RoomSetReadOnlyApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $setReadOnly_Request(
      state: state,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $setReadOnly_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomSetReadOnlyResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$setListable_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomSetListableResponseApplicationJson, void> $setListable_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RoomSetListableResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 400},
      );

  /// Make a room listable.
  ///
  /// Returns a `DynamiteRequest` backing the [setListable] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [scope] Scope where the room is listable.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Made room listable successfully
  ///   * 400: Making room listable is not possible
  ///
  /// See:
  ///  * [setListable] for a method executing this request and parsing the response.
  ///  * [$setListable_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $setListable_Request({
    required RoomSetListableScope scope,
    required String token,
    RoomSetListableApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $scope = _$jsonSerializers.serialize(scope, specifiedType: const FullType(RoomSetListableScope));
    _parameters['scope'] = $scope;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomSetListableApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/listable{?scope*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('put', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Make a room listable.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [scope] Scope where the room is listable.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Made room listable successfully
  ///   * 400: Making room listable is not possible
  ///
  /// See:
  ///  * [$setListable_Request] for the request send by this method.
  ///  * [$setListable_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomSetListableResponseApplicationJson, void>> setListable({
    required RoomSetListableScope scope,
    required String token,
    RoomSetListableApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $setListable_Request(
      scope: scope,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $setListable_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomSetListableResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$setPassword_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomSetPasswordResponseApplicationJson, void> $setPassword_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RoomSetPasswordResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 403},
      );

  /// Set a password for a room.
  ///
  /// Returns a `DynamiteRequest` backing the [setPassword] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [password] New password.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Password set successfully
  ///   * 403: Setting password is not allowed
  ///   * 400: Setting password is not possible
  ///
  /// See:
  ///  * [setPassword] for a method executing this request and parsing the response.
  ///  * [$setPassword_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $setPassword_Request({
    required String password,
    required String token,
    RoomSetPasswordApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $password = _$jsonSerializers.serialize(password, specifiedType: const FullType(String));
    _parameters['password'] = $password;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomSetPasswordApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/password{?password*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('put', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Set a password for a room.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [password] New password.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Password set successfully
  ///   * 403: Setting password is not allowed
  ///   * 400: Setting password is not possible
  ///
  /// See:
  ///  * [$setPassword_Request] for the request send by this method.
  ///  * [$setPassword_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomSetPasswordResponseApplicationJson, void>> setPassword({
    required String password,
    required String token,
    RoomSetPasswordApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $setPassword_Request(
      password: password,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $setPassword_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomSetPasswordResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$setPermissions_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomSetPermissionsResponseApplicationJson, void> $setPermissions_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RoomSetPermissionsResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Update the permissions of a room.
  ///
  /// Returns a `DynamiteRequest` backing the [setPermissions] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [permissions] New permissions.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [mode] Level of the permissions ('call', 'default').
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Permissions updated successfully
  ///   * 400: Updating permissions is not possible
  ///
  /// See:
  ///  * [setPermissions] for a method executing this request and parsing the response.
  ///  * [$setPermissions_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $setPermissions_Request({
    required int permissions,
    required String token,
    required RoomSetPermissionsMode mode,
    RoomSetPermissionsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $permissions = _$jsonSerializers.serialize(permissions, specifiedType: const FullType(int));
    _parameters['permissions'] = $permissions;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $mode = _$jsonSerializers.serialize(mode, specifiedType: const FullType(RoomSetPermissionsMode));
    _i4.checkPattern(
      $mode as String?,
      RegExp(r'^(call|default)$'),
      'mode',
    );
    _parameters['mode'] = $mode;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomSetPermissionsApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/permissions/{mode}{?permissions*}')
            .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('put', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Update the permissions of a room.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [permissions] New permissions.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [mode] Level of the permissions ('call', 'default').
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Permissions updated successfully
  ///   * 400: Updating permissions is not possible
  ///
  /// See:
  ///  * [$setPermissions_Request] for the request send by this method.
  ///  * [$setPermissions_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomSetPermissionsResponseApplicationJson, void>> setPermissions({
    required int permissions,
    required String token,
    required RoomSetPermissionsMode mode,
    RoomSetPermissionsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $setPermissions_Request(
      permissions: permissions,
      token: token,
      mode: mode,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $setPermissions_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomSetPermissionsResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$getParticipants_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomGetParticipantsResponseApplicationJson, RoomRoomGetParticipantsHeaders>
      $getParticipants_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(RoomGetParticipantsResponseApplicationJson),
            headersType: const FullType(RoomRoomGetParticipantsHeaders),
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Get a list of participants for a room.
  ///
  /// Returns a `DynamiteRequest` backing the [getParticipants] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [includeStatus] Include the user statuses. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Participants returned
  ///   * 403: Missing permissions for getting participants
  ///
  /// See:
  ///  * [getParticipants] for a method executing this request and parsing the response.
  ///  * [$getParticipants_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getParticipants_Request({
    required String token,
    RoomGetParticipantsIncludeStatus? includeStatus,
    RoomGetParticipantsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $includeStatus =
        _$jsonSerializers.serialize(includeStatus, specifiedType: const FullType(RoomGetParticipantsIncludeStatus));
    $includeStatus ??= 0;
    _parameters['includeStatus'] = $includeStatus;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomGetParticipantsApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/participants{?includeStatus*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get a list of participants for a room.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [includeStatus] Include the user statuses. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Participants returned
  ///   * 403: Missing permissions for getting participants
  ///
  /// See:
  ///  * [$getParticipants_Request] for the request send by this method.
  ///  * [$getParticipants_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomGetParticipantsResponseApplicationJson, RoomRoomGetParticipantsHeaders>>
      getParticipants({
    required String token,
    RoomGetParticipantsIncludeStatus? includeStatus,
    RoomGetParticipantsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getParticipants_Request(
      token: token,
      includeStatus: includeStatus,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getParticipants_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomGetParticipantsResponseApplicationJson, RoomRoomGetParticipantsHeaders>(
      _serializer,
    ).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$addParticipantToRoom_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomAddParticipantToRoomResponseApplicationJson, void> $addParticipantToRoom_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RoomAddParticipantToRoomResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Add a participant to a room.
  ///
  /// Returns a `DynamiteRequest` backing the [addParticipantToRoom] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [newParticipant] New participant.
  ///   * [source] Source of the participant. Defaults to `users`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Participant successfully added
  ///   * 404: User, group or other target to invite was not found
  ///   * 501: SIP dial-out is not configured
  ///   * 400: Adding participant is not possible
  ///
  /// See:
  ///  * [addParticipantToRoom] for a method executing this request and parsing the response.
  ///  * [$addParticipantToRoom_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $addParticipantToRoom_Request({
    required String newParticipant,
    required String token,
    RoomAddParticipantToRoomSource? source,
    RoomAddParticipantToRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $newParticipant = _$jsonSerializers.serialize(newParticipant, specifiedType: const FullType(String));
    _parameters['newParticipant'] = $newParticipant;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $source = _$jsonSerializers.serialize(source, specifiedType: const FullType(RoomAddParticipantToRoomSource));
    $source ??= 'users';
    _parameters['source'] = $source;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomAddParticipantToRoomApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/participants{?newParticipant*,source*}')
            .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Add a participant to a room.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [newParticipant] New participant.
  ///   * [source] Source of the participant. Defaults to `users`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Participant successfully added
  ///   * 404: User, group or other target to invite was not found
  ///   * 501: SIP dial-out is not configured
  ///   * 400: Adding participant is not possible
  ///
  /// See:
  ///  * [$addParticipantToRoom_Request] for the request send by this method.
  ///  * [$addParticipantToRoom_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomAddParticipantToRoomResponseApplicationJson, void>> addParticipantToRoom({
    required String newParticipant,
    required String token,
    RoomAddParticipantToRoomSource? source,
    RoomAddParticipantToRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $addParticipantToRoom_Request(
      newParticipant: newParticipant,
      token: token,
      source: source,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $addParticipantToRoom_Serializer();
    final _rawResponse = await _i1.ResponseConverter<RoomAddParticipantToRoomResponseApplicationJson, void>(_serializer)
        .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$getBreakoutRoomParticipants_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<
          RoomGetBreakoutRoomParticipantsResponseApplicationJson, RoomRoomGetBreakoutRoomParticipantsHeaders>
      $getBreakoutRoomParticipants_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(RoomGetBreakoutRoomParticipantsResponseApplicationJson),
            headersType: const FullType(RoomRoomGetBreakoutRoomParticipantsHeaders),
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Get the breakout room participants for a room.
  ///
  /// Returns a `DynamiteRequest` backing the [getBreakoutRoomParticipants] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [includeStatus] Include the user statuses. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Breakout room participants returned
  ///   * 400: Getting breakout room participants is not possible
  ///   * 403: Missing permissions to get breakout room participants
  ///
  /// See:
  ///  * [getBreakoutRoomParticipants] for a method executing this request and parsing the response.
  ///  * [$getBreakoutRoomParticipants_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getBreakoutRoomParticipants_Request({
    required String token,
    RoomGetBreakoutRoomParticipantsIncludeStatus? includeStatus,
    RoomGetBreakoutRoomParticipantsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $includeStatus = _$jsonSerializers.serialize(
      includeStatus,
      specifiedType: const FullType(RoomGetBreakoutRoomParticipantsIncludeStatus),
    );
    $includeStatus ??= 0;
    _parameters['includeStatus'] = $includeStatus;

    var $apiVersion = _$jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(RoomGetBreakoutRoomParticipantsApiVersion),
    );
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/breakout-rooms/participants{?includeStatus*}',
    ).expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get the breakout room participants for a room.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [includeStatus] Include the user statuses. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Breakout room participants returned
  ///   * 400: Getting breakout room participants is not possible
  ///   * 403: Missing permissions to get breakout room participants
  ///
  /// See:
  ///  * [$getBreakoutRoomParticipants_Request] for the request send by this method.
  ///  * [$getBreakoutRoomParticipants_Serializer] for a converter to parse the `Response` from an executed request.
  Future<
      _i1.DynamiteResponse<RoomGetBreakoutRoomParticipantsResponseApplicationJson,
          RoomRoomGetBreakoutRoomParticipantsHeaders>> getBreakoutRoomParticipants({
    required String token,
    RoomGetBreakoutRoomParticipantsIncludeStatus? includeStatus,
    RoomGetBreakoutRoomParticipantsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getBreakoutRoomParticipants_Request(
      token: token,
      includeStatus: includeStatus,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getBreakoutRoomParticipants_Serializer();
    final _rawResponse = await _i1.ResponseConverter<RoomGetBreakoutRoomParticipantsResponseApplicationJson,
            RoomRoomGetBreakoutRoomParticipantsHeaders>(_serializer)
        .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$removeSelfFromRoom_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomRemoveSelfFromRoomResponseApplicationJson, void> $removeSelfFromRoom_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RoomRemoveSelfFromRoomResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 400, 404},
      );

  /// Remove the current user from a room.
  ///
  /// Returns a `DynamiteRequest` backing the [removeSelfFromRoom] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Participant removed successfully
  ///   * 400: Removing participant is not possible
  ///   * 404: Participant not found
  ///
  /// See:
  ///  * [removeSelfFromRoom] for a method executing this request and parsing the response.
  ///  * [$removeSelfFromRoom_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $removeSelfFromRoom_Request({
    required String token,
    RoomRemoveSelfFromRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomRemoveSelfFromRoomApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/participants/self').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Remove the current user from a room.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Participant removed successfully
  ///   * 400: Removing participant is not possible
  ///   * 404: Participant not found
  ///
  /// See:
  ///  * [$removeSelfFromRoom_Request] for the request send by this method.
  ///  * [$removeSelfFromRoom_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomRemoveSelfFromRoomResponseApplicationJson, void>> removeSelfFromRoom({
    required String token,
    RoomRemoveSelfFromRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $removeSelfFromRoom_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $removeSelfFromRoom_Serializer();
    final _rawResponse = await _i1.ResponseConverter<RoomRemoveSelfFromRoomResponseApplicationJson, void>(_serializer)
        .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$removeAttendeeFromRoom_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomRemoveAttendeeFromRoomResponseApplicationJson, void>
      $removeAttendeeFromRoom_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(RoomRemoveAttendeeFromRoomResponseApplicationJson),
            headersType: null,
            serializers: _$jsonSerializers,
            validStatuses: const {200, 400, 403, 404},
          );

  /// Remove an attendee from a room.
  ///
  /// Returns a `DynamiteRequest` backing the [removeAttendeeFromRoom] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [attendeeId] ID of the attendee.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Attendee removed successfully
  ///   * 400: Removing attendee is not possible
  ///   * 403: Removing attendee is not allowed
  ///   * 404: Attendee not found
  ///
  /// See:
  ///  * [removeAttendeeFromRoom] for a method executing this request and parsing the response.
  ///  * [$removeAttendeeFromRoom_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $removeAttendeeFromRoom_Request({
    required int attendeeId,
    required String token,
    RoomRemoveAttendeeFromRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $attendeeId = _$jsonSerializers.serialize(attendeeId, specifiedType: const FullType(int));
    _parameters['attendeeId'] = $attendeeId;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomRemoveAttendeeFromRoomApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/attendees{?attendeeId*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Remove an attendee from a room.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [attendeeId] ID of the attendee.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Attendee removed successfully
  ///   * 400: Removing attendee is not possible
  ///   * 403: Removing attendee is not allowed
  ///   * 404: Attendee not found
  ///
  /// See:
  ///  * [$removeAttendeeFromRoom_Request] for the request send by this method.
  ///  * [$removeAttendeeFromRoom_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomRemoveAttendeeFromRoomResponseApplicationJson, void>> removeAttendeeFromRoom({
    required int attendeeId,
    required String token,
    RoomRemoveAttendeeFromRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $removeAttendeeFromRoom_Request(
      attendeeId: attendeeId,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $removeAttendeeFromRoom_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomRemoveAttendeeFromRoomResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$setAttendeePermissions_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomSetAttendeePermissionsResponseApplicationJson, void>
      $setAttendeePermissions_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(RoomSetAttendeePermissionsResponseApplicationJson),
            headersType: null,
            serializers: _$jsonSerializers,
            validStatuses: const {200, 400, 403, 404},
          );

  /// Update the permissions of an attendee.
  ///
  /// Returns a `DynamiteRequest` backing the [setAttendeePermissions] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [attendeeId] ID of the attendee.
  ///   * [method] Method of updating permissions ('set', 'remove', 'add').
  ///   * [permissions] New permissions.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Permissions updated successfully
  ///   * 400: Updating permissions is not possible
  ///   * 403: Missing permissions to update permissions
  ///   * 404: Attendee not found
  ///
  /// See:
  ///  * [setAttendeePermissions] for a method executing this request and parsing the response.
  ///  * [$setAttendeePermissions_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $setAttendeePermissions_Request({
    required int attendeeId,
    required RoomSetAttendeePermissionsMethod method,
    required int permissions,
    required String token,
    RoomSetAttendeePermissionsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $attendeeId = _$jsonSerializers.serialize(attendeeId, specifiedType: const FullType(int));
    _parameters['attendeeId'] = $attendeeId;

    final $method =
        _$jsonSerializers.serialize(method, specifiedType: const FullType(RoomSetAttendeePermissionsMethod));
    _parameters['method'] = $method;

    final $permissions = _$jsonSerializers.serialize(permissions, specifiedType: const FullType(int));
    _parameters['permissions'] = $permissions;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomSetAttendeePermissionsApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/attendees/permissions{?attendeeId*,method*,permissions*}',
    ).expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('put', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Update the permissions of an attendee.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [attendeeId] ID of the attendee.
  ///   * [method] Method of updating permissions ('set', 'remove', 'add').
  ///   * [permissions] New permissions.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Permissions updated successfully
  ///   * 400: Updating permissions is not possible
  ///   * 403: Missing permissions to update permissions
  ///   * 404: Attendee not found
  ///
  /// See:
  ///  * [$setAttendeePermissions_Request] for the request send by this method.
  ///  * [$setAttendeePermissions_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomSetAttendeePermissionsResponseApplicationJson, void>> setAttendeePermissions({
    required int attendeeId,
    required RoomSetAttendeePermissionsMethod method,
    required int permissions,
    required String token,
    RoomSetAttendeePermissionsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $setAttendeePermissions_Request(
      attendeeId: attendeeId,
      method: method,
      permissions: permissions,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $setAttendeePermissions_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomSetAttendeePermissionsResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$setAllAttendeesPermissions_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomSetAllAttendeesPermissionsResponseApplicationJson, void>
      $setAllAttendeesPermissions_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(RoomSetAllAttendeesPermissionsResponseApplicationJson),
            headersType: null,
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Update the permissions of all attendees.
  ///
  /// Returns a `DynamiteRequest` backing the [setAllAttendeesPermissions] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [method] Method of updating permissions ('set', 'remove', 'add').
  ///   * [permissions] New permissions.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Permissions updated successfully
  ///   * 400: Updating permissions is not possible
  ///
  /// See:
  ///  * [setAllAttendeesPermissions] for a method executing this request and parsing the response.
  ///  * [$setAllAttendeesPermissions_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $setAllAttendeesPermissions_Request({
    required RoomSetAllAttendeesPermissionsMethod method,
    required int permissions,
    required String token,
    RoomSetAllAttendeesPermissionsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $method =
        _$jsonSerializers.serialize(method, specifiedType: const FullType(RoomSetAllAttendeesPermissionsMethod));
    _parameters['method'] = $method;

    final $permissions = _$jsonSerializers.serialize(permissions, specifiedType: const FullType(int));
    _parameters['permissions'] = $permissions;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion = _$jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(RoomSetAllAttendeesPermissionsApiVersion),
    );
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/attendees/permissions/all{?method*,permissions*}',
    ).expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('put', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Update the permissions of all attendees.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [method] Method of updating permissions ('set', 'remove', 'add').
  ///   * [permissions] New permissions.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Permissions updated successfully
  ///   * 400: Updating permissions is not possible
  ///
  /// See:
  ///  * [$setAllAttendeesPermissions_Request] for the request send by this method.
  ///  * [$setAllAttendeesPermissions_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomSetAllAttendeesPermissionsResponseApplicationJson, void>> setAllAttendeesPermissions({
    required RoomSetAllAttendeesPermissionsMethod method,
    required int permissions,
    required String token,
    RoomSetAllAttendeesPermissionsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $setAllAttendeesPermissions_Request(
      method: method,
      permissions: permissions,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $setAllAttendeesPermissions_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomSetAllAttendeesPermissionsResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$joinRoom_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomJoinRoomResponseApplicationJson, RoomRoomJoinRoomHeaders> $joinRoom_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RoomJoinRoomResponseApplicationJson),
        headersType: const FullType(RoomRoomJoinRoomHeaders),
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Join a room.
  ///
  /// Returns a `DynamiteRequest` backing the [joinRoom] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [password] Password of the room. Defaults to `''`.
  ///   * [force] Create a new session if necessary. Defaults to `1`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token] Token of the room.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room joined successfully
  ///   * 403: Joining room is not allowed
  ///   * 404: Room not found
  ///   * 409: Session already exists
  ///
  /// See:
  ///  * [joinRoom] for a method executing this request and parsing the response.
  ///  * [$joinRoom_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $joinRoom_Request({
    required String token,
    String? password,
    RoomJoinRoomForce? force,
    RoomJoinRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $password = _$jsonSerializers.serialize(password, specifiedType: const FullType(String));
    $password ??= '';
    _parameters['password'] = $password;

    var $force = _$jsonSerializers.serialize(force, specifiedType: const FullType(RoomJoinRoomForce));
    $force ??= 1;
    _parameters['force'] = $force;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomJoinRoomApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/participants/active{?password*,force*}')
            .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Join a room.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [password] Password of the room. Defaults to `''`.
  ///   * [force] Create a new session if necessary. Defaults to `1`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token] Token of the room.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room joined successfully
  ///   * 403: Joining room is not allowed
  ///   * 404: Room not found
  ///   * 409: Session already exists
  ///
  /// See:
  ///  * [$joinRoom_Request] for the request send by this method.
  ///  * [$joinRoom_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomJoinRoomResponseApplicationJson, RoomRoomJoinRoomHeaders>> joinRoom({
    required String token,
    String? password,
    RoomJoinRoomForce? force,
    RoomJoinRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $joinRoom_Request(
      token: token,
      password: password,
      force: force,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $joinRoom_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomJoinRoomResponseApplicationJson, RoomRoomJoinRoomHeaders>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$leaveRoom_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomLeaveRoomResponseApplicationJson, void> $leaveRoom_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(RoomLeaveRoomResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Leave a room.
  ///
  /// Returns a `DynamiteRequest` backing the [leaveRoom] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token] Token of the room.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Successfully left the room
  ///
  /// See:
  ///  * [leaveRoom] for a method executing this request and parsing the response.
  ///  * [$leaveRoom_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $leaveRoom_Request({
    required String token,
    RoomLeaveRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomLeaveRoomApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/participants/active')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Leave a room.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token] Token of the room.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Successfully left the room
  ///
  /// See:
  ///  * [$leaveRoom_Request] for the request send by this method.
  ///  * [$leaveRoom_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomLeaveRoomResponseApplicationJson, void>> leaveRoom({
    required String token,
    RoomLeaveRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $leaveRoom_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $leaveRoom_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomLeaveRoomResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$resendInvitations_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomResendInvitationsResponseApplicationJson, void> $resendInvitations_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RoomResendInvitationsResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 404},
      );

  /// Resend invitations.
  ///
  /// Returns a `DynamiteRequest` backing the [resendInvitations] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [attendeeId] ID of the attendee.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Invitation resent successfully
  ///   * 404: Attendee not found
  ///
  /// See:
  ///  * [resendInvitations] for a method executing this request and parsing the response.
  ///  * [$resendInvitations_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $resendInvitations_Request({
    required String token,
    int? attendeeId,
    RoomResendInvitationsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $attendeeId = _$jsonSerializers.serialize(attendeeId, specifiedType: const FullType(int));
    _parameters['attendeeId'] = $attendeeId;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomResendInvitationsApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/participants/resend-invitations{?attendeeId*}',
    ).expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Resend invitations.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [attendeeId] ID of the attendee.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Invitation resent successfully
  ///   * 404: Attendee not found
  ///
  /// See:
  ///  * [$resendInvitations_Request] for the request send by this method.
  ///  * [$resendInvitations_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomResendInvitationsResponseApplicationJson, void>> resendInvitations({
    required String token,
    int? attendeeId,
    RoomResendInvitationsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $resendInvitations_Request(
      token: token,
      attendeeId: attendeeId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $resendInvitations_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomResendInvitationsResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$setSessionState_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomSetSessionStateResponseApplicationJson, void> $setSessionState_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RoomSetSessionStateResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Set active state for a session.
  ///
  /// Returns a `DynamiteRequest` backing the [setSessionState] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [state] of the room.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Session state set successfully
  ///   * 400: The provided new state was invalid
  ///   * 404: The participant did not have a session
  ///
  /// See:
  ///  * [setSessionState] for a method executing this request and parsing the response.
  ///  * [$setSessionState_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $setSessionState_Request({
    required RoomSetSessionStateState state,
    required String token,
    RoomSetSessionStateApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $state = _$jsonSerializers.serialize(state, specifiedType: const FullType(RoomSetSessionStateState));
    _parameters['state'] = $state;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomSetSessionStateApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/participants/state{?state*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('put', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Set active state for a session.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [state] of the room.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Session state set successfully
  ///   * 400: The provided new state was invalid
  ///   * 404: The participant did not have a session
  ///
  /// See:
  ///  * [$setSessionState_Request] for the request send by this method.
  ///  * [$setSessionState_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomSetSessionStateResponseApplicationJson, void>> setSessionState({
    required RoomSetSessionStateState state,
    required String token,
    RoomSetSessionStateApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $setSessionState_Request(
      state: state,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $setSessionState_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomSetSessionStateResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$promoteModerator_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomPromoteModeratorResponseApplicationJson, void> $promoteModerator_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RoomPromoteModeratorResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 400, 403, 404},
      );

  /// Promote an attendee to moderator.
  ///
  /// Returns a `DynamiteRequest` backing the [promoteModerator] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [attendeeId] ID of the attendee.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Attendee promoted to moderator successfully
  ///   * 400: Promoting attendee to moderator is not possible
  ///   * 403: Promoting attendee to moderator is not allowed
  ///   * 404: Attendee not found
  ///
  /// See:
  ///  * [promoteModerator] for a method executing this request and parsing the response.
  ///  * [$promoteModerator_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $promoteModerator_Request({
    required int attendeeId,
    required String token,
    RoomPromoteModeratorApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $attendeeId = _$jsonSerializers.serialize(attendeeId, specifiedType: const FullType(int));
    _parameters['attendeeId'] = $attendeeId;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomPromoteModeratorApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/moderators{?attendeeId*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Promote an attendee to moderator.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [attendeeId] ID of the attendee.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Attendee promoted to moderator successfully
  ///   * 400: Promoting attendee to moderator is not possible
  ///   * 403: Promoting attendee to moderator is not allowed
  ///   * 404: Attendee not found
  ///
  /// See:
  ///  * [$promoteModerator_Request] for the request send by this method.
  ///  * [$promoteModerator_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomPromoteModeratorResponseApplicationJson, void>> promoteModerator({
    required int attendeeId,
    required String token,
    RoomPromoteModeratorApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $promoteModerator_Request(
      attendeeId: attendeeId,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $promoteModerator_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomPromoteModeratorResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$demoteModerator_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomDemoteModeratorResponseApplicationJson, void> $demoteModerator_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RoomDemoteModeratorResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 400, 403, 404},
      );

  /// Demote an attendee from moderator.
  ///
  /// Returns a `DynamiteRequest` backing the [demoteModerator] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [attendeeId] ID of the attendee.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Attendee demoted from moderator successfully
  ///   * 400: Demoting attendee from moderator is not possible
  ///   * 403: Demoting attendee from moderator is not allowed
  ///   * 404: Attendee not found
  ///
  /// See:
  ///  * [demoteModerator] for a method executing this request and parsing the response.
  ///  * [$demoteModerator_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $demoteModerator_Request({
    required int attendeeId,
    required String token,
    RoomDemoteModeratorApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $attendeeId = _$jsonSerializers.serialize(attendeeId, specifiedType: const FullType(int));
    _parameters['attendeeId'] = $attendeeId;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomDemoteModeratorApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/moderators{?attendeeId*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Demote an attendee from moderator.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [attendeeId] ID of the attendee.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Attendee demoted from moderator successfully
  ///   * 400: Demoting attendee from moderator is not possible
  ///   * 403: Demoting attendee from moderator is not allowed
  ///   * 404: Attendee not found
  ///
  /// See:
  ///  * [$demoteModerator_Request] for the request send by this method.
  ///  * [$demoteModerator_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomDemoteModeratorResponseApplicationJson, void>> demoteModerator({
    required int attendeeId,
    required String token,
    RoomDemoteModeratorApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $demoteModerator_Request(
      attendeeId: attendeeId,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $demoteModerator_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomDemoteModeratorResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$addToFavorites_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomAddToFavoritesResponseApplicationJson, void> $addToFavorites_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RoomAddToFavoritesResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Add a room to the favorites.
  ///
  /// Returns a `DynamiteRequest` backing the [addToFavorites] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Successfully added room to favorites
  ///
  /// See:
  ///  * [addToFavorites] for a method executing this request and parsing the response.
  ///  * [$addToFavorites_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $addToFavorites_Request({
    required String token,
    RoomAddToFavoritesApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomAddToFavoritesApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/favorite').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Add a room to the favorites.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Successfully added room to favorites
  ///
  /// See:
  ///  * [$addToFavorites_Request] for the request send by this method.
  ///  * [$addToFavorites_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomAddToFavoritesResponseApplicationJson, void>> addToFavorites({
    required String token,
    RoomAddToFavoritesApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $addToFavorites_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $addToFavorites_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomAddToFavoritesResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$removeFromFavorites_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomRemoveFromFavoritesResponseApplicationJson, void> $removeFromFavorites_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RoomRemoveFromFavoritesResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Remove a room from the favorites.
  ///
  /// Returns a `DynamiteRequest` backing the [removeFromFavorites] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Successfully removed room from favorites
  ///
  /// See:
  ///  * [removeFromFavorites] for a method executing this request and parsing the response.
  ///  * [$removeFromFavorites_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $removeFromFavorites_Request({
    required String token,
    RoomRemoveFromFavoritesApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomRemoveFromFavoritesApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/favorite').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Remove a room from the favorites.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Successfully removed room from favorites
  ///
  /// See:
  ///  * [$removeFromFavorites_Request] for the request send by this method.
  ///  * [$removeFromFavorites_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomRemoveFromFavoritesResponseApplicationJson, void>> removeFromFavorites({
    required String token,
    RoomRemoveFromFavoritesApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $removeFromFavorites_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $removeFromFavorites_Serializer();
    final _rawResponse = await _i1.ResponseConverter<RoomRemoveFromFavoritesResponseApplicationJson, void>(_serializer)
        .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$setNotificationLevel_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomSetNotificationLevelResponseApplicationJson, void> $setNotificationLevel_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RoomSetNotificationLevelResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 400},
      );

  /// Update the notification level for a room.
  ///
  /// Returns a `DynamiteRequest` backing the [setNotificationLevel] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [level] New level.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Notification level updated successfully
  ///   * 400: Updating notification level is not possible
  ///
  /// See:
  ///  * [setNotificationLevel] for a method executing this request and parsing the response.
  ///  * [$setNotificationLevel_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $setNotificationLevel_Request({
    required int level,
    required String token,
    RoomSetNotificationLevelApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $level = _$jsonSerializers.serialize(level, specifiedType: const FullType(int));
    _parameters['level'] = $level;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomSetNotificationLevelApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/notify{?level*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Update the notification level for a room.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [level] New level.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Notification level updated successfully
  ///   * 400: Updating notification level is not possible
  ///
  /// See:
  ///  * [$setNotificationLevel_Request] for the request send by this method.
  ///  * [$setNotificationLevel_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomSetNotificationLevelResponseApplicationJson, void>> setNotificationLevel({
    required int level,
    required String token,
    RoomSetNotificationLevelApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $setNotificationLevel_Request(
      level: level,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $setNotificationLevel_Serializer();
    final _rawResponse = await _i1.ResponseConverter<RoomSetNotificationLevelResponseApplicationJson, void>(_serializer)
        .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$setNotificationCalls_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomSetNotificationCallsResponseApplicationJson, void> $setNotificationCalls_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RoomSetNotificationCallsResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 400},
      );

  /// Update call notifications.
  ///
  /// Returns a `DynamiteRequest` backing the [setNotificationCalls] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [level] New level.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Call notification level updated successfully
  ///   * 400: Updating call notification level is not possible
  ///
  /// See:
  ///  * [setNotificationCalls] for a method executing this request and parsing the response.
  ///  * [$setNotificationCalls_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $setNotificationCalls_Request({
    required int level,
    required String token,
    RoomSetNotificationCallsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $level = _$jsonSerializers.serialize(level, specifiedType: const FullType(int));
    _parameters['level'] = $level;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomSetNotificationCallsApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/notify-calls{?level*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Update call notifications.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [level] New level.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Call notification level updated successfully
  ///   * 400: Updating call notification level is not possible
  ///
  /// See:
  ///  * [$setNotificationCalls_Request] for the request send by this method.
  ///  * [$setNotificationCalls_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomSetNotificationCallsResponseApplicationJson, void>> setNotificationCalls({
    required int level,
    required String token,
    RoomSetNotificationCallsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $setNotificationCalls_Request(
      level: level,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $setNotificationCalls_Serializer();
    final _rawResponse = await _i1.ResponseConverter<RoomSetNotificationCallsResponseApplicationJson, void>(_serializer)
        .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$setLobby_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomSetLobbyResponseApplicationJson, void> $setLobby_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(RoomSetLobbyResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Update the lobby state for a room.
  ///
  /// Returns a `DynamiteRequest` backing the [setLobby] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [state] New state.
  ///   * [timer] Timer when the lobby will be removed.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Lobby state updated successfully
  ///   * 400: Updating lobby state is not possible
  ///
  /// See:
  ///  * [setLobby] for a method executing this request and parsing the response.
  ///  * [$setLobby_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $setLobby_Request({
    required int state,
    required String token,
    int? timer,
    RoomSetLobbyApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $state = _$jsonSerializers.serialize(state, specifiedType: const FullType(int));
    _parameters['state'] = $state;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $timer = _$jsonSerializers.serialize(timer, specifiedType: const FullType(int));
    _parameters['timer'] = $timer;

    var $apiVersion = _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomSetLobbyApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/webinar/lobby{?state*,timer*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('put', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Update the lobby state for a room.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [state] New state.
  ///   * [timer] Timer when the lobby will be removed.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Lobby state updated successfully
  ///   * 400: Updating lobby state is not possible
  ///
  /// See:
  ///  * [$setLobby_Request] for the request send by this method.
  ///  * [$setLobby_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomSetLobbyResponseApplicationJson, void>> setLobby({
    required int state,
    required String token,
    int? timer,
    RoomSetLobbyApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $setLobby_Request(
      state: state,
      token: token,
      timer: timer,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $setLobby_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomSetLobbyResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$setsipEnabled_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomSetsipEnabledResponseApplicationJson, void> $setsipEnabled_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RoomSetsipEnabledResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Update SIP enabled state.
  ///
  /// Returns a `DynamiteRequest` backing the [setsipEnabled] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [state] New state.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: SIP enabled state updated successfully
  ///   * 400: Updating SIP enabled state is not possible
  ///   * 401: User not found
  ///   * 403: Missing permissions to update SIP enabled state
  ///   * 412: SIP not configured
  ///
  /// See:
  ///  * [setsipEnabled] for a method executing this request and parsing the response.
  ///  * [$setsipEnabled_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $setsipEnabled_Request({
    required RoomSetsipEnabledState state,
    required String token,
    RoomSetsipEnabledApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $state = _$jsonSerializers.serialize(state, specifiedType: const FullType(RoomSetsipEnabledState));
    _parameters['state'] = $state;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomSetsipEnabledApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/webinar/sip{?state*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('put', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Update SIP enabled state.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [state] New state.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: SIP enabled state updated successfully
  ///   * 400: Updating SIP enabled state is not possible
  ///   * 401: User not found
  ///   * 403: Missing permissions to update SIP enabled state
  ///   * 412: SIP not configured
  ///
  /// See:
  ///  * [$setsipEnabled_Request] for the request send by this method.
  ///  * [$setsipEnabled_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomSetsipEnabledResponseApplicationJson, void>> setsipEnabled({
    required RoomSetsipEnabledState state,
    required String token,
    RoomSetsipEnabledApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $setsipEnabled_Request(
      state: state,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $setsipEnabled_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomSetsipEnabledResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$setRecordingConsent_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomSetRecordingConsentResponseApplicationJson, void> $setRecordingConsent_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RoomSetRecordingConsentResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Set recording consent requirement for this conversation.
  ///
  /// Returns a `DynamiteRequest` backing the [setRecordingConsent] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [recordingConsent] New consent setting for the conversation (Only {@see RecordingService::CONSENT_REQUIRED_NO} and {@see RecordingService::CONSENT_REQUIRED_YES} are allowed here.).
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Recording consent requirement set successfully
  ///   * 400: Setting recording consent requirement is not possible
  ///   * 412: No recording server is configured
  ///
  /// See:
  ///  * [setRecordingConsent] for a method executing this request and parsing the response.
  ///  * [$setRecordingConsent_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $setRecordingConsent_Request({
    required int recordingConsent,
    required String token,
    RoomSetRecordingConsentApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $recordingConsent = _$jsonSerializers.serialize(recordingConsent, specifiedType: const FullType(int));
    _parameters['recordingConsent'] = $recordingConsent;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomSetRecordingConsentApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/recording-consent{?recordingConsent*}')
            .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('put', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Set recording consent requirement for this conversation.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [recordingConsent] New consent setting for the conversation (Only {@see RecordingService::CONSENT_REQUIRED_NO} and {@see RecordingService::CONSENT_REQUIRED_YES} are allowed here.).
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Recording consent requirement set successfully
  ///   * 400: Setting recording consent requirement is not possible
  ///   * 412: No recording server is configured
  ///
  /// See:
  ///  * [$setRecordingConsent_Request] for the request send by this method.
  ///  * [$setRecordingConsent_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomSetRecordingConsentResponseApplicationJson, void>> setRecordingConsent({
    required int recordingConsent,
    required String token,
    RoomSetRecordingConsentApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $setRecordingConsent_Request(
      recordingConsent: recordingConsent,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $setRecordingConsent_Serializer();
    final _rawResponse = await _i1.ResponseConverter<RoomSetRecordingConsentResponseApplicationJson, void>(_serializer)
        .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$setMessageExpiration_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomSetMessageExpirationResponseApplicationJson, void> $setMessageExpiration_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RoomSetMessageExpirationResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Update message expiration time.
  ///
  /// Returns a `DynamiteRequest` backing the [setMessageExpiration] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [seconds] New time.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Message expiration time updated successfully
  ///   * 400: Updating message expiration time is not possible
  ///
  /// See:
  ///  * [setMessageExpiration] for a method executing this request and parsing the response.
  ///  * [$setMessageExpiration_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $setMessageExpiration_Request({
    required int seconds,
    required String token,
    RoomSetMessageExpirationApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $seconds = _$jsonSerializers.serialize(seconds, specifiedType: const FullType(int));
    _parameters['seconds'] = $seconds;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomSetMessageExpirationApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/message-expiration{?seconds*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Update message expiration time.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [seconds] New time.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Message expiration time updated successfully
  ///   * 400: Updating message expiration time is not possible
  ///
  /// See:
  ///  * [$setMessageExpiration_Request] for the request send by this method.
  ///  * [$setMessageExpiration_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomSetMessageExpirationResponseApplicationJson, void>> setMessageExpiration({
    required int seconds,
    required String token,
    RoomSetMessageExpirationApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $setMessageExpiration_Request(
      seconds: seconds,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $setMessageExpiration_Serializer();
    final _rawResponse = await _i1.ResponseConverter<RoomSetMessageExpirationResponseApplicationJson, void>(_serializer)
        .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$getCapabilities_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomGetCapabilitiesResponseApplicationJson, RoomRoomGetCapabilitiesHeaders>
      $getCapabilities_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(RoomGetCapabilitiesResponseApplicationJson),
            headersType: const FullType(RoomRoomGetCapabilitiesHeaders),
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Get capabilities for a room.
  ///
  /// See "Capability handling in federated conversations" in https://github.com/nextcloud/spreed/issues/10680 to learn which capabilities should be considered from the local server or from the remote server.
  ///
  /// Returns a `DynamiteRequest` backing the [getCapabilities] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Get capabilities successfully
  ///
  /// See:
  ///  * [getCapabilities] for a method executing this request and parsing the response.
  ///  * [$getCapabilities_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $getCapabilities_Request({
    required String token,
    RoomGetCapabilitiesApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomGetCapabilitiesApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/capabilities').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get capabilities for a room.
  ///
  /// See "Capability handling in federated conversations" in https://github.com/nextcloud/spreed/issues/10680 to learn which capabilities should be considered from the local server or from the remote server.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Get capabilities successfully
  ///
  /// See:
  ///  * [$getCapabilities_Request] for the request send by this method.
  ///  * [$getCapabilities_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomGetCapabilitiesResponseApplicationJson, RoomRoomGetCapabilitiesHeaders>>
      getCapabilities({
    required String token,
    RoomGetCapabilitiesApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $getCapabilities_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $getCapabilities_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomGetCapabilitiesResponseApplicationJson, RoomRoomGetCapabilitiesHeaders>(
      _serializer,
    ).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$joinFederatedRoom_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomJoinFederatedRoomResponseApplicationJson, RoomRoomJoinFederatedRoomHeaders>
      $joinFederatedRoom_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(RoomJoinFederatedRoomResponseApplicationJson),
            headersType: const FullType(RoomRoomJoinFederatedRoomHeaders),
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Fake join a room on the host server to verify the federated user is still part of it.
  ///
  /// Returns a `DynamiteRequest` backing the [joinFederatedRoom] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token] Token of the room.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Federated user is still part of the room
  ///   * 404: Room not found
  ///
  /// See:
  ///  * [joinFederatedRoom] for a method executing this request and parsing the response.
  ///  * [$joinFederatedRoom_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $joinFederatedRoom_Request({
    required String token,
    RoomJoinFederatedRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomJoinFederatedRoomApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/federation/active').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Fake join a room on the host server to verify the federated user is still part of it.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token] Token of the room.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Federated user is still part of the room
  ///   * 404: Room not found
  ///
  /// See:
  ///  * [$joinFederatedRoom_Request] for the request send by this method.
  ///  * [$joinFederatedRoom_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomJoinFederatedRoomResponseApplicationJson, RoomRoomJoinFederatedRoomHeaders>>
      joinFederatedRoom({
    required String token,
    RoomJoinFederatedRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $joinFederatedRoom_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $joinFederatedRoom_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomJoinFederatedRoomResponseApplicationJson, RoomRoomJoinFederatedRoomHeaders>(
      _serializer,
    ).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$verifyDialInPinDeprecated_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomVerifyDialInPinDeprecatedResponseApplicationJson, void>
      $verifyDialInPinDeprecated_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(RoomVerifyDialInPinDeprecatedResponseApplicationJson),
            headersType: null,
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Verify a dial-in PIN (SIP bridge).
  ///
  /// Returns a `DynamiteRequest` backing the [verifyDialInPinDeprecated] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [pin] PIN the participant used to dial-in.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Participant returned
  ///   * 401: SIP request invalid
  ///   * 404: Participant not found
  ///   * 501: SIP dial-in is not configured
  ///
  /// See:
  ///  * [verifyDialInPinDeprecated] for a method executing this request and parsing the response.
  ///  * [$verifyDialInPinDeprecated_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $verifyDialInPinDeprecated_Request({
    required String token,
    required String pin,
    RoomVerifyDialInPinDeprecatedApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $pin = _$jsonSerializers.serialize(pin, specifiedType: const FullType(String));
    _i4.checkPattern(
      $pin as String?,
      RegExp(r'^\d{7,32}$'),
      'pin',
    );
    _parameters['pin'] = $pin;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomVerifyDialInPinDeprecatedApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/pin/{pin}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Verify a dial-in PIN (SIP bridge).
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [pin] PIN the participant used to dial-in.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Participant returned
  ///   * 401: SIP request invalid
  ///   * 404: Participant not found
  ///   * 501: SIP dial-in is not configured
  ///
  /// See:
  ///  * [$verifyDialInPinDeprecated_Request] for the request send by this method.
  ///  * [$verifyDialInPinDeprecated_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomVerifyDialInPinDeprecatedResponseApplicationJson, void>> verifyDialInPinDeprecated({
    required String token,
    required String pin,
    RoomVerifyDialInPinDeprecatedApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $verifyDialInPinDeprecated_Request(
      token: token,
      pin: pin,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $verifyDialInPinDeprecated_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomVerifyDialInPinDeprecatedResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$verifyDialInPin_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomVerifyDialInPinResponseApplicationJson, void> $verifyDialInPin_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RoomVerifyDialInPinResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Verify a dial-in PIN (SIP bridge).
  ///
  /// Returns a `DynamiteRequest` backing the [verifyDialInPin] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [pin] PIN the participant used to dial-in.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Participant returned
  ///   * 401: SIP request invalid
  ///   * 404: Participant not found
  ///   * 501: SIP dial-in is not configured
  ///
  /// See:
  ///  * [verifyDialInPin] for a method executing this request and parsing the response.
  ///  * [$verifyDialInPin_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $verifyDialInPin_Request({
    required String pin,
    required String token,
    RoomVerifyDialInPinApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $pin = _$jsonSerializers.serialize(pin, specifiedType: const FullType(String));
    _parameters['pin'] = $pin;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomVerifyDialInPinApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/verify-dialin{?pin*}')
        .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Verify a dial-in PIN (SIP bridge).
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [pin] PIN the participant used to dial-in.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Participant returned
  ///   * 401: SIP request invalid
  ///   * 404: Participant not found
  ///   * 501: SIP dial-in is not configured
  ///
  /// See:
  ///  * [$verifyDialInPin_Request] for the request send by this method.
  ///  * [$verifyDialInPin_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomVerifyDialInPinResponseApplicationJson, void>> verifyDialInPin({
    required String pin,
    required String token,
    RoomVerifyDialInPinApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $verifyDialInPin_Request(
      pin: pin,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $verifyDialInPin_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomVerifyDialInPinResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$verifyDialOutNumber_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomVerifyDialOutNumberResponseApplicationJson, void> $verifyDialOutNumber_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RoomVerifyDialOutNumberResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Verify a dial-out number (SIP bridge).
  ///
  /// Returns a `DynamiteRequest` backing the [verifyDialOutNumber] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [number] E164 formatted phone number.
  ///   * [options] Additional details to verify the validity of the request.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Participant created successfully
  ///   * 400: Phone number and details could not be confirmed
  ///   * 401: SIP request invalid
  ///   * 404: Phone number is not invited as a participant
  ///   * 501: SIP dial-out is not configured
  ///
  /// See:
  ///  * [verifyDialOutNumber] for a method executing this request and parsing the response.
  ///  * [$verifyDialOutNumber_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $verifyDialOutNumber_Request({
    required String number,
    required String token,
    ContentString<RoomVerifyDialOutNumberOptions>? options,
    RoomVerifyDialOutNumberApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $number = _$jsonSerializers.serialize(number, specifiedType: const FullType(String));
    _parameters['number'] = $number;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $options = _$jsonSerializers.serialize(
      options,
      specifiedType: const FullType(ContentString, [FullType(RoomVerifyDialOutNumberOptions)]),
    );
    _parameters['options'] = $options;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomVerifyDialOutNumberApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/verify-dialout{?number*,options*}')
            .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Verify a dial-out number (SIP bridge).
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [number] E164 formatted phone number.
  ///   * [options] Additional details to verify the validity of the request.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Participant created successfully
  ///   * 400: Phone number and details could not be confirmed
  ///   * 401: SIP request invalid
  ///   * 404: Phone number is not invited as a participant
  ///   * 501: SIP dial-out is not configured
  ///
  /// See:
  ///  * [$verifyDialOutNumber_Request] for the request send by this method.
  ///  * [$verifyDialOutNumber_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomVerifyDialOutNumberResponseApplicationJson, void>> verifyDialOutNumber({
    required String number,
    required String token,
    ContentString<RoomVerifyDialOutNumberOptions>? options,
    RoomVerifyDialOutNumberApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $verifyDialOutNumber_Request(
      number: number,
      token: token,
      options: options,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $verifyDialOutNumber_Serializer();
    final _rawResponse = await _i1.ResponseConverter<RoomVerifyDialOutNumberResponseApplicationJson, void>(_serializer)
        .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$createGuestByDialIn_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomCreateGuestByDialInResponseApplicationJson, void> $createGuestByDialIn_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(RoomCreateGuestByDialInResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Create a guest by their dial-in.
  ///
  /// Returns a `DynamiteRequest` backing the [createGuestByDialIn] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Participant created successfully
  ///   * 400: SIP not enabled
  ///   * 401: SIP request invalid
  ///
  /// See:
  ///  * [createGuestByDialIn] for a method executing this request and parsing the response.
  ///  * [$createGuestByDialIn_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $createGuestByDialIn_Request({
    required String token,
    RoomCreateGuestByDialInApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomCreateGuestByDialInApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/open-dial-in').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Create a guest by their dial-in.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Participant created successfully
  ///   * 400: SIP not enabled
  ///   * 401: SIP request invalid
  ///
  /// See:
  ///  * [$createGuestByDialIn_Request] for the request send by this method.
  ///  * [$createGuestByDialIn_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomCreateGuestByDialInResponseApplicationJson, void>> createGuestByDialIn({
    required String token,
    RoomCreateGuestByDialInApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $createGuestByDialIn_Request(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $createGuestByDialIn_Serializer();
    final _rawResponse = await _i1.ResponseConverter<RoomCreateGuestByDialInResponseApplicationJson, void>(_serializer)
        .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$rejectedDialOutRequest_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RoomRejectedDialOutRequestResponseApplicationJson, void>
      $rejectedDialOutRequest_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(RoomRejectedDialOutRequestResponseApplicationJson),
            headersType: null,
            serializers: _$jsonSerializers,
            validStatuses: const {200, 400, 401, 404, 501},
          );

  /// Reset call ID of a dial-out participant when the SIP gateway rejected it.
  ///
  /// Returns a `DynamiteRequest` backing the [rejectedDialOutRequest] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [callId] The call ID provided by the SIP bridge earlier to uniquely identify the call to terminate.
  ///   * [options] Additional details to verify the validity of the request.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Call ID reset
  ///   * 400: Call ID mismatch or attendeeId not found in $options
  ///   * 401: SIP request invalid
  ///   * 404: Participant was not found
  ///   * 501: SIP dial-out is not configured
  ///
  /// See:
  ///  * [rejectedDialOutRequest] for a method executing this request and parsing the response.
  ///  * [$rejectedDialOutRequest_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $rejectedDialOutRequest_Request({
    required String callId,
    required String token,
    ContentString<RoomRejectedDialOutRequestOptions>? options,
    RoomRejectedDialOutRequestApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $callId = _$jsonSerializers.serialize(callId, specifiedType: const FullType(String));
    _parameters['callId'] = $callId;

    final $token = _$jsonSerializers.serialize(token, specifiedType: const FullType(String));
    _i4.checkPattern(
      $token as String?,
      RegExp(r'^[a-z0-9]{4,30}$'),
      'token',
    );
    _parameters['token'] = $token;

    final $options = _$jsonSerializers.serialize(
      options,
      specifiedType: const FullType(ContentString, [FullType(RoomRejectedDialOutRequestOptions)]),
    );
    _parameters['options'] = $options;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomRejectedDialOutRequestApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/rejected-dialout{?callId*,options*}')
            .expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Reset call ID of a dial-out participant when the SIP gateway rejected it.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [callId] The call ID provided by the SIP bridge earlier to uniquely identify the call to terminate.
  ///   * [options] Additional details to verify the validity of the request.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Call ID reset
  ///   * 400: Call ID mismatch or attendeeId not found in $options
  ///   * 401: SIP request invalid
  ///   * 404: Participant was not found
  ///   * 501: SIP dial-out is not configured
  ///
  /// See:
  ///  * [$rejectedDialOutRequest_Request] for the request send by this method.
  ///  * [$rejectedDialOutRequest_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RoomRejectedDialOutRequestResponseApplicationJson, void>> rejectedDialOutRequest({
    required String callId,
    required String token,
    ContentString<RoomRejectedDialOutRequestOptions>? options,
    RoomRejectedDialOutRequestApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $rejectedDialOutRequest_Request(
      callId: callId,
      token: token,
      options: options,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $rejectedDialOutRequest_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RoomRejectedDialOutRequestResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $SettingsClient {
  /// Creates a new `DynamiteClient` for settings requests.
  $SettingsClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$setUserSetting_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<SettingsSetUserSettingResponseApplicationJson, void> $setUserSetting_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(SettingsSetUserSettingResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 400},
      );

  /// Update user setting.
  ///
  /// Returns a `DynamiteRequest` backing the [setUserSetting] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [key] Key to update.
  ///   * [value] New value for the key.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: User setting updated successfully
  ///   * 400: Updating user setting is not possible
  ///
  /// See:
  ///  * [setUserSetting] for a method executing this request and parsing the response.
  ///  * [$setUserSetting_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $setUserSetting_Request({
    required SettingsSetUserSettingKey key,
    SettingsSetUserSettingValue? value,
    SettingsSetUserSettingApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $key = _$jsonSerializers.serialize(key, specifiedType: const FullType(SettingsSetUserSettingKey));
    _parameters['key'] = $key;

    final $value = _$jsonSerializers.serialize(value, specifiedType: const FullType(SettingsSetUserSettingValue));
    _parameters['value'] = $value;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(SettingsSetUserSettingApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/settings/user{?key*,value*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Update user setting.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [key] Key to update.
  ///   * [value] New value for the key.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: User setting updated successfully
  ///   * 400: Updating user setting is not possible
  ///
  /// See:
  ///  * [$setUserSetting_Request] for the request send by this method.
  ///  * [$setUserSetting_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<SettingsSetUserSettingResponseApplicationJson, void>> setUserSetting({
    required SettingsSetUserSettingKey key,
    SettingsSetUserSettingValue? value,
    SettingsSetUserSettingApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $setUserSetting_Request(
      key: key,
      value: value,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $setUserSetting_Serializer();
    final _rawResponse = await _i1.ResponseConverter<SettingsSetUserSettingResponseApplicationJson, void>(_serializer)
        .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$botAdminListBots_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<BotAdminListBotsResponseApplicationJson, void> $botAdminListBots_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(BotAdminListBotsResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// List admin bots.
  ///
  /// This endpoint requires admin access.
  ///
  /// Returns a `DynamiteRequest` backing the [botAdminListBots] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Bot list returned
  ///
  /// See:
  ///  * [botAdminListBots] for a method executing this request and parsing the response.
  ///  * [$botAdminListBots_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $botAdminListBots_Request({
    BotAdminListBotsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(BotAdminListBotsApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/bot/admin').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// List admin bots.
  ///
  /// This endpoint requires admin access.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Bot list returned
  ///
  /// See:
  ///  * [$botAdminListBots_Request] for the request send by this method.
  ///  * [$botAdminListBots_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<BotAdminListBotsResponseApplicationJson, void>> botAdminListBots({
    BotAdminListBotsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $botAdminListBots_Request(
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $botAdminListBots_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<BotAdminListBotsResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$certificateGetCertificateExpiration_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<CertificateGetCertificateExpirationResponseApplicationJson, void>
      $certificateGetCertificateExpiration_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(CertificateGetCertificateExpirationResponseApplicationJson),
            headersType: null,
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Get the certificate expiration for a host.
  ///
  /// This endpoint requires admin access.
  ///
  /// Returns a `DynamiteRequest` backing the [certificateGetCertificateExpiration] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [host] Host to check.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Certificate expiration returned
  ///   * 400: Getting certificate expiration is not possible
  ///
  /// See:
  ///  * [certificateGetCertificateExpiration] for a method executing this request and parsing the response.
  ///  * [$certificateGetCertificateExpiration_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $certificateGetCertificateExpiration_Request({
    required String host,
    CertificateGetCertificateExpirationApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $host = _$jsonSerializers.serialize(host, specifiedType: const FullType(String));
    _parameters['host'] = $host;

    var $apiVersion = _$jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(CertificateGetCertificateExpirationApiVersion),
    );
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/certificate/expiration{?host*}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get the certificate expiration for a host.
  ///
  /// This endpoint requires admin access.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [host] Host to check.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Certificate expiration returned
  ///   * 400: Getting certificate expiration is not possible
  ///
  /// See:
  ///  * [$certificateGetCertificateExpiration_Request] for the request send by this method.
  ///  * [$certificateGetCertificateExpiration_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<CertificateGetCertificateExpirationResponseApplicationJson, void>>
      certificateGetCertificateExpiration({
    required String host,
    CertificateGetCertificateExpirationApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $certificateGetCertificateExpiration_Request(
      host: host,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $certificateGetCertificateExpiration_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<CertificateGetCertificateExpirationResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$recordingGetWelcomeMessage_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<RecordingGetWelcomeMessageResponseApplicationJson, void>
      $recordingGetWelcomeMessage_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(RecordingGetWelcomeMessageResponseApplicationJson),
            headersType: null,
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Get the welcome message of a recording server.
  ///
  /// This endpoint requires admin access.
  ///
  /// Returns a `DynamiteRequest` backing the [recordingGetWelcomeMessage] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [serverId] ID of the server.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Welcome message returned
  ///   * 404: Recording server not found or not configured
  ///   * 500
  ///
  /// See:
  ///  * [recordingGetWelcomeMessage] for a method executing this request and parsing the response.
  ///  * [$recordingGetWelcomeMessage_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $recordingGetWelcomeMessage_Request({
    required int serverId,
    RecordingGetWelcomeMessageApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $serverId = _$jsonSerializers.serialize(serverId, specifiedType: const FullType(int));
    _parameters['serverId'] = $serverId;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RecordingGetWelcomeMessageApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/recording/welcome/{serverId}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get the welcome message of a recording server.
  ///
  /// This endpoint requires admin access.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [serverId] ID of the server.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Welcome message returned
  ///   * 404: Recording server not found or not configured
  ///   * 500
  ///
  /// See:
  ///  * [$recordingGetWelcomeMessage_Request] for the request send by this method.
  ///  * [$recordingGetWelcomeMessage_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<RecordingGetWelcomeMessageResponseApplicationJson, void>> recordingGetWelcomeMessage({
    required int serverId,
    RecordingGetWelcomeMessageApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $recordingGetWelcomeMessage_Request(
      serverId: serverId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $recordingGetWelcomeMessage_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<RecordingGetWelcomeMessageResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$setsipSettings_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<SettingsSetsipSettingsResponseApplicationJson, void> $setsipSettings_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(SettingsSetsipSettingsResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Update SIP bridge settings.
  ///
  /// This endpoint requires admin access.
  ///
  /// Returns a `DynamiteRequest` backing the [setsipSettings] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [sipGroups] New SIP groups. Defaults to `[]`.
  ///   * [dialInInfo] New dial info. Defaults to `''`.
  ///   * [sharedSecret] New shared secret. Defaults to `''`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Successfully set new SIP settings
  ///
  /// See:
  ///  * [setsipSettings] for a method executing this request and parsing the response.
  ///  * [$setsipSettings_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $setsipSettings_Request({
    BuiltList<String>? sipGroups,
    String? dialInInfo,
    String? sharedSecret,
    SettingsSetsipSettingsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    var $sipGroups =
        _$jsonSerializers.serialize(sipGroups, specifiedType: const FullType(BuiltList, [FullType(String)]));
    $sipGroups ??= [];
    _parameters['sipGroups%5B%5D'] = $sipGroups;

    var $dialInInfo = _$jsonSerializers.serialize(dialInInfo, specifiedType: const FullType(String));
    $dialInInfo ??= '';
    _parameters['dialInInfo'] = $dialInInfo;

    var $sharedSecret = _$jsonSerializers.serialize(sharedSecret, specifiedType: const FullType(String));
    $sharedSecret ??= '';
    _parameters['sharedSecret'] = $sharedSecret;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(SettingsSetsipSettingsApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/settings/sip{?sipGroups%5B%5D*,dialInInfo*,sharedSecret*}',
    ).expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Update SIP bridge settings.
  ///
  /// This endpoint requires admin access.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [sipGroups] New SIP groups. Defaults to `[]`.
  ///   * [dialInInfo] New dial info. Defaults to `''`.
  ///   * [sharedSecret] New shared secret. Defaults to `''`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Successfully set new SIP settings
  ///
  /// See:
  ///  * [$setsipSettings_Request] for the request send by this method.
  ///  * [$setsipSettings_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<SettingsSetsipSettingsResponseApplicationJson, void>> setsipSettings({
    BuiltList<String>? sipGroups,
    String? dialInInfo,
    String? sharedSecret,
    SettingsSetsipSettingsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $setsipSettings_Request(
      sipGroups: sipGroups,
      dialInInfo: dialInInfo,
      sharedSecret: sharedSecret,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $setsipSettings_Serializer();
    final _rawResponse = await _i1.ResponseConverter<SettingsSetsipSettingsResponseApplicationJson, void>(_serializer)
        .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$signalingGetWelcomeMessage_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<SignalingGetWelcomeMessageResponseApplicationJson, void>
      $signalingGetWelcomeMessage_Serializer() => _i1.DynamiteSerializer(
            bodyType: const FullType(SignalingGetWelcomeMessageResponseApplicationJson),
            headersType: null,
            serializers: _$jsonSerializers,
            validStatuses: const {200},
          );

  /// Get the welcome message from a signaling server.
  ///
  /// Only available for logged-in users because guests can not use the apps right now.
  /// This endpoint requires admin access.
  ///
  /// Returns a `DynamiteRequest` backing the [signalingGetWelcomeMessage] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v3`.
  ///   * [serverId] ID of the signaling server.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Welcome message returned
  ///   * 404: Signaling server not found
  ///   * 500
  ///
  /// See:
  ///  * [signalingGetWelcomeMessage] for a method executing this request and parsing the response.
  ///  * [$signalingGetWelcomeMessage_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $signalingGetWelcomeMessage_Request({
    required int serverId,
    SignalingGetWelcomeMessageApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    final $serverId = _$jsonSerializers.serialize(serverId, specifiedType: const FullType(int));
    _parameters['serverId'] = $serverId;

    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(SignalingGetWelcomeMessageApiVersion));
    $apiVersion ??= 'v3';
    _parameters['apiVersion'] = $apiVersion;

    final _path =
        _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/signaling/welcome/{serverId}').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('get', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Get the welcome message from a signaling server.
  ///
  /// Only available for logged-in users because guests can not use the apps right now.
  /// This endpoint requires admin access.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v3`.
  ///   * [serverId] ID of the signaling server.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Welcome message returned
  ///   * 404: Signaling server not found
  ///   * 500
  ///
  /// See:
  ///  * [$signalingGetWelcomeMessage_Request] for the request send by this method.
  ///  * [$signalingGetWelcomeMessage_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<SignalingGetWelcomeMessageResponseApplicationJson, void>> signalingGetWelcomeMessage({
    required int serverId,
    SignalingGetWelcomeMessageApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $signalingGetWelcomeMessage_Request(
      serverId: serverId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $signalingGetWelcomeMessage_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<SignalingGetWelcomeMessageResponseApplicationJson, void>(_serializer)
            .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $SignalingClient {
  /// Creates a new `DynamiteClient` for signaling requests.
  $SignalingClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$backend_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<SignalingBackendResponseApplicationJson, void> $backend_Serializer() => _i1.DynamiteSerializer(
        bodyType: const FullType(SignalingBackendResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Backend API to query information required for standalone signaling servers.
  ///
  /// See sections "Backend validation" in https://nextcloud-spreed-signaling.readthedocs.io/en/latest/standalone-signaling-api-v1/#backend-requests.
  ///
  /// Returns a `DynamiteRequest` backing the [backend] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v3`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Always, sorry about that
  ///
  /// See:
  ///  * [backend] for a method executing this request and parsing the response.
  ///  * [$backend_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $backend_Request({
    SignalingBackendApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, Object?>{};
    var $apiVersion =
        _$jsonSerializers.serialize(apiVersion, specifiedType: const FullType(SignalingBackendApiVersion));
    $apiVersion ??= 'v3';
    _parameters['apiVersion'] = $apiVersion;

    final _path = _i5.UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/signaling/backend').expand(_parameters);
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Backend API to query information required for standalone signaling servers.
  ///
  /// See sections "Backend validation" in https://nextcloud-spreed-signaling.readthedocs.io/en/latest/standalone-signaling-api-v1/#backend-requests.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v3`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Always, sorry about that
  ///
  /// See:
  ///  * [$backend_Request] for the request send by this method.
  ///  * [$backend_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<SignalingBackendResponseApplicationJson, void>> backend({
    SignalingBackendApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final _request = $backend_Request(
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $backend_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<SignalingBackendResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

class $UserAvatarClient {
  /// Creates a new `DynamiteClient` for user_avatar requests.
  $UserAvatarClient(this._rootClient);

  final $Client _rootClient;

  /// Builds a serializer to parse the response of [$tempAvatarPostAvatar_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<TempAvatarPostAvatarResponseApplicationJson, void> $tempAvatarPostAvatar_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(TempAvatarPostAvatarResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200},
      );

  /// Upload your avatar as a user.
  ///
  /// Returns a `DynamiteRequest` backing the [tempAvatarPostAvatar] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Avatar uploaded successfully
  ///   * 400: Uploading avatar is not possible
  ///
  /// See:
  ///  * [tempAvatarPostAvatar] for a method executing this request and parsing the response.
  ///  * [$tempAvatarPostAvatar_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $tempAvatarPostAvatar_Request({bool? oCSAPIRequest}) {
    const _path = '/ocs/v2.php/apps/spreed/temp-user-avatar';
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('post', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Upload your avatar as a user.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Avatar uploaded successfully
  ///   * 400: Uploading avatar is not possible
  ///
  /// See:
  ///  * [$tempAvatarPostAvatar_Request] for the request send by this method.
  ///  * [$tempAvatarPostAvatar_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<TempAvatarPostAvatarResponseApplicationJson, void>> tempAvatarPostAvatar({
    bool? oCSAPIRequest,
  }) async {
    final _request = $tempAvatarPostAvatar_Request(
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $tempAvatarPostAvatar_Serializer();
    final _rawResponse =
        await _i1.ResponseConverter<TempAvatarPostAvatarResponseApplicationJson, void>(_serializer).convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }

  /// Builds a serializer to parse the response of [$tempAvatarDeleteAvatar_Request].
  @_i2.experimental
  _i1.DynamiteSerializer<TempAvatarDeleteAvatarResponseApplicationJson, void> $tempAvatarDeleteAvatar_Serializer() =>
      _i1.DynamiteSerializer(
        bodyType: const FullType(TempAvatarDeleteAvatarResponseApplicationJson),
        headersType: null,
        serializers: _$jsonSerializers,
        validStatuses: const {200, 400},
      );

  /// Delete your avatar as a user.
  ///
  /// Returns a `DynamiteRequest` backing the [tempAvatarDeleteAvatar] operation.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Avatar deleted successfully
  ///   * 400: Deleting avatar is not possible
  ///
  /// See:
  ///  * [tempAvatarDeleteAvatar] for a method executing this request and parsing the response.
  ///  * [$tempAvatarDeleteAvatar_Serializer] for a converter to parse the `Response` from an executed this request.
  @_i2.experimental
  _i3.Request $tempAvatarDeleteAvatar_Request({bool? oCSAPIRequest}) {
    const _path = '/ocs/v2.php/apps/spreed/temp-user-avatar';
    final _uri = Uri.parse('${_rootClient.baseURL}$_path');
    final _request = _i3.Request('delete', _uri);
    _request.headers['Accept'] = 'application/json';
// coverage:ignore-start
    final authentication = _rootClient.authentications?.firstWhereOrNull(
      (auth) => switch (auth) {
        _i1.DynamiteHttpBearerAuthentication() || _i1.DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _request.headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = _$jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _request.headers['OCS-APIRequest'] = const _i4.HeaderEncoder().convert($oCSAPIRequest);

    return _request;
  }

  /// Delete your avatar as a user.
  ///
  /// Returns a [Future] containing a `DynamiteResponse` with the status code, deserialized body and headers.
  /// Throws a `DynamiteApiException` if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Avatar deleted successfully
  ///   * 400: Deleting avatar is not possible
  ///
  /// See:
  ///  * [$tempAvatarDeleteAvatar_Request] for the request send by this method.
  ///  * [$tempAvatarDeleteAvatar_Serializer] for a converter to parse the `Response` from an executed request.
  Future<_i1.DynamiteResponse<TempAvatarDeleteAvatarResponseApplicationJson, void>> tempAvatarDeleteAvatar({
    bool? oCSAPIRequest,
  }) async {
    final _request = $tempAvatarDeleteAvatar_Request(
      oCSAPIRequest: oCSAPIRequest,
    );
    final _response = await _rootClient.httpClient.send(_request);

    final _serializer = $tempAvatarDeleteAvatar_Serializer();
    final _rawResponse = await _i1.ResponseConverter<TempAvatarDeleteAvatarResponseApplicationJson, void>(_serializer)
        .convert(_response);
    return _i1.DynamiteResponse.fromRawResponse(_rawResponse);
  }
}

typedef ChatProxyMessage = BaseMessage;

class AvatarGetAvatarDarkTheme extends EnumClass {
  const AvatarGetAvatarDarkTheme._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const AvatarGetAvatarDarkTheme $0 = _$avatarGetAvatarDarkTheme$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const AvatarGetAvatarDarkTheme $1 = _$avatarGetAvatarDarkTheme$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<AvatarGetAvatarDarkTheme> get values => _$avatarGetAvatarDarkThemeValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static AvatarGetAvatarDarkTheme valueOf(String name) => _$valueOfAvatarGetAvatarDarkTheme(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for AvatarGetAvatarDarkTheme.
  @BuiltValueSerializer(custom: true)
  static Serializer<AvatarGetAvatarDarkTheme> get serializer => const _$AvatarGetAvatarDarkThemeSerializer();
}

class _$AvatarGetAvatarDarkThemeSerializer implements PrimitiveSerializer<AvatarGetAvatarDarkTheme> {
  const _$AvatarGetAvatarDarkThemeSerializer();

  static const Map<AvatarGetAvatarDarkTheme, Object> _toWire = <AvatarGetAvatarDarkTheme, Object>{
    AvatarGetAvatarDarkTheme.$0: 0,
    AvatarGetAvatarDarkTheme.$1: 1,
  };

  static const Map<Object, AvatarGetAvatarDarkTheme> _fromWire = <Object, AvatarGetAvatarDarkTheme>{
    0: AvatarGetAvatarDarkTheme.$0,
    1: AvatarGetAvatarDarkTheme.$1,
  };

  @override
  Iterable<Type> get types => const [AvatarGetAvatarDarkTheme];

  @override
  String get wireName => 'AvatarGetAvatarDarkTheme';

  @override
  Object serialize(
    Serializers serializers,
    AvatarGetAvatarDarkTheme object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  AvatarGetAvatarDarkTheme deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class AvatarGetAvatarApiVersion extends EnumClass {
  const AvatarGetAvatarApiVersion._(super.name);

  /// `v1`
  static const AvatarGetAvatarApiVersion v1 = _$avatarGetAvatarApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<AvatarGetAvatarApiVersion> get values => _$avatarGetAvatarApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static AvatarGetAvatarApiVersion valueOf(String name) => _$valueOfAvatarGetAvatarApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for AvatarGetAvatarApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<AvatarGetAvatarApiVersion> get serializer => const _$AvatarGetAvatarApiVersionSerializer();
}

class _$AvatarGetAvatarApiVersionSerializer implements PrimitiveSerializer<AvatarGetAvatarApiVersion> {
  const _$AvatarGetAvatarApiVersionSerializer();

  static const Map<AvatarGetAvatarApiVersion, Object> _toWire = <AvatarGetAvatarApiVersion, Object>{
    AvatarGetAvatarApiVersion.v1: 'v1',
  };

  static const Map<Object, AvatarGetAvatarApiVersion> _fromWire = <Object, AvatarGetAvatarApiVersion>{
    'v1': AvatarGetAvatarApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [AvatarGetAvatarApiVersion];

  @override
  String get wireName => 'AvatarGetAvatarApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    AvatarGetAvatarApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  AvatarGetAvatarApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class AvatarUploadAvatarApiVersion extends EnumClass {
  const AvatarUploadAvatarApiVersion._(super.name);

  /// `v1`
  static const AvatarUploadAvatarApiVersion v1 = _$avatarUploadAvatarApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<AvatarUploadAvatarApiVersion> get values => _$avatarUploadAvatarApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static AvatarUploadAvatarApiVersion valueOf(String name) => _$valueOfAvatarUploadAvatarApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for AvatarUploadAvatarApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<AvatarUploadAvatarApiVersion> get serializer => const _$AvatarUploadAvatarApiVersionSerializer();
}

class _$AvatarUploadAvatarApiVersionSerializer implements PrimitiveSerializer<AvatarUploadAvatarApiVersion> {
  const _$AvatarUploadAvatarApiVersionSerializer();

  static const Map<AvatarUploadAvatarApiVersion, Object> _toWire = <AvatarUploadAvatarApiVersion, Object>{
    AvatarUploadAvatarApiVersion.v1: 'v1',
  };

  static const Map<Object, AvatarUploadAvatarApiVersion> _fromWire = <Object, AvatarUploadAvatarApiVersion>{
    'v1': AvatarUploadAvatarApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [AvatarUploadAvatarApiVersion];

  @override
  String get wireName => 'AvatarUploadAvatarApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    AvatarUploadAvatarApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  AvatarUploadAvatarApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $OCSMetaInterface {
  String get status;
  int get statuscode;
  String? get message;
  String? get totalitems;
  String? get itemsperpage;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($OCSMetaInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($OCSMetaInterfaceBuilder b) {}
}

abstract class OCSMeta implements $OCSMetaInterface, Built<OCSMeta, OCSMetaBuilder> {
  /// Creates a new OCSMeta object using the builder pattern.
  factory OCSMeta([void Function(OCSMetaBuilder)? b]) = _$OCSMeta;

  // coverage:ignore-start
  const OCSMeta._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory OCSMeta.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for OCSMeta.
  static Serializer<OCSMeta> get serializer => _$oCSMetaSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(OCSMetaBuilder b) {
    $OCSMetaInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(OCSMetaBuilder b) {
    $OCSMetaInterface._validate(b);
  }
}

class ActorType extends EnumClass {
  const ActorType._(super.name);

  /// `users`
  static const ActorType users = _$actorTypeUsers;

  /// `groups`
  static const ActorType groups = _$actorTypeGroups;

  /// `guests`
  static const ActorType guests = _$actorTypeGuests;

  /// `emails`
  static const ActorType emails = _$actorTypeEmails;

  /// `circles`
  static const ActorType circles = _$actorTypeCircles;

  /// `bridged`
  static const ActorType bridged = _$actorTypeBridged;

  /// `bots`
  static const ActorType bots = _$actorTypeBots;

  /// `federated_users`
  @BuiltValueEnumConst(wireName: 'federated_users')
  static const ActorType federatedUsers = _$actorTypeFederatedUsers;

  /// `phones`
  static const ActorType phones = _$actorTypePhones;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<ActorType> get values => _$actorTypeValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static ActorType valueOf(String name) => _$valueOfActorType(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for ActorType.
  @BuiltValueSerializer(custom: true)
  static Serializer<ActorType> get serializer => const _$ActorTypeSerializer();
}

class _$ActorTypeSerializer implements PrimitiveSerializer<ActorType> {
  const _$ActorTypeSerializer();

  static const Map<ActorType, Object> _toWire = <ActorType, Object>{
    ActorType.users: 'users',
    ActorType.groups: 'groups',
    ActorType.guests: 'guests',
    ActorType.emails: 'emails',
    ActorType.circles: 'circles',
    ActorType.bridged: 'bridged',
    ActorType.bots: 'bots',
    ActorType.federatedUsers: 'federated_users',
    ActorType.phones: 'phones',
  };

  static const Map<Object, ActorType> _fromWire = <Object, ActorType>{
    'users': ActorType.users,
    'groups': ActorType.groups,
    'guests': ActorType.guests,
    'emails': ActorType.emails,
    'circles': ActorType.circles,
    'bridged': ActorType.bridged,
    'bots': ActorType.bots,
    'federated_users': ActorType.federatedUsers,
    'phones': ActorType.phones,
  };

  @override
  Iterable<Type> get types => const [ActorType];

  @override
  String get wireName => 'ActorType';

  @override
  Object serialize(
    Serializers serializers,
    ActorType object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ActorType deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class RichObjectParameter_CallType extends EnumClass {
  const RichObjectParameter_CallType._(super.name);

  /// `one2one`
  static const RichObjectParameter_CallType one2one = _$richObjectParameterCallTypeOne2one;

  /// `group`
  static const RichObjectParameter_CallType group = _$richObjectParameterCallTypeGroup;

  /// `public`
  static const RichObjectParameter_CallType public = _$richObjectParameterCallTypePublic;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RichObjectParameter_CallType> get values => _$richObjectParameterCallTypeValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RichObjectParameter_CallType valueOf(String name) => _$valueOfRichObjectParameter_CallType(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RichObjectParameter_CallType.
  @BuiltValueSerializer(custom: true)
  static Serializer<RichObjectParameter_CallType> get serializer => const _$RichObjectParameter_CallTypeSerializer();
}

class _$RichObjectParameter_CallTypeSerializer implements PrimitiveSerializer<RichObjectParameter_CallType> {
  const _$RichObjectParameter_CallTypeSerializer();

  static const Map<RichObjectParameter_CallType, Object> _toWire = <RichObjectParameter_CallType, Object>{
    RichObjectParameter_CallType.one2one: 'one2one',
    RichObjectParameter_CallType.group: 'group',
    RichObjectParameter_CallType.public: 'public',
  };

  static const Map<Object, RichObjectParameter_CallType> _fromWire = <Object, RichObjectParameter_CallType>{
    'one2one': RichObjectParameter_CallType.one2one,
    'group': RichObjectParameter_CallType.group,
    'public': RichObjectParameter_CallType.public,
  };

  @override
  Iterable<Type> get types => const [RichObjectParameter_CallType];

  @override
  String get wireName => 'RichObjectParameter_CallType';

  @override
  Object serialize(
    Serializers serializers,
    RichObjectParameter_CallType object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RichObjectParameter_CallType deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

typedef RichObjectParameter_Size = ({int? $int, String? string});

class RichObjectParameter_PreviewAvailable extends EnumClass {
  const RichObjectParameter_PreviewAvailable._(super.name);

  /// `yes`
  static const RichObjectParameter_PreviewAvailable yes = _$richObjectParameterPreviewAvailableYes;

  /// `no`
  static const RichObjectParameter_PreviewAvailable no = _$richObjectParameterPreviewAvailableNo;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RichObjectParameter_PreviewAvailable> get values => _$richObjectParameterPreviewAvailableValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RichObjectParameter_PreviewAvailable valueOf(String name) =>
      _$valueOfRichObjectParameter_PreviewAvailable(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RichObjectParameter_PreviewAvailable.
  @BuiltValueSerializer(custom: true)
  static Serializer<RichObjectParameter_PreviewAvailable> get serializer =>
      const _$RichObjectParameter_PreviewAvailableSerializer();
}

class _$RichObjectParameter_PreviewAvailableSerializer
    implements PrimitiveSerializer<RichObjectParameter_PreviewAvailable> {
  const _$RichObjectParameter_PreviewAvailableSerializer();

  static const Map<RichObjectParameter_PreviewAvailable, Object> _toWire =
      <RichObjectParameter_PreviewAvailable, Object>{
    RichObjectParameter_PreviewAvailable.yes: 'yes',
    RichObjectParameter_PreviewAvailable.no: 'no',
  };

  static const Map<Object, RichObjectParameter_PreviewAvailable> _fromWire =
      <Object, RichObjectParameter_PreviewAvailable>{
    'yes': RichObjectParameter_PreviewAvailable.yes,
    'no': RichObjectParameter_PreviewAvailable.no,
  };

  @override
  Iterable<Type> get types => const [RichObjectParameter_PreviewAvailable];

  @override
  String get wireName => 'RichObjectParameter_PreviewAvailable';

  @override
  Object serialize(
    Serializers serializers,
    RichObjectParameter_PreviewAvailable object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RichObjectParameter_PreviewAvailable deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class RichObjectParameter_Visibility extends EnumClass {
  const RichObjectParameter_Visibility._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const RichObjectParameter_Visibility $0 = _$richObjectParameterVisibility$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const RichObjectParameter_Visibility $1 = _$richObjectParameterVisibility$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RichObjectParameter_Visibility> get values => _$richObjectParameterVisibilityValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RichObjectParameter_Visibility valueOf(String name) => _$valueOfRichObjectParameter_Visibility(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RichObjectParameter_Visibility.
  @BuiltValueSerializer(custom: true)
  static Serializer<RichObjectParameter_Visibility> get serializer =>
      const _$RichObjectParameter_VisibilitySerializer();
}

class _$RichObjectParameter_VisibilitySerializer implements PrimitiveSerializer<RichObjectParameter_Visibility> {
  const _$RichObjectParameter_VisibilitySerializer();

  static const Map<RichObjectParameter_Visibility, Object> _toWire = <RichObjectParameter_Visibility, Object>{
    RichObjectParameter_Visibility.$0: '0',
    RichObjectParameter_Visibility.$1: '1',
  };

  static const Map<Object, RichObjectParameter_Visibility> _fromWire = <Object, RichObjectParameter_Visibility>{
    '0': RichObjectParameter_Visibility.$0,
    '1': RichObjectParameter_Visibility.$1,
  };

  @override
  Iterable<Type> get types => const [RichObjectParameter_Visibility];

  @override
  String get wireName => 'RichObjectParameter_Visibility';

  @override
  Object serialize(
    Serializers serializers,
    RichObjectParameter_Visibility object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RichObjectParameter_Visibility deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class RichObjectParameter_Assignable extends EnumClass {
  const RichObjectParameter_Assignable._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const RichObjectParameter_Assignable $0 = _$richObjectParameterAssignable$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const RichObjectParameter_Assignable $1 = _$richObjectParameterAssignable$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RichObjectParameter_Assignable> get values => _$richObjectParameterAssignableValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RichObjectParameter_Assignable valueOf(String name) => _$valueOfRichObjectParameter_Assignable(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RichObjectParameter_Assignable.
  @BuiltValueSerializer(custom: true)
  static Serializer<RichObjectParameter_Assignable> get serializer =>
      const _$RichObjectParameter_AssignableSerializer();
}

class _$RichObjectParameter_AssignableSerializer implements PrimitiveSerializer<RichObjectParameter_Assignable> {
  const _$RichObjectParameter_AssignableSerializer();

  static const Map<RichObjectParameter_Assignable, Object> _toWire = <RichObjectParameter_Assignable, Object>{
    RichObjectParameter_Assignable.$0: '0',
    RichObjectParameter_Assignable.$1: '1',
  };

  static const Map<Object, RichObjectParameter_Assignable> _fromWire = <Object, RichObjectParameter_Assignable>{
    '0': RichObjectParameter_Assignable.$0,
    '1': RichObjectParameter_Assignable.$1,
  };

  @override
  Iterable<Type> get types => const [RichObjectParameter_Assignable];

  @override
  String get wireName => 'RichObjectParameter_Assignable';

  @override
  Object serialize(
    Serializers serializers,
    RichObjectParameter_Assignable object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RichObjectParameter_Assignable deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

typedef RichObjectParameter_Width = ({int? $int, String? string});
typedef RichObjectParameter_Height = ({int? $int, String? string});

@BuiltValue(instantiable: false)
abstract interface class $RichObjectParameterInterface {
  String get type;
  String get id;
  String get name;
  String? get server;
  String? get link;
  @BuiltValueField(wireName: 'call-type')
  RichObjectParameter_CallType? get callType;
  @BuiltValueField(wireName: 'icon-url')
  String? get iconUrl;
  @BuiltValueField(wireName: 'message-id')
  String? get messageId;
  String? get boardname;
  String? get stackname;
  RichObjectParameter_Size? get size;
  String? get path;
  String? get mimetype;
  @BuiltValueField(wireName: 'preview-available')
  RichObjectParameter_PreviewAvailable? get previewAvailable;
  String? get mtime;
  String? get latitude;
  String? get longitude;
  String? get description;
  String? get thumb;
  String? get website;
  RichObjectParameter_Visibility? get visibility;
  RichObjectParameter_Assignable? get assignable;
  String? get conversation;
  String? get etag;
  RichObjectParameter_Width? get width;
  RichObjectParameter_Height? get height;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RichObjectParameterInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RichObjectParameterInterfaceBuilder b) {
    b.size?.validateOneOf();
    b.width?.validateOneOf();
    b.height?.validateOneOf();
  }
}

abstract class RichObjectParameter
    implements $RichObjectParameterInterface, Built<RichObjectParameter, RichObjectParameterBuilder> {
  /// Creates a new RichObjectParameter object using the builder pattern.
  factory RichObjectParameter([void Function(RichObjectParameterBuilder)? b]) = _$RichObjectParameter;

  // coverage:ignore-start
  const RichObjectParameter._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RichObjectParameter.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RichObjectParameter.
  static Serializer<RichObjectParameter> get serializer => _$richObjectParameterSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RichObjectParameterBuilder b) {
    $RichObjectParameterInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RichObjectParameterBuilder b) {
    $RichObjectParameterInterface._validate(b);
  }
}

class MessageType extends EnumClass {
  const MessageType._(super.name);

  /// `comment`
  static const MessageType comment = _$messageTypeComment;

  /// `system`
  static const MessageType system = _$messageTypeSystem;

  /// `object_shared`
  @BuiltValueEnumConst(wireName: 'object_shared')
  static const MessageType objectShared = _$messageTypeObjectShared;

  /// `command`
  static const MessageType command = _$messageTypeCommand;

  /// `comment_deleted`
  @BuiltValueEnumConst(wireName: 'comment_deleted')
  static const MessageType commentDeleted = _$messageTypeCommentDeleted;

  /// `reaction`
  static const MessageType reaction = _$messageTypeReaction;

  /// `reaction_deleted`
  @BuiltValueEnumConst(wireName: 'reaction_deleted')
  static const MessageType reactionDeleted = _$messageTypeReactionDeleted;

  /// `voice-message`
  @BuiltValueEnumConst(wireName: 'voice-message')
  static const MessageType voiceMessage = _$messageTypeVoiceMessage;

  /// `record-audio`
  @BuiltValueEnumConst(wireName: 'record-audio')
  static const MessageType recordAudio = _$messageTypeRecordAudio;

  /// `record-video`
  @BuiltValueEnumConst(wireName: 'record-video')
  static const MessageType recordVideo = _$messageTypeRecordVideo;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<MessageType> get values => _$messageTypeValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static MessageType valueOf(String name) => _$valueOfMessageType(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for MessageType.
  @BuiltValueSerializer(custom: true)
  static Serializer<MessageType> get serializer => const _$MessageTypeSerializer();
}

class _$MessageTypeSerializer implements PrimitiveSerializer<MessageType> {
  const _$MessageTypeSerializer();

  static const Map<MessageType, Object> _toWire = <MessageType, Object>{
    MessageType.comment: 'comment',
    MessageType.system: 'system',
    MessageType.objectShared: 'object_shared',
    MessageType.command: 'command',
    MessageType.commentDeleted: 'comment_deleted',
    MessageType.reaction: 'reaction',
    MessageType.reactionDeleted: 'reaction_deleted',
    MessageType.voiceMessage: 'voice-message',
    MessageType.recordAudio: 'record-audio',
    MessageType.recordVideo: 'record-video',
  };

  static const Map<Object, MessageType> _fromWire = <Object, MessageType>{
    'comment': MessageType.comment,
    'system': MessageType.system,
    'object_shared': MessageType.objectShared,
    'command': MessageType.command,
    'comment_deleted': MessageType.commentDeleted,
    'reaction': MessageType.reaction,
    'reaction_deleted': MessageType.reactionDeleted,
    'voice-message': MessageType.voiceMessage,
    'record-audio': MessageType.recordAudio,
    'record-video': MessageType.recordVideo,
  };

  @override
  Iterable<Type> get types => const [MessageType];

  @override
  String get wireName => 'MessageType';

  @override
  Object serialize(
    Serializers serializers,
    MessageType object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  MessageType deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BaseMessageInterface {
  String get actorDisplayName;
  String get actorId;
  ActorType get actorType;
  int get expirationTimestamp;
  String get message;
  BuiltMap<String, RichObjectParameter> get messageParameters;
  MessageType get messageType;
  String get systemMessage;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BaseMessageInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BaseMessageInterfaceBuilder b) {}
}

abstract class BaseMessage implements $BaseMessageInterface, Built<BaseMessage, BaseMessageBuilder> {
  /// Creates a new BaseMessage object using the builder pattern.
  factory BaseMessage([void Function(BaseMessageBuilder)? b]) = _$BaseMessage;

  // coverage:ignore-start
  const BaseMessage._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BaseMessage.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BaseMessage.
  static Serializer<BaseMessage> get serializer => _$baseMessageSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BaseMessageBuilder b) {
    $BaseMessageInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BaseMessageBuilder b) {
    $BaseMessageInterface._validate(b);
  }
}

class ChatMessage_Deleted extends EnumClass {
  const ChatMessage_Deleted._(super.name);

  /// `true`
  @BuiltValueEnumConst(wireName: 'true')
  static const ChatMessage_Deleted $true = _$chatMessageDeleted$true;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<ChatMessage_Deleted> get values => _$chatMessageDeletedValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static ChatMessage_Deleted valueOf(String name) => _$valueOfChatMessage_Deleted(name);

  /// Returns the serialized value of this enum value.
  bool get value => _$jsonSerializers.serializeWith(serializer, this)! as bool;

  /// Serializer for ChatMessage_Deleted.
  @BuiltValueSerializer(custom: true)
  static Serializer<ChatMessage_Deleted> get serializer => const _$ChatMessage_DeletedSerializer();
}

class _$ChatMessage_DeletedSerializer implements PrimitiveSerializer<ChatMessage_Deleted> {
  const _$ChatMessage_DeletedSerializer();

  static const Map<ChatMessage_Deleted, Object> _toWire = <ChatMessage_Deleted, Object>{
    ChatMessage_Deleted.$true: true,
  };

  static const Map<Object, ChatMessage_Deleted> _fromWire = <Object, ChatMessage_Deleted>{
    true: ChatMessage_Deleted.$true,
  };

  @override
  Iterable<Type> get types => const [ChatMessage_Deleted];

  @override
  String get wireName => 'ChatMessage_Deleted';

  @override
  Object serialize(
    Serializers serializers,
    ChatMessage_Deleted object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatMessage_Deleted deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatMessageInterface implements $BaseMessageInterface {
  ChatMessage_Deleted? get deleted;
  int get id;
  bool get isReplyable;
  bool? get markdown;
  BuiltMap<String, int> get reactions;
  String get referenceId;
  int get timestamp;
  String get token;
  String? get lastEditActorDisplayName;
  String? get lastEditActorId;
  ActorType? get lastEditActorType;
  int? get lastEditTimestamp;
  bool? get silent;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatMessageInterfaceBuilder b) {
    $BaseMessageInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatMessageInterfaceBuilder b) {
    $BaseMessageInterface._validate(b);
  }
}

abstract class ChatMessage implements $ChatMessageInterface, Built<ChatMessage, ChatMessageBuilder> {
  /// Creates a new ChatMessage object using the builder pattern.
  factory ChatMessage([void Function(ChatMessageBuilder)? b]) = _$ChatMessage;

  // coverage:ignore-start
  const ChatMessage._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatMessage.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatMessage.
  static Serializer<ChatMessage> get serializer => _$chatMessageSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatMessageBuilder b) {
    $ChatMessageInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatMessageBuilder b) {
    $ChatMessageInterface._validate(b);
  }
}

typedef RoomLastMessage = ({BaseMessage? baseMessage, ChatMessage? chatMessage});
typedef Room_LastMessage = ({BaseMessage? baseMessage, BuiltList<Never>? builtListNever, ChatMessage? chatMessage});

@BuiltValue(instantiable: false)
abstract interface class $RoomInterface {
  String get actorId;
  ActorType get actorType;
  int get attendeeId;
  int get attendeePermissions;
  String? get attendeePin;
  String get avatarVersion;
  int get breakoutRoomMode;
  int get breakoutRoomStatus;
  int get callFlag;
  int get callPermissions;
  int get callRecording;
  int get callStartTime;
  bool get canDeleteConversation;
  bool get canEnableSIP;
  bool get canLeaveConversation;
  bool get canStartCall;
  int get defaultPermissions;
  String get description;
  String get displayName;
  bool get hasCall;
  bool get hasPassword;
  int get id;
  bool get isCustomAvatar;
  bool get isFavorite;
  int get lastActivity;
  int get lastCommonReadMessage;
  Room_LastMessage get lastMessage;
  int get lastPing;
  int get lastReadMessage;
  int get listable;
  int get lobbyState;
  int get lobbyTimer;
  int get messageExpiration;
  String get name;
  int get notificationCalls;
  int get notificationLevel;
  String get objectId;
  String get objectType;
  int get participantFlags;
  int get participantType;
  int get permissions;
  int get readOnly;
  int? get recordingConsent;
  String get sessionId;
  int get sipEnabled;
  String? get status;
  int? get statusClearAt;
  String? get statusIcon;
  String? get statusMessage;
  String get token;
  int get type;
  bool get unreadMention;
  bool get unreadMentionDirect;
  int get unreadMessages;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomInterfaceBuilder b) {
    b.lastMessage?.validateAnyOf();
  }
}

abstract class Room implements $RoomInterface, Built<Room, RoomBuilder> {
  /// Creates a new Room object using the builder pattern.
  factory Room([void Function(RoomBuilder)? b]) = _$Room;

  // coverage:ignore-start
  const Room._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory Room.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for Room.
  static Serializer<Room> get serializer => _$roomSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomBuilder b) {
    $RoomInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomBuilder b) {
    $RoomInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $AvatarUploadAvatarResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($AvatarUploadAvatarResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($AvatarUploadAvatarResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class AvatarUploadAvatarResponseApplicationJson_Ocs
    implements
        $AvatarUploadAvatarResponseApplicationJson_OcsInterface,
        Built<AvatarUploadAvatarResponseApplicationJson_Ocs, AvatarUploadAvatarResponseApplicationJson_OcsBuilder> {
  /// Creates a new AvatarUploadAvatarResponseApplicationJson_Ocs object using the builder pattern.
  factory AvatarUploadAvatarResponseApplicationJson_Ocs([
    void Function(AvatarUploadAvatarResponseApplicationJson_OcsBuilder)? b,
  ]) = _$AvatarUploadAvatarResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const AvatarUploadAvatarResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory AvatarUploadAvatarResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for AvatarUploadAvatarResponseApplicationJson_Ocs.
  static Serializer<AvatarUploadAvatarResponseApplicationJson_Ocs> get serializer =>
      _$avatarUploadAvatarResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(AvatarUploadAvatarResponseApplicationJson_OcsBuilder b) {
    $AvatarUploadAvatarResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(AvatarUploadAvatarResponseApplicationJson_OcsBuilder b) {
    $AvatarUploadAvatarResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $AvatarUploadAvatarResponseApplicationJsonInterface {
  AvatarUploadAvatarResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($AvatarUploadAvatarResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($AvatarUploadAvatarResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class AvatarUploadAvatarResponseApplicationJson
    implements
        $AvatarUploadAvatarResponseApplicationJsonInterface,
        Built<AvatarUploadAvatarResponseApplicationJson, AvatarUploadAvatarResponseApplicationJsonBuilder> {
  /// Creates a new AvatarUploadAvatarResponseApplicationJson object using the builder pattern.
  factory AvatarUploadAvatarResponseApplicationJson([
    void Function(AvatarUploadAvatarResponseApplicationJsonBuilder)? b,
  ]) = _$AvatarUploadAvatarResponseApplicationJson;

  // coverage:ignore-start
  const AvatarUploadAvatarResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory AvatarUploadAvatarResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for AvatarUploadAvatarResponseApplicationJson.
  static Serializer<AvatarUploadAvatarResponseApplicationJson> get serializer =>
      _$avatarUploadAvatarResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(AvatarUploadAvatarResponseApplicationJsonBuilder b) {
    $AvatarUploadAvatarResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(AvatarUploadAvatarResponseApplicationJsonBuilder b) {
    $AvatarUploadAvatarResponseApplicationJsonInterface._validate(b);
  }
}

class AvatarDeleteAvatarApiVersion extends EnumClass {
  const AvatarDeleteAvatarApiVersion._(super.name);

  /// `v1`
  static const AvatarDeleteAvatarApiVersion v1 = _$avatarDeleteAvatarApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<AvatarDeleteAvatarApiVersion> get values => _$avatarDeleteAvatarApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static AvatarDeleteAvatarApiVersion valueOf(String name) => _$valueOfAvatarDeleteAvatarApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for AvatarDeleteAvatarApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<AvatarDeleteAvatarApiVersion> get serializer => const _$AvatarDeleteAvatarApiVersionSerializer();
}

class _$AvatarDeleteAvatarApiVersionSerializer implements PrimitiveSerializer<AvatarDeleteAvatarApiVersion> {
  const _$AvatarDeleteAvatarApiVersionSerializer();

  static const Map<AvatarDeleteAvatarApiVersion, Object> _toWire = <AvatarDeleteAvatarApiVersion, Object>{
    AvatarDeleteAvatarApiVersion.v1: 'v1',
  };

  static const Map<Object, AvatarDeleteAvatarApiVersion> _fromWire = <Object, AvatarDeleteAvatarApiVersion>{
    'v1': AvatarDeleteAvatarApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [AvatarDeleteAvatarApiVersion];

  @override
  String get wireName => 'AvatarDeleteAvatarApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    AvatarDeleteAvatarApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  AvatarDeleteAvatarApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $AvatarDeleteAvatarResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($AvatarDeleteAvatarResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($AvatarDeleteAvatarResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class AvatarDeleteAvatarResponseApplicationJson_Ocs
    implements
        $AvatarDeleteAvatarResponseApplicationJson_OcsInterface,
        Built<AvatarDeleteAvatarResponseApplicationJson_Ocs, AvatarDeleteAvatarResponseApplicationJson_OcsBuilder> {
  /// Creates a new AvatarDeleteAvatarResponseApplicationJson_Ocs object using the builder pattern.
  factory AvatarDeleteAvatarResponseApplicationJson_Ocs([
    void Function(AvatarDeleteAvatarResponseApplicationJson_OcsBuilder)? b,
  ]) = _$AvatarDeleteAvatarResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const AvatarDeleteAvatarResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory AvatarDeleteAvatarResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for AvatarDeleteAvatarResponseApplicationJson_Ocs.
  static Serializer<AvatarDeleteAvatarResponseApplicationJson_Ocs> get serializer =>
      _$avatarDeleteAvatarResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(AvatarDeleteAvatarResponseApplicationJson_OcsBuilder b) {
    $AvatarDeleteAvatarResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(AvatarDeleteAvatarResponseApplicationJson_OcsBuilder b) {
    $AvatarDeleteAvatarResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $AvatarDeleteAvatarResponseApplicationJsonInterface {
  AvatarDeleteAvatarResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($AvatarDeleteAvatarResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($AvatarDeleteAvatarResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class AvatarDeleteAvatarResponseApplicationJson
    implements
        $AvatarDeleteAvatarResponseApplicationJsonInterface,
        Built<AvatarDeleteAvatarResponseApplicationJson, AvatarDeleteAvatarResponseApplicationJsonBuilder> {
  /// Creates a new AvatarDeleteAvatarResponseApplicationJson object using the builder pattern.
  factory AvatarDeleteAvatarResponseApplicationJson([
    void Function(AvatarDeleteAvatarResponseApplicationJsonBuilder)? b,
  ]) = _$AvatarDeleteAvatarResponseApplicationJson;

  // coverage:ignore-start
  const AvatarDeleteAvatarResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory AvatarDeleteAvatarResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for AvatarDeleteAvatarResponseApplicationJson.
  static Serializer<AvatarDeleteAvatarResponseApplicationJson> get serializer =>
      _$avatarDeleteAvatarResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(AvatarDeleteAvatarResponseApplicationJsonBuilder b) {
    $AvatarDeleteAvatarResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(AvatarDeleteAvatarResponseApplicationJsonBuilder b) {
    $AvatarDeleteAvatarResponseApplicationJsonInterface._validate(b);
  }
}

class AvatarEmojiAvatarApiVersion extends EnumClass {
  const AvatarEmojiAvatarApiVersion._(super.name);

  /// `v1`
  static const AvatarEmojiAvatarApiVersion v1 = _$avatarEmojiAvatarApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<AvatarEmojiAvatarApiVersion> get values => _$avatarEmojiAvatarApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static AvatarEmojiAvatarApiVersion valueOf(String name) => _$valueOfAvatarEmojiAvatarApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for AvatarEmojiAvatarApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<AvatarEmojiAvatarApiVersion> get serializer => const _$AvatarEmojiAvatarApiVersionSerializer();
}

class _$AvatarEmojiAvatarApiVersionSerializer implements PrimitiveSerializer<AvatarEmojiAvatarApiVersion> {
  const _$AvatarEmojiAvatarApiVersionSerializer();

  static const Map<AvatarEmojiAvatarApiVersion, Object> _toWire = <AvatarEmojiAvatarApiVersion, Object>{
    AvatarEmojiAvatarApiVersion.v1: 'v1',
  };

  static const Map<Object, AvatarEmojiAvatarApiVersion> _fromWire = <Object, AvatarEmojiAvatarApiVersion>{
    'v1': AvatarEmojiAvatarApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [AvatarEmojiAvatarApiVersion];

  @override
  String get wireName => 'AvatarEmojiAvatarApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    AvatarEmojiAvatarApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  AvatarEmojiAvatarApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $AvatarEmojiAvatarResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($AvatarEmojiAvatarResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($AvatarEmojiAvatarResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class AvatarEmojiAvatarResponseApplicationJson_Ocs
    implements
        $AvatarEmojiAvatarResponseApplicationJson_OcsInterface,
        Built<AvatarEmojiAvatarResponseApplicationJson_Ocs, AvatarEmojiAvatarResponseApplicationJson_OcsBuilder> {
  /// Creates a new AvatarEmojiAvatarResponseApplicationJson_Ocs object using the builder pattern.
  factory AvatarEmojiAvatarResponseApplicationJson_Ocs([
    void Function(AvatarEmojiAvatarResponseApplicationJson_OcsBuilder)? b,
  ]) = _$AvatarEmojiAvatarResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const AvatarEmojiAvatarResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory AvatarEmojiAvatarResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for AvatarEmojiAvatarResponseApplicationJson_Ocs.
  static Serializer<AvatarEmojiAvatarResponseApplicationJson_Ocs> get serializer =>
      _$avatarEmojiAvatarResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(AvatarEmojiAvatarResponseApplicationJson_OcsBuilder b) {
    $AvatarEmojiAvatarResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(AvatarEmojiAvatarResponseApplicationJson_OcsBuilder b) {
    $AvatarEmojiAvatarResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $AvatarEmojiAvatarResponseApplicationJsonInterface {
  AvatarEmojiAvatarResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($AvatarEmojiAvatarResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($AvatarEmojiAvatarResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class AvatarEmojiAvatarResponseApplicationJson
    implements
        $AvatarEmojiAvatarResponseApplicationJsonInterface,
        Built<AvatarEmojiAvatarResponseApplicationJson, AvatarEmojiAvatarResponseApplicationJsonBuilder> {
  /// Creates a new AvatarEmojiAvatarResponseApplicationJson object using the builder pattern.
  factory AvatarEmojiAvatarResponseApplicationJson([
    void Function(AvatarEmojiAvatarResponseApplicationJsonBuilder)? b,
  ]) = _$AvatarEmojiAvatarResponseApplicationJson;

  // coverage:ignore-start
  const AvatarEmojiAvatarResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory AvatarEmojiAvatarResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for AvatarEmojiAvatarResponseApplicationJson.
  static Serializer<AvatarEmojiAvatarResponseApplicationJson> get serializer =>
      _$avatarEmojiAvatarResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(AvatarEmojiAvatarResponseApplicationJsonBuilder b) {
    $AvatarEmojiAvatarResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(AvatarEmojiAvatarResponseApplicationJsonBuilder b) {
    $AvatarEmojiAvatarResponseApplicationJsonInterface._validate(b);
  }
}

class AvatarGetAvatarDarkApiVersion extends EnumClass {
  const AvatarGetAvatarDarkApiVersion._(super.name);

  /// `v1`
  static const AvatarGetAvatarDarkApiVersion v1 = _$avatarGetAvatarDarkApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<AvatarGetAvatarDarkApiVersion> get values => _$avatarGetAvatarDarkApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static AvatarGetAvatarDarkApiVersion valueOf(String name) => _$valueOfAvatarGetAvatarDarkApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for AvatarGetAvatarDarkApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<AvatarGetAvatarDarkApiVersion> get serializer => const _$AvatarGetAvatarDarkApiVersionSerializer();
}

class _$AvatarGetAvatarDarkApiVersionSerializer implements PrimitiveSerializer<AvatarGetAvatarDarkApiVersion> {
  const _$AvatarGetAvatarDarkApiVersionSerializer();

  static const Map<AvatarGetAvatarDarkApiVersion, Object> _toWire = <AvatarGetAvatarDarkApiVersion, Object>{
    AvatarGetAvatarDarkApiVersion.v1: 'v1',
  };

  static const Map<Object, AvatarGetAvatarDarkApiVersion> _fromWire = <Object, AvatarGetAvatarDarkApiVersion>{
    'v1': AvatarGetAvatarDarkApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [AvatarGetAvatarDarkApiVersion];

  @override
  String get wireName => 'AvatarGetAvatarDarkApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    AvatarGetAvatarDarkApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  AvatarGetAvatarDarkApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class AvatarGetUserProxyAvatarWithoutRoomSize extends EnumClass {
  const AvatarGetUserProxyAvatarWithoutRoomSize._(super.name);

  /// `64`
  @BuiltValueEnumConst(wireName: '64')
  static const AvatarGetUserProxyAvatarWithoutRoomSize $64 = _$avatarGetUserProxyAvatarWithoutRoomSize$64;

  /// `512`
  @BuiltValueEnumConst(wireName: '512')
  static const AvatarGetUserProxyAvatarWithoutRoomSize $512 = _$avatarGetUserProxyAvatarWithoutRoomSize$512;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<AvatarGetUserProxyAvatarWithoutRoomSize> get values =>
      _$avatarGetUserProxyAvatarWithoutRoomSizeValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static AvatarGetUserProxyAvatarWithoutRoomSize valueOf(String name) =>
      _$valueOfAvatarGetUserProxyAvatarWithoutRoomSize(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for AvatarGetUserProxyAvatarWithoutRoomSize.
  @BuiltValueSerializer(custom: true)
  static Serializer<AvatarGetUserProxyAvatarWithoutRoomSize> get serializer =>
      const _$AvatarGetUserProxyAvatarWithoutRoomSizeSerializer();
}

class _$AvatarGetUserProxyAvatarWithoutRoomSizeSerializer
    implements PrimitiveSerializer<AvatarGetUserProxyAvatarWithoutRoomSize> {
  const _$AvatarGetUserProxyAvatarWithoutRoomSizeSerializer();

  static const Map<AvatarGetUserProxyAvatarWithoutRoomSize, Object> _toWire =
      <AvatarGetUserProxyAvatarWithoutRoomSize, Object>{
    AvatarGetUserProxyAvatarWithoutRoomSize.$64: 64,
    AvatarGetUserProxyAvatarWithoutRoomSize.$512: 512,
  };

  static const Map<Object, AvatarGetUserProxyAvatarWithoutRoomSize> _fromWire =
      <Object, AvatarGetUserProxyAvatarWithoutRoomSize>{
    64: AvatarGetUserProxyAvatarWithoutRoomSize.$64,
    512: AvatarGetUserProxyAvatarWithoutRoomSize.$512,
  };

  @override
  Iterable<Type> get types => const [AvatarGetUserProxyAvatarWithoutRoomSize];

  @override
  String get wireName => 'AvatarGetUserProxyAvatarWithoutRoomSize';

  @override
  Object serialize(
    Serializers serializers,
    AvatarGetUserProxyAvatarWithoutRoomSize object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  AvatarGetUserProxyAvatarWithoutRoomSize deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class AvatarGetUserProxyAvatarWithoutRoomDarkTheme extends EnumClass {
  const AvatarGetUserProxyAvatarWithoutRoomDarkTheme._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const AvatarGetUserProxyAvatarWithoutRoomDarkTheme $0 = _$avatarGetUserProxyAvatarWithoutRoomDarkTheme$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const AvatarGetUserProxyAvatarWithoutRoomDarkTheme $1 = _$avatarGetUserProxyAvatarWithoutRoomDarkTheme$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<AvatarGetUserProxyAvatarWithoutRoomDarkTheme> get values =>
      _$avatarGetUserProxyAvatarWithoutRoomDarkThemeValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static AvatarGetUserProxyAvatarWithoutRoomDarkTheme valueOf(String name) =>
      _$valueOfAvatarGetUserProxyAvatarWithoutRoomDarkTheme(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for AvatarGetUserProxyAvatarWithoutRoomDarkTheme.
  @BuiltValueSerializer(custom: true)
  static Serializer<AvatarGetUserProxyAvatarWithoutRoomDarkTheme> get serializer =>
      const _$AvatarGetUserProxyAvatarWithoutRoomDarkThemeSerializer();
}

class _$AvatarGetUserProxyAvatarWithoutRoomDarkThemeSerializer
    implements PrimitiveSerializer<AvatarGetUserProxyAvatarWithoutRoomDarkTheme> {
  const _$AvatarGetUserProxyAvatarWithoutRoomDarkThemeSerializer();

  static const Map<AvatarGetUserProxyAvatarWithoutRoomDarkTheme, Object> _toWire =
      <AvatarGetUserProxyAvatarWithoutRoomDarkTheme, Object>{
    AvatarGetUserProxyAvatarWithoutRoomDarkTheme.$0: 0,
    AvatarGetUserProxyAvatarWithoutRoomDarkTheme.$1: 1,
  };

  static const Map<Object, AvatarGetUserProxyAvatarWithoutRoomDarkTheme> _fromWire =
      <Object, AvatarGetUserProxyAvatarWithoutRoomDarkTheme>{
    0: AvatarGetUserProxyAvatarWithoutRoomDarkTheme.$0,
    1: AvatarGetUserProxyAvatarWithoutRoomDarkTheme.$1,
  };

  @override
  Iterable<Type> get types => const [AvatarGetUserProxyAvatarWithoutRoomDarkTheme];

  @override
  String get wireName => 'AvatarGetUserProxyAvatarWithoutRoomDarkTheme';

  @override
  Object serialize(
    Serializers serializers,
    AvatarGetUserProxyAvatarWithoutRoomDarkTheme object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  AvatarGetUserProxyAvatarWithoutRoomDarkTheme deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class AvatarGetUserProxyAvatarWithoutRoomApiVersion extends EnumClass {
  const AvatarGetUserProxyAvatarWithoutRoomApiVersion._(super.name);

  /// `v1`
  static const AvatarGetUserProxyAvatarWithoutRoomApiVersion v1 = _$avatarGetUserProxyAvatarWithoutRoomApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<AvatarGetUserProxyAvatarWithoutRoomApiVersion> get values =>
      _$avatarGetUserProxyAvatarWithoutRoomApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static AvatarGetUserProxyAvatarWithoutRoomApiVersion valueOf(String name) =>
      _$valueOfAvatarGetUserProxyAvatarWithoutRoomApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for AvatarGetUserProxyAvatarWithoutRoomApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<AvatarGetUserProxyAvatarWithoutRoomApiVersion> get serializer =>
      const _$AvatarGetUserProxyAvatarWithoutRoomApiVersionSerializer();
}

class _$AvatarGetUserProxyAvatarWithoutRoomApiVersionSerializer
    implements PrimitiveSerializer<AvatarGetUserProxyAvatarWithoutRoomApiVersion> {
  const _$AvatarGetUserProxyAvatarWithoutRoomApiVersionSerializer();

  static const Map<AvatarGetUserProxyAvatarWithoutRoomApiVersion, Object> _toWire =
      <AvatarGetUserProxyAvatarWithoutRoomApiVersion, Object>{
    AvatarGetUserProxyAvatarWithoutRoomApiVersion.v1: 'v1',
  };

  static const Map<Object, AvatarGetUserProxyAvatarWithoutRoomApiVersion> _fromWire =
      <Object, AvatarGetUserProxyAvatarWithoutRoomApiVersion>{
    'v1': AvatarGetUserProxyAvatarWithoutRoomApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [AvatarGetUserProxyAvatarWithoutRoomApiVersion];

  @override
  String get wireName => 'AvatarGetUserProxyAvatarWithoutRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    AvatarGetUserProxyAvatarWithoutRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  AvatarGetUserProxyAvatarWithoutRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class AvatarGetUserProxyAvatarDarkWithoutRoomSize extends EnumClass {
  const AvatarGetUserProxyAvatarDarkWithoutRoomSize._(super.name);

  /// `64`
  @BuiltValueEnumConst(wireName: '64')
  static const AvatarGetUserProxyAvatarDarkWithoutRoomSize $64 = _$avatarGetUserProxyAvatarDarkWithoutRoomSize$64;

  /// `512`
  @BuiltValueEnumConst(wireName: '512')
  static const AvatarGetUserProxyAvatarDarkWithoutRoomSize $512 = _$avatarGetUserProxyAvatarDarkWithoutRoomSize$512;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<AvatarGetUserProxyAvatarDarkWithoutRoomSize> get values =>
      _$avatarGetUserProxyAvatarDarkWithoutRoomSizeValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static AvatarGetUserProxyAvatarDarkWithoutRoomSize valueOf(String name) =>
      _$valueOfAvatarGetUserProxyAvatarDarkWithoutRoomSize(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for AvatarGetUserProxyAvatarDarkWithoutRoomSize.
  @BuiltValueSerializer(custom: true)
  static Serializer<AvatarGetUserProxyAvatarDarkWithoutRoomSize> get serializer =>
      const _$AvatarGetUserProxyAvatarDarkWithoutRoomSizeSerializer();
}

class _$AvatarGetUserProxyAvatarDarkWithoutRoomSizeSerializer
    implements PrimitiveSerializer<AvatarGetUserProxyAvatarDarkWithoutRoomSize> {
  const _$AvatarGetUserProxyAvatarDarkWithoutRoomSizeSerializer();

  static const Map<AvatarGetUserProxyAvatarDarkWithoutRoomSize, Object> _toWire =
      <AvatarGetUserProxyAvatarDarkWithoutRoomSize, Object>{
    AvatarGetUserProxyAvatarDarkWithoutRoomSize.$64: 64,
    AvatarGetUserProxyAvatarDarkWithoutRoomSize.$512: 512,
  };

  static const Map<Object, AvatarGetUserProxyAvatarDarkWithoutRoomSize> _fromWire =
      <Object, AvatarGetUserProxyAvatarDarkWithoutRoomSize>{
    64: AvatarGetUserProxyAvatarDarkWithoutRoomSize.$64,
    512: AvatarGetUserProxyAvatarDarkWithoutRoomSize.$512,
  };

  @override
  Iterable<Type> get types => const [AvatarGetUserProxyAvatarDarkWithoutRoomSize];

  @override
  String get wireName => 'AvatarGetUserProxyAvatarDarkWithoutRoomSize';

  @override
  Object serialize(
    Serializers serializers,
    AvatarGetUserProxyAvatarDarkWithoutRoomSize object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  AvatarGetUserProxyAvatarDarkWithoutRoomSize deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class AvatarGetUserProxyAvatarDarkWithoutRoomApiVersion extends EnumClass {
  const AvatarGetUserProxyAvatarDarkWithoutRoomApiVersion._(super.name);

  /// `v1`
  static const AvatarGetUserProxyAvatarDarkWithoutRoomApiVersion v1 =
      _$avatarGetUserProxyAvatarDarkWithoutRoomApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<AvatarGetUserProxyAvatarDarkWithoutRoomApiVersion> get values =>
      _$avatarGetUserProxyAvatarDarkWithoutRoomApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static AvatarGetUserProxyAvatarDarkWithoutRoomApiVersion valueOf(String name) =>
      _$valueOfAvatarGetUserProxyAvatarDarkWithoutRoomApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for AvatarGetUserProxyAvatarDarkWithoutRoomApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<AvatarGetUserProxyAvatarDarkWithoutRoomApiVersion> get serializer =>
      const _$AvatarGetUserProxyAvatarDarkWithoutRoomApiVersionSerializer();
}

class _$AvatarGetUserProxyAvatarDarkWithoutRoomApiVersionSerializer
    implements PrimitiveSerializer<AvatarGetUserProxyAvatarDarkWithoutRoomApiVersion> {
  const _$AvatarGetUserProxyAvatarDarkWithoutRoomApiVersionSerializer();

  static const Map<AvatarGetUserProxyAvatarDarkWithoutRoomApiVersion, Object> _toWire =
      <AvatarGetUserProxyAvatarDarkWithoutRoomApiVersion, Object>{
    AvatarGetUserProxyAvatarDarkWithoutRoomApiVersion.v1: 'v1',
  };

  static const Map<Object, AvatarGetUserProxyAvatarDarkWithoutRoomApiVersion> _fromWire =
      <Object, AvatarGetUserProxyAvatarDarkWithoutRoomApiVersion>{
    'v1': AvatarGetUserProxyAvatarDarkWithoutRoomApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [AvatarGetUserProxyAvatarDarkWithoutRoomApiVersion];

  @override
  String get wireName => 'AvatarGetUserProxyAvatarDarkWithoutRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    AvatarGetUserProxyAvatarDarkWithoutRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  AvatarGetUserProxyAvatarDarkWithoutRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class AvatarGetUserProxyAvatarSize extends EnumClass {
  const AvatarGetUserProxyAvatarSize._(super.name);

  /// `64`
  @BuiltValueEnumConst(wireName: '64')
  static const AvatarGetUserProxyAvatarSize $64 = _$avatarGetUserProxyAvatarSize$64;

  /// `512`
  @BuiltValueEnumConst(wireName: '512')
  static const AvatarGetUserProxyAvatarSize $512 = _$avatarGetUserProxyAvatarSize$512;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<AvatarGetUserProxyAvatarSize> get values => _$avatarGetUserProxyAvatarSizeValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static AvatarGetUserProxyAvatarSize valueOf(String name) => _$valueOfAvatarGetUserProxyAvatarSize(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for AvatarGetUserProxyAvatarSize.
  @BuiltValueSerializer(custom: true)
  static Serializer<AvatarGetUserProxyAvatarSize> get serializer => const _$AvatarGetUserProxyAvatarSizeSerializer();
}

class _$AvatarGetUserProxyAvatarSizeSerializer implements PrimitiveSerializer<AvatarGetUserProxyAvatarSize> {
  const _$AvatarGetUserProxyAvatarSizeSerializer();

  static const Map<AvatarGetUserProxyAvatarSize, Object> _toWire = <AvatarGetUserProxyAvatarSize, Object>{
    AvatarGetUserProxyAvatarSize.$64: 64,
    AvatarGetUserProxyAvatarSize.$512: 512,
  };

  static const Map<Object, AvatarGetUserProxyAvatarSize> _fromWire = <Object, AvatarGetUserProxyAvatarSize>{
    64: AvatarGetUserProxyAvatarSize.$64,
    512: AvatarGetUserProxyAvatarSize.$512,
  };

  @override
  Iterable<Type> get types => const [AvatarGetUserProxyAvatarSize];

  @override
  String get wireName => 'AvatarGetUserProxyAvatarSize';

  @override
  Object serialize(
    Serializers serializers,
    AvatarGetUserProxyAvatarSize object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  AvatarGetUserProxyAvatarSize deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class AvatarGetUserProxyAvatarDarkTheme extends EnumClass {
  const AvatarGetUserProxyAvatarDarkTheme._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const AvatarGetUserProxyAvatarDarkTheme $0 = _$avatarGetUserProxyAvatarDarkTheme$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const AvatarGetUserProxyAvatarDarkTheme $1 = _$avatarGetUserProxyAvatarDarkTheme$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<AvatarGetUserProxyAvatarDarkTheme> get values => _$avatarGetUserProxyAvatarDarkThemeValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static AvatarGetUserProxyAvatarDarkTheme valueOf(String name) => _$valueOfAvatarGetUserProxyAvatarDarkTheme(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for AvatarGetUserProxyAvatarDarkTheme.
  @BuiltValueSerializer(custom: true)
  static Serializer<AvatarGetUserProxyAvatarDarkTheme> get serializer =>
      const _$AvatarGetUserProxyAvatarDarkThemeSerializer();
}

class _$AvatarGetUserProxyAvatarDarkThemeSerializer implements PrimitiveSerializer<AvatarGetUserProxyAvatarDarkTheme> {
  const _$AvatarGetUserProxyAvatarDarkThemeSerializer();

  static const Map<AvatarGetUserProxyAvatarDarkTheme, Object> _toWire = <AvatarGetUserProxyAvatarDarkTheme, Object>{
    AvatarGetUserProxyAvatarDarkTheme.$0: 0,
    AvatarGetUserProxyAvatarDarkTheme.$1: 1,
  };

  static const Map<Object, AvatarGetUserProxyAvatarDarkTheme> _fromWire = <Object, AvatarGetUserProxyAvatarDarkTheme>{
    0: AvatarGetUserProxyAvatarDarkTheme.$0,
    1: AvatarGetUserProxyAvatarDarkTheme.$1,
  };

  @override
  Iterable<Type> get types => const [AvatarGetUserProxyAvatarDarkTheme];

  @override
  String get wireName => 'AvatarGetUserProxyAvatarDarkTheme';

  @override
  Object serialize(
    Serializers serializers,
    AvatarGetUserProxyAvatarDarkTheme object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  AvatarGetUserProxyAvatarDarkTheme deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class AvatarGetUserProxyAvatarApiVersion extends EnumClass {
  const AvatarGetUserProxyAvatarApiVersion._(super.name);

  /// `v1`
  static const AvatarGetUserProxyAvatarApiVersion v1 = _$avatarGetUserProxyAvatarApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<AvatarGetUserProxyAvatarApiVersion> get values => _$avatarGetUserProxyAvatarApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static AvatarGetUserProxyAvatarApiVersion valueOf(String name) => _$valueOfAvatarGetUserProxyAvatarApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for AvatarGetUserProxyAvatarApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<AvatarGetUserProxyAvatarApiVersion> get serializer =>
      const _$AvatarGetUserProxyAvatarApiVersionSerializer();
}

class _$AvatarGetUserProxyAvatarApiVersionSerializer
    implements PrimitiveSerializer<AvatarGetUserProxyAvatarApiVersion> {
  const _$AvatarGetUserProxyAvatarApiVersionSerializer();

  static const Map<AvatarGetUserProxyAvatarApiVersion, Object> _toWire = <AvatarGetUserProxyAvatarApiVersion, Object>{
    AvatarGetUserProxyAvatarApiVersion.v1: 'v1',
  };

  static const Map<Object, AvatarGetUserProxyAvatarApiVersion> _fromWire = <Object, AvatarGetUserProxyAvatarApiVersion>{
    'v1': AvatarGetUserProxyAvatarApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [AvatarGetUserProxyAvatarApiVersion];

  @override
  String get wireName => 'AvatarGetUserProxyAvatarApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    AvatarGetUserProxyAvatarApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  AvatarGetUserProxyAvatarApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class AvatarGetUserProxyAvatarDarkSize extends EnumClass {
  const AvatarGetUserProxyAvatarDarkSize._(super.name);

  /// `64`
  @BuiltValueEnumConst(wireName: '64')
  static const AvatarGetUserProxyAvatarDarkSize $64 = _$avatarGetUserProxyAvatarDarkSize$64;

  /// `512`
  @BuiltValueEnumConst(wireName: '512')
  static const AvatarGetUserProxyAvatarDarkSize $512 = _$avatarGetUserProxyAvatarDarkSize$512;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<AvatarGetUserProxyAvatarDarkSize> get values => _$avatarGetUserProxyAvatarDarkSizeValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static AvatarGetUserProxyAvatarDarkSize valueOf(String name) => _$valueOfAvatarGetUserProxyAvatarDarkSize(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for AvatarGetUserProxyAvatarDarkSize.
  @BuiltValueSerializer(custom: true)
  static Serializer<AvatarGetUserProxyAvatarDarkSize> get serializer =>
      const _$AvatarGetUserProxyAvatarDarkSizeSerializer();
}

class _$AvatarGetUserProxyAvatarDarkSizeSerializer implements PrimitiveSerializer<AvatarGetUserProxyAvatarDarkSize> {
  const _$AvatarGetUserProxyAvatarDarkSizeSerializer();

  static const Map<AvatarGetUserProxyAvatarDarkSize, Object> _toWire = <AvatarGetUserProxyAvatarDarkSize, Object>{
    AvatarGetUserProxyAvatarDarkSize.$64: 64,
    AvatarGetUserProxyAvatarDarkSize.$512: 512,
  };

  static const Map<Object, AvatarGetUserProxyAvatarDarkSize> _fromWire = <Object, AvatarGetUserProxyAvatarDarkSize>{
    64: AvatarGetUserProxyAvatarDarkSize.$64,
    512: AvatarGetUserProxyAvatarDarkSize.$512,
  };

  @override
  Iterable<Type> get types => const [AvatarGetUserProxyAvatarDarkSize];

  @override
  String get wireName => 'AvatarGetUserProxyAvatarDarkSize';

  @override
  Object serialize(
    Serializers serializers,
    AvatarGetUserProxyAvatarDarkSize object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  AvatarGetUserProxyAvatarDarkSize deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class AvatarGetUserProxyAvatarDarkApiVersion extends EnumClass {
  const AvatarGetUserProxyAvatarDarkApiVersion._(super.name);

  /// `v1`
  static const AvatarGetUserProxyAvatarDarkApiVersion v1 = _$avatarGetUserProxyAvatarDarkApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<AvatarGetUserProxyAvatarDarkApiVersion> get values => _$avatarGetUserProxyAvatarDarkApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static AvatarGetUserProxyAvatarDarkApiVersion valueOf(String name) =>
      _$valueOfAvatarGetUserProxyAvatarDarkApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for AvatarGetUserProxyAvatarDarkApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<AvatarGetUserProxyAvatarDarkApiVersion> get serializer =>
      const _$AvatarGetUserProxyAvatarDarkApiVersionSerializer();
}

class _$AvatarGetUserProxyAvatarDarkApiVersionSerializer
    implements PrimitiveSerializer<AvatarGetUserProxyAvatarDarkApiVersion> {
  const _$AvatarGetUserProxyAvatarDarkApiVersionSerializer();

  static const Map<AvatarGetUserProxyAvatarDarkApiVersion, Object> _toWire =
      <AvatarGetUserProxyAvatarDarkApiVersion, Object>{
    AvatarGetUserProxyAvatarDarkApiVersion.v1: 'v1',
  };

  static const Map<Object, AvatarGetUserProxyAvatarDarkApiVersion> _fromWire =
      <Object, AvatarGetUserProxyAvatarDarkApiVersion>{
    'v1': AvatarGetUserProxyAvatarDarkApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [AvatarGetUserProxyAvatarDarkApiVersion];

  @override
  String get wireName => 'AvatarGetUserProxyAvatarDarkApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    AvatarGetUserProxyAvatarDarkApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  AvatarGetUserProxyAvatarDarkApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class BotListBotsApiVersion extends EnumClass {
  const BotListBotsApiVersion._(super.name);

  /// `v1`
  static const BotListBotsApiVersion v1 = _$botListBotsApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<BotListBotsApiVersion> get values => _$botListBotsApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static BotListBotsApiVersion valueOf(String name) => _$valueOfBotListBotsApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for BotListBotsApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<BotListBotsApiVersion> get serializer => const _$BotListBotsApiVersionSerializer();
}

class _$BotListBotsApiVersionSerializer implements PrimitiveSerializer<BotListBotsApiVersion> {
  const _$BotListBotsApiVersionSerializer();

  static const Map<BotListBotsApiVersion, Object> _toWire = <BotListBotsApiVersion, Object>{
    BotListBotsApiVersion.v1: 'v1',
  };

  static const Map<Object, BotListBotsApiVersion> _fromWire = <Object, BotListBotsApiVersion>{
    'v1': BotListBotsApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BotListBotsApiVersion];

  @override
  String get wireName => 'BotListBotsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BotListBotsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BotListBotsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BotInterface {
  String? get description;
  int get id;
  String get name;
  int get state;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BotInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BotInterfaceBuilder b) {}
}

abstract class Bot implements $BotInterface, Built<Bot, BotBuilder> {
  /// Creates a new Bot object using the builder pattern.
  factory Bot([void Function(BotBuilder)? b]) = _$Bot;

  // coverage:ignore-start
  const Bot._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory Bot.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for Bot.
  static Serializer<Bot> get serializer => _$botSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BotBuilder b) {
    $BotInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BotBuilder b) {
    $BotInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $BotListBotsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<Bot> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BotListBotsResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BotListBotsResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class BotListBotsResponseApplicationJson_Ocs
    implements
        $BotListBotsResponseApplicationJson_OcsInterface,
        Built<BotListBotsResponseApplicationJson_Ocs, BotListBotsResponseApplicationJson_OcsBuilder> {
  /// Creates a new BotListBotsResponseApplicationJson_Ocs object using the builder pattern.
  factory BotListBotsResponseApplicationJson_Ocs([void Function(BotListBotsResponseApplicationJson_OcsBuilder)? b]) =
      _$BotListBotsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BotListBotsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BotListBotsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BotListBotsResponseApplicationJson_Ocs.
  static Serializer<BotListBotsResponseApplicationJson_Ocs> get serializer =>
      _$botListBotsResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BotListBotsResponseApplicationJson_OcsBuilder b) {
    $BotListBotsResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BotListBotsResponseApplicationJson_OcsBuilder b) {
    $BotListBotsResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $BotListBotsResponseApplicationJsonInterface {
  BotListBotsResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BotListBotsResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BotListBotsResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class BotListBotsResponseApplicationJson
    implements
        $BotListBotsResponseApplicationJsonInterface,
        Built<BotListBotsResponseApplicationJson, BotListBotsResponseApplicationJsonBuilder> {
  /// Creates a new BotListBotsResponseApplicationJson object using the builder pattern.
  factory BotListBotsResponseApplicationJson([void Function(BotListBotsResponseApplicationJsonBuilder)? b]) =
      _$BotListBotsResponseApplicationJson;

  // coverage:ignore-start
  const BotListBotsResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BotListBotsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BotListBotsResponseApplicationJson.
  static Serializer<BotListBotsResponseApplicationJson> get serializer =>
      _$botListBotsResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BotListBotsResponseApplicationJsonBuilder b) {
    $BotListBotsResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BotListBotsResponseApplicationJsonBuilder b) {
    $BotListBotsResponseApplicationJsonInterface._validate(b);
  }
}

class BotEnableBotApiVersion extends EnumClass {
  const BotEnableBotApiVersion._(super.name);

  /// `v1`
  static const BotEnableBotApiVersion v1 = _$botEnableBotApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<BotEnableBotApiVersion> get values => _$botEnableBotApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static BotEnableBotApiVersion valueOf(String name) => _$valueOfBotEnableBotApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for BotEnableBotApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<BotEnableBotApiVersion> get serializer => const _$BotEnableBotApiVersionSerializer();
}

class _$BotEnableBotApiVersionSerializer implements PrimitiveSerializer<BotEnableBotApiVersion> {
  const _$BotEnableBotApiVersionSerializer();

  static const Map<BotEnableBotApiVersion, Object> _toWire = <BotEnableBotApiVersion, Object>{
    BotEnableBotApiVersion.v1: 'v1',
  };

  static const Map<Object, BotEnableBotApiVersion> _fromWire = <Object, BotEnableBotApiVersion>{
    'v1': BotEnableBotApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BotEnableBotApiVersion];

  @override
  String get wireName => 'BotEnableBotApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BotEnableBotApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BotEnableBotApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BotEnableBotResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Bot? get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BotEnableBotResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BotEnableBotResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class BotEnableBotResponseApplicationJson_Ocs
    implements
        $BotEnableBotResponseApplicationJson_OcsInterface,
        Built<BotEnableBotResponseApplicationJson_Ocs, BotEnableBotResponseApplicationJson_OcsBuilder> {
  /// Creates a new BotEnableBotResponseApplicationJson_Ocs object using the builder pattern.
  factory BotEnableBotResponseApplicationJson_Ocs([void Function(BotEnableBotResponseApplicationJson_OcsBuilder)? b]) =
      _$BotEnableBotResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BotEnableBotResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BotEnableBotResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BotEnableBotResponseApplicationJson_Ocs.
  static Serializer<BotEnableBotResponseApplicationJson_Ocs> get serializer =>
      _$botEnableBotResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BotEnableBotResponseApplicationJson_OcsBuilder b) {
    $BotEnableBotResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BotEnableBotResponseApplicationJson_OcsBuilder b) {
    $BotEnableBotResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $BotEnableBotResponseApplicationJsonInterface {
  BotEnableBotResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BotEnableBotResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BotEnableBotResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class BotEnableBotResponseApplicationJson
    implements
        $BotEnableBotResponseApplicationJsonInterface,
        Built<BotEnableBotResponseApplicationJson, BotEnableBotResponseApplicationJsonBuilder> {
  /// Creates a new BotEnableBotResponseApplicationJson object using the builder pattern.
  factory BotEnableBotResponseApplicationJson([void Function(BotEnableBotResponseApplicationJsonBuilder)? b]) =
      _$BotEnableBotResponseApplicationJson;

  // coverage:ignore-start
  const BotEnableBotResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BotEnableBotResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BotEnableBotResponseApplicationJson.
  static Serializer<BotEnableBotResponseApplicationJson> get serializer =>
      _$botEnableBotResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BotEnableBotResponseApplicationJsonBuilder b) {
    $BotEnableBotResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BotEnableBotResponseApplicationJsonBuilder b) {
    $BotEnableBotResponseApplicationJsonInterface._validate(b);
  }
}

class BotDisableBotApiVersion extends EnumClass {
  const BotDisableBotApiVersion._(super.name);

  /// `v1`
  static const BotDisableBotApiVersion v1 = _$botDisableBotApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<BotDisableBotApiVersion> get values => _$botDisableBotApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static BotDisableBotApiVersion valueOf(String name) => _$valueOfBotDisableBotApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for BotDisableBotApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<BotDisableBotApiVersion> get serializer => const _$BotDisableBotApiVersionSerializer();
}

class _$BotDisableBotApiVersionSerializer implements PrimitiveSerializer<BotDisableBotApiVersion> {
  const _$BotDisableBotApiVersionSerializer();

  static const Map<BotDisableBotApiVersion, Object> _toWire = <BotDisableBotApiVersion, Object>{
    BotDisableBotApiVersion.v1: 'v1',
  };

  static const Map<Object, BotDisableBotApiVersion> _fromWire = <Object, BotDisableBotApiVersion>{
    'v1': BotDisableBotApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BotDisableBotApiVersion];

  @override
  String get wireName => 'BotDisableBotApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BotDisableBotApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BotDisableBotApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BotDisableBotResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Bot? get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BotDisableBotResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BotDisableBotResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class BotDisableBotResponseApplicationJson_Ocs
    implements
        $BotDisableBotResponseApplicationJson_OcsInterface,
        Built<BotDisableBotResponseApplicationJson_Ocs, BotDisableBotResponseApplicationJson_OcsBuilder> {
  /// Creates a new BotDisableBotResponseApplicationJson_Ocs object using the builder pattern.
  factory BotDisableBotResponseApplicationJson_Ocs([
    void Function(BotDisableBotResponseApplicationJson_OcsBuilder)? b,
  ]) = _$BotDisableBotResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BotDisableBotResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BotDisableBotResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BotDisableBotResponseApplicationJson_Ocs.
  static Serializer<BotDisableBotResponseApplicationJson_Ocs> get serializer =>
      _$botDisableBotResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BotDisableBotResponseApplicationJson_OcsBuilder b) {
    $BotDisableBotResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BotDisableBotResponseApplicationJson_OcsBuilder b) {
    $BotDisableBotResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $BotDisableBotResponseApplicationJsonInterface {
  BotDisableBotResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BotDisableBotResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BotDisableBotResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class BotDisableBotResponseApplicationJson
    implements
        $BotDisableBotResponseApplicationJsonInterface,
        Built<BotDisableBotResponseApplicationJson, BotDisableBotResponseApplicationJsonBuilder> {
  /// Creates a new BotDisableBotResponseApplicationJson object using the builder pattern.
  factory BotDisableBotResponseApplicationJson([void Function(BotDisableBotResponseApplicationJsonBuilder)? b]) =
      _$BotDisableBotResponseApplicationJson;

  // coverage:ignore-start
  const BotDisableBotResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BotDisableBotResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BotDisableBotResponseApplicationJson.
  static Serializer<BotDisableBotResponseApplicationJson> get serializer =>
      _$botDisableBotResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BotDisableBotResponseApplicationJsonBuilder b) {
    $BotDisableBotResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BotDisableBotResponseApplicationJsonBuilder b) {
    $BotDisableBotResponseApplicationJsonInterface._validate(b);
  }
}

class BotSendMessageSilent extends EnumClass {
  const BotSendMessageSilent._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const BotSendMessageSilent $0 = _$botSendMessageSilent$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const BotSendMessageSilent $1 = _$botSendMessageSilent$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<BotSendMessageSilent> get values => _$botSendMessageSilentValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static BotSendMessageSilent valueOf(String name) => _$valueOfBotSendMessageSilent(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for BotSendMessageSilent.
  @BuiltValueSerializer(custom: true)
  static Serializer<BotSendMessageSilent> get serializer => const _$BotSendMessageSilentSerializer();
}

class _$BotSendMessageSilentSerializer implements PrimitiveSerializer<BotSendMessageSilent> {
  const _$BotSendMessageSilentSerializer();

  static const Map<BotSendMessageSilent, Object> _toWire = <BotSendMessageSilent, Object>{
    BotSendMessageSilent.$0: 0,
    BotSendMessageSilent.$1: 1,
  };

  static const Map<Object, BotSendMessageSilent> _fromWire = <Object, BotSendMessageSilent>{
    0: BotSendMessageSilent.$0,
    1: BotSendMessageSilent.$1,
  };

  @override
  Iterable<Type> get types => const [BotSendMessageSilent];

  @override
  String get wireName => 'BotSendMessageSilent';

  @override
  Object serialize(
    Serializers serializers,
    BotSendMessageSilent object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BotSendMessageSilent deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class BotSendMessageApiVersion extends EnumClass {
  const BotSendMessageApiVersion._(super.name);

  /// `v1`
  static const BotSendMessageApiVersion v1 = _$botSendMessageApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<BotSendMessageApiVersion> get values => _$botSendMessageApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static BotSendMessageApiVersion valueOf(String name) => _$valueOfBotSendMessageApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for BotSendMessageApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<BotSendMessageApiVersion> get serializer => const _$BotSendMessageApiVersionSerializer();
}

class _$BotSendMessageApiVersionSerializer implements PrimitiveSerializer<BotSendMessageApiVersion> {
  const _$BotSendMessageApiVersionSerializer();

  static const Map<BotSendMessageApiVersion, Object> _toWire = <BotSendMessageApiVersion, Object>{
    BotSendMessageApiVersion.v1: 'v1',
  };

  static const Map<Object, BotSendMessageApiVersion> _fromWire = <Object, BotSendMessageApiVersion>{
    'v1': BotSendMessageApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BotSendMessageApiVersion];

  @override
  String get wireName => 'BotSendMessageApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BotSendMessageApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BotSendMessageApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BotSendMessageResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BotSendMessageResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BotSendMessageResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class BotSendMessageResponseApplicationJson_Ocs
    implements
        $BotSendMessageResponseApplicationJson_OcsInterface,
        Built<BotSendMessageResponseApplicationJson_Ocs, BotSendMessageResponseApplicationJson_OcsBuilder> {
  /// Creates a new BotSendMessageResponseApplicationJson_Ocs object using the builder pattern.
  factory BotSendMessageResponseApplicationJson_Ocs([
    void Function(BotSendMessageResponseApplicationJson_OcsBuilder)? b,
  ]) = _$BotSendMessageResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BotSendMessageResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BotSendMessageResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BotSendMessageResponseApplicationJson_Ocs.
  static Serializer<BotSendMessageResponseApplicationJson_Ocs> get serializer =>
      _$botSendMessageResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BotSendMessageResponseApplicationJson_OcsBuilder b) {
    $BotSendMessageResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BotSendMessageResponseApplicationJson_OcsBuilder b) {
    $BotSendMessageResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $BotSendMessageResponseApplicationJsonInterface {
  BotSendMessageResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BotSendMessageResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BotSendMessageResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class BotSendMessageResponseApplicationJson
    implements
        $BotSendMessageResponseApplicationJsonInterface,
        Built<BotSendMessageResponseApplicationJson, BotSendMessageResponseApplicationJsonBuilder> {
  /// Creates a new BotSendMessageResponseApplicationJson object using the builder pattern.
  factory BotSendMessageResponseApplicationJson([void Function(BotSendMessageResponseApplicationJsonBuilder)? b]) =
      _$BotSendMessageResponseApplicationJson;

  // coverage:ignore-start
  const BotSendMessageResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BotSendMessageResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BotSendMessageResponseApplicationJson.
  static Serializer<BotSendMessageResponseApplicationJson> get serializer =>
      _$botSendMessageResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BotSendMessageResponseApplicationJsonBuilder b) {
    $BotSendMessageResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BotSendMessageResponseApplicationJsonBuilder b) {
    $BotSendMessageResponseApplicationJsonInterface._validate(b);
  }
}

class BotReactApiVersion extends EnumClass {
  const BotReactApiVersion._(super.name);

  /// `v1`
  static const BotReactApiVersion v1 = _$botReactApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<BotReactApiVersion> get values => _$botReactApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static BotReactApiVersion valueOf(String name) => _$valueOfBotReactApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for BotReactApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<BotReactApiVersion> get serializer => const _$BotReactApiVersionSerializer();
}

class _$BotReactApiVersionSerializer implements PrimitiveSerializer<BotReactApiVersion> {
  const _$BotReactApiVersionSerializer();

  static const Map<BotReactApiVersion, Object> _toWire = <BotReactApiVersion, Object>{
    BotReactApiVersion.v1: 'v1',
  };

  static const Map<Object, BotReactApiVersion> _fromWire = <Object, BotReactApiVersion>{
    'v1': BotReactApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BotReactApiVersion];

  @override
  String get wireName => 'BotReactApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BotReactApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BotReactApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BotReactResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BotReactResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BotReactResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class BotReactResponseApplicationJson_Ocs
    implements
        $BotReactResponseApplicationJson_OcsInterface,
        Built<BotReactResponseApplicationJson_Ocs, BotReactResponseApplicationJson_OcsBuilder> {
  /// Creates a new BotReactResponseApplicationJson_Ocs object using the builder pattern.
  factory BotReactResponseApplicationJson_Ocs([void Function(BotReactResponseApplicationJson_OcsBuilder)? b]) =
      _$BotReactResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BotReactResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BotReactResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BotReactResponseApplicationJson_Ocs.
  static Serializer<BotReactResponseApplicationJson_Ocs> get serializer =>
      _$botReactResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BotReactResponseApplicationJson_OcsBuilder b) {
    $BotReactResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BotReactResponseApplicationJson_OcsBuilder b) {
    $BotReactResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $BotReactResponseApplicationJsonInterface {
  BotReactResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BotReactResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BotReactResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class BotReactResponseApplicationJson
    implements
        $BotReactResponseApplicationJsonInterface,
        Built<BotReactResponseApplicationJson, BotReactResponseApplicationJsonBuilder> {
  /// Creates a new BotReactResponseApplicationJson object using the builder pattern.
  factory BotReactResponseApplicationJson([void Function(BotReactResponseApplicationJsonBuilder)? b]) =
      _$BotReactResponseApplicationJson;

  // coverage:ignore-start
  const BotReactResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BotReactResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BotReactResponseApplicationJson.
  static Serializer<BotReactResponseApplicationJson> get serializer => _$botReactResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BotReactResponseApplicationJsonBuilder b) {
    $BotReactResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BotReactResponseApplicationJsonBuilder b) {
    $BotReactResponseApplicationJsonInterface._validate(b);
  }
}

class BotDeleteReactionApiVersion extends EnumClass {
  const BotDeleteReactionApiVersion._(super.name);

  /// `v1`
  static const BotDeleteReactionApiVersion v1 = _$botDeleteReactionApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<BotDeleteReactionApiVersion> get values => _$botDeleteReactionApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static BotDeleteReactionApiVersion valueOf(String name) => _$valueOfBotDeleteReactionApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for BotDeleteReactionApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<BotDeleteReactionApiVersion> get serializer => const _$BotDeleteReactionApiVersionSerializer();
}

class _$BotDeleteReactionApiVersionSerializer implements PrimitiveSerializer<BotDeleteReactionApiVersion> {
  const _$BotDeleteReactionApiVersionSerializer();

  static const Map<BotDeleteReactionApiVersion, Object> _toWire = <BotDeleteReactionApiVersion, Object>{
    BotDeleteReactionApiVersion.v1: 'v1',
  };

  static const Map<Object, BotDeleteReactionApiVersion> _fromWire = <Object, BotDeleteReactionApiVersion>{
    'v1': BotDeleteReactionApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BotDeleteReactionApiVersion];

  @override
  String get wireName => 'BotDeleteReactionApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BotDeleteReactionApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BotDeleteReactionApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BotDeleteReactionResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BotDeleteReactionResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BotDeleteReactionResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class BotDeleteReactionResponseApplicationJson_Ocs
    implements
        $BotDeleteReactionResponseApplicationJson_OcsInterface,
        Built<BotDeleteReactionResponseApplicationJson_Ocs, BotDeleteReactionResponseApplicationJson_OcsBuilder> {
  /// Creates a new BotDeleteReactionResponseApplicationJson_Ocs object using the builder pattern.
  factory BotDeleteReactionResponseApplicationJson_Ocs([
    void Function(BotDeleteReactionResponseApplicationJson_OcsBuilder)? b,
  ]) = _$BotDeleteReactionResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BotDeleteReactionResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BotDeleteReactionResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BotDeleteReactionResponseApplicationJson_Ocs.
  static Serializer<BotDeleteReactionResponseApplicationJson_Ocs> get serializer =>
      _$botDeleteReactionResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BotDeleteReactionResponseApplicationJson_OcsBuilder b) {
    $BotDeleteReactionResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BotDeleteReactionResponseApplicationJson_OcsBuilder b) {
    $BotDeleteReactionResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $BotDeleteReactionResponseApplicationJsonInterface {
  BotDeleteReactionResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BotDeleteReactionResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BotDeleteReactionResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class BotDeleteReactionResponseApplicationJson
    implements
        $BotDeleteReactionResponseApplicationJsonInterface,
        Built<BotDeleteReactionResponseApplicationJson, BotDeleteReactionResponseApplicationJsonBuilder> {
  /// Creates a new BotDeleteReactionResponseApplicationJson object using the builder pattern.
  factory BotDeleteReactionResponseApplicationJson([
    void Function(BotDeleteReactionResponseApplicationJsonBuilder)? b,
  ]) = _$BotDeleteReactionResponseApplicationJson;

  // coverage:ignore-start
  const BotDeleteReactionResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BotDeleteReactionResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BotDeleteReactionResponseApplicationJson.
  static Serializer<BotDeleteReactionResponseApplicationJson> get serializer =>
      _$botDeleteReactionResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BotDeleteReactionResponseApplicationJsonBuilder b) {
    $BotDeleteReactionResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BotDeleteReactionResponseApplicationJsonBuilder b) {
    $BotDeleteReactionResponseApplicationJsonInterface._validate(b);
  }
}

class BreakoutRoomConfigureBreakoutRoomsMode extends EnumClass {
  const BreakoutRoomConfigureBreakoutRoomsMode._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const BreakoutRoomConfigureBreakoutRoomsMode $0 = _$breakoutRoomConfigureBreakoutRoomsMode$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const BreakoutRoomConfigureBreakoutRoomsMode $1 = _$breakoutRoomConfigureBreakoutRoomsMode$1;

  /// `2`
  @BuiltValueEnumConst(wireName: '2')
  static const BreakoutRoomConfigureBreakoutRoomsMode $2 = _$breakoutRoomConfigureBreakoutRoomsMode$2;

  /// `3`
  @BuiltValueEnumConst(wireName: '3')
  static const BreakoutRoomConfigureBreakoutRoomsMode $3 = _$breakoutRoomConfigureBreakoutRoomsMode$3;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<BreakoutRoomConfigureBreakoutRoomsMode> get values => _$breakoutRoomConfigureBreakoutRoomsModeValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static BreakoutRoomConfigureBreakoutRoomsMode valueOf(String name) =>
      _$valueOfBreakoutRoomConfigureBreakoutRoomsMode(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for BreakoutRoomConfigureBreakoutRoomsMode.
  @BuiltValueSerializer(custom: true)
  static Serializer<BreakoutRoomConfigureBreakoutRoomsMode> get serializer =>
      const _$BreakoutRoomConfigureBreakoutRoomsModeSerializer();
}

class _$BreakoutRoomConfigureBreakoutRoomsModeSerializer
    implements PrimitiveSerializer<BreakoutRoomConfigureBreakoutRoomsMode> {
  const _$BreakoutRoomConfigureBreakoutRoomsModeSerializer();

  static const Map<BreakoutRoomConfigureBreakoutRoomsMode, Object> _toWire =
      <BreakoutRoomConfigureBreakoutRoomsMode, Object>{
    BreakoutRoomConfigureBreakoutRoomsMode.$0: 0,
    BreakoutRoomConfigureBreakoutRoomsMode.$1: 1,
    BreakoutRoomConfigureBreakoutRoomsMode.$2: 2,
    BreakoutRoomConfigureBreakoutRoomsMode.$3: 3,
  };

  static const Map<Object, BreakoutRoomConfigureBreakoutRoomsMode> _fromWire =
      <Object, BreakoutRoomConfigureBreakoutRoomsMode>{
    0: BreakoutRoomConfigureBreakoutRoomsMode.$0,
    1: BreakoutRoomConfigureBreakoutRoomsMode.$1,
    2: BreakoutRoomConfigureBreakoutRoomsMode.$2,
    3: BreakoutRoomConfigureBreakoutRoomsMode.$3,
  };

  @override
  Iterable<Type> get types => const [BreakoutRoomConfigureBreakoutRoomsMode];

  @override
  String get wireName => 'BreakoutRoomConfigureBreakoutRoomsMode';

  @override
  Object serialize(
    Serializers serializers,
    BreakoutRoomConfigureBreakoutRoomsMode object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BreakoutRoomConfigureBreakoutRoomsMode deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class BreakoutRoomConfigureBreakoutRoomsApiVersion extends EnumClass {
  const BreakoutRoomConfigureBreakoutRoomsApiVersion._(super.name);

  /// `v1`
  static const BreakoutRoomConfigureBreakoutRoomsApiVersion v1 = _$breakoutRoomConfigureBreakoutRoomsApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<BreakoutRoomConfigureBreakoutRoomsApiVersion> get values =>
      _$breakoutRoomConfigureBreakoutRoomsApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static BreakoutRoomConfigureBreakoutRoomsApiVersion valueOf(String name) =>
      _$valueOfBreakoutRoomConfigureBreakoutRoomsApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for BreakoutRoomConfigureBreakoutRoomsApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<BreakoutRoomConfigureBreakoutRoomsApiVersion> get serializer =>
      const _$BreakoutRoomConfigureBreakoutRoomsApiVersionSerializer();
}

class _$BreakoutRoomConfigureBreakoutRoomsApiVersionSerializer
    implements PrimitiveSerializer<BreakoutRoomConfigureBreakoutRoomsApiVersion> {
  const _$BreakoutRoomConfigureBreakoutRoomsApiVersionSerializer();

  static const Map<BreakoutRoomConfigureBreakoutRoomsApiVersion, Object> _toWire =
      <BreakoutRoomConfigureBreakoutRoomsApiVersion, Object>{
    BreakoutRoomConfigureBreakoutRoomsApiVersion.v1: 'v1',
  };

  static const Map<Object, BreakoutRoomConfigureBreakoutRoomsApiVersion> _fromWire =
      <Object, BreakoutRoomConfigureBreakoutRoomsApiVersion>{
    'v1': BreakoutRoomConfigureBreakoutRoomsApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BreakoutRoomConfigureBreakoutRoomsApiVersion];

  @override
  String get wireName => 'BreakoutRoomConfigureBreakoutRoomsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BreakoutRoomConfigureBreakoutRoomsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BreakoutRoomConfigureBreakoutRoomsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<Room> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_Ocs
    implements
        $BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_OcsInterface,
        Built<BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_Ocs,
            BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_OcsBuilder> {
  /// Creates a new BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_Ocs object using the builder pattern.
  factory BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_Ocs([
    void Function(BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_Ocs.
  static Serializer<BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_Ocs> get serializer =>
      _$breakoutRoomConfigureBreakoutRoomsResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_OcsBuilder b) {
    $BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_OcsBuilder b) {
    $BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomConfigureBreakoutRoomsResponseApplicationJsonInterface {
  BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BreakoutRoomConfigureBreakoutRoomsResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BreakoutRoomConfigureBreakoutRoomsResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson
    implements
        $BreakoutRoomConfigureBreakoutRoomsResponseApplicationJsonInterface,
        Built<BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson,
            BreakoutRoomConfigureBreakoutRoomsResponseApplicationJsonBuilder> {
  /// Creates a new BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson object using the builder pattern.
  factory BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson([
    void Function(BreakoutRoomConfigureBreakoutRoomsResponseApplicationJsonBuilder)? b,
  ]) = _$BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson;

  // coverage:ignore-start
  const BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson.
  static Serializer<BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson> get serializer =>
      _$breakoutRoomConfigureBreakoutRoomsResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BreakoutRoomConfigureBreakoutRoomsResponseApplicationJsonBuilder b) {
    $BreakoutRoomConfigureBreakoutRoomsResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BreakoutRoomConfigureBreakoutRoomsResponseApplicationJsonBuilder b) {
    $BreakoutRoomConfigureBreakoutRoomsResponseApplicationJsonInterface._validate(b);
  }
}

class BreakoutRoomRemoveBreakoutRoomsApiVersion extends EnumClass {
  const BreakoutRoomRemoveBreakoutRoomsApiVersion._(super.name);

  /// `v1`
  static const BreakoutRoomRemoveBreakoutRoomsApiVersion v1 = _$breakoutRoomRemoveBreakoutRoomsApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<BreakoutRoomRemoveBreakoutRoomsApiVersion> get values =>
      _$breakoutRoomRemoveBreakoutRoomsApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static BreakoutRoomRemoveBreakoutRoomsApiVersion valueOf(String name) =>
      _$valueOfBreakoutRoomRemoveBreakoutRoomsApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for BreakoutRoomRemoveBreakoutRoomsApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<BreakoutRoomRemoveBreakoutRoomsApiVersion> get serializer =>
      const _$BreakoutRoomRemoveBreakoutRoomsApiVersionSerializer();
}

class _$BreakoutRoomRemoveBreakoutRoomsApiVersionSerializer
    implements PrimitiveSerializer<BreakoutRoomRemoveBreakoutRoomsApiVersion> {
  const _$BreakoutRoomRemoveBreakoutRoomsApiVersionSerializer();

  static const Map<BreakoutRoomRemoveBreakoutRoomsApiVersion, Object> _toWire =
      <BreakoutRoomRemoveBreakoutRoomsApiVersion, Object>{
    BreakoutRoomRemoveBreakoutRoomsApiVersion.v1: 'v1',
  };

  static const Map<Object, BreakoutRoomRemoveBreakoutRoomsApiVersion> _fromWire =
      <Object, BreakoutRoomRemoveBreakoutRoomsApiVersion>{
    'v1': BreakoutRoomRemoveBreakoutRoomsApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BreakoutRoomRemoveBreakoutRoomsApiVersion];

  @override
  String get wireName => 'BreakoutRoomRemoveBreakoutRoomsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BreakoutRoomRemoveBreakoutRoomsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BreakoutRoomRemoveBreakoutRoomsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_Ocs
    implements
        $BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_OcsInterface,
        Built<BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_Ocs,
            BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_OcsBuilder> {
  /// Creates a new BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_Ocs object using the builder pattern.
  factory BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_Ocs([
    void Function(BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_Ocs.
  static Serializer<BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_Ocs> get serializer =>
      _$breakoutRoomRemoveBreakoutRoomsResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_OcsBuilder b) {
    $BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_OcsBuilder b) {
    $BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomRemoveBreakoutRoomsResponseApplicationJsonInterface {
  BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BreakoutRoomRemoveBreakoutRoomsResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BreakoutRoomRemoveBreakoutRoomsResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson
    implements
        $BreakoutRoomRemoveBreakoutRoomsResponseApplicationJsonInterface,
        Built<BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson,
            BreakoutRoomRemoveBreakoutRoomsResponseApplicationJsonBuilder> {
  /// Creates a new BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson object using the builder pattern.
  factory BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson([
    void Function(BreakoutRoomRemoveBreakoutRoomsResponseApplicationJsonBuilder)? b,
  ]) = _$BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson;

  // coverage:ignore-start
  const BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson.
  static Serializer<BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson> get serializer =>
      _$breakoutRoomRemoveBreakoutRoomsResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BreakoutRoomRemoveBreakoutRoomsResponseApplicationJsonBuilder b) {
    $BreakoutRoomRemoveBreakoutRoomsResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BreakoutRoomRemoveBreakoutRoomsResponseApplicationJsonBuilder b) {
    $BreakoutRoomRemoveBreakoutRoomsResponseApplicationJsonInterface._validate(b);
  }
}

class BreakoutRoomBroadcastChatMessageApiVersion extends EnumClass {
  const BreakoutRoomBroadcastChatMessageApiVersion._(super.name);

  /// `v1`
  static const BreakoutRoomBroadcastChatMessageApiVersion v1 = _$breakoutRoomBroadcastChatMessageApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<BreakoutRoomBroadcastChatMessageApiVersion> get values =>
      _$breakoutRoomBroadcastChatMessageApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static BreakoutRoomBroadcastChatMessageApiVersion valueOf(String name) =>
      _$valueOfBreakoutRoomBroadcastChatMessageApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for BreakoutRoomBroadcastChatMessageApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<BreakoutRoomBroadcastChatMessageApiVersion> get serializer =>
      const _$BreakoutRoomBroadcastChatMessageApiVersionSerializer();
}

class _$BreakoutRoomBroadcastChatMessageApiVersionSerializer
    implements PrimitiveSerializer<BreakoutRoomBroadcastChatMessageApiVersion> {
  const _$BreakoutRoomBroadcastChatMessageApiVersionSerializer();

  static const Map<BreakoutRoomBroadcastChatMessageApiVersion, Object> _toWire =
      <BreakoutRoomBroadcastChatMessageApiVersion, Object>{
    BreakoutRoomBroadcastChatMessageApiVersion.v1: 'v1',
  };

  static const Map<Object, BreakoutRoomBroadcastChatMessageApiVersion> _fromWire =
      <Object, BreakoutRoomBroadcastChatMessageApiVersion>{
    'v1': BreakoutRoomBroadcastChatMessageApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BreakoutRoomBroadcastChatMessageApiVersion];

  @override
  String get wireName => 'BreakoutRoomBroadcastChatMessageApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BreakoutRoomBroadcastChatMessageApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BreakoutRoomBroadcastChatMessageApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomBroadcastChatMessageResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<Room> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BreakoutRoomBroadcastChatMessageResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BreakoutRoomBroadcastChatMessageResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class BreakoutRoomBroadcastChatMessageResponseApplicationJson_Ocs
    implements
        $BreakoutRoomBroadcastChatMessageResponseApplicationJson_OcsInterface,
        Built<BreakoutRoomBroadcastChatMessageResponseApplicationJson_Ocs,
            BreakoutRoomBroadcastChatMessageResponseApplicationJson_OcsBuilder> {
  /// Creates a new BreakoutRoomBroadcastChatMessageResponseApplicationJson_Ocs object using the builder pattern.
  factory BreakoutRoomBroadcastChatMessageResponseApplicationJson_Ocs([
    void Function(BreakoutRoomBroadcastChatMessageResponseApplicationJson_OcsBuilder)? b,
  ]) = _$BreakoutRoomBroadcastChatMessageResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BreakoutRoomBroadcastChatMessageResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BreakoutRoomBroadcastChatMessageResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BreakoutRoomBroadcastChatMessageResponseApplicationJson_Ocs.
  static Serializer<BreakoutRoomBroadcastChatMessageResponseApplicationJson_Ocs> get serializer =>
      _$breakoutRoomBroadcastChatMessageResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BreakoutRoomBroadcastChatMessageResponseApplicationJson_OcsBuilder b) {
    $BreakoutRoomBroadcastChatMessageResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BreakoutRoomBroadcastChatMessageResponseApplicationJson_OcsBuilder b) {
    $BreakoutRoomBroadcastChatMessageResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomBroadcastChatMessageResponseApplicationJsonInterface {
  BreakoutRoomBroadcastChatMessageResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BreakoutRoomBroadcastChatMessageResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BreakoutRoomBroadcastChatMessageResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class BreakoutRoomBroadcastChatMessageResponseApplicationJson
    implements
        $BreakoutRoomBroadcastChatMessageResponseApplicationJsonInterface,
        Built<BreakoutRoomBroadcastChatMessageResponseApplicationJson,
            BreakoutRoomBroadcastChatMessageResponseApplicationJsonBuilder> {
  /// Creates a new BreakoutRoomBroadcastChatMessageResponseApplicationJson object using the builder pattern.
  factory BreakoutRoomBroadcastChatMessageResponseApplicationJson([
    void Function(BreakoutRoomBroadcastChatMessageResponseApplicationJsonBuilder)? b,
  ]) = _$BreakoutRoomBroadcastChatMessageResponseApplicationJson;

  // coverage:ignore-start
  const BreakoutRoomBroadcastChatMessageResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BreakoutRoomBroadcastChatMessageResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BreakoutRoomBroadcastChatMessageResponseApplicationJson.
  static Serializer<BreakoutRoomBroadcastChatMessageResponseApplicationJson> get serializer =>
      _$breakoutRoomBroadcastChatMessageResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BreakoutRoomBroadcastChatMessageResponseApplicationJsonBuilder b) {
    $BreakoutRoomBroadcastChatMessageResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BreakoutRoomBroadcastChatMessageResponseApplicationJsonBuilder b) {
    $BreakoutRoomBroadcastChatMessageResponseApplicationJsonInterface._validate(b);
  }
}

class BreakoutRoomApplyAttendeeMapApiVersion extends EnumClass {
  const BreakoutRoomApplyAttendeeMapApiVersion._(super.name);

  /// `v1`
  static const BreakoutRoomApplyAttendeeMapApiVersion v1 = _$breakoutRoomApplyAttendeeMapApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<BreakoutRoomApplyAttendeeMapApiVersion> get values => _$breakoutRoomApplyAttendeeMapApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static BreakoutRoomApplyAttendeeMapApiVersion valueOf(String name) =>
      _$valueOfBreakoutRoomApplyAttendeeMapApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for BreakoutRoomApplyAttendeeMapApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<BreakoutRoomApplyAttendeeMapApiVersion> get serializer =>
      const _$BreakoutRoomApplyAttendeeMapApiVersionSerializer();
}

class _$BreakoutRoomApplyAttendeeMapApiVersionSerializer
    implements PrimitiveSerializer<BreakoutRoomApplyAttendeeMapApiVersion> {
  const _$BreakoutRoomApplyAttendeeMapApiVersionSerializer();

  static const Map<BreakoutRoomApplyAttendeeMapApiVersion, Object> _toWire =
      <BreakoutRoomApplyAttendeeMapApiVersion, Object>{
    BreakoutRoomApplyAttendeeMapApiVersion.v1: 'v1',
  };

  static const Map<Object, BreakoutRoomApplyAttendeeMapApiVersion> _fromWire =
      <Object, BreakoutRoomApplyAttendeeMapApiVersion>{
    'v1': BreakoutRoomApplyAttendeeMapApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BreakoutRoomApplyAttendeeMapApiVersion];

  @override
  String get wireName => 'BreakoutRoomApplyAttendeeMapApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BreakoutRoomApplyAttendeeMapApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BreakoutRoomApplyAttendeeMapApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomApplyAttendeeMapResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<Room> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BreakoutRoomApplyAttendeeMapResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BreakoutRoomApplyAttendeeMapResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class BreakoutRoomApplyAttendeeMapResponseApplicationJson_Ocs
    implements
        $BreakoutRoomApplyAttendeeMapResponseApplicationJson_OcsInterface,
        Built<BreakoutRoomApplyAttendeeMapResponseApplicationJson_Ocs,
            BreakoutRoomApplyAttendeeMapResponseApplicationJson_OcsBuilder> {
  /// Creates a new BreakoutRoomApplyAttendeeMapResponseApplicationJson_Ocs object using the builder pattern.
  factory BreakoutRoomApplyAttendeeMapResponseApplicationJson_Ocs([
    void Function(BreakoutRoomApplyAttendeeMapResponseApplicationJson_OcsBuilder)? b,
  ]) = _$BreakoutRoomApplyAttendeeMapResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BreakoutRoomApplyAttendeeMapResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BreakoutRoomApplyAttendeeMapResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BreakoutRoomApplyAttendeeMapResponseApplicationJson_Ocs.
  static Serializer<BreakoutRoomApplyAttendeeMapResponseApplicationJson_Ocs> get serializer =>
      _$breakoutRoomApplyAttendeeMapResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BreakoutRoomApplyAttendeeMapResponseApplicationJson_OcsBuilder b) {
    $BreakoutRoomApplyAttendeeMapResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BreakoutRoomApplyAttendeeMapResponseApplicationJson_OcsBuilder b) {
    $BreakoutRoomApplyAttendeeMapResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomApplyAttendeeMapResponseApplicationJsonInterface {
  BreakoutRoomApplyAttendeeMapResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BreakoutRoomApplyAttendeeMapResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BreakoutRoomApplyAttendeeMapResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class BreakoutRoomApplyAttendeeMapResponseApplicationJson
    implements
        $BreakoutRoomApplyAttendeeMapResponseApplicationJsonInterface,
        Built<BreakoutRoomApplyAttendeeMapResponseApplicationJson,
            BreakoutRoomApplyAttendeeMapResponseApplicationJsonBuilder> {
  /// Creates a new BreakoutRoomApplyAttendeeMapResponseApplicationJson object using the builder pattern.
  factory BreakoutRoomApplyAttendeeMapResponseApplicationJson([
    void Function(BreakoutRoomApplyAttendeeMapResponseApplicationJsonBuilder)? b,
  ]) = _$BreakoutRoomApplyAttendeeMapResponseApplicationJson;

  // coverage:ignore-start
  const BreakoutRoomApplyAttendeeMapResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BreakoutRoomApplyAttendeeMapResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BreakoutRoomApplyAttendeeMapResponseApplicationJson.
  static Serializer<BreakoutRoomApplyAttendeeMapResponseApplicationJson> get serializer =>
      _$breakoutRoomApplyAttendeeMapResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BreakoutRoomApplyAttendeeMapResponseApplicationJsonBuilder b) {
    $BreakoutRoomApplyAttendeeMapResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BreakoutRoomApplyAttendeeMapResponseApplicationJsonBuilder b) {
    $BreakoutRoomApplyAttendeeMapResponseApplicationJsonInterface._validate(b);
  }
}

class BreakoutRoomRequestAssistanceApiVersion extends EnumClass {
  const BreakoutRoomRequestAssistanceApiVersion._(super.name);

  /// `v1`
  static const BreakoutRoomRequestAssistanceApiVersion v1 = _$breakoutRoomRequestAssistanceApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<BreakoutRoomRequestAssistanceApiVersion> get values =>
      _$breakoutRoomRequestAssistanceApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static BreakoutRoomRequestAssistanceApiVersion valueOf(String name) =>
      _$valueOfBreakoutRoomRequestAssistanceApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for BreakoutRoomRequestAssistanceApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<BreakoutRoomRequestAssistanceApiVersion> get serializer =>
      const _$BreakoutRoomRequestAssistanceApiVersionSerializer();
}

class _$BreakoutRoomRequestAssistanceApiVersionSerializer
    implements PrimitiveSerializer<BreakoutRoomRequestAssistanceApiVersion> {
  const _$BreakoutRoomRequestAssistanceApiVersionSerializer();

  static const Map<BreakoutRoomRequestAssistanceApiVersion, Object> _toWire =
      <BreakoutRoomRequestAssistanceApiVersion, Object>{
    BreakoutRoomRequestAssistanceApiVersion.v1: 'v1',
  };

  static const Map<Object, BreakoutRoomRequestAssistanceApiVersion> _fromWire =
      <Object, BreakoutRoomRequestAssistanceApiVersion>{
    'v1': BreakoutRoomRequestAssistanceApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BreakoutRoomRequestAssistanceApiVersion];

  @override
  String get wireName => 'BreakoutRoomRequestAssistanceApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BreakoutRoomRequestAssistanceApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BreakoutRoomRequestAssistanceApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomRequestAssistanceResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BreakoutRoomRequestAssistanceResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BreakoutRoomRequestAssistanceResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class BreakoutRoomRequestAssistanceResponseApplicationJson_Ocs
    implements
        $BreakoutRoomRequestAssistanceResponseApplicationJson_OcsInterface,
        Built<BreakoutRoomRequestAssistanceResponseApplicationJson_Ocs,
            BreakoutRoomRequestAssistanceResponseApplicationJson_OcsBuilder> {
  /// Creates a new BreakoutRoomRequestAssistanceResponseApplicationJson_Ocs object using the builder pattern.
  factory BreakoutRoomRequestAssistanceResponseApplicationJson_Ocs([
    void Function(BreakoutRoomRequestAssistanceResponseApplicationJson_OcsBuilder)? b,
  ]) = _$BreakoutRoomRequestAssistanceResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BreakoutRoomRequestAssistanceResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BreakoutRoomRequestAssistanceResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BreakoutRoomRequestAssistanceResponseApplicationJson_Ocs.
  static Serializer<BreakoutRoomRequestAssistanceResponseApplicationJson_Ocs> get serializer =>
      _$breakoutRoomRequestAssistanceResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BreakoutRoomRequestAssistanceResponseApplicationJson_OcsBuilder b) {
    $BreakoutRoomRequestAssistanceResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BreakoutRoomRequestAssistanceResponseApplicationJson_OcsBuilder b) {
    $BreakoutRoomRequestAssistanceResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomRequestAssistanceResponseApplicationJsonInterface {
  BreakoutRoomRequestAssistanceResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BreakoutRoomRequestAssistanceResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BreakoutRoomRequestAssistanceResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class BreakoutRoomRequestAssistanceResponseApplicationJson
    implements
        $BreakoutRoomRequestAssistanceResponseApplicationJsonInterface,
        Built<BreakoutRoomRequestAssistanceResponseApplicationJson,
            BreakoutRoomRequestAssistanceResponseApplicationJsonBuilder> {
  /// Creates a new BreakoutRoomRequestAssistanceResponseApplicationJson object using the builder pattern.
  factory BreakoutRoomRequestAssistanceResponseApplicationJson([
    void Function(BreakoutRoomRequestAssistanceResponseApplicationJsonBuilder)? b,
  ]) = _$BreakoutRoomRequestAssistanceResponseApplicationJson;

  // coverage:ignore-start
  const BreakoutRoomRequestAssistanceResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BreakoutRoomRequestAssistanceResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BreakoutRoomRequestAssistanceResponseApplicationJson.
  static Serializer<BreakoutRoomRequestAssistanceResponseApplicationJson> get serializer =>
      _$breakoutRoomRequestAssistanceResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BreakoutRoomRequestAssistanceResponseApplicationJsonBuilder b) {
    $BreakoutRoomRequestAssistanceResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BreakoutRoomRequestAssistanceResponseApplicationJsonBuilder b) {
    $BreakoutRoomRequestAssistanceResponseApplicationJsonInterface._validate(b);
  }
}

class BreakoutRoomResetRequestForAssistanceApiVersion extends EnumClass {
  const BreakoutRoomResetRequestForAssistanceApiVersion._(super.name);

  /// `v1`
  static const BreakoutRoomResetRequestForAssistanceApiVersion v1 = _$breakoutRoomResetRequestForAssistanceApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<BreakoutRoomResetRequestForAssistanceApiVersion> get values =>
      _$breakoutRoomResetRequestForAssistanceApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static BreakoutRoomResetRequestForAssistanceApiVersion valueOf(String name) =>
      _$valueOfBreakoutRoomResetRequestForAssistanceApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for BreakoutRoomResetRequestForAssistanceApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<BreakoutRoomResetRequestForAssistanceApiVersion> get serializer =>
      const _$BreakoutRoomResetRequestForAssistanceApiVersionSerializer();
}

class _$BreakoutRoomResetRequestForAssistanceApiVersionSerializer
    implements PrimitiveSerializer<BreakoutRoomResetRequestForAssistanceApiVersion> {
  const _$BreakoutRoomResetRequestForAssistanceApiVersionSerializer();

  static const Map<BreakoutRoomResetRequestForAssistanceApiVersion, Object> _toWire =
      <BreakoutRoomResetRequestForAssistanceApiVersion, Object>{
    BreakoutRoomResetRequestForAssistanceApiVersion.v1: 'v1',
  };

  static const Map<Object, BreakoutRoomResetRequestForAssistanceApiVersion> _fromWire =
      <Object, BreakoutRoomResetRequestForAssistanceApiVersion>{
    'v1': BreakoutRoomResetRequestForAssistanceApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BreakoutRoomResetRequestForAssistanceApiVersion];

  @override
  String get wireName => 'BreakoutRoomResetRequestForAssistanceApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BreakoutRoomResetRequestForAssistanceApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BreakoutRoomResetRequestForAssistanceApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomResetRequestForAssistanceResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BreakoutRoomResetRequestForAssistanceResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BreakoutRoomResetRequestForAssistanceResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class BreakoutRoomResetRequestForAssistanceResponseApplicationJson_Ocs
    implements
        $BreakoutRoomResetRequestForAssistanceResponseApplicationJson_OcsInterface,
        Built<BreakoutRoomResetRequestForAssistanceResponseApplicationJson_Ocs,
            BreakoutRoomResetRequestForAssistanceResponseApplicationJson_OcsBuilder> {
  /// Creates a new BreakoutRoomResetRequestForAssistanceResponseApplicationJson_Ocs object using the builder pattern.
  factory BreakoutRoomResetRequestForAssistanceResponseApplicationJson_Ocs([
    void Function(BreakoutRoomResetRequestForAssistanceResponseApplicationJson_OcsBuilder)? b,
  ]) = _$BreakoutRoomResetRequestForAssistanceResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BreakoutRoomResetRequestForAssistanceResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BreakoutRoomResetRequestForAssistanceResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BreakoutRoomResetRequestForAssistanceResponseApplicationJson_Ocs.
  static Serializer<BreakoutRoomResetRequestForAssistanceResponseApplicationJson_Ocs> get serializer =>
      _$breakoutRoomResetRequestForAssistanceResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BreakoutRoomResetRequestForAssistanceResponseApplicationJson_OcsBuilder b) {
    $BreakoutRoomResetRequestForAssistanceResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BreakoutRoomResetRequestForAssistanceResponseApplicationJson_OcsBuilder b) {
    $BreakoutRoomResetRequestForAssistanceResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomResetRequestForAssistanceResponseApplicationJsonInterface {
  BreakoutRoomResetRequestForAssistanceResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BreakoutRoomResetRequestForAssistanceResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BreakoutRoomResetRequestForAssistanceResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class BreakoutRoomResetRequestForAssistanceResponseApplicationJson
    implements
        $BreakoutRoomResetRequestForAssistanceResponseApplicationJsonInterface,
        Built<BreakoutRoomResetRequestForAssistanceResponseApplicationJson,
            BreakoutRoomResetRequestForAssistanceResponseApplicationJsonBuilder> {
  /// Creates a new BreakoutRoomResetRequestForAssistanceResponseApplicationJson object using the builder pattern.
  factory BreakoutRoomResetRequestForAssistanceResponseApplicationJson([
    void Function(BreakoutRoomResetRequestForAssistanceResponseApplicationJsonBuilder)? b,
  ]) = _$BreakoutRoomResetRequestForAssistanceResponseApplicationJson;

  // coverage:ignore-start
  const BreakoutRoomResetRequestForAssistanceResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BreakoutRoomResetRequestForAssistanceResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BreakoutRoomResetRequestForAssistanceResponseApplicationJson.
  static Serializer<BreakoutRoomResetRequestForAssistanceResponseApplicationJson> get serializer =>
      _$breakoutRoomResetRequestForAssistanceResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BreakoutRoomResetRequestForAssistanceResponseApplicationJsonBuilder b) {
    $BreakoutRoomResetRequestForAssistanceResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BreakoutRoomResetRequestForAssistanceResponseApplicationJsonBuilder b) {
    $BreakoutRoomResetRequestForAssistanceResponseApplicationJsonInterface._validate(b);
  }
}

class BreakoutRoomStartBreakoutRoomsApiVersion extends EnumClass {
  const BreakoutRoomStartBreakoutRoomsApiVersion._(super.name);

  /// `v1`
  static const BreakoutRoomStartBreakoutRoomsApiVersion v1 = _$breakoutRoomStartBreakoutRoomsApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<BreakoutRoomStartBreakoutRoomsApiVersion> get values =>
      _$breakoutRoomStartBreakoutRoomsApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static BreakoutRoomStartBreakoutRoomsApiVersion valueOf(String name) =>
      _$valueOfBreakoutRoomStartBreakoutRoomsApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for BreakoutRoomStartBreakoutRoomsApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<BreakoutRoomStartBreakoutRoomsApiVersion> get serializer =>
      const _$BreakoutRoomStartBreakoutRoomsApiVersionSerializer();
}

class _$BreakoutRoomStartBreakoutRoomsApiVersionSerializer
    implements PrimitiveSerializer<BreakoutRoomStartBreakoutRoomsApiVersion> {
  const _$BreakoutRoomStartBreakoutRoomsApiVersionSerializer();

  static const Map<BreakoutRoomStartBreakoutRoomsApiVersion, Object> _toWire =
      <BreakoutRoomStartBreakoutRoomsApiVersion, Object>{
    BreakoutRoomStartBreakoutRoomsApiVersion.v1: 'v1',
  };

  static const Map<Object, BreakoutRoomStartBreakoutRoomsApiVersion> _fromWire =
      <Object, BreakoutRoomStartBreakoutRoomsApiVersion>{
    'v1': BreakoutRoomStartBreakoutRoomsApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BreakoutRoomStartBreakoutRoomsApiVersion];

  @override
  String get wireName => 'BreakoutRoomStartBreakoutRoomsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BreakoutRoomStartBreakoutRoomsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BreakoutRoomStartBreakoutRoomsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomStartBreakoutRoomsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<Room> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BreakoutRoomStartBreakoutRoomsResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BreakoutRoomStartBreakoutRoomsResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class BreakoutRoomStartBreakoutRoomsResponseApplicationJson_Ocs
    implements
        $BreakoutRoomStartBreakoutRoomsResponseApplicationJson_OcsInterface,
        Built<BreakoutRoomStartBreakoutRoomsResponseApplicationJson_Ocs,
            BreakoutRoomStartBreakoutRoomsResponseApplicationJson_OcsBuilder> {
  /// Creates a new BreakoutRoomStartBreakoutRoomsResponseApplicationJson_Ocs object using the builder pattern.
  factory BreakoutRoomStartBreakoutRoomsResponseApplicationJson_Ocs([
    void Function(BreakoutRoomStartBreakoutRoomsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$BreakoutRoomStartBreakoutRoomsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BreakoutRoomStartBreakoutRoomsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BreakoutRoomStartBreakoutRoomsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BreakoutRoomStartBreakoutRoomsResponseApplicationJson_Ocs.
  static Serializer<BreakoutRoomStartBreakoutRoomsResponseApplicationJson_Ocs> get serializer =>
      _$breakoutRoomStartBreakoutRoomsResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BreakoutRoomStartBreakoutRoomsResponseApplicationJson_OcsBuilder b) {
    $BreakoutRoomStartBreakoutRoomsResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BreakoutRoomStartBreakoutRoomsResponseApplicationJson_OcsBuilder b) {
    $BreakoutRoomStartBreakoutRoomsResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomStartBreakoutRoomsResponseApplicationJsonInterface {
  BreakoutRoomStartBreakoutRoomsResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BreakoutRoomStartBreakoutRoomsResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BreakoutRoomStartBreakoutRoomsResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class BreakoutRoomStartBreakoutRoomsResponseApplicationJson
    implements
        $BreakoutRoomStartBreakoutRoomsResponseApplicationJsonInterface,
        Built<BreakoutRoomStartBreakoutRoomsResponseApplicationJson,
            BreakoutRoomStartBreakoutRoomsResponseApplicationJsonBuilder> {
  /// Creates a new BreakoutRoomStartBreakoutRoomsResponseApplicationJson object using the builder pattern.
  factory BreakoutRoomStartBreakoutRoomsResponseApplicationJson([
    void Function(BreakoutRoomStartBreakoutRoomsResponseApplicationJsonBuilder)? b,
  ]) = _$BreakoutRoomStartBreakoutRoomsResponseApplicationJson;

  // coverage:ignore-start
  const BreakoutRoomStartBreakoutRoomsResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BreakoutRoomStartBreakoutRoomsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BreakoutRoomStartBreakoutRoomsResponseApplicationJson.
  static Serializer<BreakoutRoomStartBreakoutRoomsResponseApplicationJson> get serializer =>
      _$breakoutRoomStartBreakoutRoomsResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BreakoutRoomStartBreakoutRoomsResponseApplicationJsonBuilder b) {
    $BreakoutRoomStartBreakoutRoomsResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BreakoutRoomStartBreakoutRoomsResponseApplicationJsonBuilder b) {
    $BreakoutRoomStartBreakoutRoomsResponseApplicationJsonInterface._validate(b);
  }
}

class BreakoutRoomStopBreakoutRoomsApiVersion extends EnumClass {
  const BreakoutRoomStopBreakoutRoomsApiVersion._(super.name);

  /// `v1`
  static const BreakoutRoomStopBreakoutRoomsApiVersion v1 = _$breakoutRoomStopBreakoutRoomsApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<BreakoutRoomStopBreakoutRoomsApiVersion> get values =>
      _$breakoutRoomStopBreakoutRoomsApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static BreakoutRoomStopBreakoutRoomsApiVersion valueOf(String name) =>
      _$valueOfBreakoutRoomStopBreakoutRoomsApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for BreakoutRoomStopBreakoutRoomsApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<BreakoutRoomStopBreakoutRoomsApiVersion> get serializer =>
      const _$BreakoutRoomStopBreakoutRoomsApiVersionSerializer();
}

class _$BreakoutRoomStopBreakoutRoomsApiVersionSerializer
    implements PrimitiveSerializer<BreakoutRoomStopBreakoutRoomsApiVersion> {
  const _$BreakoutRoomStopBreakoutRoomsApiVersionSerializer();

  static const Map<BreakoutRoomStopBreakoutRoomsApiVersion, Object> _toWire =
      <BreakoutRoomStopBreakoutRoomsApiVersion, Object>{
    BreakoutRoomStopBreakoutRoomsApiVersion.v1: 'v1',
  };

  static const Map<Object, BreakoutRoomStopBreakoutRoomsApiVersion> _fromWire =
      <Object, BreakoutRoomStopBreakoutRoomsApiVersion>{
    'v1': BreakoutRoomStopBreakoutRoomsApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BreakoutRoomStopBreakoutRoomsApiVersion];

  @override
  String get wireName => 'BreakoutRoomStopBreakoutRoomsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BreakoutRoomStopBreakoutRoomsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BreakoutRoomStopBreakoutRoomsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomStopBreakoutRoomsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<Room> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BreakoutRoomStopBreakoutRoomsResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BreakoutRoomStopBreakoutRoomsResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class BreakoutRoomStopBreakoutRoomsResponseApplicationJson_Ocs
    implements
        $BreakoutRoomStopBreakoutRoomsResponseApplicationJson_OcsInterface,
        Built<BreakoutRoomStopBreakoutRoomsResponseApplicationJson_Ocs,
            BreakoutRoomStopBreakoutRoomsResponseApplicationJson_OcsBuilder> {
  /// Creates a new BreakoutRoomStopBreakoutRoomsResponseApplicationJson_Ocs object using the builder pattern.
  factory BreakoutRoomStopBreakoutRoomsResponseApplicationJson_Ocs([
    void Function(BreakoutRoomStopBreakoutRoomsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$BreakoutRoomStopBreakoutRoomsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BreakoutRoomStopBreakoutRoomsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BreakoutRoomStopBreakoutRoomsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BreakoutRoomStopBreakoutRoomsResponseApplicationJson_Ocs.
  static Serializer<BreakoutRoomStopBreakoutRoomsResponseApplicationJson_Ocs> get serializer =>
      _$breakoutRoomStopBreakoutRoomsResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BreakoutRoomStopBreakoutRoomsResponseApplicationJson_OcsBuilder b) {
    $BreakoutRoomStopBreakoutRoomsResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BreakoutRoomStopBreakoutRoomsResponseApplicationJson_OcsBuilder b) {
    $BreakoutRoomStopBreakoutRoomsResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomStopBreakoutRoomsResponseApplicationJsonInterface {
  BreakoutRoomStopBreakoutRoomsResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BreakoutRoomStopBreakoutRoomsResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BreakoutRoomStopBreakoutRoomsResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class BreakoutRoomStopBreakoutRoomsResponseApplicationJson
    implements
        $BreakoutRoomStopBreakoutRoomsResponseApplicationJsonInterface,
        Built<BreakoutRoomStopBreakoutRoomsResponseApplicationJson,
            BreakoutRoomStopBreakoutRoomsResponseApplicationJsonBuilder> {
  /// Creates a new BreakoutRoomStopBreakoutRoomsResponseApplicationJson object using the builder pattern.
  factory BreakoutRoomStopBreakoutRoomsResponseApplicationJson([
    void Function(BreakoutRoomStopBreakoutRoomsResponseApplicationJsonBuilder)? b,
  ]) = _$BreakoutRoomStopBreakoutRoomsResponseApplicationJson;

  // coverage:ignore-start
  const BreakoutRoomStopBreakoutRoomsResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BreakoutRoomStopBreakoutRoomsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BreakoutRoomStopBreakoutRoomsResponseApplicationJson.
  static Serializer<BreakoutRoomStopBreakoutRoomsResponseApplicationJson> get serializer =>
      _$breakoutRoomStopBreakoutRoomsResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BreakoutRoomStopBreakoutRoomsResponseApplicationJsonBuilder b) {
    $BreakoutRoomStopBreakoutRoomsResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BreakoutRoomStopBreakoutRoomsResponseApplicationJsonBuilder b) {
    $BreakoutRoomStopBreakoutRoomsResponseApplicationJsonInterface._validate(b);
  }
}

class BreakoutRoomSwitchBreakoutRoomApiVersion extends EnumClass {
  const BreakoutRoomSwitchBreakoutRoomApiVersion._(super.name);

  /// `v1`
  static const BreakoutRoomSwitchBreakoutRoomApiVersion v1 = _$breakoutRoomSwitchBreakoutRoomApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<BreakoutRoomSwitchBreakoutRoomApiVersion> get values =>
      _$breakoutRoomSwitchBreakoutRoomApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static BreakoutRoomSwitchBreakoutRoomApiVersion valueOf(String name) =>
      _$valueOfBreakoutRoomSwitchBreakoutRoomApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for BreakoutRoomSwitchBreakoutRoomApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<BreakoutRoomSwitchBreakoutRoomApiVersion> get serializer =>
      const _$BreakoutRoomSwitchBreakoutRoomApiVersionSerializer();
}

class _$BreakoutRoomSwitchBreakoutRoomApiVersionSerializer
    implements PrimitiveSerializer<BreakoutRoomSwitchBreakoutRoomApiVersion> {
  const _$BreakoutRoomSwitchBreakoutRoomApiVersionSerializer();

  static const Map<BreakoutRoomSwitchBreakoutRoomApiVersion, Object> _toWire =
      <BreakoutRoomSwitchBreakoutRoomApiVersion, Object>{
    BreakoutRoomSwitchBreakoutRoomApiVersion.v1: 'v1',
  };

  static const Map<Object, BreakoutRoomSwitchBreakoutRoomApiVersion> _fromWire =
      <Object, BreakoutRoomSwitchBreakoutRoomApiVersion>{
    'v1': BreakoutRoomSwitchBreakoutRoomApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BreakoutRoomSwitchBreakoutRoomApiVersion];

  @override
  String get wireName => 'BreakoutRoomSwitchBreakoutRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BreakoutRoomSwitchBreakoutRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BreakoutRoomSwitchBreakoutRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_Ocs
    implements
        $BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_OcsInterface,
        Built<BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_Ocs,
            BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_OcsBuilder> {
  /// Creates a new BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_Ocs object using the builder pattern.
  factory BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_Ocs([
    void Function(BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_OcsBuilder)? b,
  ]) = _$BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_Ocs.
  static Serializer<BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_Ocs> get serializer =>
      _$breakoutRoomSwitchBreakoutRoomResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_OcsBuilder b) {
    $BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_OcsBuilder b) {
    $BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomSwitchBreakoutRoomResponseApplicationJsonInterface {
  BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BreakoutRoomSwitchBreakoutRoomResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BreakoutRoomSwitchBreakoutRoomResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class BreakoutRoomSwitchBreakoutRoomResponseApplicationJson
    implements
        $BreakoutRoomSwitchBreakoutRoomResponseApplicationJsonInterface,
        Built<BreakoutRoomSwitchBreakoutRoomResponseApplicationJson,
            BreakoutRoomSwitchBreakoutRoomResponseApplicationJsonBuilder> {
  /// Creates a new BreakoutRoomSwitchBreakoutRoomResponseApplicationJson object using the builder pattern.
  factory BreakoutRoomSwitchBreakoutRoomResponseApplicationJson([
    void Function(BreakoutRoomSwitchBreakoutRoomResponseApplicationJsonBuilder)? b,
  ]) = _$BreakoutRoomSwitchBreakoutRoomResponseApplicationJson;

  // coverage:ignore-start
  const BreakoutRoomSwitchBreakoutRoomResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BreakoutRoomSwitchBreakoutRoomResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BreakoutRoomSwitchBreakoutRoomResponseApplicationJson.
  static Serializer<BreakoutRoomSwitchBreakoutRoomResponseApplicationJson> get serializer =>
      _$breakoutRoomSwitchBreakoutRoomResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BreakoutRoomSwitchBreakoutRoomResponseApplicationJsonBuilder b) {
    $BreakoutRoomSwitchBreakoutRoomResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BreakoutRoomSwitchBreakoutRoomResponseApplicationJsonBuilder b) {
    $BreakoutRoomSwitchBreakoutRoomResponseApplicationJsonInterface._validate(b);
  }
}

class CallGetPeersForCallApiVersion extends EnumClass {
  const CallGetPeersForCallApiVersion._(super.name);

  /// `v4`
  static const CallGetPeersForCallApiVersion v4 = _$callGetPeersForCallApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<CallGetPeersForCallApiVersion> get values => _$callGetPeersForCallApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static CallGetPeersForCallApiVersion valueOf(String name) => _$valueOfCallGetPeersForCallApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for CallGetPeersForCallApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<CallGetPeersForCallApiVersion> get serializer => const _$CallGetPeersForCallApiVersionSerializer();
}

class _$CallGetPeersForCallApiVersionSerializer implements PrimitiveSerializer<CallGetPeersForCallApiVersion> {
  const _$CallGetPeersForCallApiVersionSerializer();

  static const Map<CallGetPeersForCallApiVersion, Object> _toWire = <CallGetPeersForCallApiVersion, Object>{
    CallGetPeersForCallApiVersion.v4: 'v4',
  };

  static const Map<Object, CallGetPeersForCallApiVersion> _fromWire = <Object, CallGetPeersForCallApiVersion>{
    'v4': CallGetPeersForCallApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [CallGetPeersForCallApiVersion];

  @override
  String get wireName => 'CallGetPeersForCallApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    CallGetPeersForCallApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  CallGetPeersForCallApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $CallPeerInterface {
  String get actorId;
  ActorType get actorType;
  String get displayName;
  int get lastPing;
  String get sessionId;
  String get token;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CallPeerInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CallPeerInterfaceBuilder b) {}
}

abstract class CallPeer implements $CallPeerInterface, Built<CallPeer, CallPeerBuilder> {
  /// Creates a new CallPeer object using the builder pattern.
  factory CallPeer([void Function(CallPeerBuilder)? b]) = _$CallPeer;

  // coverage:ignore-start
  const CallPeer._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CallPeer.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CallPeer.
  static Serializer<CallPeer> get serializer => _$callPeerSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CallPeerBuilder b) {
    $CallPeerInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CallPeerBuilder b) {
    $CallPeerInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CallGetPeersForCallResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<CallPeer> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CallGetPeersForCallResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CallGetPeersForCallResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class CallGetPeersForCallResponseApplicationJson_Ocs
    implements
        $CallGetPeersForCallResponseApplicationJson_OcsInterface,
        Built<CallGetPeersForCallResponseApplicationJson_Ocs, CallGetPeersForCallResponseApplicationJson_OcsBuilder> {
  /// Creates a new CallGetPeersForCallResponseApplicationJson_Ocs object using the builder pattern.
  factory CallGetPeersForCallResponseApplicationJson_Ocs([
    void Function(CallGetPeersForCallResponseApplicationJson_OcsBuilder)? b,
  ]) = _$CallGetPeersForCallResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const CallGetPeersForCallResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CallGetPeersForCallResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CallGetPeersForCallResponseApplicationJson_Ocs.
  static Serializer<CallGetPeersForCallResponseApplicationJson_Ocs> get serializer =>
      _$callGetPeersForCallResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CallGetPeersForCallResponseApplicationJson_OcsBuilder b) {
    $CallGetPeersForCallResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CallGetPeersForCallResponseApplicationJson_OcsBuilder b) {
    $CallGetPeersForCallResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CallGetPeersForCallResponseApplicationJsonInterface {
  CallGetPeersForCallResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CallGetPeersForCallResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CallGetPeersForCallResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class CallGetPeersForCallResponseApplicationJson
    implements
        $CallGetPeersForCallResponseApplicationJsonInterface,
        Built<CallGetPeersForCallResponseApplicationJson, CallGetPeersForCallResponseApplicationJsonBuilder> {
  /// Creates a new CallGetPeersForCallResponseApplicationJson object using the builder pattern.
  factory CallGetPeersForCallResponseApplicationJson([
    void Function(CallGetPeersForCallResponseApplicationJsonBuilder)? b,
  ]) = _$CallGetPeersForCallResponseApplicationJson;

  // coverage:ignore-start
  const CallGetPeersForCallResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CallGetPeersForCallResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CallGetPeersForCallResponseApplicationJson.
  static Serializer<CallGetPeersForCallResponseApplicationJson> get serializer =>
      _$callGetPeersForCallResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CallGetPeersForCallResponseApplicationJsonBuilder b) {
    $CallGetPeersForCallResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CallGetPeersForCallResponseApplicationJsonBuilder b) {
    $CallGetPeersForCallResponseApplicationJsonInterface._validate(b);
  }
}

class CallUpdateCallFlagsApiVersion extends EnumClass {
  const CallUpdateCallFlagsApiVersion._(super.name);

  /// `v4`
  static const CallUpdateCallFlagsApiVersion v4 = _$callUpdateCallFlagsApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<CallUpdateCallFlagsApiVersion> get values => _$callUpdateCallFlagsApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static CallUpdateCallFlagsApiVersion valueOf(String name) => _$valueOfCallUpdateCallFlagsApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for CallUpdateCallFlagsApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<CallUpdateCallFlagsApiVersion> get serializer => const _$CallUpdateCallFlagsApiVersionSerializer();
}

class _$CallUpdateCallFlagsApiVersionSerializer implements PrimitiveSerializer<CallUpdateCallFlagsApiVersion> {
  const _$CallUpdateCallFlagsApiVersionSerializer();

  static const Map<CallUpdateCallFlagsApiVersion, Object> _toWire = <CallUpdateCallFlagsApiVersion, Object>{
    CallUpdateCallFlagsApiVersion.v4: 'v4',
  };

  static const Map<Object, CallUpdateCallFlagsApiVersion> _fromWire = <Object, CallUpdateCallFlagsApiVersion>{
    'v4': CallUpdateCallFlagsApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [CallUpdateCallFlagsApiVersion];

  @override
  String get wireName => 'CallUpdateCallFlagsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    CallUpdateCallFlagsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  CallUpdateCallFlagsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $CallUpdateCallFlagsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CallUpdateCallFlagsResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CallUpdateCallFlagsResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class CallUpdateCallFlagsResponseApplicationJson_Ocs
    implements
        $CallUpdateCallFlagsResponseApplicationJson_OcsInterface,
        Built<CallUpdateCallFlagsResponseApplicationJson_Ocs, CallUpdateCallFlagsResponseApplicationJson_OcsBuilder> {
  /// Creates a new CallUpdateCallFlagsResponseApplicationJson_Ocs object using the builder pattern.
  factory CallUpdateCallFlagsResponseApplicationJson_Ocs([
    void Function(CallUpdateCallFlagsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$CallUpdateCallFlagsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const CallUpdateCallFlagsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CallUpdateCallFlagsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CallUpdateCallFlagsResponseApplicationJson_Ocs.
  static Serializer<CallUpdateCallFlagsResponseApplicationJson_Ocs> get serializer =>
      _$callUpdateCallFlagsResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CallUpdateCallFlagsResponseApplicationJson_OcsBuilder b) {
    $CallUpdateCallFlagsResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CallUpdateCallFlagsResponseApplicationJson_OcsBuilder b) {
    $CallUpdateCallFlagsResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CallUpdateCallFlagsResponseApplicationJsonInterface {
  CallUpdateCallFlagsResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CallUpdateCallFlagsResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CallUpdateCallFlagsResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class CallUpdateCallFlagsResponseApplicationJson
    implements
        $CallUpdateCallFlagsResponseApplicationJsonInterface,
        Built<CallUpdateCallFlagsResponseApplicationJson, CallUpdateCallFlagsResponseApplicationJsonBuilder> {
  /// Creates a new CallUpdateCallFlagsResponseApplicationJson object using the builder pattern.
  factory CallUpdateCallFlagsResponseApplicationJson([
    void Function(CallUpdateCallFlagsResponseApplicationJsonBuilder)? b,
  ]) = _$CallUpdateCallFlagsResponseApplicationJson;

  // coverage:ignore-start
  const CallUpdateCallFlagsResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CallUpdateCallFlagsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CallUpdateCallFlagsResponseApplicationJson.
  static Serializer<CallUpdateCallFlagsResponseApplicationJson> get serializer =>
      _$callUpdateCallFlagsResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CallUpdateCallFlagsResponseApplicationJsonBuilder b) {
    $CallUpdateCallFlagsResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CallUpdateCallFlagsResponseApplicationJsonBuilder b) {
    $CallUpdateCallFlagsResponseApplicationJsonInterface._validate(b);
  }
}

class CallJoinCallSilent extends EnumClass {
  const CallJoinCallSilent._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const CallJoinCallSilent $0 = _$callJoinCallSilent$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const CallJoinCallSilent $1 = _$callJoinCallSilent$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<CallJoinCallSilent> get values => _$callJoinCallSilentValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static CallJoinCallSilent valueOf(String name) => _$valueOfCallJoinCallSilent(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for CallJoinCallSilent.
  @BuiltValueSerializer(custom: true)
  static Serializer<CallJoinCallSilent> get serializer => const _$CallJoinCallSilentSerializer();
}

class _$CallJoinCallSilentSerializer implements PrimitiveSerializer<CallJoinCallSilent> {
  const _$CallJoinCallSilentSerializer();

  static const Map<CallJoinCallSilent, Object> _toWire = <CallJoinCallSilent, Object>{
    CallJoinCallSilent.$0: 0,
    CallJoinCallSilent.$1: 1,
  };

  static const Map<Object, CallJoinCallSilent> _fromWire = <Object, CallJoinCallSilent>{
    0: CallJoinCallSilent.$0,
    1: CallJoinCallSilent.$1,
  };

  @override
  Iterable<Type> get types => const [CallJoinCallSilent];

  @override
  String get wireName => 'CallJoinCallSilent';

  @override
  Object serialize(
    Serializers serializers,
    CallJoinCallSilent object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  CallJoinCallSilent deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class CallJoinCallRecordingConsent extends EnumClass {
  const CallJoinCallRecordingConsent._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const CallJoinCallRecordingConsent $0 = _$callJoinCallRecordingConsent$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const CallJoinCallRecordingConsent $1 = _$callJoinCallRecordingConsent$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<CallJoinCallRecordingConsent> get values => _$callJoinCallRecordingConsentValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static CallJoinCallRecordingConsent valueOf(String name) => _$valueOfCallJoinCallRecordingConsent(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for CallJoinCallRecordingConsent.
  @BuiltValueSerializer(custom: true)
  static Serializer<CallJoinCallRecordingConsent> get serializer => const _$CallJoinCallRecordingConsentSerializer();
}

class _$CallJoinCallRecordingConsentSerializer implements PrimitiveSerializer<CallJoinCallRecordingConsent> {
  const _$CallJoinCallRecordingConsentSerializer();

  static const Map<CallJoinCallRecordingConsent, Object> _toWire = <CallJoinCallRecordingConsent, Object>{
    CallJoinCallRecordingConsent.$0: 0,
    CallJoinCallRecordingConsent.$1: 1,
  };

  static const Map<Object, CallJoinCallRecordingConsent> _fromWire = <Object, CallJoinCallRecordingConsent>{
    0: CallJoinCallRecordingConsent.$0,
    1: CallJoinCallRecordingConsent.$1,
  };

  @override
  Iterable<Type> get types => const [CallJoinCallRecordingConsent];

  @override
  String get wireName => 'CallJoinCallRecordingConsent';

  @override
  Object serialize(
    Serializers serializers,
    CallJoinCallRecordingConsent object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  CallJoinCallRecordingConsent deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class CallJoinCallApiVersion extends EnumClass {
  const CallJoinCallApiVersion._(super.name);

  /// `v4`
  static const CallJoinCallApiVersion v4 = _$callJoinCallApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<CallJoinCallApiVersion> get values => _$callJoinCallApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static CallJoinCallApiVersion valueOf(String name) => _$valueOfCallJoinCallApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for CallJoinCallApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<CallJoinCallApiVersion> get serializer => const _$CallJoinCallApiVersionSerializer();
}

class _$CallJoinCallApiVersionSerializer implements PrimitiveSerializer<CallJoinCallApiVersion> {
  const _$CallJoinCallApiVersionSerializer();

  static const Map<CallJoinCallApiVersion, Object> _toWire = <CallJoinCallApiVersion, Object>{
    CallJoinCallApiVersion.v4: 'v4',
  };

  static const Map<Object, CallJoinCallApiVersion> _fromWire = <Object, CallJoinCallApiVersion>{
    'v4': CallJoinCallApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [CallJoinCallApiVersion];

  @override
  String get wireName => 'CallJoinCallApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    CallJoinCallApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  CallJoinCallApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $CallJoinCallResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CallJoinCallResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CallJoinCallResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class CallJoinCallResponseApplicationJson_Ocs
    implements
        $CallJoinCallResponseApplicationJson_OcsInterface,
        Built<CallJoinCallResponseApplicationJson_Ocs, CallJoinCallResponseApplicationJson_OcsBuilder> {
  /// Creates a new CallJoinCallResponseApplicationJson_Ocs object using the builder pattern.
  factory CallJoinCallResponseApplicationJson_Ocs([void Function(CallJoinCallResponseApplicationJson_OcsBuilder)? b]) =
      _$CallJoinCallResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const CallJoinCallResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CallJoinCallResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CallJoinCallResponseApplicationJson_Ocs.
  static Serializer<CallJoinCallResponseApplicationJson_Ocs> get serializer =>
      _$callJoinCallResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CallJoinCallResponseApplicationJson_OcsBuilder b) {
    $CallJoinCallResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CallJoinCallResponseApplicationJson_OcsBuilder b) {
    $CallJoinCallResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CallJoinCallResponseApplicationJsonInterface {
  CallJoinCallResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CallJoinCallResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CallJoinCallResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class CallJoinCallResponseApplicationJson
    implements
        $CallJoinCallResponseApplicationJsonInterface,
        Built<CallJoinCallResponseApplicationJson, CallJoinCallResponseApplicationJsonBuilder> {
  /// Creates a new CallJoinCallResponseApplicationJson object using the builder pattern.
  factory CallJoinCallResponseApplicationJson([void Function(CallJoinCallResponseApplicationJsonBuilder)? b]) =
      _$CallJoinCallResponseApplicationJson;

  // coverage:ignore-start
  const CallJoinCallResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CallJoinCallResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CallJoinCallResponseApplicationJson.
  static Serializer<CallJoinCallResponseApplicationJson> get serializer =>
      _$callJoinCallResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CallJoinCallResponseApplicationJsonBuilder b) {
    $CallJoinCallResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CallJoinCallResponseApplicationJsonBuilder b) {
    $CallJoinCallResponseApplicationJsonInterface._validate(b);
  }
}

class CallLeaveCallAll extends EnumClass {
  const CallLeaveCallAll._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const CallLeaveCallAll $0 = _$callLeaveCallAll$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const CallLeaveCallAll $1 = _$callLeaveCallAll$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<CallLeaveCallAll> get values => _$callLeaveCallAllValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static CallLeaveCallAll valueOf(String name) => _$valueOfCallLeaveCallAll(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for CallLeaveCallAll.
  @BuiltValueSerializer(custom: true)
  static Serializer<CallLeaveCallAll> get serializer => const _$CallLeaveCallAllSerializer();
}

class _$CallLeaveCallAllSerializer implements PrimitiveSerializer<CallLeaveCallAll> {
  const _$CallLeaveCallAllSerializer();

  static const Map<CallLeaveCallAll, Object> _toWire = <CallLeaveCallAll, Object>{
    CallLeaveCallAll.$0: 0,
    CallLeaveCallAll.$1: 1,
  };

  static const Map<Object, CallLeaveCallAll> _fromWire = <Object, CallLeaveCallAll>{
    0: CallLeaveCallAll.$0,
    1: CallLeaveCallAll.$1,
  };

  @override
  Iterable<Type> get types => const [CallLeaveCallAll];

  @override
  String get wireName => 'CallLeaveCallAll';

  @override
  Object serialize(
    Serializers serializers,
    CallLeaveCallAll object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  CallLeaveCallAll deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class CallLeaveCallApiVersion extends EnumClass {
  const CallLeaveCallApiVersion._(super.name);

  /// `v4`
  static const CallLeaveCallApiVersion v4 = _$callLeaveCallApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<CallLeaveCallApiVersion> get values => _$callLeaveCallApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static CallLeaveCallApiVersion valueOf(String name) => _$valueOfCallLeaveCallApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for CallLeaveCallApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<CallLeaveCallApiVersion> get serializer => const _$CallLeaveCallApiVersionSerializer();
}

class _$CallLeaveCallApiVersionSerializer implements PrimitiveSerializer<CallLeaveCallApiVersion> {
  const _$CallLeaveCallApiVersionSerializer();

  static const Map<CallLeaveCallApiVersion, Object> _toWire = <CallLeaveCallApiVersion, Object>{
    CallLeaveCallApiVersion.v4: 'v4',
  };

  static const Map<Object, CallLeaveCallApiVersion> _fromWire = <Object, CallLeaveCallApiVersion>{
    'v4': CallLeaveCallApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [CallLeaveCallApiVersion];

  @override
  String get wireName => 'CallLeaveCallApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    CallLeaveCallApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  CallLeaveCallApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $CallLeaveCallResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CallLeaveCallResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CallLeaveCallResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class CallLeaveCallResponseApplicationJson_Ocs
    implements
        $CallLeaveCallResponseApplicationJson_OcsInterface,
        Built<CallLeaveCallResponseApplicationJson_Ocs, CallLeaveCallResponseApplicationJson_OcsBuilder> {
  /// Creates a new CallLeaveCallResponseApplicationJson_Ocs object using the builder pattern.
  factory CallLeaveCallResponseApplicationJson_Ocs([
    void Function(CallLeaveCallResponseApplicationJson_OcsBuilder)? b,
  ]) = _$CallLeaveCallResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const CallLeaveCallResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CallLeaveCallResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CallLeaveCallResponseApplicationJson_Ocs.
  static Serializer<CallLeaveCallResponseApplicationJson_Ocs> get serializer =>
      _$callLeaveCallResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CallLeaveCallResponseApplicationJson_OcsBuilder b) {
    $CallLeaveCallResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CallLeaveCallResponseApplicationJson_OcsBuilder b) {
    $CallLeaveCallResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CallLeaveCallResponseApplicationJsonInterface {
  CallLeaveCallResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CallLeaveCallResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CallLeaveCallResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class CallLeaveCallResponseApplicationJson
    implements
        $CallLeaveCallResponseApplicationJsonInterface,
        Built<CallLeaveCallResponseApplicationJson, CallLeaveCallResponseApplicationJsonBuilder> {
  /// Creates a new CallLeaveCallResponseApplicationJson object using the builder pattern.
  factory CallLeaveCallResponseApplicationJson([void Function(CallLeaveCallResponseApplicationJsonBuilder)? b]) =
      _$CallLeaveCallResponseApplicationJson;

  // coverage:ignore-start
  const CallLeaveCallResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CallLeaveCallResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CallLeaveCallResponseApplicationJson.
  static Serializer<CallLeaveCallResponseApplicationJson> get serializer =>
      _$callLeaveCallResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CallLeaveCallResponseApplicationJsonBuilder b) {
    $CallLeaveCallResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CallLeaveCallResponseApplicationJsonBuilder b) {
    $CallLeaveCallResponseApplicationJsonInterface._validate(b);
  }
}

class CallRingAttendeeApiVersion extends EnumClass {
  const CallRingAttendeeApiVersion._(super.name);

  /// `v4`
  static const CallRingAttendeeApiVersion v4 = _$callRingAttendeeApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<CallRingAttendeeApiVersion> get values => _$callRingAttendeeApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static CallRingAttendeeApiVersion valueOf(String name) => _$valueOfCallRingAttendeeApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for CallRingAttendeeApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<CallRingAttendeeApiVersion> get serializer => const _$CallRingAttendeeApiVersionSerializer();
}

class _$CallRingAttendeeApiVersionSerializer implements PrimitiveSerializer<CallRingAttendeeApiVersion> {
  const _$CallRingAttendeeApiVersionSerializer();

  static const Map<CallRingAttendeeApiVersion, Object> _toWire = <CallRingAttendeeApiVersion, Object>{
    CallRingAttendeeApiVersion.v4: 'v4',
  };

  static const Map<Object, CallRingAttendeeApiVersion> _fromWire = <Object, CallRingAttendeeApiVersion>{
    'v4': CallRingAttendeeApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [CallRingAttendeeApiVersion];

  @override
  String get wireName => 'CallRingAttendeeApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    CallRingAttendeeApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  CallRingAttendeeApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $CallRingAttendeeResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CallRingAttendeeResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CallRingAttendeeResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class CallRingAttendeeResponseApplicationJson_Ocs
    implements
        $CallRingAttendeeResponseApplicationJson_OcsInterface,
        Built<CallRingAttendeeResponseApplicationJson_Ocs, CallRingAttendeeResponseApplicationJson_OcsBuilder> {
  /// Creates a new CallRingAttendeeResponseApplicationJson_Ocs object using the builder pattern.
  factory CallRingAttendeeResponseApplicationJson_Ocs([
    void Function(CallRingAttendeeResponseApplicationJson_OcsBuilder)? b,
  ]) = _$CallRingAttendeeResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const CallRingAttendeeResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CallRingAttendeeResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CallRingAttendeeResponseApplicationJson_Ocs.
  static Serializer<CallRingAttendeeResponseApplicationJson_Ocs> get serializer =>
      _$callRingAttendeeResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CallRingAttendeeResponseApplicationJson_OcsBuilder b) {
    $CallRingAttendeeResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CallRingAttendeeResponseApplicationJson_OcsBuilder b) {
    $CallRingAttendeeResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CallRingAttendeeResponseApplicationJsonInterface {
  CallRingAttendeeResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CallRingAttendeeResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CallRingAttendeeResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class CallRingAttendeeResponseApplicationJson
    implements
        $CallRingAttendeeResponseApplicationJsonInterface,
        Built<CallRingAttendeeResponseApplicationJson, CallRingAttendeeResponseApplicationJsonBuilder> {
  /// Creates a new CallRingAttendeeResponseApplicationJson object using the builder pattern.
  factory CallRingAttendeeResponseApplicationJson([void Function(CallRingAttendeeResponseApplicationJsonBuilder)? b]) =
      _$CallRingAttendeeResponseApplicationJson;

  // coverage:ignore-start
  const CallRingAttendeeResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CallRingAttendeeResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CallRingAttendeeResponseApplicationJson.
  static Serializer<CallRingAttendeeResponseApplicationJson> get serializer =>
      _$callRingAttendeeResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CallRingAttendeeResponseApplicationJsonBuilder b) {
    $CallRingAttendeeResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CallRingAttendeeResponseApplicationJsonBuilder b) {
    $CallRingAttendeeResponseApplicationJsonInterface._validate(b);
  }
}

class CallSipDialOutApiVersion extends EnumClass {
  const CallSipDialOutApiVersion._(super.name);

  /// `v4`
  static const CallSipDialOutApiVersion v4 = _$callSipDialOutApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<CallSipDialOutApiVersion> get values => _$callSipDialOutApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static CallSipDialOutApiVersion valueOf(String name) => _$valueOfCallSipDialOutApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for CallSipDialOutApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<CallSipDialOutApiVersion> get serializer => const _$CallSipDialOutApiVersionSerializer();
}

class _$CallSipDialOutApiVersionSerializer implements PrimitiveSerializer<CallSipDialOutApiVersion> {
  const _$CallSipDialOutApiVersionSerializer();

  static const Map<CallSipDialOutApiVersion, Object> _toWire = <CallSipDialOutApiVersion, Object>{
    CallSipDialOutApiVersion.v4: 'v4',
  };

  static const Map<Object, CallSipDialOutApiVersion> _fromWire = <Object, CallSipDialOutApiVersion>{
    'v4': CallSipDialOutApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [CallSipDialOutApiVersion];

  @override
  String get wireName => 'CallSipDialOutApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    CallSipDialOutApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  CallSipDialOutApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $CallSipDialOutResponseApplicationJson_Ocs_DataInterface {
  String? get error;
  String? get message;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CallSipDialOutResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CallSipDialOutResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class CallSipDialOutResponseApplicationJson_Ocs_Data
    implements
        $CallSipDialOutResponseApplicationJson_Ocs_DataInterface,
        Built<CallSipDialOutResponseApplicationJson_Ocs_Data, CallSipDialOutResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new CallSipDialOutResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory CallSipDialOutResponseApplicationJson_Ocs_Data([
    void Function(CallSipDialOutResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$CallSipDialOutResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const CallSipDialOutResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CallSipDialOutResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CallSipDialOutResponseApplicationJson_Ocs_Data.
  static Serializer<CallSipDialOutResponseApplicationJson_Ocs_Data> get serializer =>
      _$callSipDialOutResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CallSipDialOutResponseApplicationJson_Ocs_DataBuilder b) {
    $CallSipDialOutResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CallSipDialOutResponseApplicationJson_Ocs_DataBuilder b) {
    $CallSipDialOutResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CallSipDialOutResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  CallSipDialOutResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CallSipDialOutResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CallSipDialOutResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class CallSipDialOutResponseApplicationJson_Ocs
    implements
        $CallSipDialOutResponseApplicationJson_OcsInterface,
        Built<CallSipDialOutResponseApplicationJson_Ocs, CallSipDialOutResponseApplicationJson_OcsBuilder> {
  /// Creates a new CallSipDialOutResponseApplicationJson_Ocs object using the builder pattern.
  factory CallSipDialOutResponseApplicationJson_Ocs([
    void Function(CallSipDialOutResponseApplicationJson_OcsBuilder)? b,
  ]) = _$CallSipDialOutResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const CallSipDialOutResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CallSipDialOutResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CallSipDialOutResponseApplicationJson_Ocs.
  static Serializer<CallSipDialOutResponseApplicationJson_Ocs> get serializer =>
      _$callSipDialOutResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CallSipDialOutResponseApplicationJson_OcsBuilder b) {
    $CallSipDialOutResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CallSipDialOutResponseApplicationJson_OcsBuilder b) {
    $CallSipDialOutResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CallSipDialOutResponseApplicationJsonInterface {
  CallSipDialOutResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CallSipDialOutResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CallSipDialOutResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class CallSipDialOutResponseApplicationJson
    implements
        $CallSipDialOutResponseApplicationJsonInterface,
        Built<CallSipDialOutResponseApplicationJson, CallSipDialOutResponseApplicationJsonBuilder> {
  /// Creates a new CallSipDialOutResponseApplicationJson object using the builder pattern.
  factory CallSipDialOutResponseApplicationJson([void Function(CallSipDialOutResponseApplicationJsonBuilder)? b]) =
      _$CallSipDialOutResponseApplicationJson;

  // coverage:ignore-start
  const CallSipDialOutResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CallSipDialOutResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CallSipDialOutResponseApplicationJson.
  static Serializer<CallSipDialOutResponseApplicationJson> get serializer =>
      _$callSipDialOutResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CallSipDialOutResponseApplicationJsonBuilder b) {
    $CallSipDialOutResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CallSipDialOutResponseApplicationJsonBuilder b) {
    $CallSipDialOutResponseApplicationJsonInterface._validate(b);
  }
}

class ChatReceiveMessagesLookIntoFuture extends EnumClass {
  const ChatReceiveMessagesLookIntoFuture._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const ChatReceiveMessagesLookIntoFuture $0 = _$chatReceiveMessagesLookIntoFuture$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const ChatReceiveMessagesLookIntoFuture $1 = _$chatReceiveMessagesLookIntoFuture$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<ChatReceiveMessagesLookIntoFuture> get values => _$chatReceiveMessagesLookIntoFutureValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static ChatReceiveMessagesLookIntoFuture valueOf(String name) => _$valueOfChatReceiveMessagesLookIntoFuture(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for ChatReceiveMessagesLookIntoFuture.
  @BuiltValueSerializer(custom: true)
  static Serializer<ChatReceiveMessagesLookIntoFuture> get serializer =>
      const _$ChatReceiveMessagesLookIntoFutureSerializer();
}

class _$ChatReceiveMessagesLookIntoFutureSerializer implements PrimitiveSerializer<ChatReceiveMessagesLookIntoFuture> {
  const _$ChatReceiveMessagesLookIntoFutureSerializer();

  static const Map<ChatReceiveMessagesLookIntoFuture, Object> _toWire = <ChatReceiveMessagesLookIntoFuture, Object>{
    ChatReceiveMessagesLookIntoFuture.$0: 0,
    ChatReceiveMessagesLookIntoFuture.$1: 1,
  };

  static const Map<Object, ChatReceiveMessagesLookIntoFuture> _fromWire = <Object, ChatReceiveMessagesLookIntoFuture>{
    0: ChatReceiveMessagesLookIntoFuture.$0,
    1: ChatReceiveMessagesLookIntoFuture.$1,
  };

  @override
  Iterable<Type> get types => const [ChatReceiveMessagesLookIntoFuture];

  @override
  String get wireName => 'ChatReceiveMessagesLookIntoFuture';

  @override
  Object serialize(
    Serializers serializers,
    ChatReceiveMessagesLookIntoFuture object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatReceiveMessagesLookIntoFuture deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class ChatReceiveMessagesSetReadMarker extends EnumClass {
  const ChatReceiveMessagesSetReadMarker._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const ChatReceiveMessagesSetReadMarker $0 = _$chatReceiveMessagesSetReadMarker$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const ChatReceiveMessagesSetReadMarker $1 = _$chatReceiveMessagesSetReadMarker$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<ChatReceiveMessagesSetReadMarker> get values => _$chatReceiveMessagesSetReadMarkerValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static ChatReceiveMessagesSetReadMarker valueOf(String name) => _$valueOfChatReceiveMessagesSetReadMarker(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for ChatReceiveMessagesSetReadMarker.
  @BuiltValueSerializer(custom: true)
  static Serializer<ChatReceiveMessagesSetReadMarker> get serializer =>
      const _$ChatReceiveMessagesSetReadMarkerSerializer();
}

class _$ChatReceiveMessagesSetReadMarkerSerializer implements PrimitiveSerializer<ChatReceiveMessagesSetReadMarker> {
  const _$ChatReceiveMessagesSetReadMarkerSerializer();

  static const Map<ChatReceiveMessagesSetReadMarker, Object> _toWire = <ChatReceiveMessagesSetReadMarker, Object>{
    ChatReceiveMessagesSetReadMarker.$0: 0,
    ChatReceiveMessagesSetReadMarker.$1: 1,
  };

  static const Map<Object, ChatReceiveMessagesSetReadMarker> _fromWire = <Object, ChatReceiveMessagesSetReadMarker>{
    0: ChatReceiveMessagesSetReadMarker.$0,
    1: ChatReceiveMessagesSetReadMarker.$1,
  };

  @override
  Iterable<Type> get types => const [ChatReceiveMessagesSetReadMarker];

  @override
  String get wireName => 'ChatReceiveMessagesSetReadMarker';

  @override
  Object serialize(
    Serializers serializers,
    ChatReceiveMessagesSetReadMarker object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatReceiveMessagesSetReadMarker deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class ChatReceiveMessagesIncludeLastKnown extends EnumClass {
  const ChatReceiveMessagesIncludeLastKnown._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const ChatReceiveMessagesIncludeLastKnown $0 = _$chatReceiveMessagesIncludeLastKnown$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const ChatReceiveMessagesIncludeLastKnown $1 = _$chatReceiveMessagesIncludeLastKnown$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<ChatReceiveMessagesIncludeLastKnown> get values => _$chatReceiveMessagesIncludeLastKnownValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static ChatReceiveMessagesIncludeLastKnown valueOf(String name) => _$valueOfChatReceiveMessagesIncludeLastKnown(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for ChatReceiveMessagesIncludeLastKnown.
  @BuiltValueSerializer(custom: true)
  static Serializer<ChatReceiveMessagesIncludeLastKnown> get serializer =>
      const _$ChatReceiveMessagesIncludeLastKnownSerializer();
}

class _$ChatReceiveMessagesIncludeLastKnownSerializer
    implements PrimitiveSerializer<ChatReceiveMessagesIncludeLastKnown> {
  const _$ChatReceiveMessagesIncludeLastKnownSerializer();

  static const Map<ChatReceiveMessagesIncludeLastKnown, Object> _toWire = <ChatReceiveMessagesIncludeLastKnown, Object>{
    ChatReceiveMessagesIncludeLastKnown.$0: 0,
    ChatReceiveMessagesIncludeLastKnown.$1: 1,
  };

  static const Map<Object, ChatReceiveMessagesIncludeLastKnown> _fromWire =
      <Object, ChatReceiveMessagesIncludeLastKnown>{
    0: ChatReceiveMessagesIncludeLastKnown.$0,
    1: ChatReceiveMessagesIncludeLastKnown.$1,
  };

  @override
  Iterable<Type> get types => const [ChatReceiveMessagesIncludeLastKnown];

  @override
  String get wireName => 'ChatReceiveMessagesIncludeLastKnown';

  @override
  Object serialize(
    Serializers serializers,
    ChatReceiveMessagesIncludeLastKnown object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatReceiveMessagesIncludeLastKnown deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class ChatReceiveMessagesNoStatusUpdate extends EnumClass {
  const ChatReceiveMessagesNoStatusUpdate._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const ChatReceiveMessagesNoStatusUpdate $0 = _$chatReceiveMessagesNoStatusUpdate$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const ChatReceiveMessagesNoStatusUpdate $1 = _$chatReceiveMessagesNoStatusUpdate$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<ChatReceiveMessagesNoStatusUpdate> get values => _$chatReceiveMessagesNoStatusUpdateValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static ChatReceiveMessagesNoStatusUpdate valueOf(String name) => _$valueOfChatReceiveMessagesNoStatusUpdate(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for ChatReceiveMessagesNoStatusUpdate.
  @BuiltValueSerializer(custom: true)
  static Serializer<ChatReceiveMessagesNoStatusUpdate> get serializer =>
      const _$ChatReceiveMessagesNoStatusUpdateSerializer();
}

class _$ChatReceiveMessagesNoStatusUpdateSerializer implements PrimitiveSerializer<ChatReceiveMessagesNoStatusUpdate> {
  const _$ChatReceiveMessagesNoStatusUpdateSerializer();

  static const Map<ChatReceiveMessagesNoStatusUpdate, Object> _toWire = <ChatReceiveMessagesNoStatusUpdate, Object>{
    ChatReceiveMessagesNoStatusUpdate.$0: 0,
    ChatReceiveMessagesNoStatusUpdate.$1: 1,
  };

  static const Map<Object, ChatReceiveMessagesNoStatusUpdate> _fromWire = <Object, ChatReceiveMessagesNoStatusUpdate>{
    0: ChatReceiveMessagesNoStatusUpdate.$0,
    1: ChatReceiveMessagesNoStatusUpdate.$1,
  };

  @override
  Iterable<Type> get types => const [ChatReceiveMessagesNoStatusUpdate];

  @override
  String get wireName => 'ChatReceiveMessagesNoStatusUpdate';

  @override
  Object serialize(
    Serializers serializers,
    ChatReceiveMessagesNoStatusUpdate object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatReceiveMessagesNoStatusUpdate deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class ChatReceiveMessagesMarkNotificationsAsRead extends EnumClass {
  const ChatReceiveMessagesMarkNotificationsAsRead._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const ChatReceiveMessagesMarkNotificationsAsRead $0 = _$chatReceiveMessagesMarkNotificationsAsRead$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const ChatReceiveMessagesMarkNotificationsAsRead $1 = _$chatReceiveMessagesMarkNotificationsAsRead$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<ChatReceiveMessagesMarkNotificationsAsRead> get values =>
      _$chatReceiveMessagesMarkNotificationsAsReadValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static ChatReceiveMessagesMarkNotificationsAsRead valueOf(String name) =>
      _$valueOfChatReceiveMessagesMarkNotificationsAsRead(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for ChatReceiveMessagesMarkNotificationsAsRead.
  @BuiltValueSerializer(custom: true)
  static Serializer<ChatReceiveMessagesMarkNotificationsAsRead> get serializer =>
      const _$ChatReceiveMessagesMarkNotificationsAsReadSerializer();
}

class _$ChatReceiveMessagesMarkNotificationsAsReadSerializer
    implements PrimitiveSerializer<ChatReceiveMessagesMarkNotificationsAsRead> {
  const _$ChatReceiveMessagesMarkNotificationsAsReadSerializer();

  static const Map<ChatReceiveMessagesMarkNotificationsAsRead, Object> _toWire =
      <ChatReceiveMessagesMarkNotificationsAsRead, Object>{
    ChatReceiveMessagesMarkNotificationsAsRead.$0: 0,
    ChatReceiveMessagesMarkNotificationsAsRead.$1: 1,
  };

  static const Map<Object, ChatReceiveMessagesMarkNotificationsAsRead> _fromWire =
      <Object, ChatReceiveMessagesMarkNotificationsAsRead>{
    0: ChatReceiveMessagesMarkNotificationsAsRead.$0,
    1: ChatReceiveMessagesMarkNotificationsAsRead.$1,
  };

  @override
  Iterable<Type> get types => const [ChatReceiveMessagesMarkNotificationsAsRead];

  @override
  String get wireName => 'ChatReceiveMessagesMarkNotificationsAsRead';

  @override
  Object serialize(
    Serializers serializers,
    ChatReceiveMessagesMarkNotificationsAsRead object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatReceiveMessagesMarkNotificationsAsRead deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class ChatReceiveMessagesApiVersion extends EnumClass {
  const ChatReceiveMessagesApiVersion._(super.name);

  /// `v1`
  static const ChatReceiveMessagesApiVersion v1 = _$chatReceiveMessagesApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<ChatReceiveMessagesApiVersion> get values => _$chatReceiveMessagesApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static ChatReceiveMessagesApiVersion valueOf(String name) => _$valueOfChatReceiveMessagesApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for ChatReceiveMessagesApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<ChatReceiveMessagesApiVersion> get serializer => const _$ChatReceiveMessagesApiVersionSerializer();
}

class _$ChatReceiveMessagesApiVersionSerializer implements PrimitiveSerializer<ChatReceiveMessagesApiVersion> {
  const _$ChatReceiveMessagesApiVersionSerializer();

  static const Map<ChatReceiveMessagesApiVersion, Object> _toWire = <ChatReceiveMessagesApiVersion, Object>{
    ChatReceiveMessagesApiVersion.v1: 'v1',
  };

  static const Map<Object, ChatReceiveMessagesApiVersion> _fromWire = <Object, ChatReceiveMessagesApiVersion>{
    'v1': ChatReceiveMessagesApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ChatReceiveMessagesApiVersion];

  @override
  String get wireName => 'ChatReceiveMessagesApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ChatReceiveMessagesApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatReceiveMessagesApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatMessageWithParentInterface implements $ChatMessageInterface {
  ChatMessage? get parent;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatMessageWithParentInterfaceBuilder b) {
    $ChatMessageInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatMessageWithParentInterfaceBuilder b) {
    $ChatMessageInterface._validate(b);
  }
}

abstract class ChatMessageWithParent
    implements $ChatMessageWithParentInterface, Built<ChatMessageWithParent, ChatMessageWithParentBuilder> {
  /// Creates a new ChatMessageWithParent object using the builder pattern.
  factory ChatMessageWithParent([void Function(ChatMessageWithParentBuilder)? b]) = _$ChatMessageWithParent;

  // coverage:ignore-start
  const ChatMessageWithParent._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatMessageWithParent.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatMessageWithParent.
  static Serializer<ChatMessageWithParent> get serializer => _$chatMessageWithParentSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatMessageWithParentBuilder b) {
    $ChatMessageWithParentInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatMessageWithParentBuilder b) {
    $ChatMessageWithParentInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ChatReceiveMessagesResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<ChatMessageWithParent> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatReceiveMessagesResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatReceiveMessagesResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class ChatReceiveMessagesResponseApplicationJson_Ocs
    implements
        $ChatReceiveMessagesResponseApplicationJson_OcsInterface,
        Built<ChatReceiveMessagesResponseApplicationJson_Ocs, ChatReceiveMessagesResponseApplicationJson_OcsBuilder> {
  /// Creates a new ChatReceiveMessagesResponseApplicationJson_Ocs object using the builder pattern.
  factory ChatReceiveMessagesResponseApplicationJson_Ocs([
    void Function(ChatReceiveMessagesResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ChatReceiveMessagesResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ChatReceiveMessagesResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatReceiveMessagesResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatReceiveMessagesResponseApplicationJson_Ocs.
  static Serializer<ChatReceiveMessagesResponseApplicationJson_Ocs> get serializer =>
      _$chatReceiveMessagesResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatReceiveMessagesResponseApplicationJson_OcsBuilder b) {
    $ChatReceiveMessagesResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatReceiveMessagesResponseApplicationJson_OcsBuilder b) {
    $ChatReceiveMessagesResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ChatReceiveMessagesResponseApplicationJsonInterface {
  ChatReceiveMessagesResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatReceiveMessagesResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatReceiveMessagesResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class ChatReceiveMessagesResponseApplicationJson
    implements
        $ChatReceiveMessagesResponseApplicationJsonInterface,
        Built<ChatReceiveMessagesResponseApplicationJson, ChatReceiveMessagesResponseApplicationJsonBuilder> {
  /// Creates a new ChatReceiveMessagesResponseApplicationJson object using the builder pattern.
  factory ChatReceiveMessagesResponseApplicationJson([
    void Function(ChatReceiveMessagesResponseApplicationJsonBuilder)? b,
  ]) = _$ChatReceiveMessagesResponseApplicationJson;

  // coverage:ignore-start
  const ChatReceiveMessagesResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatReceiveMessagesResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatReceiveMessagesResponseApplicationJson.
  static Serializer<ChatReceiveMessagesResponseApplicationJson> get serializer =>
      _$chatReceiveMessagesResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatReceiveMessagesResponseApplicationJsonBuilder b) {
    $ChatReceiveMessagesResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatReceiveMessagesResponseApplicationJsonBuilder b) {
    $ChatReceiveMessagesResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ChatChatReceiveMessagesHeadersInterface {
  @BuiltValueField(wireName: 'x-chat-last-common-read')
  String? get xChatLastCommonRead;
  @BuiltValueField(wireName: 'x-chat-last-given')
  String? get xChatLastGiven;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatChatReceiveMessagesHeadersInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatChatReceiveMessagesHeadersInterfaceBuilder b) {}
}

abstract class ChatChatReceiveMessagesHeaders
    implements
        $ChatChatReceiveMessagesHeadersInterface,
        Built<ChatChatReceiveMessagesHeaders, ChatChatReceiveMessagesHeadersBuilder> {
  /// Creates a new ChatChatReceiveMessagesHeaders object using the builder pattern.
  factory ChatChatReceiveMessagesHeaders([void Function(ChatChatReceiveMessagesHeadersBuilder)? b]) =
      _$ChatChatReceiveMessagesHeaders;

  // coverage:ignore-start
  const ChatChatReceiveMessagesHeaders._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatChatReceiveMessagesHeaders.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatChatReceiveMessagesHeaders.
  static Serializer<ChatChatReceiveMessagesHeaders> get serializer => _$chatChatReceiveMessagesHeadersSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatChatReceiveMessagesHeadersBuilder b) {
    $ChatChatReceiveMessagesHeadersInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatChatReceiveMessagesHeadersBuilder b) {
    $ChatChatReceiveMessagesHeadersInterface._validate(b);
  }
}

class ChatSendMessageSilent extends EnumClass {
  const ChatSendMessageSilent._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const ChatSendMessageSilent $0 = _$chatSendMessageSilent$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const ChatSendMessageSilent $1 = _$chatSendMessageSilent$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<ChatSendMessageSilent> get values => _$chatSendMessageSilentValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static ChatSendMessageSilent valueOf(String name) => _$valueOfChatSendMessageSilent(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for ChatSendMessageSilent.
  @BuiltValueSerializer(custom: true)
  static Serializer<ChatSendMessageSilent> get serializer => const _$ChatSendMessageSilentSerializer();
}

class _$ChatSendMessageSilentSerializer implements PrimitiveSerializer<ChatSendMessageSilent> {
  const _$ChatSendMessageSilentSerializer();

  static const Map<ChatSendMessageSilent, Object> _toWire = <ChatSendMessageSilent, Object>{
    ChatSendMessageSilent.$0: 0,
    ChatSendMessageSilent.$1: 1,
  };

  static const Map<Object, ChatSendMessageSilent> _fromWire = <Object, ChatSendMessageSilent>{
    0: ChatSendMessageSilent.$0,
    1: ChatSendMessageSilent.$1,
  };

  @override
  Iterable<Type> get types => const [ChatSendMessageSilent];

  @override
  String get wireName => 'ChatSendMessageSilent';

  @override
  Object serialize(
    Serializers serializers,
    ChatSendMessageSilent object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatSendMessageSilent deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class ChatSendMessageApiVersion extends EnumClass {
  const ChatSendMessageApiVersion._(super.name);

  /// `v1`
  static const ChatSendMessageApiVersion v1 = _$chatSendMessageApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<ChatSendMessageApiVersion> get values => _$chatSendMessageApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static ChatSendMessageApiVersion valueOf(String name) => _$valueOfChatSendMessageApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for ChatSendMessageApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<ChatSendMessageApiVersion> get serializer => const _$ChatSendMessageApiVersionSerializer();
}

class _$ChatSendMessageApiVersionSerializer implements PrimitiveSerializer<ChatSendMessageApiVersion> {
  const _$ChatSendMessageApiVersionSerializer();

  static const Map<ChatSendMessageApiVersion, Object> _toWire = <ChatSendMessageApiVersion, Object>{
    ChatSendMessageApiVersion.v1: 'v1',
  };

  static const Map<Object, ChatSendMessageApiVersion> _fromWire = <Object, ChatSendMessageApiVersion>{
    'v1': ChatSendMessageApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ChatSendMessageApiVersion];

  @override
  String get wireName => 'ChatSendMessageApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ChatSendMessageApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatSendMessageApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatSendMessageResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  ChatMessageWithParent? get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatSendMessageResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatSendMessageResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class ChatSendMessageResponseApplicationJson_Ocs
    implements
        $ChatSendMessageResponseApplicationJson_OcsInterface,
        Built<ChatSendMessageResponseApplicationJson_Ocs, ChatSendMessageResponseApplicationJson_OcsBuilder> {
  /// Creates a new ChatSendMessageResponseApplicationJson_Ocs object using the builder pattern.
  factory ChatSendMessageResponseApplicationJson_Ocs([
    void Function(ChatSendMessageResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ChatSendMessageResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ChatSendMessageResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatSendMessageResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatSendMessageResponseApplicationJson_Ocs.
  static Serializer<ChatSendMessageResponseApplicationJson_Ocs> get serializer =>
      _$chatSendMessageResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatSendMessageResponseApplicationJson_OcsBuilder b) {
    $ChatSendMessageResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatSendMessageResponseApplicationJson_OcsBuilder b) {
    $ChatSendMessageResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ChatSendMessageResponseApplicationJsonInterface {
  ChatSendMessageResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatSendMessageResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatSendMessageResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class ChatSendMessageResponseApplicationJson
    implements
        $ChatSendMessageResponseApplicationJsonInterface,
        Built<ChatSendMessageResponseApplicationJson, ChatSendMessageResponseApplicationJsonBuilder> {
  /// Creates a new ChatSendMessageResponseApplicationJson object using the builder pattern.
  factory ChatSendMessageResponseApplicationJson([void Function(ChatSendMessageResponseApplicationJsonBuilder)? b]) =
      _$ChatSendMessageResponseApplicationJson;

  // coverage:ignore-start
  const ChatSendMessageResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatSendMessageResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatSendMessageResponseApplicationJson.
  static Serializer<ChatSendMessageResponseApplicationJson> get serializer =>
      _$chatSendMessageResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatSendMessageResponseApplicationJsonBuilder b) {
    $ChatSendMessageResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatSendMessageResponseApplicationJsonBuilder b) {
    $ChatSendMessageResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ChatChatSendMessageHeadersInterface {
  @BuiltValueField(wireName: 'x-chat-last-common-read')
  String? get xChatLastCommonRead;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatChatSendMessageHeadersInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatChatSendMessageHeadersInterfaceBuilder b) {}
}

abstract class ChatChatSendMessageHeaders
    implements
        $ChatChatSendMessageHeadersInterface,
        Built<ChatChatSendMessageHeaders, ChatChatSendMessageHeadersBuilder> {
  /// Creates a new ChatChatSendMessageHeaders object using the builder pattern.
  factory ChatChatSendMessageHeaders([void Function(ChatChatSendMessageHeadersBuilder)? b]) =
      _$ChatChatSendMessageHeaders;

  // coverage:ignore-start
  const ChatChatSendMessageHeaders._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatChatSendMessageHeaders.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatChatSendMessageHeaders.
  static Serializer<ChatChatSendMessageHeaders> get serializer => _$chatChatSendMessageHeadersSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatChatSendMessageHeadersBuilder b) {
    $ChatChatSendMessageHeadersInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatChatSendMessageHeadersBuilder b) {
    $ChatChatSendMessageHeadersInterface._validate(b);
  }
}

class ChatClearHistoryApiVersion extends EnumClass {
  const ChatClearHistoryApiVersion._(super.name);

  /// `v1`
  static const ChatClearHistoryApiVersion v1 = _$chatClearHistoryApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<ChatClearHistoryApiVersion> get values => _$chatClearHistoryApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static ChatClearHistoryApiVersion valueOf(String name) => _$valueOfChatClearHistoryApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for ChatClearHistoryApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<ChatClearHistoryApiVersion> get serializer => const _$ChatClearHistoryApiVersionSerializer();
}

class _$ChatClearHistoryApiVersionSerializer implements PrimitiveSerializer<ChatClearHistoryApiVersion> {
  const _$ChatClearHistoryApiVersionSerializer();

  static const Map<ChatClearHistoryApiVersion, Object> _toWire = <ChatClearHistoryApiVersion, Object>{
    ChatClearHistoryApiVersion.v1: 'v1',
  };

  static const Map<Object, ChatClearHistoryApiVersion> _fromWire = <Object, ChatClearHistoryApiVersion>{
    'v1': ChatClearHistoryApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ChatClearHistoryApiVersion];

  @override
  String get wireName => 'ChatClearHistoryApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ChatClearHistoryApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatClearHistoryApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatClearHistoryResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  ChatMessage get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatClearHistoryResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatClearHistoryResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class ChatClearHistoryResponseApplicationJson_Ocs
    implements
        $ChatClearHistoryResponseApplicationJson_OcsInterface,
        Built<ChatClearHistoryResponseApplicationJson_Ocs, ChatClearHistoryResponseApplicationJson_OcsBuilder> {
  /// Creates a new ChatClearHistoryResponseApplicationJson_Ocs object using the builder pattern.
  factory ChatClearHistoryResponseApplicationJson_Ocs([
    void Function(ChatClearHistoryResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ChatClearHistoryResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ChatClearHistoryResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatClearHistoryResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatClearHistoryResponseApplicationJson_Ocs.
  static Serializer<ChatClearHistoryResponseApplicationJson_Ocs> get serializer =>
      _$chatClearHistoryResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatClearHistoryResponseApplicationJson_OcsBuilder b) {
    $ChatClearHistoryResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatClearHistoryResponseApplicationJson_OcsBuilder b) {
    $ChatClearHistoryResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ChatClearHistoryResponseApplicationJsonInterface {
  ChatClearHistoryResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatClearHistoryResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatClearHistoryResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class ChatClearHistoryResponseApplicationJson
    implements
        $ChatClearHistoryResponseApplicationJsonInterface,
        Built<ChatClearHistoryResponseApplicationJson, ChatClearHistoryResponseApplicationJsonBuilder> {
  /// Creates a new ChatClearHistoryResponseApplicationJson object using the builder pattern.
  factory ChatClearHistoryResponseApplicationJson([void Function(ChatClearHistoryResponseApplicationJsonBuilder)? b]) =
      _$ChatClearHistoryResponseApplicationJson;

  // coverage:ignore-start
  const ChatClearHistoryResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatClearHistoryResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatClearHistoryResponseApplicationJson.
  static Serializer<ChatClearHistoryResponseApplicationJson> get serializer =>
      _$chatClearHistoryResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatClearHistoryResponseApplicationJsonBuilder b) {
    $ChatClearHistoryResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatClearHistoryResponseApplicationJsonBuilder b) {
    $ChatClearHistoryResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ChatChatClearHistoryHeadersInterface {
  @BuiltValueField(wireName: 'x-chat-last-common-read')
  String? get xChatLastCommonRead;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatChatClearHistoryHeadersInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatChatClearHistoryHeadersInterfaceBuilder b) {}
}

abstract class ChatChatClearHistoryHeaders
    implements
        $ChatChatClearHistoryHeadersInterface,
        Built<ChatChatClearHistoryHeaders, ChatChatClearHistoryHeadersBuilder> {
  /// Creates a new ChatChatClearHistoryHeaders object using the builder pattern.
  factory ChatChatClearHistoryHeaders([void Function(ChatChatClearHistoryHeadersBuilder)? b]) =
      _$ChatChatClearHistoryHeaders;

  // coverage:ignore-start
  const ChatChatClearHistoryHeaders._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatChatClearHistoryHeaders.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatChatClearHistoryHeaders.
  static Serializer<ChatChatClearHistoryHeaders> get serializer => _$chatChatClearHistoryHeadersSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatChatClearHistoryHeadersBuilder b) {
    $ChatChatClearHistoryHeadersInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatChatClearHistoryHeadersBuilder b) {
    $ChatChatClearHistoryHeadersInterface._validate(b);
  }
}

class ChatEditMessageApiVersion extends EnumClass {
  const ChatEditMessageApiVersion._(super.name);

  /// `v1`
  static const ChatEditMessageApiVersion v1 = _$chatEditMessageApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<ChatEditMessageApiVersion> get values => _$chatEditMessageApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static ChatEditMessageApiVersion valueOf(String name) => _$valueOfChatEditMessageApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for ChatEditMessageApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<ChatEditMessageApiVersion> get serializer => const _$ChatEditMessageApiVersionSerializer();
}

class _$ChatEditMessageApiVersionSerializer implements PrimitiveSerializer<ChatEditMessageApiVersion> {
  const _$ChatEditMessageApiVersionSerializer();

  static const Map<ChatEditMessageApiVersion, Object> _toWire = <ChatEditMessageApiVersion, Object>{
    ChatEditMessageApiVersion.v1: 'v1',
  };

  static const Map<Object, ChatEditMessageApiVersion> _fromWire = <Object, ChatEditMessageApiVersion>{
    'v1': ChatEditMessageApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ChatEditMessageApiVersion];

  @override
  String get wireName => 'ChatEditMessageApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ChatEditMessageApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatEditMessageApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatEditMessageResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  ChatMessageWithParent get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatEditMessageResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatEditMessageResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class ChatEditMessageResponseApplicationJson_Ocs
    implements
        $ChatEditMessageResponseApplicationJson_OcsInterface,
        Built<ChatEditMessageResponseApplicationJson_Ocs, ChatEditMessageResponseApplicationJson_OcsBuilder> {
  /// Creates a new ChatEditMessageResponseApplicationJson_Ocs object using the builder pattern.
  factory ChatEditMessageResponseApplicationJson_Ocs([
    void Function(ChatEditMessageResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ChatEditMessageResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ChatEditMessageResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatEditMessageResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatEditMessageResponseApplicationJson_Ocs.
  static Serializer<ChatEditMessageResponseApplicationJson_Ocs> get serializer =>
      _$chatEditMessageResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatEditMessageResponseApplicationJson_OcsBuilder b) {
    $ChatEditMessageResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatEditMessageResponseApplicationJson_OcsBuilder b) {
    $ChatEditMessageResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ChatEditMessageResponseApplicationJsonInterface {
  ChatEditMessageResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatEditMessageResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatEditMessageResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class ChatEditMessageResponseApplicationJson
    implements
        $ChatEditMessageResponseApplicationJsonInterface,
        Built<ChatEditMessageResponseApplicationJson, ChatEditMessageResponseApplicationJsonBuilder> {
  /// Creates a new ChatEditMessageResponseApplicationJson object using the builder pattern.
  factory ChatEditMessageResponseApplicationJson([void Function(ChatEditMessageResponseApplicationJsonBuilder)? b]) =
      _$ChatEditMessageResponseApplicationJson;

  // coverage:ignore-start
  const ChatEditMessageResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatEditMessageResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatEditMessageResponseApplicationJson.
  static Serializer<ChatEditMessageResponseApplicationJson> get serializer =>
      _$chatEditMessageResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatEditMessageResponseApplicationJsonBuilder b) {
    $ChatEditMessageResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatEditMessageResponseApplicationJsonBuilder b) {
    $ChatEditMessageResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ChatChatEditMessageHeadersInterface {
  @BuiltValueField(wireName: 'x-chat-last-common-read')
  String? get xChatLastCommonRead;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatChatEditMessageHeadersInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatChatEditMessageHeadersInterfaceBuilder b) {}
}

abstract class ChatChatEditMessageHeaders
    implements
        $ChatChatEditMessageHeadersInterface,
        Built<ChatChatEditMessageHeaders, ChatChatEditMessageHeadersBuilder> {
  /// Creates a new ChatChatEditMessageHeaders object using the builder pattern.
  factory ChatChatEditMessageHeaders([void Function(ChatChatEditMessageHeadersBuilder)? b]) =
      _$ChatChatEditMessageHeaders;

  // coverage:ignore-start
  const ChatChatEditMessageHeaders._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatChatEditMessageHeaders.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatChatEditMessageHeaders.
  static Serializer<ChatChatEditMessageHeaders> get serializer => _$chatChatEditMessageHeadersSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatChatEditMessageHeadersBuilder b) {
    $ChatChatEditMessageHeadersInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatChatEditMessageHeadersBuilder b) {
    $ChatChatEditMessageHeadersInterface._validate(b);
  }
}

class ChatDeleteMessageApiVersion extends EnumClass {
  const ChatDeleteMessageApiVersion._(super.name);

  /// `v1`
  static const ChatDeleteMessageApiVersion v1 = _$chatDeleteMessageApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<ChatDeleteMessageApiVersion> get values => _$chatDeleteMessageApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static ChatDeleteMessageApiVersion valueOf(String name) => _$valueOfChatDeleteMessageApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for ChatDeleteMessageApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<ChatDeleteMessageApiVersion> get serializer => const _$ChatDeleteMessageApiVersionSerializer();
}

class _$ChatDeleteMessageApiVersionSerializer implements PrimitiveSerializer<ChatDeleteMessageApiVersion> {
  const _$ChatDeleteMessageApiVersionSerializer();

  static const Map<ChatDeleteMessageApiVersion, Object> _toWire = <ChatDeleteMessageApiVersion, Object>{
    ChatDeleteMessageApiVersion.v1: 'v1',
  };

  static const Map<Object, ChatDeleteMessageApiVersion> _fromWire = <Object, ChatDeleteMessageApiVersion>{
    'v1': ChatDeleteMessageApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ChatDeleteMessageApiVersion];

  @override
  String get wireName => 'ChatDeleteMessageApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ChatDeleteMessageApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatDeleteMessageApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatDeleteMessageResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  ChatMessageWithParent get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatDeleteMessageResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatDeleteMessageResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class ChatDeleteMessageResponseApplicationJson_Ocs
    implements
        $ChatDeleteMessageResponseApplicationJson_OcsInterface,
        Built<ChatDeleteMessageResponseApplicationJson_Ocs, ChatDeleteMessageResponseApplicationJson_OcsBuilder> {
  /// Creates a new ChatDeleteMessageResponseApplicationJson_Ocs object using the builder pattern.
  factory ChatDeleteMessageResponseApplicationJson_Ocs([
    void Function(ChatDeleteMessageResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ChatDeleteMessageResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ChatDeleteMessageResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatDeleteMessageResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatDeleteMessageResponseApplicationJson_Ocs.
  static Serializer<ChatDeleteMessageResponseApplicationJson_Ocs> get serializer =>
      _$chatDeleteMessageResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatDeleteMessageResponseApplicationJson_OcsBuilder b) {
    $ChatDeleteMessageResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatDeleteMessageResponseApplicationJson_OcsBuilder b) {
    $ChatDeleteMessageResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ChatDeleteMessageResponseApplicationJsonInterface {
  ChatDeleteMessageResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatDeleteMessageResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatDeleteMessageResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class ChatDeleteMessageResponseApplicationJson
    implements
        $ChatDeleteMessageResponseApplicationJsonInterface,
        Built<ChatDeleteMessageResponseApplicationJson, ChatDeleteMessageResponseApplicationJsonBuilder> {
  /// Creates a new ChatDeleteMessageResponseApplicationJson object using the builder pattern.
  factory ChatDeleteMessageResponseApplicationJson([
    void Function(ChatDeleteMessageResponseApplicationJsonBuilder)? b,
  ]) = _$ChatDeleteMessageResponseApplicationJson;

  // coverage:ignore-start
  const ChatDeleteMessageResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatDeleteMessageResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatDeleteMessageResponseApplicationJson.
  static Serializer<ChatDeleteMessageResponseApplicationJson> get serializer =>
      _$chatDeleteMessageResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatDeleteMessageResponseApplicationJsonBuilder b) {
    $ChatDeleteMessageResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatDeleteMessageResponseApplicationJsonBuilder b) {
    $ChatDeleteMessageResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ChatChatDeleteMessageHeadersInterface {
  @BuiltValueField(wireName: 'x-chat-last-common-read')
  String? get xChatLastCommonRead;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatChatDeleteMessageHeadersInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatChatDeleteMessageHeadersInterfaceBuilder b) {}
}

abstract class ChatChatDeleteMessageHeaders
    implements
        $ChatChatDeleteMessageHeadersInterface,
        Built<ChatChatDeleteMessageHeaders, ChatChatDeleteMessageHeadersBuilder> {
  /// Creates a new ChatChatDeleteMessageHeaders object using the builder pattern.
  factory ChatChatDeleteMessageHeaders([void Function(ChatChatDeleteMessageHeadersBuilder)? b]) =
      _$ChatChatDeleteMessageHeaders;

  // coverage:ignore-start
  const ChatChatDeleteMessageHeaders._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatChatDeleteMessageHeaders.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatChatDeleteMessageHeaders.
  static Serializer<ChatChatDeleteMessageHeaders> get serializer => _$chatChatDeleteMessageHeadersSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatChatDeleteMessageHeadersBuilder b) {
    $ChatChatDeleteMessageHeadersInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatChatDeleteMessageHeadersBuilder b) {
    $ChatChatDeleteMessageHeadersInterface._validate(b);
  }
}

class ChatGetMessageContextApiVersion extends EnumClass {
  const ChatGetMessageContextApiVersion._(super.name);

  /// `v1`
  static const ChatGetMessageContextApiVersion v1 = _$chatGetMessageContextApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<ChatGetMessageContextApiVersion> get values => _$chatGetMessageContextApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static ChatGetMessageContextApiVersion valueOf(String name) => _$valueOfChatGetMessageContextApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for ChatGetMessageContextApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<ChatGetMessageContextApiVersion> get serializer =>
      const _$ChatGetMessageContextApiVersionSerializer();
}

class _$ChatGetMessageContextApiVersionSerializer implements PrimitiveSerializer<ChatGetMessageContextApiVersion> {
  const _$ChatGetMessageContextApiVersionSerializer();

  static const Map<ChatGetMessageContextApiVersion, Object> _toWire = <ChatGetMessageContextApiVersion, Object>{
    ChatGetMessageContextApiVersion.v1: 'v1',
  };

  static const Map<Object, ChatGetMessageContextApiVersion> _fromWire = <Object, ChatGetMessageContextApiVersion>{
    'v1': ChatGetMessageContextApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ChatGetMessageContextApiVersion];

  @override
  String get wireName => 'ChatGetMessageContextApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ChatGetMessageContextApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatGetMessageContextApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatGetMessageContextResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<ChatMessageWithParent> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatGetMessageContextResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatGetMessageContextResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class ChatGetMessageContextResponseApplicationJson_Ocs
    implements
        $ChatGetMessageContextResponseApplicationJson_OcsInterface,
        Built<ChatGetMessageContextResponseApplicationJson_Ocs,
            ChatGetMessageContextResponseApplicationJson_OcsBuilder> {
  /// Creates a new ChatGetMessageContextResponseApplicationJson_Ocs object using the builder pattern.
  factory ChatGetMessageContextResponseApplicationJson_Ocs([
    void Function(ChatGetMessageContextResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ChatGetMessageContextResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ChatGetMessageContextResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatGetMessageContextResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatGetMessageContextResponseApplicationJson_Ocs.
  static Serializer<ChatGetMessageContextResponseApplicationJson_Ocs> get serializer =>
      _$chatGetMessageContextResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatGetMessageContextResponseApplicationJson_OcsBuilder b) {
    $ChatGetMessageContextResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatGetMessageContextResponseApplicationJson_OcsBuilder b) {
    $ChatGetMessageContextResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ChatGetMessageContextResponseApplicationJsonInterface {
  ChatGetMessageContextResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatGetMessageContextResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatGetMessageContextResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class ChatGetMessageContextResponseApplicationJson
    implements
        $ChatGetMessageContextResponseApplicationJsonInterface,
        Built<ChatGetMessageContextResponseApplicationJson, ChatGetMessageContextResponseApplicationJsonBuilder> {
  /// Creates a new ChatGetMessageContextResponseApplicationJson object using the builder pattern.
  factory ChatGetMessageContextResponseApplicationJson([
    void Function(ChatGetMessageContextResponseApplicationJsonBuilder)? b,
  ]) = _$ChatGetMessageContextResponseApplicationJson;

  // coverage:ignore-start
  const ChatGetMessageContextResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatGetMessageContextResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatGetMessageContextResponseApplicationJson.
  static Serializer<ChatGetMessageContextResponseApplicationJson> get serializer =>
      _$chatGetMessageContextResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatGetMessageContextResponseApplicationJsonBuilder b) {
    $ChatGetMessageContextResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatGetMessageContextResponseApplicationJsonBuilder b) {
    $ChatGetMessageContextResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ChatChatGetMessageContextHeadersInterface {
  @BuiltValueField(wireName: 'x-chat-last-common-read')
  String? get xChatLastCommonRead;
  @BuiltValueField(wireName: 'x-chat-last-given')
  String? get xChatLastGiven;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatChatGetMessageContextHeadersInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatChatGetMessageContextHeadersInterfaceBuilder b) {}
}

abstract class ChatChatGetMessageContextHeaders
    implements
        $ChatChatGetMessageContextHeadersInterface,
        Built<ChatChatGetMessageContextHeaders, ChatChatGetMessageContextHeadersBuilder> {
  /// Creates a new ChatChatGetMessageContextHeaders object using the builder pattern.
  factory ChatChatGetMessageContextHeaders([void Function(ChatChatGetMessageContextHeadersBuilder)? b]) =
      _$ChatChatGetMessageContextHeaders;

  // coverage:ignore-start
  const ChatChatGetMessageContextHeaders._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatChatGetMessageContextHeaders.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatChatGetMessageContextHeaders.
  static Serializer<ChatChatGetMessageContextHeaders> get serializer => _$chatChatGetMessageContextHeadersSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatChatGetMessageContextHeadersBuilder b) {
    $ChatChatGetMessageContextHeadersInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatChatGetMessageContextHeadersBuilder b) {
    $ChatChatGetMessageContextHeadersInterface._validate(b);
  }
}

class ChatGetReminderApiVersion extends EnumClass {
  const ChatGetReminderApiVersion._(super.name);

  /// `v1`
  static const ChatGetReminderApiVersion v1 = _$chatGetReminderApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<ChatGetReminderApiVersion> get values => _$chatGetReminderApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static ChatGetReminderApiVersion valueOf(String name) => _$valueOfChatGetReminderApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for ChatGetReminderApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<ChatGetReminderApiVersion> get serializer => const _$ChatGetReminderApiVersionSerializer();
}

class _$ChatGetReminderApiVersionSerializer implements PrimitiveSerializer<ChatGetReminderApiVersion> {
  const _$ChatGetReminderApiVersionSerializer();

  static const Map<ChatGetReminderApiVersion, Object> _toWire = <ChatGetReminderApiVersion, Object>{
    ChatGetReminderApiVersion.v1: 'v1',
  };

  static const Map<Object, ChatGetReminderApiVersion> _fromWire = <Object, ChatGetReminderApiVersion>{
    'v1': ChatGetReminderApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ChatGetReminderApiVersion];

  @override
  String get wireName => 'ChatGetReminderApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ChatGetReminderApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatGetReminderApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatReminderInterface {
  int get messageId;
  int get timestamp;
  String get token;
  String get userId;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatReminderInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatReminderInterfaceBuilder b) {}
}

abstract class ChatReminder implements $ChatReminderInterface, Built<ChatReminder, ChatReminderBuilder> {
  /// Creates a new ChatReminder object using the builder pattern.
  factory ChatReminder([void Function(ChatReminderBuilder)? b]) = _$ChatReminder;

  // coverage:ignore-start
  const ChatReminder._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatReminder.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatReminder.
  static Serializer<ChatReminder> get serializer => _$chatReminderSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatReminderBuilder b) {
    $ChatReminderInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatReminderBuilder b) {
    $ChatReminderInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ChatGetReminderResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  ChatReminder get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatGetReminderResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatGetReminderResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class ChatGetReminderResponseApplicationJson_Ocs
    implements
        $ChatGetReminderResponseApplicationJson_OcsInterface,
        Built<ChatGetReminderResponseApplicationJson_Ocs, ChatGetReminderResponseApplicationJson_OcsBuilder> {
  /// Creates a new ChatGetReminderResponseApplicationJson_Ocs object using the builder pattern.
  factory ChatGetReminderResponseApplicationJson_Ocs([
    void Function(ChatGetReminderResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ChatGetReminderResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ChatGetReminderResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatGetReminderResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatGetReminderResponseApplicationJson_Ocs.
  static Serializer<ChatGetReminderResponseApplicationJson_Ocs> get serializer =>
      _$chatGetReminderResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatGetReminderResponseApplicationJson_OcsBuilder b) {
    $ChatGetReminderResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatGetReminderResponseApplicationJson_OcsBuilder b) {
    $ChatGetReminderResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ChatGetReminderResponseApplicationJsonInterface {
  ChatGetReminderResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatGetReminderResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatGetReminderResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class ChatGetReminderResponseApplicationJson
    implements
        $ChatGetReminderResponseApplicationJsonInterface,
        Built<ChatGetReminderResponseApplicationJson, ChatGetReminderResponseApplicationJsonBuilder> {
  /// Creates a new ChatGetReminderResponseApplicationJson object using the builder pattern.
  factory ChatGetReminderResponseApplicationJson([void Function(ChatGetReminderResponseApplicationJsonBuilder)? b]) =
      _$ChatGetReminderResponseApplicationJson;

  // coverage:ignore-start
  const ChatGetReminderResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatGetReminderResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatGetReminderResponseApplicationJson.
  static Serializer<ChatGetReminderResponseApplicationJson> get serializer =>
      _$chatGetReminderResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatGetReminderResponseApplicationJsonBuilder b) {
    $ChatGetReminderResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatGetReminderResponseApplicationJsonBuilder b) {
    $ChatGetReminderResponseApplicationJsonInterface._validate(b);
  }
}

class ChatSetReminderApiVersion extends EnumClass {
  const ChatSetReminderApiVersion._(super.name);

  /// `v1`
  static const ChatSetReminderApiVersion v1 = _$chatSetReminderApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<ChatSetReminderApiVersion> get values => _$chatSetReminderApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static ChatSetReminderApiVersion valueOf(String name) => _$valueOfChatSetReminderApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for ChatSetReminderApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<ChatSetReminderApiVersion> get serializer => const _$ChatSetReminderApiVersionSerializer();
}

class _$ChatSetReminderApiVersionSerializer implements PrimitiveSerializer<ChatSetReminderApiVersion> {
  const _$ChatSetReminderApiVersionSerializer();

  static const Map<ChatSetReminderApiVersion, Object> _toWire = <ChatSetReminderApiVersion, Object>{
    ChatSetReminderApiVersion.v1: 'v1',
  };

  static const Map<Object, ChatSetReminderApiVersion> _fromWire = <Object, ChatSetReminderApiVersion>{
    'v1': ChatSetReminderApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ChatSetReminderApiVersion];

  @override
  String get wireName => 'ChatSetReminderApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ChatSetReminderApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatSetReminderApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatSetReminderResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  ChatReminder get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatSetReminderResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatSetReminderResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class ChatSetReminderResponseApplicationJson_Ocs
    implements
        $ChatSetReminderResponseApplicationJson_OcsInterface,
        Built<ChatSetReminderResponseApplicationJson_Ocs, ChatSetReminderResponseApplicationJson_OcsBuilder> {
  /// Creates a new ChatSetReminderResponseApplicationJson_Ocs object using the builder pattern.
  factory ChatSetReminderResponseApplicationJson_Ocs([
    void Function(ChatSetReminderResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ChatSetReminderResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ChatSetReminderResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatSetReminderResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatSetReminderResponseApplicationJson_Ocs.
  static Serializer<ChatSetReminderResponseApplicationJson_Ocs> get serializer =>
      _$chatSetReminderResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatSetReminderResponseApplicationJson_OcsBuilder b) {
    $ChatSetReminderResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatSetReminderResponseApplicationJson_OcsBuilder b) {
    $ChatSetReminderResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ChatSetReminderResponseApplicationJsonInterface {
  ChatSetReminderResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatSetReminderResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatSetReminderResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class ChatSetReminderResponseApplicationJson
    implements
        $ChatSetReminderResponseApplicationJsonInterface,
        Built<ChatSetReminderResponseApplicationJson, ChatSetReminderResponseApplicationJsonBuilder> {
  /// Creates a new ChatSetReminderResponseApplicationJson object using the builder pattern.
  factory ChatSetReminderResponseApplicationJson([void Function(ChatSetReminderResponseApplicationJsonBuilder)? b]) =
      _$ChatSetReminderResponseApplicationJson;

  // coverage:ignore-start
  const ChatSetReminderResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatSetReminderResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatSetReminderResponseApplicationJson.
  static Serializer<ChatSetReminderResponseApplicationJson> get serializer =>
      _$chatSetReminderResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatSetReminderResponseApplicationJsonBuilder b) {
    $ChatSetReminderResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatSetReminderResponseApplicationJsonBuilder b) {
    $ChatSetReminderResponseApplicationJsonInterface._validate(b);
  }
}

class ChatDeleteReminderApiVersion extends EnumClass {
  const ChatDeleteReminderApiVersion._(super.name);

  /// `v1`
  static const ChatDeleteReminderApiVersion v1 = _$chatDeleteReminderApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<ChatDeleteReminderApiVersion> get values => _$chatDeleteReminderApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static ChatDeleteReminderApiVersion valueOf(String name) => _$valueOfChatDeleteReminderApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for ChatDeleteReminderApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<ChatDeleteReminderApiVersion> get serializer => const _$ChatDeleteReminderApiVersionSerializer();
}

class _$ChatDeleteReminderApiVersionSerializer implements PrimitiveSerializer<ChatDeleteReminderApiVersion> {
  const _$ChatDeleteReminderApiVersionSerializer();

  static const Map<ChatDeleteReminderApiVersion, Object> _toWire = <ChatDeleteReminderApiVersion, Object>{
    ChatDeleteReminderApiVersion.v1: 'v1',
  };

  static const Map<Object, ChatDeleteReminderApiVersion> _fromWire = <Object, ChatDeleteReminderApiVersion>{
    'v1': ChatDeleteReminderApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ChatDeleteReminderApiVersion];

  @override
  String get wireName => 'ChatDeleteReminderApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ChatDeleteReminderApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatDeleteReminderApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatDeleteReminderResponseApplicationJson_Ocs_DataInterface {
  String? get error;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatDeleteReminderResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatDeleteReminderResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class ChatDeleteReminderResponseApplicationJson_Ocs_Data
    implements
        $ChatDeleteReminderResponseApplicationJson_Ocs_DataInterface,
        Built<ChatDeleteReminderResponseApplicationJson_Ocs_Data,
            ChatDeleteReminderResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new ChatDeleteReminderResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory ChatDeleteReminderResponseApplicationJson_Ocs_Data([
    void Function(ChatDeleteReminderResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$ChatDeleteReminderResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const ChatDeleteReminderResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatDeleteReminderResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatDeleteReminderResponseApplicationJson_Ocs_Data.
  static Serializer<ChatDeleteReminderResponseApplicationJson_Ocs_Data> get serializer =>
      _$chatDeleteReminderResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatDeleteReminderResponseApplicationJson_Ocs_DataBuilder b) {
    $ChatDeleteReminderResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatDeleteReminderResponseApplicationJson_Ocs_DataBuilder b) {
    $ChatDeleteReminderResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ChatDeleteReminderResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  ChatDeleteReminderResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatDeleteReminderResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatDeleteReminderResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class ChatDeleteReminderResponseApplicationJson_Ocs
    implements
        $ChatDeleteReminderResponseApplicationJson_OcsInterface,
        Built<ChatDeleteReminderResponseApplicationJson_Ocs, ChatDeleteReminderResponseApplicationJson_OcsBuilder> {
  /// Creates a new ChatDeleteReminderResponseApplicationJson_Ocs object using the builder pattern.
  factory ChatDeleteReminderResponseApplicationJson_Ocs([
    void Function(ChatDeleteReminderResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ChatDeleteReminderResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ChatDeleteReminderResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatDeleteReminderResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatDeleteReminderResponseApplicationJson_Ocs.
  static Serializer<ChatDeleteReminderResponseApplicationJson_Ocs> get serializer =>
      _$chatDeleteReminderResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatDeleteReminderResponseApplicationJson_OcsBuilder b) {
    $ChatDeleteReminderResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatDeleteReminderResponseApplicationJson_OcsBuilder b) {
    $ChatDeleteReminderResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ChatDeleteReminderResponseApplicationJsonInterface {
  ChatDeleteReminderResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatDeleteReminderResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatDeleteReminderResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class ChatDeleteReminderResponseApplicationJson
    implements
        $ChatDeleteReminderResponseApplicationJsonInterface,
        Built<ChatDeleteReminderResponseApplicationJson, ChatDeleteReminderResponseApplicationJsonBuilder> {
  /// Creates a new ChatDeleteReminderResponseApplicationJson object using the builder pattern.
  factory ChatDeleteReminderResponseApplicationJson([
    void Function(ChatDeleteReminderResponseApplicationJsonBuilder)? b,
  ]) = _$ChatDeleteReminderResponseApplicationJson;

  // coverage:ignore-start
  const ChatDeleteReminderResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatDeleteReminderResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatDeleteReminderResponseApplicationJson.
  static Serializer<ChatDeleteReminderResponseApplicationJson> get serializer =>
      _$chatDeleteReminderResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatDeleteReminderResponseApplicationJsonBuilder b) {
    $ChatDeleteReminderResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatDeleteReminderResponseApplicationJsonBuilder b) {
    $ChatDeleteReminderResponseApplicationJsonInterface._validate(b);
  }
}

class ChatSetReadMarkerApiVersion extends EnumClass {
  const ChatSetReadMarkerApiVersion._(super.name);

  /// `v1`
  static const ChatSetReadMarkerApiVersion v1 = _$chatSetReadMarkerApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<ChatSetReadMarkerApiVersion> get values => _$chatSetReadMarkerApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static ChatSetReadMarkerApiVersion valueOf(String name) => _$valueOfChatSetReadMarkerApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for ChatSetReadMarkerApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<ChatSetReadMarkerApiVersion> get serializer => const _$ChatSetReadMarkerApiVersionSerializer();
}

class _$ChatSetReadMarkerApiVersionSerializer implements PrimitiveSerializer<ChatSetReadMarkerApiVersion> {
  const _$ChatSetReadMarkerApiVersionSerializer();

  static const Map<ChatSetReadMarkerApiVersion, Object> _toWire = <ChatSetReadMarkerApiVersion, Object>{
    ChatSetReadMarkerApiVersion.v1: 'v1',
  };

  static const Map<Object, ChatSetReadMarkerApiVersion> _fromWire = <Object, ChatSetReadMarkerApiVersion>{
    'v1': ChatSetReadMarkerApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ChatSetReadMarkerApiVersion];

  @override
  String get wireName => 'ChatSetReadMarkerApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ChatSetReadMarkerApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatSetReadMarkerApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatSetReadMarkerResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatSetReadMarkerResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatSetReadMarkerResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class ChatSetReadMarkerResponseApplicationJson_Ocs
    implements
        $ChatSetReadMarkerResponseApplicationJson_OcsInterface,
        Built<ChatSetReadMarkerResponseApplicationJson_Ocs, ChatSetReadMarkerResponseApplicationJson_OcsBuilder> {
  /// Creates a new ChatSetReadMarkerResponseApplicationJson_Ocs object using the builder pattern.
  factory ChatSetReadMarkerResponseApplicationJson_Ocs([
    void Function(ChatSetReadMarkerResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ChatSetReadMarkerResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ChatSetReadMarkerResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatSetReadMarkerResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatSetReadMarkerResponseApplicationJson_Ocs.
  static Serializer<ChatSetReadMarkerResponseApplicationJson_Ocs> get serializer =>
      _$chatSetReadMarkerResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatSetReadMarkerResponseApplicationJson_OcsBuilder b) {
    $ChatSetReadMarkerResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatSetReadMarkerResponseApplicationJson_OcsBuilder b) {
    $ChatSetReadMarkerResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ChatSetReadMarkerResponseApplicationJsonInterface {
  ChatSetReadMarkerResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatSetReadMarkerResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatSetReadMarkerResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class ChatSetReadMarkerResponseApplicationJson
    implements
        $ChatSetReadMarkerResponseApplicationJsonInterface,
        Built<ChatSetReadMarkerResponseApplicationJson, ChatSetReadMarkerResponseApplicationJsonBuilder> {
  /// Creates a new ChatSetReadMarkerResponseApplicationJson object using the builder pattern.
  factory ChatSetReadMarkerResponseApplicationJson([
    void Function(ChatSetReadMarkerResponseApplicationJsonBuilder)? b,
  ]) = _$ChatSetReadMarkerResponseApplicationJson;

  // coverage:ignore-start
  const ChatSetReadMarkerResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatSetReadMarkerResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatSetReadMarkerResponseApplicationJson.
  static Serializer<ChatSetReadMarkerResponseApplicationJson> get serializer =>
      _$chatSetReadMarkerResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatSetReadMarkerResponseApplicationJsonBuilder b) {
    $ChatSetReadMarkerResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatSetReadMarkerResponseApplicationJsonBuilder b) {
    $ChatSetReadMarkerResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ChatChatSetReadMarkerHeadersInterface {
  @BuiltValueField(wireName: 'x-chat-last-common-read')
  String? get xChatLastCommonRead;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatChatSetReadMarkerHeadersInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatChatSetReadMarkerHeadersInterfaceBuilder b) {}
}

abstract class ChatChatSetReadMarkerHeaders
    implements
        $ChatChatSetReadMarkerHeadersInterface,
        Built<ChatChatSetReadMarkerHeaders, ChatChatSetReadMarkerHeadersBuilder> {
  /// Creates a new ChatChatSetReadMarkerHeaders object using the builder pattern.
  factory ChatChatSetReadMarkerHeaders([void Function(ChatChatSetReadMarkerHeadersBuilder)? b]) =
      _$ChatChatSetReadMarkerHeaders;

  // coverage:ignore-start
  const ChatChatSetReadMarkerHeaders._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatChatSetReadMarkerHeaders.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatChatSetReadMarkerHeaders.
  static Serializer<ChatChatSetReadMarkerHeaders> get serializer => _$chatChatSetReadMarkerHeadersSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatChatSetReadMarkerHeadersBuilder b) {
    $ChatChatSetReadMarkerHeadersInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatChatSetReadMarkerHeadersBuilder b) {
    $ChatChatSetReadMarkerHeadersInterface._validate(b);
  }
}

class ChatMarkUnreadApiVersion extends EnumClass {
  const ChatMarkUnreadApiVersion._(super.name);

  /// `v1`
  static const ChatMarkUnreadApiVersion v1 = _$chatMarkUnreadApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<ChatMarkUnreadApiVersion> get values => _$chatMarkUnreadApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static ChatMarkUnreadApiVersion valueOf(String name) => _$valueOfChatMarkUnreadApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for ChatMarkUnreadApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<ChatMarkUnreadApiVersion> get serializer => const _$ChatMarkUnreadApiVersionSerializer();
}

class _$ChatMarkUnreadApiVersionSerializer implements PrimitiveSerializer<ChatMarkUnreadApiVersion> {
  const _$ChatMarkUnreadApiVersionSerializer();

  static const Map<ChatMarkUnreadApiVersion, Object> _toWire = <ChatMarkUnreadApiVersion, Object>{
    ChatMarkUnreadApiVersion.v1: 'v1',
  };

  static const Map<Object, ChatMarkUnreadApiVersion> _fromWire = <Object, ChatMarkUnreadApiVersion>{
    'v1': ChatMarkUnreadApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ChatMarkUnreadApiVersion];

  @override
  String get wireName => 'ChatMarkUnreadApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ChatMarkUnreadApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatMarkUnreadApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatMarkUnreadResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatMarkUnreadResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatMarkUnreadResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class ChatMarkUnreadResponseApplicationJson_Ocs
    implements
        $ChatMarkUnreadResponseApplicationJson_OcsInterface,
        Built<ChatMarkUnreadResponseApplicationJson_Ocs, ChatMarkUnreadResponseApplicationJson_OcsBuilder> {
  /// Creates a new ChatMarkUnreadResponseApplicationJson_Ocs object using the builder pattern.
  factory ChatMarkUnreadResponseApplicationJson_Ocs([
    void Function(ChatMarkUnreadResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ChatMarkUnreadResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ChatMarkUnreadResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatMarkUnreadResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatMarkUnreadResponseApplicationJson_Ocs.
  static Serializer<ChatMarkUnreadResponseApplicationJson_Ocs> get serializer =>
      _$chatMarkUnreadResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatMarkUnreadResponseApplicationJson_OcsBuilder b) {
    $ChatMarkUnreadResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatMarkUnreadResponseApplicationJson_OcsBuilder b) {
    $ChatMarkUnreadResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ChatMarkUnreadResponseApplicationJsonInterface {
  ChatMarkUnreadResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatMarkUnreadResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatMarkUnreadResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class ChatMarkUnreadResponseApplicationJson
    implements
        $ChatMarkUnreadResponseApplicationJsonInterface,
        Built<ChatMarkUnreadResponseApplicationJson, ChatMarkUnreadResponseApplicationJsonBuilder> {
  /// Creates a new ChatMarkUnreadResponseApplicationJson object using the builder pattern.
  factory ChatMarkUnreadResponseApplicationJson([void Function(ChatMarkUnreadResponseApplicationJsonBuilder)? b]) =
      _$ChatMarkUnreadResponseApplicationJson;

  // coverage:ignore-start
  const ChatMarkUnreadResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatMarkUnreadResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatMarkUnreadResponseApplicationJson.
  static Serializer<ChatMarkUnreadResponseApplicationJson> get serializer =>
      _$chatMarkUnreadResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatMarkUnreadResponseApplicationJsonBuilder b) {
    $ChatMarkUnreadResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatMarkUnreadResponseApplicationJsonBuilder b) {
    $ChatMarkUnreadResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ChatChatMarkUnreadHeadersInterface {
  @BuiltValueField(wireName: 'x-chat-last-common-read')
  String? get xChatLastCommonRead;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatChatMarkUnreadHeadersInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatChatMarkUnreadHeadersInterfaceBuilder b) {}
}

abstract class ChatChatMarkUnreadHeaders
    implements $ChatChatMarkUnreadHeadersInterface, Built<ChatChatMarkUnreadHeaders, ChatChatMarkUnreadHeadersBuilder> {
  /// Creates a new ChatChatMarkUnreadHeaders object using the builder pattern.
  factory ChatChatMarkUnreadHeaders([void Function(ChatChatMarkUnreadHeadersBuilder)? b]) = _$ChatChatMarkUnreadHeaders;

  // coverage:ignore-start
  const ChatChatMarkUnreadHeaders._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatChatMarkUnreadHeaders.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatChatMarkUnreadHeaders.
  static Serializer<ChatChatMarkUnreadHeaders> get serializer => _$chatChatMarkUnreadHeadersSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatChatMarkUnreadHeadersBuilder b) {
    $ChatChatMarkUnreadHeadersInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatChatMarkUnreadHeadersBuilder b) {
    $ChatChatMarkUnreadHeadersInterface._validate(b);
  }
}

class ChatMentionsIncludeStatus extends EnumClass {
  const ChatMentionsIncludeStatus._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const ChatMentionsIncludeStatus $0 = _$chatMentionsIncludeStatus$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const ChatMentionsIncludeStatus $1 = _$chatMentionsIncludeStatus$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<ChatMentionsIncludeStatus> get values => _$chatMentionsIncludeStatusValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static ChatMentionsIncludeStatus valueOf(String name) => _$valueOfChatMentionsIncludeStatus(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for ChatMentionsIncludeStatus.
  @BuiltValueSerializer(custom: true)
  static Serializer<ChatMentionsIncludeStatus> get serializer => const _$ChatMentionsIncludeStatusSerializer();
}

class _$ChatMentionsIncludeStatusSerializer implements PrimitiveSerializer<ChatMentionsIncludeStatus> {
  const _$ChatMentionsIncludeStatusSerializer();

  static const Map<ChatMentionsIncludeStatus, Object> _toWire = <ChatMentionsIncludeStatus, Object>{
    ChatMentionsIncludeStatus.$0: 0,
    ChatMentionsIncludeStatus.$1: 1,
  };

  static const Map<Object, ChatMentionsIncludeStatus> _fromWire = <Object, ChatMentionsIncludeStatus>{
    0: ChatMentionsIncludeStatus.$0,
    1: ChatMentionsIncludeStatus.$1,
  };

  @override
  Iterable<Type> get types => const [ChatMentionsIncludeStatus];

  @override
  String get wireName => 'ChatMentionsIncludeStatus';

  @override
  Object serialize(
    Serializers serializers,
    ChatMentionsIncludeStatus object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatMentionsIncludeStatus deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class ChatMentionsApiVersion extends EnumClass {
  const ChatMentionsApiVersion._(super.name);

  /// `v1`
  static const ChatMentionsApiVersion v1 = _$chatMentionsApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<ChatMentionsApiVersion> get values => _$chatMentionsApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static ChatMentionsApiVersion valueOf(String name) => _$valueOfChatMentionsApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for ChatMentionsApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<ChatMentionsApiVersion> get serializer => const _$ChatMentionsApiVersionSerializer();
}

class _$ChatMentionsApiVersionSerializer implements PrimitiveSerializer<ChatMentionsApiVersion> {
  const _$ChatMentionsApiVersionSerializer();

  static const Map<ChatMentionsApiVersion, Object> _toWire = <ChatMentionsApiVersion, Object>{
    ChatMentionsApiVersion.v1: 'v1',
  };

  static const Map<Object, ChatMentionsApiVersion> _fromWire = <Object, ChatMentionsApiVersion>{
    'v1': ChatMentionsApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ChatMentionsApiVersion];

  @override
  String get wireName => 'ChatMentionsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ChatMentionsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatMentionsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatMentionSuggestionInterface {
  String get id;
  String get label;
  String get source;
  String get mentionId;
  String? get status;
  int? get statusClearAt;
  String? get statusIcon;
  String? get statusMessage;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatMentionSuggestionInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatMentionSuggestionInterfaceBuilder b) {}
}

abstract class ChatMentionSuggestion
    implements $ChatMentionSuggestionInterface, Built<ChatMentionSuggestion, ChatMentionSuggestionBuilder> {
  /// Creates a new ChatMentionSuggestion object using the builder pattern.
  factory ChatMentionSuggestion([void Function(ChatMentionSuggestionBuilder)? b]) = _$ChatMentionSuggestion;

  // coverage:ignore-start
  const ChatMentionSuggestion._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatMentionSuggestion.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatMentionSuggestion.
  static Serializer<ChatMentionSuggestion> get serializer => _$chatMentionSuggestionSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatMentionSuggestionBuilder b) {
    $ChatMentionSuggestionInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatMentionSuggestionBuilder b) {
    $ChatMentionSuggestionInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ChatMentionsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<ChatMentionSuggestion> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatMentionsResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatMentionsResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class ChatMentionsResponseApplicationJson_Ocs
    implements
        $ChatMentionsResponseApplicationJson_OcsInterface,
        Built<ChatMentionsResponseApplicationJson_Ocs, ChatMentionsResponseApplicationJson_OcsBuilder> {
  /// Creates a new ChatMentionsResponseApplicationJson_Ocs object using the builder pattern.
  factory ChatMentionsResponseApplicationJson_Ocs([void Function(ChatMentionsResponseApplicationJson_OcsBuilder)? b]) =
      _$ChatMentionsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ChatMentionsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatMentionsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatMentionsResponseApplicationJson_Ocs.
  static Serializer<ChatMentionsResponseApplicationJson_Ocs> get serializer =>
      _$chatMentionsResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatMentionsResponseApplicationJson_OcsBuilder b) {
    $ChatMentionsResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatMentionsResponseApplicationJson_OcsBuilder b) {
    $ChatMentionsResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ChatMentionsResponseApplicationJsonInterface {
  ChatMentionsResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatMentionsResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatMentionsResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class ChatMentionsResponseApplicationJson
    implements
        $ChatMentionsResponseApplicationJsonInterface,
        Built<ChatMentionsResponseApplicationJson, ChatMentionsResponseApplicationJsonBuilder> {
  /// Creates a new ChatMentionsResponseApplicationJson object using the builder pattern.
  factory ChatMentionsResponseApplicationJson([void Function(ChatMentionsResponseApplicationJsonBuilder)? b]) =
      _$ChatMentionsResponseApplicationJson;

  // coverage:ignore-start
  const ChatMentionsResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatMentionsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatMentionsResponseApplicationJson.
  static Serializer<ChatMentionsResponseApplicationJson> get serializer =>
      _$chatMentionsResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatMentionsResponseApplicationJsonBuilder b) {
    $ChatMentionsResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatMentionsResponseApplicationJsonBuilder b) {
    $ChatMentionsResponseApplicationJsonInterface._validate(b);
  }
}

class ChatGetObjectsSharedInRoomApiVersion extends EnumClass {
  const ChatGetObjectsSharedInRoomApiVersion._(super.name);

  /// `v1`
  static const ChatGetObjectsSharedInRoomApiVersion v1 = _$chatGetObjectsSharedInRoomApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<ChatGetObjectsSharedInRoomApiVersion> get values => _$chatGetObjectsSharedInRoomApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static ChatGetObjectsSharedInRoomApiVersion valueOf(String name) =>
      _$valueOfChatGetObjectsSharedInRoomApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for ChatGetObjectsSharedInRoomApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<ChatGetObjectsSharedInRoomApiVersion> get serializer =>
      const _$ChatGetObjectsSharedInRoomApiVersionSerializer();
}

class _$ChatGetObjectsSharedInRoomApiVersionSerializer
    implements PrimitiveSerializer<ChatGetObjectsSharedInRoomApiVersion> {
  const _$ChatGetObjectsSharedInRoomApiVersionSerializer();

  static const Map<ChatGetObjectsSharedInRoomApiVersion, Object> _toWire =
      <ChatGetObjectsSharedInRoomApiVersion, Object>{
    ChatGetObjectsSharedInRoomApiVersion.v1: 'v1',
  };

  static const Map<Object, ChatGetObjectsSharedInRoomApiVersion> _fromWire =
      <Object, ChatGetObjectsSharedInRoomApiVersion>{
    'v1': ChatGetObjectsSharedInRoomApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ChatGetObjectsSharedInRoomApiVersion];

  @override
  String get wireName => 'ChatGetObjectsSharedInRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ChatGetObjectsSharedInRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatGetObjectsSharedInRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatGetObjectsSharedInRoomResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<ChatMessage> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatGetObjectsSharedInRoomResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatGetObjectsSharedInRoomResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class ChatGetObjectsSharedInRoomResponseApplicationJson_Ocs
    implements
        $ChatGetObjectsSharedInRoomResponseApplicationJson_OcsInterface,
        Built<ChatGetObjectsSharedInRoomResponseApplicationJson_Ocs,
            ChatGetObjectsSharedInRoomResponseApplicationJson_OcsBuilder> {
  /// Creates a new ChatGetObjectsSharedInRoomResponseApplicationJson_Ocs object using the builder pattern.
  factory ChatGetObjectsSharedInRoomResponseApplicationJson_Ocs([
    void Function(ChatGetObjectsSharedInRoomResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ChatGetObjectsSharedInRoomResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ChatGetObjectsSharedInRoomResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatGetObjectsSharedInRoomResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatGetObjectsSharedInRoomResponseApplicationJson_Ocs.
  static Serializer<ChatGetObjectsSharedInRoomResponseApplicationJson_Ocs> get serializer =>
      _$chatGetObjectsSharedInRoomResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatGetObjectsSharedInRoomResponseApplicationJson_OcsBuilder b) {
    $ChatGetObjectsSharedInRoomResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatGetObjectsSharedInRoomResponseApplicationJson_OcsBuilder b) {
    $ChatGetObjectsSharedInRoomResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ChatGetObjectsSharedInRoomResponseApplicationJsonInterface {
  ChatGetObjectsSharedInRoomResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatGetObjectsSharedInRoomResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatGetObjectsSharedInRoomResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class ChatGetObjectsSharedInRoomResponseApplicationJson
    implements
        $ChatGetObjectsSharedInRoomResponseApplicationJsonInterface,
        Built<ChatGetObjectsSharedInRoomResponseApplicationJson,
            ChatGetObjectsSharedInRoomResponseApplicationJsonBuilder> {
  /// Creates a new ChatGetObjectsSharedInRoomResponseApplicationJson object using the builder pattern.
  factory ChatGetObjectsSharedInRoomResponseApplicationJson([
    void Function(ChatGetObjectsSharedInRoomResponseApplicationJsonBuilder)? b,
  ]) = _$ChatGetObjectsSharedInRoomResponseApplicationJson;

  // coverage:ignore-start
  const ChatGetObjectsSharedInRoomResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatGetObjectsSharedInRoomResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatGetObjectsSharedInRoomResponseApplicationJson.
  static Serializer<ChatGetObjectsSharedInRoomResponseApplicationJson> get serializer =>
      _$chatGetObjectsSharedInRoomResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatGetObjectsSharedInRoomResponseApplicationJsonBuilder b) {
    $ChatGetObjectsSharedInRoomResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatGetObjectsSharedInRoomResponseApplicationJsonBuilder b) {
    $ChatGetObjectsSharedInRoomResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ChatChatGetObjectsSharedInRoomHeadersInterface {
  @BuiltValueField(wireName: 'x-chat-last-given')
  String? get xChatLastGiven;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatChatGetObjectsSharedInRoomHeadersInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatChatGetObjectsSharedInRoomHeadersInterfaceBuilder b) {}
}

abstract class ChatChatGetObjectsSharedInRoomHeaders
    implements
        $ChatChatGetObjectsSharedInRoomHeadersInterface,
        Built<ChatChatGetObjectsSharedInRoomHeaders, ChatChatGetObjectsSharedInRoomHeadersBuilder> {
  /// Creates a new ChatChatGetObjectsSharedInRoomHeaders object using the builder pattern.
  factory ChatChatGetObjectsSharedInRoomHeaders([void Function(ChatChatGetObjectsSharedInRoomHeadersBuilder)? b]) =
      _$ChatChatGetObjectsSharedInRoomHeaders;

  // coverage:ignore-start
  const ChatChatGetObjectsSharedInRoomHeaders._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatChatGetObjectsSharedInRoomHeaders.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatChatGetObjectsSharedInRoomHeaders.
  static Serializer<ChatChatGetObjectsSharedInRoomHeaders> get serializer =>
      _$chatChatGetObjectsSharedInRoomHeadersSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatChatGetObjectsSharedInRoomHeadersBuilder b) {
    $ChatChatGetObjectsSharedInRoomHeadersInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatChatGetObjectsSharedInRoomHeadersBuilder b) {
    $ChatChatGetObjectsSharedInRoomHeadersInterface._validate(b);
  }
}

class ChatShareObjectToChatApiVersion extends EnumClass {
  const ChatShareObjectToChatApiVersion._(super.name);

  /// `v1`
  static const ChatShareObjectToChatApiVersion v1 = _$chatShareObjectToChatApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<ChatShareObjectToChatApiVersion> get values => _$chatShareObjectToChatApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static ChatShareObjectToChatApiVersion valueOf(String name) => _$valueOfChatShareObjectToChatApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for ChatShareObjectToChatApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<ChatShareObjectToChatApiVersion> get serializer =>
      const _$ChatShareObjectToChatApiVersionSerializer();
}

class _$ChatShareObjectToChatApiVersionSerializer implements PrimitiveSerializer<ChatShareObjectToChatApiVersion> {
  const _$ChatShareObjectToChatApiVersionSerializer();

  static const Map<ChatShareObjectToChatApiVersion, Object> _toWire = <ChatShareObjectToChatApiVersion, Object>{
    ChatShareObjectToChatApiVersion.v1: 'v1',
  };

  static const Map<Object, ChatShareObjectToChatApiVersion> _fromWire = <Object, ChatShareObjectToChatApiVersion>{
    'v1': ChatShareObjectToChatApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ChatShareObjectToChatApiVersion];

  @override
  String get wireName => 'ChatShareObjectToChatApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ChatShareObjectToChatApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatShareObjectToChatApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatShareObjectToChatResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  ChatMessageWithParent? get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatShareObjectToChatResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatShareObjectToChatResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class ChatShareObjectToChatResponseApplicationJson_Ocs
    implements
        $ChatShareObjectToChatResponseApplicationJson_OcsInterface,
        Built<ChatShareObjectToChatResponseApplicationJson_Ocs,
            ChatShareObjectToChatResponseApplicationJson_OcsBuilder> {
  /// Creates a new ChatShareObjectToChatResponseApplicationJson_Ocs object using the builder pattern.
  factory ChatShareObjectToChatResponseApplicationJson_Ocs([
    void Function(ChatShareObjectToChatResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ChatShareObjectToChatResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ChatShareObjectToChatResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatShareObjectToChatResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatShareObjectToChatResponseApplicationJson_Ocs.
  static Serializer<ChatShareObjectToChatResponseApplicationJson_Ocs> get serializer =>
      _$chatShareObjectToChatResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatShareObjectToChatResponseApplicationJson_OcsBuilder b) {
    $ChatShareObjectToChatResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatShareObjectToChatResponseApplicationJson_OcsBuilder b) {
    $ChatShareObjectToChatResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ChatShareObjectToChatResponseApplicationJsonInterface {
  ChatShareObjectToChatResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatShareObjectToChatResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatShareObjectToChatResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class ChatShareObjectToChatResponseApplicationJson
    implements
        $ChatShareObjectToChatResponseApplicationJsonInterface,
        Built<ChatShareObjectToChatResponseApplicationJson, ChatShareObjectToChatResponseApplicationJsonBuilder> {
  /// Creates a new ChatShareObjectToChatResponseApplicationJson object using the builder pattern.
  factory ChatShareObjectToChatResponseApplicationJson([
    void Function(ChatShareObjectToChatResponseApplicationJsonBuilder)? b,
  ]) = _$ChatShareObjectToChatResponseApplicationJson;

  // coverage:ignore-start
  const ChatShareObjectToChatResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatShareObjectToChatResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatShareObjectToChatResponseApplicationJson.
  static Serializer<ChatShareObjectToChatResponseApplicationJson> get serializer =>
      _$chatShareObjectToChatResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatShareObjectToChatResponseApplicationJsonBuilder b) {
    $ChatShareObjectToChatResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatShareObjectToChatResponseApplicationJsonBuilder b) {
    $ChatShareObjectToChatResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ChatChatShareObjectToChatHeadersInterface {
  @BuiltValueField(wireName: 'x-chat-last-common-read')
  String? get xChatLastCommonRead;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatChatShareObjectToChatHeadersInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatChatShareObjectToChatHeadersInterfaceBuilder b) {}
}

abstract class ChatChatShareObjectToChatHeaders
    implements
        $ChatChatShareObjectToChatHeadersInterface,
        Built<ChatChatShareObjectToChatHeaders, ChatChatShareObjectToChatHeadersBuilder> {
  /// Creates a new ChatChatShareObjectToChatHeaders object using the builder pattern.
  factory ChatChatShareObjectToChatHeaders([void Function(ChatChatShareObjectToChatHeadersBuilder)? b]) =
      _$ChatChatShareObjectToChatHeaders;

  // coverage:ignore-start
  const ChatChatShareObjectToChatHeaders._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatChatShareObjectToChatHeaders.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatChatShareObjectToChatHeaders.
  static Serializer<ChatChatShareObjectToChatHeaders> get serializer => _$chatChatShareObjectToChatHeadersSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatChatShareObjectToChatHeadersBuilder b) {
    $ChatChatShareObjectToChatHeadersInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatChatShareObjectToChatHeadersBuilder b) {
    $ChatChatShareObjectToChatHeadersInterface._validate(b);
  }
}

class ChatGetObjectsSharedInRoomOverviewApiVersion extends EnumClass {
  const ChatGetObjectsSharedInRoomOverviewApiVersion._(super.name);

  /// `v1`
  static const ChatGetObjectsSharedInRoomOverviewApiVersion v1 = _$chatGetObjectsSharedInRoomOverviewApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<ChatGetObjectsSharedInRoomOverviewApiVersion> get values =>
      _$chatGetObjectsSharedInRoomOverviewApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static ChatGetObjectsSharedInRoomOverviewApiVersion valueOf(String name) =>
      _$valueOfChatGetObjectsSharedInRoomOverviewApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for ChatGetObjectsSharedInRoomOverviewApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<ChatGetObjectsSharedInRoomOverviewApiVersion> get serializer =>
      const _$ChatGetObjectsSharedInRoomOverviewApiVersionSerializer();
}

class _$ChatGetObjectsSharedInRoomOverviewApiVersionSerializer
    implements PrimitiveSerializer<ChatGetObjectsSharedInRoomOverviewApiVersion> {
  const _$ChatGetObjectsSharedInRoomOverviewApiVersionSerializer();

  static const Map<ChatGetObjectsSharedInRoomOverviewApiVersion, Object> _toWire =
      <ChatGetObjectsSharedInRoomOverviewApiVersion, Object>{
    ChatGetObjectsSharedInRoomOverviewApiVersion.v1: 'v1',
  };

  static const Map<Object, ChatGetObjectsSharedInRoomOverviewApiVersion> _fromWire =
      <Object, ChatGetObjectsSharedInRoomOverviewApiVersion>{
    'v1': ChatGetObjectsSharedInRoomOverviewApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ChatGetObjectsSharedInRoomOverviewApiVersion];

  @override
  String get wireName => 'ChatGetObjectsSharedInRoomOverviewApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ChatGetObjectsSharedInRoomOverviewApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatGetObjectsSharedInRoomOverviewApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltMap<String, BuiltList<ChatMessage>> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_Ocs
    implements
        $ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_OcsInterface,
        Built<ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_Ocs,
            ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_OcsBuilder> {
  /// Creates a new ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_Ocs object using the builder pattern.
  factory ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_Ocs([
    void Function(ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_Ocs.
  static Serializer<ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_Ocs> get serializer =>
      _$chatGetObjectsSharedInRoomOverviewResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_OcsBuilder b) {
    $ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_OcsBuilder b) {
    $ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ChatGetObjectsSharedInRoomOverviewResponseApplicationJsonInterface {
  ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ChatGetObjectsSharedInRoomOverviewResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ChatGetObjectsSharedInRoomOverviewResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class ChatGetObjectsSharedInRoomOverviewResponseApplicationJson
    implements
        $ChatGetObjectsSharedInRoomOverviewResponseApplicationJsonInterface,
        Built<ChatGetObjectsSharedInRoomOverviewResponseApplicationJson,
            ChatGetObjectsSharedInRoomOverviewResponseApplicationJsonBuilder> {
  /// Creates a new ChatGetObjectsSharedInRoomOverviewResponseApplicationJson object using the builder pattern.
  factory ChatGetObjectsSharedInRoomOverviewResponseApplicationJson([
    void Function(ChatGetObjectsSharedInRoomOverviewResponseApplicationJsonBuilder)? b,
  ]) = _$ChatGetObjectsSharedInRoomOverviewResponseApplicationJson;

  // coverage:ignore-start
  const ChatGetObjectsSharedInRoomOverviewResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ChatGetObjectsSharedInRoomOverviewResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ChatGetObjectsSharedInRoomOverviewResponseApplicationJson.
  static Serializer<ChatGetObjectsSharedInRoomOverviewResponseApplicationJson> get serializer =>
      _$chatGetObjectsSharedInRoomOverviewResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ChatGetObjectsSharedInRoomOverviewResponseApplicationJsonBuilder b) {
    $ChatGetObjectsSharedInRoomOverviewResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ChatGetObjectsSharedInRoomOverviewResponseApplicationJsonBuilder b) {
    $ChatGetObjectsSharedInRoomOverviewResponseApplicationJsonInterface._validate(b);
  }
}

class SignalingGetSettingsApiVersion extends EnumClass {
  const SignalingGetSettingsApiVersion._(super.name);

  /// `v3`
  static const SignalingGetSettingsApiVersion v3 = _$signalingGetSettingsApiVersionV3;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<SignalingGetSettingsApiVersion> get values => _$signalingGetSettingsApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static SignalingGetSettingsApiVersion valueOf(String name) => _$valueOfSignalingGetSettingsApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for SignalingGetSettingsApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<SignalingGetSettingsApiVersion> get serializer =>
      const _$SignalingGetSettingsApiVersionSerializer();
}

class _$SignalingGetSettingsApiVersionSerializer implements PrimitiveSerializer<SignalingGetSettingsApiVersion> {
  const _$SignalingGetSettingsApiVersionSerializer();

  static const Map<SignalingGetSettingsApiVersion, Object> _toWire = <SignalingGetSettingsApiVersion, Object>{
    SignalingGetSettingsApiVersion.v3: 'v3',
  };

  static const Map<Object, SignalingGetSettingsApiVersion> _fromWire = <Object, SignalingGetSettingsApiVersion>{
    'v3': SignalingGetSettingsApiVersion.v3,
  };

  @override
  Iterable<Type> get types => const [SignalingGetSettingsApiVersion];

  @override
  String get wireName => 'SignalingGetSettingsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    SignalingGetSettingsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  SignalingGetSettingsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingSettings_HelloAuthParams_10Interface {
  String? get userid;
  String get ticket;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SignalingSettings_HelloAuthParams_10InterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SignalingSettings_HelloAuthParams_10InterfaceBuilder b) {}
}

abstract class SignalingSettings_HelloAuthParams_10
    implements
        $SignalingSettings_HelloAuthParams_10Interface,
        Built<SignalingSettings_HelloAuthParams_10, SignalingSettings_HelloAuthParams_10Builder> {
  /// Creates a new SignalingSettings_HelloAuthParams_10 object using the builder pattern.
  factory SignalingSettings_HelloAuthParams_10([void Function(SignalingSettings_HelloAuthParams_10Builder)? b]) =
      _$SignalingSettings_HelloAuthParams_10;

  // coverage:ignore-start
  const SignalingSettings_HelloAuthParams_10._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SignalingSettings_HelloAuthParams_10.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SignalingSettings_HelloAuthParams_10.
  static Serializer<SignalingSettings_HelloAuthParams_10> get serializer =>
      _$signalingSettingsHelloAuthParams10Serializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SignalingSettings_HelloAuthParams_10Builder b) {
    $SignalingSettings_HelloAuthParams_10Interface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SignalingSettings_HelloAuthParams_10Builder b) {
    $SignalingSettings_HelloAuthParams_10Interface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingSettings_HelloAuthParams_20Interface {
  String get token;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SignalingSettings_HelloAuthParams_20InterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SignalingSettings_HelloAuthParams_20InterfaceBuilder b) {}
}

abstract class SignalingSettings_HelloAuthParams_20
    implements
        $SignalingSettings_HelloAuthParams_20Interface,
        Built<SignalingSettings_HelloAuthParams_20, SignalingSettings_HelloAuthParams_20Builder> {
  /// Creates a new SignalingSettings_HelloAuthParams_20 object using the builder pattern.
  factory SignalingSettings_HelloAuthParams_20([void Function(SignalingSettings_HelloAuthParams_20Builder)? b]) =
      _$SignalingSettings_HelloAuthParams_20;

  // coverage:ignore-start
  const SignalingSettings_HelloAuthParams_20._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SignalingSettings_HelloAuthParams_20.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SignalingSettings_HelloAuthParams_20.
  static Serializer<SignalingSettings_HelloAuthParams_20> get serializer =>
      _$signalingSettingsHelloAuthParams20Serializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SignalingSettings_HelloAuthParams_20Builder b) {
    $SignalingSettings_HelloAuthParams_20Interface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SignalingSettings_HelloAuthParams_20Builder b) {
    $SignalingSettings_HelloAuthParams_20Interface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingSettings_HelloAuthParamsInterface {
  @BuiltValueField(wireName: '1.0')
  SignalingSettings_HelloAuthParams_10 get $10;
  @BuiltValueField(wireName: '2.0')
  SignalingSettings_HelloAuthParams_20 get $20;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SignalingSettings_HelloAuthParamsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SignalingSettings_HelloAuthParamsInterfaceBuilder b) {}
}

abstract class SignalingSettings_HelloAuthParams
    implements
        $SignalingSettings_HelloAuthParamsInterface,
        Built<SignalingSettings_HelloAuthParams, SignalingSettings_HelloAuthParamsBuilder> {
  /// Creates a new SignalingSettings_HelloAuthParams object using the builder pattern.
  factory SignalingSettings_HelloAuthParams([void Function(SignalingSettings_HelloAuthParamsBuilder)? b]) =
      _$SignalingSettings_HelloAuthParams;

  // coverage:ignore-start
  const SignalingSettings_HelloAuthParams._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SignalingSettings_HelloAuthParams.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SignalingSettings_HelloAuthParams.
  static Serializer<SignalingSettings_HelloAuthParams> get serializer => _$signalingSettingsHelloAuthParamsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SignalingSettings_HelloAuthParamsBuilder b) {
    $SignalingSettings_HelloAuthParamsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SignalingSettings_HelloAuthParamsBuilder b) {
    $SignalingSettings_HelloAuthParamsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingSettings_StunserversInterface {
  BuiltList<String> get urls;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SignalingSettings_StunserversInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SignalingSettings_StunserversInterfaceBuilder b) {}
}

abstract class SignalingSettings_Stunservers
    implements
        $SignalingSettings_StunserversInterface,
        Built<SignalingSettings_Stunservers, SignalingSettings_StunserversBuilder> {
  /// Creates a new SignalingSettings_Stunservers object using the builder pattern.
  factory SignalingSettings_Stunservers([void Function(SignalingSettings_StunserversBuilder)? b]) =
      _$SignalingSettings_Stunservers;

  // coverage:ignore-start
  const SignalingSettings_Stunservers._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SignalingSettings_Stunservers.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SignalingSettings_Stunservers.
  static Serializer<SignalingSettings_Stunservers> get serializer => _$signalingSettingsStunserversSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SignalingSettings_StunserversBuilder b) {
    $SignalingSettings_StunserversInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SignalingSettings_StunserversBuilder b) {
    $SignalingSettings_StunserversInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingSettings_TurnserversInterface {
  BuiltList<String> get urls;
  String get username;
  JsonObject get credential;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SignalingSettings_TurnserversInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SignalingSettings_TurnserversInterfaceBuilder b) {}
}

abstract class SignalingSettings_Turnservers
    implements
        $SignalingSettings_TurnserversInterface,
        Built<SignalingSettings_Turnservers, SignalingSettings_TurnserversBuilder> {
  /// Creates a new SignalingSettings_Turnservers object using the builder pattern.
  factory SignalingSettings_Turnservers([void Function(SignalingSettings_TurnserversBuilder)? b]) =
      _$SignalingSettings_Turnservers;

  // coverage:ignore-start
  const SignalingSettings_Turnservers._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SignalingSettings_Turnservers.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SignalingSettings_Turnservers.
  static Serializer<SignalingSettings_Turnservers> get serializer => _$signalingSettingsTurnserversSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SignalingSettings_TurnserversBuilder b) {
    $SignalingSettings_TurnserversInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SignalingSettings_TurnserversBuilder b) {
    $SignalingSettings_TurnserversInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingSettingsInterface {
  SignalingSettings_HelloAuthParams get helloAuthParams;
  bool get hideWarning;
  String get server;
  String get signalingMode;
  String get sipDialinInfo;
  BuiltList<SignalingSettings_Stunservers> get stunservers;
  String get ticket;
  BuiltList<SignalingSettings_Turnservers> get turnservers;
  String? get userId;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SignalingSettingsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SignalingSettingsInterfaceBuilder b) {}
}

abstract class SignalingSettings
    implements $SignalingSettingsInterface, Built<SignalingSettings, SignalingSettingsBuilder> {
  /// Creates a new SignalingSettings object using the builder pattern.
  factory SignalingSettings([void Function(SignalingSettingsBuilder)? b]) = _$SignalingSettings;

  // coverage:ignore-start
  const SignalingSettings._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SignalingSettings.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SignalingSettings.
  static Serializer<SignalingSettings> get serializer => _$signalingSettingsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SignalingSettingsBuilder b) {
    $SignalingSettingsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SignalingSettingsBuilder b) {
    $SignalingSettingsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingGetSettingsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  SignalingSettings get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SignalingGetSettingsResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SignalingGetSettingsResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class SignalingGetSettingsResponseApplicationJson_Ocs
    implements
        $SignalingGetSettingsResponseApplicationJson_OcsInterface,
        Built<SignalingGetSettingsResponseApplicationJson_Ocs, SignalingGetSettingsResponseApplicationJson_OcsBuilder> {
  /// Creates a new SignalingGetSettingsResponseApplicationJson_Ocs object using the builder pattern.
  factory SignalingGetSettingsResponseApplicationJson_Ocs([
    void Function(SignalingGetSettingsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$SignalingGetSettingsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const SignalingGetSettingsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SignalingGetSettingsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SignalingGetSettingsResponseApplicationJson_Ocs.
  static Serializer<SignalingGetSettingsResponseApplicationJson_Ocs> get serializer =>
      _$signalingGetSettingsResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SignalingGetSettingsResponseApplicationJson_OcsBuilder b) {
    $SignalingGetSettingsResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SignalingGetSettingsResponseApplicationJson_OcsBuilder b) {
    $SignalingGetSettingsResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingGetSettingsResponseApplicationJsonInterface {
  SignalingGetSettingsResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SignalingGetSettingsResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SignalingGetSettingsResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class SignalingGetSettingsResponseApplicationJson
    implements
        $SignalingGetSettingsResponseApplicationJsonInterface,
        Built<SignalingGetSettingsResponseApplicationJson, SignalingGetSettingsResponseApplicationJsonBuilder> {
  /// Creates a new SignalingGetSettingsResponseApplicationJson object using the builder pattern.
  factory SignalingGetSettingsResponseApplicationJson([
    void Function(SignalingGetSettingsResponseApplicationJsonBuilder)? b,
  ]) = _$SignalingGetSettingsResponseApplicationJson;

  // coverage:ignore-start
  const SignalingGetSettingsResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SignalingGetSettingsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SignalingGetSettingsResponseApplicationJson.
  static Serializer<SignalingGetSettingsResponseApplicationJson> get serializer =>
      _$signalingGetSettingsResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SignalingGetSettingsResponseApplicationJsonBuilder b) {
    $SignalingGetSettingsResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SignalingGetSettingsResponseApplicationJsonBuilder b) {
    $SignalingGetSettingsResponseApplicationJsonInterface._validate(b);
  }
}

class FederationAcceptShareApiVersion extends EnumClass {
  const FederationAcceptShareApiVersion._(super.name);

  /// `v1`
  static const FederationAcceptShareApiVersion v1 = _$federationAcceptShareApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<FederationAcceptShareApiVersion> get values => _$federationAcceptShareApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static FederationAcceptShareApiVersion valueOf(String name) => _$valueOfFederationAcceptShareApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for FederationAcceptShareApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<FederationAcceptShareApiVersion> get serializer =>
      const _$FederationAcceptShareApiVersionSerializer();
}

class _$FederationAcceptShareApiVersionSerializer implements PrimitiveSerializer<FederationAcceptShareApiVersion> {
  const _$FederationAcceptShareApiVersionSerializer();

  static const Map<FederationAcceptShareApiVersion, Object> _toWire = <FederationAcceptShareApiVersion, Object>{
    FederationAcceptShareApiVersion.v1: 'v1',
  };

  static const Map<Object, FederationAcceptShareApiVersion> _fromWire = <Object, FederationAcceptShareApiVersion>{
    'v1': FederationAcceptShareApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [FederationAcceptShareApiVersion];

  @override
  String get wireName => 'FederationAcceptShareApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    FederationAcceptShareApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  FederationAcceptShareApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $FederationAcceptShareResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FederationAcceptShareResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FederationAcceptShareResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class FederationAcceptShareResponseApplicationJson_Ocs
    implements
        $FederationAcceptShareResponseApplicationJson_OcsInterface,
        Built<FederationAcceptShareResponseApplicationJson_Ocs,
            FederationAcceptShareResponseApplicationJson_OcsBuilder> {
  /// Creates a new FederationAcceptShareResponseApplicationJson_Ocs object using the builder pattern.
  factory FederationAcceptShareResponseApplicationJson_Ocs([
    void Function(FederationAcceptShareResponseApplicationJson_OcsBuilder)? b,
  ]) = _$FederationAcceptShareResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const FederationAcceptShareResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FederationAcceptShareResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FederationAcceptShareResponseApplicationJson_Ocs.
  static Serializer<FederationAcceptShareResponseApplicationJson_Ocs> get serializer =>
      _$federationAcceptShareResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FederationAcceptShareResponseApplicationJson_OcsBuilder b) {
    $FederationAcceptShareResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FederationAcceptShareResponseApplicationJson_OcsBuilder b) {
    $FederationAcceptShareResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FederationAcceptShareResponseApplicationJsonInterface {
  FederationAcceptShareResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FederationAcceptShareResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FederationAcceptShareResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class FederationAcceptShareResponseApplicationJson
    implements
        $FederationAcceptShareResponseApplicationJsonInterface,
        Built<FederationAcceptShareResponseApplicationJson, FederationAcceptShareResponseApplicationJsonBuilder> {
  /// Creates a new FederationAcceptShareResponseApplicationJson object using the builder pattern.
  factory FederationAcceptShareResponseApplicationJson([
    void Function(FederationAcceptShareResponseApplicationJsonBuilder)? b,
  ]) = _$FederationAcceptShareResponseApplicationJson;

  // coverage:ignore-start
  const FederationAcceptShareResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FederationAcceptShareResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FederationAcceptShareResponseApplicationJson.
  static Serializer<FederationAcceptShareResponseApplicationJson> get serializer =>
      _$federationAcceptShareResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FederationAcceptShareResponseApplicationJsonBuilder b) {
    $FederationAcceptShareResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FederationAcceptShareResponseApplicationJsonBuilder b) {
    $FederationAcceptShareResponseApplicationJsonInterface._validate(b);
  }
}

class FederationRejectShareApiVersion extends EnumClass {
  const FederationRejectShareApiVersion._(super.name);

  /// `v1`
  static const FederationRejectShareApiVersion v1 = _$federationRejectShareApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<FederationRejectShareApiVersion> get values => _$federationRejectShareApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static FederationRejectShareApiVersion valueOf(String name) => _$valueOfFederationRejectShareApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for FederationRejectShareApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<FederationRejectShareApiVersion> get serializer =>
      const _$FederationRejectShareApiVersionSerializer();
}

class _$FederationRejectShareApiVersionSerializer implements PrimitiveSerializer<FederationRejectShareApiVersion> {
  const _$FederationRejectShareApiVersionSerializer();

  static const Map<FederationRejectShareApiVersion, Object> _toWire = <FederationRejectShareApiVersion, Object>{
    FederationRejectShareApiVersion.v1: 'v1',
  };

  static const Map<Object, FederationRejectShareApiVersion> _fromWire = <Object, FederationRejectShareApiVersion>{
    'v1': FederationRejectShareApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [FederationRejectShareApiVersion];

  @override
  String get wireName => 'FederationRejectShareApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    FederationRejectShareApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  FederationRejectShareApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $FederationRejectShareResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FederationRejectShareResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FederationRejectShareResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class FederationRejectShareResponseApplicationJson_Ocs
    implements
        $FederationRejectShareResponseApplicationJson_OcsInterface,
        Built<FederationRejectShareResponseApplicationJson_Ocs,
            FederationRejectShareResponseApplicationJson_OcsBuilder> {
  /// Creates a new FederationRejectShareResponseApplicationJson_Ocs object using the builder pattern.
  factory FederationRejectShareResponseApplicationJson_Ocs([
    void Function(FederationRejectShareResponseApplicationJson_OcsBuilder)? b,
  ]) = _$FederationRejectShareResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const FederationRejectShareResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FederationRejectShareResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FederationRejectShareResponseApplicationJson_Ocs.
  static Serializer<FederationRejectShareResponseApplicationJson_Ocs> get serializer =>
      _$federationRejectShareResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FederationRejectShareResponseApplicationJson_OcsBuilder b) {
    $FederationRejectShareResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FederationRejectShareResponseApplicationJson_OcsBuilder b) {
    $FederationRejectShareResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FederationRejectShareResponseApplicationJsonInterface {
  FederationRejectShareResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FederationRejectShareResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FederationRejectShareResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class FederationRejectShareResponseApplicationJson
    implements
        $FederationRejectShareResponseApplicationJsonInterface,
        Built<FederationRejectShareResponseApplicationJson, FederationRejectShareResponseApplicationJsonBuilder> {
  /// Creates a new FederationRejectShareResponseApplicationJson object using the builder pattern.
  factory FederationRejectShareResponseApplicationJson([
    void Function(FederationRejectShareResponseApplicationJsonBuilder)? b,
  ]) = _$FederationRejectShareResponseApplicationJson;

  // coverage:ignore-start
  const FederationRejectShareResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FederationRejectShareResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FederationRejectShareResponseApplicationJson.
  static Serializer<FederationRejectShareResponseApplicationJson> get serializer =>
      _$federationRejectShareResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FederationRejectShareResponseApplicationJsonBuilder b) {
    $FederationRejectShareResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FederationRejectShareResponseApplicationJsonBuilder b) {
    $FederationRejectShareResponseApplicationJsonInterface._validate(b);
  }
}

class FederationGetSharesApiVersion extends EnumClass {
  const FederationGetSharesApiVersion._(super.name);

  /// `v1`
  static const FederationGetSharesApiVersion v1 = _$federationGetSharesApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<FederationGetSharesApiVersion> get values => _$federationGetSharesApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static FederationGetSharesApiVersion valueOf(String name) => _$valueOfFederationGetSharesApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for FederationGetSharesApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<FederationGetSharesApiVersion> get serializer => const _$FederationGetSharesApiVersionSerializer();
}

class _$FederationGetSharesApiVersionSerializer implements PrimitiveSerializer<FederationGetSharesApiVersion> {
  const _$FederationGetSharesApiVersionSerializer();

  static const Map<FederationGetSharesApiVersion, Object> _toWire = <FederationGetSharesApiVersion, Object>{
    FederationGetSharesApiVersion.v1: 'v1',
  };

  static const Map<Object, FederationGetSharesApiVersion> _fromWire = <Object, FederationGetSharesApiVersion>{
    'v1': FederationGetSharesApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [FederationGetSharesApiVersion];

  @override
  String get wireName => 'FederationGetSharesApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    FederationGetSharesApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  FederationGetSharesApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $FederationInviteInterface {
  int get id;
  int get state;
  String get localCloudId;
  String get localToken;
  int get remoteAttendeeId;
  String get remoteServerUrl;
  String get remoteToken;
  String get roomName;
  String get userId;
  String get inviterCloudId;
  String get inviterDisplayName;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FederationInviteInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FederationInviteInterfaceBuilder b) {}
}

abstract class FederationInvite
    implements $FederationInviteInterface, Built<FederationInvite, FederationInviteBuilder> {
  /// Creates a new FederationInvite object using the builder pattern.
  factory FederationInvite([void Function(FederationInviteBuilder)? b]) = _$FederationInvite;

  // coverage:ignore-start
  const FederationInvite._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FederationInvite.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FederationInvite.
  static Serializer<FederationInvite> get serializer => _$federationInviteSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FederationInviteBuilder b) {
    $FederationInviteInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FederationInviteBuilder b) {
    $FederationInviteInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FederationGetSharesResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<FederationInvite> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FederationGetSharesResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FederationGetSharesResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class FederationGetSharesResponseApplicationJson_Ocs
    implements
        $FederationGetSharesResponseApplicationJson_OcsInterface,
        Built<FederationGetSharesResponseApplicationJson_Ocs, FederationGetSharesResponseApplicationJson_OcsBuilder> {
  /// Creates a new FederationGetSharesResponseApplicationJson_Ocs object using the builder pattern.
  factory FederationGetSharesResponseApplicationJson_Ocs([
    void Function(FederationGetSharesResponseApplicationJson_OcsBuilder)? b,
  ]) = _$FederationGetSharesResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const FederationGetSharesResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FederationGetSharesResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FederationGetSharesResponseApplicationJson_Ocs.
  static Serializer<FederationGetSharesResponseApplicationJson_Ocs> get serializer =>
      _$federationGetSharesResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FederationGetSharesResponseApplicationJson_OcsBuilder b) {
    $FederationGetSharesResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FederationGetSharesResponseApplicationJson_OcsBuilder b) {
    $FederationGetSharesResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FederationGetSharesResponseApplicationJsonInterface {
  FederationGetSharesResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FederationGetSharesResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FederationGetSharesResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class FederationGetSharesResponseApplicationJson
    implements
        $FederationGetSharesResponseApplicationJsonInterface,
        Built<FederationGetSharesResponseApplicationJson, FederationGetSharesResponseApplicationJsonBuilder> {
  /// Creates a new FederationGetSharesResponseApplicationJson object using the builder pattern.
  factory FederationGetSharesResponseApplicationJson([
    void Function(FederationGetSharesResponseApplicationJsonBuilder)? b,
  ]) = _$FederationGetSharesResponseApplicationJson;

  // coverage:ignore-start
  const FederationGetSharesResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FederationGetSharesResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FederationGetSharesResponseApplicationJson.
  static Serializer<FederationGetSharesResponseApplicationJson> get serializer =>
      _$federationGetSharesResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FederationGetSharesResponseApplicationJsonBuilder b) {
    $FederationGetSharesResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FederationGetSharesResponseApplicationJsonBuilder b) {
    $FederationGetSharesResponseApplicationJsonInterface._validate(b);
  }
}

class FilesIntegrationGetRoomByFileIdApiVersion extends EnumClass {
  const FilesIntegrationGetRoomByFileIdApiVersion._(super.name);

  /// `v1`
  static const FilesIntegrationGetRoomByFileIdApiVersion v1 = _$filesIntegrationGetRoomByFileIdApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<FilesIntegrationGetRoomByFileIdApiVersion> get values =>
      _$filesIntegrationGetRoomByFileIdApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static FilesIntegrationGetRoomByFileIdApiVersion valueOf(String name) =>
      _$valueOfFilesIntegrationGetRoomByFileIdApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for FilesIntegrationGetRoomByFileIdApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<FilesIntegrationGetRoomByFileIdApiVersion> get serializer =>
      const _$FilesIntegrationGetRoomByFileIdApiVersionSerializer();
}

class _$FilesIntegrationGetRoomByFileIdApiVersionSerializer
    implements PrimitiveSerializer<FilesIntegrationGetRoomByFileIdApiVersion> {
  const _$FilesIntegrationGetRoomByFileIdApiVersionSerializer();

  static const Map<FilesIntegrationGetRoomByFileIdApiVersion, Object> _toWire =
      <FilesIntegrationGetRoomByFileIdApiVersion, Object>{
    FilesIntegrationGetRoomByFileIdApiVersion.v1: 'v1',
  };

  static const Map<Object, FilesIntegrationGetRoomByFileIdApiVersion> _fromWire =
      <Object, FilesIntegrationGetRoomByFileIdApiVersion>{
    'v1': FilesIntegrationGetRoomByFileIdApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [FilesIntegrationGetRoomByFileIdApiVersion];

  @override
  String get wireName => 'FilesIntegrationGetRoomByFileIdApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    FilesIntegrationGetRoomByFileIdApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  FilesIntegrationGetRoomByFileIdApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_DataInterface {
  String get token;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_Data
    implements
        $FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_DataInterface,
        Built<FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_Data,
            FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_Data([
    void Function(FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_Data.
  static Serializer<FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_Data> get serializer =>
      _$filesIntegrationGetRoomByFileIdResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_DataBuilder b) {
    $FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_DataBuilder b) {
    $FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FilesIntegrationGetRoomByFileIdResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FilesIntegrationGetRoomByFileIdResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FilesIntegrationGetRoomByFileIdResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs
    implements
        $FilesIntegrationGetRoomByFileIdResponseApplicationJson_OcsInterface,
        Built<FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs,
            FilesIntegrationGetRoomByFileIdResponseApplicationJson_OcsBuilder> {
  /// Creates a new FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs object using the builder pattern.
  factory FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs([
    void Function(FilesIntegrationGetRoomByFileIdResponseApplicationJson_OcsBuilder)? b,
  ]) = _$FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs.
  static Serializer<FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs> get serializer =>
      _$filesIntegrationGetRoomByFileIdResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FilesIntegrationGetRoomByFileIdResponseApplicationJson_OcsBuilder b) {
    $FilesIntegrationGetRoomByFileIdResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FilesIntegrationGetRoomByFileIdResponseApplicationJson_OcsBuilder b) {
    $FilesIntegrationGetRoomByFileIdResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FilesIntegrationGetRoomByFileIdResponseApplicationJsonInterface {
  FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FilesIntegrationGetRoomByFileIdResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FilesIntegrationGetRoomByFileIdResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class FilesIntegrationGetRoomByFileIdResponseApplicationJson
    implements
        $FilesIntegrationGetRoomByFileIdResponseApplicationJsonInterface,
        Built<FilesIntegrationGetRoomByFileIdResponseApplicationJson,
            FilesIntegrationGetRoomByFileIdResponseApplicationJsonBuilder> {
  /// Creates a new FilesIntegrationGetRoomByFileIdResponseApplicationJson object using the builder pattern.
  factory FilesIntegrationGetRoomByFileIdResponseApplicationJson([
    void Function(FilesIntegrationGetRoomByFileIdResponseApplicationJsonBuilder)? b,
  ]) = _$FilesIntegrationGetRoomByFileIdResponseApplicationJson;

  // coverage:ignore-start
  const FilesIntegrationGetRoomByFileIdResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FilesIntegrationGetRoomByFileIdResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FilesIntegrationGetRoomByFileIdResponseApplicationJson.
  static Serializer<FilesIntegrationGetRoomByFileIdResponseApplicationJson> get serializer =>
      _$filesIntegrationGetRoomByFileIdResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FilesIntegrationGetRoomByFileIdResponseApplicationJsonBuilder b) {
    $FilesIntegrationGetRoomByFileIdResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FilesIntegrationGetRoomByFileIdResponseApplicationJsonBuilder b) {
    $FilesIntegrationGetRoomByFileIdResponseApplicationJsonInterface._validate(b);
  }
}

class FilesIntegrationGetRoomByShareTokenApiVersion extends EnumClass {
  const FilesIntegrationGetRoomByShareTokenApiVersion._(super.name);

  /// `v1`
  static const FilesIntegrationGetRoomByShareTokenApiVersion v1 = _$filesIntegrationGetRoomByShareTokenApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<FilesIntegrationGetRoomByShareTokenApiVersion> get values =>
      _$filesIntegrationGetRoomByShareTokenApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static FilesIntegrationGetRoomByShareTokenApiVersion valueOf(String name) =>
      _$valueOfFilesIntegrationGetRoomByShareTokenApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for FilesIntegrationGetRoomByShareTokenApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<FilesIntegrationGetRoomByShareTokenApiVersion> get serializer =>
      const _$FilesIntegrationGetRoomByShareTokenApiVersionSerializer();
}

class _$FilesIntegrationGetRoomByShareTokenApiVersionSerializer
    implements PrimitiveSerializer<FilesIntegrationGetRoomByShareTokenApiVersion> {
  const _$FilesIntegrationGetRoomByShareTokenApiVersionSerializer();

  static const Map<FilesIntegrationGetRoomByShareTokenApiVersion, Object> _toWire =
      <FilesIntegrationGetRoomByShareTokenApiVersion, Object>{
    FilesIntegrationGetRoomByShareTokenApiVersion.v1: 'v1',
  };

  static const Map<Object, FilesIntegrationGetRoomByShareTokenApiVersion> _fromWire =
      <Object, FilesIntegrationGetRoomByShareTokenApiVersion>{
    'v1': FilesIntegrationGetRoomByShareTokenApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [FilesIntegrationGetRoomByShareTokenApiVersion];

  @override
  String get wireName => 'FilesIntegrationGetRoomByShareTokenApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    FilesIntegrationGetRoomByShareTokenApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  FilesIntegrationGetRoomByShareTokenApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_DataInterface {
  String get token;
  String get userId;
  String get userDisplayName;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_Data
    implements
        $FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_DataInterface,
        Built<FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_Data,
            FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_Data([
    void Function(FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_Data.
  static Serializer<FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_Data> get serializer =>
      _$filesIntegrationGetRoomByShareTokenResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_DataBuilder b) {
    $FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_DataBuilder b) {
    $FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FilesIntegrationGetRoomByShareTokenResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FilesIntegrationGetRoomByShareTokenResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FilesIntegrationGetRoomByShareTokenResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs
    implements
        $FilesIntegrationGetRoomByShareTokenResponseApplicationJson_OcsInterface,
        Built<FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs,
            FilesIntegrationGetRoomByShareTokenResponseApplicationJson_OcsBuilder> {
  /// Creates a new FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs object using the builder pattern.
  factory FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs([
    void Function(FilesIntegrationGetRoomByShareTokenResponseApplicationJson_OcsBuilder)? b,
  ]) = _$FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs.
  static Serializer<FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs> get serializer =>
      _$filesIntegrationGetRoomByShareTokenResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FilesIntegrationGetRoomByShareTokenResponseApplicationJson_OcsBuilder b) {
    $FilesIntegrationGetRoomByShareTokenResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FilesIntegrationGetRoomByShareTokenResponseApplicationJson_OcsBuilder b) {
    $FilesIntegrationGetRoomByShareTokenResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $FilesIntegrationGetRoomByShareTokenResponseApplicationJsonInterface {
  FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($FilesIntegrationGetRoomByShareTokenResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($FilesIntegrationGetRoomByShareTokenResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class FilesIntegrationGetRoomByShareTokenResponseApplicationJson
    implements
        $FilesIntegrationGetRoomByShareTokenResponseApplicationJsonInterface,
        Built<FilesIntegrationGetRoomByShareTokenResponseApplicationJson,
            FilesIntegrationGetRoomByShareTokenResponseApplicationJsonBuilder> {
  /// Creates a new FilesIntegrationGetRoomByShareTokenResponseApplicationJson object using the builder pattern.
  factory FilesIntegrationGetRoomByShareTokenResponseApplicationJson([
    void Function(FilesIntegrationGetRoomByShareTokenResponseApplicationJsonBuilder)? b,
  ]) = _$FilesIntegrationGetRoomByShareTokenResponseApplicationJson;

  // coverage:ignore-start
  const FilesIntegrationGetRoomByShareTokenResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory FilesIntegrationGetRoomByShareTokenResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for FilesIntegrationGetRoomByShareTokenResponseApplicationJson.
  static Serializer<FilesIntegrationGetRoomByShareTokenResponseApplicationJson> get serializer =>
      _$filesIntegrationGetRoomByShareTokenResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(FilesIntegrationGetRoomByShareTokenResponseApplicationJsonBuilder b) {
    $FilesIntegrationGetRoomByShareTokenResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(FilesIntegrationGetRoomByShareTokenResponseApplicationJsonBuilder b) {
    $FilesIntegrationGetRoomByShareTokenResponseApplicationJsonInterface._validate(b);
  }
}

class PublicShareAuthCreateRoomApiVersion extends EnumClass {
  const PublicShareAuthCreateRoomApiVersion._(super.name);

  /// `v1`
  static const PublicShareAuthCreateRoomApiVersion v1 = _$publicShareAuthCreateRoomApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<PublicShareAuthCreateRoomApiVersion> get values => _$publicShareAuthCreateRoomApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static PublicShareAuthCreateRoomApiVersion valueOf(String name) => _$valueOfPublicShareAuthCreateRoomApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for PublicShareAuthCreateRoomApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<PublicShareAuthCreateRoomApiVersion> get serializer =>
      const _$PublicShareAuthCreateRoomApiVersionSerializer();
}

class _$PublicShareAuthCreateRoomApiVersionSerializer
    implements PrimitiveSerializer<PublicShareAuthCreateRoomApiVersion> {
  const _$PublicShareAuthCreateRoomApiVersionSerializer();

  static const Map<PublicShareAuthCreateRoomApiVersion, Object> _toWire = <PublicShareAuthCreateRoomApiVersion, Object>{
    PublicShareAuthCreateRoomApiVersion.v1: 'v1',
  };

  static const Map<Object, PublicShareAuthCreateRoomApiVersion> _fromWire =
      <Object, PublicShareAuthCreateRoomApiVersion>{
    'v1': PublicShareAuthCreateRoomApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [PublicShareAuthCreateRoomApiVersion];

  @override
  String get wireName => 'PublicShareAuthCreateRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    PublicShareAuthCreateRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  PublicShareAuthCreateRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $PublicShareAuthCreateRoomResponseApplicationJson_Ocs_DataInterface {
  String get token;
  String get name;
  String get displayName;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($PublicShareAuthCreateRoomResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($PublicShareAuthCreateRoomResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class PublicShareAuthCreateRoomResponseApplicationJson_Ocs_Data
    implements
        $PublicShareAuthCreateRoomResponseApplicationJson_Ocs_DataInterface,
        Built<PublicShareAuthCreateRoomResponseApplicationJson_Ocs_Data,
            PublicShareAuthCreateRoomResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new PublicShareAuthCreateRoomResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory PublicShareAuthCreateRoomResponseApplicationJson_Ocs_Data([
    void Function(PublicShareAuthCreateRoomResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$PublicShareAuthCreateRoomResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const PublicShareAuthCreateRoomResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory PublicShareAuthCreateRoomResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for PublicShareAuthCreateRoomResponseApplicationJson_Ocs_Data.
  static Serializer<PublicShareAuthCreateRoomResponseApplicationJson_Ocs_Data> get serializer =>
      _$publicShareAuthCreateRoomResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(PublicShareAuthCreateRoomResponseApplicationJson_Ocs_DataBuilder b) {
    $PublicShareAuthCreateRoomResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(PublicShareAuthCreateRoomResponseApplicationJson_Ocs_DataBuilder b) {
    $PublicShareAuthCreateRoomResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $PublicShareAuthCreateRoomResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  PublicShareAuthCreateRoomResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($PublicShareAuthCreateRoomResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($PublicShareAuthCreateRoomResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class PublicShareAuthCreateRoomResponseApplicationJson_Ocs
    implements
        $PublicShareAuthCreateRoomResponseApplicationJson_OcsInterface,
        Built<PublicShareAuthCreateRoomResponseApplicationJson_Ocs,
            PublicShareAuthCreateRoomResponseApplicationJson_OcsBuilder> {
  /// Creates a new PublicShareAuthCreateRoomResponseApplicationJson_Ocs object using the builder pattern.
  factory PublicShareAuthCreateRoomResponseApplicationJson_Ocs([
    void Function(PublicShareAuthCreateRoomResponseApplicationJson_OcsBuilder)? b,
  ]) = _$PublicShareAuthCreateRoomResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const PublicShareAuthCreateRoomResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory PublicShareAuthCreateRoomResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for PublicShareAuthCreateRoomResponseApplicationJson_Ocs.
  static Serializer<PublicShareAuthCreateRoomResponseApplicationJson_Ocs> get serializer =>
      _$publicShareAuthCreateRoomResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(PublicShareAuthCreateRoomResponseApplicationJson_OcsBuilder b) {
    $PublicShareAuthCreateRoomResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(PublicShareAuthCreateRoomResponseApplicationJson_OcsBuilder b) {
    $PublicShareAuthCreateRoomResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $PublicShareAuthCreateRoomResponseApplicationJsonInterface {
  PublicShareAuthCreateRoomResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($PublicShareAuthCreateRoomResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($PublicShareAuthCreateRoomResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class PublicShareAuthCreateRoomResponseApplicationJson
    implements
        $PublicShareAuthCreateRoomResponseApplicationJsonInterface,
        Built<PublicShareAuthCreateRoomResponseApplicationJson,
            PublicShareAuthCreateRoomResponseApplicationJsonBuilder> {
  /// Creates a new PublicShareAuthCreateRoomResponseApplicationJson object using the builder pattern.
  factory PublicShareAuthCreateRoomResponseApplicationJson([
    void Function(PublicShareAuthCreateRoomResponseApplicationJsonBuilder)? b,
  ]) = _$PublicShareAuthCreateRoomResponseApplicationJson;

  // coverage:ignore-start
  const PublicShareAuthCreateRoomResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory PublicShareAuthCreateRoomResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for PublicShareAuthCreateRoomResponseApplicationJson.
  static Serializer<PublicShareAuthCreateRoomResponseApplicationJson> get serializer =>
      _$publicShareAuthCreateRoomResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(PublicShareAuthCreateRoomResponseApplicationJsonBuilder b) {
    $PublicShareAuthCreateRoomResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(PublicShareAuthCreateRoomResponseApplicationJsonBuilder b) {
    $PublicShareAuthCreateRoomResponseApplicationJsonInterface._validate(b);
  }
}

class GuestSetDisplayNameApiVersion extends EnumClass {
  const GuestSetDisplayNameApiVersion._(super.name);

  /// `v1`
  static const GuestSetDisplayNameApiVersion v1 = _$guestSetDisplayNameApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<GuestSetDisplayNameApiVersion> get values => _$guestSetDisplayNameApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static GuestSetDisplayNameApiVersion valueOf(String name) => _$valueOfGuestSetDisplayNameApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for GuestSetDisplayNameApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<GuestSetDisplayNameApiVersion> get serializer => const _$GuestSetDisplayNameApiVersionSerializer();
}

class _$GuestSetDisplayNameApiVersionSerializer implements PrimitiveSerializer<GuestSetDisplayNameApiVersion> {
  const _$GuestSetDisplayNameApiVersionSerializer();

  static const Map<GuestSetDisplayNameApiVersion, Object> _toWire = <GuestSetDisplayNameApiVersion, Object>{
    GuestSetDisplayNameApiVersion.v1: 'v1',
  };

  static const Map<Object, GuestSetDisplayNameApiVersion> _fromWire = <Object, GuestSetDisplayNameApiVersion>{
    'v1': GuestSetDisplayNameApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [GuestSetDisplayNameApiVersion];

  @override
  String get wireName => 'GuestSetDisplayNameApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    GuestSetDisplayNameApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  GuestSetDisplayNameApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $GuestSetDisplayNameResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($GuestSetDisplayNameResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($GuestSetDisplayNameResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class GuestSetDisplayNameResponseApplicationJson_Ocs
    implements
        $GuestSetDisplayNameResponseApplicationJson_OcsInterface,
        Built<GuestSetDisplayNameResponseApplicationJson_Ocs, GuestSetDisplayNameResponseApplicationJson_OcsBuilder> {
  /// Creates a new GuestSetDisplayNameResponseApplicationJson_Ocs object using the builder pattern.
  factory GuestSetDisplayNameResponseApplicationJson_Ocs([
    void Function(GuestSetDisplayNameResponseApplicationJson_OcsBuilder)? b,
  ]) = _$GuestSetDisplayNameResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const GuestSetDisplayNameResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory GuestSetDisplayNameResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for GuestSetDisplayNameResponseApplicationJson_Ocs.
  static Serializer<GuestSetDisplayNameResponseApplicationJson_Ocs> get serializer =>
      _$guestSetDisplayNameResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(GuestSetDisplayNameResponseApplicationJson_OcsBuilder b) {
    $GuestSetDisplayNameResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(GuestSetDisplayNameResponseApplicationJson_OcsBuilder b) {
    $GuestSetDisplayNameResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $GuestSetDisplayNameResponseApplicationJsonInterface {
  GuestSetDisplayNameResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($GuestSetDisplayNameResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($GuestSetDisplayNameResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class GuestSetDisplayNameResponseApplicationJson
    implements
        $GuestSetDisplayNameResponseApplicationJsonInterface,
        Built<GuestSetDisplayNameResponseApplicationJson, GuestSetDisplayNameResponseApplicationJsonBuilder> {
  /// Creates a new GuestSetDisplayNameResponseApplicationJson object using the builder pattern.
  factory GuestSetDisplayNameResponseApplicationJson([
    void Function(GuestSetDisplayNameResponseApplicationJsonBuilder)? b,
  ]) = _$GuestSetDisplayNameResponseApplicationJson;

  // coverage:ignore-start
  const GuestSetDisplayNameResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory GuestSetDisplayNameResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for GuestSetDisplayNameResponseApplicationJson.
  static Serializer<GuestSetDisplayNameResponseApplicationJson> get serializer =>
      _$guestSetDisplayNameResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(GuestSetDisplayNameResponseApplicationJsonBuilder b) {
    $GuestSetDisplayNameResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(GuestSetDisplayNameResponseApplicationJsonBuilder b) {
    $GuestSetDisplayNameResponseApplicationJsonInterface._validate(b);
  }
}

class HostedSignalingServerRequestTrialApiVersion extends EnumClass {
  const HostedSignalingServerRequestTrialApiVersion._(super.name);

  /// `v1`
  static const HostedSignalingServerRequestTrialApiVersion v1 = _$hostedSignalingServerRequestTrialApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<HostedSignalingServerRequestTrialApiVersion> get values =>
      _$hostedSignalingServerRequestTrialApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static HostedSignalingServerRequestTrialApiVersion valueOf(String name) =>
      _$valueOfHostedSignalingServerRequestTrialApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for HostedSignalingServerRequestTrialApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<HostedSignalingServerRequestTrialApiVersion> get serializer =>
      const _$HostedSignalingServerRequestTrialApiVersionSerializer();
}

class _$HostedSignalingServerRequestTrialApiVersionSerializer
    implements PrimitiveSerializer<HostedSignalingServerRequestTrialApiVersion> {
  const _$HostedSignalingServerRequestTrialApiVersionSerializer();

  static const Map<HostedSignalingServerRequestTrialApiVersion, Object> _toWire =
      <HostedSignalingServerRequestTrialApiVersion, Object>{
    HostedSignalingServerRequestTrialApiVersion.v1: 'v1',
  };

  static const Map<Object, HostedSignalingServerRequestTrialApiVersion> _fromWire =
      <Object, HostedSignalingServerRequestTrialApiVersion>{
    'v1': HostedSignalingServerRequestTrialApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [HostedSignalingServerRequestTrialApiVersion];

  @override
  String get wireName => 'HostedSignalingServerRequestTrialApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    HostedSignalingServerRequestTrialApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  HostedSignalingServerRequestTrialApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $HostedSignalingServerRequestTrialResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltMap<String, JsonObject> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($HostedSignalingServerRequestTrialResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($HostedSignalingServerRequestTrialResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class HostedSignalingServerRequestTrialResponseApplicationJson_Ocs
    implements
        $HostedSignalingServerRequestTrialResponseApplicationJson_OcsInterface,
        Built<HostedSignalingServerRequestTrialResponseApplicationJson_Ocs,
            HostedSignalingServerRequestTrialResponseApplicationJson_OcsBuilder> {
  /// Creates a new HostedSignalingServerRequestTrialResponseApplicationJson_Ocs object using the builder pattern.
  factory HostedSignalingServerRequestTrialResponseApplicationJson_Ocs([
    void Function(HostedSignalingServerRequestTrialResponseApplicationJson_OcsBuilder)? b,
  ]) = _$HostedSignalingServerRequestTrialResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const HostedSignalingServerRequestTrialResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory HostedSignalingServerRequestTrialResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for HostedSignalingServerRequestTrialResponseApplicationJson_Ocs.
  static Serializer<HostedSignalingServerRequestTrialResponseApplicationJson_Ocs> get serializer =>
      _$hostedSignalingServerRequestTrialResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(HostedSignalingServerRequestTrialResponseApplicationJson_OcsBuilder b) {
    $HostedSignalingServerRequestTrialResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(HostedSignalingServerRequestTrialResponseApplicationJson_OcsBuilder b) {
    $HostedSignalingServerRequestTrialResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $HostedSignalingServerRequestTrialResponseApplicationJsonInterface {
  HostedSignalingServerRequestTrialResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($HostedSignalingServerRequestTrialResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($HostedSignalingServerRequestTrialResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class HostedSignalingServerRequestTrialResponseApplicationJson
    implements
        $HostedSignalingServerRequestTrialResponseApplicationJsonInterface,
        Built<HostedSignalingServerRequestTrialResponseApplicationJson,
            HostedSignalingServerRequestTrialResponseApplicationJsonBuilder> {
  /// Creates a new HostedSignalingServerRequestTrialResponseApplicationJson object using the builder pattern.
  factory HostedSignalingServerRequestTrialResponseApplicationJson([
    void Function(HostedSignalingServerRequestTrialResponseApplicationJsonBuilder)? b,
  ]) = _$HostedSignalingServerRequestTrialResponseApplicationJson;

  // coverage:ignore-start
  const HostedSignalingServerRequestTrialResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory HostedSignalingServerRequestTrialResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for HostedSignalingServerRequestTrialResponseApplicationJson.
  static Serializer<HostedSignalingServerRequestTrialResponseApplicationJson> get serializer =>
      _$hostedSignalingServerRequestTrialResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(HostedSignalingServerRequestTrialResponseApplicationJsonBuilder b) {
    $HostedSignalingServerRequestTrialResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(HostedSignalingServerRequestTrialResponseApplicationJsonBuilder b) {
    $HostedSignalingServerRequestTrialResponseApplicationJsonInterface._validate(b);
  }
}

class HostedSignalingServerDeleteAccountApiVersion extends EnumClass {
  const HostedSignalingServerDeleteAccountApiVersion._(super.name);

  /// `v1`
  static const HostedSignalingServerDeleteAccountApiVersion v1 = _$hostedSignalingServerDeleteAccountApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<HostedSignalingServerDeleteAccountApiVersion> get values =>
      _$hostedSignalingServerDeleteAccountApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static HostedSignalingServerDeleteAccountApiVersion valueOf(String name) =>
      _$valueOfHostedSignalingServerDeleteAccountApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for HostedSignalingServerDeleteAccountApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<HostedSignalingServerDeleteAccountApiVersion> get serializer =>
      const _$HostedSignalingServerDeleteAccountApiVersionSerializer();
}

class _$HostedSignalingServerDeleteAccountApiVersionSerializer
    implements PrimitiveSerializer<HostedSignalingServerDeleteAccountApiVersion> {
  const _$HostedSignalingServerDeleteAccountApiVersionSerializer();

  static const Map<HostedSignalingServerDeleteAccountApiVersion, Object> _toWire =
      <HostedSignalingServerDeleteAccountApiVersion, Object>{
    HostedSignalingServerDeleteAccountApiVersion.v1: 'v1',
  };

  static const Map<Object, HostedSignalingServerDeleteAccountApiVersion> _fromWire =
      <Object, HostedSignalingServerDeleteAccountApiVersion>{
    'v1': HostedSignalingServerDeleteAccountApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [HostedSignalingServerDeleteAccountApiVersion];

  @override
  String get wireName => 'HostedSignalingServerDeleteAccountApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    HostedSignalingServerDeleteAccountApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  HostedSignalingServerDeleteAccountApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class SignalingPullMessagesApiVersion extends EnumClass {
  const SignalingPullMessagesApiVersion._(super.name);

  /// `v3`
  static const SignalingPullMessagesApiVersion v3 = _$signalingPullMessagesApiVersionV3;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<SignalingPullMessagesApiVersion> get values => _$signalingPullMessagesApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static SignalingPullMessagesApiVersion valueOf(String name) => _$valueOfSignalingPullMessagesApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for SignalingPullMessagesApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<SignalingPullMessagesApiVersion> get serializer =>
      const _$SignalingPullMessagesApiVersionSerializer();
}

class _$SignalingPullMessagesApiVersionSerializer implements PrimitiveSerializer<SignalingPullMessagesApiVersion> {
  const _$SignalingPullMessagesApiVersionSerializer();

  static const Map<SignalingPullMessagesApiVersion, Object> _toWire = <SignalingPullMessagesApiVersion, Object>{
    SignalingPullMessagesApiVersion.v3: 'v3',
  };

  static const Map<Object, SignalingPullMessagesApiVersion> _fromWire = <Object, SignalingPullMessagesApiVersion>{
    'v3': SignalingPullMessagesApiVersion.v3,
  };

  @override
  Iterable<Type> get types => const [SignalingPullMessagesApiVersion];

  @override
  String get wireName => 'SignalingPullMessagesApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    SignalingPullMessagesApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  SignalingPullMessagesApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingSessionInterface {
  int get inCall;
  int get lastPing;
  int get participantPermissions;
  int get roomId;
  String get sessionId;
  String get userId;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SignalingSessionInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SignalingSessionInterfaceBuilder b) {}
}

abstract class SignalingSession
    implements $SignalingSessionInterface, Built<SignalingSession, SignalingSessionBuilder> {
  /// Creates a new SignalingSession object using the builder pattern.
  factory SignalingSession([void Function(SignalingSessionBuilder)? b]) = _$SignalingSession;

  // coverage:ignore-start
  const SignalingSession._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SignalingSession.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SignalingSession.
  static Serializer<SignalingSession> get serializer => _$signalingSessionSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SignalingSessionBuilder b) {
    $SignalingSessionInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SignalingSessionBuilder b) {
    $SignalingSessionInterface._validate(b);
  }
}

typedef SignalingPullMessagesResponseApplicationJson_Ocs_Data_Data = ({
  BuiltList<SignalingSession>? builtListSignalingSession,
  String? string
});

@BuiltValue(instantiable: false)
abstract interface class $SignalingPullMessagesResponseApplicationJson_Ocs_DataInterface {
  String get type;
  SignalingPullMessagesResponseApplicationJson_Ocs_Data_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SignalingPullMessagesResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SignalingPullMessagesResponseApplicationJson_Ocs_DataInterfaceBuilder b) {
    b.data?.validateOneOf();
  }
}

abstract class SignalingPullMessagesResponseApplicationJson_Ocs_Data
    implements
        $SignalingPullMessagesResponseApplicationJson_Ocs_DataInterface,
        Built<SignalingPullMessagesResponseApplicationJson_Ocs_Data,
            SignalingPullMessagesResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new SignalingPullMessagesResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory SignalingPullMessagesResponseApplicationJson_Ocs_Data([
    void Function(SignalingPullMessagesResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$SignalingPullMessagesResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const SignalingPullMessagesResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SignalingPullMessagesResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SignalingPullMessagesResponseApplicationJson_Ocs_Data.
  static Serializer<SignalingPullMessagesResponseApplicationJson_Ocs_Data> get serializer =>
      _$signalingPullMessagesResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SignalingPullMessagesResponseApplicationJson_Ocs_DataBuilder b) {
    $SignalingPullMessagesResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SignalingPullMessagesResponseApplicationJson_Ocs_DataBuilder b) {
    $SignalingPullMessagesResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingPullMessagesResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<SignalingPullMessagesResponseApplicationJson_Ocs_Data> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SignalingPullMessagesResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SignalingPullMessagesResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class SignalingPullMessagesResponseApplicationJson_Ocs
    implements
        $SignalingPullMessagesResponseApplicationJson_OcsInterface,
        Built<SignalingPullMessagesResponseApplicationJson_Ocs,
            SignalingPullMessagesResponseApplicationJson_OcsBuilder> {
  /// Creates a new SignalingPullMessagesResponseApplicationJson_Ocs object using the builder pattern.
  factory SignalingPullMessagesResponseApplicationJson_Ocs([
    void Function(SignalingPullMessagesResponseApplicationJson_OcsBuilder)? b,
  ]) = _$SignalingPullMessagesResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const SignalingPullMessagesResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SignalingPullMessagesResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SignalingPullMessagesResponseApplicationJson_Ocs.
  static Serializer<SignalingPullMessagesResponseApplicationJson_Ocs> get serializer =>
      _$signalingPullMessagesResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SignalingPullMessagesResponseApplicationJson_OcsBuilder b) {
    $SignalingPullMessagesResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SignalingPullMessagesResponseApplicationJson_OcsBuilder b) {
    $SignalingPullMessagesResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingPullMessagesResponseApplicationJsonInterface {
  SignalingPullMessagesResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SignalingPullMessagesResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SignalingPullMessagesResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class SignalingPullMessagesResponseApplicationJson
    implements
        $SignalingPullMessagesResponseApplicationJsonInterface,
        Built<SignalingPullMessagesResponseApplicationJson, SignalingPullMessagesResponseApplicationJsonBuilder> {
  /// Creates a new SignalingPullMessagesResponseApplicationJson object using the builder pattern.
  factory SignalingPullMessagesResponseApplicationJson([
    void Function(SignalingPullMessagesResponseApplicationJsonBuilder)? b,
  ]) = _$SignalingPullMessagesResponseApplicationJson;

  // coverage:ignore-start
  const SignalingPullMessagesResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SignalingPullMessagesResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SignalingPullMessagesResponseApplicationJson.
  static Serializer<SignalingPullMessagesResponseApplicationJson> get serializer =>
      _$signalingPullMessagesResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SignalingPullMessagesResponseApplicationJsonBuilder b) {
    $SignalingPullMessagesResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SignalingPullMessagesResponseApplicationJsonBuilder b) {
    $SignalingPullMessagesResponseApplicationJsonInterface._validate(b);
  }
}

class SignalingSendMessagesApiVersion extends EnumClass {
  const SignalingSendMessagesApiVersion._(super.name);

  /// `v3`
  static const SignalingSendMessagesApiVersion v3 = _$signalingSendMessagesApiVersionV3;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<SignalingSendMessagesApiVersion> get values => _$signalingSendMessagesApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static SignalingSendMessagesApiVersion valueOf(String name) => _$valueOfSignalingSendMessagesApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for SignalingSendMessagesApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<SignalingSendMessagesApiVersion> get serializer =>
      const _$SignalingSendMessagesApiVersionSerializer();
}

class _$SignalingSendMessagesApiVersionSerializer implements PrimitiveSerializer<SignalingSendMessagesApiVersion> {
  const _$SignalingSendMessagesApiVersionSerializer();

  static const Map<SignalingSendMessagesApiVersion, Object> _toWire = <SignalingSendMessagesApiVersion, Object>{
    SignalingSendMessagesApiVersion.v3: 'v3',
  };

  static const Map<Object, SignalingSendMessagesApiVersion> _fromWire = <Object, SignalingSendMessagesApiVersion>{
    'v3': SignalingSendMessagesApiVersion.v3,
  };

  @override
  Iterable<Type> get types => const [SignalingSendMessagesApiVersion];

  @override
  String get wireName => 'SignalingSendMessagesApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    SignalingSendMessagesApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  SignalingSendMessagesApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingSendMessagesResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SignalingSendMessagesResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SignalingSendMessagesResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class SignalingSendMessagesResponseApplicationJson_Ocs
    implements
        $SignalingSendMessagesResponseApplicationJson_OcsInterface,
        Built<SignalingSendMessagesResponseApplicationJson_Ocs,
            SignalingSendMessagesResponseApplicationJson_OcsBuilder> {
  /// Creates a new SignalingSendMessagesResponseApplicationJson_Ocs object using the builder pattern.
  factory SignalingSendMessagesResponseApplicationJson_Ocs([
    void Function(SignalingSendMessagesResponseApplicationJson_OcsBuilder)? b,
  ]) = _$SignalingSendMessagesResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const SignalingSendMessagesResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SignalingSendMessagesResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SignalingSendMessagesResponseApplicationJson_Ocs.
  static Serializer<SignalingSendMessagesResponseApplicationJson_Ocs> get serializer =>
      _$signalingSendMessagesResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SignalingSendMessagesResponseApplicationJson_OcsBuilder b) {
    $SignalingSendMessagesResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SignalingSendMessagesResponseApplicationJson_OcsBuilder b) {
    $SignalingSendMessagesResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingSendMessagesResponseApplicationJsonInterface {
  SignalingSendMessagesResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SignalingSendMessagesResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SignalingSendMessagesResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class SignalingSendMessagesResponseApplicationJson
    implements
        $SignalingSendMessagesResponseApplicationJsonInterface,
        Built<SignalingSendMessagesResponseApplicationJson, SignalingSendMessagesResponseApplicationJsonBuilder> {
  /// Creates a new SignalingSendMessagesResponseApplicationJson object using the builder pattern.
  factory SignalingSendMessagesResponseApplicationJson([
    void Function(SignalingSendMessagesResponseApplicationJsonBuilder)? b,
  ]) = _$SignalingSendMessagesResponseApplicationJson;

  // coverage:ignore-start
  const SignalingSendMessagesResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SignalingSendMessagesResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SignalingSendMessagesResponseApplicationJson.
  static Serializer<SignalingSendMessagesResponseApplicationJson> get serializer =>
      _$signalingSendMessagesResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SignalingSendMessagesResponseApplicationJsonBuilder b) {
    $SignalingSendMessagesResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SignalingSendMessagesResponseApplicationJsonBuilder b) {
    $SignalingSendMessagesResponseApplicationJsonInterface._validate(b);
  }
}

class MatterbridgeGetBridgeOfRoomApiVersion extends EnumClass {
  const MatterbridgeGetBridgeOfRoomApiVersion._(super.name);

  /// `v1`
  static const MatterbridgeGetBridgeOfRoomApiVersion v1 = _$matterbridgeGetBridgeOfRoomApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<MatterbridgeGetBridgeOfRoomApiVersion> get values => _$matterbridgeGetBridgeOfRoomApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static MatterbridgeGetBridgeOfRoomApiVersion valueOf(String name) =>
      _$valueOfMatterbridgeGetBridgeOfRoomApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for MatterbridgeGetBridgeOfRoomApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<MatterbridgeGetBridgeOfRoomApiVersion> get serializer =>
      const _$MatterbridgeGetBridgeOfRoomApiVersionSerializer();
}

class _$MatterbridgeGetBridgeOfRoomApiVersionSerializer
    implements PrimitiveSerializer<MatterbridgeGetBridgeOfRoomApiVersion> {
  const _$MatterbridgeGetBridgeOfRoomApiVersionSerializer();

  static const Map<MatterbridgeGetBridgeOfRoomApiVersion, Object> _toWire =
      <MatterbridgeGetBridgeOfRoomApiVersion, Object>{
    MatterbridgeGetBridgeOfRoomApiVersion.v1: 'v1',
  };

  static const Map<Object, MatterbridgeGetBridgeOfRoomApiVersion> _fromWire =
      <Object, MatterbridgeGetBridgeOfRoomApiVersion>{
    'v1': MatterbridgeGetBridgeOfRoomApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [MatterbridgeGetBridgeOfRoomApiVersion];

  @override
  String get wireName => 'MatterbridgeGetBridgeOfRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    MatterbridgeGetBridgeOfRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  MatterbridgeGetBridgeOfRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeInterface {
  bool get enabled;
  BuiltList<BuiltMap<String, JsonObject>> get parts;
  int get pid;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($MatterbridgeInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($MatterbridgeInterfaceBuilder b) {}
}

abstract class Matterbridge implements $MatterbridgeInterface, Built<Matterbridge, MatterbridgeBuilder> {
  /// Creates a new Matterbridge object using the builder pattern.
  factory Matterbridge([void Function(MatterbridgeBuilder)? b]) = _$Matterbridge;

  // coverage:ignore-start
  const Matterbridge._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory Matterbridge.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for Matterbridge.
  static Serializer<Matterbridge> get serializer => _$matterbridgeSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(MatterbridgeBuilder b) {
    $MatterbridgeInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(MatterbridgeBuilder b) {
    $MatterbridgeInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeProcessStateInterface {
  String get log;
  bool get running;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($MatterbridgeProcessStateInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($MatterbridgeProcessStateInterfaceBuilder b) {}
}

abstract class MatterbridgeProcessState
    implements $MatterbridgeProcessStateInterface, Built<MatterbridgeProcessState, MatterbridgeProcessStateBuilder> {
  /// Creates a new MatterbridgeProcessState object using the builder pattern.
  factory MatterbridgeProcessState([void Function(MatterbridgeProcessStateBuilder)? b]) = _$MatterbridgeProcessState;

  // coverage:ignore-start
  const MatterbridgeProcessState._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory MatterbridgeProcessState.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for MatterbridgeProcessState.
  static Serializer<MatterbridgeProcessState> get serializer => _$matterbridgeProcessStateSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(MatterbridgeProcessStateBuilder b) {
    $MatterbridgeProcessStateInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(MatterbridgeProcessStateBuilder b) {
    $MatterbridgeProcessStateInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeWithProcessStateInterface
    implements $MatterbridgeInterface, $MatterbridgeProcessStateInterface {
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($MatterbridgeWithProcessStateInterfaceBuilder b) {
    $MatterbridgeInterface._defaults(b);
    $MatterbridgeProcessStateInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($MatterbridgeWithProcessStateInterfaceBuilder b) {
    $MatterbridgeInterface._validate(b);
    $MatterbridgeProcessStateInterface._validate(b);
  }
}

abstract class MatterbridgeWithProcessState
    implements
        $MatterbridgeWithProcessStateInterface,
        Built<MatterbridgeWithProcessState, MatterbridgeWithProcessStateBuilder> {
  /// Creates a new MatterbridgeWithProcessState object using the builder pattern.
  factory MatterbridgeWithProcessState([void Function(MatterbridgeWithProcessStateBuilder)? b]) =
      _$MatterbridgeWithProcessState;

  // coverage:ignore-start
  const MatterbridgeWithProcessState._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory MatterbridgeWithProcessState.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for MatterbridgeWithProcessState.
  static Serializer<MatterbridgeWithProcessState> get serializer => _$matterbridgeWithProcessStateSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(MatterbridgeWithProcessStateBuilder b) {
    $MatterbridgeWithProcessStateInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(MatterbridgeWithProcessStateBuilder b) {
    $MatterbridgeWithProcessStateInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeGetBridgeOfRoomResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  MatterbridgeWithProcessState get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($MatterbridgeGetBridgeOfRoomResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($MatterbridgeGetBridgeOfRoomResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class MatterbridgeGetBridgeOfRoomResponseApplicationJson_Ocs
    implements
        $MatterbridgeGetBridgeOfRoomResponseApplicationJson_OcsInterface,
        Built<MatterbridgeGetBridgeOfRoomResponseApplicationJson_Ocs,
            MatterbridgeGetBridgeOfRoomResponseApplicationJson_OcsBuilder> {
  /// Creates a new MatterbridgeGetBridgeOfRoomResponseApplicationJson_Ocs object using the builder pattern.
  factory MatterbridgeGetBridgeOfRoomResponseApplicationJson_Ocs([
    void Function(MatterbridgeGetBridgeOfRoomResponseApplicationJson_OcsBuilder)? b,
  ]) = _$MatterbridgeGetBridgeOfRoomResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const MatterbridgeGetBridgeOfRoomResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory MatterbridgeGetBridgeOfRoomResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for MatterbridgeGetBridgeOfRoomResponseApplicationJson_Ocs.
  static Serializer<MatterbridgeGetBridgeOfRoomResponseApplicationJson_Ocs> get serializer =>
      _$matterbridgeGetBridgeOfRoomResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(MatterbridgeGetBridgeOfRoomResponseApplicationJson_OcsBuilder b) {
    $MatterbridgeGetBridgeOfRoomResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(MatterbridgeGetBridgeOfRoomResponseApplicationJson_OcsBuilder b) {
    $MatterbridgeGetBridgeOfRoomResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeGetBridgeOfRoomResponseApplicationJsonInterface {
  MatterbridgeGetBridgeOfRoomResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($MatterbridgeGetBridgeOfRoomResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($MatterbridgeGetBridgeOfRoomResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class MatterbridgeGetBridgeOfRoomResponseApplicationJson
    implements
        $MatterbridgeGetBridgeOfRoomResponseApplicationJsonInterface,
        Built<MatterbridgeGetBridgeOfRoomResponseApplicationJson,
            MatterbridgeGetBridgeOfRoomResponseApplicationJsonBuilder> {
  /// Creates a new MatterbridgeGetBridgeOfRoomResponseApplicationJson object using the builder pattern.
  factory MatterbridgeGetBridgeOfRoomResponseApplicationJson([
    void Function(MatterbridgeGetBridgeOfRoomResponseApplicationJsonBuilder)? b,
  ]) = _$MatterbridgeGetBridgeOfRoomResponseApplicationJson;

  // coverage:ignore-start
  const MatterbridgeGetBridgeOfRoomResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory MatterbridgeGetBridgeOfRoomResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for MatterbridgeGetBridgeOfRoomResponseApplicationJson.
  static Serializer<MatterbridgeGetBridgeOfRoomResponseApplicationJson> get serializer =>
      _$matterbridgeGetBridgeOfRoomResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(MatterbridgeGetBridgeOfRoomResponseApplicationJsonBuilder b) {
    $MatterbridgeGetBridgeOfRoomResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(MatterbridgeGetBridgeOfRoomResponseApplicationJsonBuilder b) {
    $MatterbridgeGetBridgeOfRoomResponseApplicationJsonInterface._validate(b);
  }
}

class MatterbridgeEditBridgeOfRoomEnabled extends EnumClass {
  const MatterbridgeEditBridgeOfRoomEnabled._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const MatterbridgeEditBridgeOfRoomEnabled $0 = _$matterbridgeEditBridgeOfRoomEnabled$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const MatterbridgeEditBridgeOfRoomEnabled $1 = _$matterbridgeEditBridgeOfRoomEnabled$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<MatterbridgeEditBridgeOfRoomEnabled> get values => _$matterbridgeEditBridgeOfRoomEnabledValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static MatterbridgeEditBridgeOfRoomEnabled valueOf(String name) => _$valueOfMatterbridgeEditBridgeOfRoomEnabled(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for MatterbridgeEditBridgeOfRoomEnabled.
  @BuiltValueSerializer(custom: true)
  static Serializer<MatterbridgeEditBridgeOfRoomEnabled> get serializer =>
      const _$MatterbridgeEditBridgeOfRoomEnabledSerializer();
}

class _$MatterbridgeEditBridgeOfRoomEnabledSerializer
    implements PrimitiveSerializer<MatterbridgeEditBridgeOfRoomEnabled> {
  const _$MatterbridgeEditBridgeOfRoomEnabledSerializer();

  static const Map<MatterbridgeEditBridgeOfRoomEnabled, Object> _toWire = <MatterbridgeEditBridgeOfRoomEnabled, Object>{
    MatterbridgeEditBridgeOfRoomEnabled.$0: 0,
    MatterbridgeEditBridgeOfRoomEnabled.$1: 1,
  };

  static const Map<Object, MatterbridgeEditBridgeOfRoomEnabled> _fromWire =
      <Object, MatterbridgeEditBridgeOfRoomEnabled>{
    0: MatterbridgeEditBridgeOfRoomEnabled.$0,
    1: MatterbridgeEditBridgeOfRoomEnabled.$1,
  };

  @override
  Iterable<Type> get types => const [MatterbridgeEditBridgeOfRoomEnabled];

  @override
  String get wireName => 'MatterbridgeEditBridgeOfRoomEnabled';

  @override
  Object serialize(
    Serializers serializers,
    MatterbridgeEditBridgeOfRoomEnabled object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  MatterbridgeEditBridgeOfRoomEnabled deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class MatterbridgeEditBridgeOfRoomApiVersion extends EnumClass {
  const MatterbridgeEditBridgeOfRoomApiVersion._(super.name);

  /// `v1`
  static const MatterbridgeEditBridgeOfRoomApiVersion v1 = _$matterbridgeEditBridgeOfRoomApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<MatterbridgeEditBridgeOfRoomApiVersion> get values => _$matterbridgeEditBridgeOfRoomApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static MatterbridgeEditBridgeOfRoomApiVersion valueOf(String name) =>
      _$valueOfMatterbridgeEditBridgeOfRoomApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for MatterbridgeEditBridgeOfRoomApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<MatterbridgeEditBridgeOfRoomApiVersion> get serializer =>
      const _$MatterbridgeEditBridgeOfRoomApiVersionSerializer();
}

class _$MatterbridgeEditBridgeOfRoomApiVersionSerializer
    implements PrimitiveSerializer<MatterbridgeEditBridgeOfRoomApiVersion> {
  const _$MatterbridgeEditBridgeOfRoomApiVersionSerializer();

  static const Map<MatterbridgeEditBridgeOfRoomApiVersion, Object> _toWire =
      <MatterbridgeEditBridgeOfRoomApiVersion, Object>{
    MatterbridgeEditBridgeOfRoomApiVersion.v1: 'v1',
  };

  static const Map<Object, MatterbridgeEditBridgeOfRoomApiVersion> _fromWire =
      <Object, MatterbridgeEditBridgeOfRoomApiVersion>{
    'v1': MatterbridgeEditBridgeOfRoomApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [MatterbridgeEditBridgeOfRoomApiVersion];

  @override
  String get wireName => 'MatterbridgeEditBridgeOfRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    MatterbridgeEditBridgeOfRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  MatterbridgeEditBridgeOfRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeEditBridgeOfRoomResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  MatterbridgeProcessState get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($MatterbridgeEditBridgeOfRoomResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($MatterbridgeEditBridgeOfRoomResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class MatterbridgeEditBridgeOfRoomResponseApplicationJson_Ocs
    implements
        $MatterbridgeEditBridgeOfRoomResponseApplicationJson_OcsInterface,
        Built<MatterbridgeEditBridgeOfRoomResponseApplicationJson_Ocs,
            MatterbridgeEditBridgeOfRoomResponseApplicationJson_OcsBuilder> {
  /// Creates a new MatterbridgeEditBridgeOfRoomResponseApplicationJson_Ocs object using the builder pattern.
  factory MatterbridgeEditBridgeOfRoomResponseApplicationJson_Ocs([
    void Function(MatterbridgeEditBridgeOfRoomResponseApplicationJson_OcsBuilder)? b,
  ]) = _$MatterbridgeEditBridgeOfRoomResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const MatterbridgeEditBridgeOfRoomResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory MatterbridgeEditBridgeOfRoomResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for MatterbridgeEditBridgeOfRoomResponseApplicationJson_Ocs.
  static Serializer<MatterbridgeEditBridgeOfRoomResponseApplicationJson_Ocs> get serializer =>
      _$matterbridgeEditBridgeOfRoomResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(MatterbridgeEditBridgeOfRoomResponseApplicationJson_OcsBuilder b) {
    $MatterbridgeEditBridgeOfRoomResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(MatterbridgeEditBridgeOfRoomResponseApplicationJson_OcsBuilder b) {
    $MatterbridgeEditBridgeOfRoomResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeEditBridgeOfRoomResponseApplicationJsonInterface {
  MatterbridgeEditBridgeOfRoomResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($MatterbridgeEditBridgeOfRoomResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($MatterbridgeEditBridgeOfRoomResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class MatterbridgeEditBridgeOfRoomResponseApplicationJson
    implements
        $MatterbridgeEditBridgeOfRoomResponseApplicationJsonInterface,
        Built<MatterbridgeEditBridgeOfRoomResponseApplicationJson,
            MatterbridgeEditBridgeOfRoomResponseApplicationJsonBuilder> {
  /// Creates a new MatterbridgeEditBridgeOfRoomResponseApplicationJson object using the builder pattern.
  factory MatterbridgeEditBridgeOfRoomResponseApplicationJson([
    void Function(MatterbridgeEditBridgeOfRoomResponseApplicationJsonBuilder)? b,
  ]) = _$MatterbridgeEditBridgeOfRoomResponseApplicationJson;

  // coverage:ignore-start
  const MatterbridgeEditBridgeOfRoomResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory MatterbridgeEditBridgeOfRoomResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for MatterbridgeEditBridgeOfRoomResponseApplicationJson.
  static Serializer<MatterbridgeEditBridgeOfRoomResponseApplicationJson> get serializer =>
      _$matterbridgeEditBridgeOfRoomResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(MatterbridgeEditBridgeOfRoomResponseApplicationJsonBuilder b) {
    $MatterbridgeEditBridgeOfRoomResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(MatterbridgeEditBridgeOfRoomResponseApplicationJsonBuilder b) {
    $MatterbridgeEditBridgeOfRoomResponseApplicationJsonInterface._validate(b);
  }
}

class MatterbridgeDeleteBridgeOfRoomApiVersion extends EnumClass {
  const MatterbridgeDeleteBridgeOfRoomApiVersion._(super.name);

  /// `v1`
  static const MatterbridgeDeleteBridgeOfRoomApiVersion v1 = _$matterbridgeDeleteBridgeOfRoomApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<MatterbridgeDeleteBridgeOfRoomApiVersion> get values =>
      _$matterbridgeDeleteBridgeOfRoomApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static MatterbridgeDeleteBridgeOfRoomApiVersion valueOf(String name) =>
      _$valueOfMatterbridgeDeleteBridgeOfRoomApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for MatterbridgeDeleteBridgeOfRoomApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<MatterbridgeDeleteBridgeOfRoomApiVersion> get serializer =>
      const _$MatterbridgeDeleteBridgeOfRoomApiVersionSerializer();
}

class _$MatterbridgeDeleteBridgeOfRoomApiVersionSerializer
    implements PrimitiveSerializer<MatterbridgeDeleteBridgeOfRoomApiVersion> {
  const _$MatterbridgeDeleteBridgeOfRoomApiVersionSerializer();

  static const Map<MatterbridgeDeleteBridgeOfRoomApiVersion, Object> _toWire =
      <MatterbridgeDeleteBridgeOfRoomApiVersion, Object>{
    MatterbridgeDeleteBridgeOfRoomApiVersion.v1: 'v1',
  };

  static const Map<Object, MatterbridgeDeleteBridgeOfRoomApiVersion> _fromWire =
      <Object, MatterbridgeDeleteBridgeOfRoomApiVersion>{
    'v1': MatterbridgeDeleteBridgeOfRoomApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [MatterbridgeDeleteBridgeOfRoomApiVersion];

  @override
  String get wireName => 'MatterbridgeDeleteBridgeOfRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    MatterbridgeDeleteBridgeOfRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  MatterbridgeDeleteBridgeOfRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  bool get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_Ocs
    implements
        $MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_OcsInterface,
        Built<MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_Ocs,
            MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_OcsBuilder> {
  /// Creates a new MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_Ocs object using the builder pattern.
  factory MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_Ocs([
    void Function(MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_OcsBuilder)? b,
  ]) = _$MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_Ocs.
  static Serializer<MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_Ocs> get serializer =>
      _$matterbridgeDeleteBridgeOfRoomResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_OcsBuilder b) {
    $MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_OcsBuilder b) {
    $MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeDeleteBridgeOfRoomResponseApplicationJsonInterface {
  MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($MatterbridgeDeleteBridgeOfRoomResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($MatterbridgeDeleteBridgeOfRoomResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class MatterbridgeDeleteBridgeOfRoomResponseApplicationJson
    implements
        $MatterbridgeDeleteBridgeOfRoomResponseApplicationJsonInterface,
        Built<MatterbridgeDeleteBridgeOfRoomResponseApplicationJson,
            MatterbridgeDeleteBridgeOfRoomResponseApplicationJsonBuilder> {
  /// Creates a new MatterbridgeDeleteBridgeOfRoomResponseApplicationJson object using the builder pattern.
  factory MatterbridgeDeleteBridgeOfRoomResponseApplicationJson([
    void Function(MatterbridgeDeleteBridgeOfRoomResponseApplicationJsonBuilder)? b,
  ]) = _$MatterbridgeDeleteBridgeOfRoomResponseApplicationJson;

  // coverage:ignore-start
  const MatterbridgeDeleteBridgeOfRoomResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory MatterbridgeDeleteBridgeOfRoomResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for MatterbridgeDeleteBridgeOfRoomResponseApplicationJson.
  static Serializer<MatterbridgeDeleteBridgeOfRoomResponseApplicationJson> get serializer =>
      _$matterbridgeDeleteBridgeOfRoomResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(MatterbridgeDeleteBridgeOfRoomResponseApplicationJsonBuilder b) {
    $MatterbridgeDeleteBridgeOfRoomResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(MatterbridgeDeleteBridgeOfRoomResponseApplicationJsonBuilder b) {
    $MatterbridgeDeleteBridgeOfRoomResponseApplicationJsonInterface._validate(b);
  }
}

class MatterbridgeGetBridgeProcessStateApiVersion extends EnumClass {
  const MatterbridgeGetBridgeProcessStateApiVersion._(super.name);

  /// `v1`
  static const MatterbridgeGetBridgeProcessStateApiVersion v1 = _$matterbridgeGetBridgeProcessStateApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<MatterbridgeGetBridgeProcessStateApiVersion> get values =>
      _$matterbridgeGetBridgeProcessStateApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static MatterbridgeGetBridgeProcessStateApiVersion valueOf(String name) =>
      _$valueOfMatterbridgeGetBridgeProcessStateApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for MatterbridgeGetBridgeProcessStateApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<MatterbridgeGetBridgeProcessStateApiVersion> get serializer =>
      const _$MatterbridgeGetBridgeProcessStateApiVersionSerializer();
}

class _$MatterbridgeGetBridgeProcessStateApiVersionSerializer
    implements PrimitiveSerializer<MatterbridgeGetBridgeProcessStateApiVersion> {
  const _$MatterbridgeGetBridgeProcessStateApiVersionSerializer();

  static const Map<MatterbridgeGetBridgeProcessStateApiVersion, Object> _toWire =
      <MatterbridgeGetBridgeProcessStateApiVersion, Object>{
    MatterbridgeGetBridgeProcessStateApiVersion.v1: 'v1',
  };

  static const Map<Object, MatterbridgeGetBridgeProcessStateApiVersion> _fromWire =
      <Object, MatterbridgeGetBridgeProcessStateApiVersion>{
    'v1': MatterbridgeGetBridgeProcessStateApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [MatterbridgeGetBridgeProcessStateApiVersion];

  @override
  String get wireName => 'MatterbridgeGetBridgeProcessStateApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    MatterbridgeGetBridgeProcessStateApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  MatterbridgeGetBridgeProcessStateApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeGetBridgeProcessStateResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  MatterbridgeProcessState get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($MatterbridgeGetBridgeProcessStateResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($MatterbridgeGetBridgeProcessStateResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class MatterbridgeGetBridgeProcessStateResponseApplicationJson_Ocs
    implements
        $MatterbridgeGetBridgeProcessStateResponseApplicationJson_OcsInterface,
        Built<MatterbridgeGetBridgeProcessStateResponseApplicationJson_Ocs,
            MatterbridgeGetBridgeProcessStateResponseApplicationJson_OcsBuilder> {
  /// Creates a new MatterbridgeGetBridgeProcessStateResponseApplicationJson_Ocs object using the builder pattern.
  factory MatterbridgeGetBridgeProcessStateResponseApplicationJson_Ocs([
    void Function(MatterbridgeGetBridgeProcessStateResponseApplicationJson_OcsBuilder)? b,
  ]) = _$MatterbridgeGetBridgeProcessStateResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const MatterbridgeGetBridgeProcessStateResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory MatterbridgeGetBridgeProcessStateResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for MatterbridgeGetBridgeProcessStateResponseApplicationJson_Ocs.
  static Serializer<MatterbridgeGetBridgeProcessStateResponseApplicationJson_Ocs> get serializer =>
      _$matterbridgeGetBridgeProcessStateResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(MatterbridgeGetBridgeProcessStateResponseApplicationJson_OcsBuilder b) {
    $MatterbridgeGetBridgeProcessStateResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(MatterbridgeGetBridgeProcessStateResponseApplicationJson_OcsBuilder b) {
    $MatterbridgeGetBridgeProcessStateResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeGetBridgeProcessStateResponseApplicationJsonInterface {
  MatterbridgeGetBridgeProcessStateResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($MatterbridgeGetBridgeProcessStateResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($MatterbridgeGetBridgeProcessStateResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class MatterbridgeGetBridgeProcessStateResponseApplicationJson
    implements
        $MatterbridgeGetBridgeProcessStateResponseApplicationJsonInterface,
        Built<MatterbridgeGetBridgeProcessStateResponseApplicationJson,
            MatterbridgeGetBridgeProcessStateResponseApplicationJsonBuilder> {
  /// Creates a new MatterbridgeGetBridgeProcessStateResponseApplicationJson object using the builder pattern.
  factory MatterbridgeGetBridgeProcessStateResponseApplicationJson([
    void Function(MatterbridgeGetBridgeProcessStateResponseApplicationJsonBuilder)? b,
  ]) = _$MatterbridgeGetBridgeProcessStateResponseApplicationJson;

  // coverage:ignore-start
  const MatterbridgeGetBridgeProcessStateResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory MatterbridgeGetBridgeProcessStateResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for MatterbridgeGetBridgeProcessStateResponseApplicationJson.
  static Serializer<MatterbridgeGetBridgeProcessStateResponseApplicationJson> get serializer =>
      _$matterbridgeGetBridgeProcessStateResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(MatterbridgeGetBridgeProcessStateResponseApplicationJsonBuilder b) {
    $MatterbridgeGetBridgeProcessStateResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(MatterbridgeGetBridgeProcessStateResponseApplicationJsonBuilder b) {
    $MatterbridgeGetBridgeProcessStateResponseApplicationJsonInterface._validate(b);
  }
}

class MatterbridgeSettingsStopAllBridgesApiVersion extends EnumClass {
  const MatterbridgeSettingsStopAllBridgesApiVersion._(super.name);

  /// `v1`
  static const MatterbridgeSettingsStopAllBridgesApiVersion v1 = _$matterbridgeSettingsStopAllBridgesApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<MatterbridgeSettingsStopAllBridgesApiVersion> get values =>
      _$matterbridgeSettingsStopAllBridgesApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static MatterbridgeSettingsStopAllBridgesApiVersion valueOf(String name) =>
      _$valueOfMatterbridgeSettingsStopAllBridgesApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for MatterbridgeSettingsStopAllBridgesApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<MatterbridgeSettingsStopAllBridgesApiVersion> get serializer =>
      const _$MatterbridgeSettingsStopAllBridgesApiVersionSerializer();
}

class _$MatterbridgeSettingsStopAllBridgesApiVersionSerializer
    implements PrimitiveSerializer<MatterbridgeSettingsStopAllBridgesApiVersion> {
  const _$MatterbridgeSettingsStopAllBridgesApiVersionSerializer();

  static const Map<MatterbridgeSettingsStopAllBridgesApiVersion, Object> _toWire =
      <MatterbridgeSettingsStopAllBridgesApiVersion, Object>{
    MatterbridgeSettingsStopAllBridgesApiVersion.v1: 'v1',
  };

  static const Map<Object, MatterbridgeSettingsStopAllBridgesApiVersion> _fromWire =
      <Object, MatterbridgeSettingsStopAllBridgesApiVersion>{
    'v1': MatterbridgeSettingsStopAllBridgesApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [MatterbridgeSettingsStopAllBridgesApiVersion];

  @override
  String get wireName => 'MatterbridgeSettingsStopAllBridgesApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    MatterbridgeSettingsStopAllBridgesApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  MatterbridgeSettingsStopAllBridgesApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeSettingsStopAllBridgesResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  bool get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($MatterbridgeSettingsStopAllBridgesResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($MatterbridgeSettingsStopAllBridgesResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class MatterbridgeSettingsStopAllBridgesResponseApplicationJson_Ocs
    implements
        $MatterbridgeSettingsStopAllBridgesResponseApplicationJson_OcsInterface,
        Built<MatterbridgeSettingsStopAllBridgesResponseApplicationJson_Ocs,
            MatterbridgeSettingsStopAllBridgesResponseApplicationJson_OcsBuilder> {
  /// Creates a new MatterbridgeSettingsStopAllBridgesResponseApplicationJson_Ocs object using the builder pattern.
  factory MatterbridgeSettingsStopAllBridgesResponseApplicationJson_Ocs([
    void Function(MatterbridgeSettingsStopAllBridgesResponseApplicationJson_OcsBuilder)? b,
  ]) = _$MatterbridgeSettingsStopAllBridgesResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const MatterbridgeSettingsStopAllBridgesResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory MatterbridgeSettingsStopAllBridgesResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for MatterbridgeSettingsStopAllBridgesResponseApplicationJson_Ocs.
  static Serializer<MatterbridgeSettingsStopAllBridgesResponseApplicationJson_Ocs> get serializer =>
      _$matterbridgeSettingsStopAllBridgesResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(MatterbridgeSettingsStopAllBridgesResponseApplicationJson_OcsBuilder b) {
    $MatterbridgeSettingsStopAllBridgesResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(MatterbridgeSettingsStopAllBridgesResponseApplicationJson_OcsBuilder b) {
    $MatterbridgeSettingsStopAllBridgesResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeSettingsStopAllBridgesResponseApplicationJsonInterface {
  MatterbridgeSettingsStopAllBridgesResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($MatterbridgeSettingsStopAllBridgesResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($MatterbridgeSettingsStopAllBridgesResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class MatterbridgeSettingsStopAllBridgesResponseApplicationJson
    implements
        $MatterbridgeSettingsStopAllBridgesResponseApplicationJsonInterface,
        Built<MatterbridgeSettingsStopAllBridgesResponseApplicationJson,
            MatterbridgeSettingsStopAllBridgesResponseApplicationJsonBuilder> {
  /// Creates a new MatterbridgeSettingsStopAllBridgesResponseApplicationJson object using the builder pattern.
  factory MatterbridgeSettingsStopAllBridgesResponseApplicationJson([
    void Function(MatterbridgeSettingsStopAllBridgesResponseApplicationJsonBuilder)? b,
  ]) = _$MatterbridgeSettingsStopAllBridgesResponseApplicationJson;

  // coverage:ignore-start
  const MatterbridgeSettingsStopAllBridgesResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory MatterbridgeSettingsStopAllBridgesResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for MatterbridgeSettingsStopAllBridgesResponseApplicationJson.
  static Serializer<MatterbridgeSettingsStopAllBridgesResponseApplicationJson> get serializer =>
      _$matterbridgeSettingsStopAllBridgesResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(MatterbridgeSettingsStopAllBridgesResponseApplicationJsonBuilder b) {
    $MatterbridgeSettingsStopAllBridgesResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(MatterbridgeSettingsStopAllBridgesResponseApplicationJsonBuilder b) {
    $MatterbridgeSettingsStopAllBridgesResponseApplicationJsonInterface._validate(b);
  }
}

class MatterbridgeSettingsGetMatterbridgeVersionApiVersion extends EnumClass {
  const MatterbridgeSettingsGetMatterbridgeVersionApiVersion._(super.name);

  /// `v1`
  static const MatterbridgeSettingsGetMatterbridgeVersionApiVersion v1 =
      _$matterbridgeSettingsGetMatterbridgeVersionApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<MatterbridgeSettingsGetMatterbridgeVersionApiVersion> get values =>
      _$matterbridgeSettingsGetMatterbridgeVersionApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static MatterbridgeSettingsGetMatterbridgeVersionApiVersion valueOf(String name) =>
      _$valueOfMatterbridgeSettingsGetMatterbridgeVersionApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for MatterbridgeSettingsGetMatterbridgeVersionApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<MatterbridgeSettingsGetMatterbridgeVersionApiVersion> get serializer =>
      const _$MatterbridgeSettingsGetMatterbridgeVersionApiVersionSerializer();
}

class _$MatterbridgeSettingsGetMatterbridgeVersionApiVersionSerializer
    implements PrimitiveSerializer<MatterbridgeSettingsGetMatterbridgeVersionApiVersion> {
  const _$MatterbridgeSettingsGetMatterbridgeVersionApiVersionSerializer();

  static const Map<MatterbridgeSettingsGetMatterbridgeVersionApiVersion, Object> _toWire =
      <MatterbridgeSettingsGetMatterbridgeVersionApiVersion, Object>{
    MatterbridgeSettingsGetMatterbridgeVersionApiVersion.v1: 'v1',
  };

  static const Map<Object, MatterbridgeSettingsGetMatterbridgeVersionApiVersion> _fromWire =
      <Object, MatterbridgeSettingsGetMatterbridgeVersionApiVersion>{
    'v1': MatterbridgeSettingsGetMatterbridgeVersionApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [MatterbridgeSettingsGetMatterbridgeVersionApiVersion];

  @override
  String get wireName => 'MatterbridgeSettingsGetMatterbridgeVersionApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    MatterbridgeSettingsGetMatterbridgeVersionApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  MatterbridgeSettingsGetMatterbridgeVersionApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_DataInterface {
  String get version;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(
    $MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_DataInterfaceBuilder b,
  ) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(
    $MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_DataInterfaceBuilder b,
  ) {}
}

abstract class MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_Data
    implements
        $MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_DataInterface,
        Built<MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_Data,
            MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_Data([
    void Function(MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_Data.fromJson(
    Map<String, dynamic> json,
  ) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_Data.
  static Serializer<MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_Data> get serializer =>
      _$matterbridgeSettingsGetMatterbridgeVersionResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_DataBuilder b) {
    $MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_DataBuilder b) {
    $MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs
    implements
        $MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_OcsInterface,
        Built<MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs,
            MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_OcsBuilder> {
  /// Creates a new MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs object using the builder pattern.
  factory MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs([
    void Function(MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_OcsBuilder)? b,
  ]) = _$MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs.
  static Serializer<MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs> get serializer =>
      _$matterbridgeSettingsGetMatterbridgeVersionResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_OcsBuilder b) {
    $MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_OcsBuilder b) {
    $MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJsonInterface {
  MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson
    implements
        $MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJsonInterface,
        Built<MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson,
            MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJsonBuilder> {
  /// Creates a new MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson object using the builder pattern.
  factory MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson([
    void Function(MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJsonBuilder)? b,
  ]) = _$MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson;

  // coverage:ignore-start
  const MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson.
  static Serializer<MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson> get serializer =>
      _$matterbridgeSettingsGetMatterbridgeVersionResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJsonBuilder b) {
    $MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJsonBuilder b) {
    $MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJsonInterface._validate(b);
  }
}

class PollCreatePollResultMode extends EnumClass {
  const PollCreatePollResultMode._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const PollCreatePollResultMode $0 = _$pollCreatePollResultMode$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const PollCreatePollResultMode $1 = _$pollCreatePollResultMode$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<PollCreatePollResultMode> get values => _$pollCreatePollResultModeValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static PollCreatePollResultMode valueOf(String name) => _$valueOfPollCreatePollResultMode(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for PollCreatePollResultMode.
  @BuiltValueSerializer(custom: true)
  static Serializer<PollCreatePollResultMode> get serializer => const _$PollCreatePollResultModeSerializer();
}

class _$PollCreatePollResultModeSerializer implements PrimitiveSerializer<PollCreatePollResultMode> {
  const _$PollCreatePollResultModeSerializer();

  static const Map<PollCreatePollResultMode, Object> _toWire = <PollCreatePollResultMode, Object>{
    PollCreatePollResultMode.$0: 0,
    PollCreatePollResultMode.$1: 1,
  };

  static const Map<Object, PollCreatePollResultMode> _fromWire = <Object, PollCreatePollResultMode>{
    0: PollCreatePollResultMode.$0,
    1: PollCreatePollResultMode.$1,
  };

  @override
  Iterable<Type> get types => const [PollCreatePollResultMode];

  @override
  String get wireName => 'PollCreatePollResultMode';

  @override
  Object serialize(
    Serializers serializers,
    PollCreatePollResultMode object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  PollCreatePollResultMode deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class PollCreatePollApiVersion extends EnumClass {
  const PollCreatePollApiVersion._(super.name);

  /// `v1`
  static const PollCreatePollApiVersion v1 = _$pollCreatePollApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<PollCreatePollApiVersion> get values => _$pollCreatePollApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static PollCreatePollApiVersion valueOf(String name) => _$valueOfPollCreatePollApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for PollCreatePollApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<PollCreatePollApiVersion> get serializer => const _$PollCreatePollApiVersionSerializer();
}

class _$PollCreatePollApiVersionSerializer implements PrimitiveSerializer<PollCreatePollApiVersion> {
  const _$PollCreatePollApiVersionSerializer();

  static const Map<PollCreatePollApiVersion, Object> _toWire = <PollCreatePollApiVersion, Object>{
    PollCreatePollApiVersion.v1: 'v1',
  };

  static const Map<Object, PollCreatePollApiVersion> _fromWire = <Object, PollCreatePollApiVersion>{
    'v1': PollCreatePollApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [PollCreatePollApiVersion];

  @override
  String get wireName => 'PollCreatePollApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    PollCreatePollApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  PollCreatePollApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $PollVoteInterface {
  String get actorDisplayName;
  String get actorId;
  ActorType get actorType;
  int get optionId;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($PollVoteInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($PollVoteInterfaceBuilder b) {}
}

abstract class PollVote implements $PollVoteInterface, Built<PollVote, PollVoteBuilder> {
  /// Creates a new PollVote object using the builder pattern.
  factory PollVote([void Function(PollVoteBuilder)? b]) = _$PollVote;

  // coverage:ignore-start
  const PollVote._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory PollVote.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for PollVote.
  static Serializer<PollVote> get serializer => _$pollVoteSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(PollVoteBuilder b) {
    $PollVoteInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(PollVoteBuilder b) {
    $PollVoteInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $PollInterface {
  String get actorDisplayName;
  String get actorId;
  ActorType get actorType;
  BuiltList<PollVote>? get details;
  int get id;
  int get maxVotes;
  int? get numVoters;
  BuiltList<String> get options;
  String get question;
  int get resultMode;
  int get status;
  BuiltList<int>? get votedSelf;
  BuiltMap<String, int>? get votes;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($PollInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($PollInterfaceBuilder b) {}
}

abstract class Poll implements $PollInterface, Built<Poll, PollBuilder> {
  /// Creates a new Poll object using the builder pattern.
  factory Poll([void Function(PollBuilder)? b]) = _$Poll;

  // coverage:ignore-start
  const Poll._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory Poll.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for Poll.
  static Serializer<Poll> get serializer => _$pollSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(PollBuilder b) {
    $PollInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(PollBuilder b) {
    $PollInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $PollCreatePollResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Poll get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($PollCreatePollResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($PollCreatePollResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class PollCreatePollResponseApplicationJson_Ocs
    implements
        $PollCreatePollResponseApplicationJson_OcsInterface,
        Built<PollCreatePollResponseApplicationJson_Ocs, PollCreatePollResponseApplicationJson_OcsBuilder> {
  /// Creates a new PollCreatePollResponseApplicationJson_Ocs object using the builder pattern.
  factory PollCreatePollResponseApplicationJson_Ocs([
    void Function(PollCreatePollResponseApplicationJson_OcsBuilder)? b,
  ]) = _$PollCreatePollResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const PollCreatePollResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory PollCreatePollResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for PollCreatePollResponseApplicationJson_Ocs.
  static Serializer<PollCreatePollResponseApplicationJson_Ocs> get serializer =>
      _$pollCreatePollResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(PollCreatePollResponseApplicationJson_OcsBuilder b) {
    $PollCreatePollResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(PollCreatePollResponseApplicationJson_OcsBuilder b) {
    $PollCreatePollResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $PollCreatePollResponseApplicationJsonInterface {
  PollCreatePollResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($PollCreatePollResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($PollCreatePollResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class PollCreatePollResponseApplicationJson
    implements
        $PollCreatePollResponseApplicationJsonInterface,
        Built<PollCreatePollResponseApplicationJson, PollCreatePollResponseApplicationJsonBuilder> {
  /// Creates a new PollCreatePollResponseApplicationJson object using the builder pattern.
  factory PollCreatePollResponseApplicationJson([void Function(PollCreatePollResponseApplicationJsonBuilder)? b]) =
      _$PollCreatePollResponseApplicationJson;

  // coverage:ignore-start
  const PollCreatePollResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory PollCreatePollResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for PollCreatePollResponseApplicationJson.
  static Serializer<PollCreatePollResponseApplicationJson> get serializer =>
      _$pollCreatePollResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(PollCreatePollResponseApplicationJsonBuilder b) {
    $PollCreatePollResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(PollCreatePollResponseApplicationJsonBuilder b) {
    $PollCreatePollResponseApplicationJsonInterface._validate(b);
  }
}

class PollShowPollApiVersion extends EnumClass {
  const PollShowPollApiVersion._(super.name);

  /// `v1`
  static const PollShowPollApiVersion v1 = _$pollShowPollApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<PollShowPollApiVersion> get values => _$pollShowPollApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static PollShowPollApiVersion valueOf(String name) => _$valueOfPollShowPollApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for PollShowPollApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<PollShowPollApiVersion> get serializer => const _$PollShowPollApiVersionSerializer();
}

class _$PollShowPollApiVersionSerializer implements PrimitiveSerializer<PollShowPollApiVersion> {
  const _$PollShowPollApiVersionSerializer();

  static const Map<PollShowPollApiVersion, Object> _toWire = <PollShowPollApiVersion, Object>{
    PollShowPollApiVersion.v1: 'v1',
  };

  static const Map<Object, PollShowPollApiVersion> _fromWire = <Object, PollShowPollApiVersion>{
    'v1': PollShowPollApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [PollShowPollApiVersion];

  @override
  String get wireName => 'PollShowPollApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    PollShowPollApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  PollShowPollApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $PollShowPollResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Poll get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($PollShowPollResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($PollShowPollResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class PollShowPollResponseApplicationJson_Ocs
    implements
        $PollShowPollResponseApplicationJson_OcsInterface,
        Built<PollShowPollResponseApplicationJson_Ocs, PollShowPollResponseApplicationJson_OcsBuilder> {
  /// Creates a new PollShowPollResponseApplicationJson_Ocs object using the builder pattern.
  factory PollShowPollResponseApplicationJson_Ocs([void Function(PollShowPollResponseApplicationJson_OcsBuilder)? b]) =
      _$PollShowPollResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const PollShowPollResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory PollShowPollResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for PollShowPollResponseApplicationJson_Ocs.
  static Serializer<PollShowPollResponseApplicationJson_Ocs> get serializer =>
      _$pollShowPollResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(PollShowPollResponseApplicationJson_OcsBuilder b) {
    $PollShowPollResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(PollShowPollResponseApplicationJson_OcsBuilder b) {
    $PollShowPollResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $PollShowPollResponseApplicationJsonInterface {
  PollShowPollResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($PollShowPollResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($PollShowPollResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class PollShowPollResponseApplicationJson
    implements
        $PollShowPollResponseApplicationJsonInterface,
        Built<PollShowPollResponseApplicationJson, PollShowPollResponseApplicationJsonBuilder> {
  /// Creates a new PollShowPollResponseApplicationJson object using the builder pattern.
  factory PollShowPollResponseApplicationJson([void Function(PollShowPollResponseApplicationJsonBuilder)? b]) =
      _$PollShowPollResponseApplicationJson;

  // coverage:ignore-start
  const PollShowPollResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory PollShowPollResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for PollShowPollResponseApplicationJson.
  static Serializer<PollShowPollResponseApplicationJson> get serializer =>
      _$pollShowPollResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(PollShowPollResponseApplicationJsonBuilder b) {
    $PollShowPollResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(PollShowPollResponseApplicationJsonBuilder b) {
    $PollShowPollResponseApplicationJsonInterface._validate(b);
  }
}

class PollVotePollApiVersion extends EnumClass {
  const PollVotePollApiVersion._(super.name);

  /// `v1`
  static const PollVotePollApiVersion v1 = _$pollVotePollApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<PollVotePollApiVersion> get values => _$pollVotePollApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static PollVotePollApiVersion valueOf(String name) => _$valueOfPollVotePollApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for PollVotePollApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<PollVotePollApiVersion> get serializer => const _$PollVotePollApiVersionSerializer();
}

class _$PollVotePollApiVersionSerializer implements PrimitiveSerializer<PollVotePollApiVersion> {
  const _$PollVotePollApiVersionSerializer();

  static const Map<PollVotePollApiVersion, Object> _toWire = <PollVotePollApiVersion, Object>{
    PollVotePollApiVersion.v1: 'v1',
  };

  static const Map<Object, PollVotePollApiVersion> _fromWire = <Object, PollVotePollApiVersion>{
    'v1': PollVotePollApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [PollVotePollApiVersion];

  @override
  String get wireName => 'PollVotePollApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    PollVotePollApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  PollVotePollApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $PollVotePollResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Poll get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($PollVotePollResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($PollVotePollResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class PollVotePollResponseApplicationJson_Ocs
    implements
        $PollVotePollResponseApplicationJson_OcsInterface,
        Built<PollVotePollResponseApplicationJson_Ocs, PollVotePollResponseApplicationJson_OcsBuilder> {
  /// Creates a new PollVotePollResponseApplicationJson_Ocs object using the builder pattern.
  factory PollVotePollResponseApplicationJson_Ocs([void Function(PollVotePollResponseApplicationJson_OcsBuilder)? b]) =
      _$PollVotePollResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const PollVotePollResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory PollVotePollResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for PollVotePollResponseApplicationJson_Ocs.
  static Serializer<PollVotePollResponseApplicationJson_Ocs> get serializer =>
      _$pollVotePollResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(PollVotePollResponseApplicationJson_OcsBuilder b) {
    $PollVotePollResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(PollVotePollResponseApplicationJson_OcsBuilder b) {
    $PollVotePollResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $PollVotePollResponseApplicationJsonInterface {
  PollVotePollResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($PollVotePollResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($PollVotePollResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class PollVotePollResponseApplicationJson
    implements
        $PollVotePollResponseApplicationJsonInterface,
        Built<PollVotePollResponseApplicationJson, PollVotePollResponseApplicationJsonBuilder> {
  /// Creates a new PollVotePollResponseApplicationJson object using the builder pattern.
  factory PollVotePollResponseApplicationJson([void Function(PollVotePollResponseApplicationJsonBuilder)? b]) =
      _$PollVotePollResponseApplicationJson;

  // coverage:ignore-start
  const PollVotePollResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory PollVotePollResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for PollVotePollResponseApplicationJson.
  static Serializer<PollVotePollResponseApplicationJson> get serializer =>
      _$pollVotePollResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(PollVotePollResponseApplicationJsonBuilder b) {
    $PollVotePollResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(PollVotePollResponseApplicationJsonBuilder b) {
    $PollVotePollResponseApplicationJsonInterface._validate(b);
  }
}

class PollClosePollApiVersion extends EnumClass {
  const PollClosePollApiVersion._(super.name);

  /// `v1`
  static const PollClosePollApiVersion v1 = _$pollClosePollApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<PollClosePollApiVersion> get values => _$pollClosePollApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static PollClosePollApiVersion valueOf(String name) => _$valueOfPollClosePollApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for PollClosePollApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<PollClosePollApiVersion> get serializer => const _$PollClosePollApiVersionSerializer();
}

class _$PollClosePollApiVersionSerializer implements PrimitiveSerializer<PollClosePollApiVersion> {
  const _$PollClosePollApiVersionSerializer();

  static const Map<PollClosePollApiVersion, Object> _toWire = <PollClosePollApiVersion, Object>{
    PollClosePollApiVersion.v1: 'v1',
  };

  static const Map<Object, PollClosePollApiVersion> _fromWire = <Object, PollClosePollApiVersion>{
    'v1': PollClosePollApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [PollClosePollApiVersion];

  @override
  String get wireName => 'PollClosePollApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    PollClosePollApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  PollClosePollApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $PollClosePollResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Poll get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($PollClosePollResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($PollClosePollResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class PollClosePollResponseApplicationJson_Ocs
    implements
        $PollClosePollResponseApplicationJson_OcsInterface,
        Built<PollClosePollResponseApplicationJson_Ocs, PollClosePollResponseApplicationJson_OcsBuilder> {
  /// Creates a new PollClosePollResponseApplicationJson_Ocs object using the builder pattern.
  factory PollClosePollResponseApplicationJson_Ocs([
    void Function(PollClosePollResponseApplicationJson_OcsBuilder)? b,
  ]) = _$PollClosePollResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const PollClosePollResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory PollClosePollResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for PollClosePollResponseApplicationJson_Ocs.
  static Serializer<PollClosePollResponseApplicationJson_Ocs> get serializer =>
      _$pollClosePollResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(PollClosePollResponseApplicationJson_OcsBuilder b) {
    $PollClosePollResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(PollClosePollResponseApplicationJson_OcsBuilder b) {
    $PollClosePollResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $PollClosePollResponseApplicationJsonInterface {
  PollClosePollResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($PollClosePollResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($PollClosePollResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class PollClosePollResponseApplicationJson
    implements
        $PollClosePollResponseApplicationJsonInterface,
        Built<PollClosePollResponseApplicationJson, PollClosePollResponseApplicationJsonBuilder> {
  /// Creates a new PollClosePollResponseApplicationJson object using the builder pattern.
  factory PollClosePollResponseApplicationJson([void Function(PollClosePollResponseApplicationJsonBuilder)? b]) =
      _$PollClosePollResponseApplicationJson;

  // coverage:ignore-start
  const PollClosePollResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory PollClosePollResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for PollClosePollResponseApplicationJson.
  static Serializer<PollClosePollResponseApplicationJson> get serializer =>
      _$pollClosePollResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(PollClosePollResponseApplicationJsonBuilder b) {
    $PollClosePollResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(PollClosePollResponseApplicationJsonBuilder b) {
    $PollClosePollResponseApplicationJsonInterface._validate(b);
  }
}

class ReactionGetReactionsApiVersion extends EnumClass {
  const ReactionGetReactionsApiVersion._(super.name);

  /// `v1`
  static const ReactionGetReactionsApiVersion v1 = _$reactionGetReactionsApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<ReactionGetReactionsApiVersion> get values => _$reactionGetReactionsApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static ReactionGetReactionsApiVersion valueOf(String name) => _$valueOfReactionGetReactionsApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for ReactionGetReactionsApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<ReactionGetReactionsApiVersion> get serializer =>
      const _$ReactionGetReactionsApiVersionSerializer();
}

class _$ReactionGetReactionsApiVersionSerializer implements PrimitiveSerializer<ReactionGetReactionsApiVersion> {
  const _$ReactionGetReactionsApiVersionSerializer();

  static const Map<ReactionGetReactionsApiVersion, Object> _toWire = <ReactionGetReactionsApiVersion, Object>{
    ReactionGetReactionsApiVersion.v1: 'v1',
  };

  static const Map<Object, ReactionGetReactionsApiVersion> _fromWire = <Object, ReactionGetReactionsApiVersion>{
    'v1': ReactionGetReactionsApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ReactionGetReactionsApiVersion];

  @override
  String get wireName => 'ReactionGetReactionsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ReactionGetReactionsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ReactionGetReactionsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ReactionInterface {
  String get actorDisplayName;
  String get actorId;
  ActorType get actorType;
  int get timestamp;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ReactionInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ReactionInterfaceBuilder b) {}
}

abstract class Reaction implements $ReactionInterface, Built<Reaction, ReactionBuilder> {
  /// Creates a new Reaction object using the builder pattern.
  factory Reaction([void Function(ReactionBuilder)? b]) = _$Reaction;

  // coverage:ignore-start
  const Reaction._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory Reaction.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for Reaction.
  static Serializer<Reaction> get serializer => _$reactionSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ReactionBuilder b) {
    $ReactionInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ReactionBuilder b) {
    $ReactionInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ReactionGetReactionsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltMap<String, BuiltList<Reaction>> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ReactionGetReactionsResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ReactionGetReactionsResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class ReactionGetReactionsResponseApplicationJson_Ocs
    implements
        $ReactionGetReactionsResponseApplicationJson_OcsInterface,
        Built<ReactionGetReactionsResponseApplicationJson_Ocs, ReactionGetReactionsResponseApplicationJson_OcsBuilder> {
  /// Creates a new ReactionGetReactionsResponseApplicationJson_Ocs object using the builder pattern.
  factory ReactionGetReactionsResponseApplicationJson_Ocs([
    void Function(ReactionGetReactionsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ReactionGetReactionsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ReactionGetReactionsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ReactionGetReactionsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ReactionGetReactionsResponseApplicationJson_Ocs.
  static Serializer<ReactionGetReactionsResponseApplicationJson_Ocs> get serializer =>
      _$reactionGetReactionsResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ReactionGetReactionsResponseApplicationJson_OcsBuilder b) {
    $ReactionGetReactionsResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ReactionGetReactionsResponseApplicationJson_OcsBuilder b) {
    $ReactionGetReactionsResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ReactionGetReactionsResponseApplicationJsonInterface {
  ReactionGetReactionsResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ReactionGetReactionsResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ReactionGetReactionsResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class ReactionGetReactionsResponseApplicationJson
    implements
        $ReactionGetReactionsResponseApplicationJsonInterface,
        Built<ReactionGetReactionsResponseApplicationJson, ReactionGetReactionsResponseApplicationJsonBuilder> {
  /// Creates a new ReactionGetReactionsResponseApplicationJson object using the builder pattern.
  factory ReactionGetReactionsResponseApplicationJson([
    void Function(ReactionGetReactionsResponseApplicationJsonBuilder)? b,
  ]) = _$ReactionGetReactionsResponseApplicationJson;

  // coverage:ignore-start
  const ReactionGetReactionsResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ReactionGetReactionsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ReactionGetReactionsResponseApplicationJson.
  static Serializer<ReactionGetReactionsResponseApplicationJson> get serializer =>
      _$reactionGetReactionsResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ReactionGetReactionsResponseApplicationJsonBuilder b) {
    $ReactionGetReactionsResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ReactionGetReactionsResponseApplicationJsonBuilder b) {
    $ReactionGetReactionsResponseApplicationJsonInterface._validate(b);
  }
}

class ReactionReactApiVersion extends EnumClass {
  const ReactionReactApiVersion._(super.name);

  /// `v1`
  static const ReactionReactApiVersion v1 = _$reactionReactApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<ReactionReactApiVersion> get values => _$reactionReactApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static ReactionReactApiVersion valueOf(String name) => _$valueOfReactionReactApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for ReactionReactApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<ReactionReactApiVersion> get serializer => const _$ReactionReactApiVersionSerializer();
}

class _$ReactionReactApiVersionSerializer implements PrimitiveSerializer<ReactionReactApiVersion> {
  const _$ReactionReactApiVersionSerializer();

  static const Map<ReactionReactApiVersion, Object> _toWire = <ReactionReactApiVersion, Object>{
    ReactionReactApiVersion.v1: 'v1',
  };

  static const Map<Object, ReactionReactApiVersion> _fromWire = <Object, ReactionReactApiVersion>{
    'v1': ReactionReactApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ReactionReactApiVersion];

  @override
  String get wireName => 'ReactionReactApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ReactionReactApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ReactionReactApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ReactionReactResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltMap<String, BuiltList<Reaction>> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ReactionReactResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ReactionReactResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class ReactionReactResponseApplicationJson_Ocs
    implements
        $ReactionReactResponseApplicationJson_OcsInterface,
        Built<ReactionReactResponseApplicationJson_Ocs, ReactionReactResponseApplicationJson_OcsBuilder> {
  /// Creates a new ReactionReactResponseApplicationJson_Ocs object using the builder pattern.
  factory ReactionReactResponseApplicationJson_Ocs([
    void Function(ReactionReactResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ReactionReactResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ReactionReactResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ReactionReactResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ReactionReactResponseApplicationJson_Ocs.
  static Serializer<ReactionReactResponseApplicationJson_Ocs> get serializer =>
      _$reactionReactResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ReactionReactResponseApplicationJson_OcsBuilder b) {
    $ReactionReactResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ReactionReactResponseApplicationJson_OcsBuilder b) {
    $ReactionReactResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ReactionReactResponseApplicationJsonInterface {
  ReactionReactResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ReactionReactResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ReactionReactResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class ReactionReactResponseApplicationJson
    implements
        $ReactionReactResponseApplicationJsonInterface,
        Built<ReactionReactResponseApplicationJson, ReactionReactResponseApplicationJsonBuilder> {
  /// Creates a new ReactionReactResponseApplicationJson object using the builder pattern.
  factory ReactionReactResponseApplicationJson([void Function(ReactionReactResponseApplicationJsonBuilder)? b]) =
      _$ReactionReactResponseApplicationJson;

  // coverage:ignore-start
  const ReactionReactResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ReactionReactResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ReactionReactResponseApplicationJson.
  static Serializer<ReactionReactResponseApplicationJson> get serializer =>
      _$reactionReactResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ReactionReactResponseApplicationJsonBuilder b) {
    $ReactionReactResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ReactionReactResponseApplicationJsonBuilder b) {
    $ReactionReactResponseApplicationJsonInterface._validate(b);
  }
}

class ReactionDeleteApiVersion extends EnumClass {
  const ReactionDeleteApiVersion._(super.name);

  /// `v1`
  static const ReactionDeleteApiVersion v1 = _$reactionDeleteApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<ReactionDeleteApiVersion> get values => _$reactionDeleteApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static ReactionDeleteApiVersion valueOf(String name) => _$valueOfReactionDeleteApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for ReactionDeleteApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<ReactionDeleteApiVersion> get serializer => const _$ReactionDeleteApiVersionSerializer();
}

class _$ReactionDeleteApiVersionSerializer implements PrimitiveSerializer<ReactionDeleteApiVersion> {
  const _$ReactionDeleteApiVersionSerializer();

  static const Map<ReactionDeleteApiVersion, Object> _toWire = <ReactionDeleteApiVersion, Object>{
    ReactionDeleteApiVersion.v1: 'v1',
  };

  static const Map<Object, ReactionDeleteApiVersion> _fromWire = <Object, ReactionDeleteApiVersion>{
    'v1': ReactionDeleteApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ReactionDeleteApiVersion];

  @override
  String get wireName => 'ReactionDeleteApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ReactionDeleteApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ReactionDeleteApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ReactionDeleteResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltMap<String, BuiltList<Reaction>> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ReactionDeleteResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ReactionDeleteResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class ReactionDeleteResponseApplicationJson_Ocs
    implements
        $ReactionDeleteResponseApplicationJson_OcsInterface,
        Built<ReactionDeleteResponseApplicationJson_Ocs, ReactionDeleteResponseApplicationJson_OcsBuilder> {
  /// Creates a new ReactionDeleteResponseApplicationJson_Ocs object using the builder pattern.
  factory ReactionDeleteResponseApplicationJson_Ocs([
    void Function(ReactionDeleteResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ReactionDeleteResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ReactionDeleteResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ReactionDeleteResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ReactionDeleteResponseApplicationJson_Ocs.
  static Serializer<ReactionDeleteResponseApplicationJson_Ocs> get serializer =>
      _$reactionDeleteResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ReactionDeleteResponseApplicationJson_OcsBuilder b) {
    $ReactionDeleteResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ReactionDeleteResponseApplicationJson_OcsBuilder b) {
    $ReactionDeleteResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $ReactionDeleteResponseApplicationJsonInterface {
  ReactionDeleteResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ReactionDeleteResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ReactionDeleteResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class ReactionDeleteResponseApplicationJson
    implements
        $ReactionDeleteResponseApplicationJsonInterface,
        Built<ReactionDeleteResponseApplicationJson, ReactionDeleteResponseApplicationJsonBuilder> {
  /// Creates a new ReactionDeleteResponseApplicationJson object using the builder pattern.
  factory ReactionDeleteResponseApplicationJson([void Function(ReactionDeleteResponseApplicationJsonBuilder)? b]) =
      _$ReactionDeleteResponseApplicationJson;

  // coverage:ignore-start
  const ReactionDeleteResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory ReactionDeleteResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for ReactionDeleteResponseApplicationJson.
  static Serializer<ReactionDeleteResponseApplicationJson> get serializer =>
      _$reactionDeleteResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ReactionDeleteResponseApplicationJsonBuilder b) {
    $ReactionDeleteResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ReactionDeleteResponseApplicationJsonBuilder b) {
    $ReactionDeleteResponseApplicationJsonInterface._validate(b);
  }
}

class RecordingStartApiVersion extends EnumClass {
  const RecordingStartApiVersion._(super.name);

  /// `v1`
  static const RecordingStartApiVersion v1 = _$recordingStartApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RecordingStartApiVersion> get values => _$recordingStartApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RecordingStartApiVersion valueOf(String name) => _$valueOfRecordingStartApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RecordingStartApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RecordingStartApiVersion> get serializer => const _$RecordingStartApiVersionSerializer();
}

class _$RecordingStartApiVersionSerializer implements PrimitiveSerializer<RecordingStartApiVersion> {
  const _$RecordingStartApiVersionSerializer();

  static const Map<RecordingStartApiVersion, Object> _toWire = <RecordingStartApiVersion, Object>{
    RecordingStartApiVersion.v1: 'v1',
  };

  static const Map<Object, RecordingStartApiVersion> _fromWire = <Object, RecordingStartApiVersion>{
    'v1': RecordingStartApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [RecordingStartApiVersion];

  @override
  String get wireName => 'RecordingStartApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RecordingStartApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RecordingStartApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RecordingStartResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RecordingStartResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RecordingStartResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RecordingStartResponseApplicationJson_Ocs
    implements
        $RecordingStartResponseApplicationJson_OcsInterface,
        Built<RecordingStartResponseApplicationJson_Ocs, RecordingStartResponseApplicationJson_OcsBuilder> {
  /// Creates a new RecordingStartResponseApplicationJson_Ocs object using the builder pattern.
  factory RecordingStartResponseApplicationJson_Ocs([
    void Function(RecordingStartResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RecordingStartResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RecordingStartResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RecordingStartResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RecordingStartResponseApplicationJson_Ocs.
  static Serializer<RecordingStartResponseApplicationJson_Ocs> get serializer =>
      _$recordingStartResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RecordingStartResponseApplicationJson_OcsBuilder b) {
    $RecordingStartResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RecordingStartResponseApplicationJson_OcsBuilder b) {
    $RecordingStartResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RecordingStartResponseApplicationJsonInterface {
  RecordingStartResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RecordingStartResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RecordingStartResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RecordingStartResponseApplicationJson
    implements
        $RecordingStartResponseApplicationJsonInterface,
        Built<RecordingStartResponseApplicationJson, RecordingStartResponseApplicationJsonBuilder> {
  /// Creates a new RecordingStartResponseApplicationJson object using the builder pattern.
  factory RecordingStartResponseApplicationJson([void Function(RecordingStartResponseApplicationJsonBuilder)? b]) =
      _$RecordingStartResponseApplicationJson;

  // coverage:ignore-start
  const RecordingStartResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RecordingStartResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RecordingStartResponseApplicationJson.
  static Serializer<RecordingStartResponseApplicationJson> get serializer =>
      _$recordingStartResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RecordingStartResponseApplicationJsonBuilder b) {
    $RecordingStartResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RecordingStartResponseApplicationJsonBuilder b) {
    $RecordingStartResponseApplicationJsonInterface._validate(b);
  }
}

class RecordingStopApiVersion extends EnumClass {
  const RecordingStopApiVersion._(super.name);

  /// `v1`
  static const RecordingStopApiVersion v1 = _$recordingStopApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RecordingStopApiVersion> get values => _$recordingStopApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RecordingStopApiVersion valueOf(String name) => _$valueOfRecordingStopApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RecordingStopApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RecordingStopApiVersion> get serializer => const _$RecordingStopApiVersionSerializer();
}

class _$RecordingStopApiVersionSerializer implements PrimitiveSerializer<RecordingStopApiVersion> {
  const _$RecordingStopApiVersionSerializer();

  static const Map<RecordingStopApiVersion, Object> _toWire = <RecordingStopApiVersion, Object>{
    RecordingStopApiVersion.v1: 'v1',
  };

  static const Map<Object, RecordingStopApiVersion> _fromWire = <Object, RecordingStopApiVersion>{
    'v1': RecordingStopApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [RecordingStopApiVersion];

  @override
  String get wireName => 'RecordingStopApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RecordingStopApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RecordingStopApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RecordingStopResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RecordingStopResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RecordingStopResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RecordingStopResponseApplicationJson_Ocs
    implements
        $RecordingStopResponseApplicationJson_OcsInterface,
        Built<RecordingStopResponseApplicationJson_Ocs, RecordingStopResponseApplicationJson_OcsBuilder> {
  /// Creates a new RecordingStopResponseApplicationJson_Ocs object using the builder pattern.
  factory RecordingStopResponseApplicationJson_Ocs([
    void Function(RecordingStopResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RecordingStopResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RecordingStopResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RecordingStopResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RecordingStopResponseApplicationJson_Ocs.
  static Serializer<RecordingStopResponseApplicationJson_Ocs> get serializer =>
      _$recordingStopResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RecordingStopResponseApplicationJson_OcsBuilder b) {
    $RecordingStopResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RecordingStopResponseApplicationJson_OcsBuilder b) {
    $RecordingStopResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RecordingStopResponseApplicationJsonInterface {
  RecordingStopResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RecordingStopResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RecordingStopResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RecordingStopResponseApplicationJson
    implements
        $RecordingStopResponseApplicationJsonInterface,
        Built<RecordingStopResponseApplicationJson, RecordingStopResponseApplicationJsonBuilder> {
  /// Creates a new RecordingStopResponseApplicationJson object using the builder pattern.
  factory RecordingStopResponseApplicationJson([void Function(RecordingStopResponseApplicationJsonBuilder)? b]) =
      _$RecordingStopResponseApplicationJson;

  // coverage:ignore-start
  const RecordingStopResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RecordingStopResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RecordingStopResponseApplicationJson.
  static Serializer<RecordingStopResponseApplicationJson> get serializer =>
      _$recordingStopResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RecordingStopResponseApplicationJsonBuilder b) {
    $RecordingStopResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RecordingStopResponseApplicationJsonBuilder b) {
    $RecordingStopResponseApplicationJsonInterface._validate(b);
  }
}

class RecordingNotificationDismissApiVersion extends EnumClass {
  const RecordingNotificationDismissApiVersion._(super.name);

  /// `v1`
  static const RecordingNotificationDismissApiVersion v1 = _$recordingNotificationDismissApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RecordingNotificationDismissApiVersion> get values => _$recordingNotificationDismissApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RecordingNotificationDismissApiVersion valueOf(String name) =>
      _$valueOfRecordingNotificationDismissApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RecordingNotificationDismissApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RecordingNotificationDismissApiVersion> get serializer =>
      const _$RecordingNotificationDismissApiVersionSerializer();
}

class _$RecordingNotificationDismissApiVersionSerializer
    implements PrimitiveSerializer<RecordingNotificationDismissApiVersion> {
  const _$RecordingNotificationDismissApiVersionSerializer();

  static const Map<RecordingNotificationDismissApiVersion, Object> _toWire =
      <RecordingNotificationDismissApiVersion, Object>{
    RecordingNotificationDismissApiVersion.v1: 'v1',
  };

  static const Map<Object, RecordingNotificationDismissApiVersion> _fromWire =
      <Object, RecordingNotificationDismissApiVersion>{
    'v1': RecordingNotificationDismissApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [RecordingNotificationDismissApiVersion];

  @override
  String get wireName => 'RecordingNotificationDismissApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RecordingNotificationDismissApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RecordingNotificationDismissApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RecordingNotificationDismissResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RecordingNotificationDismissResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RecordingNotificationDismissResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RecordingNotificationDismissResponseApplicationJson_Ocs
    implements
        $RecordingNotificationDismissResponseApplicationJson_OcsInterface,
        Built<RecordingNotificationDismissResponseApplicationJson_Ocs,
            RecordingNotificationDismissResponseApplicationJson_OcsBuilder> {
  /// Creates a new RecordingNotificationDismissResponseApplicationJson_Ocs object using the builder pattern.
  factory RecordingNotificationDismissResponseApplicationJson_Ocs([
    void Function(RecordingNotificationDismissResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RecordingNotificationDismissResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RecordingNotificationDismissResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RecordingNotificationDismissResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RecordingNotificationDismissResponseApplicationJson_Ocs.
  static Serializer<RecordingNotificationDismissResponseApplicationJson_Ocs> get serializer =>
      _$recordingNotificationDismissResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RecordingNotificationDismissResponseApplicationJson_OcsBuilder b) {
    $RecordingNotificationDismissResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RecordingNotificationDismissResponseApplicationJson_OcsBuilder b) {
    $RecordingNotificationDismissResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RecordingNotificationDismissResponseApplicationJsonInterface {
  RecordingNotificationDismissResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RecordingNotificationDismissResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RecordingNotificationDismissResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RecordingNotificationDismissResponseApplicationJson
    implements
        $RecordingNotificationDismissResponseApplicationJsonInterface,
        Built<RecordingNotificationDismissResponseApplicationJson,
            RecordingNotificationDismissResponseApplicationJsonBuilder> {
  /// Creates a new RecordingNotificationDismissResponseApplicationJson object using the builder pattern.
  factory RecordingNotificationDismissResponseApplicationJson([
    void Function(RecordingNotificationDismissResponseApplicationJsonBuilder)? b,
  ]) = _$RecordingNotificationDismissResponseApplicationJson;

  // coverage:ignore-start
  const RecordingNotificationDismissResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RecordingNotificationDismissResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RecordingNotificationDismissResponseApplicationJson.
  static Serializer<RecordingNotificationDismissResponseApplicationJson> get serializer =>
      _$recordingNotificationDismissResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RecordingNotificationDismissResponseApplicationJsonBuilder b) {
    $RecordingNotificationDismissResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RecordingNotificationDismissResponseApplicationJsonBuilder b) {
    $RecordingNotificationDismissResponseApplicationJsonInterface._validate(b);
  }
}

class RecordingShareToChatApiVersion extends EnumClass {
  const RecordingShareToChatApiVersion._(super.name);

  /// `v1`
  static const RecordingShareToChatApiVersion v1 = _$recordingShareToChatApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RecordingShareToChatApiVersion> get values => _$recordingShareToChatApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RecordingShareToChatApiVersion valueOf(String name) => _$valueOfRecordingShareToChatApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RecordingShareToChatApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RecordingShareToChatApiVersion> get serializer =>
      const _$RecordingShareToChatApiVersionSerializer();
}

class _$RecordingShareToChatApiVersionSerializer implements PrimitiveSerializer<RecordingShareToChatApiVersion> {
  const _$RecordingShareToChatApiVersionSerializer();

  static const Map<RecordingShareToChatApiVersion, Object> _toWire = <RecordingShareToChatApiVersion, Object>{
    RecordingShareToChatApiVersion.v1: 'v1',
  };

  static const Map<Object, RecordingShareToChatApiVersion> _fromWire = <Object, RecordingShareToChatApiVersion>{
    'v1': RecordingShareToChatApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [RecordingShareToChatApiVersion];

  @override
  String get wireName => 'RecordingShareToChatApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RecordingShareToChatApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RecordingShareToChatApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RecordingShareToChatResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RecordingShareToChatResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RecordingShareToChatResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RecordingShareToChatResponseApplicationJson_Ocs
    implements
        $RecordingShareToChatResponseApplicationJson_OcsInterface,
        Built<RecordingShareToChatResponseApplicationJson_Ocs, RecordingShareToChatResponseApplicationJson_OcsBuilder> {
  /// Creates a new RecordingShareToChatResponseApplicationJson_Ocs object using the builder pattern.
  factory RecordingShareToChatResponseApplicationJson_Ocs([
    void Function(RecordingShareToChatResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RecordingShareToChatResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RecordingShareToChatResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RecordingShareToChatResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RecordingShareToChatResponseApplicationJson_Ocs.
  static Serializer<RecordingShareToChatResponseApplicationJson_Ocs> get serializer =>
      _$recordingShareToChatResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RecordingShareToChatResponseApplicationJson_OcsBuilder b) {
    $RecordingShareToChatResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RecordingShareToChatResponseApplicationJson_OcsBuilder b) {
    $RecordingShareToChatResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RecordingShareToChatResponseApplicationJsonInterface {
  RecordingShareToChatResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RecordingShareToChatResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RecordingShareToChatResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RecordingShareToChatResponseApplicationJson
    implements
        $RecordingShareToChatResponseApplicationJsonInterface,
        Built<RecordingShareToChatResponseApplicationJson, RecordingShareToChatResponseApplicationJsonBuilder> {
  /// Creates a new RecordingShareToChatResponseApplicationJson object using the builder pattern.
  factory RecordingShareToChatResponseApplicationJson([
    void Function(RecordingShareToChatResponseApplicationJsonBuilder)? b,
  ]) = _$RecordingShareToChatResponseApplicationJson;

  // coverage:ignore-start
  const RecordingShareToChatResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RecordingShareToChatResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RecordingShareToChatResponseApplicationJson.
  static Serializer<RecordingShareToChatResponseApplicationJson> get serializer =>
      _$recordingShareToChatResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RecordingShareToChatResponseApplicationJsonBuilder b) {
    $RecordingShareToChatResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RecordingShareToChatResponseApplicationJsonBuilder b) {
    $RecordingShareToChatResponseApplicationJsonInterface._validate(b);
  }
}

class RecordingBackendApiVersion extends EnumClass {
  const RecordingBackendApiVersion._(super.name);

  /// `v1`
  static const RecordingBackendApiVersion v1 = _$recordingBackendApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RecordingBackendApiVersion> get values => _$recordingBackendApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RecordingBackendApiVersion valueOf(String name) => _$valueOfRecordingBackendApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RecordingBackendApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RecordingBackendApiVersion> get serializer => const _$RecordingBackendApiVersionSerializer();
}

class _$RecordingBackendApiVersionSerializer implements PrimitiveSerializer<RecordingBackendApiVersion> {
  const _$RecordingBackendApiVersionSerializer();

  static const Map<RecordingBackendApiVersion, Object> _toWire = <RecordingBackendApiVersion, Object>{
    RecordingBackendApiVersion.v1: 'v1',
  };

  static const Map<Object, RecordingBackendApiVersion> _fromWire = <Object, RecordingBackendApiVersion>{
    'v1': RecordingBackendApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [RecordingBackendApiVersion];

  @override
  String get wireName => 'RecordingBackendApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RecordingBackendApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RecordingBackendApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RecordingBackendResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RecordingBackendResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RecordingBackendResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RecordingBackendResponseApplicationJson_Ocs
    implements
        $RecordingBackendResponseApplicationJson_OcsInterface,
        Built<RecordingBackendResponseApplicationJson_Ocs, RecordingBackendResponseApplicationJson_OcsBuilder> {
  /// Creates a new RecordingBackendResponseApplicationJson_Ocs object using the builder pattern.
  factory RecordingBackendResponseApplicationJson_Ocs([
    void Function(RecordingBackendResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RecordingBackendResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RecordingBackendResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RecordingBackendResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RecordingBackendResponseApplicationJson_Ocs.
  static Serializer<RecordingBackendResponseApplicationJson_Ocs> get serializer =>
      _$recordingBackendResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RecordingBackendResponseApplicationJson_OcsBuilder b) {
    $RecordingBackendResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RecordingBackendResponseApplicationJson_OcsBuilder b) {
    $RecordingBackendResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RecordingBackendResponseApplicationJsonInterface {
  RecordingBackendResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RecordingBackendResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RecordingBackendResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RecordingBackendResponseApplicationJson
    implements
        $RecordingBackendResponseApplicationJsonInterface,
        Built<RecordingBackendResponseApplicationJson, RecordingBackendResponseApplicationJsonBuilder> {
  /// Creates a new RecordingBackendResponseApplicationJson object using the builder pattern.
  factory RecordingBackendResponseApplicationJson([void Function(RecordingBackendResponseApplicationJsonBuilder)? b]) =
      _$RecordingBackendResponseApplicationJson;

  // coverage:ignore-start
  const RecordingBackendResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RecordingBackendResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RecordingBackendResponseApplicationJson.
  static Serializer<RecordingBackendResponseApplicationJson> get serializer =>
      _$recordingBackendResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RecordingBackendResponseApplicationJsonBuilder b) {
    $RecordingBackendResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RecordingBackendResponseApplicationJsonBuilder b) {
    $RecordingBackendResponseApplicationJsonInterface._validate(b);
  }
}

class RecordingStoreApiVersion extends EnumClass {
  const RecordingStoreApiVersion._(super.name);

  /// `v1`
  static const RecordingStoreApiVersion v1 = _$recordingStoreApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RecordingStoreApiVersion> get values => _$recordingStoreApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RecordingStoreApiVersion valueOf(String name) => _$valueOfRecordingStoreApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RecordingStoreApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RecordingStoreApiVersion> get serializer => const _$RecordingStoreApiVersionSerializer();
}

class _$RecordingStoreApiVersionSerializer implements PrimitiveSerializer<RecordingStoreApiVersion> {
  const _$RecordingStoreApiVersionSerializer();

  static const Map<RecordingStoreApiVersion, Object> _toWire = <RecordingStoreApiVersion, Object>{
    RecordingStoreApiVersion.v1: 'v1',
  };

  static const Map<Object, RecordingStoreApiVersion> _fromWire = <Object, RecordingStoreApiVersion>{
    'v1': RecordingStoreApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [RecordingStoreApiVersion];

  @override
  String get wireName => 'RecordingStoreApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RecordingStoreApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RecordingStoreApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RecordingStoreResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RecordingStoreResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RecordingStoreResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RecordingStoreResponseApplicationJson_Ocs
    implements
        $RecordingStoreResponseApplicationJson_OcsInterface,
        Built<RecordingStoreResponseApplicationJson_Ocs, RecordingStoreResponseApplicationJson_OcsBuilder> {
  /// Creates a new RecordingStoreResponseApplicationJson_Ocs object using the builder pattern.
  factory RecordingStoreResponseApplicationJson_Ocs([
    void Function(RecordingStoreResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RecordingStoreResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RecordingStoreResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RecordingStoreResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RecordingStoreResponseApplicationJson_Ocs.
  static Serializer<RecordingStoreResponseApplicationJson_Ocs> get serializer =>
      _$recordingStoreResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RecordingStoreResponseApplicationJson_OcsBuilder b) {
    $RecordingStoreResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RecordingStoreResponseApplicationJson_OcsBuilder b) {
    $RecordingStoreResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RecordingStoreResponseApplicationJsonInterface {
  RecordingStoreResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RecordingStoreResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RecordingStoreResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RecordingStoreResponseApplicationJson
    implements
        $RecordingStoreResponseApplicationJsonInterface,
        Built<RecordingStoreResponseApplicationJson, RecordingStoreResponseApplicationJsonBuilder> {
  /// Creates a new RecordingStoreResponseApplicationJson object using the builder pattern.
  factory RecordingStoreResponseApplicationJson([void Function(RecordingStoreResponseApplicationJsonBuilder)? b]) =
      _$RecordingStoreResponseApplicationJson;

  // coverage:ignore-start
  const RecordingStoreResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RecordingStoreResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RecordingStoreResponseApplicationJson.
  static Serializer<RecordingStoreResponseApplicationJson> get serializer =>
      _$recordingStoreResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RecordingStoreResponseApplicationJsonBuilder b) {
    $RecordingStoreResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RecordingStoreResponseApplicationJsonBuilder b) {
    $RecordingStoreResponseApplicationJsonInterface._validate(b);
  }
}

class RoomGetRoomsNoStatusUpdate extends EnumClass {
  const RoomGetRoomsNoStatusUpdate._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const RoomGetRoomsNoStatusUpdate $0 = _$roomGetRoomsNoStatusUpdate$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const RoomGetRoomsNoStatusUpdate $1 = _$roomGetRoomsNoStatusUpdate$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomGetRoomsNoStatusUpdate> get values => _$roomGetRoomsNoStatusUpdateValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomGetRoomsNoStatusUpdate valueOf(String name) => _$valueOfRoomGetRoomsNoStatusUpdate(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for RoomGetRoomsNoStatusUpdate.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomGetRoomsNoStatusUpdate> get serializer => const _$RoomGetRoomsNoStatusUpdateSerializer();
}

class _$RoomGetRoomsNoStatusUpdateSerializer implements PrimitiveSerializer<RoomGetRoomsNoStatusUpdate> {
  const _$RoomGetRoomsNoStatusUpdateSerializer();

  static const Map<RoomGetRoomsNoStatusUpdate, Object> _toWire = <RoomGetRoomsNoStatusUpdate, Object>{
    RoomGetRoomsNoStatusUpdate.$0: 0,
    RoomGetRoomsNoStatusUpdate.$1: 1,
  };

  static const Map<Object, RoomGetRoomsNoStatusUpdate> _fromWire = <Object, RoomGetRoomsNoStatusUpdate>{
    0: RoomGetRoomsNoStatusUpdate.$0,
    1: RoomGetRoomsNoStatusUpdate.$1,
  };

  @override
  Iterable<Type> get types => const [RoomGetRoomsNoStatusUpdate];

  @override
  String get wireName => 'RoomGetRoomsNoStatusUpdate';

  @override
  Object serialize(
    Serializers serializers,
    RoomGetRoomsNoStatusUpdate object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomGetRoomsNoStatusUpdate deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class RoomGetRoomsIncludeStatus extends EnumClass {
  const RoomGetRoomsIncludeStatus._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const RoomGetRoomsIncludeStatus $0 = _$roomGetRoomsIncludeStatus$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const RoomGetRoomsIncludeStatus $1 = _$roomGetRoomsIncludeStatus$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomGetRoomsIncludeStatus> get values => _$roomGetRoomsIncludeStatusValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomGetRoomsIncludeStatus valueOf(String name) => _$valueOfRoomGetRoomsIncludeStatus(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for RoomGetRoomsIncludeStatus.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomGetRoomsIncludeStatus> get serializer => const _$RoomGetRoomsIncludeStatusSerializer();
}

class _$RoomGetRoomsIncludeStatusSerializer implements PrimitiveSerializer<RoomGetRoomsIncludeStatus> {
  const _$RoomGetRoomsIncludeStatusSerializer();

  static const Map<RoomGetRoomsIncludeStatus, Object> _toWire = <RoomGetRoomsIncludeStatus, Object>{
    RoomGetRoomsIncludeStatus.$0: 0,
    RoomGetRoomsIncludeStatus.$1: 1,
  };

  static const Map<Object, RoomGetRoomsIncludeStatus> _fromWire = <Object, RoomGetRoomsIncludeStatus>{
    0: RoomGetRoomsIncludeStatus.$0,
    1: RoomGetRoomsIncludeStatus.$1,
  };

  @override
  Iterable<Type> get types => const [RoomGetRoomsIncludeStatus];

  @override
  String get wireName => 'RoomGetRoomsIncludeStatus';

  @override
  Object serialize(
    Serializers serializers,
    RoomGetRoomsIncludeStatus object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomGetRoomsIncludeStatus deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class RoomGetRoomsApiVersion extends EnumClass {
  const RoomGetRoomsApiVersion._(super.name);

  /// `v4`
  static const RoomGetRoomsApiVersion v4 = _$roomGetRoomsApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomGetRoomsApiVersion> get values => _$roomGetRoomsApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomGetRoomsApiVersion valueOf(String name) => _$valueOfRoomGetRoomsApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomGetRoomsApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomGetRoomsApiVersion> get serializer => const _$RoomGetRoomsApiVersionSerializer();
}

class _$RoomGetRoomsApiVersionSerializer implements PrimitiveSerializer<RoomGetRoomsApiVersion> {
  const _$RoomGetRoomsApiVersionSerializer();

  static const Map<RoomGetRoomsApiVersion, Object> _toWire = <RoomGetRoomsApiVersion, Object>{
    RoomGetRoomsApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomGetRoomsApiVersion> _fromWire = <Object, RoomGetRoomsApiVersion>{
    'v4': RoomGetRoomsApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomGetRoomsApiVersion];

  @override
  String get wireName => 'RoomGetRoomsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomGetRoomsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomGetRoomsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomGetRoomsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<Room> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomGetRoomsResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomGetRoomsResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomGetRoomsResponseApplicationJson_Ocs
    implements
        $RoomGetRoomsResponseApplicationJson_OcsInterface,
        Built<RoomGetRoomsResponseApplicationJson_Ocs, RoomGetRoomsResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomGetRoomsResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomGetRoomsResponseApplicationJson_Ocs([void Function(RoomGetRoomsResponseApplicationJson_OcsBuilder)? b]) =
      _$RoomGetRoomsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomGetRoomsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomGetRoomsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomGetRoomsResponseApplicationJson_Ocs.
  static Serializer<RoomGetRoomsResponseApplicationJson_Ocs> get serializer =>
      _$roomGetRoomsResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomGetRoomsResponseApplicationJson_OcsBuilder b) {
    $RoomGetRoomsResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomGetRoomsResponseApplicationJson_OcsBuilder b) {
    $RoomGetRoomsResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomGetRoomsResponseApplicationJsonInterface {
  RoomGetRoomsResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomGetRoomsResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomGetRoomsResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomGetRoomsResponseApplicationJson
    implements
        $RoomGetRoomsResponseApplicationJsonInterface,
        Built<RoomGetRoomsResponseApplicationJson, RoomGetRoomsResponseApplicationJsonBuilder> {
  /// Creates a new RoomGetRoomsResponseApplicationJson object using the builder pattern.
  factory RoomGetRoomsResponseApplicationJson([void Function(RoomGetRoomsResponseApplicationJsonBuilder)? b]) =
      _$RoomGetRoomsResponseApplicationJson;

  // coverage:ignore-start
  const RoomGetRoomsResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomGetRoomsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomGetRoomsResponseApplicationJson.
  static Serializer<RoomGetRoomsResponseApplicationJson> get serializer =>
      _$roomGetRoomsResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomGetRoomsResponseApplicationJsonBuilder b) {
    $RoomGetRoomsResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomGetRoomsResponseApplicationJsonBuilder b) {
    $RoomGetRoomsResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomRoomGetRoomsHeadersInterface {
  @BuiltValueField(wireName: 'x-nextcloud-talk-hash')
  String? get xNextcloudTalkHash;
  @BuiltValueField(wireName: 'x-nextcloud-talk-modified-before')
  String? get xNextcloudTalkModifiedBefore;
  @BuiltValueField(wireName: 'x-nextcloud-talk-federation-invites')
  String? get xNextcloudTalkFederationInvites;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomRoomGetRoomsHeadersInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomRoomGetRoomsHeadersInterfaceBuilder b) {}
}

abstract class RoomRoomGetRoomsHeaders
    implements $RoomRoomGetRoomsHeadersInterface, Built<RoomRoomGetRoomsHeaders, RoomRoomGetRoomsHeadersBuilder> {
  /// Creates a new RoomRoomGetRoomsHeaders object using the builder pattern.
  factory RoomRoomGetRoomsHeaders([void Function(RoomRoomGetRoomsHeadersBuilder)? b]) = _$RoomRoomGetRoomsHeaders;

  // coverage:ignore-start
  const RoomRoomGetRoomsHeaders._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomRoomGetRoomsHeaders.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomRoomGetRoomsHeaders.
  static Serializer<RoomRoomGetRoomsHeaders> get serializer => _$roomRoomGetRoomsHeadersSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomRoomGetRoomsHeadersBuilder b) {
    $RoomRoomGetRoomsHeadersInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomRoomGetRoomsHeadersBuilder b) {
    $RoomRoomGetRoomsHeadersInterface._validate(b);
  }
}

class RoomCreateRoomApiVersion extends EnumClass {
  const RoomCreateRoomApiVersion._(super.name);

  /// `v4`
  static const RoomCreateRoomApiVersion v4 = _$roomCreateRoomApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomCreateRoomApiVersion> get values => _$roomCreateRoomApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomCreateRoomApiVersion valueOf(String name) => _$valueOfRoomCreateRoomApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomCreateRoomApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomCreateRoomApiVersion> get serializer => const _$RoomCreateRoomApiVersionSerializer();
}

class _$RoomCreateRoomApiVersionSerializer implements PrimitiveSerializer<RoomCreateRoomApiVersion> {
  const _$RoomCreateRoomApiVersionSerializer();

  static const Map<RoomCreateRoomApiVersion, Object> _toWire = <RoomCreateRoomApiVersion, Object>{
    RoomCreateRoomApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomCreateRoomApiVersion> _fromWire = <Object, RoomCreateRoomApiVersion>{
    'v4': RoomCreateRoomApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomCreateRoomApiVersion];

  @override
  String get wireName => 'RoomCreateRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomCreateRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomCreateRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomCreateRoomResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomCreateRoomResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomCreateRoomResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomCreateRoomResponseApplicationJson_Ocs
    implements
        $RoomCreateRoomResponseApplicationJson_OcsInterface,
        Built<RoomCreateRoomResponseApplicationJson_Ocs, RoomCreateRoomResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomCreateRoomResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomCreateRoomResponseApplicationJson_Ocs([
    void Function(RoomCreateRoomResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomCreateRoomResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomCreateRoomResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomCreateRoomResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomCreateRoomResponseApplicationJson_Ocs.
  static Serializer<RoomCreateRoomResponseApplicationJson_Ocs> get serializer =>
      _$roomCreateRoomResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomCreateRoomResponseApplicationJson_OcsBuilder b) {
    $RoomCreateRoomResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomCreateRoomResponseApplicationJson_OcsBuilder b) {
    $RoomCreateRoomResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomCreateRoomResponseApplicationJsonInterface {
  RoomCreateRoomResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomCreateRoomResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomCreateRoomResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomCreateRoomResponseApplicationJson
    implements
        $RoomCreateRoomResponseApplicationJsonInterface,
        Built<RoomCreateRoomResponseApplicationJson, RoomCreateRoomResponseApplicationJsonBuilder> {
  /// Creates a new RoomCreateRoomResponseApplicationJson object using the builder pattern.
  factory RoomCreateRoomResponseApplicationJson([void Function(RoomCreateRoomResponseApplicationJsonBuilder)? b]) =
      _$RoomCreateRoomResponseApplicationJson;

  // coverage:ignore-start
  const RoomCreateRoomResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomCreateRoomResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomCreateRoomResponseApplicationJson.
  static Serializer<RoomCreateRoomResponseApplicationJson> get serializer =>
      _$roomCreateRoomResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomCreateRoomResponseApplicationJsonBuilder b) {
    $RoomCreateRoomResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomCreateRoomResponseApplicationJsonBuilder b) {
    $RoomCreateRoomResponseApplicationJsonInterface._validate(b);
  }
}

class RoomGetListedRoomsApiVersion extends EnumClass {
  const RoomGetListedRoomsApiVersion._(super.name);

  /// `v4`
  static const RoomGetListedRoomsApiVersion v4 = _$roomGetListedRoomsApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomGetListedRoomsApiVersion> get values => _$roomGetListedRoomsApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomGetListedRoomsApiVersion valueOf(String name) => _$valueOfRoomGetListedRoomsApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomGetListedRoomsApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomGetListedRoomsApiVersion> get serializer => const _$RoomGetListedRoomsApiVersionSerializer();
}

class _$RoomGetListedRoomsApiVersionSerializer implements PrimitiveSerializer<RoomGetListedRoomsApiVersion> {
  const _$RoomGetListedRoomsApiVersionSerializer();

  static const Map<RoomGetListedRoomsApiVersion, Object> _toWire = <RoomGetListedRoomsApiVersion, Object>{
    RoomGetListedRoomsApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomGetListedRoomsApiVersion> _fromWire = <Object, RoomGetListedRoomsApiVersion>{
    'v4': RoomGetListedRoomsApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomGetListedRoomsApiVersion];

  @override
  String get wireName => 'RoomGetListedRoomsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomGetListedRoomsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomGetListedRoomsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomGetListedRoomsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<Room> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomGetListedRoomsResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomGetListedRoomsResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomGetListedRoomsResponseApplicationJson_Ocs
    implements
        $RoomGetListedRoomsResponseApplicationJson_OcsInterface,
        Built<RoomGetListedRoomsResponseApplicationJson_Ocs, RoomGetListedRoomsResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomGetListedRoomsResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomGetListedRoomsResponseApplicationJson_Ocs([
    void Function(RoomGetListedRoomsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomGetListedRoomsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomGetListedRoomsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomGetListedRoomsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomGetListedRoomsResponseApplicationJson_Ocs.
  static Serializer<RoomGetListedRoomsResponseApplicationJson_Ocs> get serializer =>
      _$roomGetListedRoomsResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomGetListedRoomsResponseApplicationJson_OcsBuilder b) {
    $RoomGetListedRoomsResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomGetListedRoomsResponseApplicationJson_OcsBuilder b) {
    $RoomGetListedRoomsResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomGetListedRoomsResponseApplicationJsonInterface {
  RoomGetListedRoomsResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomGetListedRoomsResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomGetListedRoomsResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomGetListedRoomsResponseApplicationJson
    implements
        $RoomGetListedRoomsResponseApplicationJsonInterface,
        Built<RoomGetListedRoomsResponseApplicationJson, RoomGetListedRoomsResponseApplicationJsonBuilder> {
  /// Creates a new RoomGetListedRoomsResponseApplicationJson object using the builder pattern.
  factory RoomGetListedRoomsResponseApplicationJson([
    void Function(RoomGetListedRoomsResponseApplicationJsonBuilder)? b,
  ]) = _$RoomGetListedRoomsResponseApplicationJson;

  // coverage:ignore-start
  const RoomGetListedRoomsResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomGetListedRoomsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomGetListedRoomsResponseApplicationJson.
  static Serializer<RoomGetListedRoomsResponseApplicationJson> get serializer =>
      _$roomGetListedRoomsResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomGetListedRoomsResponseApplicationJsonBuilder b) {
    $RoomGetListedRoomsResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomGetListedRoomsResponseApplicationJsonBuilder b) {
    $RoomGetListedRoomsResponseApplicationJsonInterface._validate(b);
  }
}

class RoomGetNoteToSelfConversationApiVersion extends EnumClass {
  const RoomGetNoteToSelfConversationApiVersion._(super.name);

  /// `v4`
  static const RoomGetNoteToSelfConversationApiVersion v4 = _$roomGetNoteToSelfConversationApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomGetNoteToSelfConversationApiVersion> get values =>
      _$roomGetNoteToSelfConversationApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomGetNoteToSelfConversationApiVersion valueOf(String name) =>
      _$valueOfRoomGetNoteToSelfConversationApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomGetNoteToSelfConversationApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomGetNoteToSelfConversationApiVersion> get serializer =>
      const _$RoomGetNoteToSelfConversationApiVersionSerializer();
}

class _$RoomGetNoteToSelfConversationApiVersionSerializer
    implements PrimitiveSerializer<RoomGetNoteToSelfConversationApiVersion> {
  const _$RoomGetNoteToSelfConversationApiVersionSerializer();

  static const Map<RoomGetNoteToSelfConversationApiVersion, Object> _toWire =
      <RoomGetNoteToSelfConversationApiVersion, Object>{
    RoomGetNoteToSelfConversationApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomGetNoteToSelfConversationApiVersion> _fromWire =
      <Object, RoomGetNoteToSelfConversationApiVersion>{
    'v4': RoomGetNoteToSelfConversationApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomGetNoteToSelfConversationApiVersion];

  @override
  String get wireName => 'RoomGetNoteToSelfConversationApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomGetNoteToSelfConversationApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomGetNoteToSelfConversationApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomGetNoteToSelfConversationResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomGetNoteToSelfConversationResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomGetNoteToSelfConversationResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomGetNoteToSelfConversationResponseApplicationJson_Ocs
    implements
        $RoomGetNoteToSelfConversationResponseApplicationJson_OcsInterface,
        Built<RoomGetNoteToSelfConversationResponseApplicationJson_Ocs,
            RoomGetNoteToSelfConversationResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomGetNoteToSelfConversationResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomGetNoteToSelfConversationResponseApplicationJson_Ocs([
    void Function(RoomGetNoteToSelfConversationResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomGetNoteToSelfConversationResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomGetNoteToSelfConversationResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomGetNoteToSelfConversationResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomGetNoteToSelfConversationResponseApplicationJson_Ocs.
  static Serializer<RoomGetNoteToSelfConversationResponseApplicationJson_Ocs> get serializer =>
      _$roomGetNoteToSelfConversationResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomGetNoteToSelfConversationResponseApplicationJson_OcsBuilder b) {
    $RoomGetNoteToSelfConversationResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomGetNoteToSelfConversationResponseApplicationJson_OcsBuilder b) {
    $RoomGetNoteToSelfConversationResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomGetNoteToSelfConversationResponseApplicationJsonInterface {
  RoomGetNoteToSelfConversationResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomGetNoteToSelfConversationResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomGetNoteToSelfConversationResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomGetNoteToSelfConversationResponseApplicationJson
    implements
        $RoomGetNoteToSelfConversationResponseApplicationJsonInterface,
        Built<RoomGetNoteToSelfConversationResponseApplicationJson,
            RoomGetNoteToSelfConversationResponseApplicationJsonBuilder> {
  /// Creates a new RoomGetNoteToSelfConversationResponseApplicationJson object using the builder pattern.
  factory RoomGetNoteToSelfConversationResponseApplicationJson([
    void Function(RoomGetNoteToSelfConversationResponseApplicationJsonBuilder)? b,
  ]) = _$RoomGetNoteToSelfConversationResponseApplicationJson;

  // coverage:ignore-start
  const RoomGetNoteToSelfConversationResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomGetNoteToSelfConversationResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomGetNoteToSelfConversationResponseApplicationJson.
  static Serializer<RoomGetNoteToSelfConversationResponseApplicationJson> get serializer =>
      _$roomGetNoteToSelfConversationResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomGetNoteToSelfConversationResponseApplicationJsonBuilder b) {
    $RoomGetNoteToSelfConversationResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomGetNoteToSelfConversationResponseApplicationJsonBuilder b) {
    $RoomGetNoteToSelfConversationResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomRoomGetNoteToSelfConversationHeadersInterface {
  @BuiltValueField(wireName: 'x-nextcloud-talk-hash')
  String? get xNextcloudTalkHash;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomRoomGetNoteToSelfConversationHeadersInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomRoomGetNoteToSelfConversationHeadersInterfaceBuilder b) {}
}

abstract class RoomRoomGetNoteToSelfConversationHeaders
    implements
        $RoomRoomGetNoteToSelfConversationHeadersInterface,
        Built<RoomRoomGetNoteToSelfConversationHeaders, RoomRoomGetNoteToSelfConversationHeadersBuilder> {
  /// Creates a new RoomRoomGetNoteToSelfConversationHeaders object using the builder pattern.
  factory RoomRoomGetNoteToSelfConversationHeaders([
    void Function(RoomRoomGetNoteToSelfConversationHeadersBuilder)? b,
  ]) = _$RoomRoomGetNoteToSelfConversationHeaders;

  // coverage:ignore-start
  const RoomRoomGetNoteToSelfConversationHeaders._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomRoomGetNoteToSelfConversationHeaders.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomRoomGetNoteToSelfConversationHeaders.
  static Serializer<RoomRoomGetNoteToSelfConversationHeaders> get serializer =>
      _$roomRoomGetNoteToSelfConversationHeadersSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomRoomGetNoteToSelfConversationHeadersBuilder b) {
    $RoomRoomGetNoteToSelfConversationHeadersInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomRoomGetNoteToSelfConversationHeadersBuilder b) {
    $RoomRoomGetNoteToSelfConversationHeadersInterface._validate(b);
  }
}

class RoomGetSingleRoomApiVersion extends EnumClass {
  const RoomGetSingleRoomApiVersion._(super.name);

  /// `v4`
  static const RoomGetSingleRoomApiVersion v4 = _$roomGetSingleRoomApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomGetSingleRoomApiVersion> get values => _$roomGetSingleRoomApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomGetSingleRoomApiVersion valueOf(String name) => _$valueOfRoomGetSingleRoomApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomGetSingleRoomApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomGetSingleRoomApiVersion> get serializer => const _$RoomGetSingleRoomApiVersionSerializer();
}

class _$RoomGetSingleRoomApiVersionSerializer implements PrimitiveSerializer<RoomGetSingleRoomApiVersion> {
  const _$RoomGetSingleRoomApiVersionSerializer();

  static const Map<RoomGetSingleRoomApiVersion, Object> _toWire = <RoomGetSingleRoomApiVersion, Object>{
    RoomGetSingleRoomApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomGetSingleRoomApiVersion> _fromWire = <Object, RoomGetSingleRoomApiVersion>{
    'v4': RoomGetSingleRoomApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomGetSingleRoomApiVersion];

  @override
  String get wireName => 'RoomGetSingleRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomGetSingleRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomGetSingleRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomGetSingleRoomResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomGetSingleRoomResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomGetSingleRoomResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomGetSingleRoomResponseApplicationJson_Ocs
    implements
        $RoomGetSingleRoomResponseApplicationJson_OcsInterface,
        Built<RoomGetSingleRoomResponseApplicationJson_Ocs, RoomGetSingleRoomResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomGetSingleRoomResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomGetSingleRoomResponseApplicationJson_Ocs([
    void Function(RoomGetSingleRoomResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomGetSingleRoomResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomGetSingleRoomResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomGetSingleRoomResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomGetSingleRoomResponseApplicationJson_Ocs.
  static Serializer<RoomGetSingleRoomResponseApplicationJson_Ocs> get serializer =>
      _$roomGetSingleRoomResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomGetSingleRoomResponseApplicationJson_OcsBuilder b) {
    $RoomGetSingleRoomResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomGetSingleRoomResponseApplicationJson_OcsBuilder b) {
    $RoomGetSingleRoomResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomGetSingleRoomResponseApplicationJsonInterface {
  RoomGetSingleRoomResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomGetSingleRoomResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomGetSingleRoomResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomGetSingleRoomResponseApplicationJson
    implements
        $RoomGetSingleRoomResponseApplicationJsonInterface,
        Built<RoomGetSingleRoomResponseApplicationJson, RoomGetSingleRoomResponseApplicationJsonBuilder> {
  /// Creates a new RoomGetSingleRoomResponseApplicationJson object using the builder pattern.
  factory RoomGetSingleRoomResponseApplicationJson([
    void Function(RoomGetSingleRoomResponseApplicationJsonBuilder)? b,
  ]) = _$RoomGetSingleRoomResponseApplicationJson;

  // coverage:ignore-start
  const RoomGetSingleRoomResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomGetSingleRoomResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomGetSingleRoomResponseApplicationJson.
  static Serializer<RoomGetSingleRoomResponseApplicationJson> get serializer =>
      _$roomGetSingleRoomResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomGetSingleRoomResponseApplicationJsonBuilder b) {
    $RoomGetSingleRoomResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomGetSingleRoomResponseApplicationJsonBuilder b) {
    $RoomGetSingleRoomResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomRoomGetSingleRoomHeadersInterface {
  @BuiltValueField(wireName: 'x-nextcloud-talk-hash')
  String? get xNextcloudTalkHash;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomRoomGetSingleRoomHeadersInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomRoomGetSingleRoomHeadersInterfaceBuilder b) {}
}

abstract class RoomRoomGetSingleRoomHeaders
    implements
        $RoomRoomGetSingleRoomHeadersInterface,
        Built<RoomRoomGetSingleRoomHeaders, RoomRoomGetSingleRoomHeadersBuilder> {
  /// Creates a new RoomRoomGetSingleRoomHeaders object using the builder pattern.
  factory RoomRoomGetSingleRoomHeaders([void Function(RoomRoomGetSingleRoomHeadersBuilder)? b]) =
      _$RoomRoomGetSingleRoomHeaders;

  // coverage:ignore-start
  const RoomRoomGetSingleRoomHeaders._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomRoomGetSingleRoomHeaders.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomRoomGetSingleRoomHeaders.
  static Serializer<RoomRoomGetSingleRoomHeaders> get serializer => _$roomRoomGetSingleRoomHeadersSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomRoomGetSingleRoomHeadersBuilder b) {
    $RoomRoomGetSingleRoomHeadersInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomRoomGetSingleRoomHeadersBuilder b) {
    $RoomRoomGetSingleRoomHeadersInterface._validate(b);
  }
}

class RoomGetBreakoutRoomsApiVersion extends EnumClass {
  const RoomGetBreakoutRoomsApiVersion._(super.name);

  /// `v4`
  static const RoomGetBreakoutRoomsApiVersion v4 = _$roomGetBreakoutRoomsApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomGetBreakoutRoomsApiVersion> get values => _$roomGetBreakoutRoomsApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomGetBreakoutRoomsApiVersion valueOf(String name) => _$valueOfRoomGetBreakoutRoomsApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomGetBreakoutRoomsApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomGetBreakoutRoomsApiVersion> get serializer =>
      const _$RoomGetBreakoutRoomsApiVersionSerializer();
}

class _$RoomGetBreakoutRoomsApiVersionSerializer implements PrimitiveSerializer<RoomGetBreakoutRoomsApiVersion> {
  const _$RoomGetBreakoutRoomsApiVersionSerializer();

  static const Map<RoomGetBreakoutRoomsApiVersion, Object> _toWire = <RoomGetBreakoutRoomsApiVersion, Object>{
    RoomGetBreakoutRoomsApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomGetBreakoutRoomsApiVersion> _fromWire = <Object, RoomGetBreakoutRoomsApiVersion>{
    'v4': RoomGetBreakoutRoomsApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomGetBreakoutRoomsApiVersion];

  @override
  String get wireName => 'RoomGetBreakoutRoomsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomGetBreakoutRoomsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomGetBreakoutRoomsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomGetBreakoutRoomsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<Room> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomGetBreakoutRoomsResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomGetBreakoutRoomsResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomGetBreakoutRoomsResponseApplicationJson_Ocs
    implements
        $RoomGetBreakoutRoomsResponseApplicationJson_OcsInterface,
        Built<RoomGetBreakoutRoomsResponseApplicationJson_Ocs, RoomGetBreakoutRoomsResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomGetBreakoutRoomsResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomGetBreakoutRoomsResponseApplicationJson_Ocs([
    void Function(RoomGetBreakoutRoomsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomGetBreakoutRoomsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomGetBreakoutRoomsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomGetBreakoutRoomsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomGetBreakoutRoomsResponseApplicationJson_Ocs.
  static Serializer<RoomGetBreakoutRoomsResponseApplicationJson_Ocs> get serializer =>
      _$roomGetBreakoutRoomsResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomGetBreakoutRoomsResponseApplicationJson_OcsBuilder b) {
    $RoomGetBreakoutRoomsResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomGetBreakoutRoomsResponseApplicationJson_OcsBuilder b) {
    $RoomGetBreakoutRoomsResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomGetBreakoutRoomsResponseApplicationJsonInterface {
  RoomGetBreakoutRoomsResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomGetBreakoutRoomsResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomGetBreakoutRoomsResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomGetBreakoutRoomsResponseApplicationJson
    implements
        $RoomGetBreakoutRoomsResponseApplicationJsonInterface,
        Built<RoomGetBreakoutRoomsResponseApplicationJson, RoomGetBreakoutRoomsResponseApplicationJsonBuilder> {
  /// Creates a new RoomGetBreakoutRoomsResponseApplicationJson object using the builder pattern.
  factory RoomGetBreakoutRoomsResponseApplicationJson([
    void Function(RoomGetBreakoutRoomsResponseApplicationJsonBuilder)? b,
  ]) = _$RoomGetBreakoutRoomsResponseApplicationJson;

  // coverage:ignore-start
  const RoomGetBreakoutRoomsResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomGetBreakoutRoomsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomGetBreakoutRoomsResponseApplicationJson.
  static Serializer<RoomGetBreakoutRoomsResponseApplicationJson> get serializer =>
      _$roomGetBreakoutRoomsResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomGetBreakoutRoomsResponseApplicationJsonBuilder b) {
    $RoomGetBreakoutRoomsResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomGetBreakoutRoomsResponseApplicationJsonBuilder b) {
    $RoomGetBreakoutRoomsResponseApplicationJsonInterface._validate(b);
  }
}

class RoomMakePublicApiVersion extends EnumClass {
  const RoomMakePublicApiVersion._(super.name);

  /// `v4`
  static const RoomMakePublicApiVersion v4 = _$roomMakePublicApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomMakePublicApiVersion> get values => _$roomMakePublicApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomMakePublicApiVersion valueOf(String name) => _$valueOfRoomMakePublicApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomMakePublicApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomMakePublicApiVersion> get serializer => const _$RoomMakePublicApiVersionSerializer();
}

class _$RoomMakePublicApiVersionSerializer implements PrimitiveSerializer<RoomMakePublicApiVersion> {
  const _$RoomMakePublicApiVersionSerializer();

  static const Map<RoomMakePublicApiVersion, Object> _toWire = <RoomMakePublicApiVersion, Object>{
    RoomMakePublicApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomMakePublicApiVersion> _fromWire = <Object, RoomMakePublicApiVersion>{
    'v4': RoomMakePublicApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomMakePublicApiVersion];

  @override
  String get wireName => 'RoomMakePublicApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomMakePublicApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomMakePublicApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomMakePublicResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomMakePublicResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomMakePublicResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomMakePublicResponseApplicationJson_Ocs
    implements
        $RoomMakePublicResponseApplicationJson_OcsInterface,
        Built<RoomMakePublicResponseApplicationJson_Ocs, RoomMakePublicResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomMakePublicResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomMakePublicResponseApplicationJson_Ocs([
    void Function(RoomMakePublicResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomMakePublicResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomMakePublicResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomMakePublicResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomMakePublicResponseApplicationJson_Ocs.
  static Serializer<RoomMakePublicResponseApplicationJson_Ocs> get serializer =>
      _$roomMakePublicResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomMakePublicResponseApplicationJson_OcsBuilder b) {
    $RoomMakePublicResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomMakePublicResponseApplicationJson_OcsBuilder b) {
    $RoomMakePublicResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomMakePublicResponseApplicationJsonInterface {
  RoomMakePublicResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomMakePublicResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomMakePublicResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomMakePublicResponseApplicationJson
    implements
        $RoomMakePublicResponseApplicationJsonInterface,
        Built<RoomMakePublicResponseApplicationJson, RoomMakePublicResponseApplicationJsonBuilder> {
  /// Creates a new RoomMakePublicResponseApplicationJson object using the builder pattern.
  factory RoomMakePublicResponseApplicationJson([void Function(RoomMakePublicResponseApplicationJsonBuilder)? b]) =
      _$RoomMakePublicResponseApplicationJson;

  // coverage:ignore-start
  const RoomMakePublicResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomMakePublicResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomMakePublicResponseApplicationJson.
  static Serializer<RoomMakePublicResponseApplicationJson> get serializer =>
      _$roomMakePublicResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomMakePublicResponseApplicationJsonBuilder b) {
    $RoomMakePublicResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomMakePublicResponseApplicationJsonBuilder b) {
    $RoomMakePublicResponseApplicationJsonInterface._validate(b);
  }
}

class RoomMakePrivateApiVersion extends EnumClass {
  const RoomMakePrivateApiVersion._(super.name);

  /// `v4`
  static const RoomMakePrivateApiVersion v4 = _$roomMakePrivateApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomMakePrivateApiVersion> get values => _$roomMakePrivateApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomMakePrivateApiVersion valueOf(String name) => _$valueOfRoomMakePrivateApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomMakePrivateApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomMakePrivateApiVersion> get serializer => const _$RoomMakePrivateApiVersionSerializer();
}

class _$RoomMakePrivateApiVersionSerializer implements PrimitiveSerializer<RoomMakePrivateApiVersion> {
  const _$RoomMakePrivateApiVersionSerializer();

  static const Map<RoomMakePrivateApiVersion, Object> _toWire = <RoomMakePrivateApiVersion, Object>{
    RoomMakePrivateApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomMakePrivateApiVersion> _fromWire = <Object, RoomMakePrivateApiVersion>{
    'v4': RoomMakePrivateApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomMakePrivateApiVersion];

  @override
  String get wireName => 'RoomMakePrivateApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomMakePrivateApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomMakePrivateApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomMakePrivateResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomMakePrivateResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomMakePrivateResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomMakePrivateResponseApplicationJson_Ocs
    implements
        $RoomMakePrivateResponseApplicationJson_OcsInterface,
        Built<RoomMakePrivateResponseApplicationJson_Ocs, RoomMakePrivateResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomMakePrivateResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomMakePrivateResponseApplicationJson_Ocs([
    void Function(RoomMakePrivateResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomMakePrivateResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomMakePrivateResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomMakePrivateResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomMakePrivateResponseApplicationJson_Ocs.
  static Serializer<RoomMakePrivateResponseApplicationJson_Ocs> get serializer =>
      _$roomMakePrivateResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomMakePrivateResponseApplicationJson_OcsBuilder b) {
    $RoomMakePrivateResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomMakePrivateResponseApplicationJson_OcsBuilder b) {
    $RoomMakePrivateResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomMakePrivateResponseApplicationJsonInterface {
  RoomMakePrivateResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomMakePrivateResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomMakePrivateResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomMakePrivateResponseApplicationJson
    implements
        $RoomMakePrivateResponseApplicationJsonInterface,
        Built<RoomMakePrivateResponseApplicationJson, RoomMakePrivateResponseApplicationJsonBuilder> {
  /// Creates a new RoomMakePrivateResponseApplicationJson object using the builder pattern.
  factory RoomMakePrivateResponseApplicationJson([void Function(RoomMakePrivateResponseApplicationJsonBuilder)? b]) =
      _$RoomMakePrivateResponseApplicationJson;

  // coverage:ignore-start
  const RoomMakePrivateResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomMakePrivateResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomMakePrivateResponseApplicationJson.
  static Serializer<RoomMakePrivateResponseApplicationJson> get serializer =>
      _$roomMakePrivateResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomMakePrivateResponseApplicationJsonBuilder b) {
    $RoomMakePrivateResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomMakePrivateResponseApplicationJsonBuilder b) {
    $RoomMakePrivateResponseApplicationJsonInterface._validate(b);
  }
}

class RoomSetDescriptionApiVersion extends EnumClass {
  const RoomSetDescriptionApiVersion._(super.name);

  /// `v4`
  static const RoomSetDescriptionApiVersion v4 = _$roomSetDescriptionApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomSetDescriptionApiVersion> get values => _$roomSetDescriptionApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomSetDescriptionApiVersion valueOf(String name) => _$valueOfRoomSetDescriptionApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomSetDescriptionApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetDescriptionApiVersion> get serializer => const _$RoomSetDescriptionApiVersionSerializer();
}

class _$RoomSetDescriptionApiVersionSerializer implements PrimitiveSerializer<RoomSetDescriptionApiVersion> {
  const _$RoomSetDescriptionApiVersionSerializer();

  static const Map<RoomSetDescriptionApiVersion, Object> _toWire = <RoomSetDescriptionApiVersion, Object>{
    RoomSetDescriptionApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomSetDescriptionApiVersion> _fromWire = <Object, RoomSetDescriptionApiVersion>{
    'v4': RoomSetDescriptionApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomSetDescriptionApiVersion];

  @override
  String get wireName => 'RoomSetDescriptionApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetDescriptionApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetDescriptionApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetDescriptionResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomSetDescriptionResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomSetDescriptionResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomSetDescriptionResponseApplicationJson_Ocs
    implements
        $RoomSetDescriptionResponseApplicationJson_OcsInterface,
        Built<RoomSetDescriptionResponseApplicationJson_Ocs, RoomSetDescriptionResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomSetDescriptionResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomSetDescriptionResponseApplicationJson_Ocs([
    void Function(RoomSetDescriptionResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomSetDescriptionResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomSetDescriptionResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomSetDescriptionResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomSetDescriptionResponseApplicationJson_Ocs.
  static Serializer<RoomSetDescriptionResponseApplicationJson_Ocs> get serializer =>
      _$roomSetDescriptionResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomSetDescriptionResponseApplicationJson_OcsBuilder b) {
    $RoomSetDescriptionResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomSetDescriptionResponseApplicationJson_OcsBuilder b) {
    $RoomSetDescriptionResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetDescriptionResponseApplicationJsonInterface {
  RoomSetDescriptionResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomSetDescriptionResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomSetDescriptionResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomSetDescriptionResponseApplicationJson
    implements
        $RoomSetDescriptionResponseApplicationJsonInterface,
        Built<RoomSetDescriptionResponseApplicationJson, RoomSetDescriptionResponseApplicationJsonBuilder> {
  /// Creates a new RoomSetDescriptionResponseApplicationJson object using the builder pattern.
  factory RoomSetDescriptionResponseApplicationJson([
    void Function(RoomSetDescriptionResponseApplicationJsonBuilder)? b,
  ]) = _$RoomSetDescriptionResponseApplicationJson;

  // coverage:ignore-start
  const RoomSetDescriptionResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomSetDescriptionResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomSetDescriptionResponseApplicationJson.
  static Serializer<RoomSetDescriptionResponseApplicationJson> get serializer =>
      _$roomSetDescriptionResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomSetDescriptionResponseApplicationJsonBuilder b) {
    $RoomSetDescriptionResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomSetDescriptionResponseApplicationJsonBuilder b) {
    $RoomSetDescriptionResponseApplicationJsonInterface._validate(b);
  }
}

class RoomSetReadOnlyState extends EnumClass {
  const RoomSetReadOnlyState._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const RoomSetReadOnlyState $0 = _$roomSetReadOnlyState$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const RoomSetReadOnlyState $1 = _$roomSetReadOnlyState$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomSetReadOnlyState> get values => _$roomSetReadOnlyStateValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomSetReadOnlyState valueOf(String name) => _$valueOfRoomSetReadOnlyState(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for RoomSetReadOnlyState.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetReadOnlyState> get serializer => const _$RoomSetReadOnlyStateSerializer();
}

class _$RoomSetReadOnlyStateSerializer implements PrimitiveSerializer<RoomSetReadOnlyState> {
  const _$RoomSetReadOnlyStateSerializer();

  static const Map<RoomSetReadOnlyState, Object> _toWire = <RoomSetReadOnlyState, Object>{
    RoomSetReadOnlyState.$0: 0,
    RoomSetReadOnlyState.$1: 1,
  };

  static const Map<Object, RoomSetReadOnlyState> _fromWire = <Object, RoomSetReadOnlyState>{
    0: RoomSetReadOnlyState.$0,
    1: RoomSetReadOnlyState.$1,
  };

  @override
  Iterable<Type> get types => const [RoomSetReadOnlyState];

  @override
  String get wireName => 'RoomSetReadOnlyState';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetReadOnlyState object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetReadOnlyState deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class RoomSetReadOnlyApiVersion extends EnumClass {
  const RoomSetReadOnlyApiVersion._(super.name);

  /// `v4`
  static const RoomSetReadOnlyApiVersion v4 = _$roomSetReadOnlyApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomSetReadOnlyApiVersion> get values => _$roomSetReadOnlyApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomSetReadOnlyApiVersion valueOf(String name) => _$valueOfRoomSetReadOnlyApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomSetReadOnlyApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetReadOnlyApiVersion> get serializer => const _$RoomSetReadOnlyApiVersionSerializer();
}

class _$RoomSetReadOnlyApiVersionSerializer implements PrimitiveSerializer<RoomSetReadOnlyApiVersion> {
  const _$RoomSetReadOnlyApiVersionSerializer();

  static const Map<RoomSetReadOnlyApiVersion, Object> _toWire = <RoomSetReadOnlyApiVersion, Object>{
    RoomSetReadOnlyApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomSetReadOnlyApiVersion> _fromWire = <Object, RoomSetReadOnlyApiVersion>{
    'v4': RoomSetReadOnlyApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomSetReadOnlyApiVersion];

  @override
  String get wireName => 'RoomSetReadOnlyApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetReadOnlyApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetReadOnlyApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetReadOnlyResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomSetReadOnlyResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomSetReadOnlyResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomSetReadOnlyResponseApplicationJson_Ocs
    implements
        $RoomSetReadOnlyResponseApplicationJson_OcsInterface,
        Built<RoomSetReadOnlyResponseApplicationJson_Ocs, RoomSetReadOnlyResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomSetReadOnlyResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomSetReadOnlyResponseApplicationJson_Ocs([
    void Function(RoomSetReadOnlyResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomSetReadOnlyResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomSetReadOnlyResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomSetReadOnlyResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomSetReadOnlyResponseApplicationJson_Ocs.
  static Serializer<RoomSetReadOnlyResponseApplicationJson_Ocs> get serializer =>
      _$roomSetReadOnlyResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomSetReadOnlyResponseApplicationJson_OcsBuilder b) {
    $RoomSetReadOnlyResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomSetReadOnlyResponseApplicationJson_OcsBuilder b) {
    $RoomSetReadOnlyResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetReadOnlyResponseApplicationJsonInterface {
  RoomSetReadOnlyResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomSetReadOnlyResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomSetReadOnlyResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomSetReadOnlyResponseApplicationJson
    implements
        $RoomSetReadOnlyResponseApplicationJsonInterface,
        Built<RoomSetReadOnlyResponseApplicationJson, RoomSetReadOnlyResponseApplicationJsonBuilder> {
  /// Creates a new RoomSetReadOnlyResponseApplicationJson object using the builder pattern.
  factory RoomSetReadOnlyResponseApplicationJson([void Function(RoomSetReadOnlyResponseApplicationJsonBuilder)? b]) =
      _$RoomSetReadOnlyResponseApplicationJson;

  // coverage:ignore-start
  const RoomSetReadOnlyResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomSetReadOnlyResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomSetReadOnlyResponseApplicationJson.
  static Serializer<RoomSetReadOnlyResponseApplicationJson> get serializer =>
      _$roomSetReadOnlyResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomSetReadOnlyResponseApplicationJsonBuilder b) {
    $RoomSetReadOnlyResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomSetReadOnlyResponseApplicationJsonBuilder b) {
    $RoomSetReadOnlyResponseApplicationJsonInterface._validate(b);
  }
}

class RoomSetListableScope extends EnumClass {
  const RoomSetListableScope._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const RoomSetListableScope $0 = _$roomSetListableScope$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const RoomSetListableScope $1 = _$roomSetListableScope$1;

  /// `2`
  @BuiltValueEnumConst(wireName: '2')
  static const RoomSetListableScope $2 = _$roomSetListableScope$2;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomSetListableScope> get values => _$roomSetListableScopeValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomSetListableScope valueOf(String name) => _$valueOfRoomSetListableScope(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for RoomSetListableScope.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetListableScope> get serializer => const _$RoomSetListableScopeSerializer();
}

class _$RoomSetListableScopeSerializer implements PrimitiveSerializer<RoomSetListableScope> {
  const _$RoomSetListableScopeSerializer();

  static const Map<RoomSetListableScope, Object> _toWire = <RoomSetListableScope, Object>{
    RoomSetListableScope.$0: 0,
    RoomSetListableScope.$1: 1,
    RoomSetListableScope.$2: 2,
  };

  static const Map<Object, RoomSetListableScope> _fromWire = <Object, RoomSetListableScope>{
    0: RoomSetListableScope.$0,
    1: RoomSetListableScope.$1,
    2: RoomSetListableScope.$2,
  };

  @override
  Iterable<Type> get types => const [RoomSetListableScope];

  @override
  String get wireName => 'RoomSetListableScope';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetListableScope object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetListableScope deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class RoomSetListableApiVersion extends EnumClass {
  const RoomSetListableApiVersion._(super.name);

  /// `v4`
  static const RoomSetListableApiVersion v4 = _$roomSetListableApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomSetListableApiVersion> get values => _$roomSetListableApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomSetListableApiVersion valueOf(String name) => _$valueOfRoomSetListableApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomSetListableApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetListableApiVersion> get serializer => const _$RoomSetListableApiVersionSerializer();
}

class _$RoomSetListableApiVersionSerializer implements PrimitiveSerializer<RoomSetListableApiVersion> {
  const _$RoomSetListableApiVersionSerializer();

  static const Map<RoomSetListableApiVersion, Object> _toWire = <RoomSetListableApiVersion, Object>{
    RoomSetListableApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomSetListableApiVersion> _fromWire = <Object, RoomSetListableApiVersion>{
    'v4': RoomSetListableApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomSetListableApiVersion];

  @override
  String get wireName => 'RoomSetListableApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetListableApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetListableApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetListableResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomSetListableResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomSetListableResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomSetListableResponseApplicationJson_Ocs
    implements
        $RoomSetListableResponseApplicationJson_OcsInterface,
        Built<RoomSetListableResponseApplicationJson_Ocs, RoomSetListableResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomSetListableResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomSetListableResponseApplicationJson_Ocs([
    void Function(RoomSetListableResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomSetListableResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomSetListableResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomSetListableResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomSetListableResponseApplicationJson_Ocs.
  static Serializer<RoomSetListableResponseApplicationJson_Ocs> get serializer =>
      _$roomSetListableResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomSetListableResponseApplicationJson_OcsBuilder b) {
    $RoomSetListableResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomSetListableResponseApplicationJson_OcsBuilder b) {
    $RoomSetListableResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetListableResponseApplicationJsonInterface {
  RoomSetListableResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomSetListableResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomSetListableResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomSetListableResponseApplicationJson
    implements
        $RoomSetListableResponseApplicationJsonInterface,
        Built<RoomSetListableResponseApplicationJson, RoomSetListableResponseApplicationJsonBuilder> {
  /// Creates a new RoomSetListableResponseApplicationJson object using the builder pattern.
  factory RoomSetListableResponseApplicationJson([void Function(RoomSetListableResponseApplicationJsonBuilder)? b]) =
      _$RoomSetListableResponseApplicationJson;

  // coverage:ignore-start
  const RoomSetListableResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomSetListableResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomSetListableResponseApplicationJson.
  static Serializer<RoomSetListableResponseApplicationJson> get serializer =>
      _$roomSetListableResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomSetListableResponseApplicationJsonBuilder b) {
    $RoomSetListableResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomSetListableResponseApplicationJsonBuilder b) {
    $RoomSetListableResponseApplicationJsonInterface._validate(b);
  }
}

class RoomSetPasswordApiVersion extends EnumClass {
  const RoomSetPasswordApiVersion._(super.name);

  /// `v4`
  static const RoomSetPasswordApiVersion v4 = _$roomSetPasswordApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomSetPasswordApiVersion> get values => _$roomSetPasswordApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomSetPasswordApiVersion valueOf(String name) => _$valueOfRoomSetPasswordApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomSetPasswordApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetPasswordApiVersion> get serializer => const _$RoomSetPasswordApiVersionSerializer();
}

class _$RoomSetPasswordApiVersionSerializer implements PrimitiveSerializer<RoomSetPasswordApiVersion> {
  const _$RoomSetPasswordApiVersionSerializer();

  static const Map<RoomSetPasswordApiVersion, Object> _toWire = <RoomSetPasswordApiVersion, Object>{
    RoomSetPasswordApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomSetPasswordApiVersion> _fromWire = <Object, RoomSetPasswordApiVersion>{
    'v4': RoomSetPasswordApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomSetPasswordApiVersion];

  @override
  String get wireName => 'RoomSetPasswordApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetPasswordApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetPasswordApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetPasswordResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomSetPasswordResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomSetPasswordResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomSetPasswordResponseApplicationJson_Ocs
    implements
        $RoomSetPasswordResponseApplicationJson_OcsInterface,
        Built<RoomSetPasswordResponseApplicationJson_Ocs, RoomSetPasswordResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomSetPasswordResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomSetPasswordResponseApplicationJson_Ocs([
    void Function(RoomSetPasswordResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomSetPasswordResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomSetPasswordResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomSetPasswordResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomSetPasswordResponseApplicationJson_Ocs.
  static Serializer<RoomSetPasswordResponseApplicationJson_Ocs> get serializer =>
      _$roomSetPasswordResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomSetPasswordResponseApplicationJson_OcsBuilder b) {
    $RoomSetPasswordResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomSetPasswordResponseApplicationJson_OcsBuilder b) {
    $RoomSetPasswordResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetPasswordResponseApplicationJsonInterface {
  RoomSetPasswordResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomSetPasswordResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomSetPasswordResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomSetPasswordResponseApplicationJson
    implements
        $RoomSetPasswordResponseApplicationJsonInterface,
        Built<RoomSetPasswordResponseApplicationJson, RoomSetPasswordResponseApplicationJsonBuilder> {
  /// Creates a new RoomSetPasswordResponseApplicationJson object using the builder pattern.
  factory RoomSetPasswordResponseApplicationJson([void Function(RoomSetPasswordResponseApplicationJsonBuilder)? b]) =
      _$RoomSetPasswordResponseApplicationJson;

  // coverage:ignore-start
  const RoomSetPasswordResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomSetPasswordResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomSetPasswordResponseApplicationJson.
  static Serializer<RoomSetPasswordResponseApplicationJson> get serializer =>
      _$roomSetPasswordResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomSetPasswordResponseApplicationJsonBuilder b) {
    $RoomSetPasswordResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomSetPasswordResponseApplicationJsonBuilder b) {
    $RoomSetPasswordResponseApplicationJsonInterface._validate(b);
  }
}

class RoomSetPermissionsMode extends EnumClass {
  const RoomSetPermissionsMode._(super.name);

  /// `call`
  static const RoomSetPermissionsMode call = _$roomSetPermissionsModeCall;

  /// `default`
  @BuiltValueEnumConst(wireName: 'default')
  static const RoomSetPermissionsMode $default = _$roomSetPermissionsMode$default;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomSetPermissionsMode> get values => _$roomSetPermissionsModeValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomSetPermissionsMode valueOf(String name) => _$valueOfRoomSetPermissionsMode(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomSetPermissionsMode.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetPermissionsMode> get serializer => const _$RoomSetPermissionsModeSerializer();
}

class _$RoomSetPermissionsModeSerializer implements PrimitiveSerializer<RoomSetPermissionsMode> {
  const _$RoomSetPermissionsModeSerializer();

  static const Map<RoomSetPermissionsMode, Object> _toWire = <RoomSetPermissionsMode, Object>{
    RoomSetPermissionsMode.call: 'call',
    RoomSetPermissionsMode.$default: 'default',
  };

  static const Map<Object, RoomSetPermissionsMode> _fromWire = <Object, RoomSetPermissionsMode>{
    'call': RoomSetPermissionsMode.call,
    'default': RoomSetPermissionsMode.$default,
  };

  @override
  Iterable<Type> get types => const [RoomSetPermissionsMode];

  @override
  String get wireName => 'RoomSetPermissionsMode';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetPermissionsMode object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetPermissionsMode deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class RoomSetPermissionsApiVersion extends EnumClass {
  const RoomSetPermissionsApiVersion._(super.name);

  /// `v4`
  static const RoomSetPermissionsApiVersion v4 = _$roomSetPermissionsApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomSetPermissionsApiVersion> get values => _$roomSetPermissionsApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomSetPermissionsApiVersion valueOf(String name) => _$valueOfRoomSetPermissionsApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomSetPermissionsApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetPermissionsApiVersion> get serializer => const _$RoomSetPermissionsApiVersionSerializer();
}

class _$RoomSetPermissionsApiVersionSerializer implements PrimitiveSerializer<RoomSetPermissionsApiVersion> {
  const _$RoomSetPermissionsApiVersionSerializer();

  static const Map<RoomSetPermissionsApiVersion, Object> _toWire = <RoomSetPermissionsApiVersion, Object>{
    RoomSetPermissionsApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomSetPermissionsApiVersion> _fromWire = <Object, RoomSetPermissionsApiVersion>{
    'v4': RoomSetPermissionsApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomSetPermissionsApiVersion];

  @override
  String get wireName => 'RoomSetPermissionsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetPermissionsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetPermissionsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetPermissionsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomSetPermissionsResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomSetPermissionsResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomSetPermissionsResponseApplicationJson_Ocs
    implements
        $RoomSetPermissionsResponseApplicationJson_OcsInterface,
        Built<RoomSetPermissionsResponseApplicationJson_Ocs, RoomSetPermissionsResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomSetPermissionsResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomSetPermissionsResponseApplicationJson_Ocs([
    void Function(RoomSetPermissionsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomSetPermissionsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomSetPermissionsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomSetPermissionsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomSetPermissionsResponseApplicationJson_Ocs.
  static Serializer<RoomSetPermissionsResponseApplicationJson_Ocs> get serializer =>
      _$roomSetPermissionsResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomSetPermissionsResponseApplicationJson_OcsBuilder b) {
    $RoomSetPermissionsResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomSetPermissionsResponseApplicationJson_OcsBuilder b) {
    $RoomSetPermissionsResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetPermissionsResponseApplicationJsonInterface {
  RoomSetPermissionsResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomSetPermissionsResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomSetPermissionsResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomSetPermissionsResponseApplicationJson
    implements
        $RoomSetPermissionsResponseApplicationJsonInterface,
        Built<RoomSetPermissionsResponseApplicationJson, RoomSetPermissionsResponseApplicationJsonBuilder> {
  /// Creates a new RoomSetPermissionsResponseApplicationJson object using the builder pattern.
  factory RoomSetPermissionsResponseApplicationJson([
    void Function(RoomSetPermissionsResponseApplicationJsonBuilder)? b,
  ]) = _$RoomSetPermissionsResponseApplicationJson;

  // coverage:ignore-start
  const RoomSetPermissionsResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomSetPermissionsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomSetPermissionsResponseApplicationJson.
  static Serializer<RoomSetPermissionsResponseApplicationJson> get serializer =>
      _$roomSetPermissionsResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomSetPermissionsResponseApplicationJsonBuilder b) {
    $RoomSetPermissionsResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomSetPermissionsResponseApplicationJsonBuilder b) {
    $RoomSetPermissionsResponseApplicationJsonInterface._validate(b);
  }
}

class RoomGetParticipantsIncludeStatus extends EnumClass {
  const RoomGetParticipantsIncludeStatus._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const RoomGetParticipantsIncludeStatus $0 = _$roomGetParticipantsIncludeStatus$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const RoomGetParticipantsIncludeStatus $1 = _$roomGetParticipantsIncludeStatus$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomGetParticipantsIncludeStatus> get values => _$roomGetParticipantsIncludeStatusValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomGetParticipantsIncludeStatus valueOf(String name) => _$valueOfRoomGetParticipantsIncludeStatus(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for RoomGetParticipantsIncludeStatus.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomGetParticipantsIncludeStatus> get serializer =>
      const _$RoomGetParticipantsIncludeStatusSerializer();
}

class _$RoomGetParticipantsIncludeStatusSerializer implements PrimitiveSerializer<RoomGetParticipantsIncludeStatus> {
  const _$RoomGetParticipantsIncludeStatusSerializer();

  static const Map<RoomGetParticipantsIncludeStatus, Object> _toWire = <RoomGetParticipantsIncludeStatus, Object>{
    RoomGetParticipantsIncludeStatus.$0: 0,
    RoomGetParticipantsIncludeStatus.$1: 1,
  };

  static const Map<Object, RoomGetParticipantsIncludeStatus> _fromWire = <Object, RoomGetParticipantsIncludeStatus>{
    0: RoomGetParticipantsIncludeStatus.$0,
    1: RoomGetParticipantsIncludeStatus.$1,
  };

  @override
  Iterable<Type> get types => const [RoomGetParticipantsIncludeStatus];

  @override
  String get wireName => 'RoomGetParticipantsIncludeStatus';

  @override
  Object serialize(
    Serializers serializers,
    RoomGetParticipantsIncludeStatus object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomGetParticipantsIncludeStatus deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class RoomGetParticipantsApiVersion extends EnumClass {
  const RoomGetParticipantsApiVersion._(super.name);

  /// `v4`
  static const RoomGetParticipantsApiVersion v4 = _$roomGetParticipantsApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomGetParticipantsApiVersion> get values => _$roomGetParticipantsApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomGetParticipantsApiVersion valueOf(String name) => _$valueOfRoomGetParticipantsApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomGetParticipantsApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomGetParticipantsApiVersion> get serializer => const _$RoomGetParticipantsApiVersionSerializer();
}

class _$RoomGetParticipantsApiVersionSerializer implements PrimitiveSerializer<RoomGetParticipantsApiVersion> {
  const _$RoomGetParticipantsApiVersionSerializer();

  static const Map<RoomGetParticipantsApiVersion, Object> _toWire = <RoomGetParticipantsApiVersion, Object>{
    RoomGetParticipantsApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomGetParticipantsApiVersion> _fromWire = <Object, RoomGetParticipantsApiVersion>{
    'v4': RoomGetParticipantsApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomGetParticipantsApiVersion];

  @override
  String get wireName => 'RoomGetParticipantsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomGetParticipantsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomGetParticipantsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ParticipantInterface {
  String get actorId;
  ActorType get actorType;
  int get attendeeId;
  int get attendeePermissions;
  String get attendeePin;
  String get displayName;
  int get inCall;
  int get lastPing;
  int get participantType;
  int get permissions;
  String get roomToken;
  BuiltList<String> get sessionIds;
  String? get status;
  int? get statusClearAt;
  String? get statusIcon;
  String? get statusMessage;
  String? get phoneNumber;
  String? get callId;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($ParticipantInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($ParticipantInterfaceBuilder b) {}
}

abstract class Participant implements $ParticipantInterface, Built<Participant, ParticipantBuilder> {
  /// Creates a new Participant object using the builder pattern.
  factory Participant([void Function(ParticipantBuilder)? b]) = _$Participant;

  // coverage:ignore-start
  const Participant._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory Participant.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for Participant.
  static Serializer<Participant> get serializer => _$participantSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(ParticipantBuilder b) {
    $ParticipantInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(ParticipantBuilder b) {
    $ParticipantInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomGetParticipantsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<Participant> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomGetParticipantsResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomGetParticipantsResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomGetParticipantsResponseApplicationJson_Ocs
    implements
        $RoomGetParticipantsResponseApplicationJson_OcsInterface,
        Built<RoomGetParticipantsResponseApplicationJson_Ocs, RoomGetParticipantsResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomGetParticipantsResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomGetParticipantsResponseApplicationJson_Ocs([
    void Function(RoomGetParticipantsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomGetParticipantsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomGetParticipantsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomGetParticipantsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomGetParticipantsResponseApplicationJson_Ocs.
  static Serializer<RoomGetParticipantsResponseApplicationJson_Ocs> get serializer =>
      _$roomGetParticipantsResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomGetParticipantsResponseApplicationJson_OcsBuilder b) {
    $RoomGetParticipantsResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomGetParticipantsResponseApplicationJson_OcsBuilder b) {
    $RoomGetParticipantsResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomGetParticipantsResponseApplicationJsonInterface {
  RoomGetParticipantsResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomGetParticipantsResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomGetParticipantsResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomGetParticipantsResponseApplicationJson
    implements
        $RoomGetParticipantsResponseApplicationJsonInterface,
        Built<RoomGetParticipantsResponseApplicationJson, RoomGetParticipantsResponseApplicationJsonBuilder> {
  /// Creates a new RoomGetParticipantsResponseApplicationJson object using the builder pattern.
  factory RoomGetParticipantsResponseApplicationJson([
    void Function(RoomGetParticipantsResponseApplicationJsonBuilder)? b,
  ]) = _$RoomGetParticipantsResponseApplicationJson;

  // coverage:ignore-start
  const RoomGetParticipantsResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomGetParticipantsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomGetParticipantsResponseApplicationJson.
  static Serializer<RoomGetParticipantsResponseApplicationJson> get serializer =>
      _$roomGetParticipantsResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomGetParticipantsResponseApplicationJsonBuilder b) {
    $RoomGetParticipantsResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomGetParticipantsResponseApplicationJsonBuilder b) {
    $RoomGetParticipantsResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomRoomGetParticipantsHeadersInterface {
  @BuiltValueField(wireName: 'x-nextcloud-has-user-statuses')
  Header<bool>? get xNextcloudHasUserStatuses;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomRoomGetParticipantsHeadersInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomRoomGetParticipantsHeadersInterfaceBuilder b) {}
}

abstract class RoomRoomGetParticipantsHeaders
    implements
        $RoomRoomGetParticipantsHeadersInterface,
        Built<RoomRoomGetParticipantsHeaders, RoomRoomGetParticipantsHeadersBuilder> {
  /// Creates a new RoomRoomGetParticipantsHeaders object using the builder pattern.
  factory RoomRoomGetParticipantsHeaders([void Function(RoomRoomGetParticipantsHeadersBuilder)? b]) =
      _$RoomRoomGetParticipantsHeaders;

  // coverage:ignore-start
  const RoomRoomGetParticipantsHeaders._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomRoomGetParticipantsHeaders.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomRoomGetParticipantsHeaders.
  static Serializer<RoomRoomGetParticipantsHeaders> get serializer => _$roomRoomGetParticipantsHeadersSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomRoomGetParticipantsHeadersBuilder b) {
    $RoomRoomGetParticipantsHeadersInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomRoomGetParticipantsHeadersBuilder b) {
    $RoomRoomGetParticipantsHeadersInterface._validate(b);
  }
}

class RoomAddParticipantToRoomSource extends EnumClass {
  const RoomAddParticipantToRoomSource._(super.name);

  /// `users`
  static const RoomAddParticipantToRoomSource users = _$roomAddParticipantToRoomSourceUsers;

  /// `groups`
  static const RoomAddParticipantToRoomSource groups = _$roomAddParticipantToRoomSourceGroups;

  /// `circles`
  static const RoomAddParticipantToRoomSource circles = _$roomAddParticipantToRoomSourceCircles;

  /// `emails`
  static const RoomAddParticipantToRoomSource emails = _$roomAddParticipantToRoomSourceEmails;

  /// `federated_users`
  @BuiltValueEnumConst(wireName: 'federated_users')
  static const RoomAddParticipantToRoomSource federatedUsers = _$roomAddParticipantToRoomSourceFederatedUsers;

  /// `phones`
  static const RoomAddParticipantToRoomSource phones = _$roomAddParticipantToRoomSourcePhones;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomAddParticipantToRoomSource> get values => _$roomAddParticipantToRoomSourceValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomAddParticipantToRoomSource valueOf(String name) => _$valueOfRoomAddParticipantToRoomSource(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomAddParticipantToRoomSource.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomAddParticipantToRoomSource> get serializer =>
      const _$RoomAddParticipantToRoomSourceSerializer();
}

class _$RoomAddParticipantToRoomSourceSerializer implements PrimitiveSerializer<RoomAddParticipantToRoomSource> {
  const _$RoomAddParticipantToRoomSourceSerializer();

  static const Map<RoomAddParticipantToRoomSource, Object> _toWire = <RoomAddParticipantToRoomSource, Object>{
    RoomAddParticipantToRoomSource.users: 'users',
    RoomAddParticipantToRoomSource.groups: 'groups',
    RoomAddParticipantToRoomSource.circles: 'circles',
    RoomAddParticipantToRoomSource.emails: 'emails',
    RoomAddParticipantToRoomSource.federatedUsers: 'federated_users',
    RoomAddParticipantToRoomSource.phones: 'phones',
  };

  static const Map<Object, RoomAddParticipantToRoomSource> _fromWire = <Object, RoomAddParticipantToRoomSource>{
    'users': RoomAddParticipantToRoomSource.users,
    'groups': RoomAddParticipantToRoomSource.groups,
    'circles': RoomAddParticipantToRoomSource.circles,
    'emails': RoomAddParticipantToRoomSource.emails,
    'federated_users': RoomAddParticipantToRoomSource.federatedUsers,
    'phones': RoomAddParticipantToRoomSource.phones,
  };

  @override
  Iterable<Type> get types => const [RoomAddParticipantToRoomSource];

  @override
  String get wireName => 'RoomAddParticipantToRoomSource';

  @override
  Object serialize(
    Serializers serializers,
    RoomAddParticipantToRoomSource object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomAddParticipantToRoomSource deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class RoomAddParticipantToRoomApiVersion extends EnumClass {
  const RoomAddParticipantToRoomApiVersion._(super.name);

  /// `v4`
  static const RoomAddParticipantToRoomApiVersion v4 = _$roomAddParticipantToRoomApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomAddParticipantToRoomApiVersion> get values => _$roomAddParticipantToRoomApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomAddParticipantToRoomApiVersion valueOf(String name) => _$valueOfRoomAddParticipantToRoomApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomAddParticipantToRoomApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomAddParticipantToRoomApiVersion> get serializer =>
      const _$RoomAddParticipantToRoomApiVersionSerializer();
}

class _$RoomAddParticipantToRoomApiVersionSerializer
    implements PrimitiveSerializer<RoomAddParticipantToRoomApiVersion> {
  const _$RoomAddParticipantToRoomApiVersionSerializer();

  static const Map<RoomAddParticipantToRoomApiVersion, Object> _toWire = <RoomAddParticipantToRoomApiVersion, Object>{
    RoomAddParticipantToRoomApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomAddParticipantToRoomApiVersion> _fromWire = <Object, RoomAddParticipantToRoomApiVersion>{
    'v4': RoomAddParticipantToRoomApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomAddParticipantToRoomApiVersion];

  @override
  String get wireName => 'RoomAddParticipantToRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomAddParticipantToRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomAddParticipantToRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0Interface {
  int get type;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0InterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0InterfaceBuilder b) {}
}

abstract class RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0
    implements
        $RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0Interface,
        Built<RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0,
            RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0Builder> {
  /// Creates a new RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0 object using the builder pattern.
  factory RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0([
    void Function(RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0Builder)? b,
  ]) = _$RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0;

  // coverage:ignore-start
  const RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0.
  static Serializer<RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0> get serializer =>
      _$roomAddParticipantToRoomResponseApplicationJsonOcsData0Serializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0Builder b) {
    $RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0Interface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0Builder b) {
    $RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0Interface._validate(b);
  }
}

typedef RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data = ({
  BuiltList<Never>? builtListNever,
  RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0? roomAddParticipantToRoomResponseApplicationJsonOcsData0
});

@BuiltValue(instantiable: false)
abstract interface class $RoomAddParticipantToRoomResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomAddParticipantToRoomResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomAddParticipantToRoomResponseApplicationJson_OcsInterfaceBuilder b) {
    b.data?.validateOneOf();
  }
}

abstract class RoomAddParticipantToRoomResponseApplicationJson_Ocs
    implements
        $RoomAddParticipantToRoomResponseApplicationJson_OcsInterface,
        Built<RoomAddParticipantToRoomResponseApplicationJson_Ocs,
            RoomAddParticipantToRoomResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomAddParticipantToRoomResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomAddParticipantToRoomResponseApplicationJson_Ocs([
    void Function(RoomAddParticipantToRoomResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomAddParticipantToRoomResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomAddParticipantToRoomResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomAddParticipantToRoomResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomAddParticipantToRoomResponseApplicationJson_Ocs.
  static Serializer<RoomAddParticipantToRoomResponseApplicationJson_Ocs> get serializer =>
      _$roomAddParticipantToRoomResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomAddParticipantToRoomResponseApplicationJson_OcsBuilder b) {
    $RoomAddParticipantToRoomResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomAddParticipantToRoomResponseApplicationJson_OcsBuilder b) {
    $RoomAddParticipantToRoomResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomAddParticipantToRoomResponseApplicationJsonInterface {
  RoomAddParticipantToRoomResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomAddParticipantToRoomResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomAddParticipantToRoomResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomAddParticipantToRoomResponseApplicationJson
    implements
        $RoomAddParticipantToRoomResponseApplicationJsonInterface,
        Built<RoomAddParticipantToRoomResponseApplicationJson, RoomAddParticipantToRoomResponseApplicationJsonBuilder> {
  /// Creates a new RoomAddParticipantToRoomResponseApplicationJson object using the builder pattern.
  factory RoomAddParticipantToRoomResponseApplicationJson([
    void Function(RoomAddParticipantToRoomResponseApplicationJsonBuilder)? b,
  ]) = _$RoomAddParticipantToRoomResponseApplicationJson;

  // coverage:ignore-start
  const RoomAddParticipantToRoomResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomAddParticipantToRoomResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomAddParticipantToRoomResponseApplicationJson.
  static Serializer<RoomAddParticipantToRoomResponseApplicationJson> get serializer =>
      _$roomAddParticipantToRoomResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomAddParticipantToRoomResponseApplicationJsonBuilder b) {
    $RoomAddParticipantToRoomResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomAddParticipantToRoomResponseApplicationJsonBuilder b) {
    $RoomAddParticipantToRoomResponseApplicationJsonInterface._validate(b);
  }
}

class RoomGetBreakoutRoomParticipantsIncludeStatus extends EnumClass {
  const RoomGetBreakoutRoomParticipantsIncludeStatus._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const RoomGetBreakoutRoomParticipantsIncludeStatus $0 = _$roomGetBreakoutRoomParticipantsIncludeStatus$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const RoomGetBreakoutRoomParticipantsIncludeStatus $1 = _$roomGetBreakoutRoomParticipantsIncludeStatus$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomGetBreakoutRoomParticipantsIncludeStatus> get values =>
      _$roomGetBreakoutRoomParticipantsIncludeStatusValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomGetBreakoutRoomParticipantsIncludeStatus valueOf(String name) =>
      _$valueOfRoomGetBreakoutRoomParticipantsIncludeStatus(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for RoomGetBreakoutRoomParticipantsIncludeStatus.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomGetBreakoutRoomParticipantsIncludeStatus> get serializer =>
      const _$RoomGetBreakoutRoomParticipantsIncludeStatusSerializer();
}

class _$RoomGetBreakoutRoomParticipantsIncludeStatusSerializer
    implements PrimitiveSerializer<RoomGetBreakoutRoomParticipantsIncludeStatus> {
  const _$RoomGetBreakoutRoomParticipantsIncludeStatusSerializer();

  static const Map<RoomGetBreakoutRoomParticipantsIncludeStatus, Object> _toWire =
      <RoomGetBreakoutRoomParticipantsIncludeStatus, Object>{
    RoomGetBreakoutRoomParticipantsIncludeStatus.$0: 0,
    RoomGetBreakoutRoomParticipantsIncludeStatus.$1: 1,
  };

  static const Map<Object, RoomGetBreakoutRoomParticipantsIncludeStatus> _fromWire =
      <Object, RoomGetBreakoutRoomParticipantsIncludeStatus>{
    0: RoomGetBreakoutRoomParticipantsIncludeStatus.$0,
    1: RoomGetBreakoutRoomParticipantsIncludeStatus.$1,
  };

  @override
  Iterable<Type> get types => const [RoomGetBreakoutRoomParticipantsIncludeStatus];

  @override
  String get wireName => 'RoomGetBreakoutRoomParticipantsIncludeStatus';

  @override
  Object serialize(
    Serializers serializers,
    RoomGetBreakoutRoomParticipantsIncludeStatus object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomGetBreakoutRoomParticipantsIncludeStatus deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class RoomGetBreakoutRoomParticipantsApiVersion extends EnumClass {
  const RoomGetBreakoutRoomParticipantsApiVersion._(super.name);

  /// `v4`
  static const RoomGetBreakoutRoomParticipantsApiVersion v4 = _$roomGetBreakoutRoomParticipantsApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomGetBreakoutRoomParticipantsApiVersion> get values =>
      _$roomGetBreakoutRoomParticipantsApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomGetBreakoutRoomParticipantsApiVersion valueOf(String name) =>
      _$valueOfRoomGetBreakoutRoomParticipantsApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomGetBreakoutRoomParticipantsApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomGetBreakoutRoomParticipantsApiVersion> get serializer =>
      const _$RoomGetBreakoutRoomParticipantsApiVersionSerializer();
}

class _$RoomGetBreakoutRoomParticipantsApiVersionSerializer
    implements PrimitiveSerializer<RoomGetBreakoutRoomParticipantsApiVersion> {
  const _$RoomGetBreakoutRoomParticipantsApiVersionSerializer();

  static const Map<RoomGetBreakoutRoomParticipantsApiVersion, Object> _toWire =
      <RoomGetBreakoutRoomParticipantsApiVersion, Object>{
    RoomGetBreakoutRoomParticipantsApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomGetBreakoutRoomParticipantsApiVersion> _fromWire =
      <Object, RoomGetBreakoutRoomParticipantsApiVersion>{
    'v4': RoomGetBreakoutRoomParticipantsApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomGetBreakoutRoomParticipantsApiVersion];

  @override
  String get wireName => 'RoomGetBreakoutRoomParticipantsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomGetBreakoutRoomParticipantsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomGetBreakoutRoomParticipantsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomGetBreakoutRoomParticipantsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<Participant> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomGetBreakoutRoomParticipantsResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomGetBreakoutRoomParticipantsResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomGetBreakoutRoomParticipantsResponseApplicationJson_Ocs
    implements
        $RoomGetBreakoutRoomParticipantsResponseApplicationJson_OcsInterface,
        Built<RoomGetBreakoutRoomParticipantsResponseApplicationJson_Ocs,
            RoomGetBreakoutRoomParticipantsResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomGetBreakoutRoomParticipantsResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomGetBreakoutRoomParticipantsResponseApplicationJson_Ocs([
    void Function(RoomGetBreakoutRoomParticipantsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomGetBreakoutRoomParticipantsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomGetBreakoutRoomParticipantsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomGetBreakoutRoomParticipantsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomGetBreakoutRoomParticipantsResponseApplicationJson_Ocs.
  static Serializer<RoomGetBreakoutRoomParticipantsResponseApplicationJson_Ocs> get serializer =>
      _$roomGetBreakoutRoomParticipantsResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomGetBreakoutRoomParticipantsResponseApplicationJson_OcsBuilder b) {
    $RoomGetBreakoutRoomParticipantsResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomGetBreakoutRoomParticipantsResponseApplicationJson_OcsBuilder b) {
    $RoomGetBreakoutRoomParticipantsResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomGetBreakoutRoomParticipantsResponseApplicationJsonInterface {
  RoomGetBreakoutRoomParticipantsResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomGetBreakoutRoomParticipantsResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomGetBreakoutRoomParticipantsResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomGetBreakoutRoomParticipantsResponseApplicationJson
    implements
        $RoomGetBreakoutRoomParticipantsResponseApplicationJsonInterface,
        Built<RoomGetBreakoutRoomParticipantsResponseApplicationJson,
            RoomGetBreakoutRoomParticipantsResponseApplicationJsonBuilder> {
  /// Creates a new RoomGetBreakoutRoomParticipantsResponseApplicationJson object using the builder pattern.
  factory RoomGetBreakoutRoomParticipantsResponseApplicationJson([
    void Function(RoomGetBreakoutRoomParticipantsResponseApplicationJsonBuilder)? b,
  ]) = _$RoomGetBreakoutRoomParticipantsResponseApplicationJson;

  // coverage:ignore-start
  const RoomGetBreakoutRoomParticipantsResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomGetBreakoutRoomParticipantsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomGetBreakoutRoomParticipantsResponseApplicationJson.
  static Serializer<RoomGetBreakoutRoomParticipantsResponseApplicationJson> get serializer =>
      _$roomGetBreakoutRoomParticipantsResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomGetBreakoutRoomParticipantsResponseApplicationJsonBuilder b) {
    $RoomGetBreakoutRoomParticipantsResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomGetBreakoutRoomParticipantsResponseApplicationJsonBuilder b) {
    $RoomGetBreakoutRoomParticipantsResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomRoomGetBreakoutRoomParticipantsHeadersInterface {
  @BuiltValueField(wireName: 'x-nextcloud-has-user-statuses')
  Header<bool>? get xNextcloudHasUserStatuses;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomRoomGetBreakoutRoomParticipantsHeadersInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomRoomGetBreakoutRoomParticipantsHeadersInterfaceBuilder b) {}
}

abstract class RoomRoomGetBreakoutRoomParticipantsHeaders
    implements
        $RoomRoomGetBreakoutRoomParticipantsHeadersInterface,
        Built<RoomRoomGetBreakoutRoomParticipantsHeaders, RoomRoomGetBreakoutRoomParticipantsHeadersBuilder> {
  /// Creates a new RoomRoomGetBreakoutRoomParticipantsHeaders object using the builder pattern.
  factory RoomRoomGetBreakoutRoomParticipantsHeaders([
    void Function(RoomRoomGetBreakoutRoomParticipantsHeadersBuilder)? b,
  ]) = _$RoomRoomGetBreakoutRoomParticipantsHeaders;

  // coverage:ignore-start
  const RoomRoomGetBreakoutRoomParticipantsHeaders._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomRoomGetBreakoutRoomParticipantsHeaders.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomRoomGetBreakoutRoomParticipantsHeaders.
  static Serializer<RoomRoomGetBreakoutRoomParticipantsHeaders> get serializer =>
      _$roomRoomGetBreakoutRoomParticipantsHeadersSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomRoomGetBreakoutRoomParticipantsHeadersBuilder b) {
    $RoomRoomGetBreakoutRoomParticipantsHeadersInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomRoomGetBreakoutRoomParticipantsHeadersBuilder b) {
    $RoomRoomGetBreakoutRoomParticipantsHeadersInterface._validate(b);
  }
}

class RoomRemoveSelfFromRoomApiVersion extends EnumClass {
  const RoomRemoveSelfFromRoomApiVersion._(super.name);

  /// `v4`
  static const RoomRemoveSelfFromRoomApiVersion v4 = _$roomRemoveSelfFromRoomApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomRemoveSelfFromRoomApiVersion> get values => _$roomRemoveSelfFromRoomApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomRemoveSelfFromRoomApiVersion valueOf(String name) => _$valueOfRoomRemoveSelfFromRoomApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomRemoveSelfFromRoomApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomRemoveSelfFromRoomApiVersion> get serializer =>
      const _$RoomRemoveSelfFromRoomApiVersionSerializer();
}

class _$RoomRemoveSelfFromRoomApiVersionSerializer implements PrimitiveSerializer<RoomRemoveSelfFromRoomApiVersion> {
  const _$RoomRemoveSelfFromRoomApiVersionSerializer();

  static const Map<RoomRemoveSelfFromRoomApiVersion, Object> _toWire = <RoomRemoveSelfFromRoomApiVersion, Object>{
    RoomRemoveSelfFromRoomApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomRemoveSelfFromRoomApiVersion> _fromWire = <Object, RoomRemoveSelfFromRoomApiVersion>{
    'v4': RoomRemoveSelfFromRoomApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomRemoveSelfFromRoomApiVersion];

  @override
  String get wireName => 'RoomRemoveSelfFromRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomRemoveSelfFromRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomRemoveSelfFromRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomRemoveSelfFromRoomResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomRemoveSelfFromRoomResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomRemoveSelfFromRoomResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomRemoveSelfFromRoomResponseApplicationJson_Ocs
    implements
        $RoomRemoveSelfFromRoomResponseApplicationJson_OcsInterface,
        Built<RoomRemoveSelfFromRoomResponseApplicationJson_Ocs,
            RoomRemoveSelfFromRoomResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomRemoveSelfFromRoomResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomRemoveSelfFromRoomResponseApplicationJson_Ocs([
    void Function(RoomRemoveSelfFromRoomResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomRemoveSelfFromRoomResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomRemoveSelfFromRoomResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomRemoveSelfFromRoomResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomRemoveSelfFromRoomResponseApplicationJson_Ocs.
  static Serializer<RoomRemoveSelfFromRoomResponseApplicationJson_Ocs> get serializer =>
      _$roomRemoveSelfFromRoomResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomRemoveSelfFromRoomResponseApplicationJson_OcsBuilder b) {
    $RoomRemoveSelfFromRoomResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomRemoveSelfFromRoomResponseApplicationJson_OcsBuilder b) {
    $RoomRemoveSelfFromRoomResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomRemoveSelfFromRoomResponseApplicationJsonInterface {
  RoomRemoveSelfFromRoomResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomRemoveSelfFromRoomResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomRemoveSelfFromRoomResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomRemoveSelfFromRoomResponseApplicationJson
    implements
        $RoomRemoveSelfFromRoomResponseApplicationJsonInterface,
        Built<RoomRemoveSelfFromRoomResponseApplicationJson, RoomRemoveSelfFromRoomResponseApplicationJsonBuilder> {
  /// Creates a new RoomRemoveSelfFromRoomResponseApplicationJson object using the builder pattern.
  factory RoomRemoveSelfFromRoomResponseApplicationJson([
    void Function(RoomRemoveSelfFromRoomResponseApplicationJsonBuilder)? b,
  ]) = _$RoomRemoveSelfFromRoomResponseApplicationJson;

  // coverage:ignore-start
  const RoomRemoveSelfFromRoomResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomRemoveSelfFromRoomResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomRemoveSelfFromRoomResponseApplicationJson.
  static Serializer<RoomRemoveSelfFromRoomResponseApplicationJson> get serializer =>
      _$roomRemoveSelfFromRoomResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomRemoveSelfFromRoomResponseApplicationJsonBuilder b) {
    $RoomRemoveSelfFromRoomResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomRemoveSelfFromRoomResponseApplicationJsonBuilder b) {
    $RoomRemoveSelfFromRoomResponseApplicationJsonInterface._validate(b);
  }
}

class RoomRemoveAttendeeFromRoomApiVersion extends EnumClass {
  const RoomRemoveAttendeeFromRoomApiVersion._(super.name);

  /// `v4`
  static const RoomRemoveAttendeeFromRoomApiVersion v4 = _$roomRemoveAttendeeFromRoomApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomRemoveAttendeeFromRoomApiVersion> get values => _$roomRemoveAttendeeFromRoomApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomRemoveAttendeeFromRoomApiVersion valueOf(String name) =>
      _$valueOfRoomRemoveAttendeeFromRoomApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomRemoveAttendeeFromRoomApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomRemoveAttendeeFromRoomApiVersion> get serializer =>
      const _$RoomRemoveAttendeeFromRoomApiVersionSerializer();
}

class _$RoomRemoveAttendeeFromRoomApiVersionSerializer
    implements PrimitiveSerializer<RoomRemoveAttendeeFromRoomApiVersion> {
  const _$RoomRemoveAttendeeFromRoomApiVersionSerializer();

  static const Map<RoomRemoveAttendeeFromRoomApiVersion, Object> _toWire =
      <RoomRemoveAttendeeFromRoomApiVersion, Object>{
    RoomRemoveAttendeeFromRoomApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomRemoveAttendeeFromRoomApiVersion> _fromWire =
      <Object, RoomRemoveAttendeeFromRoomApiVersion>{
    'v4': RoomRemoveAttendeeFromRoomApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomRemoveAttendeeFromRoomApiVersion];

  @override
  String get wireName => 'RoomRemoveAttendeeFromRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomRemoveAttendeeFromRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomRemoveAttendeeFromRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomRemoveAttendeeFromRoomResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomRemoveAttendeeFromRoomResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomRemoveAttendeeFromRoomResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomRemoveAttendeeFromRoomResponseApplicationJson_Ocs
    implements
        $RoomRemoveAttendeeFromRoomResponseApplicationJson_OcsInterface,
        Built<RoomRemoveAttendeeFromRoomResponseApplicationJson_Ocs,
            RoomRemoveAttendeeFromRoomResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomRemoveAttendeeFromRoomResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomRemoveAttendeeFromRoomResponseApplicationJson_Ocs([
    void Function(RoomRemoveAttendeeFromRoomResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomRemoveAttendeeFromRoomResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomRemoveAttendeeFromRoomResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomRemoveAttendeeFromRoomResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomRemoveAttendeeFromRoomResponseApplicationJson_Ocs.
  static Serializer<RoomRemoveAttendeeFromRoomResponseApplicationJson_Ocs> get serializer =>
      _$roomRemoveAttendeeFromRoomResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomRemoveAttendeeFromRoomResponseApplicationJson_OcsBuilder b) {
    $RoomRemoveAttendeeFromRoomResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomRemoveAttendeeFromRoomResponseApplicationJson_OcsBuilder b) {
    $RoomRemoveAttendeeFromRoomResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomRemoveAttendeeFromRoomResponseApplicationJsonInterface {
  RoomRemoveAttendeeFromRoomResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomRemoveAttendeeFromRoomResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomRemoveAttendeeFromRoomResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomRemoveAttendeeFromRoomResponseApplicationJson
    implements
        $RoomRemoveAttendeeFromRoomResponseApplicationJsonInterface,
        Built<RoomRemoveAttendeeFromRoomResponseApplicationJson,
            RoomRemoveAttendeeFromRoomResponseApplicationJsonBuilder> {
  /// Creates a new RoomRemoveAttendeeFromRoomResponseApplicationJson object using the builder pattern.
  factory RoomRemoveAttendeeFromRoomResponseApplicationJson([
    void Function(RoomRemoveAttendeeFromRoomResponseApplicationJsonBuilder)? b,
  ]) = _$RoomRemoveAttendeeFromRoomResponseApplicationJson;

  // coverage:ignore-start
  const RoomRemoveAttendeeFromRoomResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomRemoveAttendeeFromRoomResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomRemoveAttendeeFromRoomResponseApplicationJson.
  static Serializer<RoomRemoveAttendeeFromRoomResponseApplicationJson> get serializer =>
      _$roomRemoveAttendeeFromRoomResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomRemoveAttendeeFromRoomResponseApplicationJsonBuilder b) {
    $RoomRemoveAttendeeFromRoomResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomRemoveAttendeeFromRoomResponseApplicationJsonBuilder b) {
    $RoomRemoveAttendeeFromRoomResponseApplicationJsonInterface._validate(b);
  }
}

class RoomSetAttendeePermissionsMethod extends EnumClass {
  const RoomSetAttendeePermissionsMethod._(super.name);

  /// `set`
  @BuiltValueEnumConst(wireName: 'set')
  static const RoomSetAttendeePermissionsMethod $set = _$roomSetAttendeePermissionsMethod$set;

  /// `remove`
  static const RoomSetAttendeePermissionsMethod remove = _$roomSetAttendeePermissionsMethodRemove;

  /// `add`
  static const RoomSetAttendeePermissionsMethod add = _$roomSetAttendeePermissionsMethodAdd;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomSetAttendeePermissionsMethod> get values => _$roomSetAttendeePermissionsMethodValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomSetAttendeePermissionsMethod valueOf(String name) => _$valueOfRoomSetAttendeePermissionsMethod(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomSetAttendeePermissionsMethod.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetAttendeePermissionsMethod> get serializer =>
      const _$RoomSetAttendeePermissionsMethodSerializer();
}

class _$RoomSetAttendeePermissionsMethodSerializer implements PrimitiveSerializer<RoomSetAttendeePermissionsMethod> {
  const _$RoomSetAttendeePermissionsMethodSerializer();

  static const Map<RoomSetAttendeePermissionsMethod, Object> _toWire = <RoomSetAttendeePermissionsMethod, Object>{
    RoomSetAttendeePermissionsMethod.$set: 'set',
    RoomSetAttendeePermissionsMethod.remove: 'remove',
    RoomSetAttendeePermissionsMethod.add: 'add',
  };

  static const Map<Object, RoomSetAttendeePermissionsMethod> _fromWire = <Object, RoomSetAttendeePermissionsMethod>{
    'set': RoomSetAttendeePermissionsMethod.$set,
    'remove': RoomSetAttendeePermissionsMethod.remove,
    'add': RoomSetAttendeePermissionsMethod.add,
  };

  @override
  Iterable<Type> get types => const [RoomSetAttendeePermissionsMethod];

  @override
  String get wireName => 'RoomSetAttendeePermissionsMethod';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetAttendeePermissionsMethod object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetAttendeePermissionsMethod deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class RoomSetAttendeePermissionsApiVersion extends EnumClass {
  const RoomSetAttendeePermissionsApiVersion._(super.name);

  /// `v4`
  static const RoomSetAttendeePermissionsApiVersion v4 = _$roomSetAttendeePermissionsApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomSetAttendeePermissionsApiVersion> get values => _$roomSetAttendeePermissionsApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomSetAttendeePermissionsApiVersion valueOf(String name) =>
      _$valueOfRoomSetAttendeePermissionsApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomSetAttendeePermissionsApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetAttendeePermissionsApiVersion> get serializer =>
      const _$RoomSetAttendeePermissionsApiVersionSerializer();
}

class _$RoomSetAttendeePermissionsApiVersionSerializer
    implements PrimitiveSerializer<RoomSetAttendeePermissionsApiVersion> {
  const _$RoomSetAttendeePermissionsApiVersionSerializer();

  static const Map<RoomSetAttendeePermissionsApiVersion, Object> _toWire =
      <RoomSetAttendeePermissionsApiVersion, Object>{
    RoomSetAttendeePermissionsApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomSetAttendeePermissionsApiVersion> _fromWire =
      <Object, RoomSetAttendeePermissionsApiVersion>{
    'v4': RoomSetAttendeePermissionsApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomSetAttendeePermissionsApiVersion];

  @override
  String get wireName => 'RoomSetAttendeePermissionsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetAttendeePermissionsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetAttendeePermissionsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetAttendeePermissionsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomSetAttendeePermissionsResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomSetAttendeePermissionsResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomSetAttendeePermissionsResponseApplicationJson_Ocs
    implements
        $RoomSetAttendeePermissionsResponseApplicationJson_OcsInterface,
        Built<RoomSetAttendeePermissionsResponseApplicationJson_Ocs,
            RoomSetAttendeePermissionsResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomSetAttendeePermissionsResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomSetAttendeePermissionsResponseApplicationJson_Ocs([
    void Function(RoomSetAttendeePermissionsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomSetAttendeePermissionsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomSetAttendeePermissionsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomSetAttendeePermissionsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomSetAttendeePermissionsResponseApplicationJson_Ocs.
  static Serializer<RoomSetAttendeePermissionsResponseApplicationJson_Ocs> get serializer =>
      _$roomSetAttendeePermissionsResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomSetAttendeePermissionsResponseApplicationJson_OcsBuilder b) {
    $RoomSetAttendeePermissionsResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomSetAttendeePermissionsResponseApplicationJson_OcsBuilder b) {
    $RoomSetAttendeePermissionsResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetAttendeePermissionsResponseApplicationJsonInterface {
  RoomSetAttendeePermissionsResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomSetAttendeePermissionsResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomSetAttendeePermissionsResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomSetAttendeePermissionsResponseApplicationJson
    implements
        $RoomSetAttendeePermissionsResponseApplicationJsonInterface,
        Built<RoomSetAttendeePermissionsResponseApplicationJson,
            RoomSetAttendeePermissionsResponseApplicationJsonBuilder> {
  /// Creates a new RoomSetAttendeePermissionsResponseApplicationJson object using the builder pattern.
  factory RoomSetAttendeePermissionsResponseApplicationJson([
    void Function(RoomSetAttendeePermissionsResponseApplicationJsonBuilder)? b,
  ]) = _$RoomSetAttendeePermissionsResponseApplicationJson;

  // coverage:ignore-start
  const RoomSetAttendeePermissionsResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomSetAttendeePermissionsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomSetAttendeePermissionsResponseApplicationJson.
  static Serializer<RoomSetAttendeePermissionsResponseApplicationJson> get serializer =>
      _$roomSetAttendeePermissionsResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomSetAttendeePermissionsResponseApplicationJsonBuilder b) {
    $RoomSetAttendeePermissionsResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomSetAttendeePermissionsResponseApplicationJsonBuilder b) {
    $RoomSetAttendeePermissionsResponseApplicationJsonInterface._validate(b);
  }
}

class RoomSetAllAttendeesPermissionsMethod extends EnumClass {
  const RoomSetAllAttendeesPermissionsMethod._(super.name);

  /// `set`
  @BuiltValueEnumConst(wireName: 'set')
  static const RoomSetAllAttendeesPermissionsMethod $set = _$roomSetAllAttendeesPermissionsMethod$set;

  /// `remove`
  static const RoomSetAllAttendeesPermissionsMethod remove = _$roomSetAllAttendeesPermissionsMethodRemove;

  /// `add`
  static const RoomSetAllAttendeesPermissionsMethod add = _$roomSetAllAttendeesPermissionsMethodAdd;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomSetAllAttendeesPermissionsMethod> get values => _$roomSetAllAttendeesPermissionsMethodValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomSetAllAttendeesPermissionsMethod valueOf(String name) =>
      _$valueOfRoomSetAllAttendeesPermissionsMethod(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomSetAllAttendeesPermissionsMethod.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetAllAttendeesPermissionsMethod> get serializer =>
      const _$RoomSetAllAttendeesPermissionsMethodSerializer();
}

class _$RoomSetAllAttendeesPermissionsMethodSerializer
    implements PrimitiveSerializer<RoomSetAllAttendeesPermissionsMethod> {
  const _$RoomSetAllAttendeesPermissionsMethodSerializer();

  static const Map<RoomSetAllAttendeesPermissionsMethod, Object> _toWire =
      <RoomSetAllAttendeesPermissionsMethod, Object>{
    RoomSetAllAttendeesPermissionsMethod.$set: 'set',
    RoomSetAllAttendeesPermissionsMethod.remove: 'remove',
    RoomSetAllAttendeesPermissionsMethod.add: 'add',
  };

  static const Map<Object, RoomSetAllAttendeesPermissionsMethod> _fromWire =
      <Object, RoomSetAllAttendeesPermissionsMethod>{
    'set': RoomSetAllAttendeesPermissionsMethod.$set,
    'remove': RoomSetAllAttendeesPermissionsMethod.remove,
    'add': RoomSetAllAttendeesPermissionsMethod.add,
  };

  @override
  Iterable<Type> get types => const [RoomSetAllAttendeesPermissionsMethod];

  @override
  String get wireName => 'RoomSetAllAttendeesPermissionsMethod';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetAllAttendeesPermissionsMethod object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetAllAttendeesPermissionsMethod deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class RoomSetAllAttendeesPermissionsApiVersion extends EnumClass {
  const RoomSetAllAttendeesPermissionsApiVersion._(super.name);

  /// `v4`
  static const RoomSetAllAttendeesPermissionsApiVersion v4 = _$roomSetAllAttendeesPermissionsApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomSetAllAttendeesPermissionsApiVersion> get values =>
      _$roomSetAllAttendeesPermissionsApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomSetAllAttendeesPermissionsApiVersion valueOf(String name) =>
      _$valueOfRoomSetAllAttendeesPermissionsApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomSetAllAttendeesPermissionsApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetAllAttendeesPermissionsApiVersion> get serializer =>
      const _$RoomSetAllAttendeesPermissionsApiVersionSerializer();
}

class _$RoomSetAllAttendeesPermissionsApiVersionSerializer
    implements PrimitiveSerializer<RoomSetAllAttendeesPermissionsApiVersion> {
  const _$RoomSetAllAttendeesPermissionsApiVersionSerializer();

  static const Map<RoomSetAllAttendeesPermissionsApiVersion, Object> _toWire =
      <RoomSetAllAttendeesPermissionsApiVersion, Object>{
    RoomSetAllAttendeesPermissionsApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomSetAllAttendeesPermissionsApiVersion> _fromWire =
      <Object, RoomSetAllAttendeesPermissionsApiVersion>{
    'v4': RoomSetAllAttendeesPermissionsApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomSetAllAttendeesPermissionsApiVersion];

  @override
  String get wireName => 'RoomSetAllAttendeesPermissionsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetAllAttendeesPermissionsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetAllAttendeesPermissionsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetAllAttendeesPermissionsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomSetAllAttendeesPermissionsResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomSetAllAttendeesPermissionsResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomSetAllAttendeesPermissionsResponseApplicationJson_Ocs
    implements
        $RoomSetAllAttendeesPermissionsResponseApplicationJson_OcsInterface,
        Built<RoomSetAllAttendeesPermissionsResponseApplicationJson_Ocs,
            RoomSetAllAttendeesPermissionsResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomSetAllAttendeesPermissionsResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomSetAllAttendeesPermissionsResponseApplicationJson_Ocs([
    void Function(RoomSetAllAttendeesPermissionsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomSetAllAttendeesPermissionsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomSetAllAttendeesPermissionsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomSetAllAttendeesPermissionsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomSetAllAttendeesPermissionsResponseApplicationJson_Ocs.
  static Serializer<RoomSetAllAttendeesPermissionsResponseApplicationJson_Ocs> get serializer =>
      _$roomSetAllAttendeesPermissionsResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomSetAllAttendeesPermissionsResponseApplicationJson_OcsBuilder b) {
    $RoomSetAllAttendeesPermissionsResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomSetAllAttendeesPermissionsResponseApplicationJson_OcsBuilder b) {
    $RoomSetAllAttendeesPermissionsResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetAllAttendeesPermissionsResponseApplicationJsonInterface {
  RoomSetAllAttendeesPermissionsResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomSetAllAttendeesPermissionsResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomSetAllAttendeesPermissionsResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomSetAllAttendeesPermissionsResponseApplicationJson
    implements
        $RoomSetAllAttendeesPermissionsResponseApplicationJsonInterface,
        Built<RoomSetAllAttendeesPermissionsResponseApplicationJson,
            RoomSetAllAttendeesPermissionsResponseApplicationJsonBuilder> {
  /// Creates a new RoomSetAllAttendeesPermissionsResponseApplicationJson object using the builder pattern.
  factory RoomSetAllAttendeesPermissionsResponseApplicationJson([
    void Function(RoomSetAllAttendeesPermissionsResponseApplicationJsonBuilder)? b,
  ]) = _$RoomSetAllAttendeesPermissionsResponseApplicationJson;

  // coverage:ignore-start
  const RoomSetAllAttendeesPermissionsResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomSetAllAttendeesPermissionsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomSetAllAttendeesPermissionsResponseApplicationJson.
  static Serializer<RoomSetAllAttendeesPermissionsResponseApplicationJson> get serializer =>
      _$roomSetAllAttendeesPermissionsResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomSetAllAttendeesPermissionsResponseApplicationJsonBuilder b) {
    $RoomSetAllAttendeesPermissionsResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomSetAllAttendeesPermissionsResponseApplicationJsonBuilder b) {
    $RoomSetAllAttendeesPermissionsResponseApplicationJsonInterface._validate(b);
  }
}

class RoomJoinRoomForce extends EnumClass {
  const RoomJoinRoomForce._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const RoomJoinRoomForce $0 = _$roomJoinRoomForce$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const RoomJoinRoomForce $1 = _$roomJoinRoomForce$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomJoinRoomForce> get values => _$roomJoinRoomForceValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomJoinRoomForce valueOf(String name) => _$valueOfRoomJoinRoomForce(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for RoomJoinRoomForce.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomJoinRoomForce> get serializer => const _$RoomJoinRoomForceSerializer();
}

class _$RoomJoinRoomForceSerializer implements PrimitiveSerializer<RoomJoinRoomForce> {
  const _$RoomJoinRoomForceSerializer();

  static const Map<RoomJoinRoomForce, Object> _toWire = <RoomJoinRoomForce, Object>{
    RoomJoinRoomForce.$0: 0,
    RoomJoinRoomForce.$1: 1,
  };

  static const Map<Object, RoomJoinRoomForce> _fromWire = <Object, RoomJoinRoomForce>{
    0: RoomJoinRoomForce.$0,
    1: RoomJoinRoomForce.$1,
  };

  @override
  Iterable<Type> get types => const [RoomJoinRoomForce];

  @override
  String get wireName => 'RoomJoinRoomForce';

  @override
  Object serialize(
    Serializers serializers,
    RoomJoinRoomForce object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomJoinRoomForce deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class RoomJoinRoomApiVersion extends EnumClass {
  const RoomJoinRoomApiVersion._(super.name);

  /// `v4`
  static const RoomJoinRoomApiVersion v4 = _$roomJoinRoomApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomJoinRoomApiVersion> get values => _$roomJoinRoomApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomJoinRoomApiVersion valueOf(String name) => _$valueOfRoomJoinRoomApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomJoinRoomApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomJoinRoomApiVersion> get serializer => const _$RoomJoinRoomApiVersionSerializer();
}

class _$RoomJoinRoomApiVersionSerializer implements PrimitiveSerializer<RoomJoinRoomApiVersion> {
  const _$RoomJoinRoomApiVersionSerializer();

  static const Map<RoomJoinRoomApiVersion, Object> _toWire = <RoomJoinRoomApiVersion, Object>{
    RoomJoinRoomApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomJoinRoomApiVersion> _fromWire = <Object, RoomJoinRoomApiVersion>{
    'v4': RoomJoinRoomApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomJoinRoomApiVersion];

  @override
  String get wireName => 'RoomJoinRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomJoinRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomJoinRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomJoinRoomResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomJoinRoomResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomJoinRoomResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomJoinRoomResponseApplicationJson_Ocs
    implements
        $RoomJoinRoomResponseApplicationJson_OcsInterface,
        Built<RoomJoinRoomResponseApplicationJson_Ocs, RoomJoinRoomResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomJoinRoomResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomJoinRoomResponseApplicationJson_Ocs([void Function(RoomJoinRoomResponseApplicationJson_OcsBuilder)? b]) =
      _$RoomJoinRoomResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomJoinRoomResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomJoinRoomResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomJoinRoomResponseApplicationJson_Ocs.
  static Serializer<RoomJoinRoomResponseApplicationJson_Ocs> get serializer =>
      _$roomJoinRoomResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomJoinRoomResponseApplicationJson_OcsBuilder b) {
    $RoomJoinRoomResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomJoinRoomResponseApplicationJson_OcsBuilder b) {
    $RoomJoinRoomResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomJoinRoomResponseApplicationJsonInterface {
  RoomJoinRoomResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomJoinRoomResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomJoinRoomResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomJoinRoomResponseApplicationJson
    implements
        $RoomJoinRoomResponseApplicationJsonInterface,
        Built<RoomJoinRoomResponseApplicationJson, RoomJoinRoomResponseApplicationJsonBuilder> {
  /// Creates a new RoomJoinRoomResponseApplicationJson object using the builder pattern.
  factory RoomJoinRoomResponseApplicationJson([void Function(RoomJoinRoomResponseApplicationJsonBuilder)? b]) =
      _$RoomJoinRoomResponseApplicationJson;

  // coverage:ignore-start
  const RoomJoinRoomResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomJoinRoomResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomJoinRoomResponseApplicationJson.
  static Serializer<RoomJoinRoomResponseApplicationJson> get serializer =>
      _$roomJoinRoomResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomJoinRoomResponseApplicationJsonBuilder b) {
    $RoomJoinRoomResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomJoinRoomResponseApplicationJsonBuilder b) {
    $RoomJoinRoomResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomRoomJoinRoomHeadersInterface {
  @BuiltValueField(wireName: 'x-nextcloud-talk-proxy-hash')
  String? get xNextcloudTalkProxyHash;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomRoomJoinRoomHeadersInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomRoomJoinRoomHeadersInterfaceBuilder b) {}
}

abstract class RoomRoomJoinRoomHeaders
    implements $RoomRoomJoinRoomHeadersInterface, Built<RoomRoomJoinRoomHeaders, RoomRoomJoinRoomHeadersBuilder> {
  /// Creates a new RoomRoomJoinRoomHeaders object using the builder pattern.
  factory RoomRoomJoinRoomHeaders([void Function(RoomRoomJoinRoomHeadersBuilder)? b]) = _$RoomRoomJoinRoomHeaders;

  // coverage:ignore-start
  const RoomRoomJoinRoomHeaders._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomRoomJoinRoomHeaders.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomRoomJoinRoomHeaders.
  static Serializer<RoomRoomJoinRoomHeaders> get serializer => _$roomRoomJoinRoomHeadersSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomRoomJoinRoomHeadersBuilder b) {
    $RoomRoomJoinRoomHeadersInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomRoomJoinRoomHeadersBuilder b) {
    $RoomRoomJoinRoomHeadersInterface._validate(b);
  }
}

class RoomLeaveRoomApiVersion extends EnumClass {
  const RoomLeaveRoomApiVersion._(super.name);

  /// `v4`
  static const RoomLeaveRoomApiVersion v4 = _$roomLeaveRoomApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomLeaveRoomApiVersion> get values => _$roomLeaveRoomApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomLeaveRoomApiVersion valueOf(String name) => _$valueOfRoomLeaveRoomApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomLeaveRoomApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomLeaveRoomApiVersion> get serializer => const _$RoomLeaveRoomApiVersionSerializer();
}

class _$RoomLeaveRoomApiVersionSerializer implements PrimitiveSerializer<RoomLeaveRoomApiVersion> {
  const _$RoomLeaveRoomApiVersionSerializer();

  static const Map<RoomLeaveRoomApiVersion, Object> _toWire = <RoomLeaveRoomApiVersion, Object>{
    RoomLeaveRoomApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomLeaveRoomApiVersion> _fromWire = <Object, RoomLeaveRoomApiVersion>{
    'v4': RoomLeaveRoomApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomLeaveRoomApiVersion];

  @override
  String get wireName => 'RoomLeaveRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomLeaveRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomLeaveRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomLeaveRoomResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomLeaveRoomResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomLeaveRoomResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomLeaveRoomResponseApplicationJson_Ocs
    implements
        $RoomLeaveRoomResponseApplicationJson_OcsInterface,
        Built<RoomLeaveRoomResponseApplicationJson_Ocs, RoomLeaveRoomResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomLeaveRoomResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomLeaveRoomResponseApplicationJson_Ocs([
    void Function(RoomLeaveRoomResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomLeaveRoomResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomLeaveRoomResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomLeaveRoomResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomLeaveRoomResponseApplicationJson_Ocs.
  static Serializer<RoomLeaveRoomResponseApplicationJson_Ocs> get serializer =>
      _$roomLeaveRoomResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomLeaveRoomResponseApplicationJson_OcsBuilder b) {
    $RoomLeaveRoomResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomLeaveRoomResponseApplicationJson_OcsBuilder b) {
    $RoomLeaveRoomResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomLeaveRoomResponseApplicationJsonInterface {
  RoomLeaveRoomResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomLeaveRoomResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomLeaveRoomResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomLeaveRoomResponseApplicationJson
    implements
        $RoomLeaveRoomResponseApplicationJsonInterface,
        Built<RoomLeaveRoomResponseApplicationJson, RoomLeaveRoomResponseApplicationJsonBuilder> {
  /// Creates a new RoomLeaveRoomResponseApplicationJson object using the builder pattern.
  factory RoomLeaveRoomResponseApplicationJson([void Function(RoomLeaveRoomResponseApplicationJsonBuilder)? b]) =
      _$RoomLeaveRoomResponseApplicationJson;

  // coverage:ignore-start
  const RoomLeaveRoomResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomLeaveRoomResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomLeaveRoomResponseApplicationJson.
  static Serializer<RoomLeaveRoomResponseApplicationJson> get serializer =>
      _$roomLeaveRoomResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomLeaveRoomResponseApplicationJsonBuilder b) {
    $RoomLeaveRoomResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomLeaveRoomResponseApplicationJsonBuilder b) {
    $RoomLeaveRoomResponseApplicationJsonInterface._validate(b);
  }
}

class RoomResendInvitationsApiVersion extends EnumClass {
  const RoomResendInvitationsApiVersion._(super.name);

  /// `v4`
  static const RoomResendInvitationsApiVersion v4 = _$roomResendInvitationsApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomResendInvitationsApiVersion> get values => _$roomResendInvitationsApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomResendInvitationsApiVersion valueOf(String name) => _$valueOfRoomResendInvitationsApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomResendInvitationsApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomResendInvitationsApiVersion> get serializer =>
      const _$RoomResendInvitationsApiVersionSerializer();
}

class _$RoomResendInvitationsApiVersionSerializer implements PrimitiveSerializer<RoomResendInvitationsApiVersion> {
  const _$RoomResendInvitationsApiVersionSerializer();

  static const Map<RoomResendInvitationsApiVersion, Object> _toWire = <RoomResendInvitationsApiVersion, Object>{
    RoomResendInvitationsApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomResendInvitationsApiVersion> _fromWire = <Object, RoomResendInvitationsApiVersion>{
    'v4': RoomResendInvitationsApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomResendInvitationsApiVersion];

  @override
  String get wireName => 'RoomResendInvitationsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomResendInvitationsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomResendInvitationsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomResendInvitationsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomResendInvitationsResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomResendInvitationsResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomResendInvitationsResponseApplicationJson_Ocs
    implements
        $RoomResendInvitationsResponseApplicationJson_OcsInterface,
        Built<RoomResendInvitationsResponseApplicationJson_Ocs,
            RoomResendInvitationsResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomResendInvitationsResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomResendInvitationsResponseApplicationJson_Ocs([
    void Function(RoomResendInvitationsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomResendInvitationsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomResendInvitationsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomResendInvitationsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomResendInvitationsResponseApplicationJson_Ocs.
  static Serializer<RoomResendInvitationsResponseApplicationJson_Ocs> get serializer =>
      _$roomResendInvitationsResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomResendInvitationsResponseApplicationJson_OcsBuilder b) {
    $RoomResendInvitationsResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomResendInvitationsResponseApplicationJson_OcsBuilder b) {
    $RoomResendInvitationsResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomResendInvitationsResponseApplicationJsonInterface {
  RoomResendInvitationsResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomResendInvitationsResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomResendInvitationsResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomResendInvitationsResponseApplicationJson
    implements
        $RoomResendInvitationsResponseApplicationJsonInterface,
        Built<RoomResendInvitationsResponseApplicationJson, RoomResendInvitationsResponseApplicationJsonBuilder> {
  /// Creates a new RoomResendInvitationsResponseApplicationJson object using the builder pattern.
  factory RoomResendInvitationsResponseApplicationJson([
    void Function(RoomResendInvitationsResponseApplicationJsonBuilder)? b,
  ]) = _$RoomResendInvitationsResponseApplicationJson;

  // coverage:ignore-start
  const RoomResendInvitationsResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomResendInvitationsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomResendInvitationsResponseApplicationJson.
  static Serializer<RoomResendInvitationsResponseApplicationJson> get serializer =>
      _$roomResendInvitationsResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomResendInvitationsResponseApplicationJsonBuilder b) {
    $RoomResendInvitationsResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomResendInvitationsResponseApplicationJsonBuilder b) {
    $RoomResendInvitationsResponseApplicationJsonInterface._validate(b);
  }
}

class RoomSetSessionStateState extends EnumClass {
  const RoomSetSessionStateState._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const RoomSetSessionStateState $0 = _$roomSetSessionStateState$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const RoomSetSessionStateState $1 = _$roomSetSessionStateState$1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomSetSessionStateState> get values => _$roomSetSessionStateStateValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomSetSessionStateState valueOf(String name) => _$valueOfRoomSetSessionStateState(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for RoomSetSessionStateState.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetSessionStateState> get serializer => const _$RoomSetSessionStateStateSerializer();
}

class _$RoomSetSessionStateStateSerializer implements PrimitiveSerializer<RoomSetSessionStateState> {
  const _$RoomSetSessionStateStateSerializer();

  static const Map<RoomSetSessionStateState, Object> _toWire = <RoomSetSessionStateState, Object>{
    RoomSetSessionStateState.$0: 0,
    RoomSetSessionStateState.$1: 1,
  };

  static const Map<Object, RoomSetSessionStateState> _fromWire = <Object, RoomSetSessionStateState>{
    0: RoomSetSessionStateState.$0,
    1: RoomSetSessionStateState.$1,
  };

  @override
  Iterable<Type> get types => const [RoomSetSessionStateState];

  @override
  String get wireName => 'RoomSetSessionStateState';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetSessionStateState object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetSessionStateState deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class RoomSetSessionStateApiVersion extends EnumClass {
  const RoomSetSessionStateApiVersion._(super.name);

  /// `v4`
  static const RoomSetSessionStateApiVersion v4 = _$roomSetSessionStateApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomSetSessionStateApiVersion> get values => _$roomSetSessionStateApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomSetSessionStateApiVersion valueOf(String name) => _$valueOfRoomSetSessionStateApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomSetSessionStateApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetSessionStateApiVersion> get serializer => const _$RoomSetSessionStateApiVersionSerializer();
}

class _$RoomSetSessionStateApiVersionSerializer implements PrimitiveSerializer<RoomSetSessionStateApiVersion> {
  const _$RoomSetSessionStateApiVersionSerializer();

  static const Map<RoomSetSessionStateApiVersion, Object> _toWire = <RoomSetSessionStateApiVersion, Object>{
    RoomSetSessionStateApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomSetSessionStateApiVersion> _fromWire = <Object, RoomSetSessionStateApiVersion>{
    'v4': RoomSetSessionStateApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomSetSessionStateApiVersion];

  @override
  String get wireName => 'RoomSetSessionStateApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetSessionStateApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetSessionStateApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetSessionStateResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomSetSessionStateResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomSetSessionStateResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomSetSessionStateResponseApplicationJson_Ocs
    implements
        $RoomSetSessionStateResponseApplicationJson_OcsInterface,
        Built<RoomSetSessionStateResponseApplicationJson_Ocs, RoomSetSessionStateResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomSetSessionStateResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomSetSessionStateResponseApplicationJson_Ocs([
    void Function(RoomSetSessionStateResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomSetSessionStateResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomSetSessionStateResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomSetSessionStateResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomSetSessionStateResponseApplicationJson_Ocs.
  static Serializer<RoomSetSessionStateResponseApplicationJson_Ocs> get serializer =>
      _$roomSetSessionStateResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomSetSessionStateResponseApplicationJson_OcsBuilder b) {
    $RoomSetSessionStateResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomSetSessionStateResponseApplicationJson_OcsBuilder b) {
    $RoomSetSessionStateResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetSessionStateResponseApplicationJsonInterface {
  RoomSetSessionStateResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomSetSessionStateResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomSetSessionStateResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomSetSessionStateResponseApplicationJson
    implements
        $RoomSetSessionStateResponseApplicationJsonInterface,
        Built<RoomSetSessionStateResponseApplicationJson, RoomSetSessionStateResponseApplicationJsonBuilder> {
  /// Creates a new RoomSetSessionStateResponseApplicationJson object using the builder pattern.
  factory RoomSetSessionStateResponseApplicationJson([
    void Function(RoomSetSessionStateResponseApplicationJsonBuilder)? b,
  ]) = _$RoomSetSessionStateResponseApplicationJson;

  // coverage:ignore-start
  const RoomSetSessionStateResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomSetSessionStateResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomSetSessionStateResponseApplicationJson.
  static Serializer<RoomSetSessionStateResponseApplicationJson> get serializer =>
      _$roomSetSessionStateResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomSetSessionStateResponseApplicationJsonBuilder b) {
    $RoomSetSessionStateResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomSetSessionStateResponseApplicationJsonBuilder b) {
    $RoomSetSessionStateResponseApplicationJsonInterface._validate(b);
  }
}

class RoomPromoteModeratorApiVersion extends EnumClass {
  const RoomPromoteModeratorApiVersion._(super.name);

  /// `v4`
  static const RoomPromoteModeratorApiVersion v4 = _$roomPromoteModeratorApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomPromoteModeratorApiVersion> get values => _$roomPromoteModeratorApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomPromoteModeratorApiVersion valueOf(String name) => _$valueOfRoomPromoteModeratorApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomPromoteModeratorApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomPromoteModeratorApiVersion> get serializer =>
      const _$RoomPromoteModeratorApiVersionSerializer();
}

class _$RoomPromoteModeratorApiVersionSerializer implements PrimitiveSerializer<RoomPromoteModeratorApiVersion> {
  const _$RoomPromoteModeratorApiVersionSerializer();

  static const Map<RoomPromoteModeratorApiVersion, Object> _toWire = <RoomPromoteModeratorApiVersion, Object>{
    RoomPromoteModeratorApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomPromoteModeratorApiVersion> _fromWire = <Object, RoomPromoteModeratorApiVersion>{
    'v4': RoomPromoteModeratorApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomPromoteModeratorApiVersion];

  @override
  String get wireName => 'RoomPromoteModeratorApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomPromoteModeratorApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomPromoteModeratorApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomPromoteModeratorResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomPromoteModeratorResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomPromoteModeratorResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomPromoteModeratorResponseApplicationJson_Ocs
    implements
        $RoomPromoteModeratorResponseApplicationJson_OcsInterface,
        Built<RoomPromoteModeratorResponseApplicationJson_Ocs, RoomPromoteModeratorResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomPromoteModeratorResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomPromoteModeratorResponseApplicationJson_Ocs([
    void Function(RoomPromoteModeratorResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomPromoteModeratorResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomPromoteModeratorResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomPromoteModeratorResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomPromoteModeratorResponseApplicationJson_Ocs.
  static Serializer<RoomPromoteModeratorResponseApplicationJson_Ocs> get serializer =>
      _$roomPromoteModeratorResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomPromoteModeratorResponseApplicationJson_OcsBuilder b) {
    $RoomPromoteModeratorResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomPromoteModeratorResponseApplicationJson_OcsBuilder b) {
    $RoomPromoteModeratorResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomPromoteModeratorResponseApplicationJsonInterface {
  RoomPromoteModeratorResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomPromoteModeratorResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomPromoteModeratorResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomPromoteModeratorResponseApplicationJson
    implements
        $RoomPromoteModeratorResponseApplicationJsonInterface,
        Built<RoomPromoteModeratorResponseApplicationJson, RoomPromoteModeratorResponseApplicationJsonBuilder> {
  /// Creates a new RoomPromoteModeratorResponseApplicationJson object using the builder pattern.
  factory RoomPromoteModeratorResponseApplicationJson([
    void Function(RoomPromoteModeratorResponseApplicationJsonBuilder)? b,
  ]) = _$RoomPromoteModeratorResponseApplicationJson;

  // coverage:ignore-start
  const RoomPromoteModeratorResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomPromoteModeratorResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomPromoteModeratorResponseApplicationJson.
  static Serializer<RoomPromoteModeratorResponseApplicationJson> get serializer =>
      _$roomPromoteModeratorResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomPromoteModeratorResponseApplicationJsonBuilder b) {
    $RoomPromoteModeratorResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomPromoteModeratorResponseApplicationJsonBuilder b) {
    $RoomPromoteModeratorResponseApplicationJsonInterface._validate(b);
  }
}

class RoomDemoteModeratorApiVersion extends EnumClass {
  const RoomDemoteModeratorApiVersion._(super.name);

  /// `v4`
  static const RoomDemoteModeratorApiVersion v4 = _$roomDemoteModeratorApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomDemoteModeratorApiVersion> get values => _$roomDemoteModeratorApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomDemoteModeratorApiVersion valueOf(String name) => _$valueOfRoomDemoteModeratorApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomDemoteModeratorApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomDemoteModeratorApiVersion> get serializer => const _$RoomDemoteModeratorApiVersionSerializer();
}

class _$RoomDemoteModeratorApiVersionSerializer implements PrimitiveSerializer<RoomDemoteModeratorApiVersion> {
  const _$RoomDemoteModeratorApiVersionSerializer();

  static const Map<RoomDemoteModeratorApiVersion, Object> _toWire = <RoomDemoteModeratorApiVersion, Object>{
    RoomDemoteModeratorApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomDemoteModeratorApiVersion> _fromWire = <Object, RoomDemoteModeratorApiVersion>{
    'v4': RoomDemoteModeratorApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomDemoteModeratorApiVersion];

  @override
  String get wireName => 'RoomDemoteModeratorApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomDemoteModeratorApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomDemoteModeratorApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomDemoteModeratorResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomDemoteModeratorResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomDemoteModeratorResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomDemoteModeratorResponseApplicationJson_Ocs
    implements
        $RoomDemoteModeratorResponseApplicationJson_OcsInterface,
        Built<RoomDemoteModeratorResponseApplicationJson_Ocs, RoomDemoteModeratorResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomDemoteModeratorResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomDemoteModeratorResponseApplicationJson_Ocs([
    void Function(RoomDemoteModeratorResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomDemoteModeratorResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomDemoteModeratorResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomDemoteModeratorResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomDemoteModeratorResponseApplicationJson_Ocs.
  static Serializer<RoomDemoteModeratorResponseApplicationJson_Ocs> get serializer =>
      _$roomDemoteModeratorResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomDemoteModeratorResponseApplicationJson_OcsBuilder b) {
    $RoomDemoteModeratorResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomDemoteModeratorResponseApplicationJson_OcsBuilder b) {
    $RoomDemoteModeratorResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomDemoteModeratorResponseApplicationJsonInterface {
  RoomDemoteModeratorResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomDemoteModeratorResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomDemoteModeratorResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomDemoteModeratorResponseApplicationJson
    implements
        $RoomDemoteModeratorResponseApplicationJsonInterface,
        Built<RoomDemoteModeratorResponseApplicationJson, RoomDemoteModeratorResponseApplicationJsonBuilder> {
  /// Creates a new RoomDemoteModeratorResponseApplicationJson object using the builder pattern.
  factory RoomDemoteModeratorResponseApplicationJson([
    void Function(RoomDemoteModeratorResponseApplicationJsonBuilder)? b,
  ]) = _$RoomDemoteModeratorResponseApplicationJson;

  // coverage:ignore-start
  const RoomDemoteModeratorResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomDemoteModeratorResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomDemoteModeratorResponseApplicationJson.
  static Serializer<RoomDemoteModeratorResponseApplicationJson> get serializer =>
      _$roomDemoteModeratorResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomDemoteModeratorResponseApplicationJsonBuilder b) {
    $RoomDemoteModeratorResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomDemoteModeratorResponseApplicationJsonBuilder b) {
    $RoomDemoteModeratorResponseApplicationJsonInterface._validate(b);
  }
}

class RoomAddToFavoritesApiVersion extends EnumClass {
  const RoomAddToFavoritesApiVersion._(super.name);

  /// `v4`
  static const RoomAddToFavoritesApiVersion v4 = _$roomAddToFavoritesApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomAddToFavoritesApiVersion> get values => _$roomAddToFavoritesApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomAddToFavoritesApiVersion valueOf(String name) => _$valueOfRoomAddToFavoritesApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomAddToFavoritesApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomAddToFavoritesApiVersion> get serializer => const _$RoomAddToFavoritesApiVersionSerializer();
}

class _$RoomAddToFavoritesApiVersionSerializer implements PrimitiveSerializer<RoomAddToFavoritesApiVersion> {
  const _$RoomAddToFavoritesApiVersionSerializer();

  static const Map<RoomAddToFavoritesApiVersion, Object> _toWire = <RoomAddToFavoritesApiVersion, Object>{
    RoomAddToFavoritesApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomAddToFavoritesApiVersion> _fromWire = <Object, RoomAddToFavoritesApiVersion>{
    'v4': RoomAddToFavoritesApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomAddToFavoritesApiVersion];

  @override
  String get wireName => 'RoomAddToFavoritesApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomAddToFavoritesApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomAddToFavoritesApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomAddToFavoritesResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomAddToFavoritesResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomAddToFavoritesResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomAddToFavoritesResponseApplicationJson_Ocs
    implements
        $RoomAddToFavoritesResponseApplicationJson_OcsInterface,
        Built<RoomAddToFavoritesResponseApplicationJson_Ocs, RoomAddToFavoritesResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomAddToFavoritesResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomAddToFavoritesResponseApplicationJson_Ocs([
    void Function(RoomAddToFavoritesResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomAddToFavoritesResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomAddToFavoritesResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomAddToFavoritesResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomAddToFavoritesResponseApplicationJson_Ocs.
  static Serializer<RoomAddToFavoritesResponseApplicationJson_Ocs> get serializer =>
      _$roomAddToFavoritesResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomAddToFavoritesResponseApplicationJson_OcsBuilder b) {
    $RoomAddToFavoritesResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomAddToFavoritesResponseApplicationJson_OcsBuilder b) {
    $RoomAddToFavoritesResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomAddToFavoritesResponseApplicationJsonInterface {
  RoomAddToFavoritesResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomAddToFavoritesResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomAddToFavoritesResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomAddToFavoritesResponseApplicationJson
    implements
        $RoomAddToFavoritesResponseApplicationJsonInterface,
        Built<RoomAddToFavoritesResponseApplicationJson, RoomAddToFavoritesResponseApplicationJsonBuilder> {
  /// Creates a new RoomAddToFavoritesResponseApplicationJson object using the builder pattern.
  factory RoomAddToFavoritesResponseApplicationJson([
    void Function(RoomAddToFavoritesResponseApplicationJsonBuilder)? b,
  ]) = _$RoomAddToFavoritesResponseApplicationJson;

  // coverage:ignore-start
  const RoomAddToFavoritesResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomAddToFavoritesResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomAddToFavoritesResponseApplicationJson.
  static Serializer<RoomAddToFavoritesResponseApplicationJson> get serializer =>
      _$roomAddToFavoritesResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomAddToFavoritesResponseApplicationJsonBuilder b) {
    $RoomAddToFavoritesResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomAddToFavoritesResponseApplicationJsonBuilder b) {
    $RoomAddToFavoritesResponseApplicationJsonInterface._validate(b);
  }
}

class RoomRemoveFromFavoritesApiVersion extends EnumClass {
  const RoomRemoveFromFavoritesApiVersion._(super.name);

  /// `v4`
  static const RoomRemoveFromFavoritesApiVersion v4 = _$roomRemoveFromFavoritesApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomRemoveFromFavoritesApiVersion> get values => _$roomRemoveFromFavoritesApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomRemoveFromFavoritesApiVersion valueOf(String name) => _$valueOfRoomRemoveFromFavoritesApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomRemoveFromFavoritesApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomRemoveFromFavoritesApiVersion> get serializer =>
      const _$RoomRemoveFromFavoritesApiVersionSerializer();
}

class _$RoomRemoveFromFavoritesApiVersionSerializer implements PrimitiveSerializer<RoomRemoveFromFavoritesApiVersion> {
  const _$RoomRemoveFromFavoritesApiVersionSerializer();

  static const Map<RoomRemoveFromFavoritesApiVersion, Object> _toWire = <RoomRemoveFromFavoritesApiVersion, Object>{
    RoomRemoveFromFavoritesApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomRemoveFromFavoritesApiVersion> _fromWire = <Object, RoomRemoveFromFavoritesApiVersion>{
    'v4': RoomRemoveFromFavoritesApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomRemoveFromFavoritesApiVersion];

  @override
  String get wireName => 'RoomRemoveFromFavoritesApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomRemoveFromFavoritesApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomRemoveFromFavoritesApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomRemoveFromFavoritesResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomRemoveFromFavoritesResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomRemoveFromFavoritesResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomRemoveFromFavoritesResponseApplicationJson_Ocs
    implements
        $RoomRemoveFromFavoritesResponseApplicationJson_OcsInterface,
        Built<RoomRemoveFromFavoritesResponseApplicationJson_Ocs,
            RoomRemoveFromFavoritesResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomRemoveFromFavoritesResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomRemoveFromFavoritesResponseApplicationJson_Ocs([
    void Function(RoomRemoveFromFavoritesResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomRemoveFromFavoritesResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomRemoveFromFavoritesResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomRemoveFromFavoritesResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomRemoveFromFavoritesResponseApplicationJson_Ocs.
  static Serializer<RoomRemoveFromFavoritesResponseApplicationJson_Ocs> get serializer =>
      _$roomRemoveFromFavoritesResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomRemoveFromFavoritesResponseApplicationJson_OcsBuilder b) {
    $RoomRemoveFromFavoritesResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomRemoveFromFavoritesResponseApplicationJson_OcsBuilder b) {
    $RoomRemoveFromFavoritesResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomRemoveFromFavoritesResponseApplicationJsonInterface {
  RoomRemoveFromFavoritesResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomRemoveFromFavoritesResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomRemoveFromFavoritesResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomRemoveFromFavoritesResponseApplicationJson
    implements
        $RoomRemoveFromFavoritesResponseApplicationJsonInterface,
        Built<RoomRemoveFromFavoritesResponseApplicationJson, RoomRemoveFromFavoritesResponseApplicationJsonBuilder> {
  /// Creates a new RoomRemoveFromFavoritesResponseApplicationJson object using the builder pattern.
  factory RoomRemoveFromFavoritesResponseApplicationJson([
    void Function(RoomRemoveFromFavoritesResponseApplicationJsonBuilder)? b,
  ]) = _$RoomRemoveFromFavoritesResponseApplicationJson;

  // coverage:ignore-start
  const RoomRemoveFromFavoritesResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomRemoveFromFavoritesResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomRemoveFromFavoritesResponseApplicationJson.
  static Serializer<RoomRemoveFromFavoritesResponseApplicationJson> get serializer =>
      _$roomRemoveFromFavoritesResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomRemoveFromFavoritesResponseApplicationJsonBuilder b) {
    $RoomRemoveFromFavoritesResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomRemoveFromFavoritesResponseApplicationJsonBuilder b) {
    $RoomRemoveFromFavoritesResponseApplicationJsonInterface._validate(b);
  }
}

class RoomSetNotificationLevelApiVersion extends EnumClass {
  const RoomSetNotificationLevelApiVersion._(super.name);

  /// `v4`
  static const RoomSetNotificationLevelApiVersion v4 = _$roomSetNotificationLevelApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomSetNotificationLevelApiVersion> get values => _$roomSetNotificationLevelApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomSetNotificationLevelApiVersion valueOf(String name) => _$valueOfRoomSetNotificationLevelApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomSetNotificationLevelApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetNotificationLevelApiVersion> get serializer =>
      const _$RoomSetNotificationLevelApiVersionSerializer();
}

class _$RoomSetNotificationLevelApiVersionSerializer
    implements PrimitiveSerializer<RoomSetNotificationLevelApiVersion> {
  const _$RoomSetNotificationLevelApiVersionSerializer();

  static const Map<RoomSetNotificationLevelApiVersion, Object> _toWire = <RoomSetNotificationLevelApiVersion, Object>{
    RoomSetNotificationLevelApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomSetNotificationLevelApiVersion> _fromWire = <Object, RoomSetNotificationLevelApiVersion>{
    'v4': RoomSetNotificationLevelApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomSetNotificationLevelApiVersion];

  @override
  String get wireName => 'RoomSetNotificationLevelApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetNotificationLevelApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetNotificationLevelApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetNotificationLevelResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomSetNotificationLevelResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomSetNotificationLevelResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomSetNotificationLevelResponseApplicationJson_Ocs
    implements
        $RoomSetNotificationLevelResponseApplicationJson_OcsInterface,
        Built<RoomSetNotificationLevelResponseApplicationJson_Ocs,
            RoomSetNotificationLevelResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomSetNotificationLevelResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomSetNotificationLevelResponseApplicationJson_Ocs([
    void Function(RoomSetNotificationLevelResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomSetNotificationLevelResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomSetNotificationLevelResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomSetNotificationLevelResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomSetNotificationLevelResponseApplicationJson_Ocs.
  static Serializer<RoomSetNotificationLevelResponseApplicationJson_Ocs> get serializer =>
      _$roomSetNotificationLevelResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomSetNotificationLevelResponseApplicationJson_OcsBuilder b) {
    $RoomSetNotificationLevelResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomSetNotificationLevelResponseApplicationJson_OcsBuilder b) {
    $RoomSetNotificationLevelResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetNotificationLevelResponseApplicationJsonInterface {
  RoomSetNotificationLevelResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomSetNotificationLevelResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomSetNotificationLevelResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomSetNotificationLevelResponseApplicationJson
    implements
        $RoomSetNotificationLevelResponseApplicationJsonInterface,
        Built<RoomSetNotificationLevelResponseApplicationJson, RoomSetNotificationLevelResponseApplicationJsonBuilder> {
  /// Creates a new RoomSetNotificationLevelResponseApplicationJson object using the builder pattern.
  factory RoomSetNotificationLevelResponseApplicationJson([
    void Function(RoomSetNotificationLevelResponseApplicationJsonBuilder)? b,
  ]) = _$RoomSetNotificationLevelResponseApplicationJson;

  // coverage:ignore-start
  const RoomSetNotificationLevelResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomSetNotificationLevelResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomSetNotificationLevelResponseApplicationJson.
  static Serializer<RoomSetNotificationLevelResponseApplicationJson> get serializer =>
      _$roomSetNotificationLevelResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomSetNotificationLevelResponseApplicationJsonBuilder b) {
    $RoomSetNotificationLevelResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomSetNotificationLevelResponseApplicationJsonBuilder b) {
    $RoomSetNotificationLevelResponseApplicationJsonInterface._validate(b);
  }
}

class RoomSetNotificationCallsApiVersion extends EnumClass {
  const RoomSetNotificationCallsApiVersion._(super.name);

  /// `v4`
  static const RoomSetNotificationCallsApiVersion v4 = _$roomSetNotificationCallsApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomSetNotificationCallsApiVersion> get values => _$roomSetNotificationCallsApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomSetNotificationCallsApiVersion valueOf(String name) => _$valueOfRoomSetNotificationCallsApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomSetNotificationCallsApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetNotificationCallsApiVersion> get serializer =>
      const _$RoomSetNotificationCallsApiVersionSerializer();
}

class _$RoomSetNotificationCallsApiVersionSerializer
    implements PrimitiveSerializer<RoomSetNotificationCallsApiVersion> {
  const _$RoomSetNotificationCallsApiVersionSerializer();

  static const Map<RoomSetNotificationCallsApiVersion, Object> _toWire = <RoomSetNotificationCallsApiVersion, Object>{
    RoomSetNotificationCallsApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomSetNotificationCallsApiVersion> _fromWire = <Object, RoomSetNotificationCallsApiVersion>{
    'v4': RoomSetNotificationCallsApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomSetNotificationCallsApiVersion];

  @override
  String get wireName => 'RoomSetNotificationCallsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetNotificationCallsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetNotificationCallsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetNotificationCallsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomSetNotificationCallsResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomSetNotificationCallsResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomSetNotificationCallsResponseApplicationJson_Ocs
    implements
        $RoomSetNotificationCallsResponseApplicationJson_OcsInterface,
        Built<RoomSetNotificationCallsResponseApplicationJson_Ocs,
            RoomSetNotificationCallsResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomSetNotificationCallsResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomSetNotificationCallsResponseApplicationJson_Ocs([
    void Function(RoomSetNotificationCallsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomSetNotificationCallsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomSetNotificationCallsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomSetNotificationCallsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomSetNotificationCallsResponseApplicationJson_Ocs.
  static Serializer<RoomSetNotificationCallsResponseApplicationJson_Ocs> get serializer =>
      _$roomSetNotificationCallsResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomSetNotificationCallsResponseApplicationJson_OcsBuilder b) {
    $RoomSetNotificationCallsResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomSetNotificationCallsResponseApplicationJson_OcsBuilder b) {
    $RoomSetNotificationCallsResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetNotificationCallsResponseApplicationJsonInterface {
  RoomSetNotificationCallsResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomSetNotificationCallsResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomSetNotificationCallsResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomSetNotificationCallsResponseApplicationJson
    implements
        $RoomSetNotificationCallsResponseApplicationJsonInterface,
        Built<RoomSetNotificationCallsResponseApplicationJson, RoomSetNotificationCallsResponseApplicationJsonBuilder> {
  /// Creates a new RoomSetNotificationCallsResponseApplicationJson object using the builder pattern.
  factory RoomSetNotificationCallsResponseApplicationJson([
    void Function(RoomSetNotificationCallsResponseApplicationJsonBuilder)? b,
  ]) = _$RoomSetNotificationCallsResponseApplicationJson;

  // coverage:ignore-start
  const RoomSetNotificationCallsResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomSetNotificationCallsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomSetNotificationCallsResponseApplicationJson.
  static Serializer<RoomSetNotificationCallsResponseApplicationJson> get serializer =>
      _$roomSetNotificationCallsResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomSetNotificationCallsResponseApplicationJsonBuilder b) {
    $RoomSetNotificationCallsResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomSetNotificationCallsResponseApplicationJsonBuilder b) {
    $RoomSetNotificationCallsResponseApplicationJsonInterface._validate(b);
  }
}

class RoomSetLobbyApiVersion extends EnumClass {
  const RoomSetLobbyApiVersion._(super.name);

  /// `v4`
  static const RoomSetLobbyApiVersion v4 = _$roomSetLobbyApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomSetLobbyApiVersion> get values => _$roomSetLobbyApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomSetLobbyApiVersion valueOf(String name) => _$valueOfRoomSetLobbyApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomSetLobbyApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetLobbyApiVersion> get serializer => const _$RoomSetLobbyApiVersionSerializer();
}

class _$RoomSetLobbyApiVersionSerializer implements PrimitiveSerializer<RoomSetLobbyApiVersion> {
  const _$RoomSetLobbyApiVersionSerializer();

  static const Map<RoomSetLobbyApiVersion, Object> _toWire = <RoomSetLobbyApiVersion, Object>{
    RoomSetLobbyApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomSetLobbyApiVersion> _fromWire = <Object, RoomSetLobbyApiVersion>{
    'v4': RoomSetLobbyApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomSetLobbyApiVersion];

  @override
  String get wireName => 'RoomSetLobbyApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetLobbyApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetLobbyApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetLobbyResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomSetLobbyResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomSetLobbyResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomSetLobbyResponseApplicationJson_Ocs
    implements
        $RoomSetLobbyResponseApplicationJson_OcsInterface,
        Built<RoomSetLobbyResponseApplicationJson_Ocs, RoomSetLobbyResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomSetLobbyResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomSetLobbyResponseApplicationJson_Ocs([void Function(RoomSetLobbyResponseApplicationJson_OcsBuilder)? b]) =
      _$RoomSetLobbyResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomSetLobbyResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomSetLobbyResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomSetLobbyResponseApplicationJson_Ocs.
  static Serializer<RoomSetLobbyResponseApplicationJson_Ocs> get serializer =>
      _$roomSetLobbyResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomSetLobbyResponseApplicationJson_OcsBuilder b) {
    $RoomSetLobbyResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomSetLobbyResponseApplicationJson_OcsBuilder b) {
    $RoomSetLobbyResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetLobbyResponseApplicationJsonInterface {
  RoomSetLobbyResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomSetLobbyResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomSetLobbyResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomSetLobbyResponseApplicationJson
    implements
        $RoomSetLobbyResponseApplicationJsonInterface,
        Built<RoomSetLobbyResponseApplicationJson, RoomSetLobbyResponseApplicationJsonBuilder> {
  /// Creates a new RoomSetLobbyResponseApplicationJson object using the builder pattern.
  factory RoomSetLobbyResponseApplicationJson([void Function(RoomSetLobbyResponseApplicationJsonBuilder)? b]) =
      _$RoomSetLobbyResponseApplicationJson;

  // coverage:ignore-start
  const RoomSetLobbyResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomSetLobbyResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomSetLobbyResponseApplicationJson.
  static Serializer<RoomSetLobbyResponseApplicationJson> get serializer =>
      _$roomSetLobbyResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomSetLobbyResponseApplicationJsonBuilder b) {
    $RoomSetLobbyResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomSetLobbyResponseApplicationJsonBuilder b) {
    $RoomSetLobbyResponseApplicationJsonInterface._validate(b);
  }
}

class RoomSetsipEnabledState extends EnumClass {
  const RoomSetsipEnabledState._(super.name);

  /// `0`
  @BuiltValueEnumConst(wireName: '0')
  static const RoomSetsipEnabledState $0 = _$roomSetsipEnabledState$0;

  /// `1`
  @BuiltValueEnumConst(wireName: '1')
  static const RoomSetsipEnabledState $1 = _$roomSetsipEnabledState$1;

  /// `2`
  @BuiltValueEnumConst(wireName: '2')
  static const RoomSetsipEnabledState $2 = _$roomSetsipEnabledState$2;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomSetsipEnabledState> get values => _$roomSetsipEnabledStateValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomSetsipEnabledState valueOf(String name) => _$valueOfRoomSetsipEnabledState(name);

  /// Returns the serialized value of this enum value.
  int get value => _$jsonSerializers.serializeWith(serializer, this)! as int;

  /// Serializer for RoomSetsipEnabledState.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetsipEnabledState> get serializer => const _$RoomSetsipEnabledStateSerializer();
}

class _$RoomSetsipEnabledStateSerializer implements PrimitiveSerializer<RoomSetsipEnabledState> {
  const _$RoomSetsipEnabledStateSerializer();

  static const Map<RoomSetsipEnabledState, Object> _toWire = <RoomSetsipEnabledState, Object>{
    RoomSetsipEnabledState.$0: 0,
    RoomSetsipEnabledState.$1: 1,
    RoomSetsipEnabledState.$2: 2,
  };

  static const Map<Object, RoomSetsipEnabledState> _fromWire = <Object, RoomSetsipEnabledState>{
    0: RoomSetsipEnabledState.$0,
    1: RoomSetsipEnabledState.$1,
    2: RoomSetsipEnabledState.$2,
  };

  @override
  Iterable<Type> get types => const [RoomSetsipEnabledState];

  @override
  String get wireName => 'RoomSetsipEnabledState';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetsipEnabledState object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetsipEnabledState deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class RoomSetsipEnabledApiVersion extends EnumClass {
  const RoomSetsipEnabledApiVersion._(super.name);

  /// `v4`
  static const RoomSetsipEnabledApiVersion v4 = _$roomSetsipEnabledApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomSetsipEnabledApiVersion> get values => _$roomSetsipEnabledApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomSetsipEnabledApiVersion valueOf(String name) => _$valueOfRoomSetsipEnabledApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomSetsipEnabledApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetsipEnabledApiVersion> get serializer => const _$RoomSetsipEnabledApiVersionSerializer();
}

class _$RoomSetsipEnabledApiVersionSerializer implements PrimitiveSerializer<RoomSetsipEnabledApiVersion> {
  const _$RoomSetsipEnabledApiVersionSerializer();

  static const Map<RoomSetsipEnabledApiVersion, Object> _toWire = <RoomSetsipEnabledApiVersion, Object>{
    RoomSetsipEnabledApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomSetsipEnabledApiVersion> _fromWire = <Object, RoomSetsipEnabledApiVersion>{
    'v4': RoomSetsipEnabledApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomSetsipEnabledApiVersion];

  @override
  String get wireName => 'RoomSetsipEnabledApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetsipEnabledApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetsipEnabledApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetsipEnabledResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomSetsipEnabledResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomSetsipEnabledResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomSetsipEnabledResponseApplicationJson_Ocs
    implements
        $RoomSetsipEnabledResponseApplicationJson_OcsInterface,
        Built<RoomSetsipEnabledResponseApplicationJson_Ocs, RoomSetsipEnabledResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomSetsipEnabledResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomSetsipEnabledResponseApplicationJson_Ocs([
    void Function(RoomSetsipEnabledResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomSetsipEnabledResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomSetsipEnabledResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomSetsipEnabledResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomSetsipEnabledResponseApplicationJson_Ocs.
  static Serializer<RoomSetsipEnabledResponseApplicationJson_Ocs> get serializer =>
      _$roomSetsipEnabledResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomSetsipEnabledResponseApplicationJson_OcsBuilder b) {
    $RoomSetsipEnabledResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomSetsipEnabledResponseApplicationJson_OcsBuilder b) {
    $RoomSetsipEnabledResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetsipEnabledResponseApplicationJsonInterface {
  RoomSetsipEnabledResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomSetsipEnabledResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomSetsipEnabledResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomSetsipEnabledResponseApplicationJson
    implements
        $RoomSetsipEnabledResponseApplicationJsonInterface,
        Built<RoomSetsipEnabledResponseApplicationJson, RoomSetsipEnabledResponseApplicationJsonBuilder> {
  /// Creates a new RoomSetsipEnabledResponseApplicationJson object using the builder pattern.
  factory RoomSetsipEnabledResponseApplicationJson([
    void Function(RoomSetsipEnabledResponseApplicationJsonBuilder)? b,
  ]) = _$RoomSetsipEnabledResponseApplicationJson;

  // coverage:ignore-start
  const RoomSetsipEnabledResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomSetsipEnabledResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomSetsipEnabledResponseApplicationJson.
  static Serializer<RoomSetsipEnabledResponseApplicationJson> get serializer =>
      _$roomSetsipEnabledResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomSetsipEnabledResponseApplicationJsonBuilder b) {
    $RoomSetsipEnabledResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomSetsipEnabledResponseApplicationJsonBuilder b) {
    $RoomSetsipEnabledResponseApplicationJsonInterface._validate(b);
  }
}

class RoomSetRecordingConsentApiVersion extends EnumClass {
  const RoomSetRecordingConsentApiVersion._(super.name);

  /// `v4`
  static const RoomSetRecordingConsentApiVersion v4 = _$roomSetRecordingConsentApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomSetRecordingConsentApiVersion> get values => _$roomSetRecordingConsentApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomSetRecordingConsentApiVersion valueOf(String name) => _$valueOfRoomSetRecordingConsentApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomSetRecordingConsentApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetRecordingConsentApiVersion> get serializer =>
      const _$RoomSetRecordingConsentApiVersionSerializer();
}

class _$RoomSetRecordingConsentApiVersionSerializer implements PrimitiveSerializer<RoomSetRecordingConsentApiVersion> {
  const _$RoomSetRecordingConsentApiVersionSerializer();

  static const Map<RoomSetRecordingConsentApiVersion, Object> _toWire = <RoomSetRecordingConsentApiVersion, Object>{
    RoomSetRecordingConsentApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomSetRecordingConsentApiVersion> _fromWire = <Object, RoomSetRecordingConsentApiVersion>{
    'v4': RoomSetRecordingConsentApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomSetRecordingConsentApiVersion];

  @override
  String get wireName => 'RoomSetRecordingConsentApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetRecordingConsentApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetRecordingConsentApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetRecordingConsentResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomSetRecordingConsentResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomSetRecordingConsentResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomSetRecordingConsentResponseApplicationJson_Ocs
    implements
        $RoomSetRecordingConsentResponseApplicationJson_OcsInterface,
        Built<RoomSetRecordingConsentResponseApplicationJson_Ocs,
            RoomSetRecordingConsentResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomSetRecordingConsentResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomSetRecordingConsentResponseApplicationJson_Ocs([
    void Function(RoomSetRecordingConsentResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomSetRecordingConsentResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomSetRecordingConsentResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomSetRecordingConsentResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomSetRecordingConsentResponseApplicationJson_Ocs.
  static Serializer<RoomSetRecordingConsentResponseApplicationJson_Ocs> get serializer =>
      _$roomSetRecordingConsentResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomSetRecordingConsentResponseApplicationJson_OcsBuilder b) {
    $RoomSetRecordingConsentResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomSetRecordingConsentResponseApplicationJson_OcsBuilder b) {
    $RoomSetRecordingConsentResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetRecordingConsentResponseApplicationJsonInterface {
  RoomSetRecordingConsentResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomSetRecordingConsentResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomSetRecordingConsentResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomSetRecordingConsentResponseApplicationJson
    implements
        $RoomSetRecordingConsentResponseApplicationJsonInterface,
        Built<RoomSetRecordingConsentResponseApplicationJson, RoomSetRecordingConsentResponseApplicationJsonBuilder> {
  /// Creates a new RoomSetRecordingConsentResponseApplicationJson object using the builder pattern.
  factory RoomSetRecordingConsentResponseApplicationJson([
    void Function(RoomSetRecordingConsentResponseApplicationJsonBuilder)? b,
  ]) = _$RoomSetRecordingConsentResponseApplicationJson;

  // coverage:ignore-start
  const RoomSetRecordingConsentResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomSetRecordingConsentResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomSetRecordingConsentResponseApplicationJson.
  static Serializer<RoomSetRecordingConsentResponseApplicationJson> get serializer =>
      _$roomSetRecordingConsentResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomSetRecordingConsentResponseApplicationJsonBuilder b) {
    $RoomSetRecordingConsentResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomSetRecordingConsentResponseApplicationJsonBuilder b) {
    $RoomSetRecordingConsentResponseApplicationJsonInterface._validate(b);
  }
}

class RoomSetMessageExpirationApiVersion extends EnumClass {
  const RoomSetMessageExpirationApiVersion._(super.name);

  /// `v4`
  static const RoomSetMessageExpirationApiVersion v4 = _$roomSetMessageExpirationApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomSetMessageExpirationApiVersion> get values => _$roomSetMessageExpirationApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomSetMessageExpirationApiVersion valueOf(String name) => _$valueOfRoomSetMessageExpirationApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomSetMessageExpirationApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetMessageExpirationApiVersion> get serializer =>
      const _$RoomSetMessageExpirationApiVersionSerializer();
}

class _$RoomSetMessageExpirationApiVersionSerializer
    implements PrimitiveSerializer<RoomSetMessageExpirationApiVersion> {
  const _$RoomSetMessageExpirationApiVersionSerializer();

  static const Map<RoomSetMessageExpirationApiVersion, Object> _toWire = <RoomSetMessageExpirationApiVersion, Object>{
    RoomSetMessageExpirationApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomSetMessageExpirationApiVersion> _fromWire = <Object, RoomSetMessageExpirationApiVersion>{
    'v4': RoomSetMessageExpirationApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomSetMessageExpirationApiVersion];

  @override
  String get wireName => 'RoomSetMessageExpirationApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetMessageExpirationApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetMessageExpirationApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetMessageExpirationResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomSetMessageExpirationResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomSetMessageExpirationResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomSetMessageExpirationResponseApplicationJson_Ocs
    implements
        $RoomSetMessageExpirationResponseApplicationJson_OcsInterface,
        Built<RoomSetMessageExpirationResponseApplicationJson_Ocs,
            RoomSetMessageExpirationResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomSetMessageExpirationResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomSetMessageExpirationResponseApplicationJson_Ocs([
    void Function(RoomSetMessageExpirationResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomSetMessageExpirationResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomSetMessageExpirationResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomSetMessageExpirationResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomSetMessageExpirationResponseApplicationJson_Ocs.
  static Serializer<RoomSetMessageExpirationResponseApplicationJson_Ocs> get serializer =>
      _$roomSetMessageExpirationResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomSetMessageExpirationResponseApplicationJson_OcsBuilder b) {
    $RoomSetMessageExpirationResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomSetMessageExpirationResponseApplicationJson_OcsBuilder b) {
    $RoomSetMessageExpirationResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetMessageExpirationResponseApplicationJsonInterface {
  RoomSetMessageExpirationResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomSetMessageExpirationResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomSetMessageExpirationResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomSetMessageExpirationResponseApplicationJson
    implements
        $RoomSetMessageExpirationResponseApplicationJsonInterface,
        Built<RoomSetMessageExpirationResponseApplicationJson, RoomSetMessageExpirationResponseApplicationJsonBuilder> {
  /// Creates a new RoomSetMessageExpirationResponseApplicationJson object using the builder pattern.
  factory RoomSetMessageExpirationResponseApplicationJson([
    void Function(RoomSetMessageExpirationResponseApplicationJsonBuilder)? b,
  ]) = _$RoomSetMessageExpirationResponseApplicationJson;

  // coverage:ignore-start
  const RoomSetMessageExpirationResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomSetMessageExpirationResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomSetMessageExpirationResponseApplicationJson.
  static Serializer<RoomSetMessageExpirationResponseApplicationJson> get serializer =>
      _$roomSetMessageExpirationResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomSetMessageExpirationResponseApplicationJsonBuilder b) {
    $RoomSetMessageExpirationResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomSetMessageExpirationResponseApplicationJsonBuilder b) {
    $RoomSetMessageExpirationResponseApplicationJsonInterface._validate(b);
  }
}

class RoomGetCapabilitiesApiVersion extends EnumClass {
  const RoomGetCapabilitiesApiVersion._(super.name);

  /// `v4`
  static const RoomGetCapabilitiesApiVersion v4 = _$roomGetCapabilitiesApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomGetCapabilitiesApiVersion> get values => _$roomGetCapabilitiesApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomGetCapabilitiesApiVersion valueOf(String name) => _$valueOfRoomGetCapabilitiesApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomGetCapabilitiesApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomGetCapabilitiesApiVersion> get serializer => const _$RoomGetCapabilitiesApiVersionSerializer();
}

class _$RoomGetCapabilitiesApiVersionSerializer implements PrimitiveSerializer<RoomGetCapabilitiesApiVersion> {
  const _$RoomGetCapabilitiesApiVersionSerializer();

  static const Map<RoomGetCapabilitiesApiVersion, Object> _toWire = <RoomGetCapabilitiesApiVersion, Object>{
    RoomGetCapabilitiesApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomGetCapabilitiesApiVersion> _fromWire = <Object, RoomGetCapabilitiesApiVersion>{
    'v4': RoomGetCapabilitiesApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomGetCapabilitiesApiVersion];

  @override
  String get wireName => 'RoomGetCapabilitiesApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomGetCapabilitiesApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomGetCapabilitiesApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $Capabilities_Config_AttachmentsInterface {
  bool get allowed;
  String? get folder;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($Capabilities_Config_AttachmentsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($Capabilities_Config_AttachmentsInterfaceBuilder b) {}
}

abstract class Capabilities_Config_Attachments
    implements
        $Capabilities_Config_AttachmentsInterface,
        Built<Capabilities_Config_Attachments, Capabilities_Config_AttachmentsBuilder> {
  /// Creates a new Capabilities_Config_Attachments object using the builder pattern.
  factory Capabilities_Config_Attachments([void Function(Capabilities_Config_AttachmentsBuilder)? b]) =
      _$Capabilities_Config_Attachments;

  // coverage:ignore-start
  const Capabilities_Config_Attachments._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory Capabilities_Config_Attachments.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for Capabilities_Config_Attachments.
  static Serializer<Capabilities_Config_Attachments> get serializer => _$capabilitiesConfigAttachmentsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(Capabilities_Config_AttachmentsBuilder b) {
    $Capabilities_Config_AttachmentsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(Capabilities_Config_AttachmentsBuilder b) {
    $Capabilities_Config_AttachmentsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $Capabilities_Config_CallInterface {
  bool get enabled;
  @BuiltValueField(wireName: 'breakout-rooms')
  bool get breakoutRooms;
  bool get recording;
  @BuiltValueField(wireName: 'recording-consent')
  int? get recordingConsent;
  @BuiltValueField(wireName: 'supported-reactions')
  BuiltList<String> get supportedReactions;
  @BuiltValueField(wireName: 'predefined-backgrounds')
  BuiltList<String> get predefinedBackgrounds;
  @BuiltValueField(wireName: 'can-upload-background')
  bool get canUploadBackground;
  @BuiltValueField(wireName: 'sip-enabled')
  bool? get sipEnabled;
  @BuiltValueField(wireName: 'sip-dialout-enabled')
  bool? get sipDialoutEnabled;
  @BuiltValueField(wireName: 'can-enable-sip')
  bool? get canEnableSip;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($Capabilities_Config_CallInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($Capabilities_Config_CallInterfaceBuilder b) {}
}

abstract class Capabilities_Config_Call
    implements $Capabilities_Config_CallInterface, Built<Capabilities_Config_Call, Capabilities_Config_CallBuilder> {
  /// Creates a new Capabilities_Config_Call object using the builder pattern.
  factory Capabilities_Config_Call([void Function(Capabilities_Config_CallBuilder)? b]) = _$Capabilities_Config_Call;

  // coverage:ignore-start
  const Capabilities_Config_Call._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory Capabilities_Config_Call.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for Capabilities_Config_Call.
  static Serializer<Capabilities_Config_Call> get serializer => _$capabilitiesConfigCallSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(Capabilities_Config_CallBuilder b) {
    $Capabilities_Config_CallInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(Capabilities_Config_CallBuilder b) {
    $Capabilities_Config_CallInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $Capabilities_Config_ChatInterface {
  @BuiltValueField(wireName: 'max-length')
  int get maxLength;
  @BuiltValueField(wireName: 'read-privacy')
  int get readPrivacy;
  @BuiltValueField(wireName: 'has-translation-providers')
  bool? get hasTranslationProviders;
  @BuiltValueField(wireName: 'typing-privacy')
  int get typingPrivacy;
  BuiltList<String>? get translations;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($Capabilities_Config_ChatInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($Capabilities_Config_ChatInterfaceBuilder b) {}
}

abstract class Capabilities_Config_Chat
    implements $Capabilities_Config_ChatInterface, Built<Capabilities_Config_Chat, Capabilities_Config_ChatBuilder> {
  /// Creates a new Capabilities_Config_Chat object using the builder pattern.
  factory Capabilities_Config_Chat([void Function(Capabilities_Config_ChatBuilder)? b]) = _$Capabilities_Config_Chat;

  // coverage:ignore-start
  const Capabilities_Config_Chat._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory Capabilities_Config_Chat.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for Capabilities_Config_Chat.
  static Serializer<Capabilities_Config_Chat> get serializer => _$capabilitiesConfigChatSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(Capabilities_Config_ChatBuilder b) {
    $Capabilities_Config_ChatInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(Capabilities_Config_ChatBuilder b) {
    $Capabilities_Config_ChatInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $Capabilities_Config_ConversationsInterface {
  @BuiltValueField(wireName: 'can-create')
  bool get canCreate;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($Capabilities_Config_ConversationsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($Capabilities_Config_ConversationsInterfaceBuilder b) {}
}

abstract class Capabilities_Config_Conversations
    implements
        $Capabilities_Config_ConversationsInterface,
        Built<Capabilities_Config_Conversations, Capabilities_Config_ConversationsBuilder> {
  /// Creates a new Capabilities_Config_Conversations object using the builder pattern.
  factory Capabilities_Config_Conversations([void Function(Capabilities_Config_ConversationsBuilder)? b]) =
      _$Capabilities_Config_Conversations;

  // coverage:ignore-start
  const Capabilities_Config_Conversations._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory Capabilities_Config_Conversations.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for Capabilities_Config_Conversations.
  static Serializer<Capabilities_Config_Conversations> get serializer => _$capabilitiesConfigConversationsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(Capabilities_Config_ConversationsBuilder b) {
    $Capabilities_Config_ConversationsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(Capabilities_Config_ConversationsBuilder b) {
    $Capabilities_Config_ConversationsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $Capabilities_Config_FederationInterface {
  bool get enabled;
  @BuiltValueField(wireName: 'incoming-enabled')
  bool get incomingEnabled;
  @BuiltValueField(wireName: 'outgoing-enabled')
  bool get outgoingEnabled;
  @BuiltValueField(wireName: 'only-trusted-servers')
  bool get onlyTrustedServers;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($Capabilities_Config_FederationInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($Capabilities_Config_FederationInterfaceBuilder b) {}
}

abstract class Capabilities_Config_Federation
    implements
        $Capabilities_Config_FederationInterface,
        Built<Capabilities_Config_Federation, Capabilities_Config_FederationBuilder> {
  /// Creates a new Capabilities_Config_Federation object using the builder pattern.
  factory Capabilities_Config_Federation([void Function(Capabilities_Config_FederationBuilder)? b]) =
      _$Capabilities_Config_Federation;

  // coverage:ignore-start
  const Capabilities_Config_Federation._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory Capabilities_Config_Federation.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for Capabilities_Config_Federation.
  static Serializer<Capabilities_Config_Federation> get serializer => _$capabilitiesConfigFederationSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(Capabilities_Config_FederationBuilder b) {
    $Capabilities_Config_FederationInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(Capabilities_Config_FederationBuilder b) {
    $Capabilities_Config_FederationInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $Capabilities_Config_PreviewsInterface {
  @BuiltValueField(wireName: 'max-gif-size')
  int get maxGifSize;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($Capabilities_Config_PreviewsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($Capabilities_Config_PreviewsInterfaceBuilder b) {}
}

abstract class Capabilities_Config_Previews
    implements
        $Capabilities_Config_PreviewsInterface,
        Built<Capabilities_Config_Previews, Capabilities_Config_PreviewsBuilder> {
  /// Creates a new Capabilities_Config_Previews object using the builder pattern.
  factory Capabilities_Config_Previews([void Function(Capabilities_Config_PreviewsBuilder)? b]) =
      _$Capabilities_Config_Previews;

  // coverage:ignore-start
  const Capabilities_Config_Previews._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory Capabilities_Config_Previews.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for Capabilities_Config_Previews.
  static Serializer<Capabilities_Config_Previews> get serializer => _$capabilitiesConfigPreviewsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(Capabilities_Config_PreviewsBuilder b) {
    $Capabilities_Config_PreviewsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(Capabilities_Config_PreviewsBuilder b) {
    $Capabilities_Config_PreviewsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $Capabilities_Config_SignalingInterface {
  @BuiltValueField(wireName: 'session-ping-limit')
  int get sessionPingLimit;
  @BuiltValueField(wireName: 'hello-v2-token-key')
  String? get helloV2TokenKey;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($Capabilities_Config_SignalingInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($Capabilities_Config_SignalingInterfaceBuilder b) {}
}

abstract class Capabilities_Config_Signaling
    implements
        $Capabilities_Config_SignalingInterface,
        Built<Capabilities_Config_Signaling, Capabilities_Config_SignalingBuilder> {
  /// Creates a new Capabilities_Config_Signaling object using the builder pattern.
  factory Capabilities_Config_Signaling([void Function(Capabilities_Config_SignalingBuilder)? b]) =
      _$Capabilities_Config_Signaling;

  // coverage:ignore-start
  const Capabilities_Config_Signaling._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory Capabilities_Config_Signaling.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for Capabilities_Config_Signaling.
  static Serializer<Capabilities_Config_Signaling> get serializer => _$capabilitiesConfigSignalingSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(Capabilities_Config_SignalingBuilder b) {
    $Capabilities_Config_SignalingInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(Capabilities_Config_SignalingBuilder b) {
    $Capabilities_Config_SignalingInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $Capabilities_ConfigInterface {
  Capabilities_Config_Attachments get attachments;
  Capabilities_Config_Call get call;
  Capabilities_Config_Chat get chat;
  Capabilities_Config_Conversations get conversations;
  Capabilities_Config_Federation? get federation;
  Capabilities_Config_Previews get previews;
  Capabilities_Config_Signaling get signaling;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($Capabilities_ConfigInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($Capabilities_ConfigInterfaceBuilder b) {}
}

abstract class Capabilities_Config
    implements $Capabilities_ConfigInterface, Built<Capabilities_Config, Capabilities_ConfigBuilder> {
  /// Creates a new Capabilities_Config object using the builder pattern.
  factory Capabilities_Config([void Function(Capabilities_ConfigBuilder)? b]) = _$Capabilities_Config;

  // coverage:ignore-start
  const Capabilities_Config._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory Capabilities_Config.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for Capabilities_Config.
  static Serializer<Capabilities_Config> get serializer => _$capabilitiesConfigSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(Capabilities_ConfigBuilder b) {
    $Capabilities_ConfigInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(Capabilities_ConfigBuilder b) {
    $Capabilities_ConfigInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CapabilitiesInterface {
  BuiltList<String> get features;
  Capabilities_Config get config;
  String get version;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CapabilitiesInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CapabilitiesInterfaceBuilder b) {}
}

abstract class Capabilities implements $CapabilitiesInterface, Built<Capabilities, CapabilitiesBuilder> {
  /// Creates a new Capabilities object using the builder pattern.
  factory Capabilities([void Function(CapabilitiesBuilder)? b]) = _$Capabilities;

  // coverage:ignore-start
  const Capabilities._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory Capabilities.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for Capabilities.
  static Serializer<Capabilities> get serializer => _$capabilitiesSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CapabilitiesBuilder b) {
    $CapabilitiesInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CapabilitiesBuilder b) {
    $CapabilitiesInterface._validate(b);
  }
}

typedef RoomGetCapabilitiesResponseApplicationJson_Ocs_Data = ({
  BuiltList<Never>? builtListNever,
  Capabilities? capabilities
});

@BuiltValue(instantiable: false)
abstract interface class $RoomGetCapabilitiesResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  RoomGetCapabilitiesResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomGetCapabilitiesResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomGetCapabilitiesResponseApplicationJson_OcsInterfaceBuilder b) {
    b.data?.validateAnyOf();
  }
}

abstract class RoomGetCapabilitiesResponseApplicationJson_Ocs
    implements
        $RoomGetCapabilitiesResponseApplicationJson_OcsInterface,
        Built<RoomGetCapabilitiesResponseApplicationJson_Ocs, RoomGetCapabilitiesResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomGetCapabilitiesResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomGetCapabilitiesResponseApplicationJson_Ocs([
    void Function(RoomGetCapabilitiesResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomGetCapabilitiesResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomGetCapabilitiesResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomGetCapabilitiesResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomGetCapabilitiesResponseApplicationJson_Ocs.
  static Serializer<RoomGetCapabilitiesResponseApplicationJson_Ocs> get serializer =>
      _$roomGetCapabilitiesResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomGetCapabilitiesResponseApplicationJson_OcsBuilder b) {
    $RoomGetCapabilitiesResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomGetCapabilitiesResponseApplicationJson_OcsBuilder b) {
    $RoomGetCapabilitiesResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomGetCapabilitiesResponseApplicationJsonInterface {
  RoomGetCapabilitiesResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomGetCapabilitiesResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomGetCapabilitiesResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomGetCapabilitiesResponseApplicationJson
    implements
        $RoomGetCapabilitiesResponseApplicationJsonInterface,
        Built<RoomGetCapabilitiesResponseApplicationJson, RoomGetCapabilitiesResponseApplicationJsonBuilder> {
  /// Creates a new RoomGetCapabilitiesResponseApplicationJson object using the builder pattern.
  factory RoomGetCapabilitiesResponseApplicationJson([
    void Function(RoomGetCapabilitiesResponseApplicationJsonBuilder)? b,
  ]) = _$RoomGetCapabilitiesResponseApplicationJson;

  // coverage:ignore-start
  const RoomGetCapabilitiesResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomGetCapabilitiesResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomGetCapabilitiesResponseApplicationJson.
  static Serializer<RoomGetCapabilitiesResponseApplicationJson> get serializer =>
      _$roomGetCapabilitiesResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomGetCapabilitiesResponseApplicationJsonBuilder b) {
    $RoomGetCapabilitiesResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomGetCapabilitiesResponseApplicationJsonBuilder b) {
    $RoomGetCapabilitiesResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomRoomGetCapabilitiesHeadersInterface {
  @BuiltValueField(wireName: 'x-nextcloud-talk-hash')
  String? get xNextcloudTalkHash;
  @BuiltValueField(wireName: 'x-nextcloud-talk-proxy-hash')
  String? get xNextcloudTalkProxyHash;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomRoomGetCapabilitiesHeadersInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomRoomGetCapabilitiesHeadersInterfaceBuilder b) {}
}

abstract class RoomRoomGetCapabilitiesHeaders
    implements
        $RoomRoomGetCapabilitiesHeadersInterface,
        Built<RoomRoomGetCapabilitiesHeaders, RoomRoomGetCapabilitiesHeadersBuilder> {
  /// Creates a new RoomRoomGetCapabilitiesHeaders object using the builder pattern.
  factory RoomRoomGetCapabilitiesHeaders([void Function(RoomRoomGetCapabilitiesHeadersBuilder)? b]) =
      _$RoomRoomGetCapabilitiesHeaders;

  // coverage:ignore-start
  const RoomRoomGetCapabilitiesHeaders._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomRoomGetCapabilitiesHeaders.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomRoomGetCapabilitiesHeaders.
  static Serializer<RoomRoomGetCapabilitiesHeaders> get serializer => _$roomRoomGetCapabilitiesHeadersSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomRoomGetCapabilitiesHeadersBuilder b) {
    $RoomRoomGetCapabilitiesHeadersInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomRoomGetCapabilitiesHeadersBuilder b) {
    $RoomRoomGetCapabilitiesHeadersInterface._validate(b);
  }
}

class RoomJoinFederatedRoomApiVersion extends EnumClass {
  const RoomJoinFederatedRoomApiVersion._(super.name);

  /// `v4`
  static const RoomJoinFederatedRoomApiVersion v4 = _$roomJoinFederatedRoomApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomJoinFederatedRoomApiVersion> get values => _$roomJoinFederatedRoomApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomJoinFederatedRoomApiVersion valueOf(String name) => _$valueOfRoomJoinFederatedRoomApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomJoinFederatedRoomApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomJoinFederatedRoomApiVersion> get serializer =>
      const _$RoomJoinFederatedRoomApiVersionSerializer();
}

class _$RoomJoinFederatedRoomApiVersionSerializer implements PrimitiveSerializer<RoomJoinFederatedRoomApiVersion> {
  const _$RoomJoinFederatedRoomApiVersionSerializer();

  static const Map<RoomJoinFederatedRoomApiVersion, Object> _toWire = <RoomJoinFederatedRoomApiVersion, Object>{
    RoomJoinFederatedRoomApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomJoinFederatedRoomApiVersion> _fromWire = <Object, RoomJoinFederatedRoomApiVersion>{
    'v4': RoomJoinFederatedRoomApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomJoinFederatedRoomApiVersion];

  @override
  String get wireName => 'RoomJoinFederatedRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomJoinFederatedRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomJoinFederatedRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomJoinFederatedRoomResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomJoinFederatedRoomResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomJoinFederatedRoomResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomJoinFederatedRoomResponseApplicationJson_Ocs
    implements
        $RoomJoinFederatedRoomResponseApplicationJson_OcsInterface,
        Built<RoomJoinFederatedRoomResponseApplicationJson_Ocs,
            RoomJoinFederatedRoomResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomJoinFederatedRoomResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomJoinFederatedRoomResponseApplicationJson_Ocs([
    void Function(RoomJoinFederatedRoomResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomJoinFederatedRoomResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomJoinFederatedRoomResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomJoinFederatedRoomResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomJoinFederatedRoomResponseApplicationJson_Ocs.
  static Serializer<RoomJoinFederatedRoomResponseApplicationJson_Ocs> get serializer =>
      _$roomJoinFederatedRoomResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomJoinFederatedRoomResponseApplicationJson_OcsBuilder b) {
    $RoomJoinFederatedRoomResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomJoinFederatedRoomResponseApplicationJson_OcsBuilder b) {
    $RoomJoinFederatedRoomResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomJoinFederatedRoomResponseApplicationJsonInterface {
  RoomJoinFederatedRoomResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomJoinFederatedRoomResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomJoinFederatedRoomResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomJoinFederatedRoomResponseApplicationJson
    implements
        $RoomJoinFederatedRoomResponseApplicationJsonInterface,
        Built<RoomJoinFederatedRoomResponseApplicationJson, RoomJoinFederatedRoomResponseApplicationJsonBuilder> {
  /// Creates a new RoomJoinFederatedRoomResponseApplicationJson object using the builder pattern.
  factory RoomJoinFederatedRoomResponseApplicationJson([
    void Function(RoomJoinFederatedRoomResponseApplicationJsonBuilder)? b,
  ]) = _$RoomJoinFederatedRoomResponseApplicationJson;

  // coverage:ignore-start
  const RoomJoinFederatedRoomResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomJoinFederatedRoomResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomJoinFederatedRoomResponseApplicationJson.
  static Serializer<RoomJoinFederatedRoomResponseApplicationJson> get serializer =>
      _$roomJoinFederatedRoomResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomJoinFederatedRoomResponseApplicationJsonBuilder b) {
    $RoomJoinFederatedRoomResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomJoinFederatedRoomResponseApplicationJsonBuilder b) {
    $RoomJoinFederatedRoomResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomRoomJoinFederatedRoomHeadersInterface {
  @BuiltValueField(wireName: 'x-nextcloud-talk-hash')
  String? get xNextcloudTalkHash;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomRoomJoinFederatedRoomHeadersInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomRoomJoinFederatedRoomHeadersInterfaceBuilder b) {}
}

abstract class RoomRoomJoinFederatedRoomHeaders
    implements
        $RoomRoomJoinFederatedRoomHeadersInterface,
        Built<RoomRoomJoinFederatedRoomHeaders, RoomRoomJoinFederatedRoomHeadersBuilder> {
  /// Creates a new RoomRoomJoinFederatedRoomHeaders object using the builder pattern.
  factory RoomRoomJoinFederatedRoomHeaders([void Function(RoomRoomJoinFederatedRoomHeadersBuilder)? b]) =
      _$RoomRoomJoinFederatedRoomHeaders;

  // coverage:ignore-start
  const RoomRoomJoinFederatedRoomHeaders._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomRoomJoinFederatedRoomHeaders.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomRoomJoinFederatedRoomHeaders.
  static Serializer<RoomRoomJoinFederatedRoomHeaders> get serializer => _$roomRoomJoinFederatedRoomHeadersSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomRoomJoinFederatedRoomHeadersBuilder b) {
    $RoomRoomJoinFederatedRoomHeadersInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomRoomJoinFederatedRoomHeadersBuilder b) {
    $RoomRoomJoinFederatedRoomHeadersInterface._validate(b);
  }
}

class RoomVerifyDialInPinDeprecatedApiVersion extends EnumClass {
  const RoomVerifyDialInPinDeprecatedApiVersion._(super.name);

  /// `v4`
  static const RoomVerifyDialInPinDeprecatedApiVersion v4 = _$roomVerifyDialInPinDeprecatedApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomVerifyDialInPinDeprecatedApiVersion> get values =>
      _$roomVerifyDialInPinDeprecatedApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomVerifyDialInPinDeprecatedApiVersion valueOf(String name) =>
      _$valueOfRoomVerifyDialInPinDeprecatedApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomVerifyDialInPinDeprecatedApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomVerifyDialInPinDeprecatedApiVersion> get serializer =>
      const _$RoomVerifyDialInPinDeprecatedApiVersionSerializer();
}

class _$RoomVerifyDialInPinDeprecatedApiVersionSerializer
    implements PrimitiveSerializer<RoomVerifyDialInPinDeprecatedApiVersion> {
  const _$RoomVerifyDialInPinDeprecatedApiVersionSerializer();

  static const Map<RoomVerifyDialInPinDeprecatedApiVersion, Object> _toWire =
      <RoomVerifyDialInPinDeprecatedApiVersion, Object>{
    RoomVerifyDialInPinDeprecatedApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomVerifyDialInPinDeprecatedApiVersion> _fromWire =
      <Object, RoomVerifyDialInPinDeprecatedApiVersion>{
    'v4': RoomVerifyDialInPinDeprecatedApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomVerifyDialInPinDeprecatedApiVersion];

  @override
  String get wireName => 'RoomVerifyDialInPinDeprecatedApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomVerifyDialInPinDeprecatedApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomVerifyDialInPinDeprecatedApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomVerifyDialInPinDeprecatedResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomVerifyDialInPinDeprecatedResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomVerifyDialInPinDeprecatedResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomVerifyDialInPinDeprecatedResponseApplicationJson_Ocs
    implements
        $RoomVerifyDialInPinDeprecatedResponseApplicationJson_OcsInterface,
        Built<RoomVerifyDialInPinDeprecatedResponseApplicationJson_Ocs,
            RoomVerifyDialInPinDeprecatedResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomVerifyDialInPinDeprecatedResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomVerifyDialInPinDeprecatedResponseApplicationJson_Ocs([
    void Function(RoomVerifyDialInPinDeprecatedResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomVerifyDialInPinDeprecatedResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomVerifyDialInPinDeprecatedResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomVerifyDialInPinDeprecatedResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomVerifyDialInPinDeprecatedResponseApplicationJson_Ocs.
  static Serializer<RoomVerifyDialInPinDeprecatedResponseApplicationJson_Ocs> get serializer =>
      _$roomVerifyDialInPinDeprecatedResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomVerifyDialInPinDeprecatedResponseApplicationJson_OcsBuilder b) {
    $RoomVerifyDialInPinDeprecatedResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomVerifyDialInPinDeprecatedResponseApplicationJson_OcsBuilder b) {
    $RoomVerifyDialInPinDeprecatedResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomVerifyDialInPinDeprecatedResponseApplicationJsonInterface {
  RoomVerifyDialInPinDeprecatedResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomVerifyDialInPinDeprecatedResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomVerifyDialInPinDeprecatedResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomVerifyDialInPinDeprecatedResponseApplicationJson
    implements
        $RoomVerifyDialInPinDeprecatedResponseApplicationJsonInterface,
        Built<RoomVerifyDialInPinDeprecatedResponseApplicationJson,
            RoomVerifyDialInPinDeprecatedResponseApplicationJsonBuilder> {
  /// Creates a new RoomVerifyDialInPinDeprecatedResponseApplicationJson object using the builder pattern.
  factory RoomVerifyDialInPinDeprecatedResponseApplicationJson([
    void Function(RoomVerifyDialInPinDeprecatedResponseApplicationJsonBuilder)? b,
  ]) = _$RoomVerifyDialInPinDeprecatedResponseApplicationJson;

  // coverage:ignore-start
  const RoomVerifyDialInPinDeprecatedResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomVerifyDialInPinDeprecatedResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomVerifyDialInPinDeprecatedResponseApplicationJson.
  static Serializer<RoomVerifyDialInPinDeprecatedResponseApplicationJson> get serializer =>
      _$roomVerifyDialInPinDeprecatedResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomVerifyDialInPinDeprecatedResponseApplicationJsonBuilder b) {
    $RoomVerifyDialInPinDeprecatedResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomVerifyDialInPinDeprecatedResponseApplicationJsonBuilder b) {
    $RoomVerifyDialInPinDeprecatedResponseApplicationJsonInterface._validate(b);
  }
}

class RoomVerifyDialInPinApiVersion extends EnumClass {
  const RoomVerifyDialInPinApiVersion._(super.name);

  /// `v4`
  static const RoomVerifyDialInPinApiVersion v4 = _$roomVerifyDialInPinApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomVerifyDialInPinApiVersion> get values => _$roomVerifyDialInPinApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomVerifyDialInPinApiVersion valueOf(String name) => _$valueOfRoomVerifyDialInPinApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomVerifyDialInPinApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomVerifyDialInPinApiVersion> get serializer => const _$RoomVerifyDialInPinApiVersionSerializer();
}

class _$RoomVerifyDialInPinApiVersionSerializer implements PrimitiveSerializer<RoomVerifyDialInPinApiVersion> {
  const _$RoomVerifyDialInPinApiVersionSerializer();

  static const Map<RoomVerifyDialInPinApiVersion, Object> _toWire = <RoomVerifyDialInPinApiVersion, Object>{
    RoomVerifyDialInPinApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomVerifyDialInPinApiVersion> _fromWire = <Object, RoomVerifyDialInPinApiVersion>{
    'v4': RoomVerifyDialInPinApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomVerifyDialInPinApiVersion];

  @override
  String get wireName => 'RoomVerifyDialInPinApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomVerifyDialInPinApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomVerifyDialInPinApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomVerifyDialInPinResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomVerifyDialInPinResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomVerifyDialInPinResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomVerifyDialInPinResponseApplicationJson_Ocs
    implements
        $RoomVerifyDialInPinResponseApplicationJson_OcsInterface,
        Built<RoomVerifyDialInPinResponseApplicationJson_Ocs, RoomVerifyDialInPinResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomVerifyDialInPinResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomVerifyDialInPinResponseApplicationJson_Ocs([
    void Function(RoomVerifyDialInPinResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomVerifyDialInPinResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomVerifyDialInPinResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomVerifyDialInPinResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomVerifyDialInPinResponseApplicationJson_Ocs.
  static Serializer<RoomVerifyDialInPinResponseApplicationJson_Ocs> get serializer =>
      _$roomVerifyDialInPinResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomVerifyDialInPinResponseApplicationJson_OcsBuilder b) {
    $RoomVerifyDialInPinResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomVerifyDialInPinResponseApplicationJson_OcsBuilder b) {
    $RoomVerifyDialInPinResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomVerifyDialInPinResponseApplicationJsonInterface {
  RoomVerifyDialInPinResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomVerifyDialInPinResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomVerifyDialInPinResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomVerifyDialInPinResponseApplicationJson
    implements
        $RoomVerifyDialInPinResponseApplicationJsonInterface,
        Built<RoomVerifyDialInPinResponseApplicationJson, RoomVerifyDialInPinResponseApplicationJsonBuilder> {
  /// Creates a new RoomVerifyDialInPinResponseApplicationJson object using the builder pattern.
  factory RoomVerifyDialInPinResponseApplicationJson([
    void Function(RoomVerifyDialInPinResponseApplicationJsonBuilder)? b,
  ]) = _$RoomVerifyDialInPinResponseApplicationJson;

  // coverage:ignore-start
  const RoomVerifyDialInPinResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomVerifyDialInPinResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomVerifyDialInPinResponseApplicationJson.
  static Serializer<RoomVerifyDialInPinResponseApplicationJson> get serializer =>
      _$roomVerifyDialInPinResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomVerifyDialInPinResponseApplicationJsonBuilder b) {
    $RoomVerifyDialInPinResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomVerifyDialInPinResponseApplicationJsonBuilder b) {
    $RoomVerifyDialInPinResponseApplicationJsonInterface._validate(b);
  }
}

/// Additional details to verify the validity of the request.
@BuiltValue(instantiable: false)
abstract interface class $RoomVerifyDialOutNumberOptionsInterface {
  String? get actorId;
  ActorType? get actorType;
  int? get attendeeId;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomVerifyDialOutNumberOptionsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomVerifyDialOutNumberOptionsInterfaceBuilder b) {}
}

/// Additional details to verify the validity of the request.
abstract class RoomVerifyDialOutNumberOptions
    implements
        $RoomVerifyDialOutNumberOptionsInterface,
        Built<RoomVerifyDialOutNumberOptions, RoomVerifyDialOutNumberOptionsBuilder> {
  /// Creates a new RoomVerifyDialOutNumberOptions object using the builder pattern.
  factory RoomVerifyDialOutNumberOptions([void Function(RoomVerifyDialOutNumberOptionsBuilder)? b]) =
      _$RoomVerifyDialOutNumberOptions;

  // coverage:ignore-start
  const RoomVerifyDialOutNumberOptions._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomVerifyDialOutNumberOptions.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomVerifyDialOutNumberOptions.
  static Serializer<RoomVerifyDialOutNumberOptions> get serializer => _$roomVerifyDialOutNumberOptionsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomVerifyDialOutNumberOptionsBuilder b) {
    $RoomVerifyDialOutNumberOptionsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomVerifyDialOutNumberOptionsBuilder b) {
    $RoomVerifyDialOutNumberOptionsInterface._validate(b);
  }
}

class RoomVerifyDialOutNumberApiVersion extends EnumClass {
  const RoomVerifyDialOutNumberApiVersion._(super.name);

  /// `v4`
  static const RoomVerifyDialOutNumberApiVersion v4 = _$roomVerifyDialOutNumberApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomVerifyDialOutNumberApiVersion> get values => _$roomVerifyDialOutNumberApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomVerifyDialOutNumberApiVersion valueOf(String name) => _$valueOfRoomVerifyDialOutNumberApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomVerifyDialOutNumberApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomVerifyDialOutNumberApiVersion> get serializer =>
      const _$RoomVerifyDialOutNumberApiVersionSerializer();
}

class _$RoomVerifyDialOutNumberApiVersionSerializer implements PrimitiveSerializer<RoomVerifyDialOutNumberApiVersion> {
  const _$RoomVerifyDialOutNumberApiVersionSerializer();

  static const Map<RoomVerifyDialOutNumberApiVersion, Object> _toWire = <RoomVerifyDialOutNumberApiVersion, Object>{
    RoomVerifyDialOutNumberApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomVerifyDialOutNumberApiVersion> _fromWire = <Object, RoomVerifyDialOutNumberApiVersion>{
    'v4': RoomVerifyDialOutNumberApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomVerifyDialOutNumberApiVersion];

  @override
  String get wireName => 'RoomVerifyDialOutNumberApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomVerifyDialOutNumberApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomVerifyDialOutNumberApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomVerifyDialOutNumberResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomVerifyDialOutNumberResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomVerifyDialOutNumberResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomVerifyDialOutNumberResponseApplicationJson_Ocs
    implements
        $RoomVerifyDialOutNumberResponseApplicationJson_OcsInterface,
        Built<RoomVerifyDialOutNumberResponseApplicationJson_Ocs,
            RoomVerifyDialOutNumberResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomVerifyDialOutNumberResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomVerifyDialOutNumberResponseApplicationJson_Ocs([
    void Function(RoomVerifyDialOutNumberResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomVerifyDialOutNumberResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomVerifyDialOutNumberResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomVerifyDialOutNumberResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomVerifyDialOutNumberResponseApplicationJson_Ocs.
  static Serializer<RoomVerifyDialOutNumberResponseApplicationJson_Ocs> get serializer =>
      _$roomVerifyDialOutNumberResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomVerifyDialOutNumberResponseApplicationJson_OcsBuilder b) {
    $RoomVerifyDialOutNumberResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomVerifyDialOutNumberResponseApplicationJson_OcsBuilder b) {
    $RoomVerifyDialOutNumberResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomVerifyDialOutNumberResponseApplicationJsonInterface {
  RoomVerifyDialOutNumberResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomVerifyDialOutNumberResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomVerifyDialOutNumberResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomVerifyDialOutNumberResponseApplicationJson
    implements
        $RoomVerifyDialOutNumberResponseApplicationJsonInterface,
        Built<RoomVerifyDialOutNumberResponseApplicationJson, RoomVerifyDialOutNumberResponseApplicationJsonBuilder> {
  /// Creates a new RoomVerifyDialOutNumberResponseApplicationJson object using the builder pattern.
  factory RoomVerifyDialOutNumberResponseApplicationJson([
    void Function(RoomVerifyDialOutNumberResponseApplicationJsonBuilder)? b,
  ]) = _$RoomVerifyDialOutNumberResponseApplicationJson;

  // coverage:ignore-start
  const RoomVerifyDialOutNumberResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomVerifyDialOutNumberResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomVerifyDialOutNumberResponseApplicationJson.
  static Serializer<RoomVerifyDialOutNumberResponseApplicationJson> get serializer =>
      _$roomVerifyDialOutNumberResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomVerifyDialOutNumberResponseApplicationJsonBuilder b) {
    $RoomVerifyDialOutNumberResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomVerifyDialOutNumberResponseApplicationJsonBuilder b) {
    $RoomVerifyDialOutNumberResponseApplicationJsonInterface._validate(b);
  }
}

class RoomCreateGuestByDialInApiVersion extends EnumClass {
  const RoomCreateGuestByDialInApiVersion._(super.name);

  /// `v4`
  static const RoomCreateGuestByDialInApiVersion v4 = _$roomCreateGuestByDialInApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomCreateGuestByDialInApiVersion> get values => _$roomCreateGuestByDialInApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomCreateGuestByDialInApiVersion valueOf(String name) => _$valueOfRoomCreateGuestByDialInApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomCreateGuestByDialInApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomCreateGuestByDialInApiVersion> get serializer =>
      const _$RoomCreateGuestByDialInApiVersionSerializer();
}

class _$RoomCreateGuestByDialInApiVersionSerializer implements PrimitiveSerializer<RoomCreateGuestByDialInApiVersion> {
  const _$RoomCreateGuestByDialInApiVersionSerializer();

  static const Map<RoomCreateGuestByDialInApiVersion, Object> _toWire = <RoomCreateGuestByDialInApiVersion, Object>{
    RoomCreateGuestByDialInApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomCreateGuestByDialInApiVersion> _fromWire = <Object, RoomCreateGuestByDialInApiVersion>{
    'v4': RoomCreateGuestByDialInApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomCreateGuestByDialInApiVersion];

  @override
  String get wireName => 'RoomCreateGuestByDialInApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomCreateGuestByDialInApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomCreateGuestByDialInApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomCreateGuestByDialInResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomCreateGuestByDialInResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomCreateGuestByDialInResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomCreateGuestByDialInResponseApplicationJson_Ocs
    implements
        $RoomCreateGuestByDialInResponseApplicationJson_OcsInterface,
        Built<RoomCreateGuestByDialInResponseApplicationJson_Ocs,
            RoomCreateGuestByDialInResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomCreateGuestByDialInResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomCreateGuestByDialInResponseApplicationJson_Ocs([
    void Function(RoomCreateGuestByDialInResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomCreateGuestByDialInResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomCreateGuestByDialInResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomCreateGuestByDialInResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomCreateGuestByDialInResponseApplicationJson_Ocs.
  static Serializer<RoomCreateGuestByDialInResponseApplicationJson_Ocs> get serializer =>
      _$roomCreateGuestByDialInResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomCreateGuestByDialInResponseApplicationJson_OcsBuilder b) {
    $RoomCreateGuestByDialInResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomCreateGuestByDialInResponseApplicationJson_OcsBuilder b) {
    $RoomCreateGuestByDialInResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomCreateGuestByDialInResponseApplicationJsonInterface {
  RoomCreateGuestByDialInResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomCreateGuestByDialInResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomCreateGuestByDialInResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomCreateGuestByDialInResponseApplicationJson
    implements
        $RoomCreateGuestByDialInResponseApplicationJsonInterface,
        Built<RoomCreateGuestByDialInResponseApplicationJson, RoomCreateGuestByDialInResponseApplicationJsonBuilder> {
  /// Creates a new RoomCreateGuestByDialInResponseApplicationJson object using the builder pattern.
  factory RoomCreateGuestByDialInResponseApplicationJson([
    void Function(RoomCreateGuestByDialInResponseApplicationJsonBuilder)? b,
  ]) = _$RoomCreateGuestByDialInResponseApplicationJson;

  // coverage:ignore-start
  const RoomCreateGuestByDialInResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomCreateGuestByDialInResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomCreateGuestByDialInResponseApplicationJson.
  static Serializer<RoomCreateGuestByDialInResponseApplicationJson> get serializer =>
      _$roomCreateGuestByDialInResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomCreateGuestByDialInResponseApplicationJsonBuilder b) {
    $RoomCreateGuestByDialInResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomCreateGuestByDialInResponseApplicationJsonBuilder b) {
    $RoomCreateGuestByDialInResponseApplicationJsonInterface._validate(b);
  }
}

/// Additional details to verify the validity of the request.
@BuiltValue(instantiable: false)
abstract interface class $RoomRejectedDialOutRequestOptionsInterface {
  String? get actorId;
  ActorType? get actorType;
  int? get attendeeId;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomRejectedDialOutRequestOptionsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomRejectedDialOutRequestOptionsInterfaceBuilder b) {}
}

/// Additional details to verify the validity of the request.
abstract class RoomRejectedDialOutRequestOptions
    implements
        $RoomRejectedDialOutRequestOptionsInterface,
        Built<RoomRejectedDialOutRequestOptions, RoomRejectedDialOutRequestOptionsBuilder> {
  /// Creates a new RoomRejectedDialOutRequestOptions object using the builder pattern.
  factory RoomRejectedDialOutRequestOptions([void Function(RoomRejectedDialOutRequestOptionsBuilder)? b]) =
      _$RoomRejectedDialOutRequestOptions;

  // coverage:ignore-start
  const RoomRejectedDialOutRequestOptions._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomRejectedDialOutRequestOptions.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomRejectedDialOutRequestOptions.
  static Serializer<RoomRejectedDialOutRequestOptions> get serializer => _$roomRejectedDialOutRequestOptionsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomRejectedDialOutRequestOptionsBuilder b) {
    $RoomRejectedDialOutRequestOptionsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomRejectedDialOutRequestOptionsBuilder b) {
    $RoomRejectedDialOutRequestOptionsInterface._validate(b);
  }
}

class RoomRejectedDialOutRequestApiVersion extends EnumClass {
  const RoomRejectedDialOutRequestApiVersion._(super.name);

  /// `v4`
  static const RoomRejectedDialOutRequestApiVersion v4 = _$roomRejectedDialOutRequestApiVersionV4;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RoomRejectedDialOutRequestApiVersion> get values => _$roomRejectedDialOutRequestApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RoomRejectedDialOutRequestApiVersion valueOf(String name) =>
      _$valueOfRoomRejectedDialOutRequestApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RoomRejectedDialOutRequestApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomRejectedDialOutRequestApiVersion> get serializer =>
      const _$RoomRejectedDialOutRequestApiVersionSerializer();
}

class _$RoomRejectedDialOutRequestApiVersionSerializer
    implements PrimitiveSerializer<RoomRejectedDialOutRequestApiVersion> {
  const _$RoomRejectedDialOutRequestApiVersionSerializer();

  static const Map<RoomRejectedDialOutRequestApiVersion, Object> _toWire =
      <RoomRejectedDialOutRequestApiVersion, Object>{
    RoomRejectedDialOutRequestApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomRejectedDialOutRequestApiVersion> _fromWire =
      <Object, RoomRejectedDialOutRequestApiVersion>{
    'v4': RoomRejectedDialOutRequestApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomRejectedDialOutRequestApiVersion];

  @override
  String get wireName => 'RoomRejectedDialOutRequestApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomRejectedDialOutRequestApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomRejectedDialOutRequestApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomRejectedDialOutRequestResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomRejectedDialOutRequestResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomRejectedDialOutRequestResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RoomRejectedDialOutRequestResponseApplicationJson_Ocs
    implements
        $RoomRejectedDialOutRequestResponseApplicationJson_OcsInterface,
        Built<RoomRejectedDialOutRequestResponseApplicationJson_Ocs,
            RoomRejectedDialOutRequestResponseApplicationJson_OcsBuilder> {
  /// Creates a new RoomRejectedDialOutRequestResponseApplicationJson_Ocs object using the builder pattern.
  factory RoomRejectedDialOutRequestResponseApplicationJson_Ocs([
    void Function(RoomRejectedDialOutRequestResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomRejectedDialOutRequestResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomRejectedDialOutRequestResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomRejectedDialOutRequestResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomRejectedDialOutRequestResponseApplicationJson_Ocs.
  static Serializer<RoomRejectedDialOutRequestResponseApplicationJson_Ocs> get serializer =>
      _$roomRejectedDialOutRequestResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomRejectedDialOutRequestResponseApplicationJson_OcsBuilder b) {
    $RoomRejectedDialOutRequestResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomRejectedDialOutRequestResponseApplicationJson_OcsBuilder b) {
    $RoomRejectedDialOutRequestResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomRejectedDialOutRequestResponseApplicationJsonInterface {
  RoomRejectedDialOutRequestResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RoomRejectedDialOutRequestResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RoomRejectedDialOutRequestResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RoomRejectedDialOutRequestResponseApplicationJson
    implements
        $RoomRejectedDialOutRequestResponseApplicationJsonInterface,
        Built<RoomRejectedDialOutRequestResponseApplicationJson,
            RoomRejectedDialOutRequestResponseApplicationJsonBuilder> {
  /// Creates a new RoomRejectedDialOutRequestResponseApplicationJson object using the builder pattern.
  factory RoomRejectedDialOutRequestResponseApplicationJson([
    void Function(RoomRejectedDialOutRequestResponseApplicationJsonBuilder)? b,
  ]) = _$RoomRejectedDialOutRequestResponseApplicationJson;

  // coverage:ignore-start
  const RoomRejectedDialOutRequestResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RoomRejectedDialOutRequestResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RoomRejectedDialOutRequestResponseApplicationJson.
  static Serializer<RoomRejectedDialOutRequestResponseApplicationJson> get serializer =>
      _$roomRejectedDialOutRequestResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RoomRejectedDialOutRequestResponseApplicationJsonBuilder b) {
    $RoomRejectedDialOutRequestResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomRejectedDialOutRequestResponseApplicationJsonBuilder b) {
    $RoomRejectedDialOutRequestResponseApplicationJsonInterface._validate(b);
  }
}

class SettingsSetUserSettingKey extends EnumClass {
  const SettingsSetUserSettingKey._(super.name);

  /// `attachment_folder`
  @BuiltValueEnumConst(wireName: 'attachment_folder')
  static const SettingsSetUserSettingKey attachmentFolder = _$settingsSetUserSettingKeyAttachmentFolder;

  /// `read_status_privacy`
  @BuiltValueEnumConst(wireName: 'read_status_privacy')
  static const SettingsSetUserSettingKey readStatusPrivacy = _$settingsSetUserSettingKeyReadStatusPrivacy;

  /// `typing_privacy`
  @BuiltValueEnumConst(wireName: 'typing_privacy')
  static const SettingsSetUserSettingKey typingPrivacy = _$settingsSetUserSettingKeyTypingPrivacy;

  /// `play_sounds`
  @BuiltValueEnumConst(wireName: 'play_sounds')
  static const SettingsSetUserSettingKey playSounds = _$settingsSetUserSettingKeyPlaySounds;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<SettingsSetUserSettingKey> get values => _$settingsSetUserSettingKeyValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static SettingsSetUserSettingKey valueOf(String name) => _$valueOfSettingsSetUserSettingKey(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for SettingsSetUserSettingKey.
  @BuiltValueSerializer(custom: true)
  static Serializer<SettingsSetUserSettingKey> get serializer => const _$SettingsSetUserSettingKeySerializer();
}

class _$SettingsSetUserSettingKeySerializer implements PrimitiveSerializer<SettingsSetUserSettingKey> {
  const _$SettingsSetUserSettingKeySerializer();

  static const Map<SettingsSetUserSettingKey, Object> _toWire = <SettingsSetUserSettingKey, Object>{
    SettingsSetUserSettingKey.attachmentFolder: 'attachment_folder',
    SettingsSetUserSettingKey.readStatusPrivacy: 'read_status_privacy',
    SettingsSetUserSettingKey.typingPrivacy: 'typing_privacy',
    SettingsSetUserSettingKey.playSounds: 'play_sounds',
  };

  static const Map<Object, SettingsSetUserSettingKey> _fromWire = <Object, SettingsSetUserSettingKey>{
    'attachment_folder': SettingsSetUserSettingKey.attachmentFolder,
    'read_status_privacy': SettingsSetUserSettingKey.readStatusPrivacy,
    'typing_privacy': SettingsSetUserSettingKey.typingPrivacy,
    'play_sounds': SettingsSetUserSettingKey.playSounds,
  };

  @override
  Iterable<Type> get types => const [SettingsSetUserSettingKey];

  @override
  String get wireName => 'SettingsSetUserSettingKey';

  @override
  Object serialize(
    Serializers serializers,
    SettingsSetUserSettingKey object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  SettingsSetUserSettingKey deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

typedef SettingsSetUserSettingValue = ({int? $int, String? string});

class SettingsSetUserSettingApiVersion extends EnumClass {
  const SettingsSetUserSettingApiVersion._(super.name);

  /// `v1`
  static const SettingsSetUserSettingApiVersion v1 = _$settingsSetUserSettingApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<SettingsSetUserSettingApiVersion> get values => _$settingsSetUserSettingApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static SettingsSetUserSettingApiVersion valueOf(String name) => _$valueOfSettingsSetUserSettingApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for SettingsSetUserSettingApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<SettingsSetUserSettingApiVersion> get serializer =>
      const _$SettingsSetUserSettingApiVersionSerializer();
}

class _$SettingsSetUserSettingApiVersionSerializer implements PrimitiveSerializer<SettingsSetUserSettingApiVersion> {
  const _$SettingsSetUserSettingApiVersionSerializer();

  static const Map<SettingsSetUserSettingApiVersion, Object> _toWire = <SettingsSetUserSettingApiVersion, Object>{
    SettingsSetUserSettingApiVersion.v1: 'v1',
  };

  static const Map<Object, SettingsSetUserSettingApiVersion> _fromWire = <Object, SettingsSetUserSettingApiVersion>{
    'v1': SettingsSetUserSettingApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [SettingsSetUserSettingApiVersion];

  @override
  String get wireName => 'SettingsSetUserSettingApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    SettingsSetUserSettingApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  SettingsSetUserSettingApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $SettingsSetUserSettingResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SettingsSetUserSettingResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SettingsSetUserSettingResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class SettingsSetUserSettingResponseApplicationJson_Ocs
    implements
        $SettingsSetUserSettingResponseApplicationJson_OcsInterface,
        Built<SettingsSetUserSettingResponseApplicationJson_Ocs,
            SettingsSetUserSettingResponseApplicationJson_OcsBuilder> {
  /// Creates a new SettingsSetUserSettingResponseApplicationJson_Ocs object using the builder pattern.
  factory SettingsSetUserSettingResponseApplicationJson_Ocs([
    void Function(SettingsSetUserSettingResponseApplicationJson_OcsBuilder)? b,
  ]) = _$SettingsSetUserSettingResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const SettingsSetUserSettingResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SettingsSetUserSettingResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SettingsSetUserSettingResponseApplicationJson_Ocs.
  static Serializer<SettingsSetUserSettingResponseApplicationJson_Ocs> get serializer =>
      _$settingsSetUserSettingResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SettingsSetUserSettingResponseApplicationJson_OcsBuilder b) {
    $SettingsSetUserSettingResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SettingsSetUserSettingResponseApplicationJson_OcsBuilder b) {
    $SettingsSetUserSettingResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SettingsSetUserSettingResponseApplicationJsonInterface {
  SettingsSetUserSettingResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SettingsSetUserSettingResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SettingsSetUserSettingResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class SettingsSetUserSettingResponseApplicationJson
    implements
        $SettingsSetUserSettingResponseApplicationJsonInterface,
        Built<SettingsSetUserSettingResponseApplicationJson, SettingsSetUserSettingResponseApplicationJsonBuilder> {
  /// Creates a new SettingsSetUserSettingResponseApplicationJson object using the builder pattern.
  factory SettingsSetUserSettingResponseApplicationJson([
    void Function(SettingsSetUserSettingResponseApplicationJsonBuilder)? b,
  ]) = _$SettingsSetUserSettingResponseApplicationJson;

  // coverage:ignore-start
  const SettingsSetUserSettingResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SettingsSetUserSettingResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SettingsSetUserSettingResponseApplicationJson.
  static Serializer<SettingsSetUserSettingResponseApplicationJson> get serializer =>
      _$settingsSetUserSettingResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SettingsSetUserSettingResponseApplicationJsonBuilder b) {
    $SettingsSetUserSettingResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SettingsSetUserSettingResponseApplicationJsonBuilder b) {
    $SettingsSetUserSettingResponseApplicationJsonInterface._validate(b);
  }
}

class BotAdminListBotsApiVersion extends EnumClass {
  const BotAdminListBotsApiVersion._(super.name);

  /// `v1`
  static const BotAdminListBotsApiVersion v1 = _$botAdminListBotsApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<BotAdminListBotsApiVersion> get values => _$botAdminListBotsApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static BotAdminListBotsApiVersion valueOf(String name) => _$valueOfBotAdminListBotsApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for BotAdminListBotsApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<BotAdminListBotsApiVersion> get serializer => const _$BotAdminListBotsApiVersionSerializer();
}

class _$BotAdminListBotsApiVersionSerializer implements PrimitiveSerializer<BotAdminListBotsApiVersion> {
  const _$BotAdminListBotsApiVersionSerializer();

  static const Map<BotAdminListBotsApiVersion, Object> _toWire = <BotAdminListBotsApiVersion, Object>{
    BotAdminListBotsApiVersion.v1: 'v1',
  };

  static const Map<Object, BotAdminListBotsApiVersion> _fromWire = <Object, BotAdminListBotsApiVersion>{
    'v1': BotAdminListBotsApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BotAdminListBotsApiVersion];

  @override
  String get wireName => 'BotAdminListBotsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BotAdminListBotsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BotAdminListBotsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BotWithDetailsInterface implements $BotInterface {
  @BuiltValueField(wireName: 'error_count')
  int get errorCount;
  int get features;
  @BuiltValueField(wireName: 'last_error_date')
  int get lastErrorDate;
  @BuiltValueField(wireName: 'last_error_message')
  String get lastErrorMessage;
  String get url;
  @BuiltValueField(wireName: 'url_hash')
  String get urlHash;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BotWithDetailsInterfaceBuilder b) {
    $BotInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BotWithDetailsInterfaceBuilder b) {
    $BotInterface._validate(b);
  }
}

abstract class BotWithDetails implements $BotWithDetailsInterface, Built<BotWithDetails, BotWithDetailsBuilder> {
  /// Creates a new BotWithDetails object using the builder pattern.
  factory BotWithDetails([void Function(BotWithDetailsBuilder)? b]) = _$BotWithDetails;

  // coverage:ignore-start
  const BotWithDetails._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BotWithDetails.fromJson(Map<String, dynamic> json) => _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BotWithDetails.
  static Serializer<BotWithDetails> get serializer => _$botWithDetailsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BotWithDetailsBuilder b) {
    $BotWithDetailsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BotWithDetailsBuilder b) {
    $BotWithDetailsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $BotAdminListBotsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<BotWithDetails> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BotAdminListBotsResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BotAdminListBotsResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class BotAdminListBotsResponseApplicationJson_Ocs
    implements
        $BotAdminListBotsResponseApplicationJson_OcsInterface,
        Built<BotAdminListBotsResponseApplicationJson_Ocs, BotAdminListBotsResponseApplicationJson_OcsBuilder> {
  /// Creates a new BotAdminListBotsResponseApplicationJson_Ocs object using the builder pattern.
  factory BotAdminListBotsResponseApplicationJson_Ocs([
    void Function(BotAdminListBotsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$BotAdminListBotsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BotAdminListBotsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BotAdminListBotsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BotAdminListBotsResponseApplicationJson_Ocs.
  static Serializer<BotAdminListBotsResponseApplicationJson_Ocs> get serializer =>
      _$botAdminListBotsResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BotAdminListBotsResponseApplicationJson_OcsBuilder b) {
    $BotAdminListBotsResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BotAdminListBotsResponseApplicationJson_OcsBuilder b) {
    $BotAdminListBotsResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $BotAdminListBotsResponseApplicationJsonInterface {
  BotAdminListBotsResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BotAdminListBotsResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BotAdminListBotsResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class BotAdminListBotsResponseApplicationJson
    implements
        $BotAdminListBotsResponseApplicationJsonInterface,
        Built<BotAdminListBotsResponseApplicationJson, BotAdminListBotsResponseApplicationJsonBuilder> {
  /// Creates a new BotAdminListBotsResponseApplicationJson object using the builder pattern.
  factory BotAdminListBotsResponseApplicationJson([void Function(BotAdminListBotsResponseApplicationJsonBuilder)? b]) =
      _$BotAdminListBotsResponseApplicationJson;

  // coverage:ignore-start
  const BotAdminListBotsResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BotAdminListBotsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BotAdminListBotsResponseApplicationJson.
  static Serializer<BotAdminListBotsResponseApplicationJson> get serializer =>
      _$botAdminListBotsResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BotAdminListBotsResponseApplicationJsonBuilder b) {
    $BotAdminListBotsResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BotAdminListBotsResponseApplicationJsonBuilder b) {
    $BotAdminListBotsResponseApplicationJsonInterface._validate(b);
  }
}

class CertificateGetCertificateExpirationApiVersion extends EnumClass {
  const CertificateGetCertificateExpirationApiVersion._(super.name);

  /// `v1`
  static const CertificateGetCertificateExpirationApiVersion v1 = _$certificateGetCertificateExpirationApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<CertificateGetCertificateExpirationApiVersion> get values =>
      _$certificateGetCertificateExpirationApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static CertificateGetCertificateExpirationApiVersion valueOf(String name) =>
      _$valueOfCertificateGetCertificateExpirationApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for CertificateGetCertificateExpirationApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<CertificateGetCertificateExpirationApiVersion> get serializer =>
      const _$CertificateGetCertificateExpirationApiVersionSerializer();
}

class _$CertificateGetCertificateExpirationApiVersionSerializer
    implements PrimitiveSerializer<CertificateGetCertificateExpirationApiVersion> {
  const _$CertificateGetCertificateExpirationApiVersionSerializer();

  static const Map<CertificateGetCertificateExpirationApiVersion, Object> _toWire =
      <CertificateGetCertificateExpirationApiVersion, Object>{
    CertificateGetCertificateExpirationApiVersion.v1: 'v1',
  };

  static const Map<Object, CertificateGetCertificateExpirationApiVersion> _fromWire =
      <Object, CertificateGetCertificateExpirationApiVersion>{
    'v1': CertificateGetCertificateExpirationApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [CertificateGetCertificateExpirationApiVersion];

  @override
  String get wireName => 'CertificateGetCertificateExpirationApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    CertificateGetCertificateExpirationApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  CertificateGetCertificateExpirationApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $CertificateGetCertificateExpirationResponseApplicationJson_Ocs_DataInterface {
  @BuiltValueField(wireName: 'expiration_in_days')
  int? get expirationInDays;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CertificateGetCertificateExpirationResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CertificateGetCertificateExpirationResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class CertificateGetCertificateExpirationResponseApplicationJson_Ocs_Data
    implements
        $CertificateGetCertificateExpirationResponseApplicationJson_Ocs_DataInterface,
        Built<CertificateGetCertificateExpirationResponseApplicationJson_Ocs_Data,
            CertificateGetCertificateExpirationResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new CertificateGetCertificateExpirationResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory CertificateGetCertificateExpirationResponseApplicationJson_Ocs_Data([
    void Function(CertificateGetCertificateExpirationResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$CertificateGetCertificateExpirationResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const CertificateGetCertificateExpirationResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CertificateGetCertificateExpirationResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CertificateGetCertificateExpirationResponseApplicationJson_Ocs_Data.
  static Serializer<CertificateGetCertificateExpirationResponseApplicationJson_Ocs_Data> get serializer =>
      _$certificateGetCertificateExpirationResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CertificateGetCertificateExpirationResponseApplicationJson_Ocs_DataBuilder b) {
    $CertificateGetCertificateExpirationResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CertificateGetCertificateExpirationResponseApplicationJson_Ocs_DataBuilder b) {
    $CertificateGetCertificateExpirationResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CertificateGetCertificateExpirationResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  CertificateGetCertificateExpirationResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CertificateGetCertificateExpirationResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CertificateGetCertificateExpirationResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class CertificateGetCertificateExpirationResponseApplicationJson_Ocs
    implements
        $CertificateGetCertificateExpirationResponseApplicationJson_OcsInterface,
        Built<CertificateGetCertificateExpirationResponseApplicationJson_Ocs,
            CertificateGetCertificateExpirationResponseApplicationJson_OcsBuilder> {
  /// Creates a new CertificateGetCertificateExpirationResponseApplicationJson_Ocs object using the builder pattern.
  factory CertificateGetCertificateExpirationResponseApplicationJson_Ocs([
    void Function(CertificateGetCertificateExpirationResponseApplicationJson_OcsBuilder)? b,
  ]) = _$CertificateGetCertificateExpirationResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const CertificateGetCertificateExpirationResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CertificateGetCertificateExpirationResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CertificateGetCertificateExpirationResponseApplicationJson_Ocs.
  static Serializer<CertificateGetCertificateExpirationResponseApplicationJson_Ocs> get serializer =>
      _$certificateGetCertificateExpirationResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CertificateGetCertificateExpirationResponseApplicationJson_OcsBuilder b) {
    $CertificateGetCertificateExpirationResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CertificateGetCertificateExpirationResponseApplicationJson_OcsBuilder b) {
    $CertificateGetCertificateExpirationResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $CertificateGetCertificateExpirationResponseApplicationJsonInterface {
  CertificateGetCertificateExpirationResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($CertificateGetCertificateExpirationResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($CertificateGetCertificateExpirationResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class CertificateGetCertificateExpirationResponseApplicationJson
    implements
        $CertificateGetCertificateExpirationResponseApplicationJsonInterface,
        Built<CertificateGetCertificateExpirationResponseApplicationJson,
            CertificateGetCertificateExpirationResponseApplicationJsonBuilder> {
  /// Creates a new CertificateGetCertificateExpirationResponseApplicationJson object using the builder pattern.
  factory CertificateGetCertificateExpirationResponseApplicationJson([
    void Function(CertificateGetCertificateExpirationResponseApplicationJsonBuilder)? b,
  ]) = _$CertificateGetCertificateExpirationResponseApplicationJson;

  // coverage:ignore-start
  const CertificateGetCertificateExpirationResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory CertificateGetCertificateExpirationResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for CertificateGetCertificateExpirationResponseApplicationJson.
  static Serializer<CertificateGetCertificateExpirationResponseApplicationJson> get serializer =>
      _$certificateGetCertificateExpirationResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(CertificateGetCertificateExpirationResponseApplicationJsonBuilder b) {
    $CertificateGetCertificateExpirationResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(CertificateGetCertificateExpirationResponseApplicationJsonBuilder b) {
    $CertificateGetCertificateExpirationResponseApplicationJsonInterface._validate(b);
  }
}

class RecordingGetWelcomeMessageApiVersion extends EnumClass {
  const RecordingGetWelcomeMessageApiVersion._(super.name);

  /// `v1`
  static const RecordingGetWelcomeMessageApiVersion v1 = _$recordingGetWelcomeMessageApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<RecordingGetWelcomeMessageApiVersion> get values => _$recordingGetWelcomeMessageApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static RecordingGetWelcomeMessageApiVersion valueOf(String name) =>
      _$valueOfRecordingGetWelcomeMessageApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for RecordingGetWelcomeMessageApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<RecordingGetWelcomeMessageApiVersion> get serializer =>
      const _$RecordingGetWelcomeMessageApiVersionSerializer();
}

class _$RecordingGetWelcomeMessageApiVersionSerializer
    implements PrimitiveSerializer<RecordingGetWelcomeMessageApiVersion> {
  const _$RecordingGetWelcomeMessageApiVersionSerializer();

  static const Map<RecordingGetWelcomeMessageApiVersion, Object> _toWire =
      <RecordingGetWelcomeMessageApiVersion, Object>{
    RecordingGetWelcomeMessageApiVersion.v1: 'v1',
  };

  static const Map<Object, RecordingGetWelcomeMessageApiVersion> _fromWire =
      <Object, RecordingGetWelcomeMessageApiVersion>{
    'v1': RecordingGetWelcomeMessageApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [RecordingGetWelcomeMessageApiVersion];

  @override
  String get wireName => 'RecordingGetWelcomeMessageApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RecordingGetWelcomeMessageApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RecordingGetWelcomeMessageApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RecordingGetWelcomeMessageResponseApplicationJson_Ocs_DataInterface {
  double get version;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RecordingGetWelcomeMessageResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RecordingGetWelcomeMessageResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class RecordingGetWelcomeMessageResponseApplicationJson_Ocs_Data
    implements
        $RecordingGetWelcomeMessageResponseApplicationJson_Ocs_DataInterface,
        Built<RecordingGetWelcomeMessageResponseApplicationJson_Ocs_Data,
            RecordingGetWelcomeMessageResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new RecordingGetWelcomeMessageResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory RecordingGetWelcomeMessageResponseApplicationJson_Ocs_Data([
    void Function(RecordingGetWelcomeMessageResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$RecordingGetWelcomeMessageResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const RecordingGetWelcomeMessageResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RecordingGetWelcomeMessageResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RecordingGetWelcomeMessageResponseApplicationJson_Ocs_Data.
  static Serializer<RecordingGetWelcomeMessageResponseApplicationJson_Ocs_Data> get serializer =>
      _$recordingGetWelcomeMessageResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RecordingGetWelcomeMessageResponseApplicationJson_Ocs_DataBuilder b) {
    $RecordingGetWelcomeMessageResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RecordingGetWelcomeMessageResponseApplicationJson_Ocs_DataBuilder b) {
    $RecordingGetWelcomeMessageResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RecordingGetWelcomeMessageResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  RecordingGetWelcomeMessageResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RecordingGetWelcomeMessageResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RecordingGetWelcomeMessageResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class RecordingGetWelcomeMessageResponseApplicationJson_Ocs
    implements
        $RecordingGetWelcomeMessageResponseApplicationJson_OcsInterface,
        Built<RecordingGetWelcomeMessageResponseApplicationJson_Ocs,
            RecordingGetWelcomeMessageResponseApplicationJson_OcsBuilder> {
  /// Creates a new RecordingGetWelcomeMessageResponseApplicationJson_Ocs object using the builder pattern.
  factory RecordingGetWelcomeMessageResponseApplicationJson_Ocs([
    void Function(RecordingGetWelcomeMessageResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RecordingGetWelcomeMessageResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RecordingGetWelcomeMessageResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RecordingGetWelcomeMessageResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RecordingGetWelcomeMessageResponseApplicationJson_Ocs.
  static Serializer<RecordingGetWelcomeMessageResponseApplicationJson_Ocs> get serializer =>
      _$recordingGetWelcomeMessageResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RecordingGetWelcomeMessageResponseApplicationJson_OcsBuilder b) {
    $RecordingGetWelcomeMessageResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RecordingGetWelcomeMessageResponseApplicationJson_OcsBuilder b) {
    $RecordingGetWelcomeMessageResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RecordingGetWelcomeMessageResponseApplicationJsonInterface {
  RecordingGetWelcomeMessageResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($RecordingGetWelcomeMessageResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($RecordingGetWelcomeMessageResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class RecordingGetWelcomeMessageResponseApplicationJson
    implements
        $RecordingGetWelcomeMessageResponseApplicationJsonInterface,
        Built<RecordingGetWelcomeMessageResponseApplicationJson,
            RecordingGetWelcomeMessageResponseApplicationJsonBuilder> {
  /// Creates a new RecordingGetWelcomeMessageResponseApplicationJson object using the builder pattern.
  factory RecordingGetWelcomeMessageResponseApplicationJson([
    void Function(RecordingGetWelcomeMessageResponseApplicationJsonBuilder)? b,
  ]) = _$RecordingGetWelcomeMessageResponseApplicationJson;

  // coverage:ignore-start
  const RecordingGetWelcomeMessageResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory RecordingGetWelcomeMessageResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for RecordingGetWelcomeMessageResponseApplicationJson.
  static Serializer<RecordingGetWelcomeMessageResponseApplicationJson> get serializer =>
      _$recordingGetWelcomeMessageResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(RecordingGetWelcomeMessageResponseApplicationJsonBuilder b) {
    $RecordingGetWelcomeMessageResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RecordingGetWelcomeMessageResponseApplicationJsonBuilder b) {
    $RecordingGetWelcomeMessageResponseApplicationJsonInterface._validate(b);
  }
}

class SettingsSetsipSettingsApiVersion extends EnumClass {
  const SettingsSetsipSettingsApiVersion._(super.name);

  /// `v1`
  static const SettingsSetsipSettingsApiVersion v1 = _$settingsSetsipSettingsApiVersionV1;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<SettingsSetsipSettingsApiVersion> get values => _$settingsSetsipSettingsApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static SettingsSetsipSettingsApiVersion valueOf(String name) => _$valueOfSettingsSetsipSettingsApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for SettingsSetsipSettingsApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<SettingsSetsipSettingsApiVersion> get serializer =>
      const _$SettingsSetsipSettingsApiVersionSerializer();
}

class _$SettingsSetsipSettingsApiVersionSerializer implements PrimitiveSerializer<SettingsSetsipSettingsApiVersion> {
  const _$SettingsSetsipSettingsApiVersionSerializer();

  static const Map<SettingsSetsipSettingsApiVersion, Object> _toWire = <SettingsSetsipSettingsApiVersion, Object>{
    SettingsSetsipSettingsApiVersion.v1: 'v1',
  };

  static const Map<Object, SettingsSetsipSettingsApiVersion> _fromWire = <Object, SettingsSetsipSettingsApiVersion>{
    'v1': SettingsSetsipSettingsApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [SettingsSetsipSettingsApiVersion];

  @override
  String get wireName => 'SettingsSetsipSettingsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    SettingsSetsipSettingsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  SettingsSetsipSettingsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $SettingsSetsipSettingsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SettingsSetsipSettingsResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SettingsSetsipSettingsResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class SettingsSetsipSettingsResponseApplicationJson_Ocs
    implements
        $SettingsSetsipSettingsResponseApplicationJson_OcsInterface,
        Built<SettingsSetsipSettingsResponseApplicationJson_Ocs,
            SettingsSetsipSettingsResponseApplicationJson_OcsBuilder> {
  /// Creates a new SettingsSetsipSettingsResponseApplicationJson_Ocs object using the builder pattern.
  factory SettingsSetsipSettingsResponseApplicationJson_Ocs([
    void Function(SettingsSetsipSettingsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$SettingsSetsipSettingsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const SettingsSetsipSettingsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SettingsSetsipSettingsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SettingsSetsipSettingsResponseApplicationJson_Ocs.
  static Serializer<SettingsSetsipSettingsResponseApplicationJson_Ocs> get serializer =>
      _$settingsSetsipSettingsResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SettingsSetsipSettingsResponseApplicationJson_OcsBuilder b) {
    $SettingsSetsipSettingsResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SettingsSetsipSettingsResponseApplicationJson_OcsBuilder b) {
    $SettingsSetsipSettingsResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SettingsSetsipSettingsResponseApplicationJsonInterface {
  SettingsSetsipSettingsResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SettingsSetsipSettingsResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SettingsSetsipSettingsResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class SettingsSetsipSettingsResponseApplicationJson
    implements
        $SettingsSetsipSettingsResponseApplicationJsonInterface,
        Built<SettingsSetsipSettingsResponseApplicationJson, SettingsSetsipSettingsResponseApplicationJsonBuilder> {
  /// Creates a new SettingsSetsipSettingsResponseApplicationJson object using the builder pattern.
  factory SettingsSetsipSettingsResponseApplicationJson([
    void Function(SettingsSetsipSettingsResponseApplicationJsonBuilder)? b,
  ]) = _$SettingsSetsipSettingsResponseApplicationJson;

  // coverage:ignore-start
  const SettingsSetsipSettingsResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SettingsSetsipSettingsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SettingsSetsipSettingsResponseApplicationJson.
  static Serializer<SettingsSetsipSettingsResponseApplicationJson> get serializer =>
      _$settingsSetsipSettingsResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SettingsSetsipSettingsResponseApplicationJsonBuilder b) {
    $SettingsSetsipSettingsResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SettingsSetsipSettingsResponseApplicationJsonBuilder b) {
    $SettingsSetsipSettingsResponseApplicationJsonInterface._validate(b);
  }
}

class SignalingGetWelcomeMessageApiVersion extends EnumClass {
  const SignalingGetWelcomeMessageApiVersion._(super.name);

  /// `v3`
  static const SignalingGetWelcomeMessageApiVersion v3 = _$signalingGetWelcomeMessageApiVersionV3;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<SignalingGetWelcomeMessageApiVersion> get values => _$signalingGetWelcomeMessageApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static SignalingGetWelcomeMessageApiVersion valueOf(String name) =>
      _$valueOfSignalingGetWelcomeMessageApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for SignalingGetWelcomeMessageApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<SignalingGetWelcomeMessageApiVersion> get serializer =>
      const _$SignalingGetWelcomeMessageApiVersionSerializer();
}

class _$SignalingGetWelcomeMessageApiVersionSerializer
    implements PrimitiveSerializer<SignalingGetWelcomeMessageApiVersion> {
  const _$SignalingGetWelcomeMessageApiVersionSerializer();

  static const Map<SignalingGetWelcomeMessageApiVersion, Object> _toWire =
      <SignalingGetWelcomeMessageApiVersion, Object>{
    SignalingGetWelcomeMessageApiVersion.v3: 'v3',
  };

  static const Map<Object, SignalingGetWelcomeMessageApiVersion> _fromWire =
      <Object, SignalingGetWelcomeMessageApiVersion>{
    'v3': SignalingGetWelcomeMessageApiVersion.v3,
  };

  @override
  Iterable<Type> get types => const [SignalingGetWelcomeMessageApiVersion];

  @override
  String get wireName => 'SignalingGetWelcomeMessageApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    SignalingGetWelcomeMessageApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  SignalingGetWelcomeMessageApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingGetWelcomeMessageResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltMap<String, JsonObject> get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SignalingGetWelcomeMessageResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SignalingGetWelcomeMessageResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class SignalingGetWelcomeMessageResponseApplicationJson_Ocs
    implements
        $SignalingGetWelcomeMessageResponseApplicationJson_OcsInterface,
        Built<SignalingGetWelcomeMessageResponseApplicationJson_Ocs,
            SignalingGetWelcomeMessageResponseApplicationJson_OcsBuilder> {
  /// Creates a new SignalingGetWelcomeMessageResponseApplicationJson_Ocs object using the builder pattern.
  factory SignalingGetWelcomeMessageResponseApplicationJson_Ocs([
    void Function(SignalingGetWelcomeMessageResponseApplicationJson_OcsBuilder)? b,
  ]) = _$SignalingGetWelcomeMessageResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const SignalingGetWelcomeMessageResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SignalingGetWelcomeMessageResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SignalingGetWelcomeMessageResponseApplicationJson_Ocs.
  static Serializer<SignalingGetWelcomeMessageResponseApplicationJson_Ocs> get serializer =>
      _$signalingGetWelcomeMessageResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SignalingGetWelcomeMessageResponseApplicationJson_OcsBuilder b) {
    $SignalingGetWelcomeMessageResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SignalingGetWelcomeMessageResponseApplicationJson_OcsBuilder b) {
    $SignalingGetWelcomeMessageResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingGetWelcomeMessageResponseApplicationJsonInterface {
  SignalingGetWelcomeMessageResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SignalingGetWelcomeMessageResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SignalingGetWelcomeMessageResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class SignalingGetWelcomeMessageResponseApplicationJson
    implements
        $SignalingGetWelcomeMessageResponseApplicationJsonInterface,
        Built<SignalingGetWelcomeMessageResponseApplicationJson,
            SignalingGetWelcomeMessageResponseApplicationJsonBuilder> {
  /// Creates a new SignalingGetWelcomeMessageResponseApplicationJson object using the builder pattern.
  factory SignalingGetWelcomeMessageResponseApplicationJson([
    void Function(SignalingGetWelcomeMessageResponseApplicationJsonBuilder)? b,
  ]) = _$SignalingGetWelcomeMessageResponseApplicationJson;

  // coverage:ignore-start
  const SignalingGetWelcomeMessageResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SignalingGetWelcomeMessageResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SignalingGetWelcomeMessageResponseApplicationJson.
  static Serializer<SignalingGetWelcomeMessageResponseApplicationJson> get serializer =>
      _$signalingGetWelcomeMessageResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SignalingGetWelcomeMessageResponseApplicationJsonBuilder b) {
    $SignalingGetWelcomeMessageResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SignalingGetWelcomeMessageResponseApplicationJsonBuilder b) {
    $SignalingGetWelcomeMessageResponseApplicationJsonInterface._validate(b);
  }
}

class SignalingBackendApiVersion extends EnumClass {
  const SignalingBackendApiVersion._(super.name);

  /// `v3`
  static const SignalingBackendApiVersion v3 = _$signalingBackendApiVersionV3;

  /// Returns a set with all values this enum contains.
  // coverage:ignore-start
  static BuiltSet<SignalingBackendApiVersion> get values => _$signalingBackendApiVersionValues;
  // coverage:ignore-end

  /// Returns the enum value associated to the [name].
  static SignalingBackendApiVersion valueOf(String name) => _$valueOfSignalingBackendApiVersion(name);

  /// Returns the serialized value of this enum value.
  String get value => _$jsonSerializers.serializeWith(serializer, this)! as String;

  /// Serializer for SignalingBackendApiVersion.
  @BuiltValueSerializer(custom: true)
  static Serializer<SignalingBackendApiVersion> get serializer => const _$SignalingBackendApiVersionSerializer();
}

class _$SignalingBackendApiVersionSerializer implements PrimitiveSerializer<SignalingBackendApiVersion> {
  const _$SignalingBackendApiVersionSerializer();

  static const Map<SignalingBackendApiVersion, Object> _toWire = <SignalingBackendApiVersion, Object>{
    SignalingBackendApiVersion.v3: 'v3',
  };

  static const Map<Object, SignalingBackendApiVersion> _fromWire = <Object, SignalingBackendApiVersion>{
    'v3': SignalingBackendApiVersion.v3,
  };

  @override
  Iterable<Type> get types => const [SignalingBackendApiVersion];

  @override
  String get wireName => 'SignalingBackendApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    SignalingBackendApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  SignalingBackendApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingBackendResponseApplicationJson_Ocs_Data_ErrorInterface {
  String get code;
  String get message;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SignalingBackendResponseApplicationJson_Ocs_Data_ErrorInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SignalingBackendResponseApplicationJson_Ocs_Data_ErrorInterfaceBuilder b) {}
}

abstract class SignalingBackendResponseApplicationJson_Ocs_Data_Error
    implements
        $SignalingBackendResponseApplicationJson_Ocs_Data_ErrorInterface,
        Built<SignalingBackendResponseApplicationJson_Ocs_Data_Error,
            SignalingBackendResponseApplicationJson_Ocs_Data_ErrorBuilder> {
  /// Creates a new SignalingBackendResponseApplicationJson_Ocs_Data_Error object using the builder pattern.
  factory SignalingBackendResponseApplicationJson_Ocs_Data_Error([
    void Function(SignalingBackendResponseApplicationJson_Ocs_Data_ErrorBuilder)? b,
  ]) = _$SignalingBackendResponseApplicationJson_Ocs_Data_Error;

  // coverage:ignore-start
  const SignalingBackendResponseApplicationJson_Ocs_Data_Error._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SignalingBackendResponseApplicationJson_Ocs_Data_Error.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SignalingBackendResponseApplicationJson_Ocs_Data_Error.
  static Serializer<SignalingBackendResponseApplicationJson_Ocs_Data_Error> get serializer =>
      _$signalingBackendResponseApplicationJsonOcsDataErrorSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SignalingBackendResponseApplicationJson_Ocs_Data_ErrorBuilder b) {
    $SignalingBackendResponseApplicationJson_Ocs_Data_ErrorInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SignalingBackendResponseApplicationJson_Ocs_Data_ErrorBuilder b) {
    $SignalingBackendResponseApplicationJson_Ocs_Data_ErrorInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingBackendResponseApplicationJson_Ocs_Data_AuthInterface {
  String get version;
  String? get userid;
  BuiltMap<String, JsonObject>? get user;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SignalingBackendResponseApplicationJson_Ocs_Data_AuthInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SignalingBackendResponseApplicationJson_Ocs_Data_AuthInterfaceBuilder b) {}
}

abstract class SignalingBackendResponseApplicationJson_Ocs_Data_Auth
    implements
        $SignalingBackendResponseApplicationJson_Ocs_Data_AuthInterface,
        Built<SignalingBackendResponseApplicationJson_Ocs_Data_Auth,
            SignalingBackendResponseApplicationJson_Ocs_Data_AuthBuilder> {
  /// Creates a new SignalingBackendResponseApplicationJson_Ocs_Data_Auth object using the builder pattern.
  factory SignalingBackendResponseApplicationJson_Ocs_Data_Auth([
    void Function(SignalingBackendResponseApplicationJson_Ocs_Data_AuthBuilder)? b,
  ]) = _$SignalingBackendResponseApplicationJson_Ocs_Data_Auth;

  // coverage:ignore-start
  const SignalingBackendResponseApplicationJson_Ocs_Data_Auth._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SignalingBackendResponseApplicationJson_Ocs_Data_Auth.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SignalingBackendResponseApplicationJson_Ocs_Data_Auth.
  static Serializer<SignalingBackendResponseApplicationJson_Ocs_Data_Auth> get serializer =>
      _$signalingBackendResponseApplicationJsonOcsDataAuthSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SignalingBackendResponseApplicationJson_Ocs_Data_AuthBuilder b) {
    $SignalingBackendResponseApplicationJson_Ocs_Data_AuthInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SignalingBackendResponseApplicationJson_Ocs_Data_AuthBuilder b) {
    $SignalingBackendResponseApplicationJson_Ocs_Data_AuthInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingBackendResponseApplicationJson_Ocs_Data_RoomInterface {
  String get version;
  String? get roomid;
  BuiltMap<String, JsonObject>? get properties;
  BuiltList<String>? get permissions;
  BuiltMap<String, JsonObject>? get session;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SignalingBackendResponseApplicationJson_Ocs_Data_RoomInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SignalingBackendResponseApplicationJson_Ocs_Data_RoomInterfaceBuilder b) {}
}

abstract class SignalingBackendResponseApplicationJson_Ocs_Data_Room
    implements
        $SignalingBackendResponseApplicationJson_Ocs_Data_RoomInterface,
        Built<SignalingBackendResponseApplicationJson_Ocs_Data_Room,
            SignalingBackendResponseApplicationJson_Ocs_Data_RoomBuilder> {
  /// Creates a new SignalingBackendResponseApplicationJson_Ocs_Data_Room object using the builder pattern.
  factory SignalingBackendResponseApplicationJson_Ocs_Data_Room([
    void Function(SignalingBackendResponseApplicationJson_Ocs_Data_RoomBuilder)? b,
  ]) = _$SignalingBackendResponseApplicationJson_Ocs_Data_Room;

  // coverage:ignore-start
  const SignalingBackendResponseApplicationJson_Ocs_Data_Room._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SignalingBackendResponseApplicationJson_Ocs_Data_Room.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SignalingBackendResponseApplicationJson_Ocs_Data_Room.
  static Serializer<SignalingBackendResponseApplicationJson_Ocs_Data_Room> get serializer =>
      _$signalingBackendResponseApplicationJsonOcsDataRoomSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SignalingBackendResponseApplicationJson_Ocs_Data_RoomBuilder b) {
    $SignalingBackendResponseApplicationJson_Ocs_Data_RoomInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SignalingBackendResponseApplicationJson_Ocs_Data_RoomBuilder b) {
    $SignalingBackendResponseApplicationJson_Ocs_Data_RoomInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingBackendResponseApplicationJson_Ocs_DataInterface {
  String get type;
  SignalingBackendResponseApplicationJson_Ocs_Data_Error? get error;
  SignalingBackendResponseApplicationJson_Ocs_Data_Auth? get auth;
  SignalingBackendResponseApplicationJson_Ocs_Data_Room? get room;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SignalingBackendResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SignalingBackendResponseApplicationJson_Ocs_DataInterfaceBuilder b) {}
}

abstract class SignalingBackendResponseApplicationJson_Ocs_Data
    implements
        $SignalingBackendResponseApplicationJson_Ocs_DataInterface,
        Built<SignalingBackendResponseApplicationJson_Ocs_Data,
            SignalingBackendResponseApplicationJson_Ocs_DataBuilder> {
  /// Creates a new SignalingBackendResponseApplicationJson_Ocs_Data object using the builder pattern.
  factory SignalingBackendResponseApplicationJson_Ocs_Data([
    void Function(SignalingBackendResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$SignalingBackendResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const SignalingBackendResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SignalingBackendResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SignalingBackendResponseApplicationJson_Ocs_Data.
  static Serializer<SignalingBackendResponseApplicationJson_Ocs_Data> get serializer =>
      _$signalingBackendResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SignalingBackendResponseApplicationJson_Ocs_DataBuilder b) {
    $SignalingBackendResponseApplicationJson_Ocs_DataInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SignalingBackendResponseApplicationJson_Ocs_DataBuilder b) {
    $SignalingBackendResponseApplicationJson_Ocs_DataInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingBackendResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  SignalingBackendResponseApplicationJson_Ocs_Data get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SignalingBackendResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SignalingBackendResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class SignalingBackendResponseApplicationJson_Ocs
    implements
        $SignalingBackendResponseApplicationJson_OcsInterface,
        Built<SignalingBackendResponseApplicationJson_Ocs, SignalingBackendResponseApplicationJson_OcsBuilder> {
  /// Creates a new SignalingBackendResponseApplicationJson_Ocs object using the builder pattern.
  factory SignalingBackendResponseApplicationJson_Ocs([
    void Function(SignalingBackendResponseApplicationJson_OcsBuilder)? b,
  ]) = _$SignalingBackendResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const SignalingBackendResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SignalingBackendResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SignalingBackendResponseApplicationJson_Ocs.
  static Serializer<SignalingBackendResponseApplicationJson_Ocs> get serializer =>
      _$signalingBackendResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SignalingBackendResponseApplicationJson_OcsBuilder b) {
    $SignalingBackendResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SignalingBackendResponseApplicationJson_OcsBuilder b) {
    $SignalingBackendResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingBackendResponseApplicationJsonInterface {
  SignalingBackendResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($SignalingBackendResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($SignalingBackendResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class SignalingBackendResponseApplicationJson
    implements
        $SignalingBackendResponseApplicationJsonInterface,
        Built<SignalingBackendResponseApplicationJson, SignalingBackendResponseApplicationJsonBuilder> {
  /// Creates a new SignalingBackendResponseApplicationJson object using the builder pattern.
  factory SignalingBackendResponseApplicationJson([void Function(SignalingBackendResponseApplicationJsonBuilder)? b]) =
      _$SignalingBackendResponseApplicationJson;

  // coverage:ignore-start
  const SignalingBackendResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory SignalingBackendResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for SignalingBackendResponseApplicationJson.
  static Serializer<SignalingBackendResponseApplicationJson> get serializer =>
      _$signalingBackendResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(SignalingBackendResponseApplicationJsonBuilder b) {
    $SignalingBackendResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SignalingBackendResponseApplicationJsonBuilder b) {
    $SignalingBackendResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TempAvatarPostAvatarResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TempAvatarPostAvatarResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TempAvatarPostAvatarResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class TempAvatarPostAvatarResponseApplicationJson_Ocs
    implements
        $TempAvatarPostAvatarResponseApplicationJson_OcsInterface,
        Built<TempAvatarPostAvatarResponseApplicationJson_Ocs, TempAvatarPostAvatarResponseApplicationJson_OcsBuilder> {
  /// Creates a new TempAvatarPostAvatarResponseApplicationJson_Ocs object using the builder pattern.
  factory TempAvatarPostAvatarResponseApplicationJson_Ocs([
    void Function(TempAvatarPostAvatarResponseApplicationJson_OcsBuilder)? b,
  ]) = _$TempAvatarPostAvatarResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const TempAvatarPostAvatarResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TempAvatarPostAvatarResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TempAvatarPostAvatarResponseApplicationJson_Ocs.
  static Serializer<TempAvatarPostAvatarResponseApplicationJson_Ocs> get serializer =>
      _$tempAvatarPostAvatarResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TempAvatarPostAvatarResponseApplicationJson_OcsBuilder b) {
    $TempAvatarPostAvatarResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TempAvatarPostAvatarResponseApplicationJson_OcsBuilder b) {
    $TempAvatarPostAvatarResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TempAvatarPostAvatarResponseApplicationJsonInterface {
  TempAvatarPostAvatarResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TempAvatarPostAvatarResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TempAvatarPostAvatarResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class TempAvatarPostAvatarResponseApplicationJson
    implements
        $TempAvatarPostAvatarResponseApplicationJsonInterface,
        Built<TempAvatarPostAvatarResponseApplicationJson, TempAvatarPostAvatarResponseApplicationJsonBuilder> {
  /// Creates a new TempAvatarPostAvatarResponseApplicationJson object using the builder pattern.
  factory TempAvatarPostAvatarResponseApplicationJson([
    void Function(TempAvatarPostAvatarResponseApplicationJsonBuilder)? b,
  ]) = _$TempAvatarPostAvatarResponseApplicationJson;

  // coverage:ignore-start
  const TempAvatarPostAvatarResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TempAvatarPostAvatarResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TempAvatarPostAvatarResponseApplicationJson.
  static Serializer<TempAvatarPostAvatarResponseApplicationJson> get serializer =>
      _$tempAvatarPostAvatarResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TempAvatarPostAvatarResponseApplicationJsonBuilder b) {
    $TempAvatarPostAvatarResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TempAvatarPostAvatarResponseApplicationJsonBuilder b) {
    $TempAvatarPostAvatarResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TempAvatarDeleteAvatarResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TempAvatarDeleteAvatarResponseApplicationJson_OcsInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TempAvatarDeleteAvatarResponseApplicationJson_OcsInterfaceBuilder b) {}
}

abstract class TempAvatarDeleteAvatarResponseApplicationJson_Ocs
    implements
        $TempAvatarDeleteAvatarResponseApplicationJson_OcsInterface,
        Built<TempAvatarDeleteAvatarResponseApplicationJson_Ocs,
            TempAvatarDeleteAvatarResponseApplicationJson_OcsBuilder> {
  /// Creates a new TempAvatarDeleteAvatarResponseApplicationJson_Ocs object using the builder pattern.
  factory TempAvatarDeleteAvatarResponseApplicationJson_Ocs([
    void Function(TempAvatarDeleteAvatarResponseApplicationJson_OcsBuilder)? b,
  ]) = _$TempAvatarDeleteAvatarResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const TempAvatarDeleteAvatarResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TempAvatarDeleteAvatarResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TempAvatarDeleteAvatarResponseApplicationJson_Ocs.
  static Serializer<TempAvatarDeleteAvatarResponseApplicationJson_Ocs> get serializer =>
      _$tempAvatarDeleteAvatarResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TempAvatarDeleteAvatarResponseApplicationJson_OcsBuilder b) {
    $TempAvatarDeleteAvatarResponseApplicationJson_OcsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TempAvatarDeleteAvatarResponseApplicationJson_OcsBuilder b) {
    $TempAvatarDeleteAvatarResponseApplicationJson_OcsInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $TempAvatarDeleteAvatarResponseApplicationJsonInterface {
  TempAvatarDeleteAvatarResponseApplicationJson_Ocs get ocs;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($TempAvatarDeleteAvatarResponseApplicationJsonInterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($TempAvatarDeleteAvatarResponseApplicationJsonInterfaceBuilder b) {}
}

abstract class TempAvatarDeleteAvatarResponseApplicationJson
    implements
        $TempAvatarDeleteAvatarResponseApplicationJsonInterface,
        Built<TempAvatarDeleteAvatarResponseApplicationJson, TempAvatarDeleteAvatarResponseApplicationJsonBuilder> {
  /// Creates a new TempAvatarDeleteAvatarResponseApplicationJson object using the builder pattern.
  factory TempAvatarDeleteAvatarResponseApplicationJson([
    void Function(TempAvatarDeleteAvatarResponseApplicationJsonBuilder)? b,
  ]) = _$TempAvatarDeleteAvatarResponseApplicationJson;

  // coverage:ignore-start
  const TempAvatarDeleteAvatarResponseApplicationJson._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory TempAvatarDeleteAvatarResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for TempAvatarDeleteAvatarResponseApplicationJson.
  static Serializer<TempAvatarDeleteAvatarResponseApplicationJson> get serializer =>
      _$tempAvatarDeleteAvatarResponseApplicationJsonSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(TempAvatarDeleteAvatarResponseApplicationJsonBuilder b) {
    $TempAvatarDeleteAvatarResponseApplicationJsonInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(TempAvatarDeleteAvatarResponseApplicationJsonBuilder b) {
    $TempAvatarDeleteAvatarResponseApplicationJsonInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $BotWithDetailsAndSecretInterface implements $BotWithDetailsInterface {
  String get secret;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($BotWithDetailsAndSecretInterfaceBuilder b) {
    $BotWithDetailsInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($BotWithDetailsAndSecretInterfaceBuilder b) {
    $BotWithDetailsInterface._validate(b);
  }
}

abstract class BotWithDetailsAndSecret
    implements $BotWithDetailsAndSecretInterface, Built<BotWithDetailsAndSecret, BotWithDetailsAndSecretBuilder> {
  /// Creates a new BotWithDetailsAndSecret object using the builder pattern.
  factory BotWithDetailsAndSecret([void Function(BotWithDetailsAndSecretBuilder)? b]) = _$BotWithDetailsAndSecret;

  // coverage:ignore-start
  const BotWithDetailsAndSecret._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory BotWithDetailsAndSecret.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for BotWithDetailsAndSecret.
  static Serializer<BotWithDetailsAndSecret> get serializer => _$botWithDetailsAndSecretSerializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(BotWithDetailsAndSecretBuilder b) {
    $BotWithDetailsAndSecretInterface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(BotWithDetailsAndSecretBuilder b) {
    $BotWithDetailsAndSecretInterface._validate(b);
  }
}

@BuiltValue(instantiable: false)
abstract interface class $PublicCapabilities0Interface {
  Capabilities get spreed;
  @BuiltValueHook(initializeBuilder: true)
  static void _defaults($PublicCapabilities0InterfaceBuilder b) {}
  @BuiltValueHook(finalizeBuilder: true)
  static void _validate($PublicCapabilities0InterfaceBuilder b) {}
}

abstract class PublicCapabilities0
    implements $PublicCapabilities0Interface, Built<PublicCapabilities0, PublicCapabilities0Builder> {
  /// Creates a new PublicCapabilities0 object using the builder pattern.
  factory PublicCapabilities0([void Function(PublicCapabilities0Builder)? b]) = _$PublicCapabilities0;

  // coverage:ignore-start
  const PublicCapabilities0._();
  // coverage:ignore-end

  /// Creates a new object from the given [json] data.
  ///
  /// Use [toJson] to serialize it back into json.
  // coverage:ignore-start
  factory PublicCapabilities0.fromJson(Map<String, dynamic> json) =>
      _$jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  // coverage:ignore-start
  Map<String, dynamic> toJson() => _$jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  /// Serializer for PublicCapabilities0.
  static Serializer<PublicCapabilities0> get serializer => _$publicCapabilities0Serializer;

  @BuiltValueHook(initializeBuilder: true)
  static void _defaults(PublicCapabilities0Builder b) {
    $PublicCapabilities0Interface._defaults(b);
  }

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(PublicCapabilities0Builder b) {
    $PublicCapabilities0Interface._validate(b);
  }
}

typedef PublicCapabilities = ({BuiltList<Never>? builtListNever, PublicCapabilities0? publicCapabilities0});

/// Serialization extension for `RichObjectParameter_Size`.
extension $RichObjectParameter_SizeExtension on RichObjectParameter_Size {
  /// Serializer for RichObjectParameter_Size.
  @BuiltValueSerializer(custom: true)
  static Serializer<RichObjectParameter_Size> get serializer => $b2c4857c0136baea42828d89c87c757dExtension._serializer;

  /// Creates a new object from the given [json] data.
  ///
  /// Use `toJson` to serialize it back into json.
  static RichObjectParameter_Size fromJson(Object? json) => $b2c4857c0136baea42828d89c87c757dExtension._fromJson(json);
}

/// Serialization extension for `RichObjectParameter_Width`.
extension $RichObjectParameter_WidthExtension on RichObjectParameter_Width {
  /// Serializer for RichObjectParameter_Width.
  @BuiltValueSerializer(custom: true)
  static Serializer<RichObjectParameter_Width> get serializer => $b2c4857c0136baea42828d89c87c757dExtension._serializer;

  /// Creates a new object from the given [json] data.
  ///
  /// Use `toJson` to serialize it back into json.
  static RichObjectParameter_Width fromJson(Object? json) => $b2c4857c0136baea42828d89c87c757dExtension._fromJson(json);
}

/// Serialization extension for `RichObjectParameter_Height`.
extension $RichObjectParameter_HeightExtension on RichObjectParameter_Height {
  /// Serializer for RichObjectParameter_Height.
  @BuiltValueSerializer(custom: true)
  static Serializer<RichObjectParameter_Height> get serializer =>
      $b2c4857c0136baea42828d89c87c757dExtension._serializer;

  /// Creates a new object from the given [json] data.
  ///
  /// Use `toJson` to serialize it back into json.
  static RichObjectParameter_Height fromJson(Object? json) =>
      $b2c4857c0136baea42828d89c87c757dExtension._fromJson(json);
}

/// Serialization extension for `RoomLastMessage`.
extension $RoomLastMessageExtension on RoomLastMessage {
  /// Serializer for RoomLastMessage.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomLastMessage> get serializer => $4b3c240037cf48d36f81308e641eef98Extension._serializer;

  /// Creates a new object from the given [json] data.
  ///
  /// Use `toJson` to serialize it back into json.
  static RoomLastMessage fromJson(Object? json) => $4b3c240037cf48d36f81308e641eef98Extension._fromJson(json);
}

/// Serialization extension for `Room_LastMessage`.
extension $Room_LastMessageExtension on Room_LastMessage {
  /// Serializer for Room_LastMessage.
  @BuiltValueSerializer(custom: true)
  static Serializer<Room_LastMessage> get serializer => $bed8482b7c93ae2974fa4be6ae42b9b1Extension._serializer;

  /// Creates a new object from the given [json] data.
  ///
  /// Use `toJson` to serialize it back into json.
  static Room_LastMessage fromJson(Object? json) => $bed8482b7c93ae2974fa4be6ae42b9b1Extension._fromJson(json);
}

/// Serialization extension for `SignalingPullMessagesResponseApplicationJson_Ocs_Data_Data`.
extension $SignalingPullMessagesResponseApplicationJson_Ocs_Data_DataExtension
    on SignalingPullMessagesResponseApplicationJson_Ocs_Data_Data {
  /// Serializer for SignalingPullMessagesResponseApplicationJson_Ocs_Data_Data.
  @BuiltValueSerializer(custom: true)
  static Serializer<SignalingPullMessagesResponseApplicationJson_Ocs_Data_Data> get serializer =>
      $1df642f5035aea3b22543ab331c3fb01Extension._serializer;

  /// Creates a new object from the given [json] data.
  ///
  /// Use `toJson` to serialize it back into json.
  static SignalingPullMessagesResponseApplicationJson_Ocs_Data_Data fromJson(Object? json) =>
      $1df642f5035aea3b22543ab331c3fb01Extension._fromJson(json);
}

/// Serialization extension for `RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data`.
extension $RoomAddParticipantToRoomResponseApplicationJson_Ocs_DataExtension
    on RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data {
  /// Serializer for RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data> get serializer =>
      $bd993fb3f40af33e8594d0d698208560Extension._serializer;

  /// Creates a new object from the given [json] data.
  ///
  /// Use `toJson` to serialize it back into json.
  static RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data fromJson(Object? json) =>
      $bd993fb3f40af33e8594d0d698208560Extension._fromJson(json);
}

/// Serialization extension for `RoomGetCapabilitiesResponseApplicationJson_Ocs_Data`.
extension $RoomGetCapabilitiesResponseApplicationJson_Ocs_DataExtension
    on RoomGetCapabilitiesResponseApplicationJson_Ocs_Data {
  /// Serializer for RoomGetCapabilitiesResponseApplicationJson_Ocs_Data.
  @BuiltValueSerializer(custom: true)
  static Serializer<RoomGetCapabilitiesResponseApplicationJson_Ocs_Data> get serializer =>
      $973dc40faeda3fa3aa7e7b9895ee7a34Extension._serializer;

  /// Creates a new object from the given [json] data.
  ///
  /// Use `toJson` to serialize it back into json.
  static RoomGetCapabilitiesResponseApplicationJson_Ocs_Data fromJson(Object? json) =>
      $973dc40faeda3fa3aa7e7b9895ee7a34Extension._fromJson(json);
}

/// Serialization extension for `SettingsSetUserSettingValue`.
extension $SettingsSetUserSettingValueExtension on SettingsSetUserSettingValue {
  /// Serializer for SettingsSetUserSettingValue.
  @BuiltValueSerializer(custom: true)
  static Serializer<SettingsSetUserSettingValue> get serializer =>
      $b2c4857c0136baea42828d89c87c757dExtension._serializer;

  /// Creates a new object from the given [json] data.
  ///
  /// Use `toJson` to serialize it back into json.
  static SettingsSetUserSettingValue fromJson(Object? json) =>
      $b2c4857c0136baea42828d89c87c757dExtension._fromJson(json);
}

/// Serialization extension for `PublicCapabilities`.
extension $PublicCapabilitiesExtension on PublicCapabilities {
  /// Serializer for PublicCapabilities.
  @BuiltValueSerializer(custom: true)
  static Serializer<PublicCapabilities> get serializer => $bc4aac45771b11649d372f39a92b1cf3Extension._serializer;

  /// Creates a new object from the given [json] data.
  ///
  /// Use `toJson` to serialize it back into json.
  static PublicCapabilities fromJson(Object? json) => $bc4aac45771b11649d372f39a92b1cf3Extension._fromJson(json);
}

typedef _$b2c4857c0136baea42828d89c87c757d = ({int? $int, String? string});

/// @nodoc
// ignore: library_private_types_in_public_api
extension $b2c4857c0136baea42828d89c87c757dExtension on _$b2c4857c0136baea42828d89c87c757d {
  List<dynamic> get _values => [$int, string];
  List<String> get _names => const [r'$int', 'string'];

  /// {@macro Dynamite.validateOneOf}
  void validateOneOf() => _i4.validateOneOf(
        _values,
        _names,
      );

  /// {@macro Dynamite.validateAnyOf}
  void validateAnyOf() => _i4.validateAnyOf(
        _values,
        _names,
      );
  static Serializer<_$b2c4857c0136baea42828d89c87c757d> get _serializer =>
      const _$b2c4857c0136baea42828d89c87c757dSerializer();
  static _$b2c4857c0136baea42828d89c87c757d _fromJson(Object? json) =>
      _$jsonSerializers.deserializeWith(_serializer, json)!;

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  Object? toJson() => _$jsonSerializers.serializeWith(_serializer, this);
}

class _$b2c4857c0136baea42828d89c87c757dSerializer implements PrimitiveSerializer<_$b2c4857c0136baea42828d89c87c757d> {
  const _$b2c4857c0136baea42828d89c87c757dSerializer();

  @override
  Iterable<Type> get types => const [_$b2c4857c0136baea42828d89c87c757d];

  @override
  String get wireName => r'_$b2c4857c0136baea42828d89c87c757d';

  @override
  Object serialize(
    Serializers serializers,
    _$b2c4857c0136baea42828d89c87c757d object, {
    FullType specifiedType = FullType.unspecified,
  }) {
    dynamic value;
    value = object.$int;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(int))!;
    }
    value = object.string;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(String))!;
    }
// Should not be possible after validation.
    throw StateError('Tried to serialize without any value.');
  }

  @override
  _$b2c4857c0136baea42828d89c87c757d deserialize(
    Serializers serializers,
    Object data, {
    FullType specifiedType = FullType.unspecified,
  }) {
    int? $int;
    try {
      $int = serializers.deserialize(
        data,
        specifiedType: const FullType(int),
      )! as int;
    } catch (_) {}
    String? string;
    try {
      string = serializers.deserialize(
        data,
        specifiedType: const FullType(String),
      )! as String;
    } catch (_) {}
    return ($int: $int, string: string);
  }
}

typedef _$4b3c240037cf48d36f81308e641eef98 = ({BaseMessage? baseMessage, ChatMessage? chatMessage});

/// @nodoc
// ignore: library_private_types_in_public_api
extension $4b3c240037cf48d36f81308e641eef98Extension on _$4b3c240037cf48d36f81308e641eef98 {
  List<dynamic> get _values => [baseMessage, chatMessage];
  List<String> get _names => const ['baseMessage', 'chatMessage'];

  /// {@macro Dynamite.validateOneOf}
  void validateOneOf() => _i4.validateOneOf(
        _values,
        _names,
      );

  /// {@macro Dynamite.validateAnyOf}
  void validateAnyOf() => _i4.validateAnyOf(
        _values,
        _names,
      );
  static Serializer<_$4b3c240037cf48d36f81308e641eef98> get _serializer =>
      const _$4b3c240037cf48d36f81308e641eef98Serializer();
  static _$4b3c240037cf48d36f81308e641eef98 _fromJson(Object? json) =>
      _$jsonSerializers.deserializeWith(_serializer, json)!;

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  Object? toJson() => _$jsonSerializers.serializeWith(_serializer, this);
}

class _$4b3c240037cf48d36f81308e641eef98Serializer implements PrimitiveSerializer<_$4b3c240037cf48d36f81308e641eef98> {
  const _$4b3c240037cf48d36f81308e641eef98Serializer();

  @override
  Iterable<Type> get types => const [_$4b3c240037cf48d36f81308e641eef98];

  @override
  String get wireName => r'_$4b3c240037cf48d36f81308e641eef98';

  @override
  Object serialize(
    Serializers serializers,
    _$4b3c240037cf48d36f81308e641eef98 object, {
    FullType specifiedType = FullType.unspecified,
  }) {
    dynamic value;
    value = object.baseMessage;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(BaseMessage))!;
    }
    value = object.chatMessage;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(ChatMessage))!;
    }
// Should not be possible after validation.
    throw StateError('Tried to serialize without any value.');
  }

  @override
  _$4b3c240037cf48d36f81308e641eef98 deserialize(
    Serializers serializers,
    Object data, {
    FullType specifiedType = FullType.unspecified,
  }) {
    BaseMessage? baseMessage;
    try {
      baseMessage = serializers.deserialize(
        data,
        specifiedType: const FullType(BaseMessage),
      )! as BaseMessage;
    } catch (_) {}
    ChatMessage? chatMessage;
    try {
      chatMessage = serializers.deserialize(
        data,
        specifiedType: const FullType(ChatMessage),
      )! as ChatMessage;
    } catch (_) {}
    return (baseMessage: baseMessage, chatMessage: chatMessage);
  }
}

typedef _$bed8482b7c93ae2974fa4be6ae42b9b1 = ({
  BaseMessage? baseMessage,
  BuiltList<Never>? builtListNever,
  ChatMessage? chatMessage
});

/// @nodoc
// ignore: library_private_types_in_public_api
extension $bed8482b7c93ae2974fa4be6ae42b9b1Extension on _$bed8482b7c93ae2974fa4be6ae42b9b1 {
  List<dynamic> get _values => [baseMessage, builtListNever, chatMessage];
  List<String> get _names => const ['baseMessage', 'builtListNever', 'chatMessage'];

  /// {@macro Dynamite.validateOneOf}
  void validateOneOf() => _i4.validateOneOf(
        _values,
        _names,
      );

  /// {@macro Dynamite.validateAnyOf}
  void validateAnyOf() => _i4.validateAnyOf(
        _values,
        _names,
      );
  static Serializer<_$bed8482b7c93ae2974fa4be6ae42b9b1> get _serializer =>
      const _$bed8482b7c93ae2974fa4be6ae42b9b1Serializer();
  static _$bed8482b7c93ae2974fa4be6ae42b9b1 _fromJson(Object? json) =>
      _$jsonSerializers.deserializeWith(_serializer, json)!;

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  Object? toJson() => _$jsonSerializers.serializeWith(_serializer, this);
}

class _$bed8482b7c93ae2974fa4be6ae42b9b1Serializer implements PrimitiveSerializer<_$bed8482b7c93ae2974fa4be6ae42b9b1> {
  const _$bed8482b7c93ae2974fa4be6ae42b9b1Serializer();

  @override
  Iterable<Type> get types => const [_$bed8482b7c93ae2974fa4be6ae42b9b1];

  @override
  String get wireName => r'_$bed8482b7c93ae2974fa4be6ae42b9b1';

  @override
  Object serialize(
    Serializers serializers,
    _$bed8482b7c93ae2974fa4be6ae42b9b1 object, {
    FullType specifiedType = FullType.unspecified,
  }) {
    dynamic value;
    value = object.baseMessage;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(BaseMessage))!;
    }
    value = object.builtListNever;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(BuiltList, [FullType(Never)]))!;
    }
    value = object.chatMessage;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(ChatMessage))!;
    }
// Should not be possible after validation.
    throw StateError('Tried to serialize without any value.');
  }

  @override
  _$bed8482b7c93ae2974fa4be6ae42b9b1 deserialize(
    Serializers serializers,
    Object data, {
    FullType specifiedType = FullType.unspecified,
  }) {
    BaseMessage? baseMessage;
    try {
      baseMessage = serializers.deserialize(
        data,
        specifiedType: const FullType(BaseMessage),
      )! as BaseMessage;
    } catch (_) {}
    BuiltList<Never>? builtListNever;
    try {
      builtListNever = serializers.deserialize(
        data,
        specifiedType: const FullType(BuiltList, [FullType(Never)]),
      )! as BuiltList<Never>;
    } catch (_) {}
    ChatMessage? chatMessage;
    try {
      chatMessage = serializers.deserialize(
        data,
        specifiedType: const FullType(ChatMessage),
      )! as ChatMessage;
    } catch (_) {}
    return (baseMessage: baseMessage, builtListNever: builtListNever, chatMessage: chatMessage);
  }
}

typedef _$1df642f5035aea3b22543ab331c3fb01 = ({BuiltList<SignalingSession>? builtListSignalingSession, String? string});

/// @nodoc
// ignore: library_private_types_in_public_api
extension $1df642f5035aea3b22543ab331c3fb01Extension on _$1df642f5035aea3b22543ab331c3fb01 {
  List<dynamic> get _values => [builtListSignalingSession, string];
  List<String> get _names => const ['builtListSignalingSession', 'string'];

  /// {@macro Dynamite.validateOneOf}
  void validateOneOf() => _i4.validateOneOf(
        _values,
        _names,
      );

  /// {@macro Dynamite.validateAnyOf}
  void validateAnyOf() => _i4.validateAnyOf(
        _values,
        _names,
      );
  static Serializer<_$1df642f5035aea3b22543ab331c3fb01> get _serializer =>
      const _$1df642f5035aea3b22543ab331c3fb01Serializer();
  static _$1df642f5035aea3b22543ab331c3fb01 _fromJson(Object? json) =>
      _$jsonSerializers.deserializeWith(_serializer, json)!;

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  Object? toJson() => _$jsonSerializers.serializeWith(_serializer, this);
}

class _$1df642f5035aea3b22543ab331c3fb01Serializer implements PrimitiveSerializer<_$1df642f5035aea3b22543ab331c3fb01> {
  const _$1df642f5035aea3b22543ab331c3fb01Serializer();

  @override
  Iterable<Type> get types => const [_$1df642f5035aea3b22543ab331c3fb01];

  @override
  String get wireName => r'_$1df642f5035aea3b22543ab331c3fb01';

  @override
  Object serialize(
    Serializers serializers,
    _$1df642f5035aea3b22543ab331c3fb01 object, {
    FullType specifiedType = FullType.unspecified,
  }) {
    dynamic value;
    value = object.builtListSignalingSession;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(BuiltList, [FullType(SignalingSession)]))!;
    }
    value = object.string;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(String))!;
    }
// Should not be possible after validation.
    throw StateError('Tried to serialize without any value.');
  }

  @override
  _$1df642f5035aea3b22543ab331c3fb01 deserialize(
    Serializers serializers,
    Object data, {
    FullType specifiedType = FullType.unspecified,
  }) {
    BuiltList<SignalingSession>? builtListSignalingSession;
    try {
      builtListSignalingSession = serializers.deserialize(
        data,
        specifiedType: const FullType(BuiltList, [FullType(SignalingSession)]),
      )! as BuiltList<SignalingSession>;
    } catch (_) {}
    String? string;
    try {
      string = serializers.deserialize(
        data,
        specifiedType: const FullType(String),
      )! as String;
    } catch (_) {}
    return (builtListSignalingSession: builtListSignalingSession, string: string);
  }
}

typedef _$bd993fb3f40af33e8594d0d698208560 = ({
  BuiltList<Never>? builtListNever,
  RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0? roomAddParticipantToRoomResponseApplicationJsonOcsData0
});

/// @nodoc
// ignore: library_private_types_in_public_api
extension $bd993fb3f40af33e8594d0d698208560Extension on _$bd993fb3f40af33e8594d0d698208560 {
  List<dynamic> get _values => [builtListNever, roomAddParticipantToRoomResponseApplicationJsonOcsData0];
  List<String> get _names => const ['builtListNever', 'roomAddParticipantToRoomResponseApplicationJsonOcsData0'];

  /// {@macro Dynamite.validateOneOf}
  void validateOneOf() => _i4.validateOneOf(
        _values,
        _names,
      );

  /// {@macro Dynamite.validateAnyOf}
  void validateAnyOf() => _i4.validateAnyOf(
        _values,
        _names,
      );
  static Serializer<_$bd993fb3f40af33e8594d0d698208560> get _serializer =>
      const _$bd993fb3f40af33e8594d0d698208560Serializer();
  static _$bd993fb3f40af33e8594d0d698208560 _fromJson(Object? json) =>
      _$jsonSerializers.deserializeWith(_serializer, json)!;

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  Object? toJson() => _$jsonSerializers.serializeWith(_serializer, this);
}

class _$bd993fb3f40af33e8594d0d698208560Serializer implements PrimitiveSerializer<_$bd993fb3f40af33e8594d0d698208560> {
  const _$bd993fb3f40af33e8594d0d698208560Serializer();

  @override
  Iterable<Type> get types => const [_$bd993fb3f40af33e8594d0d698208560];

  @override
  String get wireName => r'_$bd993fb3f40af33e8594d0d698208560';

  @override
  Object serialize(
    Serializers serializers,
    _$bd993fb3f40af33e8594d0d698208560 object, {
    FullType specifiedType = FullType.unspecified,
  }) {
    dynamic value;
    value = object.builtListNever;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(BuiltList, [FullType(Never)]))!;
    }
    value = object.roomAddParticipantToRoomResponseApplicationJsonOcsData0;
    if (value != null) {
      return serializers.serialize(
        value,
        specifiedType: const FullType(RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0),
      )!;
    }
// Should not be possible after validation.
    throw StateError('Tried to serialize without any value.');
  }

  @override
  _$bd993fb3f40af33e8594d0d698208560 deserialize(
    Serializers serializers,
    Object data, {
    FullType specifiedType = FullType.unspecified,
  }) {
    BuiltList<Never>? builtListNever;
    try {
      builtListNever = serializers.deserialize(
        data,
        specifiedType: const FullType(BuiltList, [FullType(Never)]),
      )! as BuiltList<Never>;
    } catch (_) {}
    RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0? roomAddParticipantToRoomResponseApplicationJsonOcsData0;
    try {
      roomAddParticipantToRoomResponseApplicationJsonOcsData0 = serializers.deserialize(
        data,
        specifiedType: const FullType(RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0),
      )! as RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0;
    } catch (_) {}
    return (
      builtListNever: builtListNever,
      roomAddParticipantToRoomResponseApplicationJsonOcsData0: roomAddParticipantToRoomResponseApplicationJsonOcsData0
    );
  }
}

typedef _$973dc40faeda3fa3aa7e7b9895ee7a34 = ({BuiltList<Never>? builtListNever, Capabilities? capabilities});

/// @nodoc
// ignore: library_private_types_in_public_api
extension $973dc40faeda3fa3aa7e7b9895ee7a34Extension on _$973dc40faeda3fa3aa7e7b9895ee7a34 {
  List<dynamic> get _values => [builtListNever, capabilities];
  List<String> get _names => const ['builtListNever', 'capabilities'];

  /// {@macro Dynamite.validateOneOf}
  void validateOneOf() => _i4.validateOneOf(
        _values,
        _names,
      );

  /// {@macro Dynamite.validateAnyOf}
  void validateAnyOf() => _i4.validateAnyOf(
        _values,
        _names,
      );
  static Serializer<_$973dc40faeda3fa3aa7e7b9895ee7a34> get _serializer =>
      const _$973dc40faeda3fa3aa7e7b9895ee7a34Serializer();
  static _$973dc40faeda3fa3aa7e7b9895ee7a34 _fromJson(Object? json) =>
      _$jsonSerializers.deserializeWith(_serializer, json)!;

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  Object? toJson() => _$jsonSerializers.serializeWith(_serializer, this);
}

class _$973dc40faeda3fa3aa7e7b9895ee7a34Serializer implements PrimitiveSerializer<_$973dc40faeda3fa3aa7e7b9895ee7a34> {
  const _$973dc40faeda3fa3aa7e7b9895ee7a34Serializer();

  @override
  Iterable<Type> get types => const [_$973dc40faeda3fa3aa7e7b9895ee7a34];

  @override
  String get wireName => r'_$973dc40faeda3fa3aa7e7b9895ee7a34';

  @override
  Object serialize(
    Serializers serializers,
    _$973dc40faeda3fa3aa7e7b9895ee7a34 object, {
    FullType specifiedType = FullType.unspecified,
  }) {
    dynamic value;
    value = object.builtListNever;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(BuiltList, [FullType(Never)]))!;
    }
    value = object.capabilities;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(Capabilities))!;
    }
// Should not be possible after validation.
    throw StateError('Tried to serialize without any value.');
  }

  @override
  _$973dc40faeda3fa3aa7e7b9895ee7a34 deserialize(
    Serializers serializers,
    Object data, {
    FullType specifiedType = FullType.unspecified,
  }) {
    BuiltList<Never>? builtListNever;
    try {
      builtListNever = serializers.deserialize(
        data,
        specifiedType: const FullType(BuiltList, [FullType(Never)]),
      )! as BuiltList<Never>;
    } catch (_) {}
    Capabilities? capabilities;
    try {
      capabilities = serializers.deserialize(
        data,
        specifiedType: const FullType(Capabilities),
      )! as Capabilities;
    } catch (_) {}
    return (builtListNever: builtListNever, capabilities: capabilities);
  }
}

typedef _$bc4aac45771b11649d372f39a92b1cf3 = ({
  BuiltList<Never>? builtListNever,
  PublicCapabilities0? publicCapabilities0
});

/// @nodoc
// ignore: library_private_types_in_public_api
extension $bc4aac45771b11649d372f39a92b1cf3Extension on _$bc4aac45771b11649d372f39a92b1cf3 {
  List<dynamic> get _values => [builtListNever, publicCapabilities0];
  List<String> get _names => const ['builtListNever', 'publicCapabilities0'];

  /// {@macro Dynamite.validateOneOf}
  void validateOneOf() => _i4.validateOneOf(
        _values,
        _names,
      );

  /// {@macro Dynamite.validateAnyOf}
  void validateAnyOf() => _i4.validateAnyOf(
        _values,
        _names,
      );
  static Serializer<_$bc4aac45771b11649d372f39a92b1cf3> get _serializer =>
      const _$bc4aac45771b11649d372f39a92b1cf3Serializer();
  static _$bc4aac45771b11649d372f39a92b1cf3 _fromJson(Object? json) =>
      _$jsonSerializers.deserializeWith(_serializer, json)!;

  /// Parses this object into a json like map.
  ///
  /// Use the fromJson factory to revive it again.
  Object? toJson() => _$jsonSerializers.serializeWith(_serializer, this);
}

class _$bc4aac45771b11649d372f39a92b1cf3Serializer implements PrimitiveSerializer<_$bc4aac45771b11649d372f39a92b1cf3> {
  const _$bc4aac45771b11649d372f39a92b1cf3Serializer();

  @override
  Iterable<Type> get types => const [_$bc4aac45771b11649d372f39a92b1cf3];

  @override
  String get wireName => r'_$bc4aac45771b11649d372f39a92b1cf3';

  @override
  Object serialize(
    Serializers serializers,
    _$bc4aac45771b11649d372f39a92b1cf3 object, {
    FullType specifiedType = FullType.unspecified,
  }) {
    dynamic value;
    value = object.builtListNever;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(BuiltList, [FullType(Never)]))!;
    }
    value = object.publicCapabilities0;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(PublicCapabilities0))!;
    }
// Should not be possible after validation.
    throw StateError('Tried to serialize without any value.');
  }

  @override
  _$bc4aac45771b11649d372f39a92b1cf3 deserialize(
    Serializers serializers,
    Object data, {
    FullType specifiedType = FullType.unspecified,
  }) {
    BuiltList<Never>? builtListNever;
    try {
      builtListNever = serializers.deserialize(
        data,
        specifiedType: const FullType(BuiltList, [FullType(Never)]),
      )! as BuiltList<Never>;
    } catch (_) {}
    PublicCapabilities0? publicCapabilities0;
    try {
      publicCapabilities0 = serializers.deserialize(
        data,
        specifiedType: const FullType(PublicCapabilities0),
      )! as PublicCapabilities0;
    } catch (_) {}
    return (builtListNever: builtListNever, publicCapabilities0: publicCapabilities0);
  }
}

// coverage:ignore-start
/// Serializer for all values in this library.
///
/// Serializes values into the `built_value` wire format.
/// See: [$jsonSerializers] for serializing into json.
@_i2.visibleForTesting
final Serializers $serializers = _$serializers;
final Serializers _$serializers = (Serializers().toBuilder()
      ..add(AvatarGetAvatarDarkTheme.serializer)
      ..add(AvatarGetAvatarApiVersion.serializer)
      ..add(AvatarUploadAvatarApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(AvatarUploadAvatarResponseApplicationJson),
        AvatarUploadAvatarResponseApplicationJsonBuilder.new,
      )
      ..add(AvatarUploadAvatarResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(AvatarUploadAvatarResponseApplicationJson_Ocs),
        AvatarUploadAvatarResponseApplicationJson_OcsBuilder.new,
      )
      ..add(AvatarUploadAvatarResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(OCSMeta), OCSMetaBuilder.new)
      ..add(OCSMeta.serializer)
      ..addBuilderFactory(const FullType(Room), RoomBuilder.new)
      ..add(Room.serializer)
      ..add(ActorType.serializer)
      ..addBuilderFactory(const FullType(ChatMessage), ChatMessageBuilder.new)
      ..add(ChatMessage.serializer)
      ..addBuilderFactory(const FullType(BaseMessage), BaseMessageBuilder.new)
      ..add(BaseMessage.serializer)
      ..addBuilderFactory(const FullType(RichObjectParameter), RichObjectParameterBuilder.new)
      ..add(RichObjectParameter.serializer)
      ..add(RichObjectParameter_CallType.serializer)
      ..add($b2c4857c0136baea42828d89c87c757dExtension._serializer)
      ..add(RichObjectParameter_PreviewAvailable.serializer)
      ..add(RichObjectParameter_Visibility.serializer)
      ..add(RichObjectParameter_Assignable.serializer)
      ..addBuilderFactory(
        const FullType(BuiltMap, [FullType(String), FullType(RichObjectParameter)]),
        MapBuilder<String, RichObjectParameter>.new,
      )
      ..add(MessageType.serializer)
      ..add(ChatMessage_Deleted.serializer)
      ..addBuilderFactory(const FullType(BuiltMap, [FullType(String), FullType(int)]), MapBuilder<String, int>.new)
      ..add($4b3c240037cf48d36f81308e641eef98Extension._serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(Never)]), ListBuilder<Never>.new)
      ..add($bed8482b7c93ae2974fa4be6ae42b9b1Extension._serializer)
      ..add(AvatarDeleteAvatarApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(AvatarDeleteAvatarResponseApplicationJson),
        AvatarDeleteAvatarResponseApplicationJsonBuilder.new,
      )
      ..add(AvatarDeleteAvatarResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(AvatarDeleteAvatarResponseApplicationJson_Ocs),
        AvatarDeleteAvatarResponseApplicationJson_OcsBuilder.new,
      )
      ..add(AvatarDeleteAvatarResponseApplicationJson_Ocs.serializer)
      ..add(AvatarEmojiAvatarApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(AvatarEmojiAvatarResponseApplicationJson),
        AvatarEmojiAvatarResponseApplicationJsonBuilder.new,
      )
      ..add(AvatarEmojiAvatarResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(AvatarEmojiAvatarResponseApplicationJson_Ocs),
        AvatarEmojiAvatarResponseApplicationJson_OcsBuilder.new,
      )
      ..add(AvatarEmojiAvatarResponseApplicationJson_Ocs.serializer)
      ..add(AvatarGetAvatarDarkApiVersion.serializer)
      ..add(AvatarGetUserProxyAvatarWithoutRoomSize.serializer)
      ..add(AvatarGetUserProxyAvatarWithoutRoomDarkTheme.serializer)
      ..add(AvatarGetUserProxyAvatarWithoutRoomApiVersion.serializer)
      ..add(AvatarGetUserProxyAvatarDarkWithoutRoomSize.serializer)
      ..add(AvatarGetUserProxyAvatarDarkWithoutRoomApiVersion.serializer)
      ..add(AvatarGetUserProxyAvatarSize.serializer)
      ..add(AvatarGetUserProxyAvatarDarkTheme.serializer)
      ..add(AvatarGetUserProxyAvatarApiVersion.serializer)
      ..add(AvatarGetUserProxyAvatarDarkSize.serializer)
      ..add(AvatarGetUserProxyAvatarDarkApiVersion.serializer)
      ..add(BotListBotsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BotListBotsResponseApplicationJson),
        BotListBotsResponseApplicationJsonBuilder.new,
      )
      ..add(BotListBotsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BotListBotsResponseApplicationJson_Ocs),
        BotListBotsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BotListBotsResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(Bot), BotBuilder.new)
      ..add(Bot.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(Bot)]), ListBuilder<Bot>.new)
      ..add(BotEnableBotApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BotEnableBotResponseApplicationJson),
        BotEnableBotResponseApplicationJsonBuilder.new,
      )
      ..add(BotEnableBotResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BotEnableBotResponseApplicationJson_Ocs),
        BotEnableBotResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BotEnableBotResponseApplicationJson_Ocs.serializer)
      ..add(BotDisableBotApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BotDisableBotResponseApplicationJson),
        BotDisableBotResponseApplicationJsonBuilder.new,
      )
      ..add(BotDisableBotResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BotDisableBotResponseApplicationJson_Ocs),
        BotDisableBotResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BotDisableBotResponseApplicationJson_Ocs.serializer)
      ..add(BotSendMessageSilent.serializer)
      ..add(BotSendMessageApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BotSendMessageResponseApplicationJson),
        BotSendMessageResponseApplicationJsonBuilder.new,
      )
      ..add(BotSendMessageResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BotSendMessageResponseApplicationJson_Ocs),
        BotSendMessageResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BotSendMessageResponseApplicationJson_Ocs.serializer)
      ..add(BotReactApiVersion.serializer)
      ..addBuilderFactory(const FullType(BotReactResponseApplicationJson), BotReactResponseApplicationJsonBuilder.new)
      ..add(BotReactResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BotReactResponseApplicationJson_Ocs),
        BotReactResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BotReactResponseApplicationJson_Ocs.serializer)
      ..add(BotDeleteReactionApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BotDeleteReactionResponseApplicationJson),
        BotDeleteReactionResponseApplicationJsonBuilder.new,
      )
      ..add(BotDeleteReactionResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BotDeleteReactionResponseApplicationJson_Ocs),
        BotDeleteReactionResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BotDeleteReactionResponseApplicationJson_Ocs.serializer)
      ..add(BreakoutRoomConfigureBreakoutRoomsMode.serializer)
      ..add(BreakoutRoomConfigureBreakoutRoomsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson),
        BreakoutRoomConfigureBreakoutRoomsResponseApplicationJsonBuilder.new,
      )
      ..add(BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_Ocs),
        BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(Room)]), ListBuilder<Room>.new)
      ..add(BreakoutRoomRemoveBreakoutRoomsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson),
        BreakoutRoomRemoveBreakoutRoomsResponseApplicationJsonBuilder.new,
      )
      ..add(BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_Ocs),
        BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_Ocs.serializer)
      ..add(BreakoutRoomBroadcastChatMessageApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomBroadcastChatMessageResponseApplicationJson),
        BreakoutRoomBroadcastChatMessageResponseApplicationJsonBuilder.new,
      )
      ..add(BreakoutRoomBroadcastChatMessageResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomBroadcastChatMessageResponseApplicationJson_Ocs),
        BreakoutRoomBroadcastChatMessageResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BreakoutRoomBroadcastChatMessageResponseApplicationJson_Ocs.serializer)
      ..add(BreakoutRoomApplyAttendeeMapApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomApplyAttendeeMapResponseApplicationJson),
        BreakoutRoomApplyAttendeeMapResponseApplicationJsonBuilder.new,
      )
      ..add(BreakoutRoomApplyAttendeeMapResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomApplyAttendeeMapResponseApplicationJson_Ocs),
        BreakoutRoomApplyAttendeeMapResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BreakoutRoomApplyAttendeeMapResponseApplicationJson_Ocs.serializer)
      ..add(BreakoutRoomRequestAssistanceApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomRequestAssistanceResponseApplicationJson),
        BreakoutRoomRequestAssistanceResponseApplicationJsonBuilder.new,
      )
      ..add(BreakoutRoomRequestAssistanceResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomRequestAssistanceResponseApplicationJson_Ocs),
        BreakoutRoomRequestAssistanceResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BreakoutRoomRequestAssistanceResponseApplicationJson_Ocs.serializer)
      ..add(BreakoutRoomResetRequestForAssistanceApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomResetRequestForAssistanceResponseApplicationJson),
        BreakoutRoomResetRequestForAssistanceResponseApplicationJsonBuilder.new,
      )
      ..add(BreakoutRoomResetRequestForAssistanceResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomResetRequestForAssistanceResponseApplicationJson_Ocs),
        BreakoutRoomResetRequestForAssistanceResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BreakoutRoomResetRequestForAssistanceResponseApplicationJson_Ocs.serializer)
      ..add(BreakoutRoomStartBreakoutRoomsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomStartBreakoutRoomsResponseApplicationJson),
        BreakoutRoomStartBreakoutRoomsResponseApplicationJsonBuilder.new,
      )
      ..add(BreakoutRoomStartBreakoutRoomsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomStartBreakoutRoomsResponseApplicationJson_Ocs),
        BreakoutRoomStartBreakoutRoomsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BreakoutRoomStartBreakoutRoomsResponseApplicationJson_Ocs.serializer)
      ..add(BreakoutRoomStopBreakoutRoomsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomStopBreakoutRoomsResponseApplicationJson),
        BreakoutRoomStopBreakoutRoomsResponseApplicationJsonBuilder.new,
      )
      ..add(BreakoutRoomStopBreakoutRoomsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomStopBreakoutRoomsResponseApplicationJson_Ocs),
        BreakoutRoomStopBreakoutRoomsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BreakoutRoomStopBreakoutRoomsResponseApplicationJson_Ocs.serializer)
      ..add(BreakoutRoomSwitchBreakoutRoomApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomSwitchBreakoutRoomResponseApplicationJson),
        BreakoutRoomSwitchBreakoutRoomResponseApplicationJsonBuilder.new,
      )
      ..add(BreakoutRoomSwitchBreakoutRoomResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_Ocs),
        BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_Ocs.serializer)
      ..add(CallGetPeersForCallApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(CallGetPeersForCallResponseApplicationJson),
        CallGetPeersForCallResponseApplicationJsonBuilder.new,
      )
      ..add(CallGetPeersForCallResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(CallGetPeersForCallResponseApplicationJson_Ocs),
        CallGetPeersForCallResponseApplicationJson_OcsBuilder.new,
      )
      ..add(CallGetPeersForCallResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(CallPeer), CallPeerBuilder.new)
      ..add(CallPeer.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(CallPeer)]), ListBuilder<CallPeer>.new)
      ..add(CallUpdateCallFlagsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(CallUpdateCallFlagsResponseApplicationJson),
        CallUpdateCallFlagsResponseApplicationJsonBuilder.new,
      )
      ..add(CallUpdateCallFlagsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(CallUpdateCallFlagsResponseApplicationJson_Ocs),
        CallUpdateCallFlagsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(CallUpdateCallFlagsResponseApplicationJson_Ocs.serializer)
      ..add(CallJoinCallSilent.serializer)
      ..add(CallJoinCallRecordingConsent.serializer)
      ..add(CallJoinCallApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(CallJoinCallResponseApplicationJson),
        CallJoinCallResponseApplicationJsonBuilder.new,
      )
      ..add(CallJoinCallResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(CallJoinCallResponseApplicationJson_Ocs),
        CallJoinCallResponseApplicationJson_OcsBuilder.new,
      )
      ..add(CallJoinCallResponseApplicationJson_Ocs.serializer)
      ..add(CallLeaveCallAll.serializer)
      ..add(CallLeaveCallApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(CallLeaveCallResponseApplicationJson),
        CallLeaveCallResponseApplicationJsonBuilder.new,
      )
      ..add(CallLeaveCallResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(CallLeaveCallResponseApplicationJson_Ocs),
        CallLeaveCallResponseApplicationJson_OcsBuilder.new,
      )
      ..add(CallLeaveCallResponseApplicationJson_Ocs.serializer)
      ..add(CallRingAttendeeApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(CallRingAttendeeResponseApplicationJson),
        CallRingAttendeeResponseApplicationJsonBuilder.new,
      )
      ..add(CallRingAttendeeResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(CallRingAttendeeResponseApplicationJson_Ocs),
        CallRingAttendeeResponseApplicationJson_OcsBuilder.new,
      )
      ..add(CallRingAttendeeResponseApplicationJson_Ocs.serializer)
      ..add(CallSipDialOutApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(CallSipDialOutResponseApplicationJson),
        CallSipDialOutResponseApplicationJsonBuilder.new,
      )
      ..add(CallSipDialOutResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(CallSipDialOutResponseApplicationJson_Ocs),
        CallSipDialOutResponseApplicationJson_OcsBuilder.new,
      )
      ..add(CallSipDialOutResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(CallSipDialOutResponseApplicationJson_Ocs_Data),
        CallSipDialOutResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(CallSipDialOutResponseApplicationJson_Ocs_Data.serializer)
      ..add(ChatReceiveMessagesLookIntoFuture.serializer)
      ..add(ChatReceiveMessagesSetReadMarker.serializer)
      ..add(ChatReceiveMessagesIncludeLastKnown.serializer)
      ..add(ChatReceiveMessagesNoStatusUpdate.serializer)
      ..add(ChatReceiveMessagesMarkNotificationsAsRead.serializer)
      ..add(ChatReceiveMessagesApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(ChatReceiveMessagesResponseApplicationJson),
        ChatReceiveMessagesResponseApplicationJsonBuilder.new,
      )
      ..add(ChatReceiveMessagesResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ChatReceiveMessagesResponseApplicationJson_Ocs),
        ChatReceiveMessagesResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ChatReceiveMessagesResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(ChatMessageWithParent), ChatMessageWithParentBuilder.new)
      ..add(ChatMessageWithParent.serializer)
      ..addBuilderFactory(
        const FullType(BuiltList, [FullType(ChatMessageWithParent)]),
        ListBuilder<ChatMessageWithParent>.new,
      )
      ..addBuilderFactory(const FullType(ChatChatReceiveMessagesHeaders), ChatChatReceiveMessagesHeadersBuilder.new)
      ..add(ChatChatReceiveMessagesHeaders.serializer)
      ..add(ChatSendMessageSilent.serializer)
      ..add(ChatSendMessageApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(ChatSendMessageResponseApplicationJson),
        ChatSendMessageResponseApplicationJsonBuilder.new,
      )
      ..add(ChatSendMessageResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ChatSendMessageResponseApplicationJson_Ocs),
        ChatSendMessageResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ChatSendMessageResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(ChatChatSendMessageHeaders), ChatChatSendMessageHeadersBuilder.new)
      ..add(ChatChatSendMessageHeaders.serializer)
      ..add(ChatClearHistoryApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(ChatClearHistoryResponseApplicationJson),
        ChatClearHistoryResponseApplicationJsonBuilder.new,
      )
      ..add(ChatClearHistoryResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ChatClearHistoryResponseApplicationJson_Ocs),
        ChatClearHistoryResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ChatClearHistoryResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(ChatChatClearHistoryHeaders), ChatChatClearHistoryHeadersBuilder.new)
      ..add(ChatChatClearHistoryHeaders.serializer)
      ..add(ChatEditMessageApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(ChatEditMessageResponseApplicationJson),
        ChatEditMessageResponseApplicationJsonBuilder.new,
      )
      ..add(ChatEditMessageResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ChatEditMessageResponseApplicationJson_Ocs),
        ChatEditMessageResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ChatEditMessageResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(ChatChatEditMessageHeaders), ChatChatEditMessageHeadersBuilder.new)
      ..add(ChatChatEditMessageHeaders.serializer)
      ..add(ChatDeleteMessageApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(ChatDeleteMessageResponseApplicationJson),
        ChatDeleteMessageResponseApplicationJsonBuilder.new,
      )
      ..add(ChatDeleteMessageResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ChatDeleteMessageResponseApplicationJson_Ocs),
        ChatDeleteMessageResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ChatDeleteMessageResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(ChatChatDeleteMessageHeaders), ChatChatDeleteMessageHeadersBuilder.new)
      ..add(ChatChatDeleteMessageHeaders.serializer)
      ..add(ChatGetMessageContextApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(ChatGetMessageContextResponseApplicationJson),
        ChatGetMessageContextResponseApplicationJsonBuilder.new,
      )
      ..add(ChatGetMessageContextResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ChatGetMessageContextResponseApplicationJson_Ocs),
        ChatGetMessageContextResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ChatGetMessageContextResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(ChatChatGetMessageContextHeaders), ChatChatGetMessageContextHeadersBuilder.new)
      ..add(ChatChatGetMessageContextHeaders.serializer)
      ..add(ChatGetReminderApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(ChatGetReminderResponseApplicationJson),
        ChatGetReminderResponseApplicationJsonBuilder.new,
      )
      ..add(ChatGetReminderResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ChatGetReminderResponseApplicationJson_Ocs),
        ChatGetReminderResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ChatGetReminderResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(ChatReminder), ChatReminderBuilder.new)
      ..add(ChatReminder.serializer)
      ..add(ChatSetReminderApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(ChatSetReminderResponseApplicationJson),
        ChatSetReminderResponseApplicationJsonBuilder.new,
      )
      ..add(ChatSetReminderResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ChatSetReminderResponseApplicationJson_Ocs),
        ChatSetReminderResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ChatSetReminderResponseApplicationJson_Ocs.serializer)
      ..add(ChatDeleteReminderApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(ChatDeleteReminderResponseApplicationJson),
        ChatDeleteReminderResponseApplicationJsonBuilder.new,
      )
      ..add(ChatDeleteReminderResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ChatDeleteReminderResponseApplicationJson_Ocs),
        ChatDeleteReminderResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ChatDeleteReminderResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(ChatDeleteReminderResponseApplicationJson_Ocs_Data),
        ChatDeleteReminderResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(ChatDeleteReminderResponseApplicationJson_Ocs_Data.serializer)
      ..add(ChatSetReadMarkerApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(ChatSetReadMarkerResponseApplicationJson),
        ChatSetReadMarkerResponseApplicationJsonBuilder.new,
      )
      ..add(ChatSetReadMarkerResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ChatSetReadMarkerResponseApplicationJson_Ocs),
        ChatSetReadMarkerResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ChatSetReadMarkerResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(ChatChatSetReadMarkerHeaders), ChatChatSetReadMarkerHeadersBuilder.new)
      ..add(ChatChatSetReadMarkerHeaders.serializer)
      ..add(ChatMarkUnreadApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(ChatMarkUnreadResponseApplicationJson),
        ChatMarkUnreadResponseApplicationJsonBuilder.new,
      )
      ..add(ChatMarkUnreadResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ChatMarkUnreadResponseApplicationJson_Ocs),
        ChatMarkUnreadResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ChatMarkUnreadResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(ChatChatMarkUnreadHeaders), ChatChatMarkUnreadHeadersBuilder.new)
      ..add(ChatChatMarkUnreadHeaders.serializer)
      ..add(ChatMentionsIncludeStatus.serializer)
      ..add(ChatMentionsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(ChatMentionsResponseApplicationJson),
        ChatMentionsResponseApplicationJsonBuilder.new,
      )
      ..add(ChatMentionsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ChatMentionsResponseApplicationJson_Ocs),
        ChatMentionsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ChatMentionsResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(ChatMentionSuggestion), ChatMentionSuggestionBuilder.new)
      ..add(ChatMentionSuggestion.serializer)
      ..addBuilderFactory(
        const FullType(BuiltList, [FullType(ChatMentionSuggestion)]),
        ListBuilder<ChatMentionSuggestion>.new,
      )
      ..add(ChatGetObjectsSharedInRoomApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(ChatGetObjectsSharedInRoomResponseApplicationJson),
        ChatGetObjectsSharedInRoomResponseApplicationJsonBuilder.new,
      )
      ..add(ChatGetObjectsSharedInRoomResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ChatGetObjectsSharedInRoomResponseApplicationJson_Ocs),
        ChatGetObjectsSharedInRoomResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ChatGetObjectsSharedInRoomResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(ChatMessage)]), ListBuilder<ChatMessage>.new)
      ..addBuilderFactory(
        const FullType(ChatChatGetObjectsSharedInRoomHeaders),
        ChatChatGetObjectsSharedInRoomHeadersBuilder.new,
      )
      ..add(ChatChatGetObjectsSharedInRoomHeaders.serializer)
      ..add(ChatShareObjectToChatApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(ChatShareObjectToChatResponseApplicationJson),
        ChatShareObjectToChatResponseApplicationJsonBuilder.new,
      )
      ..add(ChatShareObjectToChatResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ChatShareObjectToChatResponseApplicationJson_Ocs),
        ChatShareObjectToChatResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ChatShareObjectToChatResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(ChatChatShareObjectToChatHeaders), ChatChatShareObjectToChatHeadersBuilder.new)
      ..add(ChatChatShareObjectToChatHeaders.serializer)
      ..add(ChatGetObjectsSharedInRoomOverviewApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(ChatGetObjectsSharedInRoomOverviewResponseApplicationJson),
        ChatGetObjectsSharedInRoomOverviewResponseApplicationJsonBuilder.new,
      )
      ..add(ChatGetObjectsSharedInRoomOverviewResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_Ocs),
        ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(BuiltMap, [
          FullType(String),
          FullType(BuiltList, [FullType(ChatMessage)]),
        ]),
        MapBuilder<String, BuiltList<ChatMessage>>.new,
      )
      ..add(SignalingGetSettingsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(SignalingGetSettingsResponseApplicationJson),
        SignalingGetSettingsResponseApplicationJsonBuilder.new,
      )
      ..add(SignalingGetSettingsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(SignalingGetSettingsResponseApplicationJson_Ocs),
        SignalingGetSettingsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(SignalingGetSettingsResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(SignalingSettings), SignalingSettingsBuilder.new)
      ..add(SignalingSettings.serializer)
      ..addBuilderFactory(
        const FullType(SignalingSettings_HelloAuthParams),
        SignalingSettings_HelloAuthParamsBuilder.new,
      )
      ..add(SignalingSettings_HelloAuthParams.serializer)
      ..addBuilderFactory(
        const FullType(SignalingSettings_HelloAuthParams_10),
        SignalingSettings_HelloAuthParams_10Builder.new,
      )
      ..add(SignalingSettings_HelloAuthParams_10.serializer)
      ..addBuilderFactory(
        const FullType(SignalingSettings_HelloAuthParams_20),
        SignalingSettings_HelloAuthParams_20Builder.new,
      )
      ..add(SignalingSettings_HelloAuthParams_20.serializer)
      ..addBuilderFactory(const FullType(SignalingSettings_Stunservers), SignalingSettings_StunserversBuilder.new)
      ..add(SignalingSettings_Stunservers.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(String)]), ListBuilder<String>.new)
      ..addBuilderFactory(
        const FullType(BuiltList, [FullType(SignalingSettings_Stunservers)]),
        ListBuilder<SignalingSettings_Stunservers>.new,
      )
      ..addBuilderFactory(const FullType(SignalingSettings_Turnservers), SignalingSettings_TurnserversBuilder.new)
      ..add(SignalingSettings_Turnservers.serializer)
      ..addBuilderFactory(
        const FullType(BuiltList, [FullType(SignalingSettings_Turnservers)]),
        ListBuilder<SignalingSettings_Turnservers>.new,
      )
      ..add(FederationAcceptShareApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(FederationAcceptShareResponseApplicationJson),
        FederationAcceptShareResponseApplicationJsonBuilder.new,
      )
      ..add(FederationAcceptShareResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(FederationAcceptShareResponseApplicationJson_Ocs),
        FederationAcceptShareResponseApplicationJson_OcsBuilder.new,
      )
      ..add(FederationAcceptShareResponseApplicationJson_Ocs.serializer)
      ..add(FederationRejectShareApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(FederationRejectShareResponseApplicationJson),
        FederationRejectShareResponseApplicationJsonBuilder.new,
      )
      ..add(FederationRejectShareResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(FederationRejectShareResponseApplicationJson_Ocs),
        FederationRejectShareResponseApplicationJson_OcsBuilder.new,
      )
      ..add(FederationRejectShareResponseApplicationJson_Ocs.serializer)
      ..add(FederationGetSharesApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(FederationGetSharesResponseApplicationJson),
        FederationGetSharesResponseApplicationJsonBuilder.new,
      )
      ..add(FederationGetSharesResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(FederationGetSharesResponseApplicationJson_Ocs),
        FederationGetSharesResponseApplicationJson_OcsBuilder.new,
      )
      ..add(FederationGetSharesResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(FederationInvite), FederationInviteBuilder.new)
      ..add(FederationInvite.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(FederationInvite)]), ListBuilder<FederationInvite>.new)
      ..add(FilesIntegrationGetRoomByFileIdApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(FilesIntegrationGetRoomByFileIdResponseApplicationJson),
        FilesIntegrationGetRoomByFileIdResponseApplicationJsonBuilder.new,
      )
      ..add(FilesIntegrationGetRoomByFileIdResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs),
        FilesIntegrationGetRoomByFileIdResponseApplicationJson_OcsBuilder.new,
      )
      ..add(FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_Data),
        FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_Data.serializer)
      ..add(FilesIntegrationGetRoomByShareTokenApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(FilesIntegrationGetRoomByShareTokenResponseApplicationJson),
        FilesIntegrationGetRoomByShareTokenResponseApplicationJsonBuilder.new,
      )
      ..add(FilesIntegrationGetRoomByShareTokenResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs),
        FilesIntegrationGetRoomByShareTokenResponseApplicationJson_OcsBuilder.new,
      )
      ..add(FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_Data),
        FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_Data.serializer)
      ..add(PublicShareAuthCreateRoomApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(PublicShareAuthCreateRoomResponseApplicationJson),
        PublicShareAuthCreateRoomResponseApplicationJsonBuilder.new,
      )
      ..add(PublicShareAuthCreateRoomResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(PublicShareAuthCreateRoomResponseApplicationJson_Ocs),
        PublicShareAuthCreateRoomResponseApplicationJson_OcsBuilder.new,
      )
      ..add(PublicShareAuthCreateRoomResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(PublicShareAuthCreateRoomResponseApplicationJson_Ocs_Data),
        PublicShareAuthCreateRoomResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(PublicShareAuthCreateRoomResponseApplicationJson_Ocs_Data.serializer)
      ..add(GuestSetDisplayNameApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(GuestSetDisplayNameResponseApplicationJson),
        GuestSetDisplayNameResponseApplicationJsonBuilder.new,
      )
      ..add(GuestSetDisplayNameResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(GuestSetDisplayNameResponseApplicationJson_Ocs),
        GuestSetDisplayNameResponseApplicationJson_OcsBuilder.new,
      )
      ..add(GuestSetDisplayNameResponseApplicationJson_Ocs.serializer)
      ..add(HostedSignalingServerRequestTrialApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(HostedSignalingServerRequestTrialResponseApplicationJson),
        HostedSignalingServerRequestTrialResponseApplicationJsonBuilder.new,
      )
      ..add(HostedSignalingServerRequestTrialResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(HostedSignalingServerRequestTrialResponseApplicationJson_Ocs),
        HostedSignalingServerRequestTrialResponseApplicationJson_OcsBuilder.new,
      )
      ..add(HostedSignalingServerRequestTrialResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(BuiltMap, [FullType(String), FullType(JsonObject)]),
        MapBuilder<String, JsonObject>.new,
      )
      ..add(HostedSignalingServerDeleteAccountApiVersion.serializer)
      ..add(SignalingPullMessagesApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(SignalingPullMessagesResponseApplicationJson),
        SignalingPullMessagesResponseApplicationJsonBuilder.new,
      )
      ..add(SignalingPullMessagesResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(SignalingPullMessagesResponseApplicationJson_Ocs),
        SignalingPullMessagesResponseApplicationJson_OcsBuilder.new,
      )
      ..add(SignalingPullMessagesResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(SignalingPullMessagesResponseApplicationJson_Ocs_Data),
        SignalingPullMessagesResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(SignalingPullMessagesResponseApplicationJson_Ocs_Data.serializer)
      ..addBuilderFactory(const FullType(SignalingSession), SignalingSessionBuilder.new)
      ..add(SignalingSession.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(SignalingSession)]), ListBuilder<SignalingSession>.new)
      ..add($1df642f5035aea3b22543ab331c3fb01Extension._serializer)
      ..addBuilderFactory(
        const FullType(BuiltList, [FullType(SignalingPullMessagesResponseApplicationJson_Ocs_Data)]),
        ListBuilder<SignalingPullMessagesResponseApplicationJson_Ocs_Data>.new,
      )
      ..add(SignalingSendMessagesApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(SignalingSendMessagesResponseApplicationJson),
        SignalingSendMessagesResponseApplicationJsonBuilder.new,
      )
      ..add(SignalingSendMessagesResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(SignalingSendMessagesResponseApplicationJson_Ocs),
        SignalingSendMessagesResponseApplicationJson_OcsBuilder.new,
      )
      ..add(SignalingSendMessagesResponseApplicationJson_Ocs.serializer)
      ..add(MatterbridgeGetBridgeOfRoomApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(MatterbridgeGetBridgeOfRoomResponseApplicationJson),
        MatterbridgeGetBridgeOfRoomResponseApplicationJsonBuilder.new,
      )
      ..add(MatterbridgeGetBridgeOfRoomResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(MatterbridgeGetBridgeOfRoomResponseApplicationJson_Ocs),
        MatterbridgeGetBridgeOfRoomResponseApplicationJson_OcsBuilder.new,
      )
      ..add(MatterbridgeGetBridgeOfRoomResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(MatterbridgeWithProcessState), MatterbridgeWithProcessStateBuilder.new)
      ..add(MatterbridgeWithProcessState.serializer)
      ..addBuilderFactory(const FullType(Matterbridge), MatterbridgeBuilder.new)
      ..add(Matterbridge.serializer)
      ..addBuilderFactory(
        const FullType(BuiltList, [
          FullType(BuiltMap, [FullType(String), FullType(JsonObject)]),
        ]),
        ListBuilder<BuiltMap<String, JsonObject>>.new,
      )
      ..addBuilderFactory(const FullType(MatterbridgeProcessState), MatterbridgeProcessStateBuilder.new)
      ..add(MatterbridgeProcessState.serializer)
      ..add(MatterbridgeEditBridgeOfRoomEnabled.serializer)
      ..addBuilderFactory(
        const FullType(ContentString, [
          FullType(BuiltList, [
            FullType(BuiltMap, [FullType(String), FullType(JsonObject)]),
          ]),
        ]),
        ContentStringBuilder<BuiltList<BuiltMap<String, JsonObject>>>.new,
      )
      ..add(ContentString.serializer)
      ..add(MatterbridgeEditBridgeOfRoomApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(MatterbridgeEditBridgeOfRoomResponseApplicationJson),
        MatterbridgeEditBridgeOfRoomResponseApplicationJsonBuilder.new,
      )
      ..add(MatterbridgeEditBridgeOfRoomResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(MatterbridgeEditBridgeOfRoomResponseApplicationJson_Ocs),
        MatterbridgeEditBridgeOfRoomResponseApplicationJson_OcsBuilder.new,
      )
      ..add(MatterbridgeEditBridgeOfRoomResponseApplicationJson_Ocs.serializer)
      ..add(MatterbridgeDeleteBridgeOfRoomApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(MatterbridgeDeleteBridgeOfRoomResponseApplicationJson),
        MatterbridgeDeleteBridgeOfRoomResponseApplicationJsonBuilder.new,
      )
      ..add(MatterbridgeDeleteBridgeOfRoomResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_Ocs),
        MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_OcsBuilder.new,
      )
      ..add(MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_Ocs.serializer)
      ..add(MatterbridgeGetBridgeProcessStateApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(MatterbridgeGetBridgeProcessStateResponseApplicationJson),
        MatterbridgeGetBridgeProcessStateResponseApplicationJsonBuilder.new,
      )
      ..add(MatterbridgeGetBridgeProcessStateResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(MatterbridgeGetBridgeProcessStateResponseApplicationJson_Ocs),
        MatterbridgeGetBridgeProcessStateResponseApplicationJson_OcsBuilder.new,
      )
      ..add(MatterbridgeGetBridgeProcessStateResponseApplicationJson_Ocs.serializer)
      ..add(MatterbridgeSettingsStopAllBridgesApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(MatterbridgeSettingsStopAllBridgesResponseApplicationJson),
        MatterbridgeSettingsStopAllBridgesResponseApplicationJsonBuilder.new,
      )
      ..add(MatterbridgeSettingsStopAllBridgesResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(MatterbridgeSettingsStopAllBridgesResponseApplicationJson_Ocs),
        MatterbridgeSettingsStopAllBridgesResponseApplicationJson_OcsBuilder.new,
      )
      ..add(MatterbridgeSettingsStopAllBridgesResponseApplicationJson_Ocs.serializer)
      ..add(MatterbridgeSettingsGetMatterbridgeVersionApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson),
        MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJsonBuilder.new,
      )
      ..add(MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs),
        MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_OcsBuilder.new,
      )
      ..add(MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_Data),
        MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_Data.serializer)
      ..add(PollCreatePollResultMode.serializer)
      ..add(PollCreatePollApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(PollCreatePollResponseApplicationJson),
        PollCreatePollResponseApplicationJsonBuilder.new,
      )
      ..add(PollCreatePollResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(PollCreatePollResponseApplicationJson_Ocs),
        PollCreatePollResponseApplicationJson_OcsBuilder.new,
      )
      ..add(PollCreatePollResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(Poll), PollBuilder.new)
      ..add(Poll.serializer)
      ..addBuilderFactory(const FullType(PollVote), PollVoteBuilder.new)
      ..add(PollVote.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(PollVote)]), ListBuilder<PollVote>.new)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(int)]), ListBuilder<int>.new)
      ..add(PollShowPollApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(PollShowPollResponseApplicationJson),
        PollShowPollResponseApplicationJsonBuilder.new,
      )
      ..add(PollShowPollResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(PollShowPollResponseApplicationJson_Ocs),
        PollShowPollResponseApplicationJson_OcsBuilder.new,
      )
      ..add(PollShowPollResponseApplicationJson_Ocs.serializer)
      ..add(PollVotePollApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(PollVotePollResponseApplicationJson),
        PollVotePollResponseApplicationJsonBuilder.new,
      )
      ..add(PollVotePollResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(PollVotePollResponseApplicationJson_Ocs),
        PollVotePollResponseApplicationJson_OcsBuilder.new,
      )
      ..add(PollVotePollResponseApplicationJson_Ocs.serializer)
      ..add(PollClosePollApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(PollClosePollResponseApplicationJson),
        PollClosePollResponseApplicationJsonBuilder.new,
      )
      ..add(PollClosePollResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(PollClosePollResponseApplicationJson_Ocs),
        PollClosePollResponseApplicationJson_OcsBuilder.new,
      )
      ..add(PollClosePollResponseApplicationJson_Ocs.serializer)
      ..add(ReactionGetReactionsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(ReactionGetReactionsResponseApplicationJson),
        ReactionGetReactionsResponseApplicationJsonBuilder.new,
      )
      ..add(ReactionGetReactionsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ReactionGetReactionsResponseApplicationJson_Ocs),
        ReactionGetReactionsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ReactionGetReactionsResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(Reaction), ReactionBuilder.new)
      ..add(Reaction.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(Reaction)]), ListBuilder<Reaction>.new)
      ..addBuilderFactory(
        const FullType(BuiltMap, [
          FullType(String),
          FullType(BuiltList, [FullType(Reaction)]),
        ]),
        MapBuilder<String, BuiltList<Reaction>>.new,
      )
      ..add(ReactionReactApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(ReactionReactResponseApplicationJson),
        ReactionReactResponseApplicationJsonBuilder.new,
      )
      ..add(ReactionReactResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ReactionReactResponseApplicationJson_Ocs),
        ReactionReactResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ReactionReactResponseApplicationJson_Ocs.serializer)
      ..add(ReactionDeleteApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(ReactionDeleteResponseApplicationJson),
        ReactionDeleteResponseApplicationJsonBuilder.new,
      )
      ..add(ReactionDeleteResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ReactionDeleteResponseApplicationJson_Ocs),
        ReactionDeleteResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ReactionDeleteResponseApplicationJson_Ocs.serializer)
      ..add(RecordingStartApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RecordingStartResponseApplicationJson),
        RecordingStartResponseApplicationJsonBuilder.new,
      )
      ..add(RecordingStartResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RecordingStartResponseApplicationJson_Ocs),
        RecordingStartResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RecordingStartResponseApplicationJson_Ocs.serializer)
      ..add(RecordingStopApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RecordingStopResponseApplicationJson),
        RecordingStopResponseApplicationJsonBuilder.new,
      )
      ..add(RecordingStopResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RecordingStopResponseApplicationJson_Ocs),
        RecordingStopResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RecordingStopResponseApplicationJson_Ocs.serializer)
      ..add(RecordingNotificationDismissApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RecordingNotificationDismissResponseApplicationJson),
        RecordingNotificationDismissResponseApplicationJsonBuilder.new,
      )
      ..add(RecordingNotificationDismissResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RecordingNotificationDismissResponseApplicationJson_Ocs),
        RecordingNotificationDismissResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RecordingNotificationDismissResponseApplicationJson_Ocs.serializer)
      ..add(RecordingShareToChatApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RecordingShareToChatResponseApplicationJson),
        RecordingShareToChatResponseApplicationJsonBuilder.new,
      )
      ..add(RecordingShareToChatResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RecordingShareToChatResponseApplicationJson_Ocs),
        RecordingShareToChatResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RecordingShareToChatResponseApplicationJson_Ocs.serializer)
      ..add(RecordingBackendApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RecordingBackendResponseApplicationJson),
        RecordingBackendResponseApplicationJsonBuilder.new,
      )
      ..add(RecordingBackendResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RecordingBackendResponseApplicationJson_Ocs),
        RecordingBackendResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RecordingBackendResponseApplicationJson_Ocs.serializer)
      ..add(RecordingStoreApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RecordingStoreResponseApplicationJson),
        RecordingStoreResponseApplicationJsonBuilder.new,
      )
      ..add(RecordingStoreResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RecordingStoreResponseApplicationJson_Ocs),
        RecordingStoreResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RecordingStoreResponseApplicationJson_Ocs.serializer)
      ..add(RoomGetRoomsNoStatusUpdate.serializer)
      ..add(RoomGetRoomsIncludeStatus.serializer)
      ..add(RoomGetRoomsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetRoomsResponseApplicationJson),
        RoomGetRoomsResponseApplicationJsonBuilder.new,
      )
      ..add(RoomGetRoomsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetRoomsResponseApplicationJson_Ocs),
        RoomGetRoomsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomGetRoomsResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(RoomRoomGetRoomsHeaders), RoomRoomGetRoomsHeadersBuilder.new)
      ..add(RoomRoomGetRoomsHeaders.serializer)
      ..add(RoomCreateRoomApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomCreateRoomResponseApplicationJson),
        RoomCreateRoomResponseApplicationJsonBuilder.new,
      )
      ..add(RoomCreateRoomResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomCreateRoomResponseApplicationJson_Ocs),
        RoomCreateRoomResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomCreateRoomResponseApplicationJson_Ocs.serializer)
      ..add(RoomGetListedRoomsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetListedRoomsResponseApplicationJson),
        RoomGetListedRoomsResponseApplicationJsonBuilder.new,
      )
      ..add(RoomGetListedRoomsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetListedRoomsResponseApplicationJson_Ocs),
        RoomGetListedRoomsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomGetListedRoomsResponseApplicationJson_Ocs.serializer)
      ..add(RoomGetNoteToSelfConversationApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetNoteToSelfConversationResponseApplicationJson),
        RoomGetNoteToSelfConversationResponseApplicationJsonBuilder.new,
      )
      ..add(RoomGetNoteToSelfConversationResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetNoteToSelfConversationResponseApplicationJson_Ocs),
        RoomGetNoteToSelfConversationResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomGetNoteToSelfConversationResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(RoomRoomGetNoteToSelfConversationHeaders),
        RoomRoomGetNoteToSelfConversationHeadersBuilder.new,
      )
      ..add(RoomRoomGetNoteToSelfConversationHeaders.serializer)
      ..add(RoomGetSingleRoomApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetSingleRoomResponseApplicationJson),
        RoomGetSingleRoomResponseApplicationJsonBuilder.new,
      )
      ..add(RoomGetSingleRoomResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetSingleRoomResponseApplicationJson_Ocs),
        RoomGetSingleRoomResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomGetSingleRoomResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(RoomRoomGetSingleRoomHeaders), RoomRoomGetSingleRoomHeadersBuilder.new)
      ..add(RoomRoomGetSingleRoomHeaders.serializer)
      ..add(RoomGetBreakoutRoomsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetBreakoutRoomsResponseApplicationJson),
        RoomGetBreakoutRoomsResponseApplicationJsonBuilder.new,
      )
      ..add(RoomGetBreakoutRoomsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetBreakoutRoomsResponseApplicationJson_Ocs),
        RoomGetBreakoutRoomsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomGetBreakoutRoomsResponseApplicationJson_Ocs.serializer)
      ..add(RoomMakePublicApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomMakePublicResponseApplicationJson),
        RoomMakePublicResponseApplicationJsonBuilder.new,
      )
      ..add(RoomMakePublicResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomMakePublicResponseApplicationJson_Ocs),
        RoomMakePublicResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomMakePublicResponseApplicationJson_Ocs.serializer)
      ..add(RoomMakePrivateApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomMakePrivateResponseApplicationJson),
        RoomMakePrivateResponseApplicationJsonBuilder.new,
      )
      ..add(RoomMakePrivateResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomMakePrivateResponseApplicationJson_Ocs),
        RoomMakePrivateResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomMakePrivateResponseApplicationJson_Ocs.serializer)
      ..add(RoomSetDescriptionApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetDescriptionResponseApplicationJson),
        RoomSetDescriptionResponseApplicationJsonBuilder.new,
      )
      ..add(RoomSetDescriptionResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetDescriptionResponseApplicationJson_Ocs),
        RoomSetDescriptionResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomSetDescriptionResponseApplicationJson_Ocs.serializer)
      ..add(RoomSetReadOnlyState.serializer)
      ..add(RoomSetReadOnlyApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetReadOnlyResponseApplicationJson),
        RoomSetReadOnlyResponseApplicationJsonBuilder.new,
      )
      ..add(RoomSetReadOnlyResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetReadOnlyResponseApplicationJson_Ocs),
        RoomSetReadOnlyResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomSetReadOnlyResponseApplicationJson_Ocs.serializer)
      ..add(RoomSetListableScope.serializer)
      ..add(RoomSetListableApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetListableResponseApplicationJson),
        RoomSetListableResponseApplicationJsonBuilder.new,
      )
      ..add(RoomSetListableResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetListableResponseApplicationJson_Ocs),
        RoomSetListableResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomSetListableResponseApplicationJson_Ocs.serializer)
      ..add(RoomSetPasswordApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetPasswordResponseApplicationJson),
        RoomSetPasswordResponseApplicationJsonBuilder.new,
      )
      ..add(RoomSetPasswordResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetPasswordResponseApplicationJson_Ocs),
        RoomSetPasswordResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomSetPasswordResponseApplicationJson_Ocs.serializer)
      ..add(RoomSetPermissionsMode.serializer)
      ..add(RoomSetPermissionsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetPermissionsResponseApplicationJson),
        RoomSetPermissionsResponseApplicationJsonBuilder.new,
      )
      ..add(RoomSetPermissionsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetPermissionsResponseApplicationJson_Ocs),
        RoomSetPermissionsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomSetPermissionsResponseApplicationJson_Ocs.serializer)
      ..add(RoomGetParticipantsIncludeStatus.serializer)
      ..add(RoomGetParticipantsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetParticipantsResponseApplicationJson),
        RoomGetParticipantsResponseApplicationJsonBuilder.new,
      )
      ..add(RoomGetParticipantsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetParticipantsResponseApplicationJson_Ocs),
        RoomGetParticipantsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomGetParticipantsResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(Participant), ParticipantBuilder.new)
      ..add(Participant.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(Participant)]), ListBuilder<Participant>.new)
      ..addBuilderFactory(const FullType(RoomRoomGetParticipantsHeaders), RoomRoomGetParticipantsHeadersBuilder.new)
      ..add(RoomRoomGetParticipantsHeaders.serializer)
      ..addBuilderFactory(const FullType(Header, [FullType(bool)]), HeaderBuilder<bool>.new)
      ..add(Header.serializer)
      ..add(RoomAddParticipantToRoomSource.serializer)
      ..add(RoomAddParticipantToRoomApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomAddParticipantToRoomResponseApplicationJson),
        RoomAddParticipantToRoomResponseApplicationJsonBuilder.new,
      )
      ..add(RoomAddParticipantToRoomResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomAddParticipantToRoomResponseApplicationJson_Ocs),
        RoomAddParticipantToRoomResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomAddParticipantToRoomResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0),
        RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0Builder.new,
      )
      ..add(RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0.serializer)
      ..add($bd993fb3f40af33e8594d0d698208560Extension._serializer)
      ..add(RoomGetBreakoutRoomParticipantsIncludeStatus.serializer)
      ..add(RoomGetBreakoutRoomParticipantsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetBreakoutRoomParticipantsResponseApplicationJson),
        RoomGetBreakoutRoomParticipantsResponseApplicationJsonBuilder.new,
      )
      ..add(RoomGetBreakoutRoomParticipantsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetBreakoutRoomParticipantsResponseApplicationJson_Ocs),
        RoomGetBreakoutRoomParticipantsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomGetBreakoutRoomParticipantsResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(RoomRoomGetBreakoutRoomParticipantsHeaders),
        RoomRoomGetBreakoutRoomParticipantsHeadersBuilder.new,
      )
      ..add(RoomRoomGetBreakoutRoomParticipantsHeaders.serializer)
      ..add(RoomRemoveSelfFromRoomApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomRemoveSelfFromRoomResponseApplicationJson),
        RoomRemoveSelfFromRoomResponseApplicationJsonBuilder.new,
      )
      ..add(RoomRemoveSelfFromRoomResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomRemoveSelfFromRoomResponseApplicationJson_Ocs),
        RoomRemoveSelfFromRoomResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomRemoveSelfFromRoomResponseApplicationJson_Ocs.serializer)
      ..add(RoomRemoveAttendeeFromRoomApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomRemoveAttendeeFromRoomResponseApplicationJson),
        RoomRemoveAttendeeFromRoomResponseApplicationJsonBuilder.new,
      )
      ..add(RoomRemoveAttendeeFromRoomResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomRemoveAttendeeFromRoomResponseApplicationJson_Ocs),
        RoomRemoveAttendeeFromRoomResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomRemoveAttendeeFromRoomResponseApplicationJson_Ocs.serializer)
      ..add(RoomSetAttendeePermissionsMethod.serializer)
      ..add(RoomSetAttendeePermissionsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetAttendeePermissionsResponseApplicationJson),
        RoomSetAttendeePermissionsResponseApplicationJsonBuilder.new,
      )
      ..add(RoomSetAttendeePermissionsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetAttendeePermissionsResponseApplicationJson_Ocs),
        RoomSetAttendeePermissionsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomSetAttendeePermissionsResponseApplicationJson_Ocs.serializer)
      ..add(RoomSetAllAttendeesPermissionsMethod.serializer)
      ..add(RoomSetAllAttendeesPermissionsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetAllAttendeesPermissionsResponseApplicationJson),
        RoomSetAllAttendeesPermissionsResponseApplicationJsonBuilder.new,
      )
      ..add(RoomSetAllAttendeesPermissionsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetAllAttendeesPermissionsResponseApplicationJson_Ocs),
        RoomSetAllAttendeesPermissionsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomSetAllAttendeesPermissionsResponseApplicationJson_Ocs.serializer)
      ..add(RoomJoinRoomForce.serializer)
      ..add(RoomJoinRoomApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomJoinRoomResponseApplicationJson),
        RoomJoinRoomResponseApplicationJsonBuilder.new,
      )
      ..add(RoomJoinRoomResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomJoinRoomResponseApplicationJson_Ocs),
        RoomJoinRoomResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomJoinRoomResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(RoomRoomJoinRoomHeaders), RoomRoomJoinRoomHeadersBuilder.new)
      ..add(RoomRoomJoinRoomHeaders.serializer)
      ..add(RoomLeaveRoomApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomLeaveRoomResponseApplicationJson),
        RoomLeaveRoomResponseApplicationJsonBuilder.new,
      )
      ..add(RoomLeaveRoomResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomLeaveRoomResponseApplicationJson_Ocs),
        RoomLeaveRoomResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomLeaveRoomResponseApplicationJson_Ocs.serializer)
      ..add(RoomResendInvitationsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomResendInvitationsResponseApplicationJson),
        RoomResendInvitationsResponseApplicationJsonBuilder.new,
      )
      ..add(RoomResendInvitationsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomResendInvitationsResponseApplicationJson_Ocs),
        RoomResendInvitationsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomResendInvitationsResponseApplicationJson_Ocs.serializer)
      ..add(RoomSetSessionStateState.serializer)
      ..add(RoomSetSessionStateApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetSessionStateResponseApplicationJson),
        RoomSetSessionStateResponseApplicationJsonBuilder.new,
      )
      ..add(RoomSetSessionStateResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetSessionStateResponseApplicationJson_Ocs),
        RoomSetSessionStateResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomSetSessionStateResponseApplicationJson_Ocs.serializer)
      ..add(RoomPromoteModeratorApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomPromoteModeratorResponseApplicationJson),
        RoomPromoteModeratorResponseApplicationJsonBuilder.new,
      )
      ..add(RoomPromoteModeratorResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomPromoteModeratorResponseApplicationJson_Ocs),
        RoomPromoteModeratorResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomPromoteModeratorResponseApplicationJson_Ocs.serializer)
      ..add(RoomDemoteModeratorApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomDemoteModeratorResponseApplicationJson),
        RoomDemoteModeratorResponseApplicationJsonBuilder.new,
      )
      ..add(RoomDemoteModeratorResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomDemoteModeratorResponseApplicationJson_Ocs),
        RoomDemoteModeratorResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomDemoteModeratorResponseApplicationJson_Ocs.serializer)
      ..add(RoomAddToFavoritesApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomAddToFavoritesResponseApplicationJson),
        RoomAddToFavoritesResponseApplicationJsonBuilder.new,
      )
      ..add(RoomAddToFavoritesResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomAddToFavoritesResponseApplicationJson_Ocs),
        RoomAddToFavoritesResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomAddToFavoritesResponseApplicationJson_Ocs.serializer)
      ..add(RoomRemoveFromFavoritesApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomRemoveFromFavoritesResponseApplicationJson),
        RoomRemoveFromFavoritesResponseApplicationJsonBuilder.new,
      )
      ..add(RoomRemoveFromFavoritesResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomRemoveFromFavoritesResponseApplicationJson_Ocs),
        RoomRemoveFromFavoritesResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomRemoveFromFavoritesResponseApplicationJson_Ocs.serializer)
      ..add(RoomSetNotificationLevelApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetNotificationLevelResponseApplicationJson),
        RoomSetNotificationLevelResponseApplicationJsonBuilder.new,
      )
      ..add(RoomSetNotificationLevelResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetNotificationLevelResponseApplicationJson_Ocs),
        RoomSetNotificationLevelResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomSetNotificationLevelResponseApplicationJson_Ocs.serializer)
      ..add(RoomSetNotificationCallsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetNotificationCallsResponseApplicationJson),
        RoomSetNotificationCallsResponseApplicationJsonBuilder.new,
      )
      ..add(RoomSetNotificationCallsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetNotificationCallsResponseApplicationJson_Ocs),
        RoomSetNotificationCallsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomSetNotificationCallsResponseApplicationJson_Ocs.serializer)
      ..add(RoomSetLobbyApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetLobbyResponseApplicationJson),
        RoomSetLobbyResponseApplicationJsonBuilder.new,
      )
      ..add(RoomSetLobbyResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetLobbyResponseApplicationJson_Ocs),
        RoomSetLobbyResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomSetLobbyResponseApplicationJson_Ocs.serializer)
      ..add(RoomSetsipEnabledState.serializer)
      ..add(RoomSetsipEnabledApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetsipEnabledResponseApplicationJson),
        RoomSetsipEnabledResponseApplicationJsonBuilder.new,
      )
      ..add(RoomSetsipEnabledResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetsipEnabledResponseApplicationJson_Ocs),
        RoomSetsipEnabledResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomSetsipEnabledResponseApplicationJson_Ocs.serializer)
      ..add(RoomSetRecordingConsentApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetRecordingConsentResponseApplicationJson),
        RoomSetRecordingConsentResponseApplicationJsonBuilder.new,
      )
      ..add(RoomSetRecordingConsentResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetRecordingConsentResponseApplicationJson_Ocs),
        RoomSetRecordingConsentResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomSetRecordingConsentResponseApplicationJson_Ocs.serializer)
      ..add(RoomSetMessageExpirationApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetMessageExpirationResponseApplicationJson),
        RoomSetMessageExpirationResponseApplicationJsonBuilder.new,
      )
      ..add(RoomSetMessageExpirationResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetMessageExpirationResponseApplicationJson_Ocs),
        RoomSetMessageExpirationResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomSetMessageExpirationResponseApplicationJson_Ocs.serializer)
      ..add(RoomGetCapabilitiesApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetCapabilitiesResponseApplicationJson),
        RoomGetCapabilitiesResponseApplicationJsonBuilder.new,
      )
      ..add(RoomGetCapabilitiesResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetCapabilitiesResponseApplicationJson_Ocs),
        RoomGetCapabilitiesResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomGetCapabilitiesResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(Capabilities), CapabilitiesBuilder.new)
      ..add(Capabilities.serializer)
      ..addBuilderFactory(const FullType(Capabilities_Config), Capabilities_ConfigBuilder.new)
      ..add(Capabilities_Config.serializer)
      ..addBuilderFactory(const FullType(Capabilities_Config_Attachments), Capabilities_Config_AttachmentsBuilder.new)
      ..add(Capabilities_Config_Attachments.serializer)
      ..addBuilderFactory(const FullType(Capabilities_Config_Call), Capabilities_Config_CallBuilder.new)
      ..add(Capabilities_Config_Call.serializer)
      ..addBuilderFactory(const FullType(Capabilities_Config_Chat), Capabilities_Config_ChatBuilder.new)
      ..add(Capabilities_Config_Chat.serializer)
      ..addBuilderFactory(
        const FullType(Capabilities_Config_Conversations),
        Capabilities_Config_ConversationsBuilder.new,
      )
      ..add(Capabilities_Config_Conversations.serializer)
      ..addBuilderFactory(const FullType(Capabilities_Config_Federation), Capabilities_Config_FederationBuilder.new)
      ..add(Capabilities_Config_Federation.serializer)
      ..addBuilderFactory(const FullType(Capabilities_Config_Previews), Capabilities_Config_PreviewsBuilder.new)
      ..add(Capabilities_Config_Previews.serializer)
      ..addBuilderFactory(const FullType(Capabilities_Config_Signaling), Capabilities_Config_SignalingBuilder.new)
      ..add(Capabilities_Config_Signaling.serializer)
      ..add($973dc40faeda3fa3aa7e7b9895ee7a34Extension._serializer)
      ..addBuilderFactory(const FullType(RoomRoomGetCapabilitiesHeaders), RoomRoomGetCapabilitiesHeadersBuilder.new)
      ..add(RoomRoomGetCapabilitiesHeaders.serializer)
      ..add(RoomJoinFederatedRoomApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomJoinFederatedRoomResponseApplicationJson),
        RoomJoinFederatedRoomResponseApplicationJsonBuilder.new,
      )
      ..add(RoomJoinFederatedRoomResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomJoinFederatedRoomResponseApplicationJson_Ocs),
        RoomJoinFederatedRoomResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomJoinFederatedRoomResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(RoomRoomJoinFederatedRoomHeaders), RoomRoomJoinFederatedRoomHeadersBuilder.new)
      ..add(RoomRoomJoinFederatedRoomHeaders.serializer)
      ..add(RoomVerifyDialInPinDeprecatedApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomVerifyDialInPinDeprecatedResponseApplicationJson),
        RoomVerifyDialInPinDeprecatedResponseApplicationJsonBuilder.new,
      )
      ..add(RoomVerifyDialInPinDeprecatedResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomVerifyDialInPinDeprecatedResponseApplicationJson_Ocs),
        RoomVerifyDialInPinDeprecatedResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomVerifyDialInPinDeprecatedResponseApplicationJson_Ocs.serializer)
      ..add(RoomVerifyDialInPinApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomVerifyDialInPinResponseApplicationJson),
        RoomVerifyDialInPinResponseApplicationJsonBuilder.new,
      )
      ..add(RoomVerifyDialInPinResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomVerifyDialInPinResponseApplicationJson_Ocs),
        RoomVerifyDialInPinResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomVerifyDialInPinResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(RoomVerifyDialOutNumberOptions), RoomVerifyDialOutNumberOptionsBuilder.new)
      ..add(RoomVerifyDialOutNumberOptions.serializer)
      ..addBuilderFactory(
        const FullType(ContentString, [FullType(RoomVerifyDialOutNumberOptions)]),
        ContentStringBuilder<RoomVerifyDialOutNumberOptions>.new,
      )
      ..add(RoomVerifyDialOutNumberApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomVerifyDialOutNumberResponseApplicationJson),
        RoomVerifyDialOutNumberResponseApplicationJsonBuilder.new,
      )
      ..add(RoomVerifyDialOutNumberResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomVerifyDialOutNumberResponseApplicationJson_Ocs),
        RoomVerifyDialOutNumberResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomVerifyDialOutNumberResponseApplicationJson_Ocs.serializer)
      ..add(RoomCreateGuestByDialInApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomCreateGuestByDialInResponseApplicationJson),
        RoomCreateGuestByDialInResponseApplicationJsonBuilder.new,
      )
      ..add(RoomCreateGuestByDialInResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomCreateGuestByDialInResponseApplicationJson_Ocs),
        RoomCreateGuestByDialInResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomCreateGuestByDialInResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(RoomRejectedDialOutRequestOptions),
        RoomRejectedDialOutRequestOptionsBuilder.new,
      )
      ..add(RoomRejectedDialOutRequestOptions.serializer)
      ..addBuilderFactory(
        const FullType(ContentString, [FullType(RoomRejectedDialOutRequestOptions)]),
        ContentStringBuilder<RoomRejectedDialOutRequestOptions>.new,
      )
      ..add(RoomRejectedDialOutRequestApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomRejectedDialOutRequestResponseApplicationJson),
        RoomRejectedDialOutRequestResponseApplicationJsonBuilder.new,
      )
      ..add(RoomRejectedDialOutRequestResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomRejectedDialOutRequestResponseApplicationJson_Ocs),
        RoomRejectedDialOutRequestResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomRejectedDialOutRequestResponseApplicationJson_Ocs.serializer)
      ..add(SettingsSetUserSettingKey.serializer)
      ..add(SettingsSetUserSettingApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(SettingsSetUserSettingResponseApplicationJson),
        SettingsSetUserSettingResponseApplicationJsonBuilder.new,
      )
      ..add(SettingsSetUserSettingResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(SettingsSetUserSettingResponseApplicationJson_Ocs),
        SettingsSetUserSettingResponseApplicationJson_OcsBuilder.new,
      )
      ..add(SettingsSetUserSettingResponseApplicationJson_Ocs.serializer)
      ..add(BotAdminListBotsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BotAdminListBotsResponseApplicationJson),
        BotAdminListBotsResponseApplicationJsonBuilder.new,
      )
      ..add(BotAdminListBotsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BotAdminListBotsResponseApplicationJson_Ocs),
        BotAdminListBotsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BotAdminListBotsResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(BotWithDetails), BotWithDetailsBuilder.new)
      ..add(BotWithDetails.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(BotWithDetails)]), ListBuilder<BotWithDetails>.new)
      ..add(CertificateGetCertificateExpirationApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(CertificateGetCertificateExpirationResponseApplicationJson),
        CertificateGetCertificateExpirationResponseApplicationJsonBuilder.new,
      )
      ..add(CertificateGetCertificateExpirationResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(CertificateGetCertificateExpirationResponseApplicationJson_Ocs),
        CertificateGetCertificateExpirationResponseApplicationJson_OcsBuilder.new,
      )
      ..add(CertificateGetCertificateExpirationResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(CertificateGetCertificateExpirationResponseApplicationJson_Ocs_Data),
        CertificateGetCertificateExpirationResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(CertificateGetCertificateExpirationResponseApplicationJson_Ocs_Data.serializer)
      ..add(RecordingGetWelcomeMessageApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RecordingGetWelcomeMessageResponseApplicationJson),
        RecordingGetWelcomeMessageResponseApplicationJsonBuilder.new,
      )
      ..add(RecordingGetWelcomeMessageResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RecordingGetWelcomeMessageResponseApplicationJson_Ocs),
        RecordingGetWelcomeMessageResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RecordingGetWelcomeMessageResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(RecordingGetWelcomeMessageResponseApplicationJson_Ocs_Data),
        RecordingGetWelcomeMessageResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(RecordingGetWelcomeMessageResponseApplicationJson_Ocs_Data.serializer)
      ..add(SettingsSetsipSettingsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(SettingsSetsipSettingsResponseApplicationJson),
        SettingsSetsipSettingsResponseApplicationJsonBuilder.new,
      )
      ..add(SettingsSetsipSettingsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(SettingsSetsipSettingsResponseApplicationJson_Ocs),
        SettingsSetsipSettingsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(SettingsSetsipSettingsResponseApplicationJson_Ocs.serializer)
      ..add(SignalingGetWelcomeMessageApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(SignalingGetWelcomeMessageResponseApplicationJson),
        SignalingGetWelcomeMessageResponseApplicationJsonBuilder.new,
      )
      ..add(SignalingGetWelcomeMessageResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(SignalingGetWelcomeMessageResponseApplicationJson_Ocs),
        SignalingGetWelcomeMessageResponseApplicationJson_OcsBuilder.new,
      )
      ..add(SignalingGetWelcomeMessageResponseApplicationJson_Ocs.serializer)
      ..add(SignalingBackendApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(SignalingBackendResponseApplicationJson),
        SignalingBackendResponseApplicationJsonBuilder.new,
      )
      ..add(SignalingBackendResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(SignalingBackendResponseApplicationJson_Ocs),
        SignalingBackendResponseApplicationJson_OcsBuilder.new,
      )
      ..add(SignalingBackendResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(SignalingBackendResponseApplicationJson_Ocs_Data),
        SignalingBackendResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(SignalingBackendResponseApplicationJson_Ocs_Data.serializer)
      ..addBuilderFactory(
        const FullType(SignalingBackendResponseApplicationJson_Ocs_Data_Error),
        SignalingBackendResponseApplicationJson_Ocs_Data_ErrorBuilder.new,
      )
      ..add(SignalingBackendResponseApplicationJson_Ocs_Data_Error.serializer)
      ..addBuilderFactory(
        const FullType(SignalingBackendResponseApplicationJson_Ocs_Data_Auth),
        SignalingBackendResponseApplicationJson_Ocs_Data_AuthBuilder.new,
      )
      ..add(SignalingBackendResponseApplicationJson_Ocs_Data_Auth.serializer)
      ..addBuilderFactory(
        const FullType(SignalingBackendResponseApplicationJson_Ocs_Data_Room),
        SignalingBackendResponseApplicationJson_Ocs_Data_RoomBuilder.new,
      )
      ..add(SignalingBackendResponseApplicationJson_Ocs_Data_Room.serializer)
      ..addBuilderFactory(
        const FullType(TempAvatarPostAvatarResponseApplicationJson),
        TempAvatarPostAvatarResponseApplicationJsonBuilder.new,
      )
      ..add(TempAvatarPostAvatarResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(TempAvatarPostAvatarResponseApplicationJson_Ocs),
        TempAvatarPostAvatarResponseApplicationJson_OcsBuilder.new,
      )
      ..add(TempAvatarPostAvatarResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(TempAvatarDeleteAvatarResponseApplicationJson),
        TempAvatarDeleteAvatarResponseApplicationJsonBuilder.new,
      )
      ..add(TempAvatarDeleteAvatarResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(TempAvatarDeleteAvatarResponseApplicationJson_Ocs),
        TempAvatarDeleteAvatarResponseApplicationJson_OcsBuilder.new,
      )
      ..add(TempAvatarDeleteAvatarResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(BotWithDetailsAndSecret), BotWithDetailsAndSecretBuilder.new)
      ..add(BotWithDetailsAndSecret.serializer)
      ..addBuilderFactory(const FullType(PublicCapabilities0), PublicCapabilities0Builder.new)
      ..add(PublicCapabilities0.serializer)
      ..add($bc4aac45771b11649d372f39a92b1cf3Extension._serializer))
    .build();

/// Serializer for all values in this library.
///
/// Serializes values into the json. Json serialization is more expensive than the built_value wire format.
/// See: [$serializers] for serializing into the `built_value` wire format.
@_i2.visibleForTesting
final Serializers $jsonSerializers = _$jsonSerializers;
final Serializers _$jsonSerializers = (_$serializers.toBuilder()
      ..add(_i6.DynamiteDoubleSerializer())
      ..addPlugin(
        _i7.StandardJsonPlugin(
          typesToLeaveAsList: const {
            _$b2c4857c0136baea42828d89c87c757d,
            _$4b3c240037cf48d36f81308e641eef98,
            _$bed8482b7c93ae2974fa4be6ae42b9b1,
            _$1df642f5035aea3b22543ab331c3fb01,
            _$bd993fb3f40af33e8594d0d698208560,
            _$973dc40faeda3fa3aa7e7b9895ee7a34,
            _$bc4aac45771b11649d372f39a92b1cf3,
          },
        ),
      )
      ..addPlugin(const _i6.HeaderPlugin())
      ..addPlugin(const _i6.ContentStringPlugin()))
    .build();
// coverage:ignore-end
